"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PasswordHash = void 0;
var bcrypt = require('bcryptjs');
class PasswordHash {
    async hash(password) {
        let hashedPassword = await new Promise((resolve, reject) => {
            bcrypt.hash(password, 10, function (err, hash) {
                if (err)
                    reject(err);
                resolve(hash);
            });
        });
        return hashedPassword;
    }
    async compare(password, hash) {
        let comp = await new Promise((resolve, reject) => {
            bcrypt.compare(password, hash, function (err, res) {
                if (res) {
                    resolve(true);
                }
                else {
                    resolve(false);
                }
            });
        });
        return comp;
    }
}
exports.PasswordHash = PasswordHash;
