import { AccessTableService } from './access-table.service';
import { AccessTable } from './entities/access-table.entity';
import { CreateAccessTableInput } from './dto/create-access-table.input';
import { UpdateAccessTableInput } from './dto/update-access-table.input';
export declare class AccessTableResolver {
    private readonly accessTableService;
    constructor(accessTableService: AccessTableService);
    createAccessTable(createAccessTableInput: CreateAccessTableInput): Promise<void>;
    findAllAccess(): Promise<AccessTable>;
    findOneAccess(accessId: number): Promise<AccessTable>;
    updateAccessTable(updateAccessTableInput: UpdateAccessTableInput): Promise<void>;
    removeAccessTable(accessId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getAllAccessParameterByUsername(username: string): Promise<AccessTable[]>;
}
