"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const access_table_service_1 = require("./access-table.service");
const access_table_entity_1 = require("./entities/access-table.entity");
const create_access_table_input_1 = require("./dto/create-access-table.input");
const update_access_table_input_1 = require("./dto/update-access-table.input");
const access_table_return_type_1 = require("./types/access-table-return.type");
const access_table_type_1 = require("./types/access-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
let AccessTableResolver = exports.AccessTableResolver = class AccessTableResolver {
    constructor(accessTableService) {
        this.accessTableService = accessTableService;
    }
    createAccessTable(createAccessTableInput) {
        return this.accessTableService.create(createAccessTableInput);
    }
    findAllAccess() {
        return this.accessTableService.findAll();
    }
    findOneAccess(accessId) {
        return this.accessTableService.findOne(accessId);
    }
    updateAccessTable(updateAccessTableInput) {
        return this.accessTableService.update(updateAccessTableInput.accessId, updateAccessTableInput);
    }
    removeAccessTable(accessId) {
        return this.accessTableService.remove(accessId);
    }
    getAllAccessParameterByUsername(username) {
        return this.accessTableService.getAllAccessParameterByUsername(username);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => access_table_return_type_1.AccessTableReturnType),
    __param(0, (0, graphql_1.Args)('createAccessTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_access_table_input_1.CreateAccessTableInput]),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "createAccessTable", null);
__decorate([
    (0, graphql_1.Query)(() => [access_table_type_1.AccessTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "findAllAccess", null);
__decorate([
    (0, graphql_1.Query)(() => access_table_type_1.AccessTableType),
    __param(0, (0, graphql_1.Args)('accessId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "findOneAccess", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => access_table_return_type_1.AccessTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAccessTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_access_table_input_1.UpdateAccessTableInput]),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "updateAccessTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => access_table_return_type_1.AccessTableReturnType),
    __param(0, (0, graphql_1.Args)('accessId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "removeAccessTable", null);
__decorate([
    (0, graphql_1.Query)(() => [access_table_type_1.AccessTableType]),
    __param(0, (0, graphql_1.Args)('username', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], AccessTableResolver.prototype, "getAllAccessParameterByUsername", null);
exports.AccessTableResolver = AccessTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => access_table_entity_1.AccessTable),
    __metadata("design:paramtypes", [access_table_service_1.AccessTableService])
], AccessTableResolver);
