import { RedisPubSub } from 'graphql-redis-subscriptions';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateAccessTableInput } from './dto/create-access-table.input';
import { UpdateAccessTableInput } from './dto/update-access-table.input';
import { AccessTable } from './entities/access-table.entity';
export declare class AccessTableService {
    private readonly accessTableRepository;
    private pubSub;
    private readonly userCollectionService;
    constructor(accessTableRepository: Repository<AccessTable>, pubSub: RedisPubSub, userCollectionService: UserCollectionService);
    create(createAccessTableInput: CreateAccessTableInput): Promise<void>;
    checkIfExists(userId: number): Promise<AccessTable>;
    findAllByUserName(username: string): Promise<AccessTable[]>;
    findAll(): Promise<AccessTable>;
    findOne(accessId: number): Promise<AccessTable>;
    update(accessId: number, updateAccessTableInput: UpdateAccessTableInput): Promise<void>;
    remove(accessId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getAllAccessParameterByUsername(username: string): Promise<AccessTable[]>;
}
