"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccessTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const typeorm_2 = require("typeorm");
const access_table_entity_1 = require("./entities/access-table.entity");
let AccessTableService = exports.AccessTableService = class AccessTableService {
    constructor(accessTableRepository, pubSub, userCollectionService) {
        this.accessTableRepository = accessTableRepository;
        this.pubSub = pubSub;
        this.userCollectionService = userCollectionService;
    }
    async create(createAccessTableInput) {
    }
    async checkIfExists(userId) {
        let result = await this.accessTableRepository.findOne({
            where: {
                UserTable: {
                    id: userId
                }
            }
        });
        return result;
    }
    async findAllByUserName(username) {
        return await this.accessTableRepository.find({
            where: {
                UserTable: {
                    username: username
                }
            },
            relations: {
                UserTable: true,
            }
        });
    }
    async findAll() {
        return await this.accessTableRepository.findOne({
            relations: {
                UserTable: true,
            }
        });
    }
    async findOne(accessId) {
        return await this.accessTableRepository.findOne({
            where: {
                accessId: accessId
            },
            relations: {
                UserTable: true,
            }
        });
    }
    async update(accessId, updateAccessTableInput) {
        let rr = await this.accessTableRepository.findOne({
            where: {
                accessId: accessId
            }
        });
    }
    async remove(accessId) {
        let rr = await this.accessTableRepository.findOne({
            where: {
                accessId: accessId
            }
        });
        if (rr) {
            await this.accessTableRepository.remove(rr);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async getAllAccessParameterByUsername(username) {
        let result = await this.accessTableRepository.find({
            where: {
                UserTable: {
                    username
                }
            },
            relations: {
                UserTable: true,
            }
        });
        return result;
    }
};
exports.AccessTableService = AccessTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(access_table_entity_1.AccessTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        user_collection_service_1.UserCollectionService])
], AccessTableService);
