import { CreateActivityAchievementsTableInput } from './dto/create-activity-achievements-table.input';
import { UpdateActivityAchievementsTableInput } from './dto/update-activity-achievements-table.input';
import { ActivityAchievementsTable } from './entities/activity-achievements-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ThemeTableService } from 'src/theme-table/theme-table.service';
import { ActivityTableService } from 'src/activity-table/activity-table.service';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CreateActivityAchievementsTableBulkInput } from './dto/create-activity-achievements-table-bulk.input';
export declare class ActivityAchievementsTableService {
    private readonly activityAchievementsTableRepository;
    private pubSub;
    private readonly themeTableService;
    private readonly activityTableService;
    private readonly sessionmasterTableService;
    private readonly userCollectionService;
    constructor(activityAchievementsTableRepository: Repository<ActivityAchievementsTable>, pubSub: RedisPubSub, themeTableService: ThemeTableService, activityTableService: ActivityTableService, sessionmasterTableService: SessionmasterTableService, userCollectionService: UserCollectionService);
    create(createActivityAchievementsTableBulkInput: CreateActivityAchievementsTableBulkInput, user: any): Promise<any>;
    createSingle(createActivityAchievementsTableInput: CreateActivityAchievementsTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(createActivityAchievementsTableInput: CreateActivityAchievementsTableInput): Promise<ActivityAchievementsTable>;
    fetchAchievementNosOfMonth(month: string, themeId: number, activityId: number, user: any): Promise<number>;
    fetchAchievementNosOfMonthIfNotPresent(month: string, userId: number, sessionId: number): Promise<ActivityAchievementsTable[]>;
    fetchAchievementNosHalfYearly(halfNo: number, themeId: number, activityId: number, user: any, sessionId: number): Promise<any>;
    fetchAchievementNosAnnually(themeId: number, activityId: number, user: any, sessionId: number): Promise<any>;
    findAll(): string;
    findOne(id: number): string;
    update(id: number, updateActivityAchievementsTableInput: UpdateActivityAchievementsTableInput): string;
    remove(id: number): string;
}
