"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityAchievementsTableService = void 0;
const common_1 = require("@nestjs/common");
const activity_achievements_table_entity_1 = require("./entities/activity-achievements-table.entity");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const theme_table_service_1 = require("../theme-table/theme-table.service");
const activity_table_service_1 = require("../activity-table/activity-table.service");
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
let ActivityAchievementsTableService = exports.ActivityAchievementsTableService = class ActivityAchievementsTableService {
    constructor(activityAchievementsTableRepository, pubSub, themeTableService, activityTableService, sessionmasterTableService, userCollectionService) {
        this.activityAchievementsTableRepository = activityAchievementsTableRepository;
        this.pubSub = pubSub;
        this.themeTableService = themeTableService;
        this.activityTableService = activityTableService;
        this.sessionmasterTableService = sessionmasterTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createActivityAchievementsTableBulkInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        let data = [];
        for (const createActivityAchievementsTableInput of createActivityAchievementsTableBulkInput.data) {
            const checkIfExists = await this.checkIfExists(createActivityAchievementsTableInput);
            if (!checkIfExists) {
                let apt = new activity_achievements_table_entity_1.ActivityAchievementsTable();
                const session = await this.sessionmasterTableService.findActiveSession();
                const theme = await this.themeTableService.findOne(createActivityAchievementsTableInput.themeId);
                const activity = await this.activityTableService.findOne(createActivityAchievementsTableInput.activityId);
                const userTable = await this.userCollectionService.findOneByUsername(user.username);
                apt.SessionmasterTable = session;
                apt.ThemeTable = theme;
                apt.ActivityTable = activity;
                apt.UserTable = userTable;
                apt.nosPerformed = createActivityAchievementsTableInput.nosPerformed;
                apt.activityType = createActivityAchievementsTableInput.activityType;
                apt.isVerified = 0;
                apt.month = createActivityAchievementsTableInput.month;
                let hh = (0, moment_1.default)(createActivityAchievementsTableInput.month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                apt.halfNo = halfNo;
                await this.activityAchievementsTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Acheivement Submitted Successfully."
                });
            }
            else {
                let apt = checkIfExists;
                apt.nosPerformed = createActivityAchievementsTableInput.nosPerformed;
                let hh = (0, moment_1.default)(createActivityAchievementsTableInput.month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                apt.halfNo = halfNo;
                await this.activityAchievementsTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Acheivement Updated Successfully"
                });
            }
        }
        return data;
    }
    async createSingle(createActivityAchievementsTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        const checkIfExists = await this.checkIfExists(createActivityAchievementsTableInput);
        if (!checkIfExists) {
            let apt = new activity_achievements_table_entity_1.ActivityAchievementsTable();
            const session = await this.sessionmasterTableService.findActiveSession();
            const theme = await this.themeTableService.findOne(createActivityAchievementsTableInput.themeId);
            const activity = await this.activityTableService.findOne(createActivityAchievementsTableInput.activityId);
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            apt.SessionmasterTable = session;
            apt.ThemeTable = theme;
            apt.ActivityTable = activity;
            apt.UserTable = userTable;
            apt.nosPerformed = createActivityAchievementsTableInput.nosPerformed;
            apt.activityType = createActivityAchievementsTableInput.activityType;
            apt.isVerified = 0;
            apt.month = createActivityAchievementsTableInput.month;
            let hh = (0, moment_1.default)(createActivityAchievementsTableInput.month, "MM-YYYY").format("MM");
            let halfNo = 1;
            if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                halfNo = 1;
            }
            else {
                halfNo = 2;
            }
            apt.halfNo = halfNo;
            await this.activityAchievementsTableRepository.save(apt);
            return {
                status: true,
                status_text: "Acheivement Submitted Successfully."
            };
        }
        else {
            let apt = checkIfExists;
            apt.nosPerformed = createActivityAchievementsTableInput.nosPerformed;
            await this.activityAchievementsTableRepository.save(apt);
            return {
                status: true,
                status_text: "Acheivement Updated Successfully"
            };
        }
    }
    async checkIfExists(createActivityAchievementsTableInput) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let res = await this.activityAchievementsTableRepository.findOne({
            where: {
                ThemeTable: {
                    themeId: createActivityAchievementsTableInput.themeId,
                },
                ActivityTable: {
                    activityId: createActivityAchievementsTableInput.activityId
                },
                activityType: createActivityAchievementsTableInput.activityType,
                month: createActivityAchievementsTableInput.month,
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return res;
    }
    async fetchAchievementNosOfMonth(month, themeId, activityId, user) {
        let ac = await this.activityAchievementsTableRepository.findOne({
            where: {
                month,
                ThemeTable: {
                    themeId
                },
                ActivityTable: {
                    activityId
                },
                UserTable: {
                    username: user.username
                }
            }
        });
        if (ac) {
            return ac.nosPerformed;
        }
        else {
            return 0;
        }
    }
    async fetchAchievementNosOfMonthIfNotPresent(month, userId, sessionId) {
        let ac = await this.activityAchievementsTableRepository.find({
            where: {
                month,
                SessionmasterTable: {
                    sessionId
                },
                UserTable: {
                    id: userId
                }
            },
            relations: {
                ThemeTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        return ac;
    }
    async fetchAchievementNosHalfYearly(halfNo, themeId, activityId, user, sessionId) {
        let ac = await this.activityAchievementsTableRepository.createQueryBuilder('r')
            .andWhere('r.halfNo=:halfNo', { halfNo })
            .andWhere('r.themeId=:themeId', { themeId: themeId })
            .andWhere('r.activityId=:activityId', { activityId: activityId })
            .andWhere('r.sessionMasterId=:sessionMasterId', { sessionMasterId: sessionId })
            .andWhere('r.userId=:userId', { userId: user.id })
            .select('SUM(r.nosPerformed)', 'nosPerformed')
            .getRawOne();
        if (ac) {
            if (ac.nosPerformed) {
                return ac.nosPerformed;
            }
            else {
                return 0;
            }
        }
        else {
            return 0;
        }
    }
    async fetchAchievementNosAnnually(themeId, activityId, user, sessionId) {
        let ac = await this.activityAchievementsTableRepository.createQueryBuilder('r')
            .andWhere('r.themeId=:themeId', { themeId: themeId })
            .andWhere('r.activityId=:activityId', { activityId: activityId })
            .andWhere('r.sessionMasterId=:sessionMasterId', { sessionMasterId: sessionId })
            .andWhere('r.userId=:userId', { userId: user.id })
            .select('SUM(r.nosPerformed)', 'nosPerformed')
            .getRawOne();
        if (ac) {
            if (ac.nosPerformed) {
                return ac.nosPerformed;
            }
            else {
                return 0;
            }
        }
        else {
            return 0;
        }
    }
    findAll() {
        return `This action returns all activityAchievementsTable`;
    }
    findOne(id) {
        return `This action returns a #${id} activityAchievementsTable`;
    }
    update(id, updateActivityAchievementsTableInput) {
        return `This action updates a #${id} activityAchievementsTable`;
    }
    remove(id) {
        return `This action removes a #${id} activityAchievementsTable`;
    }
};
exports.ActivityAchievementsTableService = ActivityAchievementsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(activity_achievements_table_entity_1.ActivityAchievementsTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => theme_table_service_1.ThemeTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => activity_table_service_1.ActivityTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        theme_table_service_1.ThemeTableService,
        activity_table_service_1.ActivityTableService,
        sessionmaster_table_service_1.SessionmasterTableService,
        user_collection_service_1.UserCollectionService])
], ActivityAchievementsTableService);
