import { ActivityPlanningTableService } from './activity-planning-table.service';
import { ActivityPlanningTable } from './entities/activity-planning-table.entity';
import { CreateActivityPlanningTableInput } from './dto/create-activity-planning-table.input';
import { UpdateActivityPlanningTableInput } from './dto/update-activity-planning-table.input';
import { CreateActivityPlanningTableBulkInput } from './dto/create-activity-planning-table-bulk.input';
import { PlanningVerificationDtoInput } from './dto/planning-verification-dto.input';
export declare class ActivityPlanningTableResolver {
    private readonly activityPlanningTableService;
    constructor(activityPlanningTableService: ActivityPlanningTableService);
    createActivityPlanningTable(createActivityPlanningTableInput: CreateActivityPlanningTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createActivityHalfYearlyPlanningTable(createActivityPlanningTableBulkInput: CreateActivityPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    createActivityMonthlyPlanningTable(createActivityPlanningTableBulkInput: CreateActivityPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    findAllActivityPlannerBySessionAndUser(user: any, sessionId: number, activityType: string): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerBySessionAndUserVerification(userId: number, sessionId: number, activityType: string): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerHalfYearlyBySessionAndUser(user: any, sessionId: number, activityType: string, halfNo: number): Promise<any>;
    findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId: number, sessionId: number, activityType: string, halfNo: number): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerMonthlyBySessionAndUser(user: any, sessionId: number, activityType: string, month: string): Promise<any>;
    findAllActivityPlannerMonthlyBySessionAndUserVerification(userId: number, sessionId: number, activityType: string, month: string): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerMonthlyBySessionAndUserDashboard(user: any, sessionId: number, activityType: string, month: string): Promise<any>;
    findAllActivityListForUser(user: any, sessionId: number): Promise<import("../activity-table/entities/activity-table.entity").ActivityTable[]>;
    updateActivityPlanningTable(updateActivityPlanningTableInput: UpdateActivityPlanningTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeActivityPlanningTable(activityPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateActivityStatus(planningVerificationDtoInput: PlanningVerificationDtoInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleIsEditable(activityPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityPlanningTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
