"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityPlanningTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const activity_planning_table_service_1 = require("./activity-planning-table.service");
const activity_planning_table_entity_1 = require("./entities/activity-planning-table.entity");
const create_activity_planning_table_input_1 = require("./dto/create-activity-planning-table.input");
const update_activity_planning_table_input_1 = require("./dto/update-activity-planning-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const activity_planning_table_return_type_1 = require("./types/activity-planning-table-return.type");
const activity_planning_table_type_1 = require("./types/activity-planning-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const activity_table_type_1 = require("../activity-table/types/activity-table.type");
const create_activity_planning_table_bulk_input_1 = require("./dto/create-activity-planning-table-bulk.input");
const activity_planning_table_return_bulk_type_1 = require("./types/activity-planning-table-return-bulk.type");
const planning_verification_dto_input_1 = require("./dto/planning-verification-dto.input");
let ActivityPlanningTableResolver = exports.ActivityPlanningTableResolver = class ActivityPlanningTableResolver {
    constructor(activityPlanningTableService) {
        this.activityPlanningTableService = activityPlanningTableService;
    }
    createActivityPlanningTable(createActivityPlanningTableInput, user) {
        return this.activityPlanningTableService.create(createActivityPlanningTableInput, user);
    }
    createActivityHalfYearlyPlanningTable(createActivityPlanningTableBulkInput, user) {
        return this.activityPlanningTableService.createHalfYearly(createActivityPlanningTableBulkInput, user);
    }
    createActivityMonthlyPlanningTable(createActivityPlanningTableBulkInput, user) {
        return this.activityPlanningTableService.createMonthly(createActivityPlanningTableBulkInput, user);
    }
    findAllActivityPlannerBySessionAndUser(user, sessionId, activityType) {
        return this.activityPlanningTableService.findAllActivityPlannerBySessionAndUser(user, sessionId, activityType);
    }
    findAllActivityPlannerBySessionAndUserVerification(userId, sessionId, activityType) {
        return this.activityPlanningTableService.findAllActivityPlannerBySessionAndUserVerification(userId, sessionId, activityType);
    }
    findAllActivityPlannerHalfYearlyBySessionAndUser(user, sessionId, activityType, halfNo) {
        return this.activityPlanningTableService.findAllActivityPlannerHalfYearlyBySessionAndUser(user, sessionId, activityType, halfNo);
    }
    findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, activityType, halfNo) {
        return this.activityPlanningTableService.findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, activityType, halfNo);
    }
    findAllActivityPlannerMonthlyBySessionAndUser(user, sessionId, activityType, month) {
        return this.activityPlanningTableService.findAllActivityPlannerMonthlyBySessionAndUser(user, sessionId, activityType, month);
    }
    findAllActivityPlannerMonthlyBySessionAndUserVerification(userId, sessionId, activityType, month) {
        return this.activityPlanningTableService.findAllActivityPlannerMonthlyBySessionAndUserVerification(userId, sessionId, activityType, month);
    }
    findAllActivityPlannerMonthlyBySessionAndUserDashboard(user, sessionId, activityType, month) {
        return this.activityPlanningTableService.findAllActivityPlannerMonthlyBySessionAndUserDashboard(user, sessionId, activityType, month);
    }
    findAllActivityListForUser(user, sessionId) {
        return this.activityPlanningTableService.findAllActivityListForUser(user, sessionId);
    }
    updateActivityPlanningTable(updateActivityPlanningTableInput) {
        return this.activityPlanningTableService.update(updateActivityPlanningTableInput.activityPlanningId, updateActivityPlanningTableInput);
    }
    removeActivityPlanningTable(activityPlanningId) {
        return this.activityPlanningTableService.remove(activityPlanningId);
    }
    updateActivityStatus(planningVerificationDtoInput, user) {
        return this.activityPlanningTableService.updateActivityStatus(planningVerificationDtoInput, user);
    }
    toggleIsEditable(activityPlanningId) {
        return this.activityPlanningTableService.toggleIsEditable(activityPlanningId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_type_1.ActivityPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('createActivityPlanningTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_activity_planning_table_input_1.CreateActivityPlanningTableInput, Object]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "createActivityPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_bulk_type_1.ActivityPlanningTableReturnBulkType),
    __param(0, (0, graphql_1.Args)('createActivityPlanningTableBulkInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_activity_planning_table_bulk_input_1.CreateActivityPlanningTableBulkInput, Object]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "createActivityHalfYearlyPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_bulk_type_1.ActivityPlanningTableReturnBulkType),
    __param(0, (0, graphql_1.Args)('createActivityPlanningTableBulkInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_activity_planning_table_bulk_input_1.CreateActivityPlanningTableBulkInput, Object]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "createActivityMonthlyPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __param(3, (0, graphql_1.Args)('halfNo')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, Number]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerHalfYearlyBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __param(3, (0, graphql_1.Args)('halfNo')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, Number]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerHalfYearlyBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, String]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerMonthlyBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, String]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerMonthlyBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_planning_table_type_1.ActivityPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('activityType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, String]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityPlannerMonthlyBySessionAndUserDashboard", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_table_type_1.ActivityTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "findAllActivityListForUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_type_1.ActivityPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('updateActivityPlanningTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_activity_planning_table_input_1.UpdateActivityPlanningTableInput]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "updateActivityPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_type_1.ActivityPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('activityPlanningId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "removeActivityPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_type_1.ActivityPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('planningVerificationDtoInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [planning_verification_dto_input_1.PlanningVerificationDtoInput, Object]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "updateActivityStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_planning_table_return_type_1.ActivityPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('activityPlanningId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ActivityPlanningTableResolver.prototype, "toggleIsEditable", null);
exports.ActivityPlanningTableResolver = ActivityPlanningTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => activity_planning_table_entity_1.ActivityPlanningTable),
    __metadata("design:paramtypes", [activity_planning_table_service_1.ActivityPlanningTableService])
], ActivityPlanningTableResolver);
