import { CreateActivityPlanningTableInput } from './dto/create-activity-planning-table.input';
import { UpdateActivityPlanningTableInput } from './dto/update-activity-planning-table.input';
import { ActivityPlanningTable } from './entities/activity-planning-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ThemeTableService } from 'src/theme-table/theme-table.service';
import { ActivityTableService } from 'src/activity-table/activity-table.service';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CreateActivityPlanningTableBulkInput } from './dto/create-activity-planning-table-bulk.input';
import { ActivityAchievementsTableService } from 'src/activity-achievements-table/activity-achievements-table.service';
import { PlanningVerificationDtoInput } from './dto/planning-verification-dto.input';
export declare class ActivityPlanningTableService {
    private readonly activityPlanningTableRepository;
    private pubSub;
    private readonly themeTableService;
    private readonly activityTableService;
    private readonly sessionmasterTableService;
    private readonly userCollectionService;
    private readonly activityAchievementsTableService;
    constructor(activityPlanningTableRepository: Repository<ActivityPlanningTable>, pubSub: RedisPubSub, themeTableService: ThemeTableService, activityTableService: ActivityTableService, sessionmasterTableService: SessionmasterTableService, userCollectionService: UserCollectionService, activityAchievementsTableService: ActivityAchievementsTableService);
    create(createActivityPlanningTableInput: CreateActivityPlanningTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createHalfYearly(createActivityPlanningTableBulkInput: CreateActivityPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    checkIfExists(createActivityPlanningTableInput: CreateActivityPlanningTableInput, user: any): Promise<boolean>;
    checkIfExistsHalfYearly(createActivityPlanningTableInput: CreateActivityPlanningTableInput, user: any): Promise<ActivityPlanningTable>;
    checkIfExistsMonthly(createActivityPlanningTableInput: CreateActivityPlanningTableInput, user: any): Promise<ActivityPlanningTable>;
    createMonthly(createActivityPlanningTableBulkInput: CreateActivityPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    findAllActivityPlannerBySessionAndUser(user: any, sessionId: number, activityType: string): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerBySessionAndUserVerification(userId: number, sessionId: number, activityType: string): Promise<ActivityPlanningTable[]>;
    findHalfData(user: any, sessionId: number, activityType: string, halfNo: number): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerHalfYearlyBySessionAndUser(user: any, sessionId: number, activityType: string, halfNo: number): Promise<any>;
    findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId: any, sessionId: number, activityType: string, halfNo: number): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerMonthlyBySessionAndUser(user: any, sessionId: number, activityType: string, month: string): Promise<any>;
    findAllActivityPlannerMonthlyBySessionAndUserVerification(userId: any, sessionId: number, activityType: string, month: string): Promise<ActivityPlanningTable[]>;
    findAllActivityPlannerMonthlyBySessionAndUserDashboard(user: any, sessionId: number, activityType: string, month: string): Promise<any>;
    findAll(): string;
    findOne(id: number): string;
    findAllActivityListForUser(user: any, sessionId: number): Promise<import("../activity-table/entities/activity-table.entity").ActivityTable[]>;
    update(activityPlanningId: number, updateActivityPlanningTableInput: UpdateActivityPlanningTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(activityPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateActivityStatus(planningVerificationDtoInput: PlanningVerificationDtoInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleIsEditable(activityPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityPlanningTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllActivityPlannerMonthlyBySessionAndUserReports(userId: any, sessionId: number, activityType: string, month: string): Promise<ActivityPlanningTable[] | import("../activity-achievements-table/entities/activity-achievements-table.entity").ActivityAchievementsTable[]>;
}
