"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityPlanningTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const activity_planning_table_entity_1 = require("./entities/activity-planning-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const theme_table_service_1 = require("../theme-table/theme-table.service");
const activity_table_service_1 = require("../activity-table/activity-table.service");
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
const activity_achievements_table_service_1 = require("../activity-achievements-table/activity-achievements-table.service");
let ActivityPlanningTableService = exports.ActivityPlanningTableService = class ActivityPlanningTableService {
    constructor(activityPlanningTableRepository, pubSub, themeTableService, activityTableService, sessionmasterTableService, userCollectionService, activityAchievementsTableService) {
        this.activityPlanningTableRepository = activityPlanningTableRepository;
        this.pubSub = pubSub;
        this.themeTableService = themeTableService;
        this.activityTableService = activityTableService;
        this.sessionmasterTableService = sessionmasterTableService;
        this.userCollectionService = userCollectionService;
        this.activityAchievementsTableService = activityAchievementsTableService;
    }
    async create(createActivityPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        const checkIfExists = await this.checkIfExists(createActivityPlanningTableInput, user);
        if (!checkIfExists) {
            let apt = new activity_planning_table_entity_1.ActivityPlanningTable();
            const session = await this.sessionmasterTableService.findActiveSession();
            const theme = await this.themeTableService.findOne(createActivityPlanningTableInput.themeId);
            const activity = await this.activityTableService.findOne(createActivityPlanningTableInput.activityId);
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            apt.SessionmasterTable = session;
            apt.ThemeTable = theme;
            apt.ActivityTable = activity;
            apt.UserTable = userTable;
            apt.nosToBePerformed = createActivityPlanningTableInput.nosToBePerformed;
            apt.activityType = createActivityPlanningTableInput.activityType;
            apt.isVerified = 0;
            apt.isActive = 1;
            await this.activityPlanningTableRepository.save(apt);
            return {
                status: true,
                status_text: "Submitted Successfully. You can submit the task for this activity"
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createHalfYearly(createActivityPlanningTableBulkInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        let data = [];
        for (const createActivityPlanningTableInput of createActivityPlanningTableBulkInput.data) {
            const checkIfExists = await this.checkIfExistsHalfYearly(createActivityPlanningTableInput, user);
            if (!checkIfExists) {
                let apt = new activity_planning_table_entity_1.ActivityPlanningTable();
                const session = await this.sessionmasterTableService.findActiveSession();
                const theme = await this.themeTableService.findOne(createActivityPlanningTableInput.themeId);
                const activity = await this.activityTableService.findOne(createActivityPlanningTableInput.activityId);
                const userTable = await this.userCollectionService.findOneByUsername(user.username);
                apt.SessionmasterTable = session;
                apt.ThemeTable = theme;
                apt.ActivityTable = activity;
                apt.UserTable = userTable;
                apt.nosToBePerformed = createActivityPlanningTableInput.nosToBePerformed;
                apt.activityType = createActivityPlanningTableInput.activityType;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.halfNo = createActivityPlanningTableInput.halfNo;
                await this.activityPlanningTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Submitted Successfully. You can submit the task for this activity"
                });
            }
            else {
                let apt = checkIfExists;
                apt.nosToBePerformed = createActivityPlanningTableInput.nosToBePerformed;
                apt.isVerified = 0;
                apt.isActive = 1;
                await this.activityPlanningTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Updated Successfully"
                });
            }
        }
        return {
            data: data
        };
    }
    async checkIfExists(createActivityPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.activityPlanningTableRepository.findOne({
            where: {
                ThemeTable: {
                    themeId: createActivityPlanningTableInput.themeId
                },
                ActivityTable: {
                    activityId: createActivityPlanningTableInput.activityId
                },
                activityType: createActivityPlanningTableInput.activityType,
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        if (result) {
            return true;
        }
        else {
            return false;
        }
    }
    async checkIfExistsHalfYearly(createActivityPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.activityPlanningTableRepository.findOne({
            where: {
                ThemeTable: {
                    themeId: createActivityPlanningTableInput.themeId
                },
                ActivityTable: {
                    activityId: createActivityPlanningTableInput.activityId
                },
                activityType: createActivityPlanningTableInput.activityType,
                halfNo: createActivityPlanningTableInput.halfNo,
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return result;
    }
    async checkIfExistsMonthly(createActivityPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.activityPlanningTableRepository.findOne({
            where: {
                ThemeTable: {
                    themeId: createActivityPlanningTableInput.themeId
                },
                ActivityTable: {
                    activityId: createActivityPlanningTableInput.activityId
                },
                activityType: createActivityPlanningTableInput.activityType,
                month: createActivityPlanningTableInput.month,
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return result;
    }
    async createMonthly(createActivityPlanningTableBulkInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        let data = [];
        for (const createActivityPlanningTableInput of createActivityPlanningTableBulkInput.data) {
            const checkIfExists = await this.checkIfExistsMonthly(createActivityPlanningTableInput, user);
            if (!checkIfExists) {
                let apt = new activity_planning_table_entity_1.ActivityPlanningTable();
                const session = await this.sessionmasterTableService.findActiveSession();
                const theme = await this.themeTableService.findOne(createActivityPlanningTableInput.themeId);
                const activity = await this.activityTableService.findOne(createActivityPlanningTableInput.activityId);
                const userTable = await this.userCollectionService.findOneByUsername(user.username);
                apt.SessionmasterTable = session;
                apt.ThemeTable = theme;
                apt.ActivityTable = activity;
                apt.UserTable = userTable;
                apt.nosToBePerformed = createActivityPlanningTableInput.nosToBePerformed;
                apt.activityType = createActivityPlanningTableInput.activityType;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.month = createActivityPlanningTableInput.month;
                await this.activityPlanningTableRepository.save(apt);
                let perviousMonth = (0, moment_1.default)(createActivityPlanningTableInput.month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
                await this.activityAchievementsTableService.createSingle({
                    activityId: createActivityPlanningTableInput.activityId,
                    activityType: createActivityPlanningTableInput.activityType,
                    month: perviousMonth,
                    nosPerformed: createActivityPlanningTableInput.nosPerformed,
                    themeId: createActivityPlanningTableInput.themeId
                }, user);
                data.push({
                    status: true,
                    status_text: "Submitted Successfully. You can submit the task for this activity"
                });
            }
            else {
                let apt = checkIfExists;
                apt.nosToBePerformed = createActivityPlanningTableInput.nosToBePerformed;
                apt.isVerified = 0;
                apt.isActive = 1;
                await this.activityPlanningTableRepository.save(apt);
                let perviousMonth = (0, moment_1.default)(createActivityPlanningTableInput.month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
                await this.activityAchievementsTableService.createSingle({
                    activityId: createActivityPlanningTableInput.activityId,
                    activityType: createActivityPlanningTableInput.activityType,
                    month: perviousMonth,
                    nosPerformed: createActivityPlanningTableInput.nosPerformed,
                    themeId: createActivityPlanningTableInput.themeId
                }, user);
                data.push({
                    status: true,
                    status_text: "Updated Successfully"
                });
            }
        }
        return {
            data: data
        };
    }
    async findAllActivityPlannerBySessionAndUser(user, sessionId, activityType) {
        if (activityType == "ANNUAL") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const el of result) {
                let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosAnnually(el.ThemeTable.themeId, el.ActivityTable.activityId, user, sessionId);
                result[index]['nosPerformed'] = nosPerformed;
                index++;
            }
            return result;
        }
    }
    async findAllActivityPlannerBySessionAndUserVerification(userId, sessionId, activityType) {
        if (activityType == "ANNUAL") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const el of result) {
                let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosAnnually(el.ThemeTable.themeId, el.ActivityTable.activityId, el.UserTable, sessionId);
                result[index]['nosPerformed'] = nosPerformed;
                index++;
            }
            return result;
        }
    }
    async findHalfData(user, sessionId, activityType, halfNo) {
        let result = await this.activityPlanningTableRepository.find({
            where: {
                UserTable: {
                    username: user.username
                },
                halfNo,
                SessionmasterTable: {
                    sessionId
                },
                activityType
            },
            relations: {
                ThemeTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        return result;
    }
    async findAllActivityPlannerHalfYearlyBySessionAndUser(user, sessionId, activityType, halfNo) {
        if (activityType == "HALF-YEARLY") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    halfNo,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let annualData = await this.findAllActivityPlannerBySessionAndUser(user, sessionId, "ANNUAL");
                if (halfNo == 1) {
                    let data = [];
                    for (const el of annualData) {
                        let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosHalfYearly(1, el.ThemeTable.themeId, el.ActivityTable.activityId, user, sessionId);
                        data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(el.nosToBePerformed / 2), nosPerformed: nosPerformed, isSubmitted: false }));
                    }
                    return data;
                }
                if (halfNo == 2) {
                    let firstHalfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", 1);
                    if (firstHalfData.length == 0) {
                        let data = [];
                        for (const el of annualData) {
                            let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosHalfYearly(2, el.ThemeTable.themeId, el.ActivityTable.activityId, user, sessionId);
                            data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(el.nosToBePerformed), nosPerformed, isSubmitted: false }));
                        }
                        return data;
                    }
                    else {
                        let data = [];
                        for (const el of annualData) {
                            let ff = firstHalfData.find(el1 => el1.ActivityTable.activityId === el.ActivityTable.activityId && el1.SessionmasterTable.sessionId === el.SessionmasterTable.sessionId && el1.UserTable.username === el.UserTable.username);
                            let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.ThemeTable.themeId, el.ActivityTable.activityId, user, sessionId);
                            if (ff) {
                                let calculated = el.nosToBePerformed - ff.nosToBePerformed;
                                if (calculated < 0) {
                                    calculated = 0;
                                }
                                data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(calculated), nosPerformed, isSubmitted: false }));
                            }
                            else {
                                data.push(Object.assign(Object.assign({}, el), { nosPerformed, isSubmitted: false }));
                            }
                        }
                        return data;
                    }
                }
            }
            else {
                let index = 0;
                for (const el of result) {
                    let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.ThemeTable.themeId, el.ActivityTable.activityId, user, sessionId);
                    result[index]['nosPerformed'] = nosPerformed;
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    async findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, activityType, halfNo) {
        if (activityType == "HALF-YEARLY") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    halfNo,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const el of result) {
                let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.ThemeTable.themeId, el.ActivityTable.activityId, el.UserTable, sessionId);
                result[index]['nosPerformed'] = nosPerformed;
                result[index]['isSubmitted'] = true;
                index++;
            }
            return result;
        }
    }
    async findAllActivityPlannerMonthlyBySessionAndUser(user, sessionId, activityType, month) {
        if (activityType == "MONTHLY") {
            let previousMonth = (0, moment_1.default)(month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let hh = (0, moment_1.default)(month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                let halfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", halfNo);
                let data = [];
                for (const hd of halfData) {
                    let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, hd.ThemeTable.themeId, hd.ActivityTable.activityId, user);
                    data.push(Object.assign(Object.assign({}, hd), { nosToBePerformed: Math.round(hd.nosToBePerformed / 6), nosPerformed: nosPerformed, isSubmitted: false }));
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, res.ThemeTable.themeId, res.ActivityTable.activityId, user);
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    async findAllActivityPlannerMonthlyBySessionAndUserVerification(userId, sessionId, activityType, month) {
        if (activityType == "MONTHLY") {
            let previousMonth = (0, moment_1.default)(month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const res of result) {
                result[index]['nosPerformed'] = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, res.ThemeTable.themeId, res.ActivityTable.activityId, res.UserTable);
                result[index]['isSubmitted'] = true;
                index++;
            }
            return result;
        }
    }
    async findAllActivityPlannerMonthlyBySessionAndUserDashboard(user, sessionId, activityType, month) {
        if (activityType == "MONTHLY") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let hh = (0, moment_1.default)(month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                let halfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", halfNo);
                let data = [];
                for (const hd of halfData) {
                    let nosPerformed = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(month, hd.ThemeTable.themeId, hd.ActivityTable.activityId, user);
                    data.push(Object.assign(Object.assign({}, hd), { nosToBePerformed: Math.round(hd.nosToBePerformed / 6), nosPerformed: nosPerformed, isSubmitted: false }));
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(month, res.ThemeTable.themeId, res.ActivityTable.activityId, user);
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    findAll() {
        return `This action returns all activityPlanningTable`;
    }
    findOne(id) {
        return `This action returns a #${id} activityPlanningTable`;
    }
    async findAllActivityListForUser(user, sessionId) {
        let result = await this.activityPlanningTableRepository.find({
            where: {
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId
                }
            },
            relations: {
                ActivityTable: {
                    ThemeTable: true
                }
            }
        });
        let res = result.map(el => el.ActivityTable);
        return res;
    }
    async update(activityPlanningId, updateActivityPlanningTableInput) {
        let res = await this.activityPlanningTableRepository.findOne({
            where: {
                activityPlanningId
            }
        });
        if (res) {
            const session = await this.sessionmasterTableService.findActiveSession();
            const theme = await this.themeTableService.findOne(updateActivityPlanningTableInput.themeId);
            const activity = await this.activityTableService.findOne(updateActivityPlanningTableInput.activityId);
            res.SessionmasterTable = session;
            res.ThemeTable = theme;
            res.ActivityTable = activity;
            res.nosToBePerformed = updateActivityPlanningTableInput.nosToBePerformed;
            res.activityType = updateActivityPlanningTableInput.activityType;
            res.isVerified = 0;
            await this.activityPlanningTableRepository.save(res);
            return {
                status: true,
                status_text: "Submitted Successfully. You can submit the task for this activity"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async remove(activityPlanningId) {
        let res = await this.activityPlanningTableRepository.findOne({
            where: {
                activityPlanningId
            }
        });
        if (res) {
            await this.activityPlanningTableRepository.remove(res);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async updateActivityStatus(planningVerificationDtoInput, user) {
        for (const el of planningVerificationDtoInput.data) {
            let res = await this.activityPlanningTableRepository.findOne({
                where: {
                    activityPlanningId: el
                }
            });
            if (res) {
                res.isVerified = 1;
                res.isEditable = 0;
                res.verifiedOn = (0, moment_1.default)().format("DD-MM-YYYY h:m:s a");
                res.verifiedBy = user.id;
                await this.activityPlanningTableRepository.save(res);
            }
        }
        return {
            status: true,
            status_text: "Successfully Updated"
        };
    }
    async toggleIsEditable(activityPlanningId) {
        let res = await this.activityPlanningTableRepository.findOne({
            where: {
                activityPlanningId
            }
        });
        if (res) {
            let oldStatus = res.isEditable;
            let newStatus = 0;
            if (oldStatus == 1) {
                newStatus = 0;
            }
            if (oldStatus == 0) {
                newStatus = 1;
            }
            res.isEditable = newStatus;
            let result = await this.activityPlanningTableRepository.save(res);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async findAllActivityPlannerMonthlyBySessionAndUserReports(userId, sessionId, activityType, month) {
        if (activityType == "MONTHLY") {
            let result = await this.activityPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    activityType
                },
                relations: {
                    ThemeTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let data = await this.activityAchievementsTableService.fetchAchievementNosOfMonthIfNotPresent(month, userId, sessionId);
                let index1 = 0;
                for (const res of data) {
                    let annualData = await this.activityPlanningTableRepository.findOne({
                        where: {
                            UserTable: {
                                id: userId,
                            },
                            SessionmasterTable: {
                                sessionId
                            },
                            activityType: "ANNUAL",
                            ActivityTable: {
                                activityId: res.ActivityTable.activityId
                            }
                        }
                    });
                    data[index1]['annualTarget'] = annualData === null || annualData === void 0 ? void 0 : annualData.nosToBePerformed;
                    data[index1]['isSubmitted'] = true;
                    data[index1]['nosToBePerformed'] = 0;
                    index1++;
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.activityAchievementsTableService.fetchAchievementNosOfMonth(month, res.ThemeTable.themeId, res.ActivityTable.activityId, res.UserTable);
                    let annualData = await this.activityPlanningTableRepository.findOne({
                        where: {
                            UserTable: {
                                id: userId,
                            },
                            SessionmasterTable: {
                                sessionId
                            },
                            activityType: "ANNUAL",
                            ActivityTable: {
                                activityId: res.ActivityTable.activityId
                            }
                        }
                    });
                    result[index]['annualTarget'] = annualData === null || annualData === void 0 ? void 0 : annualData.nosToBePerformed;
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
};
exports.ActivityPlanningTableService = ActivityPlanningTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(activity_planning_table_entity_1.ActivityPlanningTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => theme_table_service_1.ThemeTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => activity_table_service_1.ActivityTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => activity_achievements_table_service_1.ActivityAchievementsTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        theme_table_service_1.ThemeTableService,
        activity_table_service_1.ActivityTableService,
        sessionmaster_table_service_1.SessionmasterTableService,
        user_collection_service_1.UserCollectionService,
        activity_achievements_table_service_1.ActivityAchievementsTableService])
], ActivityPlanningTableService);
