import { ActivityTableService } from './activity-table.service';
import { ActivityTable } from './entities/activity-table.entity';
import { CreateActivityTableInput } from './dto/create-activity-table.input';
import { UpdateActivityTableInput } from './dto/update-activity-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ACTIVITY_ADD = "NEW_ACTIVITY_ADD";
export declare class ActivityTableResolver {
    private readonly activityTableService;
    private pubSub;
    constructor(activityTableService: ActivityTableService, pubSub: RedisPubSub);
    createActivityTable(createActivityTableInput: CreateActivityTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityTable;
    }>;
    findAllActivities(): Promise<ActivityTable[]>;
    findOneActivity(activityId: number): Promise<ActivityTable>;
    updateActivityTable(updateActivityTableInput: UpdateActivityTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityTable;
    }>;
    removeActivityTable(activityId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    activitySubscription(): AsyncIterator<unknown, any, undefined>;
}
