"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityTableResolver = exports.NEW_ACTIVITY_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const activity_table_service_1 = require("./activity-table.service");
const activity_table_entity_1 = require("./entities/activity-table.entity");
const create_activity_table_input_1 = require("./dto/create-activity-table.input");
const update_activity_table_input_1 = require("./dto/update-activity-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const activity_table_return_type_1 = require("./types/activity-table-return.type");
const activity_table_type_1 = require("./types/activity-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_ACTIVITY_ADD = "NEW_ACTIVITY_ADD";
let ActivityTableResolver = exports.ActivityTableResolver = class ActivityTableResolver {
    constructor(activityTableService, pubSub) {
        this.activityTableService = activityTableService;
        this.pubSub = pubSub;
    }
    createActivityTable(createActivityTableInput) {
        return this.activityTableService.create(createActivityTableInput);
    }
    findAllActivities() {
        return this.activityTableService.findAll();
    }
    findOneActivity(activityId) {
        return this.activityTableService.findOne(activityId);
    }
    updateActivityTable(updateActivityTableInput) {
        return this.activityTableService.update(updateActivityTableInput.activityId, updateActivityTableInput);
    }
    removeActivityTable(activityId) {
        return this.activityTableService.remove(activityId);
    }
    activitySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_ACTIVITY_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_table_return_type_1.ActivityTableReturnType),
    __param(0, (0, graphql_1.Args)('createActivityTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_activity_table_input_1.CreateActivityTableInput]),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "createActivityTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [activity_table_type_1.ActivityTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "findAllActivities", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => activity_table_type_1.ActivityTableType),
    __param(0, (0, graphql_1.Args)('activityId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "findOneActivity", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_table_return_type_1.ActivityTableReturnType),
    __param(0, (0, graphql_1.Args)('updateActivityTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_activity_table_input_1.UpdateActivityTableInput]),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "updateActivityTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => activity_table_return_type_1.ActivityTableReturnType),
    __param(0, (0, graphql_1.Args)('activityId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "removeActivityTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ActivityTableResolver.prototype, "activitySubscription", null);
exports.ActivityTableResolver = ActivityTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => activity_table_entity_1.ActivityTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [activity_table_service_1.ActivityTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ActivityTableResolver);
