import { CreateActivityTableInput } from './dto/create-activity-table.input';
import { UpdateActivityTableInput } from './dto/update-activity-table.input';
import { ActivityTable } from './entities/activity-table.entity';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { ThemeTableService } from 'src/theme-table/theme-table.service';
export declare const NEW_ACTIVITY_ADD = "NEW_ACTIVITY_ADD";
export declare class ActivityTableService {
    private readonly activityTableRepository;
    private pubSub;
    private readonly themeTableService;
    constructor(activityTableRepository: Repository<ActivityTable>, pubSub: RedisPubSub, themeTableService: ThemeTableService);
    create(createActivityTableInput: CreateActivityTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityTable;
    }>;
    createorElseReturnObject(createActivityTableInput: CreateActivityTableInput): Promise<ActivityTable>;
    checkIfExists(activityName: string, themeId: number): Promise<boolean>;
    findAll(): Promise<ActivityTable[]>;
    getCount(): Promise<number>;
    findAllByThemeId(themeId: number): Promise<ActivityTable[]>;
    findOne(activityId: number): Promise<ActivityTable>;
    update(activityId: number, updateActivityTableInput: UpdateActivityTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ActivityTable;
    }>;
    remove(activityId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
