import { AdvertisementTableService } from './advertisement-table.service';
import { AdvertisementTable } from './entities/advertisement-table.entity';
import { CreateAdvertisementTableInput } from './dto/create-advertisement-table.input';
import { UpdateAdvertisementTableInput } from './dto/update-advertisement-table.input';
export declare class AdvertisementTableResolver {
    private readonly advertisementTableService;
    constructor(advertisementTableService: AdvertisementTableService);
    createAdvertisementTable(createAdvertisementTableInput: CreateAdvertisementTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
    findAllAdvertisement(): Promise<AdvertisementTable[]>;
    findOneAdvertisement(advertisementId: number): Promise<AdvertisementTable>;
    findAdvertisementByFarmerId(farmerId: number): Promise<AdvertisementTable[]>;
    updateAdvertisementTable(updateAdvertisementTableInput: UpdateAdvertisementTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
    removeAdvertisementTable(advertisementId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    toggleActiveStatusAdvertisement(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
}
