"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdvertisementTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const advertisement_table_service_1 = require("./advertisement-table.service");
const advertisement_table_entity_1 = require("./entities/advertisement-table.entity");
const create_advertisement_table_input_1 = require("./dto/create-advertisement-table.input");
const update_advertisement_table_input_1 = require("./dto/update-advertisement-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const advertisement_table_return_type_1 = require("./types/advertisement-table-return.type");
const advertisement_table_type_1 = require("./types/advertisement-table.type");
let AdvertisementTableResolver = class AdvertisementTableResolver {
    constructor(advertisementTableService) {
        this.advertisementTableService = advertisementTableService;
    }
    createAdvertisementTable(createAdvertisementTableInput, user) {
        return this.advertisementTableService.create(createAdvertisementTableInput, user);
    }
    findAllAdvertisement() {
        return this.advertisementTableService.findAll();
    }
    findOneAdvertisement(advertisementId) {
        return this.advertisementTableService.findOne(advertisementId);
    }
    findAdvertisementByFarmerId(farmerId) {
        return this.advertisementTableService.findOneByFarmerId(farmerId);
    }
    updateAdvertisementTable(updateAdvertisementTableInput, user) {
        return this.advertisementTableService.update(updateAdvertisementTableInput.advertisementId, updateAdvertisementTableInput, user);
    }
    removeAdvertisementTable(advertisementId) {
        return this.advertisementTableService.remove(advertisementId);
    }
    toggleActiveStatusAdvertisement(id) {
        return this.advertisementTableService.toggleActiveStatus(id);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_table_return_type_1.AdvertisementTableReturnType),
    __param(0, (0, graphql_1.Args)('createAdvertisementTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_advertisement_table_input_1.CreateAdvertisementTableInput, Object]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "createAdvertisementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [advertisement_table_type_1.AdvertisementTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "findAllAdvertisement", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => advertisement_table_type_1.AdvertisementTableType),
    __param(0, (0, graphql_1.Args)('advertisementId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "findOneAdvertisement", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [advertisement_table_type_1.AdvertisementTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "findAdvertisementByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_table_return_type_1.AdvertisementTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAdvertisementTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_advertisement_table_input_1.UpdateAdvertisementTableInput, Object]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "updateAdvertisementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_table_return_type_1.AdvertisementTableReturnType),
    __param(0, (0, graphql_1.Args)('advertisementId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "removeAdvertisementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.PIGBONDHU, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_table_return_type_1.AdvertisementTableReturnType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTableResolver.prototype, "toggleActiveStatusAdvertisement", null);
AdvertisementTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => advertisement_table_entity_1.AdvertisementTable),
    __metadata("design:paramtypes", [advertisement_table_service_1.AdvertisementTableService])
], AdvertisementTableResolver);
exports.AdvertisementTableResolver = AdvertisementTableResolver;
