import { AdvertisementTypeTableService } from 'src/advertisement-type-table/advertisement-type-table.service';
import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateAdvertisementTableInput } from './dto/create-advertisement-table.input';
import { UpdateAdvertisementTableInput } from './dto/update-advertisement-table.input';
import { AdvertisementTable } from './entities/advertisement-table.entity';
export declare class AdvertisementTableService {
    private readonly advertisementTableRepository;
    private readonly advertisementTypeTableService;
    private readonly userCollectionService;
    private readonly farmersTableService;
    constructor(advertisementTableRepository: Repository<AdvertisementTable>, advertisementTypeTableService: AdvertisementTypeTableService, userCollectionService: UserCollectionService, farmersTableService: FarmersTableService);
    create(createAdvertisementTableInput: CreateAdvertisementTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
    checkIfExists(createAdvertisementTableInput: CreateAdvertisementTableInput): Promise<boolean>;
    findByFarmerId(farmerId: number): Promise<AdvertisementTable[]>;
    findAll(): Promise<AdvertisementTable[]>;
    findOne(advertisementId: number): Promise<AdvertisementTable>;
    findOneByFarmerId(farmerId: number): Promise<AdvertisementTable[]>;
    update(advertisementId: number, updateAdvertisementTableInput: UpdateAdvertisementTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
    remove(advertisementId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    toggleActiveStatus(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTable;
    }>;
}
