import { AdvertisementTypeTableService } from './advertisement-type-table.service';
import { AdvertisementTypeTable } from './entities/advertisement-type-table.entity';
import { CreateAdvertisementTypeTableInput } from './dto/create-advertisement-type-table.input';
import { UpdateAdvertisementTypeTableInput } from './dto/update-advertisement-type-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ADVERTISEMENTTYPE_ADD = "NEW_ADVERTISEMENTTYPE_ADD";
export declare class AdvertisementTypeTableResolver {
    private readonly advertisementTypeTableService;
    private pubSub;
    constructor(advertisementTypeTableService: AdvertisementTypeTableService, pubSub: RedisPubSub);
    createAdvertisementTypeTable(createAdvertisementTypeTableInput: CreateAdvertisementTypeTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTypeTable;
    }>;
    findAllAdvertisementType(): Promise<AdvertisementTypeTable[]>;
    findOneAdvertisementType(advertisementTypeId: number): Promise<AdvertisementTypeTable>;
    updateAdvertisementTypeTable(updateAdvertisementTypeTableInput: UpdateAdvertisementTypeTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTypeTable;
    }>;
    removeAdvertisementTypeTable(advertisementTypeId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    advertisementTypeSubscription(): AsyncIterator<unknown, any, undefined>;
}
