"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdvertisementTypeTableResolver = exports.NEW_ADVERTISEMENTTYPE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const advertisement_type_table_service_1 = require("./advertisement-type-table.service");
const advertisement_type_table_entity_1 = require("./entities/advertisement-type-table.entity");
const create_advertisement_type_table_input_1 = require("./dto/create-advertisement-type-table.input");
const update_advertisement_type_table_input_1 = require("./dto/update-advertisement-type-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const advertisement_type_table_return_type_1 = require("./types/advertisement-type-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const advertisement_type_table_type_1 = require("./types/advertisement-type-table.type");
const advertisement_count_changed_type_1 = require("./types/advertisement-count-changed.type");
exports.NEW_ADVERTISEMENTTYPE_ADD = "NEW_ADVERTISEMENTTYPE_ADD";
let AdvertisementTypeTableResolver = class AdvertisementTypeTableResolver {
    constructor(advertisementTypeTableService, pubSub) {
        this.advertisementTypeTableService = advertisementTypeTableService;
        this.pubSub = pubSub;
    }
    createAdvertisementTypeTable(createAdvertisementTypeTableInput, user) {
        return this.advertisementTypeTableService.create(createAdvertisementTypeTableInput, user);
    }
    findAllAdvertisementType() {
        return this.advertisementTypeTableService.findAll();
    }
    findOneAdvertisementType(advertisementTypeId) {
        return this.advertisementTypeTableService.findOne(advertisementTypeId);
    }
    updateAdvertisementTypeTable(updateAdvertisementTypeTableInput, user) {
        return this.advertisementTypeTableService.update(updateAdvertisementTypeTableInput.advertisementTypeId, updateAdvertisementTypeTableInput, user);
    }
    removeAdvertisementTypeTable(advertisementTypeId) {
        return this.advertisementTypeTableService.remove(advertisementTypeId);
    }
    advertisementTypeSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_ADVERTISEMENTTYPE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_type_table_return_type_1.AdvertisementTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('createAdvertisementTypeTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_advertisement_type_table_input_1.CreateAdvertisementTypeTableInput, Object]),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "createAdvertisementTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [advertisement_type_table_type_1.AdvertisementTypeTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "findAllAdvertisementType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => advertisement_type_table_type_1.AdvertisementTypeTableType),
    __param(0, (0, graphql_1.Args)('advertisementTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "findOneAdvertisementType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_type_table_return_type_1.AdvertisementTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAdvertisementTypeTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_advertisement_type_table_input_1.UpdateAdvertisementTypeTableInput, Object]),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "updateAdvertisementTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => advertisement_type_table_return_type_1.AdvertisementTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('advertisementTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "removeAdvertisementTypeTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => advertisement_count_changed_type_1.AdvertisementCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AdvertisementTypeTableResolver.prototype, "advertisementTypeSubscription", null);
AdvertisementTypeTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => advertisement_type_table_entity_1.AdvertisementTypeTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [advertisement_type_table_service_1.AdvertisementTypeTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], AdvertisementTypeTableResolver);
exports.AdvertisementTypeTableResolver = AdvertisementTypeTableResolver;
