import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateAdvertisementTypeTableInput } from './dto/create-advertisement-type-table.input';
import { UpdateAdvertisementTypeTableInput } from './dto/update-advertisement-type-table.input';
import { AdvertisementTypeTable } from './entities/advertisement-type-table.entity';
export declare const NEW_ADVERTISEMENTTYPE_ADD = "NEW_ADVERTISEMENTTYPE_ADD";
export declare class AdvertisementTypeTableService {
    private readonly advertisementTypeTableRepository;
    private pubSub;
    constructor(advertisementTypeTableRepository: Repository<AdvertisementTypeTable>, pubSub: RedisPubSub);
    create(createAdvertisementTypeTableInput: CreateAdvertisementTypeTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTypeTable;
    }>;
    checkIfExists(createAdvertisementTypeTableInput: CreateAdvertisementTypeTableInput): Promise<boolean>;
    findAll(): Promise<AdvertisementTypeTable[]>;
    findOne(advertisementTypeId: number): Promise<AdvertisementTypeTable>;
    update(advertisementTypeId: number, updateAdvertisementTypeTableInput: UpdateAdvertisementTypeTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AdvertisementTypeTable;
    }>;
    remove(advertisementTypeId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
