"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalDiseaseSubTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const create_disease_decease_input_1 = require("./dto/create-disease-decease.input");
const animal_disease_sub_table_entity_1 = require("./entities/animal-disease-sub-table.entity");
const animal_disease_sub_table_service_1 = require("./animal-disease-sub-table.service");
const animal_disease_sub_table_return_type_1 = require("./types/animal-disease-sub-table-return.type");
const create_animal_disease_sub_table_input_1 = require("./dto/create-animal-disease-sub-table.input");
const animal_disease_sub_table_type_1 = require("./types/animal-disease-sub-table.type");
const update_animal_disease_sub_table_input_1 = require("./dto/update-animal-disease-sub-table.input");
const disease_report_type_1 = require("./types/disease-report.type");
let AnimalDiseaseSubTableResolver = class AnimalDiseaseSubTableResolver {
    constructor(animalDiseaseSubTableService) {
        this.animalDiseaseSubTableService = animalDiseaseSubTableService;
    }
    createAnimalDiseaseSubTable(createAnimalDiseaseSubTableInput, user) {
        return this.animalDiseaseSubTableService.create(createAnimalDiseaseSubTableInput, user);
    }
    findAllAnimalDiseaseSubTable() {
        return this.animalDiseaseSubTableService.findAll();
    }
    findOneAnimalDiseaseSubTable(animalDiseaseSubId) {
        return this.animalDiseaseSubTableService.findOne(animalDiseaseSubId);
    }
    updateAnimalDiseaseSubTable(updateAnimalDiseaseSubTableInput, user) {
        return this.animalDiseaseSubTableService.update(updateAnimalDiseaseSubTableInput.animalDiseaseSubId, updateAnimalDiseaseSubTableInput, user);
    }
    removeAnimalDiseaseSubTable(animalDiseaseSubId) {
        return this.animalDiseaseSubTableService.remove(animalDiseaseSubId);
    }
    animalDeceaseEntry(createDeceaseFromDiseae, user) {
        return this.animalDiseaseSubTableService.animalDeceaseEntry(createDeceaseFromDiseae, user);
    }
    updateDiseaseNameOfAnimalDisease(animalDiseaseSubId, diseaseId, user) {
        return this.animalDiseaseSubTableService.updateDiseaseNameOfAnimalDisease(animalDiseaseSubId, diseaseId);
    }
    getDiseaseDetailsOfOneAnimal(animalId) {
        return this.animalDiseaseSubTableService.getDiseaseDetailsOfOneAnimal(animalId);
    }
    fetchDiseasesByDistrictId(districtId, startingDate, endingDate) {
        return this.animalDiseaseSubTableService.fetchDiseasesByDistrictId(districtId, startingDate, endingDate);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_disease_sub_table_return_type_1.AnimalDiseaseSubTableReturnType),
    __param(0, (0, graphql_1.Args)('createAnimalDiseaseSubTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_animal_disease_sub_table_input_1.CreateAnimalDiseaseSubTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "createAnimalDiseaseSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_disease_sub_table_type_1.AnimalDiseaseSubTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "findAllAnimalDiseaseSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_disease_sub_table_type_1.AnimalDiseaseSubTableType),
    __param(0, (0, graphql_1.Args)('animalDiseaseSubId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "findOneAnimalDiseaseSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_disease_sub_table_return_type_1.AnimalDiseaseSubTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAnimalDiseaseSubTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_animal_disease_sub_table_input_1.UpdateAnimalDiseaseSubTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "updateAnimalDiseaseSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_disease_sub_table_return_type_1.AnimalDiseaseSubTableReturnType),
    __param(0, (0, graphql_1.Args)('animalDiseaseSubId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "removeAnimalDiseaseSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_disease_sub_table_return_type_1.AnimalDiseaseSubTableReturnType),
    __param(0, (0, graphql_1.Args)('createDeceaseFromDiseae')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_disease_decease_input_1.CreateDeceaseFromDiseae, Object]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "animalDeceaseEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_disease_sub_table_return_type_1.AnimalDiseaseSubTableReturnType),
    __param(0, (0, graphql_1.Args)('animalDiseaseSubId')),
    __param(1, (0, graphql_1.Args)('diseaseId')),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "updateDiseaseNameOfAnimalDisease", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_disease_sub_table_type_1.AnimalDiseaseSubTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "getDiseaseDetailsOfOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [disease_report_type_1.DiseaseReportDistrictWise]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('startingDate', { type: () => String })),
    __param(2, (0, graphql_1.Args)('endingDate', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String]),
    __metadata("design:returntype", void 0)
], AnimalDiseaseSubTableResolver.prototype, "fetchDiseasesByDistrictId", null);
AnimalDiseaseSubTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => animal_disease_sub_table_entity_1.AnimalDiseaseSubTable),
    __metadata("design:paramtypes", [animal_disease_sub_table_service_1.AnimalDiseaseSubTableService])
], AnimalDiseaseSubTableResolver);
exports.AnimalDiseaseSubTableResolver = AnimalDiseaseSubTableResolver;
