import { AnimalDiseaseTableService } from 'src/animal-disease/animal-disease-table.service';
import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { DiseaseObservationTableService } from 'src/disease-observation-table/disease-observation-table.service';
import { DiseaseTableService } from 'src/disease-table/disease-table.service';
import { DistrictTableService } from 'src/district-table/district-table.service';
import { StockEntryTableService } from 'src/stock-entry/stock-entry-table.service';
import { Repository } from 'typeorm';
import { CreateAnimalDiseaseSubTableInput } from './dto/create-animal-disease-sub-table.input';
import { CreateDeceaseFromDiseae } from './dto/create-disease-decease.input';
import { UpdateAnimalDiseaseSubTableInput } from './dto/update-animal-disease-sub-table.input';
import { AnimalDiseaseSubTable } from './entities/animal-disease-sub-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class AnimalDiseaseSubTableService {
    private readonly animalDiseaseSubTableRepository;
    private readonly dataEntryTableService;
    private readonly animalEntryTableService;
    private readonly diseaseTableService;
    private readonly stockEntryTableService;
    private readonly animalDiseaseTableService;
    private readonly diseaseObservationTableService;
    private readonly districtTableService;
    constructor(animalDiseaseSubTableRepository: Repository<AnimalDiseaseSubTable>, dataEntryTableService: DataEntryTableService, animalEntryTableService: AnimalEntryTableService, diseaseTableService: DiseaseTableService, stockEntryTableService: StockEntryTableService, animalDiseaseTableService: AnimalDiseaseTableService, diseaseObservationTableService: DiseaseObservationTableService, districtTableService: DistrictTableService);
    create(CreateAnimalDiseaseSubTableInput: CreateAnimalDiseaseSubTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAll(): Promise<AnimalDiseaseSubTable[]>;
    findAllByHousingId(housingId: number): Promise<AnimalDiseaseSubTable[]>;
    findOne(animalDiseaseId: number): Promise<AnimalDiseaseSubTable>;
    findOneById(animalDiseaseSubId: number): Promise<AnimalDiseaseSubTable>;
    update(animalDiseaseSubId: number, updateAnimalDiseaseSubTableInput: UpdateAnimalDiseaseSubTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalDiseaseSubTable;
    }>;
    remove(animalDiseaseSubId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    animalDeceaseEntry(createDeceaseFromDiseae: CreateDeceaseFromDiseae, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    updateDiseaseNameOfAnimalDisease(animalDiseaseSubId: number, diseaseId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    fetchDiseasesByDistrictId(districtId: number, startingDate: string, endingDate: string): Promise<any>;
    getDiseaseDetailsOfOneAnimal(animalId: number): Promise<AnimalDiseaseSubTable[]>;
}
