"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalDiseaseSubTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const animal_disease_table_service_1 = require("../animal-disease/animal-disease-table.service");
const animal_entry_table_service_1 = require("../animal-table/animal-entry-table.service");
const animal_entry_table_entity_1 = require("../animal-table/entities/animal-entry-table.entity");
const disease_observation_table_service_1 = require("../disease-observation-table/disease-observation-table.service");
const disease_table_service_1 = require("../disease-table/disease-table.service");
const disease_table_entity_1 = require("../disease-table/entities/disease-table.entity");
const district_table_service_1 = require("../district-table/district-table.service");
const farmers_table_entity_1 = require("../farmers-table/entities/farmers-table.entity");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const housing_table_entity_1 = require("../housing-table/entities/housing-table.entity");
const stock_entry_table_service_1 = require("../stock-entry/stock-entry-table.service");
const typeorm_2 = require("typeorm");
const animal_disease_sub_table_entity_1 = require("./entities/animal-disease-sub-table.entity");
const data_entry_table_service_1 = require("../data-entry-table/data-entry-table.service");
let AnimalDiseaseSubTableService = class AnimalDiseaseSubTableService {
    constructor(animalDiseaseSubTableRepository, dataEntryTableService, animalEntryTableService, diseaseTableService, stockEntryTableService, animalDiseaseTableService, diseaseObservationTableService, districtTableService) {
        this.animalDiseaseSubTableRepository = animalDiseaseSubTableRepository;
        this.dataEntryTableService = dataEntryTableService;
        this.animalEntryTableService = animalEntryTableService;
        this.diseaseTableService = diseaseTableService;
        this.stockEntryTableService = stockEntryTableService;
        this.animalDiseaseTableService = animalDiseaseTableService;
        this.diseaseObservationTableService = diseaseObservationTableService;
        this.districtTableService = districtTableService;
    }
    async create(CreateAnimalDiseaseSubTableInput, user) {
        if (Array.isArray(CreateAnimalDiseaseSubTableInput.animalData) && CreateAnimalDiseaseSubTableInput.animalData.length > 0) {
            for (const el of CreateAnimalDiseaseSubTableInput.animalData) {
                let dd = new animal_disease_sub_table_entity_1.AnimalDiseaseSubTable();
                dd.dateOfOccurence = CreateAnimalDiseaseSubTableInput.dateOfOccurence;
                dd.details = CreateAnimalDiseaseSubTableInput.details;
                dd.AnimalTable = await this.animalEntryTableService.findByAnimalId(el.animalId);
                dd.DiseaseTable = CreateAnimalDiseaseSubTableInput.diseaseId == 0 ? null : await this.diseaseTableService.findOne(CreateAnimalDiseaseSubTableInput.diseaseId);
                dd.AnimalDiseaseTable = await this.animalDiseaseTableService.findOne(CreateAnimalDiseaseSubTableInput.animalDiseaseId);
                await this.animalDiseaseSubTableRepository.save(dd);
            }
        }
        else {
            let animals = await this.animalEntryTableService.findByCurrentStock(CreateAnimalDiseaseSubTableInput.currentStockId, CreateAnimalDiseaseSubTableInput.qty);
            if (animals.length == CreateAnimalDiseaseSubTableInput.qty) {
                for (const el1 of animals) {
                    let dd = new animal_disease_sub_table_entity_1.AnimalDiseaseSubTable();
                    dd.dateOfOccurence = CreateAnimalDiseaseSubTableInput.dateOfOccurence;
                    dd.details = CreateAnimalDiseaseSubTableInput.details;
                    dd.AnimalTable = await this.animalEntryTableService.findByAnimalId(el1.animalId);
                    dd.DiseaseTable = await this.diseaseTableService.findOne(CreateAnimalDiseaseSubTableInput.diseaseId);
                    dd.AnimalDiseaseTable = await this.animalDiseaseTableService.findOne(CreateAnimalDiseaseSubTableInput.animalDiseaseId);
                    await this.animalDiseaseSubTableRepository.save(dd);
                }
            }
        }
        this.dataEntryTableService.create({ type: GlobalConstants_1.CREATE, typeOfEntry: GlobalConstants_1.DISEASE_ADD, remarks: "New Disease added" }, user);
        return {
            status: true,
            status_text: "Successfully Created",
            data: null
        };
    }
    async findAll() {
        return await this.animalDiseaseSubTableRepository.find({
            relations: {
                AnimalTable: true,
                DiseaseTable: true
            }
        });
    }
    async findAllByHousingId(housingId) {
        let result = await this.animalDiseaseSubTableRepository.find({
            where: {
                AnimalTable: {
                    HousingTable: {
                        housingId
                    }
                }
            },
            relations: {
                AnimalTable: {
                    HousingTable: {
                        FarmersTable: true
                    }
                },
                DiseaseTable: true,
                AnimalDiseaseTable: true,
            }
        });
        let index = 0;
        for (const el of result) {
            result[index]['observationCount'] = await this.diseaseObservationTableService.countBySubTableId(el.animalDiseaseSubId);
            index++;
        }
        return result;
    }
    async findOne(animalDiseaseId) {
        return await this.animalDiseaseSubTableRepository.findOne({
            where: {
                AnimalDiseaseTable: {
                    animalDiseaseId
                }
            },
            relations: {
                AnimalTable: true,
                DiseaseTable: true
            }
        });
    }
    async findOneById(animalDiseaseSubId) {
        return await this.animalDiseaseSubTableRepository.findOne({
            where: {
                animalDiseaseSubId
            }
        });
    }
    async update(animalDiseaseSubId, updateAnimalDiseaseSubTableInput, user) {
        let ht = await this.animalDiseaseSubTableRepository.findOne({
            where: {
                animalDiseaseSubId,
                AnimalTable: {
                    animalId: updateAnimalDiseaseSubTableInput.animalId
                }
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.dateOfOccurence = updateAnimalDiseaseSubTableInput.dateOfOccurence;
            ht.details = updateAnimalDiseaseSubTableInput.details;
            ht.DiseaseTable = await this.diseaseTableService.findOne(updateAnimalDiseaseSubTableInput.diseaseId);
            let result = await this.animalDiseaseSubTableRepository.save(ht);
            this.dataEntryTableService.create({ type: GlobalConstants_1.UPDATE, typeOfEntry: GlobalConstants_1.DISEASE_UPDATE, remarks: "Disease Updated" }, user);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(animalDiseaseSubId) {
        let ht = await this.animalDiseaseSubTableRepository.findOne({
            where: {
                animalDiseaseSubId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.animalDiseaseSubTableRepository.remove(ht);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
    async animalDeceaseEntry(createDeceaseFromDiseae, user) {
        var _a;
        let ht = await this.animalDiseaseSubTableRepository.findOne({
            where: {
                animalDiseaseSubId: createDeceaseFromDiseae.animalDiseaseSubId,
                AnimalTable: {
                    animalId: createDeceaseFromDiseae.animalId
                }
            },
            relations: {
                AnimalTable: true,
                DiseaseTable: true
            }
        });
        if (ht == null || ht == undefined) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            if (createDeceaseFromDiseae.status == "ACTIVE") {
                ht.status = createDeceaseFromDiseae.status;
                ht.remarks = createDeceaseFromDiseae.remarks;
                ht.deceaseDate = null;
                await this.animalDiseaseSubTableRepository.save(ht);
                this.dataEntryTableService.create({ type: GlobalConstants_1.UPDATE, typeOfEntry: GlobalConstants_1.DISEASE_UPDATE, remarks: "Disease Status Updated" }, user);
                return {
                    status: true,
                    status_text: "Successfully Entered",
                    data: null
                };
            }
            if (createDeceaseFromDiseae.status == "CURED") {
                ht.status = createDeceaseFromDiseae.status;
                ht.remarks = createDeceaseFromDiseae.remarks;
                ht.deceaseDate = null;
                await this.animalDiseaseSubTableRepository.save(ht);
                this.dataEntryTableService.create({ type: GlobalConstants_1.UPDATE, typeOfEntry: GlobalConstants_1.DISEASE_UPDATE, remarks: "Disease Status Updated" }, user);
                return {
                    status: true,
                    status_text: "Successfully Entered",
                    data: null
                };
            }
            if (createDeceaseFromDiseae.status == "DECEASED") {
                let temp = {
                    animalId: ht.AnimalTable.animalId,
                    diseaseId: (_a = ht.DiseaseTable) === null || _a === void 0 ? void 0 : _a.diseaseTableId,
                    dateOfEntry: createDeceaseFromDiseae.dateOfDecease,
                    remarks: createDeceaseFromDiseae.remarks,
                };
                let rr = await this.stockEntryTableService.deceaseEntry(temp, user);
                if (rr.status) {
                    ht.status = createDeceaseFromDiseae.status;
                    ht.deceaseDate = createDeceaseFromDiseae.dateOfDecease;
                    await this.animalDiseaseSubTableRepository.save(ht);
                    this.dataEntryTableService.create({ type: GlobalConstants_1.UPDATE, typeOfEntry: GlobalConstants_1.DISEASE_UPDATE, remarks: "Disease Status Updated" }, user);
                    return {
                        status: true,
                        status_text: "Successfully Entered",
                        data: null
                    };
                }
            }
        }
    }
    async updateDiseaseNameOfAnimalDisease(animalDiseaseSubId, diseaseId) {
        let ht = await this.animalDiseaseSubTableRepository.findOne({
            where: {
                animalDiseaseSubId: animalDiseaseSubId,
            }
        });
        if (ht == null || ht == undefined) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            let dis = await this.diseaseTableService.findOne(diseaseId);
            ht.DiseaseTable = dis;
            await this.animalDiseaseSubTableRepository.save(ht);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: null
            };
        }
    }
    async fetchDiseasesByDistrictId(districtId, startingDate, endingDate) {
        let data = [];
        let diseases = await this.diseaseTableService.findAll();
        for (const disease of diseases) {
            let result = await this.animalDiseaseSubTableRepository.createQueryBuilder("r")
                .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
                .leftJoinAndMapOne("ml1.HousingTable", housing_table_entity_1.HousingTable, "ml3", "ml3.housingId=ml1.housingId")
                .leftJoinAndMapOne("ml3.FarmersTable", farmers_table_entity_1.FarmersTable, "ml4", "ml4.farmerId=ml3.farmerId")
                .leftJoinAndMapOne("r.DiseaseTable", disease_table_entity_1.DiseaseTable, "ml2", "ml2.diseaseTableId=r.diseaseId")
                .where("r.diseaseId=:diseaseId", { diseaseId: disease.diseaseTableId })
                .andWhere("ml4.districtId=:districtId", { districtId: districtId })
                .andWhere("STR_TO_DATE(r.dateOfOccurence,'%Y-%m-%d') BETWEEN STR_TO_DATE(:startingDate,'%Y-%m-%d') AND STR_TO_DATE(:endingDate,'%Y-%m-%d')", {
                startingDate: startingDate,
                endingDate: endingDate,
            })
                .getMany();
            let totalOccurance = 0;
            let totalCured = 0;
            let totalPending = 0;
            let totalDeceased = 0;
            let mortalityRate = "0";
            result.map((el) => {
                totalOccurance++;
                if (el.status === "CURED") {
                    totalCured++;
                }
                if (el.status === "PENDING") {
                    totalPending++;
                }
                if (el.status === "DECEASED") {
                    totalDeceased++;
                }
            });
            if (totalOccurance > 0) {
                let mt = (totalDeceased / totalOccurance) * 1000;
                mortalityRate = mt.toFixed(0);
            }
            let d = {
                DiseaseTable: disease,
                totalOccurance,
                totalCured,
                totalPending,
                totalDeceased,
                mortalityRate
            };
            console.log(d);
            data.push(d);
        }
        return data;
    }
    async getDiseaseDetailsOfOneAnimal(animalId) {
        let result = await this.animalDiseaseSubTableRepository.createQueryBuilder("r")
            .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
            .leftJoinAndMapOne("r.DiseaseTable", disease_table_entity_1.DiseaseTable, "ml2", "ml2.diseaseTableId=r.diseaseId")
            .where("r.animalId=:animalId", { animalId: animalId })
            .getMany();
        let index = 0;
        for (const el of result) {
            result[index]['DiseaseObservationTable'] = await this.diseaseObservationTableService.findAllBySubTableId(el.animalDiseaseSubId);
            index++;
        }
        return result;
    }
};
AnimalDiseaseSubTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(animal_disease_sub_table_entity_1.AnimalDiseaseSubTable)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_entry_table_service_1.AnimalEntryTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => disease_table_service_1.DiseaseTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => stock_entry_table_service_1.StockEntryTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_disease_table_service_1.AnimalDiseaseTableService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => disease_observation_table_service_1.DiseaseObservationTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        data_entry_table_service_1.DataEntryTableService,
        animal_entry_table_service_1.AnimalEntryTableService,
        disease_table_service_1.DiseaseTableService,
        stock_entry_table_service_1.StockEntryTableService,
        animal_disease_table_service_1.AnimalDiseaseTableService,
        disease_observation_table_service_1.DiseaseObservationTableService,
        district_table_service_1.DistrictTableService])
], AnimalDiseaseSubTableService);
exports.AnimalDiseaseSubTableService = AnimalDiseaseSubTableService;
