import { AnimalDiseaseSubTableService } from 'src/animal-disease-sub-table/animal-disease-sub-table.service';
import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { DiseaseTableService } from 'src/disease-table/disease-table.service';
import { StockEntryTableService } from 'src/stock-entry/stock-entry-table.service';
import { Repository } from 'typeorm';
import { CreateAnimalDiseaseTableInput } from './dto/create-animal-disease-table.input';
import { AnimalDiseaseTable } from './entities/animal-disease-table.entity';
export declare class AnimalDiseaseTableService {
    private readonly animalDiseaseTableRepository;
    private readonly animalEntryTableService;
    private readonly diseaseTableService;
    private readonly stockEntryTableService;
    private readonly animalDiseaseSubTableService;
    constructor(animalDiseaseTableRepository: Repository<AnimalDiseaseTable>, animalEntryTableService: AnimalEntryTableService, diseaseTableService: DiseaseTableService, stockEntryTableService: StockEntryTableService, animalDiseaseSubTableService: AnimalDiseaseSubTableService);
    create(createAnimalDiseaseTableInput: CreateAnimalDiseaseTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAll(): Promise<AnimalDiseaseTable[]>;
    findOne(animalDiseaseId: number): Promise<AnimalDiseaseTable>;
    findDiseaseByFarmerId(farmerId: number): Promise<AnimalDiseaseTable[]>;
    findDiseaseByHousingId(housingId: number): Promise<import("../animal-disease-sub-table/entities/animal-disease-sub-table.entity").AnimalDiseaseSubTable[]>;
}
