"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalDiseaseTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const animal_disease_sub_table_service_1 = require("../animal-disease-sub-table/animal-disease-sub-table.service");
const animal_entry_table_service_1 = require("../animal-table/animal-entry-table.service");
const disease_table_service_1 = require("../disease-table/disease-table.service");
const stock_entry_table_service_1 = require("../stock-entry/stock-entry-table.service");
const typeorm_2 = require("typeorm");
const animal_disease_table_entity_1 = require("./entities/animal-disease-table.entity");
let AnimalDiseaseTableService = class AnimalDiseaseTableService {
    constructor(animalDiseaseTableRepository, animalEntryTableService, diseaseTableService, stockEntryTableService, animalDiseaseSubTableService) {
        this.animalDiseaseTableRepository = animalDiseaseTableRepository;
        this.animalEntryTableService = animalEntryTableService;
        this.diseaseTableService = diseaseTableService;
        this.stockEntryTableService = stockEntryTableService;
        this.animalDiseaseSubTableService = animalDiseaseSubTableService;
    }
    async create(createAnimalDiseaseTableInput, user) {
        let dd = new animal_disease_table_entity_1.AnimalDiseaseTable();
        dd.dateOfOccurence = createAnimalDiseaseTableInput.dateOfOccurence;
        dd.animalData = createAnimalDiseaseTableInput.animalData;
        dd.symptoms = createAnimalDiseaseTableInput.symptoms;
        let rr = await this.animalDiseaseTableRepository.save(dd);
        await this.animalDiseaseSubTableService.create(Object.assign(Object.assign({}, createAnimalDiseaseTableInput), { animalDiseaseId: rr.animalDiseaseId, qty: createAnimalDiseaseTableInput.qty }), user);
        return {
            status: true,
            status_text: "Successfully Created",
            data: null
        };
    }
    async findAll() {
        return await this.animalDiseaseTableRepository.find({
            relations: {
                AnimalDiseaseSubTable: {
                    AnimalTable: {
                        HousingTable: {
                            FarmersTable: true
                        }
                    },
                    DiseaseTable: true
                }
            }
        });
    }
    async findOne(animalDiseaseId) {
        return await this.animalDiseaseTableRepository.findOne({
            where: {
                animalDiseaseId: animalDiseaseId
            },
            relations: {
                AnimalDiseaseSubTable: {
                    AnimalTable: {
                        HousingTable: {
                            FarmersTable: true
                        }
                    },
                    DiseaseTable: true
                }
            }
        });
    }
    async findDiseaseByFarmerId(farmerId) {
        return await this.animalDiseaseTableRepository.find({
            where: {
                AnimalDiseaseSubTable: {
                    AnimalTable: {
                        HousingTable: {
                            FarmersTable: {
                                farmerId
                            }
                        }
                    }
                }
            },
            relations: {
                AnimalDiseaseSubTable: {
                    AnimalTable: {
                        HousingTable: {
                            FarmersTable: true
                        }
                    },
                    DiseaseTable: true
                }
            }
        });
    }
    async findDiseaseByHousingId(housingId) {
        let result = await this.animalDiseaseSubTableService.findAllByHousingId(housingId);
        return result;
    }
};
AnimalDiseaseTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(animal_disease_table_entity_1.AnimalDiseaseTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_entry_table_service_1.AnimalEntryTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => disease_table_service_1.DiseaseTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => stock_entry_table_service_1.StockEntryTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_disease_sub_table_service_1.AnimalDiseaseSubTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        animal_entry_table_service_1.AnimalEntryTableService,
        disease_table_service_1.DiseaseTableService,
        stock_entry_table_service_1.StockEntryTableService,
        animal_disease_sub_table_service_1.AnimalDiseaseSubTableService])
], AnimalDiseaseTableService);
exports.AnimalDiseaseTableService = AnimalDiseaseTableService;
