import { AnimalHealthCoverageService } from './animal-health-coverage.service';
import { AnimalHealthCoverage } from './entities/animal-health-coverage.entity';
import { CreateAnimalHealthCoverageInput } from './dto/create-animal-health-coverage.input';
import { UpdateAnimalHealthCoverageInput } from './dto/update-animal-health-coverage.input';
export declare class AnimalHealthCoverageResolver {
    private readonly animalHealthCoverageService;
    constructor(animalHealthCoverageService: AnimalHealthCoverageService);
    createAnimalHealthCoverage(createAnimalHealthCoverageInput: CreateAnimalHealthCoverageInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAllAnimalHealthCoverage(): Promise<AnimalHealthCoverage[]>;
    findOneAnimalHealthCoverage(healthCoverageId: number): Promise<AnimalHealthCoverage>;
    updateAnimalHealthCoverage(updateAnimalHealthCoverageInput: UpdateAnimalHealthCoverageInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalHealthCoverage;
    }>;
    removeAnimalHealthCoverage(healthCoverageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAnimalHealthCoverageByFarmerId(farmerId: number): Promise<AnimalHealthCoverage[]>;
    findAnimalHealthCoverageByHousingd(housingId: number): Promise<AnimalHealthCoverage[]>;
    toggleNextDoseStatus(healthCoverageId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getHealthCoverageDetailsOfOneAnimal(animalId: number): Promise<AnimalHealthCoverage[]>;
}
