"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalHealthCoverageResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const animal_health_coverage_service_1 = require("./animal-health-coverage.service");
const animal_health_coverage_entity_1 = require("./entities/animal-health-coverage.entity");
const create_animal_health_coverage_input_1 = require("./dto/create-animal-health-coverage.input");
const update_animal_health_coverage_input_1 = require("./dto/update-animal-health-coverage.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const common_1 = require("@nestjs/common");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const animal_health_coverage_table_return_type_1 = require("./types/animal-health-coverage-table-return.type");
const animal_health_coverage_table_type_1 = require("./types/animal-health-coverage-table.type");
let AnimalHealthCoverageResolver = class AnimalHealthCoverageResolver {
    constructor(animalHealthCoverageService) {
        this.animalHealthCoverageService = animalHealthCoverageService;
    }
    createAnimalHealthCoverage(createAnimalHealthCoverageInput, user) {
        return this.animalHealthCoverageService.create(createAnimalHealthCoverageInput, user);
    }
    findAllAnimalHealthCoverage() {
        return this.animalHealthCoverageService.findAll();
    }
    findOneAnimalHealthCoverage(healthCoverageId) {
        return this.animalHealthCoverageService.findOne(healthCoverageId);
    }
    updateAnimalHealthCoverage(updateAnimalHealthCoverageInput, user) {
        return this.animalHealthCoverageService.update(updateAnimalHealthCoverageInput.healthCoverageId, updateAnimalHealthCoverageInput, user);
    }
    removeAnimalHealthCoverage(healthCoverageId) {
        return this.animalHealthCoverageService.remove(healthCoverageId);
    }
    findAnimalHealthCoverageByFarmerId(farmerId) {
        return this.animalHealthCoverageService.findAnimalHealthCoverageByFarmerId(farmerId);
    }
    findAnimalHealthCoverageByHousingd(housingId) {
        return this.animalHealthCoverageService.findAnimalHealthCoverageByHousingd(housingId);
    }
    toggleNextDoseStatus(healthCoverageId, user) {
        return this.animalHealthCoverageService.toggleNextDoseStatus(healthCoverageId, user);
    }
    getHealthCoverageDetailsOfOneAnimal(animalId) {
        return this.animalHealthCoverageService.getHealthCoverageDetailsOfOneAnimal(animalId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_health_coverage_table_return_type_1.AnimalHealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('createAnimalHealthCoverageInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_animal_health_coverage_input_1.CreateAnimalHealthCoverageInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "createAnimalHealthCoverage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_health_coverage_table_type_1.AnimalHealthCoverageTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "findAllAnimalHealthCoverage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_health_coverage_table_type_1.AnimalHealthCoverageTableType),
    __param(0, (0, graphql_1.Args)('healthCoverageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "findOneAnimalHealthCoverage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_health_coverage_table_return_type_1.AnimalHealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAnimalHealthCoverageInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_animal_health_coverage_input_1.UpdateAnimalHealthCoverageInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "updateAnimalHealthCoverage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_health_coverage_table_return_type_1.AnimalHealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('healthCoverageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "removeAnimalHealthCoverage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_health_coverage_table_type_1.AnimalHealthCoverageTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "findAnimalHealthCoverageByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_health_coverage_table_type_1.AnimalHealthCoverageTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "findAnimalHealthCoverageByHousingd", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_health_coverage_table_return_type_1.AnimalHealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('healthCoverageId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "toggleNextDoseStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_health_coverage_table_type_1.AnimalHealthCoverageTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalHealthCoverageResolver.prototype, "getHealthCoverageDetailsOfOneAnimal", null);
AnimalHealthCoverageResolver = __decorate([
    (0, graphql_1.Resolver)(() => animal_health_coverage_entity_1.AnimalHealthCoverage),
    __metadata("design:paramtypes", [animal_health_coverage_service_1.AnimalHealthCoverageService])
], AnimalHealthCoverageResolver);
exports.AnimalHealthCoverageResolver = AnimalHealthCoverageResolver;
