import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { HealthCoverageTableService } from 'src/health-coverage-table/health-coverage-table.service';
import { Repository } from 'typeorm';
import { CreateAnimalHealthCoverageInput } from './dto/create-animal-health-coverage.input';
import { UpdateAnimalHealthCoverageInput } from './dto/update-animal-health-coverage.input';
import { AnimalHealthCoverage } from './entities/animal-health-coverage.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class AnimalHealthCoverageService {
    private readonly animalHealthCoverageTableRepository;
    private readonly dataEntryTableService;
    private readonly animalEntryTableService;
    private readonly healthCoverageTableService;
    constructor(animalHealthCoverageTableRepository: Repository<AnimalHealthCoverage>, dataEntryTableService: DataEntryTableService, animalEntryTableService: AnimalEntryTableService, healthCoverageTableService: HealthCoverageTableService);
    create(createAnimalHealthCoverageInput: CreateAnimalHealthCoverageInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    checkIfExists(animalId: number, dateOfCoverage: string): Promise<boolean>;
    findAll(): Promise<AnimalHealthCoverage[]>;
    findOne(healthCoverageId: number): Promise<AnimalHealthCoverage>;
    findAnimalHealthCoverageByFarmerId(farmerId: number): Promise<AnimalHealthCoverage[]>;
    findAnimalHealthCoverageByHousingd(housingId: number): Promise<AnimalHealthCoverage[]>;
    update(healthCoverageId: number, updateAnimalHealthCoverageInput: UpdateAnimalHealthCoverageInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalHealthCoverage;
    }>;
    remove(healthCoverageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    toggleNextDoseStatus(healthCoverageId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getHealthCoverageDetailsOfOneAnimal(animalId: number): Promise<AnimalHealthCoverage[]>;
    checkDaysLeft(date: string): string;
    getExpiredOrNearlyExpiredData(farmerId: number, days: number): Promise<any>;
}
