"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalHealthCoverage = exports.YesNo = void 0;
const animal_entry_table_entity_1 = require("../../animal-table/entities/animal-entry-table.entity");
const health_coverage_table_entity_1 = require("../../health-coverage-table/entities/health-coverage-table.entity");
const housing_table_entity_1 = require("../../housing-table/entities/housing-table.entity");
const typeorm_1 = require("typeorm");
var YesNo;
(function (YesNo) {
    YesNo["YES"] = "YES";
    YesNo["NO"] = "NO";
})(YesNo = exports.YesNo || (exports.YesNo = {}));
let AnimalHealthCoverage = class AnimalHealthCoverage {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], AnimalHealthCoverage.prototype, "healthCoverageId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => housing_table_entity_1.HousingTable, dt => dt.AnimalHealthCoverage, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "housingId" }),
    __metadata("design:type", housing_table_entity_1.HousingTable)
], AnimalHealthCoverage.prototype, "HousingTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => health_coverage_table_entity_1.HealthCoverageTable, dt => dt.AnimalHealthCoverage, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "coverageId" }),
    __metadata("design:type", health_coverage_table_entity_1.HealthCoverageTable)
], AnimalHealthCoverage.prototype, "HealthCoverageTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => animal_entry_table_entity_1.AnimalEntryTable, dt => dt.AnimalHealthCoverage, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "animalId" }),
    __metadata("design:type", animal_entry_table_entity_1.AnimalEntryTable)
], AnimalHealthCoverage.prototype, "AnimalTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50 }),
    __metadata("design:type", String)
], AnimalHealthCoverage.prototype, "dateOfCoverage", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'text' }),
    __metadata("design:type", String)
], AnimalHealthCoverage.prototype, "details", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 0 }),
    __metadata("design:type", Number)
], AnimalHealthCoverage.prototype, "nextStatus", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], AnimalHealthCoverage.prototype, "isNextRequired", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], AnimalHealthCoverage.prototype, "nextDate", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalHealthCoverage.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalHealthCoverage.prototype, "updatedAt", void 0);
AnimalHealthCoverage = __decorate([
    (0, typeorm_1.Entity)()
], AnimalHealthCoverage);
exports.AnimalHealthCoverage = AnimalHealthCoverage;
