import { AnimalEntryTable } from './entities/animal-entry-table.entity';
import { AnimalEntryTableService } from './animal-entry-table.service';
import { CreateAnimalTableInput } from './dto/create-animal-table.input';
import { UpdateAnimalTableInput } from './dto/update-animal-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { CreateBoarTableInput } from './dto/create-boar-table.input';
export declare const ANIMAL_UPDATE = "ANIMAL_UPDATE";
export declare class AnimalEntryTableResolver {
    private readonly animalEntryTableService;
    private pubSub;
    constructor(animalEntryTableService: AnimalEntryTableService, pubSub: RedisPubSub);
    createAnimalEntryTable(createAnimalTableInput: CreateAnimalTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalEntryTable;
    }>;
    createBoarTable(createBoarTableInput: CreateBoarTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalEntryTable;
    }>;
    findAllAnimals(): Promise<AnimalEntryTable[]>;
    findOneAnimal(animalId: number): Promise<AnimalEntryTable[]>;
    findAllBoarDetached(): Promise<AnimalEntryTable[]>;
    findOneAnimalForReport(animalId: number): Promise<AnimalEntryTable>;
    findAnimalByHousingId(housingId: number): Promise<AnimalEntryTable[]>;
    findByAnimalForBreeding(housingId: number): Promise<AnimalEntryTable[]>;
    findByAnimalId(animalId: number): Promise<AnimalEntryTable>;
    findByStockId(stockId: number): Promise<AnimalEntryTable[]>;
    updateAnimalTable(updateAnimalTableInput: UpdateAnimalTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalEntryTable;
    }>;
    updateBoarSow(animalId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateCastratedStatus(animalId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    ageUpdate(): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllAnimalByDistAndDivAndFarmer(districtId: number, farmerId: number, subDivisionId: number): Promise<{
        data: any;
        summary: any[];
    }>;
    findIndividualFarmerReport(districtId: number, farmerId: number, subDivisionId: number): Promise<{
        data: AnimalEntryTable[];
        summary: any[];
    }>;
    Subscription(): AsyncIterator<unknown, any, undefined>;
}
