"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalEntryTableResolver = exports.ANIMAL_UPDATE = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const animal_entry_table_entity_1 = require("./entities/animal-entry-table.entity");
const animal_entry_table_service_1 = require("./animal-entry-table.service");
const create_animal_table_input_1 = require("./dto/create-animal-table.input");
const animal_entry_table_return_type_1 = require("./types/animal-entry-table-return.type");
const animal_entry_table_type_1 = require("./types/animal-entry-table.type");
const update_animal_table_input_1 = require("./dto/update-animal-table.input");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const animal_count_changed_type_1 = require("./types/animal-count-changed.type");
const animal_summary_table_type_1 = require("./types/animal-summary-table.type");
const IndividualFarmer_report_table_type_1 = require("./types/IndividualFarmer-report-table.type");
const create_boar_table_input_1 = require("./dto/create-boar-table.input");
exports.ANIMAL_UPDATE = "ANIMAL_UPDATE";
let AnimalEntryTableResolver = class AnimalEntryTableResolver {
    constructor(animalEntryTableService, pubSub) {
        this.animalEntryTableService = animalEntryTableService;
        this.pubSub = pubSub;
    }
    createAnimalEntryTable(createAnimalTableInput, user) {
        return this.animalEntryTableService.create(createAnimalTableInput, user);
    }
    createBoarTable(createBoarTableInput, user) {
        return this.animalEntryTableService.createBoar(createBoarTableInput, user);
    }
    findAllAnimals() {
        return this.animalEntryTableService.findAll();
    }
    findOneAnimal(animalId) {
        return this.animalEntryTableService.findOne(animalId);
    }
    findAllBoarDetached() {
        return this.animalEntryTableService.findAllBoarDetached();
    }
    findOneAnimalForReport(animalId) {
        return this.animalEntryTableService.findOneForReport(animalId);
    }
    findAnimalByHousingId(housingId) {
        return this.animalEntryTableService.findByHousingId(housingId);
    }
    findByAnimalForBreeding(housingId) {
        return this.animalEntryTableService.findByAnimalForBreeding(housingId);
    }
    findByAnimalId(animalId) {
        return this.animalEntryTableService.findByAnimalId(animalId);
    }
    findByStockId(stockId) {
        return this.animalEntryTableService.findByStockId(stockId);
    }
    updateAnimalTable(updateAnimalTableInput, user) {
        return this.animalEntryTableService.update(updateAnimalTableInput.animalId, updateAnimalTableInput, user);
    }
    updateBoarSow(animalId) {
        return this.animalEntryTableService.updateBoarSow(animalId);
    }
    updateCastratedStatus(animalId) {
        return this.animalEntryTableService.updateCastratedStatus(animalId);
    }
    ageUpdate() {
        return this.animalEntryTableService.ageUpdate();
    }
    findAllAnimalByDistAndDivAndFarmer(districtId, farmerId, subDivisionId) {
        return this.animalEntryTableService.findAllAnimalByDistAndDivAndFarmer(districtId, farmerId, subDivisionId);
    }
    findIndividualFarmerReport(districtId, farmerId, subDivisionId) {
        return this.animalEntryTableService.findIndividualFarmerReport(districtId, farmerId, subDivisionId);
    }
    Subscription() {
        return this.pubSub.asyncIterator(exports.ANIMAL_UPDATE);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createAnimalTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_animal_table_input_1.CreateAnimalTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "createAnimalEntryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createBoarTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_boar_table_input_1.CreateBoarTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "createBoarTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findAllAnimals", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findAllBoarDetached", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_entry_table_type_1.AnimalEntryTableType),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findOneAnimalForReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findAnimalByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findByAnimalForBreeding", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_entry_table_type_1.AnimalEntryTableType),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findByAnimalId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_entry_table_type_1.AnimalEntryTableType]),
    __param(0, (0, graphql_1.Args)('stockId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findByStockId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAnimalTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_animal_table_input_1.UpdateAnimalTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "updateAnimalTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "updateBoarSow", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "updateCastratedStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_entry_table_return_type_1.AnimalEntryTableReturnType),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "ageUpdate", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_summary_table_type_1.AnimalSummaryTableType),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => Number })),
    __param(1, (0, graphql_1.Args)('farmerId', { type: () => Number, nullable: true })),
    __param(2, (0, graphql_1.Args)('subDivisionId', { type: () => Number, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findAllAnimalByDistAndDivAndFarmer", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => IndividualFarmer_report_table_type_1.IndividualFarmerTableType),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => Number })),
    __param(1, (0, graphql_1.Args)('farmerId', { type: () => Number, nullable: true })),
    __param(2, (0, graphql_1.Args)('subDivisionId', { type: () => Number, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Number]),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "findIndividualFarmerReport", null);
__decorate([
    (0, graphql_1.Subscription)(() => animal_count_changed_type_1.AnimalCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalEntryTableResolver.prototype, "Subscription", null);
AnimalEntryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => animal_entry_table_entity_1.AnimalEntryTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [animal_entry_table_service_1.AnimalEntryTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], AnimalEntryTableResolver);
exports.AnimalEntryTableResolver = AnimalEntryTableResolver;
