"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalEntryTableService = exports.ANIMAL_UPDATE = exports.NEW_ANIMAL_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const typeorm_2 = require("typeorm");
const moment_1 = __importDefault(require("moment"));
const housing_table_service_1 = require("../housing-table/housing-table.service");
const farmers_table_service_1 = require("../farmers-table/farmers-table.service");
const breed_table_service_1 = require("../breed-table/breed-table.service");
const current_stock_table_service_1 = require("../current-stock/current-stock-table.service");
const animal_entry_table_entity_1 = require("./entities/animal-entry-table.entity");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const stock_balance_table_service_1 = require("../stock-balance/stock-balance-table.service");
const ledger_entry_table_service_1 = require("../ledger-table/ledger-entry-table.service");
const parent_table_service_1 = require("../parent-table/parent-table.service");
const housing_table_entity_1 = require("../housing-table/entities/housing-table.entity");
const farmers_table_entity_1 = require("../farmers-table/entities/farmers-table.entity");
const district_table_entity_1 = require("../district-table/entities/district-table.entity");
const sub_division_table_entity_1 = require("../sub-division-table/entities/sub-division-table.entity");
const breed_table_entity_1 = require("../breed-table/entities/breed-table.entity");
exports.NEW_ANIMAL_ADD = "NEW_ANIMAL_ADD";
exports.ANIMAL_UPDATE = "ANIMAL_UPDATE";
let AnimalEntryTableService = class AnimalEntryTableService {
    constructor(animalTableRepository, pubSub, userCollectionService, farmersTableService, housingTableService, breedTableService, stockBalanceTableService, currentStockTableService, ledgerEntryTableService, parentTableService) {
        this.animalTableRepository = animalTableRepository;
        this.pubSub = pubSub;
        this.userCollectionService = userCollectionService;
        this.farmersTableService = farmersTableService;
        this.housingTableService = housingTableService;
        this.breedTableService = breedTableService;
        this.stockBalanceTableService = stockBalanceTableService;
        this.currentStockTableService = currentStockTableService;
        this.ledgerEntryTableService = ledgerEntryTableService;
        this.parentTableService = parentTableService;
    }
    async create(createAnimalTableInput, user) {
        let ht = new animal_entry_table_entity_1.AnimalEntryTable();
        let userTable = await this.userCollectionService.getOneByUserId(user.userId);
        let housingTable = await this.housingTableService.findOne(createAnimalTableInput.housingId);
        let breedTable = await this.breedTableService.findOne(createAnimalTableInput.breedId);
        ht.UserTable = userTable;
        ht.HousingTable = housingTable;
        ht.BreedTable = breedTable;
        ht.dateOfEntry = createAnimalTableInput.dateOfEntry;
        ht.dateOfAgeUpdate = (0, moment_1.default)().format('YYYY-MM-DD');
        ht.age = createAnimalTableInput.age;
        ht.gender = createAnimalTableInput.gender;
        ht.earTag = createAnimalTableInput.earTag;
        ht.weight = createAnimalTableInput.weight;
        let result = await this.animalTableRepository.save(ht);
        this.pubSub.publish(exports.NEW_ANIMAL_ADD, 1);
        return {
            status: true,
            status_text: "Successfully Submitted",
            data: result
        };
    }
    async createBoar(createBoarTableInput, user) {
        let ht = new animal_entry_table_entity_1.AnimalEntryTable();
        let userTable = await this.userCollectionService.getOneByUserId(user.userId);
        let breedTable = await this.breedTableService.findOne(createBoarTableInput.breedId);
        ht.UserTable = userTable;
        ht.BreedTable = breedTable;
        ht.dateOfEntry = (0, moment_1.default)().format("DD-MM-YYYY");
        ht.dateOfAgeUpdate = (0, moment_1.default)().format('YYYY-MM-DD');
        ht.age = createBoarTableInput.age;
        ht.gender = "MALE";
        ht.earTag = createBoarTableInput.earTag;
        ht.weight = createBoarTableInput.weight;
        ht.isBoar = 1;
        ht.isSow = 0;
        let result = await this.animalTableRepository.save(ht);
        this.pubSub.publish(exports.NEW_ANIMAL_ADD, 1);
        return {
            status: true,
            status_text: "Successfully Submitted",
            data: result
        };
    }
    async multipleEntry(createAnimalTableInput, user, qtyMale, qtyFemale, qtyTotal, sowId, boarId, currentStockId) {
        let currentSock = await this.currentStockTableService.findOne(currentStockId);
        while (qtyMale > 0) {
            let ht = new animal_entry_table_entity_1.AnimalEntryTable();
            let userTable = await this.userCollectionService.getOneByUserId(user.userId);
            let housingTable = await this.housingTableService.findOne(createAnimalTableInput.housingId);
            let breedTable = await this.breedTableService.findOne(createAnimalTableInput.breedId);
            ht.UserTable = userTable;
            ht.HousingTable = housingTable;
            ht.BreedTable = breedTable;
            ht.CurrentStockTable = currentSock;
            ht.dateOfEntry = createAnimalTableInput.dateOfEntry;
            ht.dateOfAgeUpdate = createAnimalTableInput.dateOfEntry;
            ht.age = createAnimalTableInput.age;
            ht.gender = 'MALE';
            ht.earTag = createAnimalTableInput.earTag;
            ht.weight = createAnimalTableInput.weight;
            let rr = await this.animalTableRepository.save(ht);
            await this.parentTableService.create({
                animalId: rr.animalId,
                sowId: parseInt(createAnimalTableInput.sowId) || null,
                boarId: parseInt(createAnimalTableInput.boarId) || null
            }, user);
            qtyMale--;
        }
        while (qtyFemale > 0) {
            let ht = new animal_entry_table_entity_1.AnimalEntryTable();
            let userTable = await this.userCollectionService.getOneByUserId(user.userId);
            let housingTable = await this.housingTableService.findOne(createAnimalTableInput.housingId);
            let breedTable = await this.breedTableService.findOne(createAnimalTableInput.breedId);
            ht.UserTable = userTable;
            ht.HousingTable = housingTable;
            ht.BreedTable = breedTable;
            ht.CurrentStockTable = currentSock;
            ht.dateOfEntry = createAnimalTableInput.dateOfEntry;
            ht.dateOfAgeUpdate = createAnimalTableInput.dateOfEntry;
            ht.age = createAnimalTableInput.age;
            ht.gender = 'FEMALE';
            ht.earTag = createAnimalTableInput.earTag;
            ht.weight = createAnimalTableInput.weight;
            let rr = await this.animalTableRepository.save(ht);
            await this.parentTableService.create({
                animalId: rr.animalId,
                sowId: parseInt(createAnimalTableInput.sowId) || null,
                boarId: parseInt(createAnimalTableInput.boarId) || null
            }, user);
            qtyFemale--;
        }
        this.pubSub.publish(exports.NEW_ANIMAL_ADD, qtyTotal);
        return {
            status: true,
            status_text: "Successfully Submitted",
            data: null
        };
    }
    async findByHousingId(housingId) {
        return await this.animalTableRepository.find({
            where: {
                HousingTable: {
                    housingId
                },
                isActive: 1
            },
            relations: ["UserTable", "HousingTable.FarmersTable", "BreedTable"]
        });
    }
    async findByAnimalId(animalId) {
        return await this.animalTableRepository.findOne({
            where: {
                animalId
            },
            relations: ["UserTable", "HousingTable.FarmersTable", "BreedTable"]
        });
    }
    async findByStockId(stockId) {
        return await this.animalTableRepository.find({
            where: {
                CurrentStockTable: {
                    stockId
                }
            },
            relations: ["BreedTable"]
        });
    }
    async findByAnimalAge(age, limit) {
        return await this.animalTableRepository.find({
            where: {
                age,
                isActive: 1
            },
            take: limit
        });
    }
    async findByCurrentStock(currentStockId, limit) {
        return await this.animalTableRepository.find({
            where: {
                CurrentStockTable: {
                    stockId: currentStockId
                },
                isActive: 1
            },
            take: limit
        });
    }
    async findByAnimalForBreeding(housingId) {
        return await this.animalTableRepository.find({
            where: {
                earTag: (0, typeorm_2.Not)(''),
                HousingTable: {
                    housingId
                },
                isActive: 1
            },
            relations: ["UserTable", "HousingTable.FarmersTable", "BreedTable"]
        });
    }
    async findAll() {
        return await this.animalTableRepository.find({
            where: {
                isActive: 1
            },
            relations: ["UserTable", "HousingTable.FarmersTable", "BreedTable"]
        });
    }
    async findOne(animalId) {
        return await this.animalTableRepository.find({
            where: {
                animalId: animalId
            },
        });
    }
    async findAllBoarDetached() {
        return await this.animalTableRepository.createQueryBuilder("r").where("r.HousingTable IS NULL").getMany();
    }
    async findOneForReport(animalId) {
        return await this.animalTableRepository.findOne({
            where: {
                animalId: animalId
            },
            relations: ["BreedTable", "HousingTable", "HousingTable.FarmersTable", "HousingTable.FarmersTable.DistrictTable", "HousingTable.FarmersTable.SubDivisionTable"]
        });
    }
    async findAllAnimalByDistAndDivAndFarmer(districtId, subDivisionId, farmerId) {
        let result = await this.animalTableRepository.createQueryBuilder("r");
        result = await result.leftJoinAndMapOne("r.BreedTable", breed_table_entity_1.BreedTable, "ml11", "ml11.breedId = r.breedId");
        result = await result.leftJoinAndMapOne("r.HousingTable", housing_table_entity_1.HousingTable, "ml1", "ml1.housingId = r.housingId");
        result = await result.leftJoinAndMapOne("ml1.FarmersTable", farmers_table_entity_1.FarmersTable, "ml2", "ml2.farmerId = ml1.farmerId");
        result = await result.leftJoinAndMapOne("ml2.DistrictTable", district_table_entity_1.DistrictTable, "ml3", "ml2.districtId = ml3.districtId");
        result = await result.leftJoinAndMapOne("ml2.SubDivisionTable", sub_division_table_entity_1.SubDivisionTable, "ml4", "ml2.subDivisionId = ml4.subDivisionId");
        if (districtId != 0) {
            result = await result.where("ml3.districtId=:districtId", { districtId: districtId });
        }
        if (subDivisionId != 0) {
            result = await result.andWhere("ml4.subDivisionId=:subDivisionId", { subDivisionId: subDivisionId });
        }
        if (farmerId != 0) {
            result = await result.andWhere("ml2.farmerId=:farmerId", { farmerId: farmerId });
        }
        let res = await result.getMany();
        let summary = [];
        for (const el of res) {
            let breedName = el.BreedTable.breedName;
            let r = summary.find((el1) => el1.breedName === breedName);
            let rIndex = summary.findIndex((el1) => el1.breedName === breedName);
            if (r) {
                let prevMaleCount = parseFloat(r.maleCount);
                let prevFemaleCount = parseFloat(r.femaleCount);
                let prevTotalCount = parseFloat(r.totalCount);
                let maleCount = prevMaleCount;
                let femaleCount = prevFemaleCount;
                let totalCount = prevTotalCount;
                if (el.gender === "MALE") {
                    maleCount = maleCount + 1;
                }
                else if (el.gender === "FEMALE") {
                    femaleCount = femaleCount + 1;
                }
                totalCount = totalCount + 1;
                summary[rIndex]['maleCount'] = maleCount;
                summary[rIndex]['femaleCount'] = femaleCount;
                summary[rIndex]['totalCount'] = totalCount;
            }
            else {
                let maleCount = 0;
                let femaleCount = 0;
                let totalCount = 0;
                if (el.gender === "MALE") {
                    maleCount = 1;
                }
                else if (el.gender === "FEMALE") {
                    femaleCount = 1;
                }
                totalCount = 1;
                summary.push({
                    breedName: breedName,
                    maleCount: maleCount,
                    femaleCount: femaleCount,
                    totalCount: totalCount
                });
            }
        }
        return { data: res, summary };
    }
    async update(animalId, updateAnimalTableInput, user) {
        let result = await this.animalTableRepository.findOne({
            where: {
                animalId: animalId
            },
            relations: ["UserTable", "HousingTable.FarmersTable", "BreedTable"]
        });
        if (result) {
            let temp = {
                housingId: result.HousingTable.housingId,
                breedId: result.BreedTable.breedId,
                ageGroup: result.age,
                dateOfEntry: updateAnimalTableInput.dateOfEntry,
                qtyMale: result.gender == 'MALE' ? -1 : 0,
                qtyFemale: result.gender == 'FEMALE' ? -1 : 0,
                qtyTotal: -1,
                totalWeight: -result.weight,
            };
            await this.stockBalanceTableService.create(temp);
            await this.currentStockTableService.create(temp);
            temp = {
                housingId: updateAnimalTableInput.housingId,
                breedId: updateAnimalTableInput.breedId,
                ageGroup: updateAnimalTableInput.age,
                dateOfEntry: updateAnimalTableInput.dateOfEntry,
                qtyMale: updateAnimalTableInput.gender == 'MALE' ? 1 : 0,
                qtyFemale: updateAnimalTableInput.gender == 'FEMALE' ? 1 : 0,
                qtyTotal: 1,
                totalWeight: updateAnimalTableInput.weight,
            };
            await this.stockBalanceTableService.create(temp);
            await this.currentStockTableService.create(temp);
            let temp1 = {
                housingId: updateAnimalTableInput.housingId,
                breedId: updateAnimalTableInput.breedId,
                ageGroup: updateAnimalTableInput.age,
                dateOfEntry: updateAnimalTableInput.dateOfEntry,
                qtyMale: updateAnimalTableInput.gender == 'MALE' ? 1 : 0,
                qtyFemale: updateAnimalTableInput.gender == 'FEMALE' ? 1 : 0,
                qtyTotal: 1,
                avgWeight: updateAnimalTableInput.weight,
                entryType: "UPDATE_ANIMAL",
                referenceId: animalId
            };
            await this.ledgerEntryTableService.create(temp1, user);
            result.age = updateAnimalTableInput.age;
            result.weight = updateAnimalTableInput.weight;
            result.gender = updateAnimalTableInput.gender;
            result.earTag = updateAnimalTableInput.earTag;
            let r = await this.animalTableRepository.save(result);
            this.pubSub.publish(exports.ANIMAL_UPDATE, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async deceaseEntry(animalId, status) {
        let result = await this.animalTableRepository.findOne({
            where: {
                animalId: animalId
            }
        });
        if (result != null && result != undefined) {
            result.isActive = status;
            await this.animalTableRepository.save(result);
            return true;
        }
        else
            return false;
    }
    async ageUpdate() {
        let result = await this.animalTableRepository.find({
            where: {
                isActive: 1
            }
        });
        for (const el of result) {
            let current = (0, moment_1.default)((0, moment_1.default)().format('YYYY-MM-DD'));
            let prev = (0, moment_1.default)(el.dateOfAgeUpdate);
            let days = current.diff(prev, "days");
            let weeks = parseFloat(el.age) + parseFloat((days / 30).toFixed(2));
            el.age = weeks.toString();
            el.dateOfAgeUpdate = (0, moment_1.default)().format('YYYY-MM-DD');
            await this.animalTableRepository.save(el);
        }
        await this.currentStockTableService.ageUpdate();
        return {
            status: true,
            status_text: 'Successfully Updated'
        };
    }
    async updateBoarSow(animalId) {
        let result = await this.animalTableRepository.findOne({
            where: {
                animalId
            }
        });
        if (result) {
            if (result.gender == "MALE") {
                let bb = result.isBoar;
                if (bb == 1) {
                    result.isBoar = 0;
                }
                if (bb == 0) {
                    result.isBoar = 1;
                }
                result.isSow = 0;
                await this.animalTableRepository.save(result);
            }
            if (result.gender == "FEMALE") {
                let bb = result.isSow;
                result.isBoar = 0;
                if (bb == 1) {
                    result.isSow = 0;
                }
                if (bb == 0) {
                    result.isSow = 1;
                }
                await this.animalTableRepository.save(result);
            }
            return {
                status: true,
                status_text: 'Successfully Updated'
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found'
            };
        }
    }
    async updateCastratedStatus(animalId) {
        let result = await this.animalTableRepository.findOne({
            where: {
                animalId
            }
        });
        if (result) {
            if (result.gender == "MALE") {
                if (result.isBoar == 0 && result.isSow == 0) {
                    let oldStatus = result.isCastrated;
                    if (oldStatus == 0) {
                        result.isCastrated = 1;
                    }
                    if (oldStatus == 1) {
                        result.isCastrated = 0;
                    }
                    await this.animalTableRepository.save(result);
                    return {
                        status: true,
                        status_text: 'Successfully Updated'
                    };
                }
                else {
                    return {
                        status: false,
                        status_text: 'Unselect Boar or Sow status first'
                    };
                }
            }
            else {
                return {
                    status: false,
                    status_text: 'Only Males can be castrated'
                };
            }
        }
        else {
            return {
                status: false,
                status_text: 'Not found'
            };
        }
    }
    async findIndividualFarmerReport(districtId, subDivisionId, farmerId) {
        let result = await this.animalTableRepository.createQueryBuilder("r");
        result = await result.leftJoinAndMapOne("r.HousingTable", housing_table_entity_1.HousingTable, "ml1", "ml1.housingId=r.housingId");
        result = await result.leftJoinAndMapOne("ml1.FarmersTable", farmers_table_entity_1.FarmersTable, "ml2", "ml2.farmerId=ml1.farmerId");
        result = await result.leftJoinAndMapOne("ml2.DistrictTable", district_table_entity_1.DistrictTable, "ml3", "ml3.districtId=ml2.districtId");
        result = await result.leftJoinAndMapOne("ml2.SubDivisionTable", sub_division_table_entity_1.SubDivisionTable, "ml4", "ml4.subDivisionId=ml2.subDivisionId");
        if (districtId != 0) {
            result = await result.where("ml3.districtId=:districtId", { districtId: districtId });
        }
        if (subDivisionId != 0) {
            result = await result.andWhere("ml4.subDivisionId=:subDivisionId", { subDivisionId: subDivisionId });
        }
        if (farmerId != 0) {
            result = await result.andWhere("ml2.farmerId=:farmerId", { farmerId: farmerId });
        }
        let res = await result.getMany();
        console.log("🚀 ~ file: animal-entry-table.service.ts:590 ~ AnimalEntryTableService ~ findIndividualFarmerReport ~ res", res);
        let summary = [];
        for (const e of res) {
            let farmerName = e.HousingTable.FarmersTable.farmerName;
            let r = summary.find((el1) => el1.farmerName === farmerName);
            let rIndex = summary.findIndex((el1) => el1.farmerName === farmerName);
            if (r) {
                let prevMaleCount = parseFloat(r.maleCount);
                let prevFemaleCount = parseFloat(r.femaleCount);
                let prevTotalCount = parseFloat(r.totalCount);
                let { organized, backyard } = await this.housingTableService.countAllHousingArea(r.farmerId);
                let maleCount = prevMaleCount;
                let femaleCount = prevFemaleCount;
                let totalCount = prevTotalCount;
                if (e.gender === "MALE") {
                    maleCount = maleCount + 1;
                }
                else if (e.gender === "FEMALE") {
                    femaleCount = femaleCount + 1;
                }
                totalCount = totalCount + 1;
                summary[rIndex]['maleCount'] = maleCount;
                summary[rIndex]['femaleCount'] = femaleCount;
                summary[rIndex]['totalCount'] = totalCount;
                summary[rIndex]['organized'] = organized;
                summary[rIndex]['backyard'] = backyard;
            }
            else {
                let maleCount = 0;
                let femaleCount = 0;
                let totalCount = 0;
                let organized = 0;
                let backyard = 0;
                if (e.gender === "MALE") {
                    maleCount = 1;
                }
                else if (e.gender === "FEMALE") {
                    femaleCount = 1;
                }
                totalCount = 1;
                summary.push({
                    farmerName: farmerName,
                    maleCount: maleCount,
                    femaleCount: femaleCount,
                    totalCount: totalCount,
                    organized: organized,
                    backyard: backyard
                });
            }
        }
        console.log('data', res);
        console.log('summary', summary);
        return { data: res, summary };
    }
};
AnimalEntryTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(animal_entry_table_entity_1.AnimalEntryTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => farmers_table_service_1.FarmersTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => housing_table_service_1.HousingTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => breed_table_service_1.BreedTableService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => stock_balance_table_service_1.StockBalanceTableService))),
    __param(7, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_table_service_1.CurrentStockTableService))),
    __param(8, (0, common_1.Inject)((0, common_1.forwardRef)(() => ledger_entry_table_service_1.LedgerEntryTableService))),
    __param(9, (0, common_1.Inject)((0, common_1.forwardRef)(() => parent_table_service_1.ParentTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        user_collection_service_1.UserCollectionService,
        farmers_table_service_1.FarmersTableService,
        housing_table_service_1.HousingTableService,
        breed_table_service_1.BreedTableService,
        stock_balance_table_service_1.StockBalanceTableService,
        current_stock_table_service_1.CurrentStockTableService,
        ledger_entry_table_service_1.LedgerEntryTableService,
        parent_table_service_1.ParentTableService])
], AnimalEntryTableService);
exports.AnimalEntryTableService = AnimalEntryTableService;
