"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalEntryTable = void 0;
const animal_disease_sub_table_entity_1 = require("../../animal-disease-sub-table/entities/animal-disease-sub-table.entity");
const animal_health_coverage_entity_1 = require("../../animal-health-coverage/entities/animal-health-coverage.entity");
const animal_vaccination_table_entity_1 = require("../../animal-vaccination/entities/animal-vaccination-table.entity");
const breed_table_entity_1 = require("../../breed-table/entities/breed-table.entity");
const breeding_single_table_entity_1 = require("../../breeding-single-table/entities/breeding-single-table.entity");
const consumption_sub_table_entity_1 = require("../../consumption-sub-table/entities/consumption-sub-table.entity");
const current_stock_table_entity_1 = require("../../current-stock/entities/current-stock-table.entity");
const housing_table_entity_1 = require("../../housing-table/entities/housing-table.entity");
const parent_table_entity_1 = require("../../parent-table/entities/parent-table.entity");
const pig_insurance_table_entity_1 = require("../../pig-insurance-table/entities/pig-insurance-table.entity");
const sale_entry_sub_table_entity_1 = require("../../sale-entry-sub-table/entities/sale-entry-sub-table.entity");
const sale_ready_table_entity_1 = require("../../sale-ready-table/entities/sale-ready-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
let AnimalEntryTable = class AnimalEntryTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "animalId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => housing_table_entity_1.HousingTable, et => et.AnimalTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "housingId" }),
    __metadata("design:type", housing_table_entity_1.HousingTable)
], AnimalEntryTable.prototype, "HousingTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => breed_table_entity_1.BreedTable, et => et.AnimalTable),
    (0, typeorm_1.JoinColumn)({ name: "breedId" }),
    __metadata("design:type", breed_table_entity_1.BreedTable)
], AnimalEntryTable.prototype, "BreedTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => current_stock_table_entity_1.CurrentStockTable, et => et.AnimalTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "currentStockId" }),
    __metadata("design:type", current_stock_table_entity_1.CurrentStockTable)
], AnimalEntryTable.prototype, "CurrentStockTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String }),
    __metadata("design:type", String)
], AnimalEntryTable.prototype, "dateOfEntry", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String, nullable: true }),
    __metadata("design:type", String)
], AnimalEntryTable.prototype, "dateOfAgeUpdate", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String }),
    __metadata("design:type", String)
], AnimalEntryTable.prototype, "age", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String }),
    __metadata("design:type", String)
], AnimalEntryTable.prototype, "gender", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: null }),
    __metadata("design:type", String)
], AnimalEntryTable.prototype, "earTag", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 1 }),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "isActive", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 0 }),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "isBoar", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 0 }),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "isSow", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 0 }),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "isCastrated", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "decimal", precision: 10, scale: 3, default: 0.000 }),
    __metadata("design:type", Number)
], AnimalEntryTable.prototype, "weight", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, et => et.StockEntryTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], AnimalEntryTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => sale_entry_sub_table_entity_1.SaleEntrySubTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "SaleEntrySubTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => consumption_sub_table_entity_1.ConsumptionSubTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "ConsumptionSubTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_vaccination_table_entity_1.AnimalVaccinationTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "AnimalVaccinationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_disease_sub_table_entity_1.AnimalDiseaseSubTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "AnimalDiseaseSubTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => breeding_single_table_entity_1.BreedingSingleTable, et => et.SowTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "BreedingSowTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => breeding_single_table_entity_1.BreedingSingleTable, et => et.BoarTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "BreedingBoarTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => parent_table_entity_1.ParentTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "AnimalTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => parent_table_entity_1.ParentTable, et => et.BoarTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "BoarTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => parent_table_entity_1.ParentTable, et => et.SowTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "SowTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => pig_insurance_table_entity_1.PigInsuranceTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "PigInsuranceTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_health_coverage_entity_1.AnimalHealthCoverage, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "AnimalHealthCoverage", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => sale_ready_table_entity_1.SaleReadyTable, et => et.AnimalTable),
    __metadata("design:type", Array)
], AnimalEntryTable.prototype, "SaleReadyTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalEntryTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalEntryTable.prototype, "updatedAt", void 0);
AnimalEntryTable = __decorate([
    (0, typeorm_1.Entity)()
], AnimalEntryTable);
exports.AnimalEntryTable = AnimalEntryTable;
