"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalVaccinationTableModule = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const animal_entry_table_module_1 = require("../animal-table/animal-entry-table.module");
const disease_control_table_module_1 = require("../disease-control/disease-control-table.module");
const housing_table_module_1 = require("../housing-table/housing-table.module");
const vaccine_table_module_1 = require("../vaccine-table/vaccine-table.module");
const animal_vaccination_table_resolver_1 = require("./animal-vaccination-table.resolver");
const animal_vaccination_table_service_1 = require("./animal-vaccination-table.service");
const animal_vaccination_table_entity_1 = require("./entities/animal-vaccination-table.entity");
const data_entry_table_module_1 = require("../data-entry-table/data-entry-table.module");
let AnimalVaccinationTableModule = class AnimalVaccinationTableModule {
};
AnimalVaccinationTableModule = __decorate([
    (0, common_1.Module)({
        imports: [typeorm_1.TypeOrmModule.forFeature([animal_vaccination_table_entity_1.AnimalVaccinationTable]), (0, common_1.forwardRef)(() => animal_entry_table_module_1.AnimalEntryTableModule), (0, common_1.forwardRef)(() => disease_control_table_module_1.DiseaseControlTableModule), (0, common_1.forwardRef)(() => housing_table_module_1.HousingTableModule), (0, common_1.forwardRef)(() => vaccine_table_module_1.VaccineTableModule), data_entry_table_module_1.DataEntryTableModule],
        providers: [animal_vaccination_table_resolver_1.AnimalVaccinationTableResolver, animal_vaccination_table_service_1.AnimalVaccinationTableService],
        exports: [animal_vaccination_table_service_1.AnimalVaccinationTableService]
    })
], AnimalVaccinationTableModule);
exports.AnimalVaccinationTableModule = AnimalVaccinationTableModule;
