import { AnimalVaccinationTable } from './entities/animal-vaccination-table.entity';
import { AnimalVaccinationTableService } from './animal-vaccination-table.service';
import { CreateAnimalVaccinationTableInput } from './dto/create-animal-vaccination-table.input';
import { UpdateAnimalVaccinationTableInput } from './dto/update-animal-vaccination-table.input';
export declare class AnimalVaccinationTableResolver {
    private readonly animalVaccinationTableService;
    constructor(animalVaccinationTableService: AnimalVaccinationTableService);
    createAnimalVaccinationTable(createAnimalVaccinationTableInput: CreateAnimalVaccinationTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAllAnimalVaccination(): Promise<AnimalVaccinationTable[]>;
    findOneAnimalVaccination(vaccinationId: number): Promise<AnimalVaccinationTable>;
    updateAnimalVaccinationTable(updateAnimalVaccinationTableInput: UpdateAnimalVaccinationTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalVaccinationTable;
    }>;
    removeAnimalVaccinationTable(vaccinationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findVaccinationByFarmerId(farmerId: number): Promise<AnimalVaccinationTable[]>;
    findVaccinationByHousingd(housingId: number): Promise<AnimalVaccinationTable[]>;
    getVaccineDetailsOfOneAnimal(animalId: number): Promise<AnimalVaccinationTable[]>;
    toggleNextDoseStatusV(vaccinationId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
