"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalVaccinationTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const animal_vaccination_table_entity_1 = require("./entities/animal-vaccination-table.entity");
const animal_vaccination_table_service_1 = require("./animal-vaccination-table.service");
const animal_vaccination_table_type_1 = require("./types/animal-vaccination-table.type");
const create_animal_vaccination_table_input_1 = require("./dto/create-animal-vaccination-table.input");
const update_animal_vaccination_table_input_1 = require("./dto/update-animal-vaccination-table.input");
const animal_vaccination_table_return_type_1 = require("./types/animal-vaccination-table-return.type");
let AnimalVaccinationTableResolver = class AnimalVaccinationTableResolver {
    constructor(animalVaccinationTableService) {
        this.animalVaccinationTableService = animalVaccinationTableService;
    }
    createAnimalVaccinationTable(createAnimalVaccinationTableInput, user) {
        return this.animalVaccinationTableService.create(createAnimalVaccinationTableInput, user);
    }
    findAllAnimalVaccination() {
        return this.animalVaccinationTableService.findAll();
    }
    findOneAnimalVaccination(vaccinationId) {
        return this.animalVaccinationTableService.findOne(vaccinationId);
    }
    updateAnimalVaccinationTable(updateAnimalVaccinationTableInput, user) {
        return this.animalVaccinationTableService.update(updateAnimalVaccinationTableInput.vaccinationId, updateAnimalVaccinationTableInput, user);
    }
    removeAnimalVaccinationTable(vaccinationId) {
        return this.animalVaccinationTableService.remove(vaccinationId);
    }
    findVaccinationByFarmerId(farmerId) {
        return this.animalVaccinationTableService.findVaccinationByFarmerId(farmerId);
    }
    findVaccinationByHousingd(housingId) {
        return this.animalVaccinationTableService.findVaccinationByHousingId(housingId);
    }
    getVaccineDetailsOfOneAnimal(animalId) {
        return this.animalVaccinationTableService.getVaccineDetailsOfOneAnimal(animalId);
    }
    toggleNextDoseStatusV(vaccinationId, user) {
        return this.animalVaccinationTableService.toggleNextDoseStatus(vaccinationId, user);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_vaccination_table_return_type_1.AnimalVaccinationTableReturnType),
    __param(0, (0, graphql_1.Args)('createAnimalVaccinationTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_animal_vaccination_table_input_1.CreateAnimalVaccinationTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "createAnimalVaccinationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_vaccination_table_type_1.AnimalVaccinationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "findAllAnimalVaccination", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => animal_vaccination_table_type_1.AnimalVaccinationTableType),
    __param(0, (0, graphql_1.Args)('vaccinationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "findOneAnimalVaccination", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_vaccination_table_return_type_1.AnimalVaccinationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAnimalVaccinationTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_animal_vaccination_table_input_1.UpdateAnimalVaccinationTableInput, Object]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "updateAnimalVaccinationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_vaccination_table_return_type_1.AnimalVaccinationTableReturnType),
    __param(0, (0, graphql_1.Args)('vaccinationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "removeAnimalVaccinationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_vaccination_table_type_1.AnimalVaccinationTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "findVaccinationByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_vaccination_table_type_1.AnimalVaccinationTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "findVaccinationByHousingd", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [animal_vaccination_table_type_1.AnimalVaccinationTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "getVaccineDetailsOfOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => animal_vaccination_table_return_type_1.AnimalVaccinationTableReturnType),
    __param(0, (0, graphql_1.Args)('vaccinationId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], AnimalVaccinationTableResolver.prototype, "toggleNextDoseStatusV", null);
AnimalVaccinationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => animal_vaccination_table_entity_1.AnimalVaccinationTable),
    __metadata("design:paramtypes", [animal_vaccination_table_service_1.AnimalVaccinationTableService])
], AnimalVaccinationTableResolver);
exports.AnimalVaccinationTableResolver = AnimalVaccinationTableResolver;
