import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { DiseaseControlTableService } from 'src/disease-control/disease-control-table.service';
import { VaccineTableService } from 'src/vaccine-table/vaccine-table.service';
import { Repository } from 'typeorm';
import { CreateAnimalVaccinationTableInput } from './dto/create-animal-vaccination-table.input';
import { UpdateAnimalVaccinationTableInput } from './dto/update-animal-vaccination-table.input';
import { AnimalVaccinationTable } from './entities/animal-vaccination-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class AnimalVaccinationTableService {
    private readonly animalVaccinationTableRepository;
    private readonly dataEntryTableService;
    private readonly animalEntryTableService;
    private readonly vaccineTableService;
    private readonly diseaseControlTableService;
    constructor(animalVaccinationTableRepository: Repository<AnimalVaccinationTable>, dataEntryTableService: DataEntryTableService, animalEntryTableService: AnimalEntryTableService, vaccineTableService: VaccineTableService, diseaseControlTableService: DiseaseControlTableService);
    create(createAnimalVaccinationTableInput: CreateAnimalVaccinationTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    checkIfExists(animalId: number, dateOfVaccination: string): Promise<boolean>;
    findAll(): Promise<AnimalVaccinationTable[]>;
    findOne(vaccinationId: number): Promise<AnimalVaccinationTable>;
    findVaccinationByFarmerId(farmerId: number): Promise<AnimalVaccinationTable[]>;
    findVaccinationByHousingId(housingId: number): Promise<AnimalVaccinationTable[]>;
    update(vaccinationId: number, updateAnimalVaccinationTableInput: UpdateAnimalVaccinationTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AnimalVaccinationTable;
    }>;
    remove(vaccinationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getVaccineDetailsOfOneAnimal(animalId: number): Promise<AnimalVaccinationTable[]>;
    toggleNextDoseStatus(vaccinationId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkDaysLeft(date: string): string;
    getExpiredOrNearlyExpiredData(farmerId: number, days: number): Promise<any>;
}
