"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AnimalVaccinationTable = void 0;
const animal_entry_table_entity_1 = require("../../animal-table/entities/animal-entry-table.entity");
const disese_control_table_entity_1 = require("../../disease-control/entities/disese-control-table.entity");
const housing_table_entity_1 = require("../../housing-table/entities/housing-table.entity");
const vaccine_table_entity_1 = require("../../vaccine-table/entities/vaccine-table.entity");
const typeorm_1 = require("typeorm");
let AnimalVaccinationTable = class AnimalVaccinationTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], AnimalVaccinationTable.prototype, "vaccinationId", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50 }),
    __metadata("design:type", String)
], AnimalVaccinationTable.prototype, "dateOfVaccination", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'text' }),
    __metadata("design:type", String)
], AnimalVaccinationTable.prototype, "details", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], AnimalVaccinationTable.prototype, "nextDateOfVaccination", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, default: 0 }),
    __metadata("design:type", Number)
], AnimalVaccinationTable.prototype, "isNextDoseGiven", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => housing_table_entity_1.HousingTable, dt => dt.AnimalVaccinationTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "housingId" }),
    __metadata("design:type", housing_table_entity_1.HousingTable)
], AnimalVaccinationTable.prototype, "HousingTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => animal_entry_table_entity_1.AnimalEntryTable, dt => dt.AnimalVaccinationTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "animalId" }),
    __metadata("design:type", animal_entry_table_entity_1.AnimalEntryTable)
], AnimalVaccinationTable.prototype, "AnimalTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => vaccine_table_entity_1.VaccineTable, dt => dt.AnimalVaccinationTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "vaccineId" }),
    __metadata("design:type", vaccine_table_entity_1.VaccineTable)
], AnimalVaccinationTable.prototype, "VaccineTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => disese_control_table_entity_1.DiseaseControlTable, dt => dt.AnimalVaccinationTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "diseaseControlId" }),
    __metadata("design:type", disese_control_table_entity_1.DiseaseControlTable)
], AnimalVaccinationTable.prototype, "DiseaseControlTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalVaccinationTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], AnimalVaccinationTable.prototype, "updatedAt", void 0);
AnimalVaccinationTable = __decorate([
    (0, typeorm_1.Entity)()
], AnimalVaccinationTable);
exports.AnimalVaccinationTable = AnimalVaccinationTable;
