import { AppService } from './app.service';
import { AuthService } from './auth/auth.service';
import { LoginDto } from './user-collection/dto/login-dto';
import { ImportDataType } from './types/import-data-type.type';
import { ImportDataTypePg } from './types/import-data-type-pg.type';
import { ImportDataTypeUser } from './types/import-data-type-user.type';
import { ImportDataTypeMk } from './types/import-data-type-mk.type';
export declare class AppController {
    private readonly appService;
    private readonly authService;
    constructor(appService: AppService, authService: AuthService);
    login(loginDto: LoginDto): Promise<{
        status: boolean;
        token: string;
        user: {
            username: string;
            id: number;
            name: string;
            role: string;
            isIntegrator: boolean;
            isEd: boolean;
        };
    } | {
        status: boolean;
        token?: undefined;
        user?: undefined;
    }>;
    uploadBulkFileShg(data: ImportDataType[], req: any): void;
    uploadBulkFileUser(data: ImportDataTypeUser[], req: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    uploadBulkFilePg(data: ImportDataTypePg[], req: any): void;
    uploadBulkFileMk(data: ImportDataTypeMk[], req: any): void;
    getDashboardCounts(): Promise<{
        status: boolean;
        data: {};
    }>;
    getDashboardCountApp(req: any): Promise<{
        assignedState: number;
        assignedDistrict: number;
        assignedBlock: number;
        mkEntered: number;
        fblpPerformed: number;
    }>;
    getOfflineDataForEntry(req: any): Promise<{}>;
    getAssignedStatesAndAll(req: any): Promise<{}>;
    getInterventionOfflineDataForEntry(req: any): Promise<{}>;
    getFblpSingleReport(mkId: number): Promise<void>;
    getMkSingleReport(mkId: number): Promise<void>;
    getConvergenceReport(sessionId: number): Promise<void>;
    getConvergenceReportIntergrator(sessionId: number, body: any): Promise<void>;
    convergenceListDownload(body: any, res: any): Promise<void>;
    getInterventionReport(req: any): Promise<void>;
    getActivityParticipationList(req: any): Promise<void>;
    getActivityPlanningReport(req: any): Promise<void>;
    updatePaymentReceiptFile(file: any, req: any): Promise<string>;
}
