"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppController = void 0;
const common_1 = require("@nestjs/common");
const app_service_1 = require("./app.service");
const auth_service_1 = require("./auth/auth.service");
const login_dto_1 = require("./user-collection/dto/login-dto");
const roles_decorator_1 = require("./user-collection/decorators/roles.decorator");
const role_enum_1 = require("./user-collection/roles/role.enum");
const roles_guard_1 = require("./auth/guards/roles.guard");
const jwt_auth_guard_1 = require("./auth/guards/jwt-auth.guard");
const moment_1 = __importDefault(require("moment"));
const platform_express_1 = require("@nestjs/platform-express");
const GlobalConstants_1 = require("./helper/GlobalConstants");
const path_1 = require("path");
const fs_1 = require("fs");
const mutler_config_1 = require("./config/mutler-config");
let AppController = exports.AppController = class AppController {
    constructor(appService, authService) {
        this.appService = appService;
        this.authService = authService;
    }
    login(loginDto) {
        return this.authService.login(loginDto);
    }
    uploadBulkFileShg(data, req) {
    }
    uploadBulkFileUser(data, req) {
        return this.appService.updateBulkDataUser(data, req.user);
    }
    uploadBulkFilePg(data, req) {
    }
    uploadBulkFileMk(data, req) {
    }
    getDashboardCounts() {
        return this.appService.getDashboardCounts();
    }
    getDashboardCountApp(req) {
        var _a;
        console.log("🚀 ~ file: app.controller.ts:68 ~ AppController ~ getDashboardCountApp ~ req:", req.user);
        return this.appService.getDashboardCountForApplication((_a = req === null || req === void 0 ? void 0 : req.user) === null || _a === void 0 ? void 0 : _a.username);
    }
    getOfflineDataForEntry(req) {
        var _a, _b;
        return this.appService.getOfflineDataForEntry((_a = req === null || req === void 0 ? void 0 : req.user) === null || _a === void 0 ? void 0 : _a.username, (_b = req === null || req === void 0 ? void 0 : req.user) === null || _b === void 0 ? void 0 : _b.role);
    }
    getAssignedStatesAndAll(req) {
        var _a, _b;
        return this.appService.getAssignedStatesAndAll((_a = req === null || req === void 0 ? void 0 : req.user) === null || _a === void 0 ? void 0 : _a.username, (_b = req === null || req === void 0 ? void 0 : req.user) === null || _b === void 0 ? void 0 : _b.role);
    }
    getInterventionOfflineDataForEntry(req) {
        var _a, _b;
        return this.appService.getInterventionOfflineDataForEntry((_a = req === null || req === void 0 ? void 0 : req.user) === null || _a === void 0 ? void 0 : _a.username, (_b = req === null || req === void 0 ? void 0 : req.user) === null || _b === void 0 ? void 0 : _b.role);
    }
    async getFblpSingleReport(mkId) {
    }
    async getMkSingleReport(mkId) {
    }
    async getConvergenceReport(sessionId) {
    }
    async getConvergenceReportIntergrator(sessionId, body) {
    }
    async convergenceListDownload(body, res) {
        let schemeMasterSubId = body.schemeMasterSubId;
        let sessionId = body.sessionId;
        var fileName = `convergence-report-download-${(0, moment_1.default)().toISOString()}.xlsx`;
        res.setHeader('Content-Type', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        res.setHeader("Content-Disposition", "attachment; filename=" + fileName);
        var Excel = require('exceljs');
        var workbook = new Excel.Workbook();
        var worksheet = workbook.addWorksheet('MK Table');
        workbook.creator = 'Sesta MIS';
        workbook.lastModifiedBy = 'Sesta MIS';
        workbook.created = new Date();
        workbook.modified = new Date();
        worksheet.columns = [
            { header: 'MK ID', key: 'mkId', width: 10 },
            { header: 'Name', key: 'mkName', width: 32 },
            { header: 'State', key: 'stateName', width: 10 },
            { header: 'District', key: 'districtName', width: 10 },
            { header: 'Block', key: 'blockName', width: 10 },
            { header: 'Grampanchayat', key: 'gpName', width: 10 },
            { header: 'Village', key: 'villageName', width: 10 },
            { header: 'Scheme Name', key: 'schemeName', width: 30 },
            { header: 'Sub Scheme Name', key: 'subSchemeName', width: 30 },
            { header: 'Amount Sanctioned', key: 'amountSanctioned', width: 10 },
            { header: 'Amount Leveraged', key: 'amountLeveraged', width: 10 },
            { header: 'Date of Entry', key: 'date', width: 10 },
            { header: 'Status', key: 'status', width: 10 },
            { header: 'Entered By', key: 'userName', width: 10 },
            { header: 'Entered on', key: 'createdAtReadable', width: 10 },
        ];
        await workbook.xlsx.write(res);
        res.end();
    }
    async getInterventionReport(req) {
        let sessionId = req.query.hasOwnProperty('sessionId') ? req.query.sessionId : 0;
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        let type = req.query.hasOwnProperty('type') ? req.query.type : "block";
    }
    async getActivityParticipationList(req) {
        let sessionId = req.query.hasOwnProperty('sessionId') ? req.query.sessionId : 0;
        let page = req.query.hasOwnProperty('page') ? req.query.page : 1;
        let limit = req.query.hasOwnProperty('limit') ? req.query.limit : 100;
    }
    async getActivityPlanningReport(req) {
        let sessionId = req.query.hasOwnProperty('sessionId') ? req.query.sessionId : 0;
        let userId = req.query.hasOwnProperty('userId') ? req.query.userId : 1;
    }
    async updatePaymentReceiptFile(file, req) {
        let sFolder = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, 'ASSETS');
        if (!(0, fs_1.existsSync)(sFolder)) {
            (0, fs_1.mkdirSync)(sFolder, { recursive: true });
        }
        let up = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH);
        let prePath = '';
        if (file != undefined && file.filename != undefined) {
            (0, fs_1.renameSync)(`${up}/${file.filename}`, `${sFolder}/${file.filename}`);
            prePath = `/${GlobalConstants_1.UPLOAD_PATH}/ASSETS/${file.filename}`;
        }
        return prePath;
    }
};
__decorate([
    (0, common_1.Post)('login'),
    (0, common_1.UsePipes)(common_1.ValidationPipe),
    (0, common_1.Header)('Cache-Control', 'no-cache'),
    __param(0, (0, common_1.Body)('')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [login_dto_1.LoginDto]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "login", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('upload-bulk-file-shg'),
    __param(0, (0, common_1.Body)('data')),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array, Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "uploadBulkFileShg", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('upload-bulk-file-user'),
    __param(0, (0, common_1.Body)('data')),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array, Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "uploadBulkFileUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('upload-bulk-file-pg'),
    __param(0, (0, common_1.Body)('data')),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array, Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "uploadBulkFilePg", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('upload-bulk-file-mk'),
    __param(0, (0, common_1.Body)('data')),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array, Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "uploadBulkFileMk", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-dashboard-count'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AppController.prototype, "getDashboardCounts", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-dashboard-count-app'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "getDashboardCountApp", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-data-for-offline-use'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "getOfflineDataForEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-assigned-state-and-all'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "getAssignedStatesAndAll", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-intervention-data-for-offline-use'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], AppController.prototype, "getInterventionOfflineDataForEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-fblp-single-report/:mkId'),
    __param(0, (0, common_1.Param)('mkId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getFblpSingleReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-mk-single-report/:mkId'),
    __param(0, (0, common_1.Param)('mkId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getMkSingleReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-convergence-report/:sessionId'),
    __param(0, (0, common_1.Param)('sessionId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getConvergenceReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('get-convergence-report-integrator/:sessionId'),
    __param(0, (0, common_1.Param)('sessionId')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getConvergenceReportIntergrator", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('convergence-list-download'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "convergenceListDownload", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-intervention-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getInterventionReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-activity-participation-list'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getActivityParticipationList", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('get-activity-planning-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getActivityPlanningReport", null);
__decorate([
    (0, common_1.Post)('upload-file-to-server'),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('receiptFile', mutler_config_1.multerOptions)),
    __param(0, (0, common_1.UploadedFile)()),
    __param(1, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "updatePaymentReceiptFile", null);
exports.AppController = AppController = __decorate([
    (0, common_1.Controller)(),
    __metadata("design:paramtypes", [app_service_1.AppService,
        auth_service_1.AuthService])
], AppController);
