import { OnGatewayInit, OnGatewayConnection, OnGatewayDisconnect } from '@nestjs/websockets';
import { Socket, Server } from 'socket.io';
import { AuthService } from './auth/auth.service';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare class AppGateway implements OnGatewayInit, OnGatewayConnection, OnGatewayDisconnect {
    private readonly authService;
    private pubSub;
    constructor(authService: AuthService, pubSub: RedisPubSub);
    server: Server;
    private logger;
    afterInit(server: Server): void;
    getActiveInstancesCount(): Promise<{
        count: number;
    }>;
    handleDisconnect(client: Socket): void;
    handleConnection(client: Socket, data: any): Promise<void>;
    emitToClient(socket: string, type: string, data: any): void;
}
