"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const serve_static_1 = require("@nestjs/serve-static");
const auth_module_1 = require("./auth/auth.module");
const path_1 = require("path");
const app_gateway_1 = require("./app.gateway");
const graphql_1 = require("@nestjs/graphql");
const apollo_1 = require("@nestjs/apollo");
const user_collection_module_1 = require("./user-collection/user-collection.module");
const app_resolver_1 = require("./app.resolver");
const pubSub_module_1 = require("./pubSub.module");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const typeorm_1 = require("@nestjs/typeorm");
const user_collection_entity_1 = require("./user-collection/entities/user-collection.entity");
const notification_table_module_1 = require("./notification-table/notification-table.module");
const notification_table_entity_1 = require("./notification-table/entities/notification-table.entity");
const otp_table_entity_1 = require("./otp-table/otp-table.entity");
const access_table_module_1 = require("./access-table/access-table.module");
const access_table_entity_1 = require("./access-table/entities/access-table.entity");
const schedule_1 = require("@nestjs/schedule");
const config_1 = require("@nestjs/config");
const mail_module_1 = require("./mail/mail.module");
const nestjs_pdf_1 = require("@t00nday/nestjs-pdf");
const designation_table_module_1 = require("./designation-table/designation-table.module");
const designation_table_entity_1 = require("./designation-table/entities/designation-table.entity");
const course_table_module_1 = require("./course-table/course-table.module");
const course_table_entity_1 = require("./course-table/entities/course-table.entity");
const course_unit_table_module_1 = require("./course-unit-table/course-unit-table.module");
const course_unit_table_entity_1 = require("./course-unit-table/entities/course-unit-table.entity");
const file_table_entity_1 = require("./file-table/file-table.entity");
const file_table_module_1 = require("./file-table/file-table.module");
const assessment_master_table_module_1 = require("./assessment-master-table/assessment-master-table.module");
const assessment_questions_table_module_1 = require("./assessment-questions-table/assessment-questions-table.module");
const assessment_answer_table_module_1 = require("./assessment-answer-table/assessment-answer-table.module");
const assessment_master_table_entity_1 = require("./assessment-master-table/entities/assessment-master-table.entity");
const assessment_questions_table_entity_1 = require("./assessment-questions-table/entities/assessment-questions-table.entity");
const assessment_answer_table_entity_1 = require("./assessment-answer-table/entities/assessment-answer-table.entity");
const subscription_table_entity_1 = require("./subscription-table/entities/subscription-table.entity");
const subscription_table_module_1 = require("./subscription-table/subscription-table.module");
const organisation_table_module_1 = require("./organisation-table/organisation-table.module");
const organisation_table_entity_1 = require("./organisation-table/entities/organisation-table.entity");
const course_progression_table_module_1 = require("./course-progression-table/course-progression-table.module");
const course_progression_table_entity_1 = require("./course-progression-table/entities/course-progression-table.entity");
const discussion_table_module_1 = require("./discussion-table/discussion-table.module");
const discussion_table_entity_1 = require("./discussion-table/entities/discussion-table.entity");
const course_session_table_module_1 = require("./course-session-table/course-session-table.module");
const course_session_table_entity_1 = require("./course-session-table/entities/course-session-table.entity");
let AppModule = exports.AppModule = class AppModule {
};
exports.AppModule = AppModule = __decorate([
    (0, common_1.Module)({
        imports: [
            config_1.ConfigModule.forRoot(),
            typeorm_1.TypeOrmModule.forRoot({
                "type": "mysql",
                "host": "localhost",
                "port": 3306,
                "username": process.env.DB_USERNAME,
                "password": process.env.DB_PASSWORD,
                "database": process.env.DB_NAME,
                "entities": [
                    user_collection_entity_1.UserTable,
                    notification_table_entity_1.NotificationTable,
                    otp_table_entity_1.OtpTable,
                    access_table_entity_1.AccessTable,
                    designation_table_entity_1.DesignationTable,
                    course_table_entity_1.CourseTable,
                    course_unit_table_entity_1.CourseUnitTable,
                    file_table_entity_1.FileTable,
                    assessment_master_table_entity_1.AssessmentMasterTable,
                    assessment_questions_table_entity_1.AssessmentQuestionsTable,
                    assessment_answer_table_entity_1.AssessmentAnswerTable,
                    subscription_table_entity_1.SubscriptionTable,
                    organisation_table_entity_1.OrganisationTable,
                    course_progression_table_entity_1.CourseProgressionTable,
                    discussion_table_entity_1.DiscussionTable,
                    course_session_table_entity_1.CourseSessionTable
                ],
                "synchronize": true
            }),
            graphql_1.GraphQLModule.forRoot({
                autoSchemaFile: 'schema.gql',
                driver: apollo_1.ApolloDriver,
                sortSchema: true,
                playground: true,
                installSubscriptionHandlers: true,
                context: ({ req, connection }) => connection ? { req: connection.context } : { req },
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'uploads'),
                exclude: ['/api*'],
                serveRoot: "/uploads",
                serveStaticOptions: {
                    setHeaders: (res, path, stat) => {
                        res.set('Cross-Origin-Resource-Policy', 'cross-origin');
                    }
                }
            }),
            serve_static_1.ServeStaticModule.forRoot({
                rootPath: (0, path_1.join)(__dirname, '..', 'client'),
                exclude: ['/api*', "/uploads*"],
            }),
            nestjs_pdf_1.PDFModule.register({
                isGlobal: true,
                view: {
                    root: (0, path_1.join)(__dirname, 'templates', 'reports'),
                    engine: 'handlebars',
                },
            }),
            schedule_1.ScheduleModule.forRoot(),
            user_collection_module_1.UserCollectionModule,
            auth_module_1.AuthModule,
            pubSub_module_1.PubSubModule,
            notification_table_module_1.NotificationTableModule,
            access_table_module_1.AccessTableModule,
            mail_module_1.MailModule,
            designation_table_module_1.DesignationTableModule,
            course_table_module_1.CourseTableModule,
            course_unit_table_module_1.CourseUnitTableModule,
            file_table_module_1.FileTableModule,
            assessment_master_table_module_1.AssessmentMasterTableModule,
            assessment_questions_table_module_1.AssessmentQuestionsTableModule,
            assessment_answer_table_module_1.AssessmentAnswerTableModule,
            subscription_table_module_1.SubscriptionTableModule,
            organisation_table_module_1.OrganisationTableModule,
            course_progression_table_module_1.CourseProgressionTableModule,
            discussion_table_module_1.DiscussionTableModule,
            course_session_table_module_1.CourseSessionTableModule,
        ],
        controllers: [app_controller_1.AppController],
        providers: [app_resolver_1.AppResolver, app_gateway_1.AppGateway, app_service_1.AppService],
        exports: [app_gateway_1.AppGateway]
    })
], AppModule);
