import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AppGateway } from './app.gateway';
import { AuthService } from './auth/auth.service';
import { AppService } from './app.service';
export declare class AppResolver {
    private readonly authService;
    private readonly appGateway;
    private readonly appService;
    private pubSub;
    constructor(authService: AuthService, appGateway: AppGateway, appService: AppService, pubSub: RedisPubSub);
    login(username: string, password: string): Promise<{
        status: boolean;
        token: string;
        user: {
            username: string;
            id: number;
            name: string;
            role: string;
            isIntegrator: boolean;
            isEd: boolean;
        };
    } | {
        status: boolean;
        token?: undefined;
        user?: undefined;
    }>;
    socketCount(): Promise<{
        count: number;
    }>;
    socketCountSub(): AsyncIterator<unknown, any, undefined>;
    getCountOfMkRelatedDataForGraph(year?: string): Promise<any>;
}
