import { AccessTableService } from './access-table/access-table.service';
import { PDFService } from '@t00nday/nestjs-pdf';
import { UserCollectionService } from './user-collection/user-collection.service';
import { ImportDataTypeUser } from './types/import-data-type-user.type';
export declare class AppService {
    private readonly accessTableService;
    private readonly userCollectionService;
    private readonly pdfService;
    constructor(accessTableService: AccessTableService, userCollectionService: UserCollectionService, pdfService: PDFService);
    updateBulkDataUser(data: ImportDataTypeUser[], user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getDashboardCounts(): Promise<{
        status: boolean;
        data: {};
    }>;
    getDashboardCountForApplication(username: string): Promise<{
        assignedState: number;
        assignedDistrict: number;
        assignedBlock: number;
        mkEntered: number;
        fblpPerformed: number;
    }>;
    getCountOfMkRelatedDataForGraph(year?: string): Promise<any>;
    getOfflineDataForEntry(username: string, role: string): Promise<{}>;
    getAssignedStatesAndAll(username: string, role: string): Promise<{}>;
    getInterventionOfflineDataForEntry(username: string, role: string): Promise<{}>;
}
