"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppService = void 0;
const common_1 = require("@nestjs/common");
const access_table_service_1 = require("./access-table/access-table.service");
const moment_1 = __importDefault(require("moment"));
const nestjs_pdf_1 = require("@t00nday/nestjs-pdf");
const user_collection_service_1 = require("./user-collection/user-collection.service");
let AppService = exports.AppService = class AppService {
    constructor(accessTableService, userCollectionService, pdfService) {
        this.accessTableService = accessTableService;
        this.userCollectionService = userCollectionService;
        this.pdfService = pdfService;
    }
    async updateBulkDataUser(data, user) {
        let result = [];
        for (const el of data) {
            let user = await this.userCollectionService.create({
                name: el.name,
                email: el.email,
                username: el.username,
                phone: el.phone,
                organisationId: el.organisationId,
                designationId: el.designationId,
                role: el.role,
                password: el.password.toString(),
                isActive: true
            });
            result.push(`${el.name} successfully inserted`);
        }
        return {
            status: true,
            status_text: "Data Uploaded Successfully",
            data: result
        };
    }
    async getDashboardCounts() {
        return {
            status: true,
            data: {}
        };
    }
    async getDashboardCountForApplication(username) {
        let assignedState = [];
        let assignedDistrict = [];
        let assignedBlock = [];
        let mkEntered = 0;
        let fblpPerformed = 0;
        let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);
        for (const el of accessData) {
            if (el.accessLevel == "STATE") {
            }
        }
        return {
            assignedState: assignedState.length,
            assignedDistrict: assignedDistrict.length,
            assignedBlock: assignedBlock.length,
            mkEntered,
            fblpPerformed
        };
    }
    async getCountOfMkRelatedDataForGraph(year) {
        let yearToBeTaken = year;
        if (!year) {
            yearToBeTaken = (0, moment_1.default)().format("YYYY");
        }
        const startOfYear = (0, moment_1.default)(yearToBeTaken, "YYYY").startOf('year').format('YYYY-MM-DD');
        const endOfYear = (0, moment_1.default)(yearToBeTaken, "YYYY").endOf('year').format('YYYY-MM-DD');
        let monthObject = {
            Jan: 0,
            Feb: 0,
            Mar: 0,
            Apr: 0,
            May: 0,
            Jun: 0,
            Jul: 0,
            Aug: 0,
            Sep: 0,
            Oct: 0,
            Nov: 0,
            Dec: 0,
        };
        let result = [];
        for (var key in monthObject) {
            let month = (0, moment_1.default)(`${key}-${yearToBeTaken}`, 'MMM-YYYY').format('YYYY-MM');
            result.push({
                month: key,
            });
        }
        return result;
    }
    async getOfflineDataForEntry(username, role) {
        let assignedState = [];
        let assignedDistrict = [];
        let assignedBlock = [];
        if (role == "USER") {
            let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);
            return {};
        }
        else {
            return {};
        }
    }
    async getAssignedStatesAndAll(username, role) {
        let assignedState = [];
        let assignedDistrict = [];
        let assignedBlock = [];
        if (role == "USER") {
            let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);
            return {};
        }
        else {
            return {};
        }
    }
    async getInterventionOfflineDataForEntry(username, role) {
        return {};
    }
};
exports.AppService = AppService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [access_table_service_1.AccessTableService,
        user_collection_service_1.UserCollectionService,
        nestjs_pdf_1.PDFService])
], AppService);
