import { CreateAssessmentAnswerTableInput } from './dto/create-assessment-answer-table.input';
import { AssessmentAnswerTable } from './entities/assessment-answer-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AssessmentMasterTableService } from 'src/assessment-master-table/assessment-master-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { AssessmentQuestionsTableService } from 'src/assessment-questions-table/assessment-questions-table.service';
import { CourseProgressionTableService } from 'src/course-progression-table/course-progression-table.service';
export declare const NEW_ANSWER_ADD = "NEW_ANSWER_ADD";
export declare class AssessmentAnswerTableService {
    private readonly assessmentAnswersTableRepository;
    private pubSub;
    private readonly assessmentMasterTableService;
    private readonly userCollectionService;
    private readonly assessmentQuestionsTableService;
    private readonly courseProgressionTableService;
    constructor(assessmentAnswersTableRepository: Repository<AssessmentAnswerTable>, pubSub: RedisPubSub, assessmentMasterTableService: AssessmentMasterTableService, userCollectionService: UserCollectionService, assessmentQuestionsTableService: AssessmentQuestionsTableService, courseProgressionTableService: CourseProgressionTableService);
    create(createAssessmentAnswerTableInput: CreateAssessmentAnswerTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentAnswerTable;
    }>;
    convertedArray(array: any[]): {}[];
    recalculateScore(answerId: number): Promise<false | AssessmentAnswerTable>;
    checkIfExists(createAssessmentAnswerTableInput: CreateAssessmentAnswerTableInput, user: any): Promise<number>;
    findAll(): Promise<AssessmentAnswerTable[]>;
    findOne(answerId: number): Promise<AssessmentAnswerTable>;
    findMyLatestCourse(assessmentId: number, userId: number): Promise<string>;
    findAllByCourseIdAndUserId(courseId: number, userId: number): Promise<AssessmentAnswerTable[]>;
    getListOfAnswersByUser(limit: number, page: number, type: string, search: string, user: any): Promise<{
        data: any;
        total: any;
    }>;
    remove(answerId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
