import { AssessmentInterpretationTableService } from './assessment-interpretation-table.service';
import { AssessmentInterpretationTable } from './entities/assessment-interpretation-table.entity';
import { CreateAssessmentInterpretationTableInput } from './dto/create-assessment-interpretation-table.input';
import { UpdateAssessmentInterpretationTableInput } from './dto/update-assessment-interpretation-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
export declare class AssessmentInterpretationTableResolver {
    private readonly assessmentInterpretationTableService;
    private pubSub;
    constructor(assessmentInterpretationTableService: AssessmentInterpretationTableService, pubSub: RedisPubSub);
    createAssessmentInterpretationTable(createAssessmentInterpretationTableInput: CreateAssessmentInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentInterpretationTable;
    }>;
    findAllAssessmentInterpretations(): Promise<AssessmentInterpretationTable[]>;
    findOneAssessmentInterpretation(interpretationId: number): Promise<AssessmentInterpretationTable>;
    updateAssessmentInterpretationTable(updateAssessmentInterpretationTableInput: UpdateAssessmentInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentInterpretationTable;
    }>;
    removeAssessmentInterpretationTable(interpretationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
