"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssessmentInterpretationTableResolver = exports.NEW_INTERPRETATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const assessment_interpretation_table_service_1 = require("./assessment-interpretation-table.service");
const assessment_interpretation_table_entity_1 = require("./entities/assessment-interpretation-table.entity");
const create_assessment_interpretation_table_input_1 = require("./dto/create-assessment-interpretation-table.input");
const update_assessment_interpretation_table_input_1 = require("./dto/update-assessment-interpretation-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const assessment_interpretation_table_return_type_1 = require("./types/assessment-interpretation-table-return.type");
const assessment_interpretation_table_type_1 = require("./types/assessment-interpretation-table.type");
exports.NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
let AssessmentInterpretationTableResolver = exports.AssessmentInterpretationTableResolver = class AssessmentInterpretationTableResolver {
    constructor(assessmentInterpretationTableService, pubSub) {
        this.assessmentInterpretationTableService = assessmentInterpretationTableService;
        this.pubSub = pubSub;
    }
    createAssessmentInterpretationTable(createAssessmentInterpretationTableInput) {
        return this.assessmentInterpretationTableService.create(createAssessmentInterpretationTableInput);
    }
    findAllAssessmentInterpretations() {
        return this.assessmentInterpretationTableService.findAll();
    }
    findOneAssessmentInterpretation(interpretationId) {
        return this.assessmentInterpretationTableService.findOne(interpretationId);
    }
    updateAssessmentInterpretationTable(updateAssessmentInterpretationTableInput) {
        return this.assessmentInterpretationTableService.update(updateAssessmentInterpretationTableInput.interpretationId, updateAssessmentInterpretationTableInput);
    }
    removeAssessmentInterpretationTable(interpretationId) {
        return this.assessmentInterpretationTableService.remove(interpretationId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_interpretation_table_return_type_1.AssessmentInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('createAssessmentInterpretationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_assessment_interpretation_table_input_1.CreateAssessmentInterpretationTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentInterpretationTableResolver.prototype, "createAssessmentInterpretationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_interpretation_table_type_1.AssessmentInterpretationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AssessmentInterpretationTableResolver.prototype, "findAllAssessmentInterpretations", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => assessment_interpretation_table_type_1.AssessmentInterpretationTableType),
    __param(0, (0, graphql_1.Args)('interpretationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentInterpretationTableResolver.prototype, "findOneAssessmentInterpretation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_interpretation_table_return_type_1.AssessmentInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAssessmentInterpretationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_assessment_interpretation_table_input_1.UpdateAssessmentInterpretationTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentInterpretationTableResolver.prototype, "updateAssessmentInterpretationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_interpretation_table_return_type_1.AssessmentInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('interpretationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentInterpretationTableResolver.prototype, "removeAssessmentInterpretationTable", null);
exports.AssessmentInterpretationTableResolver = AssessmentInterpretationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => assessment_interpretation_table_entity_1.AssessmentInterpretationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [assessment_interpretation_table_service_1.AssessmentInterpretationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], AssessmentInterpretationTableResolver);
