import { CreateAssessmentInterpretationTableInput } from './dto/create-assessment-interpretation-table.input';
import { UpdateAssessmentInterpretationTableInput } from './dto/update-assessment-interpretation-table.input';
import { AssessmentInterpretationTable } from './entities/assessment-interpretation-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AssessmentMasterTableService } from 'src/assessment-master-table/assessment-master-table.service';
export declare const NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
export declare class AssessmentInterpretationTableService {
    private readonly assessmentInterpretationTableRepository;
    private pubSub;
    private readonly assessmentMasterTableService;
    constructor(assessmentInterpretationTableRepository: Repository<AssessmentInterpretationTable>, pubSub: RedisPubSub, assessmentMasterTableService: AssessmentMasterTableService);
    create(createAssessmentInterpretationTableInput: CreateAssessmentInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentInterpretationTable;
    }>;
    checkIfExists(interpretation: string, type: string, classification: string, maxScore: string, minScore: string): Promise<boolean>;
    findAll(): Promise<AssessmentInterpretationTable[]>;
    findInterpretationByScore(assessmentId: number, score: string): Promise<false | AssessmentInterpretationTable>;
    findOne(interpretationId: number): Promise<AssessmentInterpretationTable>;
    update(interpretationId: number, updateAssessmentInterpretationTableInput: UpdateAssessmentInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentInterpretationTable;
    }>;
    remove(interpretationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
