import { AssessmentMasterTableService } from './assessment-master-table.service';
import { AssessmentMasterTable } from './entities/assessment-master-table.entity';
import { CreateAssessmentMasterTableInput } from './dto/create-assessment-master-table.input';
import { UpdateAssessmentMasterTableInput } from './dto/update-assessment-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ASSESSMENT_ADD = "NEW_ASSESSMENT_ADD";
export declare class AssessmentMasterTableResolver {
    private readonly assessmentMasterTableService;
    private pubSub;
    constructor(assessmentMasterTableService: AssessmentMasterTableService, pubSub: RedisPubSub);
    createAssessmentMasterTable(createAssessmentMasterTableInput: CreateAssessmentMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    findAllAssessments(): Promise<AssessmentMasterTable[]>;
    findOneAssessment(assessmentId: number): Promise<AssessmentMasterTable>;
    findOneAssessmentByCourseUnitId(courseId: number): Promise<AssessmentMasterTable[]>;
    findOneAssessmentByCourseUnitIdActive(courseId: number, user: any): Promise<AssessmentMasterTable[]>;
    updateAssessmentMasterTable(updateAssessmentMasterTableInput: UpdateAssessmentMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    toggleActiveStatusAssesment(assessmentId: number): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    removeAssessmentMasterTable(assessmentId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    assessmentSubscription(): AsyncIterator<unknown, any, undefined>;
}
