"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssessmentMasterTableResolver = exports.NEW_ASSESSMENT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const assessment_master_table_service_1 = require("./assessment-master-table.service");
const assessment_master_table_entity_1 = require("./entities/assessment-master-table.entity");
const create_assessment_master_table_input_1 = require("./dto/create-assessment-master-table.input");
const update_assessment_master_table_input_1 = require("./dto/update-assessment-master-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const assessment_master_table_return_type_1 = require("./types/assessment-master-table-return.type");
const assessment_master_table_type_1 = require("./types/assessment-master-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
exports.NEW_ASSESSMENT_ADD = "NEW_ASSESSMENT_ADD";
let AssessmentMasterTableResolver = exports.AssessmentMasterTableResolver = class AssessmentMasterTableResolver {
    constructor(assessmentMasterTableService, pubSub) {
        this.assessmentMasterTableService = assessmentMasterTableService;
        this.pubSub = pubSub;
    }
    createAssessmentMasterTable(createAssessmentMasterTableInput) {
        return this.assessmentMasterTableService.create(createAssessmentMasterTableInput);
    }
    findAllAssessments() {
        return this.assessmentMasterTableService.findAll();
    }
    findOneAssessment(assessmentId) {
        return this.assessmentMasterTableService.findOne(assessmentId);
    }
    findOneAssessmentByCourseUnitId(courseId) {
        return this.assessmentMasterTableService.findOneAssessmentByCourseUnitId(courseId);
    }
    findOneAssessmentByCourseUnitIdActive(courseId, user) {
        return this.assessmentMasterTableService.findOneAssessmentByCourseUnitIdActive(courseId, user);
    }
    updateAssessmentMasterTable(updateAssessmentMasterTableInput) {
        return this.assessmentMasterTableService.update(updateAssessmentMasterTableInput.assessmentId, updateAssessmentMasterTableInput);
    }
    toggleActiveStatusAssesment(assessmentId) {
        return this.assessmentMasterTableService.toggleActiveStatus(assessmentId);
    }
    removeAssessmentMasterTable(assessmentId) {
        return this.assessmentMasterTableService.remove(assessmentId);
    }
    assessmentSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_ASSESSMENT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_master_table_return_type_1.AssessmentMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('createAssessmentMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_assessment_master_table_input_1.CreateAssessmentMasterTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "createAssessmentMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_master_table_type_1.AssessmentMasterTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "findAllAssessments", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => assessment_master_table_type_1.AssessmentMasterTableType),
    __param(0, (0, graphql_1.Args)('assessmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "findOneAssessment", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_master_table_type_1.AssessmentMasterTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "findOneAssessmentByCourseUnitId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_master_table_type_1.AssessmentMasterTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "findOneAssessmentByCourseUnitIdActive", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_master_table_return_type_1.AssessmentMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAssessmentMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_assessment_master_table_input_1.UpdateAssessmentMasterTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "updateAssessmentMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_master_table_return_type_1.AssessmentMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('assessmentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "toggleActiveStatusAssesment", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_master_table_return_type_1.AssessmentMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('assessmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "removeAssessmentMasterTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AssessmentMasterTableResolver.prototype, "assessmentSubscription", null);
exports.AssessmentMasterTableResolver = AssessmentMasterTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => assessment_master_table_entity_1.AssessmentMasterTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [assessment_master_table_service_1.AssessmentMasterTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], AssessmentMasterTableResolver);
