import { CreateAssessmentMasterTableInput } from './dto/create-assessment-master-table.input';
import { UpdateAssessmentMasterTableInput } from './dto/update-assessment-master-table.input';
import { AssessmentMasterTable } from './entities/assessment-master-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { CourseTableService } from 'src/course-table/course-table.service';
import { CourseProgressionTableService } from 'src/course-progression-table/course-progression-table.service';
import { AssessmentAnswerTableService } from 'src/assessment-answer-table/assessment-answer-table.service';
export declare const NEW_ASSESSMENT_ADD = "NEW_ASSESSMENT_ADD";
export declare class AssessmentMasterTableService {
    private readonly assessmentMasterTableRepository;
    private pubSub;
    private readonly courseTableService;
    private readonly assessmentAnswerTableService;
    private readonly courseProgressionTableService;
    constructor(assessmentMasterTableRepository: Repository<AssessmentMasterTable>, pubSub: RedisPubSub, courseTableService: CourseTableService, assessmentAnswerTableService: AssessmentAnswerTableService, courseProgressionTableService: CourseProgressionTableService);
    create(createAssessmentMasterTableInput: CreateAssessmentMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    checkIfExists(createAssessmentMasterTableInput: CreateAssessmentMasterTableInput): Promise<boolean>;
    findAll(): Promise<AssessmentMasterTable[]>;
    findOne(assessmentId: number): Promise<AssessmentMasterTable>;
    findOneAssessmentByCourseUnitId(courseId: number): Promise<AssessmentMasterTable[]>;
    findOneAssessmentByCourseUnitIdActive(courseId: number, user: any): Promise<AssessmentMasterTable[]>;
    update(assessmentId: number, updateAssessmentMasterTableInput: UpdateAssessmentMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    toggleActiveStatus(assessmentId: number): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentMasterTable;
    }>;
    remove(assessmentId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
