import { AssessmentQuestionsTableService } from './assessment-questions-table.service';
import { AssessmentQuestionsTable } from './entities/assessment-questions-table.entity';
import { CreateAssessmentQuestionsTableInput } from './dto/create-assessment-questions-table.input';
import { UpdateAssessmentQuestionsTableInput } from './dto/update-assessment-questions-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
export declare class AssessmentQuestionsTableResolver {
    private readonly assessmentQuestionsTableService;
    private pubSub;
    constructor(assessmentQuestionsTableService: AssessmentQuestionsTableService, pubSub: RedisPubSub);
    createAssessmentQuestionsTable(createAssessmentQuestionsTableInput: CreateAssessmentQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentQuestionsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllAssessmentQuestions(): Promise<AssessmentQuestionsTable[]>;
    findOne(assessmentQuestionId: number): Promise<AssessmentQuestionsTable>;
    findOneByAssessmentMasterId(assessmentId: number): Promise<AssessmentQuestionsTable[]>;
    findOneAssessmentByType(type: string): Promise<{
        data: any;
        length: number;
        assessmentId: number;
    }>;
    findOneAssessmentByIdForApp(assessmentId: number): Promise<{
        data: any;
        length: number;
        assessmentId: number;
        duration: number;
    }>;
    updateAssessmentQuestionsTable(updateAssessmentQuestionsTableInput: UpdateAssessmentQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentQuestionsTable;
    }>;
    removeAssessmentQuestionsTable(assessmentQuestionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    assessmentQuestionsSubscription(): AsyncIterator<unknown, any, undefined>;
}
