"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssessmentQuestionsTableResolver = exports.NEW_QUESTION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const assessment_questions_table_service_1 = require("./assessment-questions-table.service");
const assessment_questions_table_entity_1 = require("./entities/assessment-questions-table.entity");
const create_assessment_questions_table_input_1 = require("./dto/create-assessment-questions-table.input");
const update_assessment_questions_table_input_1 = require("./dto/update-assessment-questions-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const assessment_questions_table_return_type_1 = require("./types/assessment-questions-table-return.type");
const assessment_questions_table_type_1 = require("./types/assessment-questions-table.type");
const assessment_questions_table_return_app_type_1 = require("./types/assessment-questions-table-return-app.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
let AssessmentQuestionsTableResolver = exports.AssessmentQuestionsTableResolver = class AssessmentQuestionsTableResolver {
    constructor(assessmentQuestionsTableService, pubSub) {
        this.assessmentQuestionsTableService = assessmentQuestionsTableService;
        this.pubSub = pubSub;
    }
    createAssessmentQuestionsTable(createAssessmentQuestionsTableInput) {
        return this.assessmentQuestionsTableService.create(createAssessmentQuestionsTableInput);
    }
    findAllAssessmentQuestions() {
        return this.assessmentQuestionsTableService.findAll();
    }
    findOne(assessmentQuestionId) {
        return this.assessmentQuestionsTableService.findOne(assessmentQuestionId);
    }
    findOneByAssessmentMasterId(assessmentId) {
        return this.assessmentQuestionsTableService.findOneByAssessmentMasterId(assessmentId);
    }
    findOneAssessmentByType(type) {
        return this.assessmentQuestionsTableService.findOneAssessmentByType(type);
    }
    findOneAssessmentByIdForApp(assessmentId) {
        return this.assessmentQuestionsTableService.findOneAssessmentByIdForApp(assessmentId);
    }
    updateAssessmentQuestionsTable(updateAssessmentQuestionsTableInput) {
        return this.assessmentQuestionsTableService.update(updateAssessmentQuestionsTableInput.assessmentQuestionId, updateAssessmentQuestionsTableInput);
    }
    removeAssessmentQuestionsTable(assessmentQuestionId) {
        return this.assessmentQuestionsTableService.remove(assessmentQuestionId);
    }
    assessmentQuestionsSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_QUESTION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_questions_table_return_type_1.AssessmentQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('createAssessmentQuestionsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_assessment_questions_table_input_1.CreateAssessmentQuestionsTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "createAssessmentQuestionsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_questions_table_type_1.AssessmentQuestionsTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "findAllAssessmentQuestions", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => assessment_questions_table_return_type_1.AssessmentQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('assessmentQuestionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [assessment_questions_table_type_1.AssessmentQuestionsTableType]),
    __param(0, (0, graphql_1.Args)('assessmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "findOneByAssessmentMasterId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => assessment_questions_table_return_app_type_1.AssessmentQuestionsTableReturnAppType),
    __param(0, (0, graphql_1.Args)('type', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "findOneAssessmentByType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => assessment_questions_table_return_app_type_1.AssessmentQuestionsTableReturnAppType),
    __param(0, (0, graphql_1.Args)('assessmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "findOneAssessmentByIdForApp", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_questions_table_return_type_1.AssessmentQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('updateAssessmentQuestionsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_assessment_questions_table_input_1.UpdateAssessmentQuestionsTableInput]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "updateAssessmentQuestionsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => assessment_questions_table_return_type_1.AssessmentQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('assessmentQuestionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "removeAssessmentQuestionsTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AssessmentQuestionsTableResolver.prototype, "assessmentQuestionsSubscription", null);
exports.AssessmentQuestionsTableResolver = AssessmentQuestionsTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => assessment_questions_table_entity_1.AssessmentQuestionsTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [assessment_questions_table_service_1.AssessmentQuestionsTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], AssessmentQuestionsTableResolver);
