import { CreateAssessmentQuestionsTableInput } from './dto/create-assessment-questions-table.input';
import { UpdateAssessmentQuestionsTableInput } from './dto/update-assessment-questions-table.input';
import { AssessmentQuestionsTable } from './entities/assessment-questions-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AssessmentMasterTableService } from 'src/assessment-master-table/assessment-master-table.service';
export declare const NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
export declare class AssessmentQuestionsTableService {
    private readonly assessmentQuestionsTableRepository;
    private pubSub;
    private readonly assessmentMasterTableService;
    constructor(assessmentQuestionsTableRepository: Repository<AssessmentQuestionsTable>, pubSub: RedisPubSub, assessmentMasterTableService: AssessmentMasterTableService);
    create(createAssessmentQuestionsTableInput: CreateAssessmentQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentQuestionsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createAssessmentQuestionsTableInput: CreateAssessmentQuestionsTableInput): Promise<number>;
    findAll(): Promise<AssessmentQuestionsTable[]>;
    findOne(assessmentQuestionId: number): Promise<AssessmentQuestionsTable>;
    findOneByAssessmentMasterId(assessmentId: number): Promise<AssessmentQuestionsTable[]>;
    findOneAssessmentByType(type: string): Promise<{
        data: any;
        length: number;
        assessmentId: number;
    }>;
    findOneAssessmentByIdForApp(assessmentId: number): Promise<{
        data: any;
        length: number;
        assessmentId: number;
        duration: number;
    }>;
    findLargest(arr: number[]): number;
    shuffleArray(array: any): any;
    update(assessmentQuestionId: number, updateAssessmentQuestionsTableInput: UpdateAssessmentQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: AssessmentQuestionsTable;
    }>;
    remove(assessmentQuestionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
