import { JwtService } from '@nestjs/jwt';
import { LoginDto } from 'src/user-collection/dto/login-dto';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { AccessTableService } from 'src/access-table/access-table.service';
export declare class AuthService {
    private readonly userCollectionService;
    private readonly jwtService;
    private readonly accessTableService;
    constructor(userCollectionService: UserCollectionService, jwtService: JwtService, accessTableService: AccessTableService);
    validateUser(username: string, password: string): Promise<any>;
    validateUserNewWs(id: number): Promise<any>;
    login(loginDto: LoginDto): Promise<{
        status: boolean;
        token: string;
        user: {
            username: string;
            id: number;
            name: string;
            role: string;
            isIntegrator: boolean;
            isEd: boolean;
        };
    } | {
        status: boolean;
        token?: undefined;
        user?: undefined;
    }>;
    isValidJwt(token: string): Promise<void>;
}
