"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GqlAuthGuard = void 0;
const graphql_1 = require("@nestjs/graphql");
const passport_1 = require("@nestjs/passport");
class GqlAuthGuard extends (0, passport_1.AuthGuard)("jwt") {
    getRequest(context) {
        const ctx = graphql_1.GqlExecutionContext.create(context);
        const { req, connection } = ctx.getContext();
        return (connection && connection.context && connection.context.headers)
            ? connection.context
            : req;
    }
}
exports.GqlAuthGuard = GqlAuthGuard;
