"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationCollectionController = void 0;
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const authentication_collection_service_1 = require("./authentication-collection.service");
let AuthenticationCollectionController = class AuthenticationCollectionController {
    constructor(authenticationCollectionService) {
        this.authenticationCollectionService = authenticationCollectionService;
    }
    async checkAuthentication(authString) {
        let result = await this.authenticationCollectionService.checkAuthentication(authString);
        return {
            url: result.link,
            statusCode: 301
        };
    }
    async checkForgotData(authString) {
        let result = await this.authenticationCollectionService.checkForgotTokenIfValid(authString);
        return result;
    }
};
__decorate([
    (0, common_1.Get)(':authString'),
    (0, common_1.Header)('Cache-Control', 'no-cache'),
    (0, common_1.Redirect)(GlobalConstants_1.REDIRECT_LINK, 301),
    __param(0, (0, common_1.Param)('authString')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AuthenticationCollectionController.prototype, "checkAuthentication", null);
__decorate([
    (0, common_1.Get)('/verify/:authString'),
    (0, common_1.Header)('Cache-Control', 'no-cache'),
    __param(0, (0, common_1.Param)('authString')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AuthenticationCollectionController.prototype, "checkForgotData", null);
AuthenticationCollectionController = __decorate([
    (0, common_1.Controller)('owval-authentication'),
    __metadata("design:paramtypes", [authentication_collection_service_1.AuthenticationCollectionService])
], AuthenticationCollectionController);
exports.AuthenticationCollectionController = AuthenticationCollectionController;
