import { Model } from 'mongoose';
import { ClientCollectionService } from 'src/client-collection/client-collection.service';
import { AuthenticationCollection } from './entities/authentication-collection.entity';
export declare class AuthenticationCollectionService {
    private authenticationCollectionRepository;
    private clientCollectionService;
    private crypto;
    constructor(authenticationCollectionRepository: Model<AuthenticationCollection>, clientCollectionService: ClientCollectionService, crypto: any);
    checkAuthentication(authString: string): Promise<{
        status: boolean;
        status_text: string;
        link: string;
    } | {
        status: boolean;
        status_text: string;
        link?: undefined;
    }>;
    createAuthentication(email: string, type: string): Promise<any>;
    checkForgotTokenIfValid(authString: string): Promise<{
        status: boolean;
        status_text: string;
        username?: undefined;
    } | {
        status: boolean;
        status_text: string;
        username: string;
    }>;
    getEmail(authString: string): Promise<string | false>;
    deactivateToken(email: string, type: string): Promise<boolean>;
}
