"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthenticationCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const client_collection_service_1 = require("../client-collection/client-collection.service");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const authentication_collection_entity_1 = require("./entities/authentication-collection.entity");
let AuthenticationCollectionService = class AuthenticationCollectionService {
    constructor(authenticationCollectionRepository, clientCollectionService, crypto) {
        this.authenticationCollectionRepository = authenticationCollectionRepository;
        this.clientCollectionService = clientCollectionService;
        this.crypto = crypto;
    }
    async checkAuthentication(authString) {
        let r = await this.authenticationCollectionRepository.findOne({
            authString: authString,
            isValid: true
        }).exec();
        if (r) {
            if (r.type == 'CLIENT_EMAIL_VERIFICATION') {
                await this.clientCollectionService.markAsEmailVerified(r.email);
                r.isValid = false;
                let cc1 = await this.authenticationCollectionRepository.updateOne({ _id: r.id }, r);
                return {
                    status: true,
                    status_text: 'Successfully Verified. Now you can login to the site.',
                    link: `${GlobalConstants_1.REDIRECT_LINK}/verification-owval?status=true&message=Successfully Verified. Now you can login to the site.`
                };
            }
            if (r.type == 'CLIENT_FORGOT_PASSWORD') {
                await this.clientCollectionService.markAsEmailVerified(r.email);
                let cc1 = await this.authenticationCollectionRepository.updateOne({ _id: r.id }, r);
                return {
                    status: true,
                    status_text: 'Successfully Verified. Now you can login to the site.',
                    link: `${GlobalConstants_1.REDIRECT_LINK}/password-change?data=${r.authString}`
                };
            }
        }
        else {
            return {
                status: false,
                status_text: 'Token timeout'
            };
        }
    }
    async createAuthentication(email, type) {
        let r = await this.authenticationCollectionRepository.findOne({
            email: email,
            type: type
        }).exec();
        let randString = this.crypto.randomBytes(20).toString('hex');
        ;
        if (r) {
            r.authString = randString;
            r.isValid = true;
            let cc1 = await this.authenticationCollectionRepository.updateOne({ _id: r.id }, r);
            return randString;
        }
        else {
            let cm = new authentication_collection_entity_1.AuthenticationCollection();
            cm.email = email;
            cm.authString = randString;
            cm.type = type;
            cm.isValid = true;
            let c = await this.authenticationCollectionRepository.create(cm);
            return randString;
        }
    }
    async checkForgotTokenIfValid(authString) {
        let r = await this.authenticationCollectionRepository.findOne({
            authString,
            isValid: true
        }).exec();
        if (r) {
            return {
                status: true,
                status_text: "Please insert new password"
            };
        }
        else {
            return {
                status: false,
                status_text: "Token Expired",
                username: ''
            };
        }
    }
    async getEmail(authString) {
        let r = await this.authenticationCollectionRepository.findOne({
            authString,
            isValid: true
        }).exec();
        if (r) {
            return r.email;
        }
        else {
            return false;
        }
    }
    async deactivateToken(email, type) {
        let r = await this.authenticationCollectionRepository.findOne({
            email,
            type,
            isValid: true
        }).exec();
        if (r) {
            r.isValid = false;
            let cc1 = await this.authenticationCollectionRepository.updateOne({ _id: r.id }, r);
            return true;
        }
        else {
            return false;
        }
    }
};
AuthenticationCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(authentication_collection_entity_1.AuthenticationCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => client_collection_service_1.ClientCollectionService))),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.CRYPTO)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        client_collection_service_1.ClientCollectionService, Object])
], AuthenticationCollectionService);
exports.AuthenticationCollectionService = AuthenticationCollectionService;
