import { BankLoanTableService } from './bank-loan-table.service';
import { BankLoanTable } from './entities/bank-loan-table.entity';
import { CreateBankLoanTableInput } from './dto/create-bank-loan-table.input';
import { UpdateBankLoanTableInput } from './dto/update-bank-loan-table.input';
export declare class BankLoanTableResolver {
    private readonly bankLoanTableService;
    constructor(bankLoanTableService: BankLoanTableService);
    createBankLoanTable(createBankLoanTableInput: CreateBankLoanTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BankLoanTable;
    }>;
    findAllBankLoan(): Promise<BankLoanTable[]>;
    findOneBankLoan(bankLoanId: number): Promise<BankLoanTable>;
    findBankLoanByFarmerId(farmerId: number): Promise<BankLoanTable[]>;
    updateBankLoanTable(updateBankLoanTableInput: UpdateBankLoanTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BankLoanTable;
    }>;
    removeBankLoanTable(bankLoanId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    countBankLoanDetails(districtId: number): Promise<any>;
}
