"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BankLoanTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const bank_loan_table_service_1 = require("./bank-loan-table.service");
const bank_loan_table_entity_1 = require("./entities/bank-loan-table.entity");
const create_bank_loan_table_input_1 = require("./dto/create-bank-loan-table.input");
const update_bank_loan_table_input_1 = require("./dto/update-bank-loan-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const bank_loan_table_return_type_1 = require("./types/bank-loan-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const bank_loan_table_type_1 = require("./types/bank-loan-table.type");
const bank_loan_report_type_1 = require("./types/bank-loan-report.type");
let BankLoanTableResolver = class BankLoanTableResolver {
    constructor(bankLoanTableService) {
        this.bankLoanTableService = bankLoanTableService;
    }
    createBankLoanTable(createBankLoanTableInput, user) {
        return this.bankLoanTableService.create(createBankLoanTableInput, user);
    }
    findAllBankLoan() {
        return this.bankLoanTableService.findAll();
    }
    findOneBankLoan(bankLoanId) {
        return this.bankLoanTableService.findOne(bankLoanId);
    }
    findBankLoanByFarmerId(farmerId) {
        return this.bankLoanTableService.findOneByFarmerId(farmerId);
    }
    updateBankLoanTable(updateBankLoanTableInput, user) {
        return this.bankLoanTableService.update(updateBankLoanTableInput.bankLoanId, updateBankLoanTableInput, user);
    }
    removeBankLoanTable(bankLoanId, user) {
        return this.bankLoanTableService.remove(bankLoanId, user);
    }
    countBankLoanDetails(districtId) {
        return this.bankLoanTableService.countBankLoanDetails(districtId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => bank_loan_table_return_type_1.BankLoanTableReturnType),
    __param(0, (0, graphql_1.Args)('createBankLoanTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_bank_loan_table_input_1.CreateBankLoanTableInput, Object]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "createBankLoanTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [bank_loan_table_type_1.BankLoanTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "findAllBankLoan", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => bank_loan_table_type_1.BankLoanTableType),
    __param(0, (0, graphql_1.Args)('bankLoanId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "findOneBankLoan", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [bank_loan_table_type_1.BankLoanTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "findBankLoanByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => bank_loan_table_return_type_1.BankLoanTableReturnType),
    __param(0, (0, graphql_1.Args)('updateBankLoanTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_bank_loan_table_input_1.UpdateBankLoanTableInput, Object]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "updateBankLoanTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => bank_loan_table_return_type_1.BankLoanTableReturnType),
    __param(0, (0, graphql_1.Args)('bankLoanId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "removeBankLoanTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [bank_loan_report_type_1.BankLoanCountReport]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BankLoanTableResolver.prototype, "countBankLoanDetails", null);
BankLoanTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => bank_loan_table_entity_1.BankLoanTable),
    __metadata("design:paramtypes", [bank_loan_table_service_1.BankLoanTableService])
], BankLoanTableResolver);
exports.BankLoanTableResolver = BankLoanTableResolver;
