import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateBankLoanTableInput } from './dto/create-bank-loan-table.input';
import { UpdateBankLoanTableInput } from './dto/update-bank-loan-table.input';
import { BankLoanTable } from './entities/bank-loan-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class BankLoanTableService {
    private readonly bankLoanTableRepository;
    private readonly userCollectionService;
    private readonly farmersTableService;
    private readonly subDivisionTableService;
    private readonly dataEntryTableService;
    constructor(bankLoanTableRepository: Repository<BankLoanTable>, userCollectionService: UserCollectionService, farmersTableService: FarmersTableService, subDivisionTableService: SubDivisionTableService, dataEntryTableService: DataEntryTableService);
    create(createBankLoanTableInput: CreateBankLoanTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BankLoanTable;
    }>;
    checkIfExists(createBankLoanTableInput: CreateBankLoanTableInput): Promise<boolean>;
    findByFarmerId(farmerId: number): Promise<BankLoanTable[]>;
    findAll(): Promise<BankLoanTable[]>;
    findOne(bankLoanId: number): Promise<BankLoanTable>;
    findOneByFarmerId(farmerId: number): Promise<BankLoanTable[]>;
    update(bankLoanId: number, updateBankLoanTableInput: UpdateBankLoanTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BankLoanTable;
    }>;
    remove(bankLoanId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    countBankLoanDetails(districtId: any): Promise<any>;
}
