import { BlockTableService } from './block-table.service';
import { BlockTable } from './entities/block-table.entity';
import { CreateBlockTableInput } from './dto/create-block-table.input';
import { UpdateBlockTableInput } from './dto/update-block-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BLOCK_ADD = "NEW_BLOCK_ADD";
export declare class BlockTableResolver {
    private readonly blockTableService;
    private pubSub;
    constructor(blockTableService: BlockTableService, pubSub: RedisPubSub);
    createBlockTable(createBlockTableInput: CreateBlockTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BlockTable;
    }>;
    findAllBlock(user: any): Promise<BlockTable[]>;
    findAllBlockByDistrict(user: any, districtId: number): Promise<BlockTable[]>;
    findOneBlock(blockId: number): Promise<BlockTable>;
    updateBlockTable(updateBlockTableInput: UpdateBlockTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BlockTable;
    }>;
    removeBlockTable(blockId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    blockSubscription(): AsyncIterator<unknown, any, undefined>;
}
