"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockTableResolver = exports.NEW_BLOCK_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const block_table_service_1 = require("./block-table.service");
const block_table_entity_1 = require("./entities/block-table.entity");
const create_block_table_input_1 = require("./dto/create-block-table.input");
const update_block_table_input_1 = require("./dto/update-block-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const block_table_return_type_1 = require("./types/block-table-return.type");
const block_table_type_1 = require("./types/block-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_BLOCK_ADD = "NEW_BLOCK_ADD";
let BlockTableResolver = exports.BlockTableResolver = class BlockTableResolver {
    constructor(blockTableService, pubSub) {
        this.blockTableService = blockTableService;
        this.pubSub = pubSub;
    }
    createBlockTable(createBlockTableInput) {
        return this.blockTableService.create(createBlockTableInput);
    }
    findAllBlock(user) {
        return this.blockTableService.findAll();
    }
    findAllBlockByDistrict(user, districtId) {
        return this.blockTableService.findAllByDistrictId(districtId);
    }
    findOneBlock(blockId) {
        return this.blockTableService.findOne(blockId);
    }
    updateBlockTable(updateBlockTableInput) {
        return this.blockTableService.update(updateBlockTableInput.blockId, updateBlockTableInput);
    }
    removeBlockTable(blockId) {
        return this.blockTableService.remove(blockId);
    }
    blockSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_BLOCK_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => block_table_return_type_1.BlockTableReturnType),
    __param(0, (0, graphql_1.Args)('createBlockTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_block_table_input_1.CreateBlockTableInput]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "createBlockTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [block_table_type_1.BlockTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "findAllBlock", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [block_table_type_1.BlockTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "findAllBlockByDistrict", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => block_table_type_1.BlockTableType),
    __param(0, (0, graphql_1.Args)('blockId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "findOneBlock", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => block_table_return_type_1.BlockTableReturnType),
    __param(0, (0, graphql_1.Args)('updateBlockTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_block_table_input_1.UpdateBlockTableInput]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "updateBlockTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => block_table_return_type_1.BlockTableReturnType),
    __param(0, (0, graphql_1.Args)('blockId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "removeBlockTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BlockTableResolver.prototype, "blockSubscription", null);
exports.BlockTableResolver = BlockTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => block_table_entity_1.BlockTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [block_table_service_1.BlockTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], BlockTableResolver);
