import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateBlockTableInput } from './dto/create-block-table.input';
import { UpdateBlockTableInput } from './dto/update-block-table.input';
import { BlockTable } from './entities/block-table.entity';
import { DistrictTableService } from 'src/district-table/district-table.service';
export declare const NEW_BLOCK_ADD = "NEW_BLOCK_ADD";
export declare class BlockTableService {
    private readonly blockTableRepository;
    private pubSub;
    private readonly districtTableService;
    constructor(blockTableRepository: Repository<BlockTable>, pubSub: RedisPubSub, districtTableService: DistrictTableService);
    create(createBlockTableInput: CreateBlockTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BlockTable;
    }>;
    createorElseReturnObject(createBlockTableInput: CreateBlockTableInput): Promise<BlockTable>;
    checkIfExists(blockName: string, districtId: number): Promise<boolean>;
    findAll(): Promise<BlockTable[]>;
    findAllByIds(Ids: number[]): Promise<BlockTable[]>;
    getCount(): Promise<number>;
    getCountUnderAState(stateId: any): Promise<number[]>;
    getCountUnderADistrict(districtId: any): Promise<number[]>;
    findAllByDistrictId(districtId: number): Promise<BlockTable[]>;
    findOne(blockId: number): Promise<BlockTable>;
    update(blockId: number, updateBlockTableInput: UpdateBlockTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BlockTable;
    }>;
    remove(blockId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
