import { BrandCollectionService } from './brand-collection.service';
import { BrandCollection } from './entities/brand-collection.entity';
import { CreateBrandCollectionInput } from './input/create-brand-collection.input';
import { UpdateBrandCollectionInput } from './input/update-brand-collection.input';
import { FileUpload } from 'graphql-upload';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BRAND_ADD = "NEW_BRAND_ADD";
export declare class BrandCollectionResolver {
    private readonly brandCollectionService;
    private pubSub;
    constructor(brandCollectionService: BrandCollectionService, pubSub: RedisPubSub);
    createBrandCollection(user: any, createBrandCollectionInput: CreateBrandCollectionInput, fileUpload?: FileUpload): Promise<void | {
        status: boolean;
        status_text: string;
        data: BrandCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllBrand(): Promise<(BrandCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    updateBrandCollection(updateBrandCollectionInput: UpdateBrandCollectionInput, fileUpload?: FileUpload): Promise<any>;
    updateBrandCollectionWithOutFile(updateBrandCollectionInput: UpdateBrandCollectionInput): Promise<any>;
    removeBrandCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: BrandCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    brandSubscription(): AsyncIterator<unknown, any, undefined>;
}
