"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrandCollectionResolver = exports.NEW_BRAND_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const brand_collection_service_1 = require("./brand-collection.service");
const brand_collection_entity_1 = require("./entities/brand-collection.entity");
const create_brand_collection_input_1 = require("./input/create-brand-collection.input");
const update_brand_collection_input_1 = require("./input/update-brand-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const brand_collection_create_type_1 = require("./types/brand-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const brand_collection_type_1 = require("./types/brand-collection.type");
const graphql_upload_1 = require("graphql-upload");
const fs_1 = require("fs");
const path_1 = require("path");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const uuid_1 = require("uuid");
const new_brand_type_1 = require("./types/new-brand.type");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_BRAND_ADD = "NEW_BRAND_ADD";
let BrandCollectionResolver = class BrandCollectionResolver {
    constructor(brandCollectionService, pubSub) {
        this.brandCollectionService = brandCollectionService;
        this.pubSub = pubSub;
    }
    createBrandCollection(user, createBrandCollectionInput, fileUpload) {
        if (fileUpload.filename != undefined) {
            let newFileName = `${(0, uuid_1.v4)()}${(0, path_1.extname)(fileUpload.filename)}`;
            let path = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, 'brands', newFileName);
            let sweetPath = `/uploads/brands/${newFileName}`;
            return new Promise(async (resolve, reject) => fileUpload.createReadStream()
                .pipe((0, fs_1.createWriteStream)(path))
                .on('finish', () => resolve(true))
                .on('error', () => reject(false)))
                .then(() => {
                return this.brandCollectionService.create(createBrandCollectionInput, sweetPath, newFileName);
            })
                .catch(() => { });
        }
        else {
            return this.brandCollectionService.create(createBrandCollectionInput, null, null);
        }
    }
    findAllBrand() {
        return this.brandCollectionService.findAll();
    }
    updateBrandCollection(updateBrandCollectionInput, fileUpload) {
        if (fileUpload.filename != undefined) {
            let newFileName = `${(0, uuid_1.v4)()}${(0, path_1.extname)(fileUpload.filename)}`;
            let path = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, 'brands', newFileName);
            let sweetPath = `/uploads/brands/${newFileName}`;
            return new Promise(async (resolve, reject) => fileUpload.createReadStream()
                .pipe((0, fs_1.createWriteStream)(path))
                .on('finish', () => resolve(true))
                .on('error', () => reject(false)))
                .then(() => {
                return this.brandCollectionService.update(updateBrandCollectionInput.id, updateBrandCollectionInput, sweetPath, newFileName);
            })
                .catch(() => { });
        }
        else {
            return this.brandCollectionService.update(updateBrandCollectionInput.id, updateBrandCollectionInput, null, null);
        }
    }
    updateBrandCollectionWithOutFile(updateBrandCollectionInput) {
        return this.brandCollectionService.update(updateBrandCollectionInput.id, updateBrandCollectionInput, null, null);
    }
    removeBrandCollection(id) {
        return this.brandCollectionService.remove(id);
    }
    brandSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_BRAND_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_collection_create_type_1.BrandCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createBrandCollectionInput')),
    __param(2, (0, graphql_1.Args)({ name: 'file', type: () => graphql_upload_1.GraphQLUpload })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_brand_collection_input_1.CreateBrandCollectionInput, typeof (_a = typeof graphql_upload_1.FileUpload !== "undefined" && graphql_upload_1.FileUpload) === "function" ? _a : Object]),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "createBrandCollection", null);
__decorate([
    (0, graphql_1.Query)(() => [brand_collection_type_1.BrandCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "findAllBrand", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_collection_create_type_1.BrandCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateBrandCollectionInput')),
    __param(1, (0, graphql_1.Args)({ name: 'file', type: () => graphql_upload_1.GraphQLUpload })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_brand_collection_input_1.UpdateBrandCollectionInput, typeof (_b = typeof graphql_upload_1.FileUpload !== "undefined" && graphql_upload_1.FileUpload) === "function" ? _b : Object]),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "updateBrandCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_collection_create_type_1.BrandCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateBrandCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_brand_collection_input_1.UpdateBrandCollectionInput]),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "updateBrandCollectionWithOutFile", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_collection_create_type_1.BrandCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "removeBrandCollection", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_brand_type_1.NewBrandAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BrandCollectionResolver.prototype, "brandSubscription", null);
BrandCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => brand_collection_entity_1.BrandCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [brand_collection_service_1.BrandCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], BrandCollectionResolver);
exports.BrandCollectionResolver = BrandCollectionResolver;
