import { CreateBrandCollectionInput } from './input/create-brand-collection.input';
import { UpdateBrandCollectionInput } from './input/update-brand-collection.input';
import { BrandCollection, BrandCollectionDocument } from './entities/brand-collection.entity';
import { Model } from 'mongoose';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BRAND_ADD = "NEW_BRAND_ADD";
export declare class BrandCollectionService {
    private brandRepository;
    private pubSub;
    constructor(brandRepository: Model<BrandCollectionDocument>, pubSub: RedisPubSub);
    create(createBrandCollectionInput: CreateBrandCollectionInput, path: string, filename: string): Promise<{
        status: boolean;
        status_text: string;
        data: BrandCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(brandCode: string): Promise<boolean>;
    findAll(): Promise<(BrandCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneById(id: string): Promise<BrandCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: BrandCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    update(id: string, updateBrandCollectionInput: UpdateBrandCollectionInput, path: string, filename: string): Promise<any>;
    deleteFileWithFileName(file: any): Promise<boolean>;
}
