"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrandCollectionService = exports.NEW_BRAND_ADD = void 0;
const common_1 = require("@nestjs/common");
const brand_collection_entity_1 = require("./entities/brand-collection.entity");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_BRAND_ADD = "NEW_BRAND_ADD";
let BrandCollectionService = class BrandCollectionService {
    constructor(brandRepository, pubSub) {
        this.brandRepository = brandRepository;
        this.pubSub = pubSub;
    }
    async create(createBrandCollectionInput, path, filename) {
        let checkIfExists = await this.checkIfExists(createBrandCollectionInput.brandCode);
        if (!checkIfExists) {
            let cm = new brand_collection_entity_1.BrandCollection();
            cm.brandName = createBrandCollectionInput.brandName;
            cm.brandCode = createBrandCollectionInput.brandCode;
            if (filename != null) {
                cm.brandLogo = {
                    fileName: filename,
                    url: path,
                    fileType: 'brands'
                };
            }
            let c = await this.brandRepository.create(cm);
            this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Brand Code already exists',
                data: null
            };
        }
    }
    async checkIfExists(brandCode) {
        let r = await this.brandRepository.count({
            brandCode: brandCode
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.brandRepository.find().exec();
    }
    async findOneById(id) {
        return await this.brandRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        let cc = await this.brandRepository.findOne({ _id: id }).exec();
        this.deleteFileWithFileName(cc.brandLogo);
        await this.brandRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: cc
        };
    }
    async update(id, updateBrandCollectionInput, path, filename) {
        let cc = await this.brandRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.brandName = updateBrandCollectionInput.brandName;
            if (filename != null) {
                this.deleteFileWithFileName(cc.brandLogo);
                cc.brandLogo = {
                    fileName: filename,
                    url: path,
                    fileType: 'brands'
                };
            }
            let cc1 = await this.brandRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
    async deleteFileWithFileName(file) {
        if (file.url != undefined) {
            let p = path.join(__dirname, '..', '..', 'uploads', 'brands', file.fileName);
            let ifExists = fs.existsSync(p);
            if (ifExists) {
                fs.unlinkSync(p);
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }
};
BrandCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(brand_collection_entity_1.BrandCollection.name)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        graphql_redis_subscriptions_1.RedisPubSub])
], BrandCollectionService);
exports.BrandCollectionService = BrandCollectionService;
