import { BrandTableService } from './brand-table.service';
import { BrandTable } from './entities/brand-table.entity';
import { CreateBrandTableInput } from './dto/create-brand-table.input';
import { UpdateBrandTableInput } from './dto/update-brand-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BRAND_ADD = "NEW_BRAND_ADD";
export declare class BrandTableResolver {
    private readonly brandTableService;
    private pubSub;
    constructor(brandTableService: BrandTableService, pubSub: RedisPubSub);
    createBrandTable(createBrandTableInput: CreateBrandTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BrandTable;
    }>;
    findAllBrand(): Promise<BrandTable[]>;
    findOneBrand(brandId: number): Promise<BrandTable>;
    updateBrandTable(updateBrandTableInput: UpdateBrandTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BrandTable;
    }>;
    removeBrandTable(brandId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    brandSubscription(): AsyncIterator<unknown, any, undefined>;
}
