"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrandTableResolver = exports.NEW_BRAND_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const brand_table_service_1 = require("./brand-table.service");
const brand_table_entity_1 = require("./entities/brand-table.entity");
const create_brand_table_input_1 = require("./dto/create-brand-table.input");
const update_brand_table_input_1 = require("./dto/update-brand-table.input");
const brand_table_type_1 = require("./types/brand-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const brand_table_return_type_1 = require("./types/brand-table-return.type");
const brand_count_changed_type_1 = require("./types/brand-count-changed.type");
exports.NEW_BRAND_ADD = "NEW_BRAND_ADD";
let BrandTableResolver = class BrandTableResolver {
    constructor(brandTableService, pubSub) {
        this.brandTableService = brandTableService;
        this.pubSub = pubSub;
    }
    createBrandTable(createBrandTableInput, user) {
        return this.brandTableService.create(createBrandTableInput, user);
    }
    findAllBrand() {
        return this.brandTableService.findAll();
    }
    findOneBrand(brandId) {
        return this.brandTableService.findOne(brandId);
    }
    updateBrandTable(updateBrandTableInput, user) {
        return this.brandTableService.update(updateBrandTableInput.brandId, updateBrandTableInput, user);
    }
    removeBrandTable(brandId) {
        return this.brandTableService.remove(brandId);
    }
    brandSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_BRAND_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_table_return_type_1.BrandTableReturnType),
    __param(0, (0, graphql_1.Args)('createBrandTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_brand_table_input_1.CreateBrandTableInput, Object]),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "createBrandTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [brand_table_type_1.BrandTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "findAllBrand", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => brand_table_type_1.BrandTableType),
    __param(0, (0, graphql_1.Args)('brandId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "findOneBrand", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_table_return_type_1.BrandTableReturnType),
    __param(0, (0, graphql_1.Args)('updateBrandTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_brand_table_input_1.UpdateBrandTableInput, Object]),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "updateBrandTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => brand_table_return_type_1.BrandTableReturnType),
    __param(0, (0, graphql_1.Args)('brandId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "removeBrandTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => brand_count_changed_type_1.BrandCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BrandTableResolver.prototype, "brandSubscription", null);
BrandTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => brand_table_entity_1.BrandTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [brand_table_service_1.BrandTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], BrandTableResolver);
exports.BrandTableResolver = BrandTableResolver;
