import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateBrandTableInput } from './dto/create-brand-table.input';
import { UpdateBrandTableInput } from './dto/update-brand-table.input';
import { BrandTable } from './entities/brand-table.entity';
export declare const NEW_BRAND_ADD = "NEW_BRAND_ADD";
export declare class BrandTableService {
    private readonly brandTableRepository;
    private pubSub;
    constructor(brandTableRepository: Repository<BrandTable>, pubSub: RedisPubSub);
    create(createBrandTableInput: CreateBrandTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BrandTable;
    }>;
    checkIfExists(createBrandTableInput: CreateBrandTableInput): Promise<boolean>;
    findAll(): Promise<BrandTable[]>;
    findOne(brandId: number): Promise<BrandTable>;
    update(brandId: number, updateBrandTableInput: UpdateBrandTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BrandTable;
    }>;
    remove(brandId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
