"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrandTableService = exports.NEW_BRAND_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const brand_table_entity_1 = require("./entities/brand-table.entity");
exports.NEW_BRAND_ADD = "NEW_BRAND_ADD";
let BrandTableService = class BrandTableService {
    constructor(brandTableRepository, pubSub) {
        this.brandTableRepository = brandTableRepository;
        this.pubSub = pubSub;
    }
    async create(createBrandTableInput, user) {
        let checkIfExists = await this.checkIfExists(createBrandTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new brand_table_entity_1.BrandTable();
            dd.brandName = createBrandTableInput.brandName;
            let result = await this.brandTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createBrandTableInput) {
        let rr = await this.brandTableRepository.count({
            where: {
                brandName: createBrandTableInput.brandName,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.brandTableRepository.find();
    }
    async findOne(brandId) {
        return await this.brandTableRepository.findOne({
            where: {
                brandId: brandId
            }
        });
    }
    async update(brandId, updateBrandTableInput, user) {
        let ht = await this.brandTableRepository.findOne({
            where: {
                brandId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.brandName = updateBrandTableInput.brandName;
            let result = await this.brandTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(brandId) {
        let ht = await this.brandTableRepository.findOne({
            where: {
                brandId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.brandTableRepository.remove(ht);
            this.pubSub.publish(exports.NEW_BRAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
};
BrandTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(brand_table_entity_1.BrandTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], BrandTableService);
exports.BrandTableService = BrandTableService;
