import { BreedTableService } from './breed-table.service';
import { BreedTable } from './entities/breed-table.entity';
import { CreateBreedTableInput } from './dto/create-breed-table.input';
import { UpdateBreedTableInput } from './dto/update-breed-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BREED_ADD = "NEW_BREED_ADD";
export declare class BreedTableResolver {
    private readonly breedTableService;
    private pubSub;
    constructor(breedTableService: BreedTableService, pubSub: RedisPubSub);
    createBreedTable(createBreedTableInput: CreateBreedTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedTable;
    }>;
    findAllBreed(): Promise<BreedTable[]>;
    findOneBreed(breedId: number): Promise<BreedTable>;
    updateBreedTable(updateBreedTableInput: UpdateBreedTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedTable;
    }>;
    removeBreedTable(breedId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    breedSubscription(): AsyncIterator<unknown, any, undefined>;
}
