"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreedTableResolver = exports.NEW_BREED_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const breed_table_service_1 = require("./breed-table.service");
const breed_table_entity_1 = require("./entities/breed-table.entity");
const create_breed_table_input_1 = require("./dto/create-breed-table.input");
const update_breed_table_input_1 = require("./dto/update-breed-table.input");
const breed_table_type_1 = require("./types/breed-table.type");
const breed_table_return_type_1 = require("./types/breed-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const breed_count_changed_type_1 = require("./types/breed-count-changed.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
exports.NEW_BREED_ADD = "NEW_BREED_ADD";
let BreedTableResolver = class BreedTableResolver {
    constructor(breedTableService, pubSub) {
        this.breedTableService = breedTableService;
        this.pubSub = pubSub;
    }
    createBreedTable(createBreedTableInput, user) {
        return this.breedTableService.create(createBreedTableInput, user);
    }
    findAllBreed() {
        return this.breedTableService.findAll();
    }
    findOneBreed(breedId) {
        return this.breedTableService.findOne(breedId);
    }
    updateBreedTable(updateBreedTableInput, user) {
        return this.breedTableService.update(updateBreedTableInput.breedId, updateBreedTableInput, user);
    }
    removeBreedTable(breedId) {
        return this.breedTableService.remove(breedId);
    }
    breedSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_BREED_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breed_table_return_type_1.BreedTableReturnType),
    __param(0, (0, graphql_1.Args)('createBreedTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_breed_table_input_1.CreateBreedTableInput, Object]),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "createBreedTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breed_table_type_1.BreedTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "findAllBreed", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => breed_table_type_1.BreedTableType),
    __param(0, (0, graphql_1.Args)('breedId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "findOneBreed", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breed_table_return_type_1.BreedTableReturnType),
    __param(0, (0, graphql_1.Args)('updateBreedTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_breed_table_input_1.UpdateBreedTableInput, Object]),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "updateBreedTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breed_table_return_type_1.BreedTableReturnType),
    __param(0, (0, graphql_1.Args)('breedId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "removeBreedTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => breed_count_changed_type_1.BreedCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BreedTableResolver.prototype, "breedSubscription", null);
BreedTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => breed_table_entity_1.BreedTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [breed_table_service_1.BreedTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], BreedTableResolver);
exports.BreedTableResolver = BreedTableResolver;
