import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateBreedTableInput } from './dto/create-breed-table.input';
import { UpdateBreedTableInput } from './dto/update-breed-table.input';
import { BreedTable } from './entities/breed-table.entity';
export declare const NEW_BREED_ADD = "NEW_BREED_ADD";
export declare class BreedTableService {
    private readonly breedTableRepository;
    private pubSub;
    constructor(breedTableRepository: Repository<BreedTable>, pubSub: RedisPubSub);
    create(createBreedTableInput: CreateBreedTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedTable;
    }>;
    checkIfExists(createBreedTableInput: CreateBreedTableInput): Promise<boolean>;
    findAll(): Promise<BreedTable[]>;
    findOne(breedId: number): Promise<BreedTable>;
    update(breedId: number, updateBreedTableInput: UpdateBreedTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedTable;
    }>;
    remove(breedId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
