"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreedTableService = exports.NEW_BREED_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const breed_table_entity_1 = require("./entities/breed-table.entity");
exports.NEW_BREED_ADD = "NEW_BREED_ADD";
let BreedTableService = class BreedTableService {
    constructor(breedTableRepository, pubSub) {
        this.breedTableRepository = breedTableRepository;
        this.pubSub = pubSub;
    }
    async create(createBreedTableInput, user) {
        let checkIfExists = await this.checkIfExists(createBreedTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new breed_table_entity_1.BreedTable();
            dd.breedName = createBreedTableInput.breedName;
            dd.breedType = createBreedTableInput.breedType;
            let result = await this.breedTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_BREED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createBreedTableInput) {
        let rr = await this.breedTableRepository.count({
            where: {
                breedName: createBreedTableInput.breedName,
                breedType: createBreedTableInput.breedType,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.breedTableRepository.find();
    }
    async findOne(breedId) {
        return await this.breedTableRepository.findOne({
            where: {
                breedId: breedId
            },
        });
    }
    async update(breedId, updateBreedTableInput, user) {
        let ht = await this.breedTableRepository.findOne({
            where: {
                breedId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.breedName = updateBreedTableInput.breedName;
            ht.breedType = updateBreedTableInput.breedType;
            let result = await this.breedTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_BREED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(breedId) {
        let result = await this.breedTableRepository.findOne({
            where: {
                breedId: breedId
            }
        });
        if (result) {
            await this.breedTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_BREED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
BreedTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(breed_table_entity_1.BreedTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], BreedTableService);
exports.BreedTableService = BreedTableService;
