import { BreedingSingleTableService } from './breeding-single-table.service';
import { BreedingSingleTable } from './entities/breeding-single-table.entity';
import { CreateBreedingSingleTableInput } from './dto/create-breeding-single-table.input';
export declare class BreedingSingleTableResolver {
    private readonly breedingSingleTableService;
    constructor(breedingSingleTableService: BreedingSingleTableService);
    createBreedingSingleTable(createBreedingSingleTableInput: CreateBreedingSingleTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingSingleTable;
    }>;
    findAllBreeding(): Promise<BreedingSingleTable[]>;
    findBreedingByHousingId(housingId: number): Promise<BreedingSingleTable[]>;
    findBreedingById(breedingSingleId: number): Promise<BreedingSingleTable>;
    updateBreedingStatus(breedingSingleId: number, ageOfSowAtFarrowing: string, totalNoOfPiglets: string, totalMale: string, totalFemale: string, status: number, weightOfEach: string, dateOfFarrowing: string, litterSize: string, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findOneBreeding(breedingSingleId: number): Promise<BreedingSingleTable>;
    checkBreedingPossibility(sowId: number, boarId?: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    fetchBreedingDetailsSingle(animalId: number): Promise<BreedingSingleTable[]>;
    countBreedingDetailsReport(districtId: number, startingDate: string, endingDate: string): Promise<any[]>;
}
