"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreedingSingleTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const breeding_single_table_service_1 = require("./breeding-single-table.service");
const breeding_single_table_entity_1 = require("./entities/breeding-single-table.entity");
const create_breeding_single_table_input_1 = require("./dto/create-breeding-single-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const common_1 = require("@nestjs/common");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const breeding_single_return_type_1 = require("./types/breeding-single-return.type");
const breeding_single_type_1 = require("./types/breeding-single.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const breeding_cluster_wise_type_1 = require("./types/breeding-cluster-wise.type");
let BreedingSingleTableResolver = class BreedingSingleTableResolver {
    constructor(breedingSingleTableService) {
        this.breedingSingleTableService = breedingSingleTableService;
    }
    createBreedingSingleTable(createBreedingSingleTableInput, user) {
        return this.breedingSingleTableService.create(createBreedingSingleTableInput, user);
    }
    findAllBreeding() {
        return this.breedingSingleTableService.findAll();
    }
    findBreedingByHousingId(housingId) {
        return this.breedingSingleTableService.findByHousingId(housingId);
    }
    findBreedingById(breedingSingleId) {
        return this.breedingSingleTableService.findOne(breedingSingleId);
    }
    updateBreedingStatus(breedingSingleId, ageOfSowAtFarrowing, totalNoOfPiglets, totalMale, totalFemale, status, weightOfEach, dateOfFarrowing, litterSize, user) {
        return this.breedingSingleTableService.updateDetailsOfInsemination(breedingSingleId, ageOfSowAtFarrowing, totalNoOfPiglets, totalMale, totalFemale, status, weightOfEach, dateOfFarrowing, litterSize, user);
    }
    findOneBreeding(breedingSingleId) {
        return this.breedingSingleTableService.findOne(breedingSingleId);
    }
    checkBreedingPossibility(sowId, boarId) {
        return this.breedingSingleTableService.checkBreedingPossibility(sowId, boarId);
    }
    fetchBreedingDetailsSingle(animalId) {
        return this.breedingSingleTableService.fetchBreedingDetailsSingle(animalId);
    }
    countBreedingDetailsReport(districtId, startingDate, endingDate) {
        return this.breedingSingleTableService.countBreedingDetailsReport(districtId, startingDate, endingDate);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breeding_single_return_type_1.BreedingSingleTableReturnType),
    __param(0, (0, graphql_1.Args)('createBreedingSingleTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_breeding_single_table_input_1.CreateBreedingSingleTableInput, Object]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "createBreedingSingleTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breeding_single_type_1.BreedingSingleTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "findAllBreeding", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breeding_single_type_1.BreedingSingleTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "findBreedingByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => breeding_single_type_1.BreedingSingleTableType),
    __param(0, (0, graphql_1.Args)('breedingSingleId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "findBreedingById", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breeding_single_return_type_1.BreedingSingleTableReturnType),
    __param(0, (0, graphql_1.Args)('breedingSingleId', { type: () => Number })),
    __param(1, (0, graphql_1.Args)('ageOfSowAtFarrowing', { type: () => String })),
    __param(2, (0, graphql_1.Args)('totalNoOfPiglets', { type: () => String })),
    __param(3, (0, graphql_1.Args)('totalMale', { type: () => String })),
    __param(4, (0, graphql_1.Args)('totalFemale', { type: () => String })),
    __param(5, (0, graphql_1.Args)('status', { type: () => Number })),
    __param(6, (0, graphql_1.Args)('weightOfEach', { type: () => String })),
    __param(7, (0, graphql_1.Args)('dateOfFarrowing', { type: () => String })),
    __param(8, (0, graphql_1.Args)('litterSize', { type: () => String })),
    __param(9, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String, String, String, Number, String, String, String, Object]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "updateBreedingStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => breeding_single_type_1.BreedingSingleTableType),
    __param(0, (0, graphql_1.Args)('breedingSingleId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "findOneBreeding", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => breeding_single_return_type_1.BreedingSingleTableReturnType),
    __param(0, (0, graphql_1.Args)('sowId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('boarId', { type: () => graphql_1.Int, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "checkBreedingPossibility", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breeding_single_type_1.BreedingSingleTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "fetchBreedingDetailsSingle", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breeding_cluster_wise_type_1.BreedingClusterWise]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('startingDate', { type: () => String })),
    __param(2, (0, graphql_1.Args)('endingDate', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String]),
    __metadata("design:returntype", void 0)
], BreedingSingleTableResolver.prototype, "countBreedingDetailsReport", null);
BreedingSingleTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => breeding_single_table_entity_1.BreedingSingleTable),
    __metadata("design:paramtypes", [breeding_single_table_service_1.BreedingSingleTableService])
], BreedingSingleTableResolver);
exports.BreedingSingleTableResolver = BreedingSingleTableResolver;
