import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { ParentTableService } from 'src/parent-table/parent-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateBreedingSingleTableInput } from './dto/create-breeding-single-table.input';
import { UpdateBreedingSingleTableInput } from './dto/update-breeding-single-table.input';
import { BreedingSingleTable } from './entities/breeding-single-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class BreedingSingleTableService {
    private readonly breedingSingleTableRepository;
    private readonly dataEntryTableService;
    private readonly userCollectionService;
    private readonly housingTableService;
    private readonly animalEntryTableService;
    private readonly parentTableService;
    private readonly subDivisionTableService;
    constructor(breedingSingleTableRepository: Repository<BreedingSingleTable>, dataEntryTableService: DataEntryTableService, userCollectionService: UserCollectionService, housingTableService: HousingTableService, animalEntryTableService: AnimalEntryTableService, parentTableService: ParentTableService, subDivisionTableService: SubDivisionTableService);
    create(createBreedingSingleTableInput: CreateBreedingSingleTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingSingleTable;
    }>;
    checkIfExists(createBreedingSingleTableInput: CreateBreedingSingleTableInput): Promise<boolean>;
    fetchBreedingDetailsSingle(animalId: number): Promise<BreedingSingleTable[]>;
    checkBreedingPossibility(sowId: number, boarId?: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findByHousingId(housingId: number): Promise<BreedingSingleTable[]>;
    updateDetailsOfInsemination(breedingSingleId: any, ageOfSowAtFarrowing: any, totalNoOfPiglets: any, totalMale: any, totalFemale: any, status: any, weightOfEach: any, dateOfFarrowing: any, litterSize: any, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAll(): Promise<BreedingSingleTable[]>;
    findOne(breedingSingleId: number): Promise<BreedingSingleTable>;
    countBreedingDetailsReport(districtId: number, startingDate: string, endingDate: string): Promise<any[]>;
    update(id: number, updateBreedingSingleTableInput: UpdateBreedingSingleTableInput): string;
    remove(id: number): string;
}
