import { BreedingTypeTableService } from './breeding-type-table.service';
import { BreedingTypeTable } from './entities/breeding-type-table.entity';
import { CreateBreedingTypeTableInput } from './dto/create-breeding-type-table.input';
import { UpdateBreedingTypeTableInput } from './dto/update-breeding-type-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_BREEDING_ADD = "NEW_BREEDING_ADD";
export declare class BreedingTypeTableResolver {
    private readonly breedingTypeTableService;
    private pubSub;
    constructor(breedingTypeTableService: BreedingTypeTableService, pubSub: RedisPubSub);
    createBreedingTypeTable(createBreedingTypeTableInput: CreateBreedingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingTypeTable;
    }>;
    findAllBreedingTypes(): Promise<BreedingTypeTable[]>;
    findOneBreedingType(breedingTypeTableId: number): Promise<BreedingTypeTable>;
    updateBreedingTypeTable(updateBreedingTypeTableInput: UpdateBreedingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingTypeTable;
    }>;
    removeBreedingTypeTable(breedingTypeTableId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    breedingSubscription(): AsyncIterator<unknown, any, undefined>;
}
