"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreedingTypeTableResolver = exports.NEW_BREEDING_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const breeding_type_table_service_1 = require("./breeding-type-table.service");
const breeding_type_table_entity_1 = require("./entities/breeding-type-table.entity");
const create_breeding_type_table_input_1 = require("./dto/create-breeding-type-table.input");
const update_breeding_type_table_input_1 = require("./dto/update-breeding-type-table.input");
const common_1 = require("@nestjs/common");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const breeding_type_table_return_type_1 = require("./types/breeding-type-table-return.type");
const breeding_type_table_type_1 = require("./types/breeding-type-table.type");
const count_changed_type_1 = require("./types/count-changed.type");
exports.NEW_BREEDING_ADD = "NEW_BREEDING_ADD";
let BreedingTypeTableResolver = class BreedingTypeTableResolver {
    constructor(breedingTypeTableService, pubSub) {
        this.breedingTypeTableService = breedingTypeTableService;
        this.pubSub = pubSub;
    }
    createBreedingTypeTable(createBreedingTypeTableInput) {
        return this.breedingTypeTableService.create(createBreedingTypeTableInput);
    }
    findAllBreedingTypes() {
        return this.breedingTypeTableService.findAll();
    }
    findOneBreedingType(breedingTypeTableId) {
        return this.breedingTypeTableService.findOne(breedingTypeTableId);
    }
    updateBreedingTypeTable(updateBreedingTypeTableInput) {
        return this.breedingTypeTableService.update(updateBreedingTypeTableInput.breedingTypeTableId, updateBreedingTypeTableInput);
    }
    removeBreedingTypeTable(breedingTypeTableId) {
        return this.breedingTypeTableService.remove(breedingTypeTableId);
    }
    breedingSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_BREEDING_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breeding_type_table_return_type_1.BreedingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('createBreedingTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_breeding_type_table_input_1.CreateBreedingTypeTableInput]),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "createBreedingTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [breeding_type_table_type_1.BreedingTypeTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "findAllBreedingTypes", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => breeding_type_table_type_1.BreedingTypeTableType),
    __param(0, (0, graphql_1.Args)('breedingTypeTableId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "findOneBreedingType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breeding_type_table_return_type_1.BreedingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('updateBreedingTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_breeding_type_table_input_1.UpdateBreedingTypeTableInput]),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "updateBreedingTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => breeding_type_table_return_type_1.BreedingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('breedingTypeTableId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "removeBreedingTypeTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.breedingcountchangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], BreedingTypeTableResolver.prototype, "breedingSubscription", null);
BreedingTypeTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => breeding_type_table_entity_1.BreedingTypeTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [breeding_type_table_service_1.BreedingTypeTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], BreedingTypeTableResolver);
exports.BreedingTypeTableResolver = BreedingTypeTableResolver;
