import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateBreedingTypeTableInput } from './dto/create-breeding-type-table.input';
import { UpdateBreedingTypeTableInput } from './dto/update-breeding-type-table.input';
import { BreedingTypeTable } from './entities/breeding-type-table.entity';
export declare const NEW_BREEDING_ADD = "NEW_BREEDING_ADD";
export declare class BreedingTypeTableService {
    private readonly breedingTypeTableRepository;
    private pubSub;
    constructor(breedingTypeTableRepository: Repository<BreedingTypeTable>, pubSub: RedisPubSub);
    create(createBreedingTypeTableInput: CreateBreedingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingTypeTable;
    }>;
    checkIfExists(breedingTypeName: string): Promise<boolean>;
    findAll(): Promise<BreedingTypeTable[]>;
    findOne(breedingTypeTableId: number): Promise<BreedingTypeTable>;
    update(breedingTypeTableId: number, updateBreedingTypeTableInput: UpdateBreedingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: BreedingTypeTable;
    }>;
    remove(breedingTypeTableId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
