"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreedingTypeTableService = exports.NEW_BREEDING_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const breeding_type_table_entity_1 = require("./entities/breeding-type-table.entity");
exports.NEW_BREEDING_ADD = "NEW_BREEDING_ADD";
let BreedingTypeTableService = class BreedingTypeTableService {
    constructor(breedingTypeTableRepository, pubSub) {
        this.breedingTypeTableRepository = breedingTypeTableRepository;
        this.pubSub = pubSub;
    }
    async create(createBreedingTypeTableInput) {
        let checkIfExists = await this.checkIfExists(createBreedingTypeTableInput.breedingTypeName);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new breeding_type_table_entity_1.BreedingTypeTable();
            dd.breedingTypeName = createBreedingTypeTableInput.breedingTypeName;
            let result = await this.breedingTypeTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_BREEDING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(breedingTypeName) {
        let result = await this.breedingTypeTableRepository.count({
            where: {
                breedingTypeName: breedingTypeName
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.breedingTypeTableRepository.find();
    }
    async findOne(breedingTypeTableId) {
        return await this.breedingTypeTableRepository.findOne({
            where: {
                breedingTypeTableId: breedingTypeTableId
            }
        });
    }
    async update(breedingTypeTableId, updateBreedingTypeTableInput) {
        let result = await this.breedingTypeTableRepository.findOne({
            where: {
                breedingTypeTableId: breedingTypeTableId
            }
        });
        if (result) {
            result.breedingTypeName = updateBreedingTypeTableInput.breedingTypeName;
            let r = await this.breedingTypeTableRepository.save(result);
            this.pubSub.publish(exports.NEW_BREEDING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(breedingTypeTableId) {
        let result = await this.breedingTypeTableRepository.findOne({
            where: {
                breedingTypeTableId: breedingTypeTableId
            }
        });
        if (result) {
            await this.breedingTypeTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_BREEDING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
BreedingTypeTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(breeding_type_table_entity_1.BreedingTypeTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], BreedingTypeTableService);
exports.BreedingTypeTableService = BreedingTypeTableService;
