"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CadreTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const cadre_table_service_1 = require("./cadre-table.service");
const cadre_table_entity_1 = require("./entities/cadre-table.entity");
const create_cadre_table_input_1 = require("./dto/create-cadre-table.input");
const update_cadre_table_input_1 = require("./dto/update-cadre-table.input");
let CadreTableResolver = exports.CadreTableResolver = class CadreTableResolver {
    constructor(cadreTableService) {
        this.cadreTableService = cadreTableService;
    }
    createCadreTable(createCadreTableInput) {
        return this.cadreTableService.create(createCadreTableInput);
    }
    findAll() {
        return this.cadreTableService.findAll();
    }
    findOne(id) {
        return this.cadreTableService.findOne(id);
    }
    updateCadreTable(updateCadreTableInput) {
        return this.cadreTableService.update(updateCadreTableInput.id, updateCadreTableInput);
    }
    removeCadreTable(id) {
        return this.cadreTableService.remove(id);
    }
};
__decorate([
    (0, graphql_1.Mutation)(() => cadre_table_entity_1.CadreTable),
    __param(0, (0, graphql_1.Args)('createCadreTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_cadre_table_input_1.CreateCadreTableInput]),
    __metadata("design:returntype", void 0)
], CadreTableResolver.prototype, "createCadreTable", null);
__decorate([
    (0, graphql_1.Query)(() => [cadre_table_entity_1.CadreTable], { name: 'cadreTable' }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CadreTableResolver.prototype, "findAll", null);
__decorate([
    (0, graphql_1.Query)(() => cadre_table_entity_1.CadreTable, { name: 'cadreTable' }),
    __param(0, (0, graphql_1.Args)('id', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CadreTableResolver.prototype, "findOne", null);
__decorate([
    (0, graphql_1.Mutation)(() => cadre_table_entity_1.CadreTable),
    __param(0, (0, graphql_1.Args)('updateCadreTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_cadre_table_input_1.UpdateCadreTableInput]),
    __metadata("design:returntype", void 0)
], CadreTableResolver.prototype, "updateCadreTable", null);
__decorate([
    (0, graphql_1.Mutation)(() => cadre_table_entity_1.CadreTable),
    __param(0, (0, graphql_1.Args)('id', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CadreTableResolver.prototype, "removeCadreTable", null);
exports.CadreTableResolver = CadreTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => cadre_table_entity_1.CadreTable),
    __metadata("design:paramtypes", [cadre_table_service_1.CadreTableService])
], CadreTableResolver);
