import { CartCollectionService } from './cart-collection.service';
import { CartCollection } from './entities/cart-collection.entity';
import { CreateCartCollectionInput } from './dto/create-cart-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare class CartCollectionResolver {
    private readonly cartCollectionService;
    private pubSub;
    constructor(cartCollectionService: CartCollectionService, pubSub: RedisPubSub);
    addToCart(createCartCollectionInput: CreateCartCollectionInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    countMyCart(user: any): Promise<{
        cartCount: number;
    }>;
    getMyCart(user: any): Promise<(CartCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    cartSubscription(username: string): AsyncIterator<unknown, any, undefined>;
}
