"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CartCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const cart_collection_service_1 = require("./cart-collection.service");
const cart_collection_entity_1 = require("./entities/cart-collection.entity");
const create_cart_collection_input_1 = require("./dto/create-cart-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const cart_collection_create_type_1 = require("./types/cart-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const cart_count_type_1 = require("./types/cart-count.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const cart_collection_type_1 = require("./types/cart-collection.type");
let CartCollectionResolver = class CartCollectionResolver {
    constructor(cartCollectionService, pubSub) {
        this.cartCollectionService = cartCollectionService;
        this.pubSub = pubSub;
    }
    addToCart(createCartCollectionInput, user) {
        return this.cartCollectionService.create(createCartCollectionInput, user.username);
    }
    async countMyCart(user) {
        let res = await this.cartCollectionService.countMyCart(user.username);
        return {
            cartCount: res
        };
    }
    getMyCart(user) {
        return this.cartCollectionService.getMyCart(user.username);
    }
    cartSubscription(username) {
        return this.pubSub.asyncIterator(`CART_COUNT_CHANGED_${username}`);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => cart_collection_create_type_1.CartCollectionCreateType),
    __param(0, (0, graphql_1.Args)('createCartCollectionInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_cart_collection_input_1.CreateCartCollectionInput, Object]),
    __metadata("design:returntype", void 0)
], CartCollectionResolver.prototype, "addToCart", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => cart_count_type_1.CartCount),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], CartCollectionResolver.prototype, "countMyCart", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [cart_collection_type_1.CartCollectionType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], CartCollectionResolver.prototype, "getMyCart", null);
__decorate([
    (0, graphql_1.Subscription)(() => cart_count_type_1.CartCount, {
        resolve: (payload) => {
            return { cartCount: payload };
        }
    }),
    __param(0, (0, graphql_1.Args)("username")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], CartCollectionResolver.prototype, "cartSubscription", null);
CartCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => cart_collection_entity_1.CartCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [cart_collection_service_1.CartCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CartCollectionResolver);
exports.CartCollectionResolver = CartCollectionResolver;
