import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { ProductCollectionService } from 'src/product-collection/product-collection.service';
import { CreateCartCollectionInput } from './dto/create-cart-collection.input';
import { CartCollection, CartCollectionDocument } from './entities/cart-collection.entity';
export declare class CartCollectionService {
    private cartCollectionRepository;
    private readonly productCollectionService;
    private pubSub;
    constructor(cartCollectionRepository: Model<CartCollectionDocument>, productCollectionService: ProductCollectionService, pubSub: RedisPubSub);
    create(createCartCollectionInput: CreateCartCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(productId: string, size: string, username: string): Promise<boolean>;
    countMyCart(username: string): Promise<number>;
    getMyCart(username: string): Promise<(CartCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
}
