"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CartCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const product_collection_service_1 = require("../product-collection/product-collection.service");
const cart_collection_entity_1 = require("./entities/cart-collection.entity");
let CartCollectionService = class CartCollectionService {
    constructor(cartCollectionRepository, productCollectionService, pubSub) {
        this.cartCollectionRepository = cartCollectionRepository;
        this.productCollectionService = productCollectionService;
        this.pubSub = pubSub;
    }
    async create(createCartCollectionInput, username) {
        let checkIfExists = await this.checkIfExists(createCartCollectionInput.productId, createCartCollectionInput.size, username);
        if (checkIfExists) {
            return {
                status: true,
                status_text: "Item already exists in your cart"
            };
        }
        let product = await this.productCollectionService.findOneById(createCartCollectionInput.productId);
        if (product) {
            let cr = new cart_collection_entity_1.CartCollection();
            cr.createdBy = username;
            cr.size = createCartCollectionInput.size;
            cr.Product = product;
            cr.qty = createCartCollectionInput.qty;
            cr.price = createCartCollectionInput.price;
            cr.amount = createCartCollectionInput.amount;
            let res = await this.cartCollectionRepository.create(cr);
            this.pubSub.publish(`CART_COUNT_CHANGED_${username}`, await this.countMyCart(username));
            return {
                status: true,
                status_text: "Item successfully added to your cart"
            };
        }
    }
    async checkIfExists(productId, size, username) {
        let res = await this.cartCollectionRepository.count({
            Product: {
                "_id": productId,
            },
            size: size,
            createdBy: username
        }).exec();
        if (res > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    async countMyCart(username) {
        return await this.cartCollectionRepository.count({
            createdBy: username
        }).exec();
    }
    getMyCart(username) {
        return this.cartCollectionRepository.find({
            createdBy: username
        }).populate('Product').exec();
    }
};
CartCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(cart_collection_entity_1.CartCollection.name)),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_collection_service_1.ProductCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CartCollectionService);
exports.CartCollectionService = CartCollectionService;
