import { ChallengesFacedService } from './challenges-faced.service';
import { ChallengesFaced } from './entities/challenges-faced.entity';
import { CreateChallengesFacedInput } from './dto/create-challenges-faced.input';
import { UpdateChallengesFacedInput } from './dto/update-challenges-faced.input';
export declare class ChallengesFacedResolver {
    private readonly challengesFacedService;
    constructor(challengesFacedService: ChallengesFacedService);
    createChallengesFaced(createChallengesFacedInput: CreateChallengesFacedInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    findAllChallengesFaced(): Promise<ChallengesFaced[]>;
    findOneChallengeFaced(challengeFacedId: number): Promise<ChallengesFaced>;
    findChallengeFacedByFarmerId(farmerId: number): Promise<ChallengesFaced[]>;
    updateChallengesFaced(updateChallengesFacedInput: UpdateChallengesFacedInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    removeChallengesFaced(challengeFacedId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    toggleActiveStatusChallenge(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    getDifficultyReportDistrictWise(districtId: number, difficultyId: number): Promise<ChallengesFaced[]>;
}
