"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChallengesFacedResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const challenges_faced_service_1 = require("./challenges-faced.service");
const challenges_faced_entity_1 = require("./entities/challenges-faced.entity");
const create_challenges_faced_input_1 = require("./dto/create-challenges-faced.input");
const update_challenges_faced_input_1 = require("./dto/update-challenges-faced.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const challenges_faced_return_type_1 = require("./types/challenges-faced-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const challenges_faced_type_1 = require("./types/challenges-faced.type");
let ChallengesFacedResolver = class ChallengesFacedResolver {
    constructor(challengesFacedService) {
        this.challengesFacedService = challengesFacedService;
    }
    createChallengesFaced(createChallengesFacedInput, user) {
        return this.challengesFacedService.create(createChallengesFacedInput, user);
    }
    findAllChallengesFaced() {
        return this.challengesFacedService.findAll();
    }
    findOneChallengeFaced(challengeFacedId) {
        return this.challengesFacedService.findOne(challengeFacedId);
    }
    findChallengeFacedByFarmerId(farmerId) {
        return this.challengesFacedService.findOneByFarmerId(farmerId);
    }
    updateChallengesFaced(updateChallengesFacedInput, user) {
        return this.challengesFacedService.update(updateChallengesFacedInput.challengeFacedId, updateChallengesFacedInput, user);
    }
    removeChallengesFaced(challengeFacedId) {
        return this.challengesFacedService.remove(challengeFacedId);
    }
    toggleActiveStatusChallenge(id) {
        return this.challengesFacedService.toggleActiveStatus(id);
    }
    getDifficultyReportDistrictWise(districtId, difficultyId) {
        return this.challengesFacedService.getDifficultyReportDistrictWise(districtId, difficultyId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => challenges_faced_return_type_1.ChallengesFacedReturnType),
    __param(0, (0, graphql_1.Args)('createChallengesFacedInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_challenges_faced_input_1.CreateChallengesFacedInput, Object]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "createChallengesFaced", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [challenges_faced_type_1.ChallengesFacedType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "findAllChallengesFaced", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => challenges_faced_type_1.ChallengesFacedType),
    __param(0, (0, graphql_1.Args)('challengeFacedId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "findOneChallengeFaced", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [challenges_faced_type_1.ChallengesFacedType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "findChallengeFacedByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => challenges_faced_return_type_1.ChallengesFacedReturnType),
    __param(0, (0, graphql_1.Args)('updateChallengesFacedInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_challenges_faced_input_1.UpdateChallengesFacedInput, Object]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "updateChallengesFaced", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => challenges_faced_return_type_1.ChallengesFacedReturnType),
    __param(0, (0, graphql_1.Args)('challengeFacedId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "removeChallengesFaced", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.PIGBONDHU, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => challenges_faced_return_type_1.ChallengesFacedReturnType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "toggleActiveStatusChallenge", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [challenges_faced_type_1.ChallengesFacedType]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int, nullable: true })),
    __param(1, (0, graphql_1.Args)('difficultyId', { type: () => graphql_1.Int, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", void 0)
], ChallengesFacedResolver.prototype, "getDifficultyReportDistrictWise", null);
ChallengesFacedResolver = __decorate([
    (0, graphql_1.Resolver)(() => challenges_faced_entity_1.ChallengesFaced),
    __metadata("design:paramtypes", [challenges_faced_service_1.ChallengesFacedService])
], ChallengesFacedResolver);
exports.ChallengesFacedResolver = ChallengesFacedResolver;
