import { DifficultiesTableService } from 'src/difficulties-table/difficulties-table.service';
import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { Repository } from 'typeorm';
import { CreateChallengesFacedInput } from './dto/create-challenges-faced.input';
import { UpdateChallengesFacedInput } from './dto/update-challenges-faced.input';
import { ChallengesFaced } from './entities/challenges-faced.entity';
export declare class ChallengesFacedService {
    private readonly challengesFacedRepository;
    private readonly difficultiesTableService;
    private readonly farmersTableService;
    constructor(challengesFacedRepository: Repository<ChallengesFaced>, difficultiesTableService: DifficultiesTableService, farmersTableService: FarmersTableService);
    create(createChallengesFacedInput: CreateChallengesFacedInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    checkIfExists(createChallengesFacedInput: CreateChallengesFacedInput): Promise<boolean>;
    findAll(): Promise<ChallengesFaced[]>;
    findOne(challengeFacedId: number): Promise<ChallengesFaced>;
    findByFarmerId(farmerId: number): Promise<ChallengesFaced[]>;
    findOneByFarmerId(farmerId: number): Promise<ChallengesFaced[]>;
    update(challengeFacedId: number, updateChallengesFacedInput: UpdateChallengesFacedInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    remove(challengeFacedId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    toggleActiveStatus(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: ChallengesFaced;
    }>;
    getDifficultyReportDistrictWise(districtId: number, difficultyId: number): Promise<ChallengesFaced[]>;
}
