import { ClientCategoryCollectionService } from './client-category-collection.service';
import { ClientCategoryCollection } from './entities/client-category-collection.entity';
import { CreateClientCategoryCollectionInput } from './input/create-client-category-collection.input';
import { UpdateClientCategoryCollectionInput } from './input/update-client-category-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_CLIENT_CATEGORY_ADD = "NEW_CLIENT_CATEGORY_ADD";
export declare class ClientCategoryCollectionResolver {
    private readonly clientCategoryCollectionService;
    private pubSub;
    constructor(clientCategoryCollectionService: ClientCategoryCollectionService, pubSub: RedisPubSub);
    createClientCategoryCollection(user: any, createClientCategoryCollectionInput: CreateClientCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ClientCategoryCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllClientCategory(): Promise<(ClientCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOne(id: number): string;
    updateClientCategoryCollection(updateClientCategoryCollectionInput: UpdateClientCategoryCollectionInput): Promise<any>;
    removeClientCategoryCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any[];
    }>;
    clientCategorySubscription(): AsyncIterator<unknown, any, undefined>;
}
