"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientCategoryCollectionResolver = exports.NEW_CLIENT_CATEGORY_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const client_category_collection_service_1 = require("./client-category-collection.service");
const client_category_collection_entity_1 = require("./entities/client-category-collection.entity");
const create_client_category_collection_input_1 = require("./input/create-client-category-collection.input");
const update_client_category_collection_input_1 = require("./input/update-client-category-collection.input");
const client_category_collection_create_type_1 = require("./types/client-category-collection-create.type");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const client_category_collection_type_1 = require("./types/client-category-collection.type");
const new_product_category_type_1 = require("../product-category-collection/types/new-product-category.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_CLIENT_CATEGORY_ADD = "NEW_CLIENT_CATEGORY_ADD";
let ClientCategoryCollectionResolver = class ClientCategoryCollectionResolver {
    constructor(clientCategoryCollectionService, pubSub) {
        this.clientCategoryCollectionService = clientCategoryCollectionService;
        this.pubSub = pubSub;
    }
    createClientCategoryCollection(user, createClientCategoryCollectionInput) {
        return this.clientCategoryCollectionService.create(createClientCategoryCollectionInput);
    }
    findAllClientCategory() {
        return this.clientCategoryCollectionService.findAll();
    }
    findOne(id) {
        return this.clientCategoryCollectionService.findOne(id);
    }
    updateClientCategoryCollection(updateClientCategoryCollectionInput) {
        return this.clientCategoryCollectionService.update(updateClientCategoryCollectionInput.id, updateClientCategoryCollectionInput);
    }
    removeClientCategoryCollection(id) {
        return this.clientCategoryCollectionService.remove(id);
    }
    clientCategorySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_CLIENT_CATEGORY_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_category_collection_create_type_1.ClientCategoryCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createClientCategoryCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_client_category_collection_input_1.CreateClientCategoryCollectionInput]),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "createClientCategoryCollection", null);
__decorate([
    (0, graphql_1.Query)(() => [client_category_collection_type_1.ClientCategoryCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "findAllClientCategory", null);
__decorate([
    (0, graphql_1.Query)(() => client_category_collection_type_1.ClientCategoryCollectionType, { name: 'clientCategoryCollection' }),
    __param(0, (0, graphql_1.Args)('id', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_category_collection_create_type_1.ClientCategoryCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateClientCategoryCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_client_category_collection_input_1.UpdateClientCategoryCollectionInput]),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "updateClientCategoryCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_category_collection_create_type_1.ClientCategoryCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "removeClientCategoryCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, graphql_1.Subscription)(() => new_product_category_type_1.NewCategoryAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ClientCategoryCollectionResolver.prototype, "clientCategorySubscription", null);
ClientCategoryCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => client_category_collection_entity_1.ClientCategoryCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [client_category_collection_service_1.ClientCategoryCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ClientCategoryCollectionResolver);
exports.ClientCategoryCollectionResolver = ClientCategoryCollectionResolver;
