import { CreateClientCategoryCollectionInput } from './input/create-client-category-collection.input';
import { UpdateClientCategoryCollectionInput } from './input/update-client-category-collection.input';
import { ClientCategoryCollection, ClientCategoryDocument } from './entities/client-category-collection.entity';
import { Model } from 'mongoose';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_CLIENT_CATEGORY_ADD = "NEW_CLIENT_CATEGORY_ADD";
export declare class ClientCategoryCollectionService {
    private clientCategoryRepository;
    private pubSub;
    constructor(clientCategoryRepository: Model<ClientCategoryDocument>, pubSub: RedisPubSub);
    create(createClientCollectionDto: CreateClientCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ClientCategoryCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(categoryName: string): Promise<boolean>;
    findAll(): Promise<(ClientCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneById(id: string): Promise<ClientCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    findOne(id: number): string;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any[];
    }>;
    update(id: string, updateClientCategoryCollectionInput: UpdateClientCategoryCollectionInput): Promise<any>;
}
