"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientCategoryCollectionService = exports.NEW_CLIENT_CATEGORY_ADD = void 0;
const common_1 = require("@nestjs/common");
const client_category_collection_entity_1 = require("./entities/client-category-collection.entity");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_CLIENT_CATEGORY_ADD = "NEW_CLIENT_CATEGORY_ADD";
let ClientCategoryCollectionService = class ClientCategoryCollectionService {
    constructor(clientCategoryRepository, pubSub) {
        this.clientCategoryRepository = clientCategoryRepository;
        this.pubSub = pubSub;
    }
    async create(createClientCollectionDto) {
        let checkIfExists = await this.checkIfExists(createClientCollectionDto.categoryName);
        if (!checkIfExists) {
            let cm = new client_category_collection_entity_1.ClientCategoryCollection();
            cm.categoryName = createClientCollectionDto.categoryName;
            let c = await this.clientCategoryRepository.create(cm);
            this.pubSub.publish(exports.NEW_CLIENT_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(categoryName) {
        let r = await this.clientCategoryRepository.count({
            categoryName: categoryName
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.clientCategoryRepository.find().exec();
    }
    async findOneById(id) {
        return await this.clientCategoryRepository.findOne({ _id: id }).exec();
    }
    findOne(id) {
        return `This action returns a #${id} clientCollection`;
    }
    async remove(id) {
        await this.clientCategoryRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_CLIENT_CATEGORY_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: []
        };
    }
    async update(id, updateClientCategoryCollectionInput) {
        let cc = await this.clientCategoryRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.categoryName = updateClientCategoryCollectionInput.categoryName;
            let cc1 = await this.clientCategoryRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_CLIENT_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
ClientCategoryCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(client_category_collection_entity_1.ClientCategoryCollection.name)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        graphql_redis_subscriptions_1.RedisPubSub])
], ClientCategoryCollectionService);
exports.ClientCategoryCollectionService = ClientCategoryCollectionService;
