/// <reference types="mongoose" />
import { HttpService } from '@nestjs/common';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ClientCollection } from './entities/client-collection.entity';
import { ClientCollectionService } from './client-collection.service';
import { BillingAddressInput, CreateClientCollectionInput } from './input/create-client-collection.input';
import { UpdateClientCollectionInput } from './input/update-client-collection.input';
import { CreateSignupInput } from './input/signup.input';
import { ClientPaginationType } from './types/client-pagination.type';
export declare const NEW_CLIENT_ADD = "NEW_CLIENT_ADD";
export declare class ClientCollectionResolver {
    private readonly clientCollectionService;
    private pubSub;
    private httpservice;
    private queryString;
    constructor(clientCollectionService: ClientCollectionService, pubSub: RedisPubSub, httpservice: HttpService, queryString: any);
    createClientCollection(user: any, createClientCollectionInput: CreateClientCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    signup(createSignupInput: CreateSignupInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    findAllClient(limit: number, page: number, search?: string): Promise<ClientPaginationType>;
    findOneClient(id: string): Promise<import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    updateOrAddAddress(id: string, edit: boolean, index: number, billingAddress: BillingAddressInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    deleteBillingAddress(id: string, index: number): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    updateClientCollection(updateClientCollectionInput: UpdateClientCollectionInput): Promise<any>;
    removeClientCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    clientSubscription(): AsyncIterator<unknown, any, undefined>;
}
