"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientCollectionResolver = exports.NEW_CLIENT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const client_collection_entity_1 = require("./entities/client-collection.entity");
const client_collection_create_type_1 = require("./types/client-collection-create.type");
const client_collection_service_1 = require("./client-collection.service");
const create_client_collection_input_1 = require("./input/create-client-collection.input");
const update_client_collection_input_1 = require("./input/update-client-collection.input");
const client_collection_type_1 = require("./types/client-collection.type");
const signup_create_type_1 = require("./types/signup-create.type");
const signup_input_1 = require("./input/signup.input");
const client_pagination_type_1 = require("./types/client-pagination.type");
exports.NEW_CLIENT_ADD = 'NEW_CLIENT_ADD';
let ClientCollectionResolver = class ClientCollectionResolver {
    constructor(clientCollectionService, pubSub, httpservice, queryString) {
        this.clientCollectionService = clientCollectionService;
        this.pubSub = pubSub;
        this.httpservice = httpservice;
        this.queryString = queryString;
    }
    createClientCollection(user, createClientCollectionInput) {
        return this.clientCollectionService.create(createClientCollectionInput);
    }
    async signup(createSignupInput) {
        let d = {
            secret: GlobalConstants_1.GOOGLE_CAP,
            response: createSignupInput.cap,
        };
        let dataStr = this.queryString.stringify(d);
        let res = await this.httpservice
            .post(GlobalConstants_1.SMS_POST_TO_GOOGLE, dataStr)
            .toPromise();
        if (res.data.success) {
            return this.clientCollectionService.signup(createSignupInput);
        }
        else {
            return {
                status: false,
                status_text: 'Re-captcha Value not found',
                data: null,
            };
        }
    }
    async findAllClient(limit, page, search) {
        const result = await this.clientCollectionService.findAll(limit, page, search);
        return {
            data: result.result,
            page: result.page,
            totalCount: result.count,
        };
    }
    findOneClient(id) {
        return this.clientCollectionService.findOneById(id);
    }
    updateOrAddAddress(id, edit, index, billingAddress) {
        return this.clientCollectionService.updateOrAddAddress(id, billingAddress, edit, index);
    }
    deleteBillingAddress(id, index) {
        return this.clientCollectionService.deleteBillingAddress(id, index);
    }
    updateClientCollection(updateClientCollectionInput) {
        return this.clientCollectionService.update(updateClientCollectionInput.id, updateClientCollectionInput);
    }
    removeClientCollection(id) {
        return this.clientCollectionService.remove(id);
    }
    clientSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_CLIENT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_collection_create_type_1.ClientCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createClientCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_client_collection_input_1.CreateClientCollectionInput]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "createClientCollection", null);
__decorate([
    (0, graphql_1.Mutation)(() => signup_create_type_1.SignupCreateType),
    __param(0, (0, graphql_1.Args)('createSignupInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [signup_input_1.CreateSignupInput]),
    __metadata("design:returntype", Promise)
], ClientCollectionResolver.prototype, "signup", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => client_pagination_type_1.ClientPaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('search')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String]),
    __metadata("design:returntype", Promise)
], ClientCollectionResolver.prototype, "findAllClient", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => client_collection_type_1.ClientCollectionType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "findOneClient", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_collection_create_type_1.ClientCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id')),
    __param(1, (0, graphql_1.Args)('edit')),
    __param(2, (0, graphql_1.Args)('index')),
    __param(3, (0, graphql_1.Args)('billingAddress')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Boolean, Number, create_client_collection_input_1.BillingAddressInput]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "updateOrAddAddress", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_collection_create_type_1.ClientCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id')),
    __param(1, (0, graphql_1.Args)('index')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Number]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "deleteBillingAddress", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_collection_create_type_1.ClientCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateClientCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_client_collection_input_1.UpdateClientCollectionInput]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "updateClientCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => client_collection_create_type_1.ClientCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ClientCollectionResolver.prototype, "removeClientCollection", null);
ClientCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => client_collection_entity_1.ClientCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(3, (0, common_1.Inject)(GlobalConstants_1.QUERY_STRING)),
    __metadata("design:paramtypes", [client_collection_service_1.ClientCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub,
        common_1.HttpService, Object])
], ClientCollectionResolver);
exports.ClientCollectionResolver = ClientCollectionResolver;
