import { Model } from 'mongoose';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ClientCollection } from './entities/client-collection.entity';
import { ClientCategoryCollectionService } from 'src/client-category-collection/client-category-collection.service';
import { BillingAddressInput, CreateClientCollectionInput } from './input/create-client-collection.input';
import { UpdateClientCollectionInput } from './input/update-client-collection.input';
import { CreateSignupInput } from './input/signup.input';
import { MailService } from 'src/mail/mail.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { AuthenticationCollectionService } from 'src/authentication-collection/authentication-collection.service';
export declare const NEW_CLIENT_ADD = "NEW_CLIENT_ADD";
export declare class ClientCollectionService {
    private clientRepository;
    private readonly clientCategoryService;
    private pubSub;
    private mailService;
    private userCollectionService;
    private authenticationCollectionService;
    constructor(clientRepository: Model<ClientCollection>, clientCategoryService: ClientCategoryCollectionService, pubSub: RedisPubSub, mailService: MailService, userCollectionService: UserCollectionService, authenticationCollectionService: AuthenticationCollectionService);
    create(createClientCollectionInput: CreateClientCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    signup(createSignupInput: CreateSignupInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    checkIfExists(dlNumber: string): Promise<boolean>;
    markAsEmailVerified(email: string): Promise<boolean>;
    checkIfExistsEmail(email: string): Promise<boolean>;
    findAll(limit: number, page: number, search?: string): Promise<{
        result: (import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        })[];
        count: number;
        page: number;
    }>;
    findOneById(id: string): Promise<import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    findOneUsersById(id: string): Promise<void>;
    updateOrAddAddress(id: string, billingAddress: BillingAddressInput, edit: boolean, index: number): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    deleteBillingAddress(id: string, index: number): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ClientCollection> & ClientCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateClientCollectionInput: UpdateClientCollectionInput): Promise<any>;
}
