import { ObjectID } from "typeorm";
import * as mongoose from 'mongoose';
import { ClientCategoryCollection } from "src/client-category-collection/entities/client-category-collection.entity";
export declare type ClientDocument = ClientCollection & Document;
export declare class BillingAddress {
    contactPerson: string;
    addressLine1: string;
    addressLine2: string;
    city: string;
    district: string;
    postOffice: string;
    pin: string;
    state: string;
    gstin: string;
    email: string;
    phone: string;
    dlNumber: string;
}
export declare class ClientCollection {
    _id: ObjectID;
    organizationName: string;
    contactPerson: string;
    email: string;
    phone: string;
    dlNumber: string;
    discountPercentage: string;
    markupPercentage: string;
    BillingAddress: BillingAddress[];
    isEmailVerified: boolean;
    ClientCategory: ClientCategoryCollection;
}
declare const ClientCollectionSchema: mongoose.Schema<mongoose.Document<ClientCollection, any, any>, mongoose.Model<mongoose.Document<ClientCollection, any, any>, any, any, any>, any, any>;
export { ClientCollectionSchema };
