import { Model } from 'mongoose';
import { AppGateway } from 'src/app.gateway';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CreateClientSocketCollectionDto } from './dto/create-client-socket-collection.dto';
import { ClientSocketCollection, ClientSocketDocument } from './entities/client-socket-collection.entity';
export declare class ClientSocketCollectionService {
    private clientSocketRepository;
    private appGatewayService;
    private readonly userCollectionService;
    constructor(clientSocketRepository: Model<ClientSocketDocument>, appGatewayService: AppGateway, userCollectionService: UserCollectionService);
    create(createClientSocketCollectionDto: CreateClientSocketCollectionDto): Promise<{
        status: boolean;
        data: ClientSocketCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(username: string): Promise<boolean>;
    findAll(): Promise<(ClientSocketCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    emitToAdminOnly(count: number): Promise<{
        count: number;
    }>;
    findOneBySocket(socket: string): Promise<ClientSocketCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    findByUsernameAndSend(username: string, type: string, data: any): Promise<boolean>;
    findByUsername(username: string): Promise<(ClientSocketCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    remove(socket: string): Promise<boolean>;
}
