"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientSocketCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const app_gateway_1 = require("../app.gateway");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const client_socket_collection_entity_1 = require("./entities/client-socket-collection.entity");
let ClientSocketCollectionService = class ClientSocketCollectionService {
    constructor(clientSocketRepository, appGatewayService, userCollectionService) {
        this.clientSocketRepository = clientSocketRepository;
        this.appGatewayService = appGatewayService;
        this.userCollectionService = userCollectionService;
    }
    async create(createClientSocketCollectionDto) {
        if (createClientSocketCollectionDto.socket != '') {
            let checkIfExists = await this.checkIfExists(createClientSocketCollectionDto.username);
            if (!checkIfExists) {
                let sc = new client_socket_collection_entity_1.ClientSocketCollection();
                sc.username = createClientSocketCollectionDto.username;
                sc.socket = createClientSocketCollectionDto.socket;
                let r = await this.clientSocketRepository.create(sc);
                return {
                    status: true,
                    data: r,
                };
            }
            else {
                let sc = await this.clientSocketRepository.findOne({
                    username: createClientSocketCollectionDto.username,
                });
                sc.socket = createClientSocketCollectionDto.socket;
                await this.clientSocketRepository.create(sc);
                return {
                    status: true,
                    data: sc,
                };
            }
        }
        else {
            return {
                status: false,
                data: null,
            };
        }
    }
    async checkIfExists(username) {
        let cc = await this.clientSocketRepository.count({
            username,
        }).exec();
        if (cc == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        let r = await this.clientSocketRepository.find().exec();
        return r;
    }
    async emitToAdminOnly(count) {
        let admins = await this.userCollectionService.findAllAdmin();
        admins.map(async (el, index) => {
            let sockets = await this.clientSocketRepository.find({
                username: el.username,
            }).exec();
            sockets.map((el) => {
                this.appGatewayService.emitToClient(el.socket, 'total-instance-count', count);
            });
        });
        return { count: count };
    }
    async findOneBySocket(socket) {
        let r = await this.clientSocketRepository.findOne({
            socket: socket
        }).exec();
        return r;
    }
    async findByUsernameAndSend(username, type, data) {
        let r = await this.clientSocketRepository.find({
            username: username
        }).exec();
        r.forEach((el, index) => {
            this.appGatewayService.emitToClient(el.socket, type, data);
        });
        return true;
    }
    async findByUsername(username) {
        let r = await this.clientSocketRepository.find({
            username: username
        }).exec();
        return r;
    }
    async remove(socket) {
        let r = await this.clientSocketRepository.deleteOne({ socket });
        return true;
    }
};
ClientSocketCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(client_socket_collection_entity_1.ClientSocketCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => app_gateway_1.AppGateway))),
    __metadata("design:paramtypes", [mongoose_2.Model,
        app_gateway_1.AppGateway,
        user_collection_service_1.UserCollectionService])
], ClientSocketCollectionService);
exports.ClientSocketCollectionService = ClientSocketCollectionService;
