import { CollectionTableService } from './collection-table.service';
import { CollectionTable } from './entities/collection-table.entity';
import { CreateCollectionTableInput } from './dto/create-collection-table.input';
import { UpdateCollectionTableInput } from './dto/update-collection-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const DASHBOARD_COUNT_CHANGE = "DASHBOARD_COUNT_CHANGE";
export declare class CollectionTableResolver {
    private readonly collectionTableService;
    private pubSub;
    constructor(collectionTableService: CollectionTableService, pubSub: RedisPubSub);
    createCollectionTable(createCollectionTableInput: CreateCollectionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findMonthData(username: string, month?: string): Promise<{
        status: boolean;
        data: string;
    }>;
    findDashboardCount(user: any): Promise<{
        totalCollection: string;
        totalCollectionByMe: string;
    }>;
    getReportsByMonth(startDate: string, endDate: string, type: string): Promise<{
        status: boolean;
        data: any[];
        html: string;
    }>;
    getReportsByMonthOfUser(startDate: string, endDate: string, type: string): Promise<{
        status: boolean;
        data: CollectionTable[];
        html: string;
    }>;
    getReportsOfUserByDate(startDate: string, endDate: string, username: string): Promise<{
        status: boolean;
        data: CollectionTable[];
        html: string;
    }>;
    findOne(collectionId: number): string;
    updateCollectionTable(updateCollectionTableInput: UpdateCollectionTableInput): string;
    removeCollectionTable(id: number): string;
    dashboardCountSubscription(): AsyncIterator<unknown, any, undefined>;
}
