"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectionTableResolver = exports.DASHBOARD_COUNT_CHANGE = void 0;
const graphql_1 = require("@nestjs/graphql");
const collection_table_service_1 = require("./collection-table.service");
const collection_table_entity_1 = require("./entities/collection-table.entity");
const create_collection_table_input_1 = require("./dto/create-collection-table.input");
const update_collection_table_input_1 = require("./dto/update-collection-table.input");
const collection_table_type_1 = require("./types/collection-table-type");
const collection_table_return_type_1 = require("./types/collection-table-return.type");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const role_enum_1 = require("../user-collection/roles/role.enum");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const collection_table_return_calendar_type_1 = require("./types/collection-table-return-calendar.type");
const collection_table_report_type_1 = require("./types/collection-table-report.type");
const collection_table_report_user_type_1 = require("./types/collection-table-report-user.type");
const dashboard_collection_type_1 = require("./types/dashboard-collection-type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const dashboard_count_change_type_1 = require("./types/dashboard-count-change.type");
exports.DASHBOARD_COUNT_CHANGE = "DASHBOARD_COUNT_CHANGE";
let CollectionTableResolver = class CollectionTableResolver {
    constructor(collectionTableService, pubSub) {
        this.collectionTableService = collectionTableService;
        this.pubSub = pubSub;
    }
    createCollectionTable(createCollectionTableInput, user) {
        return this.collectionTableService.create(createCollectionTableInput, user.username);
    }
    findMonthData(username, month) {
        return this.collectionTableService.findAllCollectionOfUserByMonth(username, month);
    }
    findDashboardCount(user) {
        return this.collectionTableService.findDashboardCount(user.username);
    }
    getReportsByMonth(startDate, endDate, type) {
        return this.collectionTableService.getReportsByMonth(startDate, endDate, type);
    }
    getReportsByMonthOfUser(startDate, endDate, type) {
        return this.collectionTableService.getReportsByMonthOfUser(startDate, endDate, type);
    }
    getReportsOfUserByDate(startDate, endDate, username) {
        return this.collectionTableService.getReportsOfUserByDate(startDate, endDate, username);
    }
    findOne(collectionId) {
        return this.collectionTableService.findOne(collectionId);
    }
    updateCollectionTable(updateCollectionTableInput) {
        return this.collectionTableService.update(updateCollectionTableInput.collectionId, updateCollectionTableInput);
    }
    removeCollectionTable(id) {
        return this.collectionTableService.remove(id);
    }
    dashboardCountSubscription() {
        return this.pubSub.asyncIterator(exports.DASHBOARD_COUNT_CHANGE);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => collection_table_return_type_1.CollectionTableReturnType),
    __param(0, (0, graphql_1.Args)('createCollectionTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_collection_table_input_1.CreateCollectionTableInput, Object]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "createCollectionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => collection_table_return_calendar_type_1.CollectionTableReturnCalendarType),
    __param(0, (0, graphql_1.Args)("username")),
    __param(1, (0, graphql_1.Args)("month")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "findMonthData", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => dashboard_collection_type_1.DashboardCollectionType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "findDashboardCount", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => collection_table_report_type_1.CollectionTableReportType),
    __param(0, (0, graphql_1.Args)("startDate")),
    __param(1, (0, graphql_1.Args)("endDate")),
    __param(2, (0, graphql_1.Args)("type")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "getReportsByMonth", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => collection_table_report_user_type_1.CollectionTableReportUserType),
    __param(0, (0, graphql_1.Args)("startDate")),
    __param(1, (0, graphql_1.Args)("endDate")),
    __param(2, (0, graphql_1.Args)("type")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "getReportsByMonthOfUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.COLLECTOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => collection_table_report_user_type_1.CollectionTableReportUserType),
    __param(0, (0, graphql_1.Args)("startDate")),
    __param(1, (0, graphql_1.Args)("endDate")),
    __param(2, (0, graphql_1.Args)("username")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "getReportsOfUserByDate", null);
__decorate([
    (0, graphql_1.Query)(() => collection_table_type_1.CollectionTableType),
    __param(0, (0, graphql_1.Args)('collectionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "findOne", null);
__decorate([
    (0, graphql_1.Mutation)(() => collection_table_return_type_1.CollectionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateCollectionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_collection_table_input_1.UpdateCollectionTableInput]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "updateCollectionTable", null);
__decorate([
    (0, graphql_1.Mutation)(() => collection_table_return_type_1.CollectionTableReturnType),
    __param(0, (0, graphql_1.Args)('id', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "removeCollectionTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => dashboard_count_change_type_1.DashboardCountChangeType, {
        resolve: (payload) => {
            return {
                countChanged: payload
            };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CollectionTableResolver.prototype, "dashboardCountSubscription", null);
CollectionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => collection_table_entity_1.CollectionTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [collection_table_service_1.CollectionTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CollectionTableResolver);
exports.CollectionTableResolver = CollectionTableResolver;
