import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Connection, Repository } from 'typeorm';
import { CreateCollectionTableInput } from './dto/create-collection-table.input';
import { UpdateCollectionTableInput } from './dto/update-collection-table.input';
import { CollectionTable } from './entities/collection-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const DASHBOARD_COUNT_CHANGE = "DASHBOARD_COUNT_CHANGE";
export declare class CollectionTableService {
    private readonly collectionTableRepository;
    private readonly userCollectionService;
    private pubSub;
    private connection;
    constructor(collectionTableRepository: Repository<CollectionTable>, userCollectionService: UserCollectionService, pubSub: RedisPubSub, connection: Connection);
    create(createCollectionTableInput: CreateCollectionTableInput, username: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    ifExists(createCollectionTableInput: CreateCollectionTableInput, date: string): Promise<boolean>;
    checkIfAlreadyExistsMonthly(queryRunner: any, user: UserTable, month: string, amount: string, collectionType: string, startOfMonth: string, endOfMonth: string): Promise<boolean>;
    findAllCollectionOfUserByMonth(username: string, month: string): Promise<{
        status: boolean;
        data: string;
    }>;
    enumerateDaysBetweenDates(startDate: string, endDate: string): any[];
    getReportsByMonth(startDate: string, endDate: string, type: string): Promise<{
        status: boolean;
        data: any[];
        html: string;
    }>;
    getReportsByMonthOfUser(startDate: string, endDate: string, type: string): Promise<{
        status: boolean;
        data: CollectionTable[];
        html: string;
    }>;
    getReportsOfUserByDate(startDate: string, endDate: string, username: string): Promise<{
        status: boolean;
        data: CollectionTable[];
        html: string;
    }>;
    findDashboardCount(username: string): Promise<{
        totalCollection: string;
        totalCollectionByMe: string;
    }>;
    findAll(): string;
    findOne(collectionId: number): string;
    update(collectionId: number, updateCollectionTableInput: UpdateCollectionTableInput): string;
    remove(collectionId: number): string;
}
