import { CommunityCadreTableService } from './community-cadre-table.service';
import { CommunityCadreTable } from './entities/community-cadre-table.entity';
import { CreateCommunityCadreTableInput } from './dto/create-community-cadre-table.input';
import { UpdateCommunityCadreTableInput } from './dto/update-community-cadre-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_COMMUNITY_CADRE_ADD = "NEW_COMMUNITY_CADRE_ADD";
export declare class CommunityCadreTableResolver {
    private readonly communityCadreTableService;
    private pubSub;
    constructor(communityCadreTableService: CommunityCadreTableService, pubSub: RedisPubSub);
    createCommunityCadreTable(createCommunityCadreTableInput: CreateCommunityCadreTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CommunityCadreTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllCommunityCadre(): Promise<CommunityCadreTable[]>;
    findOneCommunityCadre(communityCadreId: number): Promise<CommunityCadreTable>;
    updateCommunityCadreTable(updateCommunityCadreTableInput: UpdateCommunityCadreTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CommunityCadreTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeCommunityCadreTable(communityCadreId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    communityCadreSubscription(): AsyncIterator<unknown, any, undefined>;
}
