"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommunityCadreTableResolver = exports.NEW_COMMUNITY_CADRE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const community_cadre_table_service_1 = require("./community-cadre-table.service");
const community_cadre_table_entity_1 = require("./entities/community-cadre-table.entity");
const create_community_cadre_table_input_1 = require("./dto/create-community-cadre-table.input");
const update_community_cadre_table_input_1 = require("./dto/update-community-cadre-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const community_cadre_return_type_1 = require("./types/community-cadre-return.type");
const community_cadre_type_1 = require("./types/community-cadre.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_COMMUNITY_CADRE_ADD = "NEW_COMMUNITY_CADRE_ADD";
let CommunityCadreTableResolver = exports.CommunityCadreTableResolver = class CommunityCadreTableResolver {
    constructor(communityCadreTableService, pubSub) {
        this.communityCadreTableService = communityCadreTableService;
        this.pubSub = pubSub;
    }
    createCommunityCadreTable(createCommunityCadreTableInput) {
        return this.communityCadreTableService.create(createCommunityCadreTableInput);
    }
    findAllCommunityCadre() {
        return this.communityCadreTableService.findAll();
    }
    findOneCommunityCadre(communityCadreId) {
        return this.communityCadreTableService.findOne(communityCadreId);
    }
    updateCommunityCadreTable(updateCommunityCadreTableInput) {
        return this.communityCadreTableService.update(updateCommunityCadreTableInput.communityCadreId, updateCommunityCadreTableInput);
    }
    removeCommunityCadreTable(communityCadreId) {
        return this.communityCadreTableService.remove(communityCadreId);
    }
    communityCadreSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_COMMUNITY_CADRE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => community_cadre_return_type_1.CommunityCadreReturnType),
    __param(0, (0, graphql_1.Args)('createCommunityCadreTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_community_cadre_table_input_1.CreateCommunityCadreTableInput]),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "createCommunityCadreTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [community_cadre_type_1.CommunityCadreType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "findAllCommunityCadre", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => community_cadre_type_1.CommunityCadreType, { name: 'communityCadreTable' }),
    __param(0, (0, graphql_1.Args)('communityCadreId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "findOneCommunityCadre", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => community_cadre_return_type_1.CommunityCadreReturnType),
    __param(0, (0, graphql_1.Args)('updateCommunityCadreTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_community_cadre_table_input_1.UpdateCommunityCadreTableInput]),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "updateCommunityCadreTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => community_cadre_return_type_1.CommunityCadreReturnType),
    __param(0, (0, graphql_1.Args)('communityCadreId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "removeCommunityCadreTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CommunityCadreTableResolver.prototype, "communityCadreSubscription", null);
exports.CommunityCadreTableResolver = CommunityCadreTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => community_cadre_table_entity_1.CommunityCadreTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [community_cadre_table_service_1.CommunityCadreTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CommunityCadreTableResolver);
