import { CreateCommunityCadreTableInput } from './dto/create-community-cadre-table.input';
import { UpdateCommunityCadreTableInput } from './dto/update-community-cadre-table.input';
import { CommunityCadreTable } from './entities/community-cadre-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare const NEW_COMMUNITY_CADRE_ADD = "NEW_COMMUNITY_CADRE_ADD";
export declare class CommunityCadreTableService {
    private readonly communityCadreTableRepository;
    private readonly userCollectionService;
    private pubSub;
    constructor(communityCadreTableRepository: Repository<CommunityCadreTable>, userCollectionService: UserCollectionService, pubSub: RedisPubSub);
    create(createCommunityCadreTableInput: CreateCommunityCadreTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CommunityCadreTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createCommunityCadreTableInput: CreateCommunityCadreTableInput): Promise<number>;
    findAll(): Promise<CommunityCadreTable[]>;
    findOne(communityCadreId: number): Promise<CommunityCadreTable>;
    update(communityCadreId: number, updateCommunityCadreTableInput: UpdateCommunityCadreTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CommunityCadreTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(communityCadreId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
