"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommunityCadreTableService = exports.NEW_COMMUNITY_CADRE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const community_cadre_table_entity_1 = require("./entities/community-cadre-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const user_collection_service_1 = require("../user-collection/user-collection.service");
exports.NEW_COMMUNITY_CADRE_ADD = "NEW_COMMUNITY_CADRE_ADD";
let CommunityCadreTableService = exports.CommunityCadreTableService = class CommunityCadreTableService {
    constructor(communityCadreTableRepository, userCollectionService, pubSub) {
        this.communityCadreTableRepository = communityCadreTableRepository;
        this.userCollectionService = userCollectionService;
        this.pubSub = pubSub;
    }
    async create(createCommunityCadreTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createCommunityCadreTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new community_cadre_table_entity_1.CommunityCadreTable();
            st.communityCadreName = createCommunityCadreTableInput.communityCadreName;
            st.type = createCommunityCadreTableInput.type;
            st.gender = createCommunityCadreTableInput.gender;
            st.qualification = createCommunityCadreTableInput.qualification;
            st.age = createCommunityCadreTableInput.age;
            st.phone = createCommunityCadreTableInput.phone;
            st.alternatePhone = createCommunityCadreTableInput.alternatePhone;
            st.address = createCommunityCadreTableInput.address;
            st.bankAccountNo = createCommunityCadreTableInput.bankAccountNo;
            st.bankName = createCommunityCadreTableInput.bankName;
            st.bankBranch = createCommunityCadreTableInput.bankBranch;
            st.bankIfsc = createCommunityCadreTableInput.bankIfsc;
            let user = await this.userCollectionService.findOne(createCommunityCadreTableInput.userId);
            st.UserTable = user;
            let result = await this.communityCadreTableRepository.save(st);
            this.pubSub.publish(exports.NEW_COMMUNITY_CADRE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createCommunityCadreTableInput) {
        let result = await this.communityCadreTableRepository.count({
            where: {
                communityCadreName: createCommunityCadreTableInput.communityCadreName,
                type: createCommunityCadreTableInput.type,
                UserTable: {
                    id: createCommunityCadreTableInput.userId
                }
            }
        });
        return result;
    }
    async findAll() {
        return await this.communityCadreTableRepository.find({
            relations: {
                UserTable: true
            }
        });
    }
    async findOne(communityCadreId) {
        return await this.communityCadreTableRepository.findOne({
            where: {
                communityCadreId
            },
            relations: {
                UserTable: true
            }
        });
    }
    async update(communityCadreId, updateCommunityCadreTableInput) {
        let result = await this.findOne(communityCadreId);
        if (result) {
            result.communityCadreName = updateCommunityCadreTableInput.communityCadreName;
            result.type = updateCommunityCadreTableInput.type;
            result.gender = updateCommunityCadreTableInput.gender;
            result.qualification = updateCommunityCadreTableInput.qualification;
            result.age = updateCommunityCadreTableInput.age;
            result.phone = updateCommunityCadreTableInput.phone;
            result.alternatePhone = updateCommunityCadreTableInput.alternatePhone;
            result.address = updateCommunityCadreTableInput.address;
            result.bankAccountNo = updateCommunityCadreTableInput.bankAccountNo;
            result.bankName = updateCommunityCadreTableInput.bankName;
            result.bankBranch = updateCommunityCadreTableInput.bankBranch;
            result.bankIfsc = updateCommunityCadreTableInput.bankIfsc;
            let user = await this.userCollectionService.findOne(updateCommunityCadreTableInput.userId);
            result.UserTable = user;
            let updatedResult = await this.communityCadreTableRepository.save(result);
            this.pubSub.publish(exports.NEW_COMMUNITY_CADRE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(communityCadreId) {
        let result = await this.findOne(communityCadreId);
        if (result) {
            await this.communityCadreTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_COMMUNITY_CADRE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.CommunityCadreTableService = CommunityCadreTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(community_cadre_table_entity_1.CommunityCadreTable)),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        user_collection_service_1.UserCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CommunityCadreTableService);
