"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsumptionSubTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const consumption_sub_table_entity_1 = require("./entities/consumption-sub-table.entity");
const consumption_sub_table_service_1 = require("./consumption-sub-table.service");
const consumption_sub_table_type_1 = require("./types/consumption-sub-table.type");
const consumption_cluster_wise_type_1 = require("./types/consumption-cluster-wise.type");
const feeding_summary_report_type_1 = require("./types/feeding-summary-report.type");
let ConsumptionSubTableResolver = class ConsumptionSubTableResolver {
    constructor(consumptionSubTableService, pubSub) {
        this.consumptionSubTableService = consumptionSubTableService;
        this.pubSub = pubSub;
    }
    getFeedingDetailsOfOneAnimal(animalId) {
        return this.consumptionSubTableService.getFeedingDetailsOfOneAnimal(animalId);
    }
    countFeedingDetailsClusterWise(districtId, startingDate, endingDate) {
        return this.consumptionSubTableService.countFeedingDetailsClusterWise(districtId, startingDate, endingDate);
    }
    getFeedingDetailsDistrictWise() {
        return this.consumptionSubTableService.getFeedingDetailsDistrictWise();
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [consumption_sub_table_type_1.ConsumptionSubTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ConsumptionSubTableResolver.prototype, "getFeedingDetailsOfOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [consumption_cluster_wise_type_1.FeedingClusterWise]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('startingDate', { type: () => String })),
    __param(2, (0, graphql_1.Args)('endingDate', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String]),
    __metadata("design:returntype", void 0)
], ConsumptionSubTableResolver.prototype, "countFeedingDetailsClusterWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [feeding_summary_report_type_1.FeedingSummaryReport]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ConsumptionSubTableResolver.prototype, "getFeedingDetailsDistrictWise", null);
ConsumptionSubTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => consumption_sub_table_entity_1.ConsumptionSubTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [consumption_sub_table_service_1.ConsumptionSubTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ConsumptionSubTableResolver);
exports.ConsumptionSubTableResolver = ConsumptionSubTableResolver;
