import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { ConsumptionTableService } from 'src/consumption-table/consumption-table.service';
import { DistrictTableService } from 'src/district-table/district-table.service';
import { RationTableService } from 'src/ration-table/ration-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { Repository } from 'typeorm';
import { CreateConsumptionSubTableInput } from './dto/create-consumption-sub-table.input';
import { ConsumptionSubTable } from './entities/consumption-sub-table.entity';
export declare class ConsumptionSubTableService {
    private readonly consumptionSubTableRepository;
    private pubSub;
    private readonly consumptionTableService;
    private readonly rationTableService;
    private readonly animalEntryTableService;
    private readonly subDivisionTableService;
    private readonly districtTableService;
    constructor(consumptionSubTableRepository: Repository<ConsumptionSubTable>, pubSub: RedisPubSub, consumptionTableService: ConsumptionTableService, rationTableService: RationTableService, animalEntryTableService: AnimalEntryTableService, subDivisionTableService: SubDivisionTableService, districtTableService: DistrictTableService);
    create(consumptionId: number, createConsumptionTableInput: CreateConsumptionSubTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAll(): Promise<ConsumptionSubTable[]>;
    findOne(consumptionSubId: number): Promise<ConsumptionSubTable>;
    remove(consumptionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    countFeedingDetailsClusterWise(districtId: number, startingDate: string, endingDate: string): Promise<any[]>;
    getFeedingDetailsDistrictWise(): Promise<any>;
    getFeedingDetailsOfOneAnimal(animalId: number): Promise<ConsumptionSubTable[]>;
}
