import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ConsumptionTable } from './entities/consumption-table.entity';
import { ConsumptionTableService } from './consumption-table.service';
import { CreateConsumptionTableInput } from './dto/create-consumption-table.input';
export declare class ConsumptionTableResolver {
    private readonly consumptionTableService;
    private pubSub;
    constructor(consumptionTableService: ConsumptionTableService, pubSub: RedisPubSub);
    createConsumptionTable(createConsumptionTableInput: CreateConsumptionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ConsumptionTable;
    }>;
    findAllConsumption(): Promise<ConsumptionTable[]>;
    findOneConsumption(consumptionId: number): Promise<ConsumptionTable>;
    removeConsumptionTable(consumptionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findConsumptionByFarmerId(farmerId: number): Promise<ConsumptionTable[]>;
    findConsumptionByHousingd(housingId: number): Promise<ConsumptionTable[]>;
}
