"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsumptionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const consumption_table_entity_1 = require("./entities/consumption-table.entity");
const consumption_table_service_1 = require("./consumption-table.service");
const create_consumption_table_input_1 = require("./dto/create-consumption-table.input");
const consumption_table_return_type_1 = require("./types/consumption-table-return.type");
const consumption_table_type_1 = require("./types/consumption-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
let ConsumptionTableResolver = class ConsumptionTableResolver {
    constructor(consumptionTableService, pubSub) {
        this.consumptionTableService = consumptionTableService;
        this.pubSub = pubSub;
    }
    createConsumptionTable(createConsumptionTableInput, user) {
        return this.consumptionTableService.create(createConsumptionTableInput, user);
    }
    findAllConsumption() {
        return this.consumptionTableService.findAll();
    }
    findOneConsumption(consumptionId) {
        return this.consumptionTableService.findOneConsumption(consumptionId);
    }
    removeConsumptionTable(consumptionId, user) {
        return this.consumptionTableService.remove(consumptionId, user);
    }
    findConsumptionByFarmerId(farmerId) {
        return this.consumptionTableService.findConsumptionByFarmerId(farmerId);
    }
    findConsumptionByHousingd(housingId) {
        return this.consumptionTableService.findConsumptionByHousingId(housingId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => consumption_table_return_type_1.ConsumptionTableReturnType),
    __param(0, (0, graphql_1.Args)('createConsumptionTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_consumption_table_input_1.CreateConsumptionTableInput, Object]),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "createConsumptionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [consumption_table_type_1.ConsumptionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "findAllConsumption", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => consumption_table_type_1.ConsumptionTableType),
    __param(0, (0, graphql_1.Args)('consumptionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "findOneConsumption", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => consumption_table_return_type_1.ConsumptionTableReturnType),
    __param(0, (0, graphql_1.Args)('consumptionId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "removeConsumptionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [consumption_table_type_1.ConsumptionTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "findConsumptionByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [consumption_table_type_1.ConsumptionTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ConsumptionTableResolver.prototype, "findConsumptionByHousingd", null);
ConsumptionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => consumption_table_entity_1.ConsumptionTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [consumption_table_service_1.ConsumptionTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ConsumptionTableResolver);
exports.ConsumptionTableResolver = ConsumptionTableResolver;
