import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ConsumptionSubTableService } from 'src/consumption-sub-table/consumption-sub-table.service';
import { ConsumptionSubTotalTableService } from 'src/consumption-sub-total-table/consumption-sub-total-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { Repository } from 'typeorm';
import { CreateConsumptionTableInput } from './dto/create-consumption-table.input';
import { ConsumptionTable } from './entities/consumption-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class ConsumptionTableService {
    private readonly consumptionTableRepository;
    private readonly userCollectionService;
    private readonly dataEntryTableService;
    private pubSub;
    private readonly housingTableService;
    private readonly consumptionSubTableService;
    private readonly consumptionSubTotalTableService;
    private readonly subDivisionTableService;
    constructor(consumptionTableRepository: Repository<ConsumptionTable>, userCollectionService: UserCollectionService, dataEntryTableService: DataEntryTableService, pubSub: RedisPubSub, housingTableService: HousingTableService, consumptionSubTableService: ConsumptionSubTableService, consumptionSubTotalTableService: ConsumptionSubTotalTableService, subDivisionTableService: SubDivisionTableService);
    create(createConsumptionTableInput: CreateConsumptionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ConsumptionTable;
    }>;
    findAll(): Promise<ConsumptionTable[]>;
    findOne(consumptionId: number): Promise<ConsumptionTable>;
    findOneConsumption(consumptionId: number): Promise<ConsumptionTable>;
    findConsumptionByFarmerId(farmerId: number): Promise<ConsumptionTable[]>;
    findConsumptionByHousingId(housingId: number): Promise<ConsumptionTable[]>;
    remove(consumptionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
