"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseProgressionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const course_progression_table_service_1 = require("./course-progression-table.service");
const course_progression_table_entity_1 = require("./entities/course-progression-table.entity");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const common_1 = require("@nestjs/common");
const course_progression_table_return_type_1 = require("./types/course-progression-table-return.type");
const course_progression_table_type_1 = require("./types/course-progression-table.type");
let CourseProgressionTableResolver = exports.CourseProgressionTableResolver = class CourseProgressionTableResolver {
    constructor(courseProgressionTableService) {
        this.courseProgressionTableService = courseProgressionTableService;
    }
    updateCourseProgression(courseUnitId, type, user) {
        return this.courseProgressionTableService.updateCourseProgression(courseUnitId, type, user);
    }
    findAllCourseProgression(courseId) {
        return this.courseProgressionTableService.findAllCourseProgression(courseId);
    }
    toggleStatusOfTable(courseProgressionId, type, currentValue) {
        return this.courseProgressionTableService.toggleStatusOfTable(courseProgressionId, type, currentValue);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_progression_table_return_type_1.CourseProgressionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseUnitId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('type', { type: () => String })),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, Object]),
    __metadata("design:returntype", void 0)
], CourseProgressionTableResolver.prototype, "updateCourseProgression", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_progression_table_type_1.CourseProgressionTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseProgressionTableResolver.prototype, "findAllCourseProgression", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_progression_table_return_type_1.CourseProgressionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseProgressionId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('type', { type: () => String })),
    __param(2, (0, graphql_1.Args)('currentValue', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, Number]),
    __metadata("design:returntype", void 0)
], CourseProgressionTableResolver.prototype, "toggleStatusOfTable", null);
exports.CourseProgressionTableResolver = CourseProgressionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => course_progression_table_entity_1.CourseProgressionTable),
    __metadata("design:paramtypes", [course_progression_table_service_1.CourseProgressionTableService])
], CourseProgressionTableResolver);
