import { CourseProgressionTable } from './entities/course-progression-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { CourseUnitTableService } from 'src/course-unit-table/course-unit-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { AssessmentAnswerTableService } from 'src/assessment-answer-table/assessment-answer-table.service';
export declare class CourseProgressionTableService {
    private readonly courseProgressionTableRepository;
    private pubSub;
    private readonly courseUnitTableService;
    private readonly userCollectionService;
    private readonly assessmentAnswerTableService;
    constructor(courseProgressionTableRepository: Repository<CourseProgressionTable>, pubSub: RedisPubSub, courseUnitTableService: CourseUnitTableService, userCollectionService: UserCollectionService, assessmentAnswerTableService: AssessmentAnswerTableService);
    updateCourseProgression(courseUnitId: number, type: string, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getProgressionReport(courseUnitId: number, user: any): Promise<CourseProgressionTable>;
    checkIfAllowedForAssessment(courseUnitId: number, user: any): Promise<boolean>;
    getScoreForAssessment(courseUnitId: number, user: any): Promise<number | false>;
    updateCourseProgressionAssessment(courseUnitId: number, user: any, assesmentTaken: number, assesmentTakenOn: string, assesmentScore: number, assesmentStatus: number): Promise<boolean>;
    findAllCourseProgression(courseId: number): Promise<CourseProgressionTable[]>;
    toggleStatusOfTable(courseProgressionId: number, type: string, currentValue: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
