import { CourseSessionTableService } from './course-session-table.service';
import { CourseSessionTable } from './entities/course-session-table.entity';
import { CreateCourseSessionTableInput } from './dto/create-course-session-table.input';
import { UpdateCourseSessionTableInput } from './dto/update-course-session-table.input';
export declare class CourseSessionTableResolver {
    private readonly courseSessionTableService;
    constructor(courseSessionTableService: CourseSessionTableService);
    createCourseSessionTable(createCourseSessionTableInput: CreateCourseSessionTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllCourseSession(): Promise<CourseSessionTable[]>;
    findOneCourseSession(courseSessionId: number): Promise<CourseSessionTable>;
    findOneCourseSessionByCourseId(courseId: number): Promise<CourseSessionTable[]>;
    updateCourseSessionTable(updateCourseSessionTableInput: UpdateCourseSessionTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeCourseSessionTable(courseSessionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleStatusofCourseSession(courseSessionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseSessionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
