"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseSessionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const course_session_table_service_1 = require("./course-session-table.service");
const course_session_table_entity_1 = require("./entities/course-session-table.entity");
const create_course_session_table_input_1 = require("./dto/create-course-session-table.input");
const update_course_session_table_input_1 = require("./dto/update-course-session-table.input");
const course_session_table_return_type_1 = require("./types/course-session-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const course_session_table_type_1 = require("./types/course-session-table.type");
let CourseSessionTableResolver = exports.CourseSessionTableResolver = class CourseSessionTableResolver {
    constructor(courseSessionTableService) {
        this.courseSessionTableService = courseSessionTableService;
    }
    createCourseSessionTable(createCourseSessionTableInput) {
        return this.courseSessionTableService.create(createCourseSessionTableInput);
    }
    findAllCourseSession() {
        return this.courseSessionTableService.findAll();
    }
    findOneCourseSession(courseSessionId) {
        return this.courseSessionTableService.findOne(courseSessionId);
    }
    findOneCourseSessionByCourseId(courseId) {
        return this.courseSessionTableService.findOneByCourseId(courseId);
    }
    updateCourseSessionTable(updateCourseSessionTableInput) {
        return this.courseSessionTableService.update(updateCourseSessionTableInput.courseSessionId, updateCourseSessionTableInput);
    }
    removeCourseSessionTable(courseSessionId) {
        return this.courseSessionTableService.remove(courseSessionId);
    }
    toggleStatusofCourseSession(courseSessionId) {
        return this.courseSessionTableService.toggleStatusofCourseSession(courseSessionId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_session_table_return_type_1.CourseSessionTableReturnType),
    __param(0, (0, graphql_1.Args)('createCourseSessionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_course_session_table_input_1.CreateCourseSessionTableInput]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "createCourseSessionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_session_table_type_1.CourseSessionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "findAllCourseSession", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => course_session_table_type_1.CourseSessionTableType),
    __param(0, (0, graphql_1.Args)('courseSessionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "findOneCourseSession", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_session_table_type_1.CourseSessionTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "findOneCourseSessionByCourseId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_session_table_return_type_1.CourseSessionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateCourseSessionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_course_session_table_input_1.UpdateCourseSessionTableInput]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "updateCourseSessionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_session_table_return_type_1.CourseSessionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseSessionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "removeCourseSessionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_session_table_return_type_1.CourseSessionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseSessionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseSessionTableResolver.prototype, "toggleStatusofCourseSession", null);
exports.CourseSessionTableResolver = CourseSessionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => course_session_table_entity_1.CourseSessionTable),
    __metadata("design:paramtypes", [course_session_table_service_1.CourseSessionTableService])
], CourseSessionTableResolver);
