import { CreateCourseSessionTableInput } from './dto/create-course-session-table.input';
import { UpdateCourseSessionTableInput } from './dto/update-course-session-table.input';
import { CourseSessionTable } from './entities/course-session-table.entity';
import { Repository } from 'typeorm';
import { CourseTableService } from 'src/course-table/course-table.service';
export declare class CourseSessionTableService {
    private readonly courseSessionTableRepository;
    private readonly courseTableService;
    constructor(courseSessionTableRepository: Repository<CourseSessionTable>, courseTableService: CourseTableService);
    create(createCourseSessionTableInput: CreateCourseSessionTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(createCourseSessionTableInput: CreateCourseSessionTableInput): Promise<CourseSessionTable>;
    findAll(): Promise<CourseSessionTable[]>;
    findAllCourseByCourseId(courseId: number): Promise<CourseSessionTable[]>;
    findOne(courseSessionId: number): Promise<CourseSessionTable>;
    findOneByCourseId(courseId: number): Promise<CourseSessionTable[]>;
    update(courseSessionId: number, updateCourseSessionTableInput: UpdateCourseSessionTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(courseSessionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleStatusofCourseSession(courseSessionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseSessionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
