import { CourseTableService } from './course-table.service';
import { CourseTable } from './entities/course-table.entity';
import { CreateCourseTableInput } from './dto/create-course-table.input';
import { UpdateCourseTableInput } from './dto/update-course-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_COURSE_ADD = "NEW_COURSE_ADD";
export declare class CourseTableResolver {
    private readonly courseTableService;
    private pubSub;
    constructor(courseTableService: CourseTableService, pubSub: RedisPubSub);
    createCourseTable(createCourseTableInput: CreateCourseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllCourses(): Promise<CourseTable[]>;
    findAllActiveCourses(): Promise<CourseTable[]>;
    findMyActiveCourses(user: any): Promise<CourseTable[]>;
    searchActiveCourses(search: string): Promise<any>;
    findOneCourse(courseId: number): Promise<any>;
    findOneCourseRestricted(courseId: number, user: any): Promise<any>;
    updateCourseTable(updateCourseTableInput: UpdateCourseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    toggleStatusofCourse(courseId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    toggleHasAssesmentofCourse(courseId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeCourseTable(courseId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    courseSubscription(): AsyncIterator<unknown, any, undefined>;
}
