"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseTableResolver = exports.NEW_COURSE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const course_table_service_1 = require("./course-table.service");
const course_table_entity_1 = require("./entities/course-table.entity");
const create_course_table_input_1 = require("./dto/create-course-table.input");
const update_course_table_input_1 = require("./dto/update-course-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const course_table_return_type_1 = require("./types/course-table-return.type");
const course_table_type_1 = require("./types/course-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
exports.NEW_COURSE_ADD = "NEW_COURSE_ADD";
let CourseTableResolver = exports.CourseTableResolver = class CourseTableResolver {
    constructor(courseTableService, pubSub) {
        this.courseTableService = courseTableService;
        this.pubSub = pubSub;
    }
    createCourseTable(createCourseTableInput) {
        return this.courseTableService.create(createCourseTableInput);
    }
    findAllCourses() {
        return this.courseTableService.findAll();
    }
    findAllActiveCourses() {
        return this.courseTableService.findAllActiveCourses();
    }
    findMyActiveCourses(user) {
        return this.courseTableService.findMyActiveCourses(user);
    }
    searchActiveCourses(search) {
        return this.courseTableService.searchActiveCourses(search);
    }
    findOneCourse(courseId) {
        return this.courseTableService.findOne(courseId);
    }
    findOneCourseRestricted(courseId, user) {
        return this.courseTableService.findOneRestrictedNew(courseId, user);
    }
    updateCourseTable(updateCourseTableInput) {
        return this.courseTableService.update(updateCourseTableInput.courseId, updateCourseTableInput);
    }
    toggleStatusofCourse(courseId) {
        return this.courseTableService.toggleStatusofCourse(courseId);
    }
    toggleHasAssesmentofCourse(courseId) {
        return this.courseTableService.toggleHasAssesmentofCourse(courseId);
    }
    removeCourseTable(courseId) {
        return this.courseTableService.remove(courseId);
    }
    courseSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_COURSE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_table_return_type_1.CourseTableReturnType),
    __param(0, (0, graphql_1.Args)('createCourseTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_course_table_input_1.CreateCourseTableInput]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "createCourseTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_table_type_1.CourseTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "findAllCourses", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_table_type_1.CourseTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "findAllActiveCourses", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_table_type_1.CourseTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "findMyActiveCourses", null);
__decorate([
    (0, graphql_1.Query)(() => [course_table_type_1.CourseTableType]),
    __param(0, (0, graphql_1.Args)('search', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "searchActiveCourses", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => course_table_type_1.CourseTableType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "findOneCourse", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => course_table_type_1.CourseTableType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "findOneCourseRestricted", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_table_return_type_1.CourseTableReturnType),
    __param(0, (0, graphql_1.Args)('updateCourseTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_course_table_input_1.UpdateCourseTableInput]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "updateCourseTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_table_return_type_1.CourseTableReturnType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "toggleStatusofCourse", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_table_return_type_1.CourseTableReturnType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "toggleHasAssesmentofCourse", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_table_return_type_1.CourseTableReturnType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "removeCourseTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseTableResolver.prototype, "courseSubscription", null);
exports.CourseTableResolver = CourseTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => course_table_entity_1.CourseTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [course_table_service_1.CourseTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CourseTableResolver);
