import { CreateCourseTableInput } from './dto/create-course-table.input';
import { UpdateCourseTableInput } from './dto/update-course-table.input';
import { CourseTable } from './entities/course-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { FileTableService } from 'src/file-table/file-table.service';
import { SubscriptionTableService } from 'src/subscription-table/subscription-table.service';
import { CourseUnitTableService } from 'src/course-unit-table/course-unit-table.service';
import { CourseProgressionTableService } from 'src/course-progression-table/course-progression-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CourseSessionTableService } from 'src/course-session-table/course-session-table.service';
export declare const NEW_COURSE_ADD = "NEW_COURSE_ADD";
export declare class CourseTableService {
    private readonly courseTableRepository;
    private pubSub;
    private readonly fileTableService;
    private readonly subscriptionTableService;
    private readonly courseUnitTableService;
    private readonly courseProgressionTableService;
    private readonly userCollectionService;
    private readonly courseSessionTableService;
    constructor(courseTableRepository: Repository<CourseTable>, pubSub: RedisPubSub, fileTableService: FileTableService, subscriptionTableService: SubscriptionTableService, courseUnitTableService: CourseUnitTableService, courseProgressionTableService: CourseProgressionTableService, userCollectionService: UserCollectionService, courseSessionTableService: CourseSessionTableService);
    create(createCourseTableInput: CreateCourseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createCourseTableInput: CreateCourseTableInput): Promise<number>;
    findAll(): Promise<CourseTable[]>;
    findAllActiveCourses(): Promise<CourseTable[]>;
    findMyActiveCourses(user: any): Promise<CourseTable[]>;
    searchActiveCourses(search: string): Promise<any>;
    findOne(courseId: number): Promise<any>;
    findOneRestricted(courseId: number, user: any): Promise<any>;
    findOneRestrictedNew(courseId: number, user: any): Promise<any>;
    updateCourseBanner(courseCode: string, fileId: string): Promise<boolean>;
    update(courseId: number, updateCourseTableInput: UpdateCourseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(courseId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleStatusofCourse(courseId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    toggleHasAssesmentofCourse(courseId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
