import { CourseUnitTableService } from './course-unit-table.service';
import { CourseUnitTable } from './entities/course-unit-table.entity';
import { CreateCourseUnitTableInput } from './dto/create-course-unit-table.input';
import { UpdateCourseUnitTableInput } from './dto/update-course-unit-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_COURSE_UNIT_ADD = "NEW_COURSE_UNIT_ADD";
export declare class CourseUnitTableResolver {
    private readonly courseUnitTableService;
    private pubSub;
    constructor(courseUnitTableService: CourseUnitTableService, pubSub: RedisPubSub);
    createCourseUnitTable(createCourseUnitTableInput: CreateCourseUnitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CourseUnitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllCourseUnit(): Promise<CourseUnitTable[]>;
    findOneCourseUnit(courseUnitId: number): Promise<any>;
    findOneCourseUnitByCourseId(courseId: number): Promise<CourseUnitTable[]>;
    updateCourseUnitTable(updateCourseUnitTableInput: UpdateCourseUnitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    toggleHasAssesmentofCourseUnit(courseUnitId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseUnitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeCourseUnitTable(courseUnitId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    courseUnitSubscription(): AsyncIterator<unknown, any, undefined>;
}
