"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CourseUnitTableResolver = exports.NEW_COURSE_UNIT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const course_unit_table_service_1 = require("./course-unit-table.service");
const course_unit_table_entity_1 = require("./entities/course-unit-table.entity");
const create_course_unit_table_input_1 = require("./dto/create-course-unit-table.input");
const update_course_unit_table_input_1 = require("./dto/update-course-unit-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const course_unit_table_return_type_1 = require("./types/course-unit-table-return.type");
const course_unit_table_type_1 = require("./types/course-unit-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_COURSE_UNIT_ADD = "NEW_COURSE_UNIT_ADD";
let CourseUnitTableResolver = exports.CourseUnitTableResolver = class CourseUnitTableResolver {
    constructor(courseUnitTableService, pubSub) {
        this.courseUnitTableService = courseUnitTableService;
        this.pubSub = pubSub;
    }
    createCourseUnitTable(createCourseUnitTableInput) {
        return this.courseUnitTableService.create(createCourseUnitTableInput);
    }
    findAllCourseUnit() {
        return this.courseUnitTableService.findAll();
    }
    findOneCourseUnit(courseUnitId) {
        return this.courseUnitTableService.findOne(courseUnitId);
    }
    findOneCourseUnitByCourseId(courseId) {
        return this.courseUnitTableService.findOneCourseUnitByCourseId(courseId);
    }
    updateCourseUnitTable(updateCourseUnitTableInput) {
        return this.courseUnitTableService.update(updateCourseUnitTableInput.courseUnitId, updateCourseUnitTableInput);
    }
    toggleHasAssesmentofCourseUnit(courseUnitId) {
        return this.courseUnitTableService.toggleHasAssesmentofCourseUnit(courseUnitId);
    }
    removeCourseUnitTable(courseUnitId) {
        return this.courseUnitTableService.remove(courseUnitId);
    }
    courseUnitSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_COURSE_UNIT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_unit_table_return_type_1.CourseUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('createCourseUnitTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_course_unit_table_input_1.CreateCourseUnitTableInput]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "createCourseUnitTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_unit_table_type_1.CourseUnitTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "findAllCourseUnit", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => course_unit_table_type_1.CourseUnitTableType),
    __param(0, (0, graphql_1.Args)('courseUnitId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "findOneCourseUnit", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [course_unit_table_type_1.CourseUnitTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "findOneCourseUnitByCourseId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_unit_table_return_type_1.CourseUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('updateCourseUnitTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_course_unit_table_input_1.UpdateCourseUnitTableInput]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "updateCourseUnitTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_unit_table_return_type_1.CourseUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('courseUnitId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "toggleHasAssesmentofCourseUnit", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => course_unit_table_return_type_1.CourseUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('courseUnitId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "removeCourseUnitTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CourseUnitTableResolver.prototype, "courseUnitSubscription", null);
exports.CourseUnitTableResolver = CourseUnitTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => course_unit_table_entity_1.CourseUnitTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [course_unit_table_service_1.CourseUnitTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CourseUnitTableResolver);
