import { CreateCourseUnitTableInput } from './dto/create-course-unit-table.input';
import { UpdateCourseUnitTableInput } from './dto/update-course-unit-table.input';
import { CourseUnitTable } from './entities/course-unit-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { CourseTableService } from 'src/course-table/course-table.service';
import { FileTableService } from 'src/file-table/file-table.service';
export declare const NEW_COURSE_UNIT_ADD = "NEW_COURSE_UNIT_ADD";
export declare class CourseUnitTableService {
    private readonly courseUnitTableRepository;
    private pubSub;
    private readonly courseTableService;
    private readonly fileTableService;
    constructor(courseUnitTableRepository: Repository<CourseUnitTable>, pubSub: RedisPubSub, courseTableService: CourseTableService, fileTableService: FileTableService);
    create(createCourseUnitTableInput: CreateCourseUnitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CourseUnitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createCourseUnitTableInput: CreateCourseUnitTableInput): Promise<number>;
    findAll(): Promise<CourseUnitTable[]>;
    findOne(courseUnitId: number): Promise<any>;
    findOneCourseUnitByCourseId(courseId: number): Promise<CourseUnitTable[]>;
    update(courseUnitId: number, updateCourseUnitTableInput: UpdateCourseUnitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(courseUnitId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleHasAssesmentofCourseUnit(courseUnitId: number): Promise<{
        status: boolean;
        status_text: string;
        data: CourseUnitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
