"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CurrentStockCollectionResolver = exports.NEW_CURRENT_STOCK_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const current_stock_collection_service_1 = require("./current-stock-collection.service");
const current_stock_collection_entity_1 = require("./entities/current-stock-collection.entity");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const current_stock_collection_type_1 = require("./types/current-stock-collection.type");
const new_product_category_type_1 = require("../product-category-collection/types/new-product-category.type");
exports.NEW_CURRENT_STOCK_ADD = "NEW_CURRENT_STOCK_ADD";
let CurrentStockCollectionResolver = class CurrentStockCollectionResolver {
    constructor(currentStockCollectionService, pubSub) {
        this.currentStockCollectionService = currentStockCollectionService;
        this.pubSub = pubSub;
    }
    findAllCurrentStock() {
        return this.currentStockCollectionService.findAll();
    }
    getProductWithBarcodeForSale(barcode, clientId) {
        return this.currentStockCollectionService.getStockWithBarcode(barcode, clientId);
    }
    currentStockSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_CURRENT_STOCK_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_collection_type_1.CurrentStockCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockCollectionResolver.prototype, "findAllCurrentStock", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => current_stock_collection_type_1.CurrentStockCollectionType, { nullable: true }),
    __param(0, (0, graphql_1.Args)("barcode")),
    __param(1, (0, graphql_1.Args)("clientId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", void 0)
], CurrentStockCollectionResolver.prototype, "getProductWithBarcodeForSale", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_product_category_type_1.NewCategoryAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockCollectionResolver.prototype, "currentStockSubscription", null);
CurrentStockCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => current_stock_collection_entity_1.CurrentStockCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [current_stock_collection_service_1.CurrentStockCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], CurrentStockCollectionResolver);
exports.CurrentStockCollectionResolver = CurrentStockCollectionResolver;
