import { RedisPubSub } from "graphql-redis-subscriptions";
import { Model } from "mongoose";
import { ProductCollectionService } from "src/product-collection/product-collection.service";
import { UpdateCurrentStockCollectionInput } from "./dto/update-current-stock-collection.input";
import { CurrentStockCollection } from "./entities/current-stock-collection.entity";
import { ProductCollection } from "src/product-collection/entities/product-collection.entity";
import { UserCollectionService } from "src/user-collection/user-collection.service";
import { ClientCollectionService } from "src/client-collection/client-collection.service";
export declare class CurrentStockCollectionService {
    private currentStockCollectionRepository;
    private productService;
    private clientCollectionService;
    private userCollectionService;
    private pubSub;
    constructor(currentStockCollectionRepository: Model<CurrentStockCollection>, productService: ProductCollectionService, clientCollectionService: ClientCollectionService, userCollectionService: UserCollectionService, pubSub: RedisPubSub);
    updateCurrentStock(productId: string, size: string, qty: number, basePrice: string, mrp: string, barcode: string, mfgDate: string, expiryDate: string, batchNo: string, factor: number): Promise<any>;
    padWithZero(num: number, targetLength: number): string;
    getLatestIndex(): Promise<number>;
    checkIfExists(pc: ProductCollection, size: string, basePrice: string, expiryDate: string, batchNo: string): Promise<import("mongoose").Document<unknown, any, CurrentStockCollection> & CurrentStockCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    getStockWithBarcode(barcode: string, clientId: string): Promise<any>;
    getStockWithPriceSpecific(pc: ProductCollection, size: string, qty: string, username: string): Promise<string>;
    getStockWithPrice(pc: ProductCollection, discountPercentage: string, markupPercentage: string): Promise<(import("mongoose").Document<unknown, any, CurrentStockCollection> & CurrentStockCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    priceCalculator(discountPercentage: string, markupPercentage: string, pricingMethod: string, basePrice: string, mrp: string, taxRate: string): Promise<string>;
    findAll(): Promise<(import("mongoose").Document<unknown, any, CurrentStockCollection> & CurrentStockCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findOneById(id: string): Promise<import("mongoose").Document<unknown, any, CurrentStockCollection> & CurrentStockCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateCurrentStockCollectionInput: UpdateCurrentStockCollectionInput): Promise<any>;
    updateStock(id: string, qty: number): Promise<any>;
}
