"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CurrentStockTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const current_stock_table_service_1 = require("./current-stock-table.service");
const current_stock_table_entity_1 = require("./entities/current-stock-table.entity");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const create_current_stock_table_input_1 = require("./dto/create-current-stock-table.input");
const current_stock_table_return_type_1 = require("./types/current-stock-table-return.type");
const current_stock_table_type_1 = require("./types/current-stock-table.type");
const current_stock_district_wise_type_1 = require("./types/current-stock-district-wise.type");
const current_stock_breed_wise_type_1 = require("./types/current-stock-breed-wise.type");
const current_stock_cluster_wise_type_1 = require("./types/current-stock-cluster-wise.type");
const current_stock_age_wise_type_1 = require("./types/current-stock-age-wise.type");
let CurrentStockTableResolver = class CurrentStockTableResolver {
    constructor(currentStockTableService) {
        this.currentStockTableService = currentStockTableService;
    }
    createCurrentStockTable(createCurrentStockTableInput, user) {
        return this.currentStockTableService.create(createCurrentStockTableInput);
    }
    findAllCurrentStock() {
        return this.currentStockTableService.findAll();
    }
    getForDiseaseAndSale(housingId) {
        return this.currentStockTableService.getForDiseaseAndSale(housingId);
    }
    findCurrentStockByHousingId(housingId) {
        return this.currentStockTableService.findByHousingId(housingId);
    }
    countAllStockDistrictWise() {
        return this.currentStockTableService.countAllStockDistrictWise();
    }
    countAllStockAgeWise() {
        return this.currentStockTableService.countAllStockDistrictWise();
    }
    async countAllStockClusterWise(user) {
        let result = await this.currentStockTableService.countAllStockClusterWise(user.username);
        console.log(result);
        return result;
    }
    countAllStockBreedWise() {
        return this.currentStockTableService.countAllStockBreedWise();
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => current_stock_table_return_type_1.CurrentStockTableReturnType),
    __param(0, (0, graphql_1.Args)('createCurrentStockTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_current_stock_table_input_1.CreateCurrentStockTableInput, Object]),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "createCurrentStockTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_table_type_1.CurrentStockTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "findAllCurrentStock", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_table_type_1.CurrentStockTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "getForDiseaseAndSale", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_table_type_1.CurrentStockTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "findCurrentStockByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_district_wise_type_1.CurrentStockDistrictWiseType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "countAllStockDistrictWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_age_wise_type_1.CurrentStockAgeWiseType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "countAllStockAgeWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_cluster_wise_type_1.CurrentStockClusterWiseType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], CurrentStockTableResolver.prototype, "countAllStockClusterWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [current_stock_breed_wise_type_1.CurrentStockBreedWiseType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], CurrentStockTableResolver.prototype, "countAllStockBreedWise", null);
CurrentStockTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => current_stock_table_entity_1.CurrentStockTable),
    __metadata("design:paramtypes", [current_stock_table_service_1.CurrentStockTableService])
], CurrentStockTableResolver);
exports.CurrentStockTableResolver = CurrentStockTableResolver;
