import { Repository } from 'typeorm';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { BreedTableService } from 'src/breed-table/breed-table.service';
import { CurrentStockTable } from './entities/current-stock-table.entity';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { CreateCurrentStockTableInput } from './dto/create-current-stock-table.input';
import { DistrictTableService } from 'src/district-table/district-table.service';
import { AccessTableService } from 'src/access-table/access-table.service';
export declare class CurrentStockTableService {
    private readonly currentStockTableRepository;
    private readonly housingTableService;
    private readonly breedTableService;
    private readonly accessTableService;
    private readonly districtTableService;
    private readonly subDivisionTableService;
    constructor(currentStockTableRepository: Repository<CurrentStockTable>, housingTableService: HousingTableService, breedTableService: BreedTableService, accessTableService: AccessTableService, districtTableService: DistrictTableService, subDivisionTableService: SubDivisionTableService);
    create(createCurrentStockTableInput: CreateCurrentStockTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: CurrentStockTable;
    }>;
    checkIfExists(createCurrentStockTableInput: CreateCurrentStockTableInput): Promise<false | CurrentStockTable>;
    findByHousingId(housingId: number): Promise<CurrentStockTable[]>;
    findOne(currentStockId: number): Promise<CurrentStockTable>;
    findAll(): Promise<CurrentStockTable[]>;
    getForDiseaseAndSale(housingId: number): Promise<CurrentStockTable[]>;
    getAllCount(farmerId?: number): Promise<any>;
    getAllCountByDistAndDiv(districtId?: number, subDivisionId?: number): Promise<any>;
    getAgeWiseCount(farmerId?: number): Promise<{
        pigletCount: number;
        nurseryCount: number;
        growerCount: number;
        finisherCount: number;
    }>;
    getAgeWiseCountBYDistAndDiv(districtId?: number, subDivisionId?: number): Promise<{
        pigletCount: number;
        nurseryCount: number;
        growerCount: number;
        finisherCount: number;
    }>;
    ageUpdate(): Promise<{
        status: boolean;
        status_text: string;
    }>;
    fetchDistrictWiseTotalStock(): Promise<any[]>;
    countAllStockDistrictWise(): Promise<any>;
    countAllStockAgeWise(): Promise<any>;
    countAllStockClusterWise(username: string): Promise<any>;
    countAllStockBreedWise(): Promise<any>;
}
