import { CreateDataEntryTableDto } from './dto/create-data-entry-table.dto';
import { UpdateDataEntryTableDto } from './dto/update-data-entry-table.dto';
import { DataEntryTable } from './entities/data-entry-table.entity';
import { Repository } from 'typeorm';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class DataEntryTableService {
    private readonly dataEntryTableRepository;
    private readonly userCollectionService;
    constructor(dataEntryTableRepository: Repository<DataEntryTable>, userCollectionService: UserCollectionService);
    create(createDataEntryTableDto: CreateDataEntryTableDto, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    countAllUsersDataEntry(): Promise<any>;
    findAll(): Promise<DataEntryTable[]>;
    findOne(id: number): string;
    update(id: number, updateDataEntryTableDto: UpdateDataEntryTableDto): string;
    remove(id: number): string;
}
