"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataEntryTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const data_entry_table_entity_1 = require("./entities/data-entry-table.entity");
const typeorm_2 = require("typeorm");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
let DataEntryTableService = exports.DataEntryTableService = class DataEntryTableService {
    constructor(dataEntryTableRepository, userCollectionService) {
        this.dataEntryTableRepository = dataEntryTableRepository;
        this.userCollectionService = userCollectionService;
    }
    async create(createDataEntryTableDto, user) {
        let userTable = await this.userCollectionService.getOneByUserId(user.userId);
        let det = new data_entry_table_entity_1.DataEntryTable();
        det.type = createDataEntryTableDto.type;
        det.typeOfEntry = createDataEntryTableDto.typeOfEntry;
        det.remarks = createDataEntryTableDto.remarks;
        det.UserTable = userTable;
        det.dateOfEntry = (0, moment_1.default)().format("DD-MM-YYYY");
        det.timeOfEntry = (0, moment_1.default)().format("hh:mm:ss a");
        let result = await this.dataEntryTableRepository.save(det);
        return {
            status: true,
            status_text: "Data Entry Log Updated"
        };
    }
    async countAllUsersDataEntry() {
        let result = await this.dataEntryTableRepository.createQueryBuilder("r")
            .addSelect("COUNT(r.userId)", "numberOfData")
            .groupBy("r.userId")
            .getRawMany();
        return result;
    }
    async findAll() {
        return await this.dataEntryTableRepository.find();
    }
    findOne(id) {
        return `This action returns a #${id} dataEntryTable`;
    }
    update(id, updateDataEntryTableDto) {
        return `This action updates a #${id} dataEntryTable`;
    }
    remove(id) {
        return `This action removes a #${id} dataEntryTable`;
    }
};
exports.DataEntryTableService = DataEntryTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(data_entry_table_entity_1.DataEntryTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        user_collection_service_1.UserCollectionService])
], DataEntryTableService);
