import { DepartmentsTableService } from './departments-table.service';
import { DepartmentsTable } from './entities/departments-table.entity';
import { CreateDepartmentsTableInput } from './dto/create-departments-table.input';
import { UpdateDepartmentsTableInput } from './dto/update-departments-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DEPARTMENT_ADD = "NEW_DEPARTMENT_ADD";
export declare class DepartmentsTableResolver {
    private readonly departmentsTableService;
    private pubSub;
    constructor(departmentsTableService: DepartmentsTableService, pubSub: RedisPubSub);
    createDepartmentsTable(createDepartmentsTableInput: CreateDepartmentsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DepartmentsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllDepartments(): Promise<DepartmentsTable[]>;
    findOneDepartment(departmentId: number): Promise<DepartmentsTable>;
    updateDepartmentsTable(updateDepartmentsTableInput: UpdateDepartmentsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DepartmentsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeDepartmentsTable(departmentId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    departmentSubscription(): AsyncIterator<unknown, any, undefined>;
}
