import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateDepartmentsTableInput } from './dto/create-departments-table.input';
import { UpdateDepartmentsTableInput } from './dto/update-departments-table.input';
import { DepartmentsTable } from './entities/departments-table.entity';
export declare const NEW_DEPARTMENT_ADD = "NEW_DEPARTMENT_ADD";
export declare class DepartmentsTableService {
    private readonly departmentTableRepository;
    private pubSub;
    constructor(departmentTableRepository: Repository<DepartmentsTable>, pubSub: RedisPubSub);
    create(createDepartmentsTableInput: CreateDepartmentsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DepartmentsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createDepartmentsTableInput: CreateDepartmentsTableInput): Promise<number>;
    findAll(): Promise<DepartmentsTable[]>;
    findOne(departmentId: number): Promise<DepartmentsTable>;
    update(departmentId: number, updateDepartmentsTableInput: UpdateDepartmentsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DepartmentsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(departmentId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
