"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DepartmentsTableService = exports.NEW_DEPARTMENT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const departments_table_entity_1 = require("./entities/departments-table.entity");
exports.NEW_DEPARTMENT_ADD = "NEW_DEPARTMENT_ADD";
let DepartmentsTableService = exports.DepartmentsTableService = class DepartmentsTableService {
    constructor(departmentTableRepository, pubSub) {
        this.departmentTableRepository = departmentTableRepository;
        this.pubSub = pubSub;
    }
    async create(createDepartmentsTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createDepartmentsTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new departments_table_entity_1.DepartmentsTable();
            st.departmentName = createDepartmentsTableInput.departmentName;
            let result = await this.departmentTableRepository.save(st);
            this.pubSub.publish(exports.NEW_DEPARTMENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createDepartmentsTableInput) {
        let result = await this.departmentTableRepository.count({
            where: {
                departmentName: createDepartmentsTableInput.departmentName
            }
        });
        return result;
    }
    async findAll() {
        return await this.departmentTableRepository.find();
    }
    async findOne(departmentId) {
        return await this.departmentTableRepository.findOne({
            where: {
                departmentId
            }
        });
    }
    async update(departmentId, updateDepartmentsTableInput) {
        let result = await this.findOne(departmentId);
        if (result) {
            result.departmentName = updateDepartmentsTableInput.departmentName;
            let updatedResult = await this.departmentTableRepository.save(result);
            this.pubSub.publish(exports.NEW_DEPARTMENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(departmentId) {
        let result = await this.findOne(departmentId);
        if (result) {
            await this.departmentTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_DEPARTMENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.DepartmentsTableService = DepartmentsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(departments_table_entity_1.DepartmentsTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], DepartmentsTableService);
