import { DesignationTableService } from './designation-table.service';
import { DesignationTable } from './entities/designation-table.entity';
import { CreateDesignationTableInput } from './dto/create-designation-table.input';
import { UpdateDesignationTableInput } from './dto/update-designation-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DESIGNATION_ADD = "NEW_DESIGNATION_ADD";
export declare class DesignationTableResolver {
    private readonly designationTableService;
    private pubSub;
    constructor(designationTableService: DesignationTableService, pubSub: RedisPubSub);
    createDesignationTable(createDesignationTableInput: CreateDesignationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DesignationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllDesignations(): Promise<DesignationTable[]>;
    findOneDesignation(designationId: number): Promise<DesignationTable>;
    updateDesignationTable(updateDesignationTableInput: UpdateDesignationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DesignationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeDesignationTable(designationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    designationSubscription(): AsyncIterator<unknown, any, undefined>;
}
