"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DesignationTableResolver = exports.NEW_DESIGNATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const designation_table_service_1 = require("./designation-table.service");
const designation_table_entity_1 = require("./entities/designation-table.entity");
const create_designation_table_input_1 = require("./dto/create-designation-table.input");
const update_designation_table_input_1 = require("./dto/update-designation-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const designation_table_return_type_1 = require("./types/designation-table-return.type");
const designation_table_type_1 = require("./types/designation-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
exports.NEW_DESIGNATION_ADD = "NEW_DESIGNATION_ADD";
let DesignationTableResolver = exports.DesignationTableResolver = class DesignationTableResolver {
    constructor(designationTableService, pubSub) {
        this.designationTableService = designationTableService;
        this.pubSub = pubSub;
    }
    createDesignationTable(createDesignationTableInput) {
        return this.designationTableService.create(createDesignationTableInput);
    }
    findAllDesignations() {
        return this.designationTableService.findAll();
    }
    findOneDesignation(designationId) {
        return this.designationTableService.findOne(designationId);
    }
    updateDesignationTable(updateDesignationTableInput) {
        return this.designationTableService.update(updateDesignationTableInput.designationId, updateDesignationTableInput);
    }
    removeDesignationTable(designationId) {
        return this.designationTableService.remove(designationId);
    }
    designationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_DESIGNATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => designation_table_return_type_1.DesignationTableReturnType),
    __param(0, (0, graphql_1.Args)('createDesignationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_designation_table_input_1.CreateDesignationTableInput]),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "createDesignationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [designation_table_type_1.DesignationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "findAllDesignations", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => designation_table_type_1.DesignationTableType),
    __param(0, (0, graphql_1.Args)('designationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "findOneDesignation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => designation_table_return_type_1.DesignationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateDesignationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_designation_table_input_1.UpdateDesignationTableInput]),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "updateDesignationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => designation_table_return_type_1.DesignationTableReturnType),
    __param(0, (0, graphql_1.Args)('designationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "removeDesignationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DesignationTableResolver.prototype, "designationSubscription", null);
exports.DesignationTableResolver = DesignationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => designation_table_entity_1.DesignationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [designation_table_service_1.DesignationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], DesignationTableResolver);
