import { CreateDesignationTableInput } from './dto/create-designation-table.input';
import { UpdateDesignationTableInput } from './dto/update-designation-table.input';
import { DesignationTable } from './entities/designation-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DESIGNATION_ADD = "NEW_DESIGNATION_ADD";
export declare class DesignationTableService {
    private readonly designationTableRepository;
    private pubSub;
    constructor(designationTableRepository: Repository<DesignationTable>, pubSub: RedisPubSub);
    create(createDesignationTableInput: CreateDesignationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DesignationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createDesignationTableInput: CreateDesignationTableInput): Promise<number>;
    findAll(): Promise<DesignationTable[]>;
    findOne(designationId: number): Promise<DesignationTable>;
    update(designationId: number, updateDesignationTableInput: UpdateDesignationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DesignationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(designationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
