"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DesignationTableService = exports.NEW_DESIGNATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const designation_table_entity_1 = require("./entities/designation-table.entity");
const typeorm_2 = require("typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
exports.NEW_DESIGNATION_ADD = "NEW_DESIGNATION_ADD";
let DesignationTableService = exports.DesignationTableService = class DesignationTableService {
    constructor(designationTableRepository, pubSub) {
        this.designationTableRepository = designationTableRepository;
        this.pubSub = pubSub;
    }
    async create(createDesignationTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createDesignationTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new designation_table_entity_1.DesignationTable();
            st.designationName = createDesignationTableInput.designationName;
            let result = await this.designationTableRepository.save(st);
            this.pubSub.publish(exports.NEW_DESIGNATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createDesignationTableInput) {
        let result = await this.designationTableRepository.count({
            where: {
                designationName: createDesignationTableInput.designationName
            }
        });
        return result;
    }
    async findAll() {
        return await this.designationTableRepository.find();
    }
    async findOne(designationId) {
        return await this.designationTableRepository.findOne({
            where: {
                designationId
            }
        });
    }
    async update(designationId, updateDesignationTableInput) {
        let result = await this.findOne(designationId);
        if (result) {
            result.designationName = updateDesignationTableInput.designationName;
            let updatedResult = await this.designationTableRepository.save(result);
            this.pubSub.publish(exports.NEW_DESIGNATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(designationId) {
        let result = await this.findOne(designationId);
        if (result) {
            await this.designationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_DESIGNATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.DesignationTableService = DesignationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(designation_table_entity_1.DesignationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], DesignationTableService);
