import { DifficultiesTableService } from './difficulties-table.service';
import { DifficultiesTable } from './entities/difficulties-table.entity';
import { CreateDifficultiesTableInput } from './dto/create-difficulties-table.input';
import { UpdateDifficultiesTableInput } from './dto/update-difficulties-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DIFFICULTY_ADD = "NEW_DIFFICULTY_ADD";
export declare class DifficultiesTableResolver {
    private readonly difficultiesTableService;
    private pubSub;
    constructor(difficultiesTableService: DifficultiesTableService, pubSub: RedisPubSub);
    createDifficultiesTable(createDifficultiesTableInput: CreateDifficultiesTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DifficultiesTable;
    }>;
    findAllDifficulty(): Promise<DifficultiesTable[]>;
    findOneDifficulty(difficultyId: number): Promise<DifficultiesTable>;
    updateDifficultiesTable(updateDifficultiesTableInput: UpdateDifficultiesTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DifficultiesTable;
    }>;
    removeDifficultiesTable(difficultyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    difficultySubscription(): AsyncIterator<unknown, any, undefined>;
}
