"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DifficultiesTableResolver = exports.NEW_DIFFICULTY_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const difficulties_table_service_1 = require("./difficulties-table.service");
const difficulties_table_entity_1 = require("./entities/difficulties-table.entity");
const create_difficulties_table_input_1 = require("./dto/create-difficulties-table.input");
const update_difficulties_table_input_1 = require("./dto/update-difficulties-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const difficulties_table_return_type_1 = require("./types/difficulties-table-return.type");
const difficulties_table_type_1 = require("./types/difficulties-table.type");
const difficulties_count_changed_type_1 = require("./types/difficulties-count-changed.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
exports.NEW_DIFFICULTY_ADD = "NEW_DIFFICULTY_ADD";
let DifficultiesTableResolver = class DifficultiesTableResolver {
    constructor(difficultiesTableService, pubSub) {
        this.difficultiesTableService = difficultiesTableService;
        this.pubSub = pubSub;
    }
    createDifficultiesTable(createDifficultiesTableInput, user) {
        return this.difficultiesTableService.create(createDifficultiesTableInput, user);
    }
    findAllDifficulty() {
        return this.difficultiesTableService.findAll();
    }
    findOneDifficulty(difficultyId) {
        return this.difficultiesTableService.findOne(difficultyId);
    }
    updateDifficultiesTable(updateDifficultiesTableInput, user) {
        return this.difficultiesTableService.update(updateDifficultiesTableInput.difficultyId, updateDifficultiesTableInput, user);
    }
    removeDifficultiesTable(difficultyId) {
        return this.difficultiesTableService.remove(difficultyId);
    }
    difficultySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_DIFFICULTY_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => difficulties_table_return_type_1.DifficultiesTableReturnType),
    __param(0, (0, graphql_1.Args)('createDifficultiesTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_difficulties_table_input_1.CreateDifficultiesTableInput, Object]),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "createDifficultiesTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [difficulties_table_type_1.DifficultiesTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "findAllDifficulty", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => difficulties_table_type_1.DifficultiesTableType),
    __param(0, (0, graphql_1.Args)('difficultyId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "findOneDifficulty", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => difficulties_table_return_type_1.DifficultiesTableReturnType),
    __param(0, (0, graphql_1.Args)('updateDifficultiesTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_difficulties_table_input_1.UpdateDifficultiesTableInput, Object]),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "updateDifficultiesTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => difficulties_table_return_type_1.DifficultiesTableReturnType),
    __param(0, (0, graphql_1.Args)('difficultyId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "removeDifficultiesTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => difficulties_count_changed_type_1.DifficultiesCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DifficultiesTableResolver.prototype, "difficultySubscription", null);
DifficultiesTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => difficulties_table_entity_1.DifficultiesTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [difficulties_table_service_1.DifficultiesTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], DifficultiesTableResolver);
exports.DifficultiesTableResolver = DifficultiesTableResolver;
