import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateDifficultiesTableInput } from './dto/create-difficulties-table.input';
import { UpdateDifficultiesTableInput } from './dto/update-difficulties-table.input';
import { DifficultiesTable } from './entities/difficulties-table.entity';
export declare const NEW_DIFFICULTY_ADD = "NEW_DIFFICULTY_ADD";
export declare class DifficultiesTableService {
    private readonly difficultiesTableRepository;
    private pubSub;
    constructor(difficultiesTableRepository: Repository<DifficultiesTable>, pubSub: RedisPubSub);
    create(createDifficultiesTableInput: CreateDifficultiesTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DifficultiesTable;
    }>;
    checkIfExists(createDifficultiesTableInput: CreateDifficultiesTableInput): Promise<boolean>;
    findAll(): Promise<DifficultiesTable[]>;
    findOne(difficultyId: number): Promise<DifficultiesTable>;
    update(difficultyId: number, updateDifficultiesTableInput: UpdateDifficultiesTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DifficultiesTable;
    }>;
    remove(difficultyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
