"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscussionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const discussion_table_service_1 = require("./discussion-table.service");
const discussion_table_entity_1 = require("./entities/discussion-table.entity");
const create_discussion_table_input_1 = require("./dto/create-discussion-table.input");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const discussion_table_return_type_1 = require("./types/discussion-table-return.type");
const discussion_table_type_1 = require("./types/discussion-table.type");
let DiscussionTableResolver = exports.DiscussionTableResolver = class DiscussionTableResolver {
    constructor(discussionTableService) {
        this.discussionTableService = discussionTableService;
    }
    createDiscussionTable(createDiscussionTableInput, user) {
        return this.discussionTableService.create(createDiscussionTableInput, user);
    }
    findAllByCourseId(courseId) {
        return this.discussionTableService.findAllByCourseId(courseId);
    }
    findAllByCourseIdWeb(courseId) {
        return this.discussionTableService.findAllByCourseIdWeb(courseId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => discussion_table_return_type_1.DiscussionTableReturnType),
    __param(0, (0, graphql_1.Args)('createDiscussionTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_discussion_table_input_1.CreateDiscussionTableInput, Object]),
    __metadata("design:returntype", void 0)
], DiscussionTableResolver.prototype, "createDiscussionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [discussion_table_type_1.DiscussionTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiscussionTableResolver.prototype, "findAllByCourseId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [discussion_table_type_1.DiscussionTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiscussionTableResolver.prototype, "findAllByCourseIdWeb", null);
exports.DiscussionTableResolver = DiscussionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => discussion_table_entity_1.DiscussionTable),
    __metadata("design:paramtypes", [discussion_table_service_1.DiscussionTableService])
], DiscussionTableResolver);
