import { CreateDiscussionTableInput } from './dto/create-discussion-table.input';
import { DiscussionTable } from './entities/discussion-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { CourseTableService } from 'src/course-table/course-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class DiscussionTableService {
    private readonly discussionTableRepository;
    private pubSub;
    private readonly courseTableService;
    private readonly userCollectionService;
    constructor(discussionTableRepository: Repository<DiscussionTable>, pubSub: RedisPubSub, courseTableService: CourseTableService, userCollectionService: UserCollectionService);
    create(createDiscussionTableInput: CreateDiscussionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DiscussionTable;
    }>;
    findAllByCourseId(courseId: number): Promise<any[]>;
    findAllByCourseIdWeb(courseId: number): Promise<any[]>;
}
