"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscussionTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const discussion_table_entity_1 = require("./entities/discussion-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const course_table_service_1 = require("../course-table/course-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
let DiscussionTableService = exports.DiscussionTableService = class DiscussionTableService {
    constructor(discussionTableRepository, pubSub, courseTableService, userCollectionService) {
        this.discussionTableRepository = discussionTableRepository;
        this.pubSub = pubSub;
        this.courseTableService = courseTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createDiscussionTableInput, user) {
        let st = new discussion_table_entity_1.DiscussionTable();
        let courseTable = await this.courseTableService.findOne(createDiscussionTableInput.courseId);
        st.CourseTable = courseTable;
        let userTable = await this.userCollectionService.findOne(user.id);
        st.UserTable = userTable;
        st.message = createDiscussionTableInput.message;
        let result = await this.discussionTableRepository.save(st);
        return {
            status: true,
            status_text: "Successfully Added",
            data: result
        };
    }
    async findAllByCourseId(courseId) {
        let result = await this.discussionTableRepository.find({
            where: {
                CourseTable: {
                    courseId
                },
            },
            relations: {
                UserTable: true
            },
            order: {
                discussionId: "DESC"
            }
        });
        let data = [];
        for (const el of result) {
            let d = {
                _id: el.discussionId,
                text: el.message,
                createdAt: el.createdAt,
                user: {
                    _id: el.UserTable.id,
                    name: el.UserTable.name
                }
            };
            data.push(d);
        }
        console.log("🚀 ~ DiscussionTableService ~ findAllByCourseId ~ data:", data);
        return data;
    }
    async findAllByCourseIdWeb(courseId) {
        let result = await this.discussionTableRepository.find({
            where: {
                CourseTable: {
                    courseId
                },
            },
            relations: {
                UserTable: true
            },
            order: {
                discussionId: "ASC"
            }
        });
        let data = [];
        for (const el of result) {
            let d = {
                _id: el.discussionId,
                text: el.message,
                createdAt: el.createdAt,
                user: {
                    _id: el.UserTable.id,
                    name: el.UserTable.name
                }
            };
            data.push(d);
        }
        console.log("🚀 ~ DiscussionTableService ~ findAllByCourseId ~ data:", data);
        return data;
    }
};
exports.DiscussionTableService = DiscussionTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(discussion_table_entity_1.DiscussionTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => course_table_service_1.CourseTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        course_table_service_1.CourseTableService,
        user_collection_service_1.UserCollectionService])
], DiscussionTableService);
