import { RedisPubSub } from 'graphql-redis-subscriptions';
import { DiseaseControlTable } from './entities/disese-control-table.entity';
import { DiseaseControlTableService } from './disease-control-table.service';
import { CreateDiseaseControlTableInput } from './dto/create-disease-control-table.input';
import { UpdateDiseaseControlTableInput } from './dto/update-disease-control-table.input';
export declare const NEW_DISEASECONTROL_ADD = "NEW_DISEASECONTROL_ADD";
export declare class DiseaseControlTableResolver {
    private readonly diseaseControlTableService;
    private pubSub;
    constructor(diseaseControlTableService: DiseaseControlTableService, pubSub: RedisPubSub);
    createDiseaseControlTable(createDiseaseControlTableInput: CreateDiseaseControlTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseControlTable;
    }>;
    findAllDiseaseControl(): Promise<DiseaseControlTable[]>;
    findOneDiseaseControl(diseaseControlId: number): Promise<DiseaseControlTable>;
    updateDiseaseControlTable(updateDiseaseControlTableInput: UpdateDiseaseControlTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseControlTable;
    }>;
    removeDiseaseControlTable(diseaseControlId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    diseaseControlSubscription(): AsyncIterator<unknown, any, undefined>;
}
