"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseControlTableResolver = exports.NEW_DISEASECONTROL_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const disese_control_table_entity_1 = require("./entities/disese-control-table.entity");
const disease_control_table_service_1 = require("./disease-control-table.service");
const disease_control_table_return_type_1 = require("./types/disease-control-table-return.type");
const create_disease_control_table_input_1 = require("./dto/create-disease-control-table.input");
const disease_control_table_type_1 = require("./types/disease-control-table.type");
const update_disease_control_table_input_1 = require("./dto/update-disease-control-table.input");
const disease_control_count_changed_type_1 = require("./types/disease-control-count-changed.type");
exports.NEW_DISEASECONTROL_ADD = 'NEW_DISEASECONTROL_ADD';
let DiseaseControlTableResolver = class DiseaseControlTableResolver {
    constructor(diseaseControlTableService, pubSub) {
        this.diseaseControlTableService = diseaseControlTableService;
        this.pubSub = pubSub;
    }
    createDiseaseControlTable(createDiseaseControlTableInput, user) {
        return this.diseaseControlTableService.create(createDiseaseControlTableInput, user);
    }
    findAllDiseaseControl() {
        return this.diseaseControlTableService.findAll();
    }
    findOneDiseaseControl(diseaseControlId) {
        return this.diseaseControlTableService.findOne(diseaseControlId);
    }
    updateDiseaseControlTable(updateDiseaseControlTableInput, user) {
        return this.diseaseControlTableService.update(updateDiseaseControlTableInput.diseaseControlId, updateDiseaseControlTableInput, user);
    }
    removeDiseaseControlTable(diseaseControlId) {
        return this.diseaseControlTableService.remove(diseaseControlId);
    }
    diseaseControlSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_DISEASECONTROL_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_control_table_return_type_1.DiseaseControlTableReturnType),
    __param(0, (0, graphql_1.Args)('createDiseaseControlTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_disease_control_table_input_1.CreateDiseaseControlTableInput, Object]),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "createDiseaseControlTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [disease_control_table_type_1.DiseaseControlTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "findAllDiseaseControl", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => disease_control_table_type_1.DiseaseControlTableType),
    __param(0, (0, graphql_1.Args)('diseaseControlId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "findOneDiseaseControl", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_control_table_return_type_1.DiseaseControlTableReturnType),
    __param(0, (0, graphql_1.Args)('updateDiseaseControlTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_disease_control_table_input_1.UpdateDiseaseControlTableInput, Object]),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "updateDiseaseControlTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_control_table_return_type_1.DiseaseControlTableReturnType),
    __param(0, (0, graphql_1.Args)('diseaseControlId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "removeDiseaseControlTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => disease_control_count_changed_type_1.DiseaseControlCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DiseaseControlTableResolver.prototype, "diseaseControlSubscription", null);
DiseaseControlTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => disese_control_table_entity_1.DiseaseControlTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [disease_control_table_service_1.DiseaseControlTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], DiseaseControlTableResolver);
exports.DiseaseControlTableResolver = DiseaseControlTableResolver;
