import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateDiseaseControlTableInput } from './dto/create-disease-control-table.input';
import { UpdateDiseaseControlTableInput } from './dto/update-disease-control-table.input';
import { DiseaseControlTable } from './entities/disese-control-table.entity';
export declare const NEW_DISEASECONTROL_ADD = "NEW_DISEASECONTROL_ADD";
export declare class DiseaseControlTableService {
    private readonly diseaseControlTableRepository;
    private pubSub;
    constructor(diseaseControlTableRepository: Repository<DiseaseControlTable>, pubSub: RedisPubSub);
    create(createDiseaseControlTableInput: CreateDiseaseControlTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseControlTable;
    }>;
    checkIfExists(createDiseaseControlTableInput: CreateDiseaseControlTableInput): Promise<boolean>;
    findAll(): Promise<DiseaseControlTable[]>;
    findOne(diseaseControlId: number): Promise<DiseaseControlTable>;
    update(diseaseControlId: number, updateDiseaseControlTableInput: UpdateDiseaseControlTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseControlTable;
    }>;
    remove(diseaseControlId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
