"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseControlTableService = exports.NEW_DISEASECONTROL_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const disese_control_table_entity_1 = require("./entities/disese-control-table.entity");
exports.NEW_DISEASECONTROL_ADD = "NEW_DISEASECONTROL_ADD";
let DiseaseControlTableService = class DiseaseControlTableService {
    constructor(diseaseControlTableRepository, pubSub) {
        this.diseaseControlTableRepository = diseaseControlTableRepository;
        this.pubSub = pubSub;
    }
    async create(createDiseaseControlTableInput, user) {
        let checkIfExists = await this.checkIfExists(createDiseaseControlTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new disese_control_table_entity_1.DiseaseControlTable();
            dd.controlType = createDiseaseControlTableInput.controlType;
            let result = await this.diseaseControlTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_DISEASECONTROL_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createDiseaseControlTableInput) {
        let rr = await this.diseaseControlTableRepository.count({
            where: {
                controlType: createDiseaseControlTableInput.controlType,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.diseaseControlTableRepository.find();
    }
    async findOne(diseaseControlId) {
        return await this.diseaseControlTableRepository.findOne({
            where: {
                diseaseControlId: diseaseControlId
            }
        });
    }
    async update(diseaseControlId, updateDiseaseControlTableInput, user) {
        let ht = await this.diseaseControlTableRepository.findOne({
            where: {
                diseaseControlId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.controlType = updateDiseaseControlTableInput.controlType;
            let result = await this.diseaseControlTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_DISEASECONTROL_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(diseaseControlId) {
        let ht = await this.diseaseControlTableRepository.findOne({
            where: {
                diseaseControlId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.diseaseControlTableRepository.remove(ht);
            this.pubSub.publish(exports.NEW_DISEASECONTROL_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
};
DiseaseControlTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(disese_control_table_entity_1.DiseaseControlTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], DiseaseControlTableService);
exports.DiseaseControlTableService = DiseaseControlTableService;
