"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseObservationTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const disease_observation_table_service_1 = require("./disease-observation-table.service");
const disease_observation_table_entity_1 = require("./entities/disease-observation-table.entity");
const create_disease_observation_table_input_1 = require("./dto/create-disease-observation-table.input");
const update_disease_observation_table_input_1 = require("./dto/update-disease-observation-table.input");
const disease_observation_return_type_1 = require("./types/disease-observation-return.type");
const disease_observation_type_1 = require("./types/disease-observation.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
let DiseaseObservationTableResolver = class DiseaseObservationTableResolver {
    constructor(diseaseObservationTableService) {
        this.diseaseObservationTableService = diseaseObservationTableService;
    }
    createDiseaseObservationTable(createDiseaseObservationTableInput, user) {
        return this.diseaseObservationTableService.create(createDiseaseObservationTableInput, user.username);
    }
    findAllDiseaseObservation(animalDiseaseSubId) {
        return this.diseaseObservationTableService.findAllBySubTableId(animalDiseaseSubId);
    }
    updateDiseaseObservationTable(updateDiseaseObservationTableInput) {
        return this.diseaseObservationTableService.update(updateDiseaseObservationTableInput.diseaseObservationId, updateDiseaseObservationTableInput);
    }
    removeDiseaseObservationTable(diseaseObservationId) {
        return this.diseaseObservationTableService.remove(diseaseObservationId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_observation_return_type_1.DiseaseObservationReturnType),
    __param(0, (0, graphql_1.Args)('createDiseaseObservationTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_disease_observation_table_input_1.CreateDiseaseObservationTableInput, Object]),
    __metadata("design:returntype", void 0)
], DiseaseObservationTableResolver.prototype, "createDiseaseObservationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [disease_observation_type_1.DiseaseObservationType]),
    __param(0, (0, graphql_1.Args)("animalDiseaseSubId")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseObservationTableResolver.prototype, "findAllDiseaseObservation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_observation_return_type_1.DiseaseObservationReturnType),
    __param(0, (0, graphql_1.Args)('updateDiseaseObservationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_disease_observation_table_input_1.UpdateDiseaseObservationTableInput]),
    __metadata("design:returntype", void 0)
], DiseaseObservationTableResolver.prototype, "updateDiseaseObservationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_observation_return_type_1.DiseaseObservationReturnType),
    __param(0, (0, graphql_1.Args)('diseaseObservationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseObservationTableResolver.prototype, "removeDiseaseObservationTable", null);
DiseaseObservationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => disease_observation_table_entity_1.DiseaseObservationTable),
    __metadata("design:paramtypes", [disease_observation_table_service_1.DiseaseObservationTableService])
], DiseaseObservationTableResolver);
exports.DiseaseObservationTableResolver = DiseaseObservationTableResolver;
