import { AnimalDiseaseSubTableService } from 'src/animal-disease-sub-table/animal-disease-sub-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateDiseaseObservationTableInput } from './dto/create-disease-observation-table.input';
import { UpdateDiseaseObservationTableInput } from './dto/update-disease-observation-table.input';
import { DiseaseObservationTable } from './entities/disease-observation-table.entity';
export declare class DiseaseObservationTableService {
    private readonly diseaseObservationTable;
    private readonly userCollectionService;
    private readonly animalDiseaseSubTableService;
    constructor(diseaseObservationTable: Repository<DiseaseObservationTable>, userCollectionService: UserCollectionService, animalDiseaseSubTableService: AnimalDiseaseSubTableService);
    create(createDiseaseObservationTableInput: CreateDiseaseObservationTableInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(createDiseaseObservationTableInput: CreateDiseaseObservationTableInput, username: string): Promise<boolean>;
    findAllBySubTableId(animalDiseaseSubId: number): Promise<DiseaseObservationTable[]>;
    countBySubTableId(animalDiseaseSubId: number): Promise<number>;
    findOne(diseaseObservationId: number): string;
    update(diseaseObservationId: number, updateDiseaseObservationTableInput: UpdateDiseaseObservationTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(diseaseObservationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
