"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseObservationTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const moment_1 = __importDefault(require("moment"));
const animal_disease_sub_table_service_1 = require("../animal-disease-sub-table/animal-disease-sub-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const typeorm_2 = require("typeorm");
const disease_observation_table_entity_1 = require("./entities/disease-observation-table.entity");
let DiseaseObservationTableService = class DiseaseObservationTableService {
    constructor(diseaseObservationTable, userCollectionService, animalDiseaseSubTableService) {
        this.diseaseObservationTable = diseaseObservationTable;
        this.userCollectionService = userCollectionService;
        this.animalDiseaseSubTableService = animalDiseaseSubTableService;
    }
    async create(createDiseaseObservationTableInput, username) {
        let user = await this.userCollectionService.findOneByUsername(username);
        let today = (0, moment_1.default)().format("DD-MM-YYYY");
        let animalDiseaseSubTable = await this.animalDiseaseSubTableService.findOneById(createDiseaseObservationTableInput.animalDiseaseSubId);
        let checkIfExists = await this.checkIfExists(createDiseaseObservationTableInput, username);
        if (!checkIfExists) {
            let DiseaseObservation = new disease_observation_table_entity_1.DiseaseObservationTable();
            DiseaseObservation.AnimalDiseaseSubTable = animalDiseaseSubTable;
            DiseaseObservation.UserTable = user;
            DiseaseObservation.observation = createDiseaseObservationTableInput.observation;
            DiseaseObservation.date = today;
            await this.diseaseObservationTable.save(DiseaseObservation);
            return {
                status: true,
                status_text: "Successfully Added"
            };
        }
        else {
            return {
                status: false,
                status_text: "Already added"
            };
        }
    }
    async checkIfExists(createDiseaseObservationTableInput, username) {
        let today = (0, moment_1.default)().format("DD-MM-YYYY");
        let res = await this.diseaseObservationTable.findOne({
            where: {
                observation: createDiseaseObservationTableInput.observation,
                AnimalDiseaseSubTable: {
                    animalDiseaseSubId: createDiseaseObservationTableInput.animalDiseaseSubId
                },
                date: today,
                UserTable: {
                    username: username
                }
            }
        });
        if (res) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAllBySubTableId(animalDiseaseSubId) {
        let res = await this.diseaseObservationTable.find({
            where: {
                AnimalDiseaseSubTable: {
                    animalDiseaseSubId
                },
            },
            order: {
                diseaseObservationId: "DESC"
            },
            relations: {
                AnimalDiseaseSubTable: true,
                UserTable: true
            }
        });
        return res;
    }
    async countBySubTableId(animalDiseaseSubId) {
        let res = await this.diseaseObservationTable.count({
            where: {
                AnimalDiseaseSubTable: {
                    animalDiseaseSubId
                },
            },
        });
        return res;
    }
    findOne(diseaseObservationId) {
        return `This action returns a #${diseaseObservationId} diseaseObservationTable`;
    }
    async update(diseaseObservationId, updateDiseaseObservationTableInput) {
        let res = await this.diseaseObservationTable.findOne({
            where: {
                diseaseObservationId
            }
        });
        if (res) {
            res.observation = updateDiseaseObservationTableInput.observation;
            await this.diseaseObservationTable.save(res);
            return {
                status: true,
                status_text: "Successfully Updated"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async remove(diseaseObservationId) {
        let res = await this.diseaseObservationTable.findOne({
            where: {
                diseaseObservationId
            }
        });
        if (res) {
            await this.diseaseObservationTable.remove(res);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
};
DiseaseObservationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(disease_observation_table_entity_1.DiseaseObservationTable)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_disease_sub_table_service_1.AnimalDiseaseSubTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        user_collection_service_1.UserCollectionService,
        animal_disease_sub_table_service_1.AnimalDiseaseSubTableService])
], DiseaseObservationTableService);
exports.DiseaseObservationTableService = DiseaseObservationTableService;
