import { DiseaseTableService } from './disease-table.service';
import { DiseaseTable } from './entities/disease-table.entity';
import { CreateDiseaseTableInput } from './dto/create-disease-table.input';
import { UpdateDiseaseTableInput } from './dto/update-disease-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DISEASE_ADD = "NEW_DISEASE_ADD";
export declare class DiseaseTableResolver {
    private readonly diseaseTableService;
    private pubSub;
    constructor(diseaseTableService: DiseaseTableService, pubSub: RedisPubSub);
    createDiseaseTable(createDiseaseTableInput: CreateDiseaseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseTable;
    }>;
    findAllDisease(): Promise<DiseaseTable[]>;
    findOneDisease(diseaseTableId: number): Promise<DiseaseTable>;
    updateDiseaseTable(updateDiseaseTableInput: UpdateDiseaseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseTable;
    }>;
    removeDiseaseTable(diseaseTableId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    diseaseSubscription(): AsyncIterator<unknown, any, undefined>;
}
