"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseTableResolver = exports.NEW_DISEASE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const disease_table_service_1 = require("./disease-table.service");
const disease_table_entity_1 = require("./entities/disease-table.entity");
const create_disease_table_input_1 = require("./dto/create-disease-table.input");
const update_disease_table_input_1 = require("./dto/update-disease-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const role_enum_1 = require("../user-collection/roles/role.enum");
const roles_guard_1 = require("../auth/guards/roles.guard");
const disease_table_return_type_1 = require("./types/disease-table-return.type");
const disease_table_type_1 = require("./types/disease-table.type");
const count_changed_type_1 = require("../housing-type-table/types/count-changed.type");
exports.NEW_DISEASE_ADD = "NEW_DISEASE_ADD";
let DiseaseTableResolver = class DiseaseTableResolver {
    constructor(diseaseTableService, pubSub) {
        this.diseaseTableService = diseaseTableService;
        this.pubSub = pubSub;
    }
    createDiseaseTable(createDiseaseTableInput) {
        return this.diseaseTableService.create(createDiseaseTableInput);
    }
    findAllDisease() {
        return this.diseaseTableService.findAll();
    }
    findOneDisease(diseaseTableId) {
        return this.diseaseTableService.findOne(diseaseTableId);
    }
    updateDiseaseTable(updateDiseaseTableInput) {
        return this.diseaseTableService.update(updateDiseaseTableInput.diseaseTableId, updateDiseaseTableInput);
    }
    removeDiseaseTable(diseaseTableId) {
        return this.diseaseTableService.remove(diseaseTableId);
    }
    diseaseSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_DISEASE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_table_return_type_1.DiseaseTableReturnType),
    __param(0, (0, graphql_1.Args)('createDiseaseTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_disease_table_input_1.CreateDiseaseTableInput]),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "createDiseaseTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [disease_table_type_1.DiseaseTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "findAllDisease", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => disease_table_type_1.DiseaseTableType),
    __param(0, (0, graphql_1.Args)('diseaseTableId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "findOneDisease", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_table_return_type_1.DiseaseTableReturnType),
    __param(0, (0, graphql_1.Args)('updateDiseaseTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_disease_table_input_1.UpdateDiseaseTableInput]),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "updateDiseaseTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => disease_table_return_type_1.DiseaseTableReturnType),
    __param(0, (0, graphql_1.Args)('diseaseTableId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "removeDiseaseTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.countchangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DiseaseTableResolver.prototype, "diseaseSubscription", null);
DiseaseTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => disease_table_entity_1.DiseaseTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [disease_table_service_1.DiseaseTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], DiseaseTableResolver);
exports.DiseaseTableResolver = DiseaseTableResolver;
