import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateDiseaseTableInput } from './dto/create-disease-table.input';
import { UpdateDiseaseTableInput } from './dto/update-disease-table.input';
import { DiseaseTable } from './entities/disease-table.entity';
export declare const NEW_DISEASE_ADD = "NEW_DISEASE_ADD";
export declare class DiseaseTableService {
    private readonly diseaseTableRepository;
    private pubSub;
    constructor(diseaseTableRepository: Repository<DiseaseTable>, pubSub: RedisPubSub);
    create(createDiseaseTableInput: CreateDiseaseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseTable;
    }>;
    checkIfExists(diseaseTableName: string, diseaseCode: string): Promise<boolean>;
    findAll(): Promise<DiseaseTable[]>;
    findOne(diseaseTableId: number): Promise<DiseaseTable>;
    update(diseaseTableId: number, updateDiseaseTableInput: UpdateDiseaseTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DiseaseTable;
    }>;
    remove(diseaseTableId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
