"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiseaseTableService = exports.NEW_DISEASE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const disease_table_entity_1 = require("./entities/disease-table.entity");
exports.NEW_DISEASE_ADD = "NEW_DISEASE_ADD";
let DiseaseTableService = class DiseaseTableService {
    constructor(diseaseTableRepository, pubSub) {
        this.diseaseTableRepository = diseaseTableRepository;
        this.pubSub = pubSub;
    }
    async create(createDiseaseTableInput) {
        let checkIfExists = await this.checkIfExists(createDiseaseTableInput.diseaseTableName, createDiseaseTableInput.diseaseCode);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new disease_table_entity_1.DiseaseTable();
            dd.diseaseTableName = createDiseaseTableInput.diseaseTableName;
            dd.diseaseCode = createDiseaseTableInput.diseaseCode;
            let result = await this.diseaseTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_DISEASE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(diseaseTableName, diseaseCode) {
        let result = await this.diseaseTableRepository.count({
            where: {
                diseaseTableName: diseaseTableName,
                diseaseCode: diseaseCode,
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.diseaseTableRepository.find();
    }
    async findOne(diseaseTableId) {
        return await this.diseaseTableRepository.findOne({
            where: {
                diseaseTableId: diseaseTableId
            }
        });
    }
    async update(diseaseTableId, updateDiseaseTableInput) {
        let result = await this.diseaseTableRepository.findOne({
            where: {
                diseaseTableId: diseaseTableId
            }
        });
        if (result) {
            result.diseaseTableName = updateDiseaseTableInput.diseaseTableName;
            result.diseaseCode = updateDiseaseTableInput.diseaseCode;
            let r = await this.diseaseTableRepository.save(result);
            this.pubSub.publish(exports.NEW_DISEASE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(diseaseTableId) {
        let result = await this.diseaseTableRepository.findOne({
            where: {
                diseaseTableId: diseaseTableId
            }
        });
        if (result) {
            await this.diseaseTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_DISEASE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
DiseaseTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(disease_table_entity_1.DiseaseTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], DiseaseTableService);
exports.DiseaseTableService = DiseaseTableService;
