import { DistrictTableService } from './district-table.service';
import { DistrictTable } from './entities/district-table.entity';
import { CreateDistrictTableInput } from './dto/create-district-table.input';
import { UpdateDistrictTableInput } from './dto/update-district-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_DISTRICT_ADD = "NEW_DISTRICT_ADD";
export declare class DistrictTableResolver {
    private readonly districtTableService;
    private pubSub;
    constructor(districtTableService: DistrictTableService, pubSub: RedisPubSub);
    createDistrictTable(createDistrictTableInput: CreateDistrictTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DistrictTable;
    }>;
    findAllDistrict(user: any): Promise<DistrictTable[]>;
    getAllDistrictsByState(user: any, stateId: number): Promise<DistrictTable[]>;
    findOneDistrict(districtId: number): Promise<DistrictTable>;
    updateDistrictTable(updateDistrictTableInput: UpdateDistrictTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DistrictTable;
    }>;
    removeDistrictTable(districtId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    districtSubscription(): AsyncIterator<unknown, any, undefined>;
}
