"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DistrictTableResolver = exports.NEW_DISTRICT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const district_table_service_1 = require("./district-table.service");
const district_table_entity_1 = require("./entities/district-table.entity");
const create_district_table_input_1 = require("./dto/create-district-table.input");
const update_district_table_input_1 = require("./dto/update-district-table.input");
const district_table_type_1 = require("./types/district-table.type");
const district_table_return_type_1 = require("./types/district-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_DISTRICT_ADD = "NEW_DISTRICT_ADD";
let DistrictTableResolver = exports.DistrictTableResolver = class DistrictTableResolver {
    constructor(districtTableService, pubSub) {
        this.districtTableService = districtTableService;
        this.pubSub = pubSub;
    }
    createDistrictTable(createDistrictTableInput) {
        return this.districtTableService.create(createDistrictTableInput);
    }
    findAllDistrict(user) {
        return this.districtTableService.findAll();
    }
    getAllDistrictsByState(user, stateId) {
        return this.districtTableService.findAllByStateId(stateId);
    }
    findOneDistrict(districtId) {
        return this.districtTableService.findOne(districtId);
    }
    updateDistrictTable(updateDistrictTableInput) {
        return this.districtTableService.update(updateDistrictTableInput.districtId, updateDistrictTableInput);
    }
    removeDistrictTable(districtId) {
        return this.districtTableService.remove(districtId);
    }
    districtSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_DISTRICT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => district_table_return_type_1.DistrictTableReturnType),
    __param(0, (0, graphql_1.Args)('createDistrictTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_district_table_input_1.CreateDistrictTableInput]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "createDistrictTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [district_table_type_1.DistrictTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "findAllDistrict", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [district_table_type_1.DistrictTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('stateId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "getAllDistrictsByState", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => district_table_type_1.DistrictTableType),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "findOneDistrict", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => district_table_return_type_1.DistrictTableReturnType),
    __param(0, (0, graphql_1.Args)('updateDistrictTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_district_table_input_1.UpdateDistrictTableInput]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "updateDistrictTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => district_table_return_type_1.DistrictTableReturnType),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "removeDistrictTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], DistrictTableResolver.prototype, "districtSubscription", null);
exports.DistrictTableResolver = DistrictTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => district_table_entity_1.DistrictTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [district_table_service_1.DistrictTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], DistrictTableResolver);
