import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateDistrictTableInput } from './dto/create-district-table.input';
import { UpdateDistrictTableInput } from './dto/update-district-table.input';
import { DistrictTable } from './entities/district-table.entity';
import { StateTableService } from 'src/state-table/state-table.service';
export declare const NEW_DISTRICT_ADD = "NEW_DISTRICT_ADD";
export declare class DistrictTableService {
    private readonly districtTableRepository;
    private pubSub;
    private readonly stateTableService;
    constructor(districtTableRepository: Repository<DistrictTable>, pubSub: RedisPubSub, stateTableService: StateTableService);
    create(createDistrictTableInput: CreateDistrictTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DistrictTable;
    }>;
    createorElseReturnObject(createDistrictTableInput: CreateDistrictTableInput): Promise<DistrictTable>;
    getCount(): Promise<number>;
    getCountUnderAState(stateId: any): Promise<number[]>;
    checkIfExists(districtName: string, stateId: number): Promise<boolean>;
    findAll(): Promise<DistrictTable[]>;
    findAllByIds(ids: number[]): Promise<DistrictTable[]>;
    findAllByStateId(stateId: number): Promise<DistrictTable[]>;
    findOne(districtId: number): Promise<DistrictTable>;
    update(districtId: number, updateDistrictTableInput: UpdateDistrictTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: DistrictTable;
    }>;
    remove(districtId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
