import { EducationTableService } from './education-table.service';
import { EducationTable } from './entities/education-table.entity';
import { CreateEducationTableInput } from './dto/create-education-table.input';
import { UpdateEducationTableInput } from './dto/update-education-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_EDUCATION_ADD = "NEW_EDUCATION_ADD";
export declare class EducationTableResolver {
    private readonly educationTableService;
    private pubSub;
    constructor(educationTableService: EducationTableService, pubSub: RedisPubSub);
    createEducationTable(createEducationTableInput: CreateEducationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: EducationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllEducation(): Promise<EducationTable[]>;
    findOneEducation(educationId: number): Promise<EducationTable>;
    updateEducationTable(updateEducationTableInput: UpdateEducationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: EducationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeEducationTable(educationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    educationSubscription(): AsyncIterator<unknown, any, undefined>;
}
