"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationTableResolver = exports.NEW_EDUCATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const education_table_service_1 = require("./education-table.service");
const education_table_entity_1 = require("./entities/education-table.entity");
const create_education_table_input_1 = require("./dto/create-education-table.input");
const update_education_table_input_1 = require("./dto/update-education-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const education_table_return_type_1 = require("./types/education-table-return.type");
const education_table_type_1 = require("./types/education-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_EDUCATION_ADD = "NEW_EDUCATION_ADD";
let EducationTableResolver = exports.EducationTableResolver = class EducationTableResolver {
    constructor(educationTableService, pubSub) {
        this.educationTableService = educationTableService;
        this.pubSub = pubSub;
    }
    createEducationTable(createEducationTableInput) {
        return this.educationTableService.create(createEducationTableInput);
    }
    findAllEducation() {
        return this.educationTableService.findAll();
    }
    findOneEducation(educationId) {
        return this.educationTableService.findOne(educationId);
    }
    updateEducationTable(updateEducationTableInput) {
        return this.educationTableService.update(updateEducationTableInput.educationId, updateEducationTableInput);
    }
    removeEducationTable(educationId) {
        return this.educationTableService.remove(educationId);
    }
    educationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_EDUCATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => education_table_return_type_1.EducationTableReturnType),
    __param(0, (0, graphql_1.Args)('createEducationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_education_table_input_1.CreateEducationTableInput]),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "createEducationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [education_table_type_1.EducationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "findAllEducation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => education_table_type_1.EducationTableType),
    __param(0, (0, graphql_1.Args)('educationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "findOneEducation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => education_table_return_type_1.EducationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateEducationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_education_table_input_1.UpdateEducationTableInput]),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "updateEducationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => education_table_return_type_1.EducationTableReturnType),
    __param(0, (0, graphql_1.Args)('educationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "removeEducationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], EducationTableResolver.prototype, "educationSubscription", null);
exports.EducationTableResolver = EducationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => education_table_entity_1.EducationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [education_table_service_1.EducationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], EducationTableResolver);
