import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateEducationTableInput } from './dto/create-education-table.input';
import { UpdateEducationTableInput } from './dto/update-education-table.input';
import { EducationTable } from './entities/education-table.entity';
export declare const NEW_EDUCATION_ADD = "NEW_EDUCATION_ADD";
export declare class EducationTableService {
    private readonly educationTableRepository;
    private pubSub;
    constructor(educationTableRepository: Repository<EducationTable>, pubSub: RedisPubSub);
    create(createEducationTableInput: CreateEducationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: EducationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createEducationTableInput: CreateEducationTableInput): Promise<number>;
    findAll(): Promise<EducationTable[]>;
    findOne(educationId: number): Promise<EducationTable>;
    update(educationId: number, updateEducationTableInput: UpdateEducationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: EducationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(educationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
