"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EducationTableService = exports.NEW_EDUCATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const education_table_entity_1 = require("./entities/education-table.entity");
exports.NEW_EDUCATION_ADD = "NEW_EDUCATION_ADD";
let EducationTableService = exports.EducationTableService = class EducationTableService {
    constructor(educationTableRepository, pubSub) {
        this.educationTableRepository = educationTableRepository;
        this.pubSub = pubSub;
    }
    async create(createEducationTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createEducationTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new education_table_entity_1.EducationTable();
            st.educationName = createEducationTableInput.educationName;
            let result = await this.educationTableRepository.save(st);
            this.pubSub.publish(exports.NEW_EDUCATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createEducationTableInput) {
        let result = await this.educationTableRepository.count({
            where: {
                educationName: createEducationTableInput.educationName
            }
        });
        return result;
    }
    async findAll() {
        return await this.educationTableRepository.find();
    }
    async findOne(educationId) {
        return await this.educationTableRepository.findOne({
            where: {
                educationId
            }
        });
    }
    async update(educationId, updateEducationTableInput) {
        let result = await this.findOne(educationId);
        if (result) {
            result.educationName = updateEducationTableInput.educationName;
            let updatedResult = await this.educationTableRepository.save(result);
            this.pubSub.publish(exports.NEW_EDUCATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(educationId) {
        let result = await this.findOne(educationId);
        if (result) {
            await this.educationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_EDUCATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.EducationTableService = EducationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(education_table_entity_1.EducationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], EducationTableService);
