"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FarmersTable = void 0;
const advertisement_table_entity_1 = require("../../advertisement-table/entities/advertisement-table.entity");
const bank_loan_table_entity_1 = require("../../bank-loan-table/entities/bank-loan-table.entity");
const district_table_entity_1 = require("../../district-table/entities/district-table.entity");
const housing_table_entity_1 = require("../../housing-table/entities/housing-table.entity");
const ration_table_entity_1 = require("../../ration-table/entities/ration-table.entity");
const sub_division_table_entity_1 = require("../../sub-division-table/entities/sub-division-table.entity");
const training_table_entity_1 = require("../../training-table/entities/training-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
let FarmersTable = class FarmersTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], FarmersTable.prototype, "farmerId", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerCode", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => district_table_entity_1.DistrictTable, et => et.FarmersTable),
    (0, typeorm_1.JoinColumn)({ name: "districtId" }),
    __metadata("design:type", district_table_entity_1.DistrictTable)
], FarmersTable.prototype, "DistrictTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => sub_division_table_entity_1.SubDivisionTable, et => et.FarmersTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "subDivisionId" }),
    __metadata("design:type", sub_division_table_entity_1.SubDivisionTable)
], FarmersTable.prototype, "SubDivisionTable", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerVillage", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerPostOffice", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerState", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerAadhar", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerPin", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerName", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "gender", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "caste", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "gramPanchayat", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "circleOffice", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "wardNo", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], FarmersTable.prototype, "villageDispensary", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerFatherName", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], FarmersTable.prototype, "farmerPhone", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], FarmersTable.prototype, "farmerCodeIndex", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, et => et.FarmersTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], FarmersTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => housing_table_entity_1.HousingTable, et => et.FarmersTable),
    __metadata("design:type", Array)
], FarmersTable.prototype, "HousingTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => training_table_entity_1.TrainingTable, et => et.FarmersTable),
    __metadata("design:type", Array)
], FarmersTable.prototype, "TrainingTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => bank_loan_table_entity_1.BankLoanTable, et => et.FarmersTable),
    __metadata("design:type", Array)
], FarmersTable.prototype, "BankLoanTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => ration_table_entity_1.RationTable, et => et.FarmersTable),
    __metadata("design:type", Array)
], FarmersTable.prototype, "RationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => advertisement_table_entity_1.AdvertisementTable, et => et.FarmersTable),
    __metadata("design:type", Array)
], FarmersTable.prototype, "AdvertisementTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], FarmersTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], FarmersTable.prototype, "updatedAt", void 0);
FarmersTable = __decorate([
    (0, typeorm_1.Entity)()
], FarmersTable);
exports.FarmersTable = FarmersTable;
