import { FarmersTableService } from './farmers-table.service';
import { FarmersTable } from './entities/farmers-table.entity';
import { CreateFarmersTableInput } from './dto/create-farmers-table.input';
import { UpdateFarmersTableInput } from './dto/update-farmers-table.input';
export declare class FarmersTableResolver {
    private readonly farmersTableService;
    constructor(farmersTableService: FarmersTableService);
    createFarmersTable(createFarmersTableInput: CreateFarmersTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FarmersTable;
    }>;
    findAllFarmers(user: any): Promise<FarmersTable[]>;
    findOneFarmer(farmerId: number): Promise<FarmersTable>;
    findOneFarmerByCode(farmerCode: string): Promise<FarmersTable>;
    findOneFarmerById(farmerId: number): Promise<FarmersTable>;
    updateFarmersTable(updateFarmersTableInput: UpdateFarmersTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FarmersTable;
    }>;
    removeFarmersTable(farmerId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAllFarmerReport(): Promise<FarmersTable[]>;
    findAllFarmerReportSingle(farmerId: number): Promise<FarmersTable[]>;
    fetchDistrictWiseFarmingArea(): Promise<any>;
}
