import { AccessTableService } from 'src/access-table/access-table.service';
import { CurrentStockTableService } from 'src/current-stock/current-stock-table.service';
import { DistrictTableService } from 'src/district-table/district-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateFarmersTableInput } from './dto/create-farmers-table.input';
import { UpdateFarmersTableInput } from './dto/update-farmers-table.input';
import { FarmersTable } from './entities/farmers-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class FarmersTableService {
    private readonly farmersTableRepository;
    private readonly districtTableService;
    private readonly subDivisionTableService;
    private readonly dataEntryTableService;
    private readonly userCollectionService;
    private readonly accessTableService;
    private readonly housingTableService;
    private readonly currentStockTableService;
    constructor(farmersTableRepository: Repository<FarmersTable>, districtTableService: DistrictTableService, subDivisionTableService: SubDivisionTableService, dataEntryTableService: DataEntryTableService, userCollectionService: UserCollectionService, accessTableService: AccessTableService, housingTableService: HousingTableService, currentStockTableService: CurrentStockTableService);
    create(createFarmersTableInput: CreateFarmersTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FarmersTable;
    }>;
    countAllFarmers(farmerId?: number): Promise<{
        farmers: number;
        backyard: number;
        organized: number;
    }>;
    countAllFarmersByDistAndDiv(districtId?: number, subDivisionId?: number): Promise<{
        farmers: number;
        backyard: any;
        organized: any;
    }>;
    checkIfExists(createFarmersTableInput: CreateFarmersTableInput): Promise<boolean>;
    getFarmerCode(): Promise<number>;
    findAll(): Promise<FarmersTable[]>;
    findAllWithAccess(username: string): Promise<FarmersTable[]>;
    findAllFarmerReport(): Promise<FarmersTable[]>;
    findAllFarmerReportSingle(farmerId: number): Promise<FarmersTable[]>;
    padWithZero(num: number, targetLength: number): string;
    findOne(farmerId: number): Promise<FarmersTable>;
    findOneByCode(farmerCode: string): Promise<FarmersTable>;
    findOneById(farmerId: number): Promise<FarmersTable>;
    update(farmerId: number, updateFarmersTableInput: UpdateFarmersTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FarmersTable;
    }>;
    remove(farmerId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    fetchDistrictWiseFarmingArea(): Promise<any>;
}
