import { CreateFblpSubLsTableInput } from './dto/create-fblp-sub-ls-table.input';
import { UpdateFblpSubLsTableInput } from './dto/update-fblp-sub-ls-table.input';
import { FblpSubLsTable } from './entities/fblp-sub-ls-table.entity';
import { Repository } from 'typeorm';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
import { FblpSubTable } from 'src/fblp-sub-table/entities/fblp-sub-table.entity';
export declare class FblpSubLsTableService {
    private readonly fblpSubLsTableRepository;
    private readonly livelihoodSourceTableService;
    constructor(fblpSubLsTableRepository: Repository<FblpSubLsTable>, livelihoodSourceTableService: LivelihoodSourceTableService);
    create(createFblpSubLsTableInput: CreateFblpSubLsTableInput[], fblpSubTable: FblpSubTable): Promise<any[]>;
    findByFblpSubId(fblpSubId: number): Promise<FblpSubLsTable[]>;
    findOne(id: number): string;
    update(id: number, updateFblpSubLsTableInput: UpdateFblpSubLsTableInput): string;
    remove(id: number): string;
    removeByFblpSubId(fblpSubId: number): Promise<boolean>;
}
