"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FblpSubLsTableService = void 0;
const common_1 = require("@nestjs/common");
const fblp_sub_ls_table_entity_1 = require("./entities/fblp-sub-ls-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
let FblpSubLsTableService = exports.FblpSubLsTableService = class FblpSubLsTableService {
    constructor(fblpSubLsTableRepository, livelihoodSourceTableService) {
        this.fblpSubLsTableRepository = fblpSubLsTableRepository;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
    }
    async create(createFblpSubLsTableInput, fblpSubTable) {
        let results = [];
        await this.removeByFblpSubId(fblpSubTable.fblpSubId);
        for (const el of createFblpSubLsTableInput) {
            let fblpSubLsTable = new fblp_sub_ls_table_entity_1.FblpSubLsTable();
            let livelihoodData = await this.livelihoodSourceTableService.findOne(el.lsId);
            fblpSubLsTable.LivelihoodSourceTable = livelihoodData;
            fblpSubLsTable.FblpSubTable = fblpSubTable;
            let result = await this.fblpSubLsTableRepository.save(fblpSubLsTable);
            results.push(result);
        }
        return results;
    }
    async findByFblpSubId(fblpSubId) {
        return await this.fblpSubLsTableRepository.find({
            where: {
                FblpSubTable: {
                    fblpSubId
                }
            },
            relations: {
                LivelihoodSourceTable: true
            }
        });
    }
    findOne(id) {
        return `This action returns a #${id} fblpSubLsTable`;
    }
    update(id, updateFblpSubLsTableInput) {
        return `This action updates a #${id} fblpSubLsTable`;
    }
    remove(id) {
        return `This action removes a #${id} fblpSubLsTable`;
    }
    async removeByFblpSubId(fblpSubId) {
        let results = await this.fblpSubLsTableRepository.find({
            where: {
                FblpSubTable: {
                    fblpSubId
                }
            }
        });
        await this.fblpSubLsTableRepository.remove(results);
        return true;
    }
};
exports.FblpSubLsTableService = FblpSubLsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(fblp_sub_ls_table_entity_1.FblpSubLsTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        livelihood_source_table_service_1.LivelihoodSourceTableService])
], FblpSubLsTableService);
