"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FblpSubTable = void 0;
const fblp_table_entity_1 = require("../../fblp-table/entities/fblp-table.entity");
const income_source_table_entity_1 = require("../../income-source-table/entities/income-source-table.entity");
const livelihood_source_table_entity_1 = require("../../livelihood-source-table/entities/livelihood-source-table.entity");
const typeorm_1 = require("typeorm");
let FblpSubTable = exports.FblpSubTable = class FblpSubTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], FblpSubTable.prototype, "fblpSubId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => fblp_table_entity_1.FblpTable, dt => dt.FblpSubTable, { onDelete: "CASCADE" }),
    (0, typeorm_1.JoinColumn)({ name: "fblpId" }),
    __metadata("design:type", fblp_table_entity_1.FblpTable)
], FblpSubTable.prototype, "FblpTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "estimatedExpenditure", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "ownInvestment", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "projectContribution", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "loanRequired", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "farmEquipmentAvailable", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "insuranceSupportNeeded", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "shedSupportNeeded", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "pondConstructionNeeded", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "pondRenevationNeeded", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "breedingUnitNeeded", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "areaOfLand", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "areaOfLandUnit", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], FblpSubTable.prototype, "conversionToBigha", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => income_source_table_entity_1.IncomeSourceTable, dt => dt.FblpSubTable),
    (0, typeorm_1.JoinColumn)({ name: "incomeSourceId" }),
    __metadata("design:type", income_source_table_entity_1.IncomeSourceTable)
], FblpSubTable.prototype, "IncomeSourceTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => livelihood_source_table_entity_1.LivelihoodSourceTable, dt => dt.FblpSubTable),
    (0, typeorm_1.JoinColumn)({ name: "lsId" }),
    __metadata("design:type", livelihood_source_table_entity_1.LivelihoodSourceTable)
], FblpSubTable.prototype, "LivelihoodSourceTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], FblpSubTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], FblpSubTable.prototype, "updatedAt", void 0);
exports.FblpSubTable = FblpSubTable = __decorate([
    (0, typeorm_1.Entity)()
], FblpSubTable);
