import { CreateFblpSubTableInput } from './dto/create-fblp-sub-table.input';
import { UpdateFblpSubTableInput } from './dto/update-fblp-sub-table.input';
import { FblpSubTable } from './entities/fblp-sub-table.entity';
import { Repository } from 'typeorm';
import { FblpTable } from 'src/fblp-table/entities/fblp-table.entity';
import { IncomeSourceTableService } from 'src/income-source-table/income-source-table.service';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
export declare class FblpSubTableService {
    private readonly fblpSubTableRepository;
    private readonly livelihoodSourceTableService;
    private readonly incomeSourceTableService;
    constructor(fblpSubTableRepository: Repository<FblpSubTable>, livelihoodSourceTableService: LivelihoodSourceTableService, incomeSourceTableService: IncomeSourceTableService);
    create(createFblpSubTableInput: CreateFblpSubTableInput[], fblpTable: FblpTable): Promise<any[]>;
    findByFblpId(fblpId: number): Promise<FblpSubTable[]>;
    getFblpConsolidatedReportList(shgId: number, lsCode: string): Promise<FblpSubTable[]>;
    findOne(id: number): string;
    update(id: number, updateFblpSubTableInput: UpdateFblpSubTableInput): string;
    remove(id: number): string;
    removeByFblpId(fblpId: number): Promise<boolean>;
}
