"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FblpTableController = void 0;
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const jwt_auth_guard_1 = require("../auth/guards/jwt-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const fblp_table_service_1 = require("./fblp-table.service");
let FblpTableController = exports.FblpTableController = class FblpTableController {
    constructor(fblpTableService) {
        this.fblpTableService = fblpTableService;
    }
    async getFblpTotalReport(req) {
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        let type = req.query.hasOwnProperty('type') ? req.query.type : "AGIRCULTURE";
        return await this.fblpTableService.getFblpTotalReport(stateId, districtId, blockId, type);
    }
    async getFblpListReport(req) {
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        let sessionId = req.query.hasOwnProperty('sessionId') ? req.query.sessionId : 0;
        return await this.fblpTableService.getFblpListReport(stateId, districtId, blockId, sessionId);
    }
    async getFblpConsolidatedReport(req) {
        let shgId = req.query.hasOwnProperty('shgId') ? req.query.shgId : 0;
        return await this.fblpTableService.getFblpConsolidatedReport(shgId);
    }
    async getFblpConsolidatedReportList(req) {
        let shgId = req.query.hasOwnProperty('shgId') ? req.query.shgId : 0;
        let lsCode = req.query.hasOwnProperty('lsCode') ? req.query.lsCode : "";
        return await this.fblpTableService.getFblpConsolidatedReportList(shgId, lsCode);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('fblp-total-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FblpTableController.prototype, "getFblpTotalReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('fblp-list-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FblpTableController.prototype, "getFblpListReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('fblp-consolidated-report-by-shg'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FblpTableController.prototype, "getFblpConsolidatedReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('fblp-consolidated-report-list-by-shg'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FblpTableController.prototype, "getFblpConsolidatedReportList", null);
exports.FblpTableController = FblpTableController = __decorate([
    (0, common_1.Controller)('fblp-table'),
    __metadata("design:paramtypes", [fblp_table_service_1.FblpTableService])
], FblpTableController);
