import { FblpTableService } from './fblp-table.service';
import { FblpTable } from './entities/fblp-table.entity';
import { CreateFblpTableInput } from './dto/create-fblp-table.input';
import { UpdateFblpTableInput } from './dto/update-fblp-table.input';
export declare class FblpTableResolver {
    private readonly fblpTableService;
    constructor(fblpTableService: FblpTableService);
    createFblpTable(createFblpTableInput: CreateFblpTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FblpTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllFblp(): Promise<FblpTable[]>;
    findOneFblpByMkId(mkId: number): Promise<FblpTable>;
    updateFblpTable(updateFblpTableInput: UpdateFblpTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getListOfLsFromLatestFblp(mkId: number): Promise<{
        lsCodes: any[];
    }>;
    updateFblpEditableDate(editableTill: string, fblpId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeFblpTable(fblpId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
