import { CreateFblpTableInput } from './dto/create-fblp-table.input';
import { UpdateFblpTableInput } from './dto/update-fblp-table.input';
import { FblpTable } from './entities/fblp-table.entity';
import { Repository } from 'typeorm';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { FblpSubTableService } from 'src/fblp-sub-table/fblp-sub-table.service';
import { MkEntitlementsTableService } from 'src/mk-entitlements-table/mk-entitlements-table.service';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
import { FblpSubTable } from 'src/fblp-sub-table/entities/fblp-sub-table.entity';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
export declare class FblpTableService {
    private readonly fblpTableRepository;
    private readonly userCollectionService;
    private readonly mkTableService;
    private readonly fblpSubTableService;
    private readonly mkEntitlementsTableService;
    private readonly livelihoodSourceTableService;
    private readonly sessionmasterTableService;
    constructor(fblpTableRepository: Repository<FblpTable>, userCollectionService: UserCollectionService, mkTableService: MkTableService, fblpSubTableService: FblpSubTableService, mkEntitlementsTableService: MkEntitlementsTableService, livelihoodSourceTableService: LivelihoodSourceTableService, sessionmasterTableService: SessionmasterTableService);
    create(createFblpTableInput: CreateFblpTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: FblpTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyDoneRecently(mkId: number): Promise<boolean>;
    findAll(): Promise<FblpTable[]>;
    countByShgId(shgId: number): Promise<number>;
    findOneByMkId(mkId: number): Promise<FblpTable>;
    getListOfLsFromLatestFblp(mkId: number): Promise<{
        lsCodes: any[];
    }>;
    update(fblpId: number, updateFblpTableInput: UpdateFblpTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateFblpEditableDate(fblpId: number, editableTill: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(fblpId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getCount(): Promise<number>;
    getCountByMonth(month: string): Promise<any>;
    getCountByUsername(username: string): Promise<number>;
    getFblpTotalReport(stateId: number, districtId: number, blockId: number, type: string): Promise<any>;
    getFblpListReport(stateId: number, districtId: number, blockId: number, sessionId: number): Promise<{
        data: any[];
        lsMasterData: import("../livelihood-source-table/entities/livelihood-source-table.entity").LivelihoodSourceTable[];
    }>;
    getFblpConsolidatedReport(shgId: number): Promise<any>;
    getFblpConsolidatedReportList(shgId: number, lsCode: string): Promise<FblpSubTable[]>;
    getRepeatAndNewFarmer(mkIds: number[]): Promise<{
        newFarmer: number;
        repeatFarmer: number;
    }>;
}
