"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileTableController = void 0;
const common_1 = require("@nestjs/common");
const file_table_service_1 = require("./file-table.service");
const platform_express_1 = require("@nestjs/platform-express");
const mutler_config_1 = require("../config/mutler-config");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const path_1 = require("path");
const fs_1 = require("fs");
let FileTableController = exports.FileTableController = class FileTableController {
    constructor(fileTableService) {
        this.fileTableService = fileTableService;
    }
    async uploadFileNew(file, body) {
        let sFolder = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, body.code, body.fileType);
        if (!(0, fs_1.existsSync)(sFolder)) {
            (0, fs_1.mkdirSync)(sFolder, { recursive: true });
        }
        let up = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH);
        let prePath = '';
        if (file != undefined && file.filename != undefined) {
            (0, fs_1.renameSync)(`${up}/${file.filename}`, `${sFolder}/${file.filename}`);
            prePath = `/${GlobalConstants_1.UPLOAD_PATH}/${body.code}/${body.fileType}/${file.filename}`;
        }
        return await this.fileTableService.saveFileNew(file, prePath, body.fileType, body.code);
    }
    async uploadFile(file, params) {
        return await this.fileTableService.saveFile(file, params.fileType, params.code);
    }
    async deleteFile(params) {
        return await this.fileTableService.deleteFile(params.fileId, params.code);
    }
    async getUploadedFile(params) {
        return await this.fileTableService.getMyFilesByType(params.code, params.fileType);
    }
    async deleteFileWithFileName(body) {
        let fileName = body['fileName'];
        return await this.fileTableService.deleteFileNew(fileName);
    }
    async deleteFileWithId(body) {
        let fileId = body['fileId'];
        return await this.fileTableService.deleteFileWithId(fileId);
    }
    async deleteFileWithoutId(params) {
        return await this.fileTableService.deleteFile(params.fileId, params.code);
    }
};
__decorate([
    (0, common_1.Post)('file-upload-new'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('uploadFile', mutler_config_1.multerOptions)),
    __param(0, (0, common_1.UploadedFile)()),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "uploadFileNew", null);
__decorate([
    (0, common_1.Post)(':code/:fileType/file-upload'),
    (0, common_1.UseInterceptors)((0, platform_express_1.FileInterceptor)('file', mutler_config_1.multerOptions)),
    __param(0, (0, common_1.UploadedFile)()),
    __param(1, (0, common_1.Param)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "uploadFile", null);
__decorate([
    (0, common_1.Delete)('delete-file/:fileId/:code'),
    __param(0, (0, common_1.Param)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "deleteFile", null);
__decorate([
    (0, common_1.Get)(':code/:fileType/get-file-upload'),
    __param(0, (0, common_1.Param)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "getUploadedFile", null);
__decorate([
    (0, common_1.Post)('delete-file-uploaded-new'),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "deleteFileWithFileName", null);
__decorate([
    (0, common_1.Post)('delete-file-uploaded-new-by-id'),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "deleteFileWithId", null);
__decorate([
    (0, common_1.Delete)(':code/:fileId/delete-file-uploaded'),
    __param(0, (0, common_1.Param)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], FileTableController.prototype, "deleteFileWithoutId", null);
exports.FileTableController = FileTableController = __decorate([
    (0, common_1.Controller)('file-table'),
    __metadata("design:paramtypes", [file_table_service_1.FileTableService])
], FileTableController);
