import { FileTable } from './file-table.entity';
import { Repository } from 'typeorm';
import { CourseTableService } from 'src/course-table/course-table.service';
export declare class FileTableService {
    private readonly fileTableRepository;
    private readonly courseTableService;
    constructor(fileTableRepository: Repository<FileTable>, courseTableService: CourseTableService);
    checkIfAlreadyExists(fileType: string): Promise<boolean>;
    saveFileNew(file: any, prePath: string, fileType: string, code: string): Promise<string>;
    saveFile(file: any, fileType: string, code: string): Promise<FileTable>;
    getMyFilesByType(code: string, fileType: string): Promise<false | FileTable>;
    getUrlOfFileId(fileId: string): Promise<string | false>;
    deleteFile(fileId: string, code: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    deleteFileNew(fileName: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    deleteFileWithId(fileId: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
