"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const file_table_entity_1 = require("./file-table.entity");
const typeorm_2 = require("typeorm");
const course_table_service_1 = require("../course-table/course-table.service");
let FileTableService = exports.FileTableService = class FileTableService {
    constructor(fileTableRepository, courseTableService) {
        this.fileTableRepository = fileTableRepository;
        this.courseTableService = courseTableService;
    }
    async checkIfAlreadyExists(fileType) {
        return false;
    }
    async saveFileNew(file, prePath, fileType, code) {
        let fileTable = new file_table_entity_1.FileTable();
        fileTable.fileName = file.filename;
        fileTable.code = code;
        fileTable.fileType = fileType;
        fileTable.path = prePath;
        fileTable.mimeType = file.mimetype;
        let result = await this.fileTableRepository.save(fileTable);
        return result.fileId;
    }
    async saveFile(file, fileType, code) {
        let fileTable = new file_table_entity_1.FileTable();
        fileTable.fileName = file.filename;
        fileTable.code = code;
        fileTable.fileType = fileType;
        fileTable.path = `uploads/${file.filename}`;
        fileTable.mimeType = file.mimetype;
        let result = await this.fileTableRepository.save(fileTable);
        if (fileType == "COURSE_BANNER_IMAGES") {
            await this.courseTableService.updateCourseBanner(code, result.fileId);
        }
        return result;
    }
    async getMyFilesByType(code, fileType) {
        let result = await this.fileTableRepository.findOne({
            where: {
                code,
                fileType
            }
        });
        if (result !== null && result !== undefined) {
            return result;
        }
        else {
            return false;
        }
    }
    async getUrlOfFileId(fileId) {
        let result = await this.fileTableRepository.findOne({
            where: {
                fileId
            }
        });
        if (result !== null && result !== undefined) {
            return result.path;
        }
        else {
            return false;
        }
    }
    async deleteFile(fileId, code) {
        const fs = require('fs');
        let file = await this.fileTableRepository.findOne({
            where: {
                fileId
            }
        });
        if (file !== null && file !== undefined) {
            const path = require('path');
            let p = path.join(__dirname, '..', '..', file.path);
            let ifExists = fs.existsSync(p);
            if (ifExists) {
                fs.unlinkSync(p);
                await this.fileTableRepository.remove(file);
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
            else {
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
        }
        else {
            return {
                status: true,
                status_text: 'File is already deleted'
            };
        }
    }
    async deleteFileNew(fileName) {
        const fs = require('fs');
        let file = await this.fileTableRepository.findOne({
            where: {
                fileName
            }
        });
        if (file !== null && file !== undefined) {
            const path = require('path');
            let p = path.join(__dirname, '..', '..', file.path);
            let ifExists = fs.existsSync(p);
            if (ifExists) {
                fs.unlinkSync(p);
                await this.fileTableRepository.remove(file);
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
            else {
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
        }
        else {
            return {
                status: true,
                status_text: 'File is already deleted'
            };
        }
    }
    async deleteFileWithId(fileId) {
        const fs = require('fs');
        let file = await this.fileTableRepository.findOne({
            where: {
                fileId
            }
        });
        if (file !== null && file !== undefined) {
            const path = require('path');
            let p = path.join(__dirname, '..', '..', file.path);
            let ifExists = fs.existsSync(p);
            if (ifExists) {
                fs.unlinkSync(p);
                await this.fileTableRepository.remove(file);
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
            else {
                return {
                    status: true,
                    status_text: 'Successfully Deleted'
                };
            }
        }
        else {
            return {
                status: true,
                status_text: 'File is already deleted'
            };
        }
    }
};
exports.FileTableService = FileTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(file_table_entity_1.FileTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => course_table_service_1.CourseTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        course_table_service_1.CourseTableService])
], FileTableService);
