import { FpoTableService } from './fpo-table.service';
import { FpoTable } from './entities/fpo-table.entity';
import { CreateFpoTableInput } from './dto/create-fpo-table.input';
import { UpdateFpoTableInput } from './dto/update-fpo-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_FPO_ADD = "NEW_FPO_ADD";
export declare class FpoTableResolver {
    private readonly fpoTableService;
    private pubSub;
    constructor(fpoTableService: FpoTableService, pubSub: RedisPubSub);
    createFpoTable(createFpoTableInput: CreateFpoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: FpoTable;
    }>;
    findAllFpoTable(): Promise<FpoTable[]>;
    findOneFpoTable(fpoId: number): Promise<FpoTable>;
    updateFpoTable(updateFpoTableInput: UpdateFpoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: FpoTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeFpoTable(fpoId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    fpoSubscription(): AsyncIterator<unknown, any, undefined>;
}
