"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FpoTableResolver = exports.NEW_FPO_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const fpo_table_service_1 = require("./fpo-table.service");
const fpo_table_entity_1 = require("./entities/fpo-table.entity");
const create_fpo_table_input_1 = require("./dto/create-fpo-table.input");
const update_fpo_table_input_1 = require("./dto/update-fpo-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const common_1 = require("@nestjs/common");
const fpo_table_return_type_1 = require("./types/fpo-table-return.type");
const fpo_table_type_1 = require("./types/fpo-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_FPO_ADD = "NEW_FPO_ADD";
let FpoTableResolver = exports.FpoTableResolver = class FpoTableResolver {
    constructor(fpoTableService, pubSub) {
        this.fpoTableService = fpoTableService;
        this.pubSub = pubSub;
    }
    createFpoTable(createFpoTableInput) {
        return this.fpoTableService.create(createFpoTableInput);
    }
    findAllFpoTable() {
        return this.fpoTableService.findAll();
    }
    findOneFpoTable(fpoId) {
        return this.fpoTableService.findOne(fpoId);
    }
    updateFpoTable(updateFpoTableInput) {
        return this.fpoTableService.update(updateFpoTableInput.fpoId, updateFpoTableInput);
    }
    removeFpoTable(fpoId) {
        return this.fpoTableService.remove(fpoId);
    }
    fpoSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_FPO_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => fpo_table_return_type_1.FpoTableReturnType),
    __param(0, (0, graphql_1.Args)('createFpoTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_fpo_table_input_1.CreateFpoTableInput]),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "createFpoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [fpo_table_type_1.FpoTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "findAllFpoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => fpo_table_type_1.FpoTableType),
    __param(0, (0, graphql_1.Args)('fpoId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "findOneFpoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => fpo_table_return_type_1.FpoTableReturnType),
    __param(0, (0, graphql_1.Args)('updateFpoTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_fpo_table_input_1.UpdateFpoTableInput]),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "updateFpoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => fpo_table_return_type_1.FpoTableReturnType),
    __param(0, (0, graphql_1.Args)('fpoId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "removeFpoTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], FpoTableResolver.prototype, "fpoSubscription", null);
exports.FpoTableResolver = FpoTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => fpo_table_entity_1.FpoTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [fpo_table_service_1.FpoTableService, graphql_redis_subscriptions_1.RedisPubSub])
], FpoTableResolver);
