import { CreateFpoTableInput } from './dto/create-fpo-table.input';
import { UpdateFpoTableInput } from './dto/update-fpo-table.input';
import { FpoTable } from './entities/fpo-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { BlockTableService } from 'src/block-table/block-table.service';
export declare const NEW_FPO_ADD = "NEW_FPO_ADD";
export declare class FpoTableService {
    private readonly fpoTableRepository;
    private pubSub;
    private readonly blockTableService;
    constructor(fpoTableRepository: Repository<FpoTable>, pubSub: RedisPubSub, blockTableService: BlockTableService);
    create(createFpoTableInput: CreateFpoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: FpoTable;
    }>;
    checkIfExists(createFpoTableInput: CreateFpoTableInput): Promise<boolean>;
    findAll(): Promise<FpoTable[]>;
    getCount(): Promise<number>;
    findOne(fpoId: number): Promise<FpoTable>;
    findOneByBlockId(blockId: number): Promise<FpoTable[]>;
    update(fpoId: number, updateFpoTableInput: UpdateFpoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: FpoTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(fpoId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
