"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FpoTableService = exports.NEW_FPO_ADD = void 0;
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_1 = require("@nestjs/typeorm");
const fpo_table_entity_1 = require("./entities/fpo-table.entity");
const typeorm_2 = require("typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const block_table_service_1 = require("../block-table/block-table.service");
exports.NEW_FPO_ADD = "NEW_FPO_ADD";
let FpoTableService = exports.FpoTableService = class FpoTableService {
    constructor(fpoTableRepository, pubSub, blockTableService) {
        this.fpoTableRepository = fpoTableRepository;
        this.pubSub = pubSub;
        this.blockTableService = blockTableService;
    }
    async create(createFpoTableInput) {
        let checkIfExists = await this.checkIfExists(createFpoTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new fpo_table_entity_1.FpoTable();
            dd.typeOfFpo = createFpoTableInput.typeOfFpo;
            dd.nameOfFpo = createFpoTableInput.nameOfFpo;
            dd.dateOfFormation = createFpoTableInput.dateOfFormation;
            dd.legalStatus = createFpoTableInput.legalStatus;
            dd.incorporation = createFpoTableInput.incorporation;
            dd.bankName = createFpoTableInput.bankName;
            dd.bankAccountNo = createFpoTableInput.bankAccountNo;
            dd.bankBranch = createFpoTableInput.bankBranch;
            dd.bankIfsc = createFpoTableInput.bankIfsc;
            let block = await this.blockTableService.findOne(createFpoTableInput.blockId);
            dd.BlockTable = block;
            let result = await this.fpoTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_FPO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createFpoTableInput) {
        let result = await this.fpoTableRepository.count({
            where: {
                nameOfFpo: createFpoTableInput.nameOfFpo,
                typeOfFpo: createFpoTableInput.typeOfFpo,
                dateOfFormation: createFpoTableInput.dateOfFormation,
                incorporation: createFpoTableInput.incorporation,
                legalStatus: createFpoTableInput.legalStatus,
                BlockTable: {
                    blockId: createFpoTableInput.blockId
                },
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.fpoTableRepository.find({
            relations: {
                BlockTable: {
                    DistrictTable: {
                        StateTable: true
                    }
                }
            }
        });
    }
    async getCount() {
        return await this.fpoTableRepository.count();
    }
    async findOne(fpoId) {
        return await this.fpoTableRepository.findOne({
            where: {
                fpoId
            },
            relations: {
                BlockTable: {
                    DistrictTable: {
                        StateTable: true
                    }
                }
            }
        });
    }
    async findOneByBlockId(blockId) {
        return await this.fpoTableRepository.find({
            where: {
                BlockTable: {
                    blockId
                }
            },
            relations: {
                BlockTable: {
                    DistrictTable: {
                        StateTable: true
                    }
                }
            }
        });
    }
    async update(fpoId, updateFpoTableInput) {
        let result = await this.findOne(fpoId);
        if (result) {
            let dd = result;
            dd.typeOfFpo = updateFpoTableInput.typeOfFpo;
            dd.nameOfFpo = updateFpoTableInput.nameOfFpo;
            dd.dateOfFormation = updateFpoTableInput.dateOfFormation;
            dd.legalStatus = updateFpoTableInput.legalStatus;
            dd.incorporation = updateFpoTableInput.incorporation;
            dd.bankName = updateFpoTableInput.bankName;
            dd.bankAccountNo = updateFpoTableInput.bankAccountNo;
            dd.bankBranch = updateFpoTableInput.bankBranch;
            dd.bankIfsc = updateFpoTableInput.bankIfsc;
            let block = await this.blockTableService.findOne(updateFpoTableInput.blockId);
            dd.BlockTable = block;
            let result1 = await this.fpoTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_FPO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result1
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async remove(fpoId) {
        let result = await this.findOne(fpoId);
        if (result) {
            await this.fpoTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_FPO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
};
exports.FpoTableService = FpoTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(fpo_table_entity_1.FpoTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        block_table_service_1.BlockTableService])
], FpoTableService);
