import { GrampanchayatTableService } from './grampanchayat-table.service';
import { GrampanchayatTable } from './entities/grampanchayat-table.entity';
import { CreateGrampanchayatTableInput } from './dto/create-grampanchayat-table.input';
import { UpdateGrampanchayatTableInput } from './dto/update-grampanchayat-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_GP_ADD = "NEW_GP_ADD";
export declare class GrampanchayatTableResolver {
    private readonly grampanchayatTableService;
    private pubSub;
    constructor(grampanchayatTableService: GrampanchayatTableService, pubSub: RedisPubSub);
    createGrampanchayatTable(createGrampanchayatTableInput: CreateGrampanchayatTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: GrampanchayatTable;
    }>;
    findAllGramPanchayat(user: any): Promise<GrampanchayatTable[]>;
    findAllGramPanchayatByBlockId(user: any, blockId: number): Promise<GrampanchayatTable[]>;
    findOneGramPanchayat(gpId: number): Promise<GrampanchayatTable>;
    updateGrampanchayatTable(updateGrampanchayatTableInput: UpdateGrampanchayatTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: GrampanchayatTable;
    }>;
    removeGrampanchayatTable(gpId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    gramPanchayatSubscription(): AsyncIterator<unknown, any, undefined>;
}
