"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrampanchayatTableResolver = exports.NEW_GP_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const grampanchayat_table_service_1 = require("./grampanchayat-table.service");
const grampanchayat_table_entity_1 = require("./entities/grampanchayat-table.entity");
const create_grampanchayat_table_input_1 = require("./dto/create-grampanchayat-table.input");
const update_grampanchayat_table_input_1 = require("./dto/update-grampanchayat-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const role_enum_1 = require("../user-collection/roles/role.enum");
const grampanchayat_table_return_type_1 = require("./types/grampanchayat-table-return.type");
const grampanchayat_table_type_1 = require("./types/grampanchayat-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_GP_ADD = "NEW_GP_ADD";
let GrampanchayatTableResolver = exports.GrampanchayatTableResolver = class GrampanchayatTableResolver {
    constructor(grampanchayatTableService, pubSub) {
        this.grampanchayatTableService = grampanchayatTableService;
        this.pubSub = pubSub;
    }
    createGrampanchayatTable(createGrampanchayatTableInput) {
        return this.grampanchayatTableService.create(createGrampanchayatTableInput);
    }
    findAllGramPanchayat(user) {
        return this.grampanchayatTableService.findAll();
    }
    findAllGramPanchayatByBlockId(user, blockId) {
        return this.grampanchayatTableService.findAllByBlockId(blockId);
    }
    findOneGramPanchayat(gpId) {
        return this.grampanchayatTableService.findOne(gpId);
    }
    updateGrampanchayatTable(updateGrampanchayatTableInput) {
        return this.grampanchayatTableService.update(updateGrampanchayatTableInput.gpId, updateGrampanchayatTableInput);
    }
    removeGrampanchayatTable(gpId) {
        return this.grampanchayatTableService.remove(gpId);
    }
    gramPanchayatSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_GP_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => grampanchayat_table_return_type_1.GramPanchayatTableReturnType),
    __param(0, (0, graphql_1.Args)('createGrampanchayatTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_grampanchayat_table_input_1.CreateGrampanchayatTableInput]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "createGrampanchayatTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [grampanchayat_table_type_1.GramPanchayatTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "findAllGramPanchayat", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [grampanchayat_table_type_1.GramPanchayatTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('blockId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "findAllGramPanchayatByBlockId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => grampanchayat_table_type_1.GramPanchayatTableType),
    __param(0, (0, graphql_1.Args)('gpId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "findOneGramPanchayat", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => grampanchayat_table_return_type_1.GramPanchayatTableReturnType),
    __param(0, (0, graphql_1.Args)('updateGrampanchayatTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_grampanchayat_table_input_1.UpdateGrampanchayatTableInput]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "updateGrampanchayatTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => grampanchayat_table_return_type_1.GramPanchayatTableReturnType),
    __param(0, (0, graphql_1.Args)('gpId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "removeGrampanchayatTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], GrampanchayatTableResolver.prototype, "gramPanchayatSubscription", null);
exports.GrampanchayatTableResolver = GrampanchayatTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => grampanchayat_table_entity_1.GrampanchayatTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [grampanchayat_table_service_1.GrampanchayatTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], GrampanchayatTableResolver);
