import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateGrampanchayatTableInput } from './dto/create-grampanchayat-table.input';
import { UpdateGrampanchayatTableInput } from './dto/update-grampanchayat-table.input';
import { GrampanchayatTable } from './entities/grampanchayat-table.entity';
import { BlockTableService } from 'src/block-table/block-table.service';
export declare const NEW_GP_ADD = "NEW_GP_ADD";
export declare class GrampanchayatTableService {
    private readonly gramPanchayatTableRepository;
    private pubSub;
    private readonly blockTableService;
    constructor(gramPanchayatTableRepository: Repository<GrampanchayatTable>, pubSub: RedisPubSub, blockTableService: BlockTableService);
    create(createGrampanchayatTableInput: CreateGrampanchayatTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: GrampanchayatTable;
    }>;
    createorElseReturnObject(createGrampanchayatTableInput: CreateGrampanchayatTableInput): Promise<GrampanchayatTable>;
    checkIfExists(gpName: string, blockId: number): Promise<boolean>;
    getCount(): Promise<number>;
    findAll(): Promise<GrampanchayatTable[]>;
    findAllByBlockIds(ids: number[]): Promise<GrampanchayatTable[]>;
    findAllByBlockId(blockId: number): Promise<GrampanchayatTable[]>;
    findOne(gpId: number): Promise<GrampanchayatTable>;
    update(gpId: number, updateGrampanchayatTableInput: UpdateGrampanchayatTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: GrampanchayatTable;
    }>;
    remove(gpId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
