"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GrampanchayatTableService = exports.NEW_GP_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const grampanchayat_table_entity_1 = require("./entities/grampanchayat-table.entity");
const block_table_service_1 = require("../block-table/block-table.service");
exports.NEW_GP_ADD = "NEW_GP_ADD";
let GrampanchayatTableService = exports.GrampanchayatTableService = class GrampanchayatTableService {
    constructor(gramPanchayatTableRepository, pubSub, blockTableService) {
        this.gramPanchayatTableRepository = gramPanchayatTableRepository;
        this.pubSub = pubSub;
        this.blockTableService = blockTableService;
    }
    async create(createGrampanchayatTableInput) {
        let checkIfExists = await this.checkIfExists(createGrampanchayatTableInput.gpName, createGrampanchayatTableInput.blockId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new grampanchayat_table_entity_1.GrampanchayatTable();
            dd.gpName = createGrampanchayatTableInput.gpName;
            let block = await this.blockTableService.findOne(createGrampanchayatTableInput.blockId);
            dd.BlockTable = block;
            let result = await this.gramPanchayatTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_GP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async createorElseReturnObject(createGrampanchayatTableInput) {
        let checkIfAlreadyExists = await this.gramPanchayatTableRepository.findOne({
            where: {
                gpName: createGrampanchayatTableInput.gpName.trim(),
                BlockTable: {
                    blockId: createGrampanchayatTableInput.blockId
                }
            }
        });
        if (!checkIfAlreadyExists) {
            let dd = new grampanchayat_table_entity_1.GrampanchayatTable();
            dd.gpName = createGrampanchayatTableInput.gpName.trim();
            let block = await this.blockTableService.findOne(createGrampanchayatTableInput.blockId);
            dd.BlockTable = block;
            let result = await this.gramPanchayatTableRepository.save(dd);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfExists(gpName, blockId) {
        let result = await this.gramPanchayatTableRepository.count({
            where: {
                gpName: gpName,
                BlockTable: {
                    blockId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getCount() {
        return await this.gramPanchayatTableRepository.count();
    }
    async findAll() {
        return await this.gramPanchayatTableRepository.find({
            relations: {
                BlockTable: {
                    DistrictTable: {
                        StateTable: true
                    }
                }
            }
        });
    }
    async findAllByBlockIds(ids) {
        return await this.gramPanchayatTableRepository.find({
            where: {
                BlockTable: {
                    blockId: (0, typeorm_2.In)(ids)
                }
            },
            relations: {
                BlockTable: {
                    DistrictTable: {
                        StateTable: true
                    }
                }
            }
        });
    }
    async findAllByBlockId(blockId) {
        return await this.gramPanchayatTableRepository.find({
            where: {
                BlockTable: {
                    blockId
                }
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async findOne(gpId) {
        return await this.gramPanchayatTableRepository.findOne({
            where: {
                gpId: gpId
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async update(gpId, updateGrampanchayatTableInput) {
        let result = await this.gramPanchayatTableRepository.findOne({
            where: {
                gpId: gpId
            }
        });
        if (result) {
            result.gpName = updateGrampanchayatTableInput.gpName;
            let block = await this.blockTableService.findOne(updateGrampanchayatTableInput.blockId);
            result.BlockTable = block;
            let r = await this.gramPanchayatTableRepository.save(result);
            this.pubSub.publish(exports.NEW_GP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(gpId) {
        let result = await this.gramPanchayatTableRepository.findOne({
            where: {
                gpId: gpId
            }
        });
        if (result) {
            await this.gramPanchayatTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_GP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.GrampanchayatTableService = GrampanchayatTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(grampanchayat_table_entity_1.GrampanchayatTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        block_table_service_1.BlockTableService])
], GrampanchayatTableService);
