import { HealthCoverageTableService } from './health-coverage-table.service';
import { HealthCoverageTable } from './entities/health-coverage-table.entity';
import { CreateHealthCoverageTableInput } from './dto/create-health-coverage-table.input';
import { UpdateHealthCoverageTableInput } from './dto/update-health-coverage-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_COVERAGETYPE_ADD = "NEW_COVERAGETYPE_ADD";
export declare class HealthCoverageTableResolver {
    private readonly healthCoverageTableService;
    private pubSub;
    constructor(healthCoverageTableService: HealthCoverageTableService, pubSub: RedisPubSub);
    createHealthCoverageTable(createHealthCoverageTableInput: CreateHealthCoverageTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HealthCoverageTable;
    }>;
    findAllCoverageType(): Promise<HealthCoverageTable[]>;
    findOne(coverageId: number): Promise<HealthCoverageTable>;
    updateHealthCoverageTable(updateHealthCoverageTableInput: UpdateHealthCoverageTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HealthCoverageTable;
    }>;
    removeHealthCoverageTable(coverageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    healthCoverageSubscription(): AsyncIterator<unknown, any, undefined>;
}
