"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthCoverageTableResolver = exports.NEW_COVERAGETYPE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const health_coverage_table_service_1 = require("./health-coverage-table.service");
const health_coverage_table_entity_1 = require("./entities/health-coverage-table.entity");
const create_health_coverage_table_input_1 = require("./dto/create-health-coverage-table.input");
const update_health_coverage_table_input_1 = require("./dto/update-health-coverage-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const health_coverage_table_return_type_1 = require("./types/health-coverage-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const health_coverage_table_type_1 = require("./types/health-coverage-table.type");
const health_coverage_count_changed_type_1 = require("./types/health-coverage-count-changed.type");
exports.NEW_COVERAGETYPE_ADD = "NEW_COVERAGETYPE_ADD";
let HealthCoverageTableResolver = class HealthCoverageTableResolver {
    constructor(healthCoverageTableService, pubSub) {
        this.healthCoverageTableService = healthCoverageTableService;
        this.pubSub = pubSub;
    }
    createHealthCoverageTable(createHealthCoverageTableInput, user) {
        return this.healthCoverageTableService.create(createHealthCoverageTableInput, user);
    }
    findAllCoverageType() {
        return this.healthCoverageTableService.findAll();
    }
    findOne(coverageId) {
        return this.healthCoverageTableService.findOne(coverageId);
    }
    updateHealthCoverageTable(updateHealthCoverageTableInput, user) {
        return this.healthCoverageTableService.update(updateHealthCoverageTableInput.coverageId, updateHealthCoverageTableInput, user);
    }
    removeHealthCoverageTable(coverageId) {
        return this.healthCoverageTableService.remove(coverageId);
    }
    healthCoverageSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_COVERAGETYPE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => health_coverage_table_return_type_1.HealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('createHealthCoverageTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_health_coverage_table_input_1.CreateHealthCoverageTableInput, Object]),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "createHealthCoverageTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [health_coverage_table_type_1.HealthCoverageTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "findAllCoverageType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => health_coverage_table_type_1.HealthCoverageTableType),
    __param(0, (0, graphql_1.Args)('coverageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => health_coverage_table_return_type_1.HealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('updateHealthCoverageTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_health_coverage_table_input_1.UpdateHealthCoverageTableInput, Object]),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "updateHealthCoverageTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => health_coverage_table_return_type_1.HealthCoverageTableReturnType),
    __param(0, (0, graphql_1.Args)('coverageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "removeHealthCoverageTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => health_coverage_count_changed_type_1.HealthCoverageCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], HealthCoverageTableResolver.prototype, "healthCoverageSubscription", null);
HealthCoverageTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => health_coverage_table_entity_1.HealthCoverageTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [health_coverage_table_service_1.HealthCoverageTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], HealthCoverageTableResolver);
exports.HealthCoverageTableResolver = HealthCoverageTableResolver;
