import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateHealthCoverageTableInput } from './dto/create-health-coverage-table.input';
import { UpdateHealthCoverageTableInput } from './dto/update-health-coverage-table.input';
import { HealthCoverageTable } from './entities/health-coverage-table.entity';
export declare const NEW_COVERAGETYPE_ADD = "NEW_COVERAGETYPE_ADD";
export declare class HealthCoverageTableService {
    private readonly healthCoverageTableRepository;
    private pubSub;
    constructor(healthCoverageTableRepository: Repository<HealthCoverageTable>, pubSub: RedisPubSub);
    create(createHealthCoverageTableInput: CreateHealthCoverageTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HealthCoverageTable;
    }>;
    checkIfExists(createHealthCoverageTableInput: CreateHealthCoverageTableInput): Promise<boolean>;
    findAll(): Promise<HealthCoverageTable[]>;
    findOne(coverageId: number): Promise<HealthCoverageTable>;
    update(coverageId: number, updateHealthCoverageTableInput: UpdateHealthCoverageTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HealthCoverageTable;
    }>;
    remove(coverageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
