"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HealthCoverageTableService = exports.NEW_COVERAGETYPE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const health_coverage_table_entity_1 = require("./entities/health-coverage-table.entity");
exports.NEW_COVERAGETYPE_ADD = "NEW_COVERAGETYPE_ADD";
let HealthCoverageTableService = class HealthCoverageTableService {
    constructor(healthCoverageTableRepository, pubSub) {
        this.healthCoverageTableRepository = healthCoverageTableRepository;
        this.pubSub = pubSub;
    }
    async create(createHealthCoverageTableInput, user) {
        let checkIfExists = await this.checkIfExists(createHealthCoverageTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new health_coverage_table_entity_1.HealthCoverageTable();
            dd.coverageType = createHealthCoverageTableInput.coverageType;
            let result = await this.healthCoverageTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_COVERAGETYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createHealthCoverageTableInput) {
        let rr = await this.healthCoverageTableRepository.count({
            where: {
                coverageType: createHealthCoverageTableInput.coverageType,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.healthCoverageTableRepository.find();
    }
    async findOne(coverageId) {
        return await this.healthCoverageTableRepository.findOne({
            where: {
                coverageId: coverageId
            }
        });
    }
    async update(coverageId, updateHealthCoverageTableInput, user) {
        let ht = await this.healthCoverageTableRepository.findOne({
            where: {
                coverageId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.coverageType = updateHealthCoverageTableInput.coverageType;
            let result = await this.healthCoverageTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_COVERAGETYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(coverageId) {
        let ht = await this.healthCoverageTableRepository.findOne({
            where: {
                coverageId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.healthCoverageTableRepository.remove(ht);
            this.pubSub.publish(exports.NEW_COVERAGETYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
};
HealthCoverageTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(health_coverage_table_entity_1.HealthCoverageTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], HealthCoverageTableService);
exports.HealthCoverageTableService = HealthCoverageTableService;
