import { AnimalHealthCoverage } from 'src/animal-health-coverage/entities/animal-health-coverage.entity';
import { AnimalEntryTable } from 'src/animal-table/entities/animal-entry-table.entity';
import { AnimalVaccinationTable } from 'src/animal-vaccination/entities/animal-vaccination-table.entity';
import { BreedingSingleTable } from 'src/breeding-single-table/entities/breeding-single-table.entity';
import { ConsumptionTable } from 'src/consumption-table/entities/consumption-table.entity';
import { CurrentStockTable } from 'src/current-stock/entities/current-stock-table.entity';
import { FarmersTable } from 'src/farmers-table/entities/farmers-table.entity';
import { LedgerEntryTable } from 'src/ledger-table/entities/ledger-entry-table.entity';
import { PigInsuranceTable } from 'src/pig-insurance-table/entities/pig-insurance-table.entity';
import { StockBalanceTable } from 'src/stock-balance/entities/stock-balance-table.entity';
import { StockEntryTable } from 'src/stock-entry/entities/stock-entry-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
export declare enum YesNo {
    YES = "YES",
    NO = "NO"
}
export declare class HousingTable {
    housingId: number;
    FarmersTable: FarmersTable;
    StockEntryTable: StockEntryTable[];
    CurrentStockTable: CurrentStockTable[];
    StockBalanceTable: StockBalanceTable[];
    LedgerTable: LedgerEntryTable[];
    AnimalTable: AnimalEntryTable[];
    ConsumptionTable: ConsumptionTable[];
    AnimalVaccinationTable: AnimalVaccinationTable[];
    PigInsuranceTable: PigInsuranceTable[];
    AnimalHealthCoverage: AnimalHealthCoverage[];
    BreedingSingleTable: BreedingSingleTable[];
    isAvailable: YesNo;
    typesOfHouse: string;
    typeOfFarm: string;
    farmingArea: string;
    floor: string;
    hasSufficientFloor: YesNo;
    floorSpace: string;
    hasBoundaryWall: YesNo;
    hasDrainageFacility: YesNo;
    hasManurePit: YesNo;
    manurePitDetails: string;
    hasCleaningFacility: YesNo;
    hasWaterSource: YesNo;
    waterSourceDetails: string;
    hasUsedDisinfectants: YesNo;
    disinfectantDetails: string;
    frequencyOfCleaning: string;
    dateOfEntry: string;
    UserTable: UserTable;
    createdAt: Date;
    updatedAt: Date;
}
