"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HousingTable = exports.YesNo = void 0;
const animal_health_coverage_entity_1 = require("../../animal-health-coverage/entities/animal-health-coverage.entity");
const animal_entry_table_entity_1 = require("../../animal-table/entities/animal-entry-table.entity");
const animal_vaccination_table_entity_1 = require("../../animal-vaccination/entities/animal-vaccination-table.entity");
const breeding_single_table_entity_1 = require("../../breeding-single-table/entities/breeding-single-table.entity");
const consumption_table_entity_1 = require("../../consumption-table/entities/consumption-table.entity");
const current_stock_table_entity_1 = require("../../current-stock/entities/current-stock-table.entity");
const farmers_table_entity_1 = require("../../farmers-table/entities/farmers-table.entity");
const ledger_entry_table_entity_1 = require("../../ledger-table/entities/ledger-entry-table.entity");
const pig_insurance_table_entity_1 = require("../../pig-insurance-table/entities/pig-insurance-table.entity");
const stock_balance_table_entity_1 = require("../../stock-balance/entities/stock-balance-table.entity");
const stock_entry_table_entity_1 = require("../../stock-entry/entities/stock-entry-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
var YesNo;
(function (YesNo) {
    YesNo["YES"] = "YES";
    YesNo["NO"] = "NO";
})(YesNo = exports.YesNo || (exports.YesNo = {}));
let HousingTable = class HousingTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], HousingTable.prototype, "housingId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => farmers_table_entity_1.FarmersTable, et => et.HousingTable),
    (0, typeorm_1.JoinColumn)({ name: "farmerId" }),
    __metadata("design:type", farmers_table_entity_1.FarmersTable)
], HousingTable.prototype, "FarmersTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => stock_entry_table_entity_1.StockEntryTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "StockEntryTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => current_stock_table_entity_1.CurrentStockTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "CurrentStockTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => stock_balance_table_entity_1.StockBalanceTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "StockBalanceTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => ledger_entry_table_entity_1.LedgerEntryTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "LedgerTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_entry_table_entity_1.AnimalEntryTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "AnimalTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => consumption_table_entity_1.ConsumptionTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "ConsumptionTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_vaccination_table_entity_1.AnimalVaccinationTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "AnimalVaccinationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => pig_insurance_table_entity_1.PigInsuranceTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "PigInsuranceTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => animal_health_coverage_entity_1.AnimalHealthCoverage, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "AnimalHealthCoverage", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => breeding_single_table_entity_1.BreedingSingleTable, et => et.HousingTable),
    __metadata("design:type", Array)
], HousingTable.prototype, "BreedingSingleTable", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "isAvailable", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "typesOfHouse", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "typeOfFarm", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "farmingArea", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "floor", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasSufficientFloor", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "floorSpace", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasBoundaryWall", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasDrainageFacility", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasManurePit", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "manurePitDetails", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasCleaningFacility", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasWaterSource", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "waterSourceDetails", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: YesNo,
        nullable: true
    }),
    __metadata("design:type", String)
], HousingTable.prototype, "hasUsedDisinfectants", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "disinfectantDetails", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "frequencyOfCleaning", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], HousingTable.prototype, "dateOfEntry", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, et => et.HousingTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], HousingTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], HousingTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], HousingTable.prototype, "updatedAt", void 0);
HousingTable = __decorate([
    (0, typeorm_1.Entity)()
], HousingTable);
exports.HousingTable = HousingTable;
