import { HousingTableService } from './housing-table.service';
import { HousingTable } from './entities/housing-table.entity';
import { CreateHousingTableInput } from './dto/create-housing-table.input';
import { UpdateHousingTableInput } from './dto/update-housing-table.input';
export declare class HousingTableResolver {
    private readonly housingTableService;
    constructor(housingTableService: HousingTableService);
    createHousingTable(createHousingTableInput: CreateHousingTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTable;
    }>;
    findAllHousing(): Promise<HousingTable[]>;
    findOneHousing(housingId: number): Promise<HousingTable>;
    findHousingByFarmerId(farmerId: number): Promise<HousingTable[]>;
    updateHousingTable(updateHousingTableInput: UpdateHousingTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTable;
    }>;
    removeHousingTable(housingId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
