import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateHousingTableInput } from './dto/create-housing-table.input';
import { UpdateHousingTableInput } from './dto/update-housing-table.input';
import { HousingTable } from './entities/housing-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class HousingTableService {
    private readonly housingTableRepository;
    private readonly dataEntryTableService;
    private readonly userCollectionService;
    private readonly farmersTableService;
    constructor(housingTableRepository: Repository<HousingTable>, dataEntryTableService: DataEntryTableService, userCollectionService: UserCollectionService, farmersTableService: FarmersTableService);
    create(createHousingTableInput: CreateHousingTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTable;
    }>;
    countAllHousing(farmerId?: number): Promise<{
        organized: number;
        backyard: number;
    }>;
    countAllHousingArea(farmerId?: number): Promise<{
        organized: any;
        backyard: any;
    }>;
    countAllHousingAreaDistrictWise(districtId: number): Promise<{
        organized: any;
        backyard: any;
    }>;
    countAllHousingByDistAndDiv(districtId?: number, subDivisionId?: number): Promise<{
        organized: any;
        backyard: any;
    }>;
    checkIfExists(createHousingTableInput: CreateHousingTableInput): Promise<boolean>;
    findByFarmerId(farmerId: number): Promise<HousingTable[]>;
    findAll(): Promise<HousingTable[]>;
    findOne(housingId: number): Promise<HousingTable>;
    findOneByFarmerId(farmerId: number): Promise<HousingTable[]>;
    update(housingId: number, updateHousingTableInput: UpdateHousingTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTable;
    }>;
    remove(housingId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findSingleFarmerReport(districtId: number, subDivisionId: number, farmerId: number): Promise<void>;
}
