import { HousingTypeTableService } from './housing-type-table.service';
import { HousingTypeTable } from './entities/housing-type-table.entity';
import { CreateHousingTypeTableInput } from './dto/create-housing-type-table.input';
import { UpdateHousingTypeTableInput } from './dto/update-housing-type-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_TYPESOFHOUSES_ADD = "NEW_TYPESOFHOUSES_ADD";
export declare class HousingTypeTableResolver {
    private readonly housingTypeTableService;
    private pubSub;
    constructor(housingTypeTableService: HousingTypeTableService, pubSub: RedisPubSub);
    createHousingTypeTable(createHousingTypeTableInput: CreateHousingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTypeTable;
    }>;
    findAllTypesOfHouses(): Promise<HousingTypeTable[]>;
    findOneHousingType(housingTableTypeId: number): Promise<HousingTypeTable>;
    updateHousingTypeTable(updateHousingTypeTableInput: UpdateHousingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTypeTable;
    }>;
    removeHousingTypeTable(housingTableTypeId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    typesOfHousesSubscription(): AsyncIterator<unknown, any, undefined>;
}
