"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HousingTypeTableResolver = exports.NEW_TYPESOFHOUSES_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const housing_type_table_service_1 = require("./housing-type-table.service");
const housing_type_table_entity_1 = require("./entities/housing-type-table.entity");
const create_housing_type_table_input_1 = require("./dto/create-housing-type-table.input");
const update_housing_type_table_input_1 = require("./dto/update-housing-type-table.input");
const housing_type_table_type_1 = require("./types/housing-type-table.type");
const housing_type_table_return_type_1 = require("./types/housing-type-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const count_changed_type_1 = require("./types/count-changed.type");
exports.NEW_TYPESOFHOUSES_ADD = "NEW_TYPESOFHOUSES_ADD";
let HousingTypeTableResolver = class HousingTypeTableResolver {
    constructor(housingTypeTableService, pubSub) {
        this.housingTypeTableService = housingTypeTableService;
        this.pubSub = pubSub;
    }
    createHousingTypeTable(createHousingTypeTableInput) {
        return this.housingTypeTableService.create(createHousingTypeTableInput);
    }
    findAllTypesOfHouses() {
        return this.housingTypeTableService.findAll();
    }
    findOneHousingType(housingTableTypeId) {
        return this.housingTypeTableService.findOne(housingTableTypeId);
    }
    updateHousingTypeTable(updateHousingTypeTableInput) {
        return this.housingTypeTableService.update(updateHousingTypeTableInput.housingTableTypeId, updateHousingTypeTableInput);
    }
    removeHousingTypeTable(housingTableTypeId) {
        return this.housingTypeTableService.remove(housingTableTypeId);
    }
    typesOfHousesSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_TYPESOFHOUSES_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => housing_type_table_return_type_1.HousingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('createHousingTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_housing_type_table_input_1.CreateHousingTypeTableInput]),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "createHousingTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [housing_type_table_type_1.HousingTypeTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "findAllTypesOfHouses", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => housing_type_table_type_1.HousingTypeTableType),
    __param(0, (0, graphql_1.Args)('housingTableTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "findOneHousingType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => housing_type_table_return_type_1.HousingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('updateHousingTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_housing_type_table_input_1.UpdateHousingTypeTableInput]),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "updateHousingTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => housing_type_table_return_type_1.HousingTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('housingTableTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "removeHousingTypeTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.countchangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], HousingTypeTableResolver.prototype, "typesOfHousesSubscription", null);
HousingTypeTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => housing_type_table_entity_1.HousingTypeTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [housing_type_table_service_1.HousingTypeTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], HousingTypeTableResolver);
exports.HousingTypeTableResolver = HousingTypeTableResolver;
