import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateHousingTypeTableInput } from './dto/create-housing-type-table.input';
import { UpdateHousingTypeTableInput } from './dto/update-housing-type-table.input';
import { HousingTypeTable } from './entities/housing-type-table.entity';
export declare const NEW_TYPESOFHOUSES_ADD = "NEW_TYPESOFHOUSES_ADD";
export declare class HousingTypeTableService {
    private readonly housingTypeTableRepository;
    private pubSub;
    constructor(housingTypeTableRepository: Repository<HousingTypeTable>, pubSub: RedisPubSub);
    create(createHousingTypeTableInput: CreateHousingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTypeTable;
    }>;
    checkIfExists(housingTableTypeName: string): Promise<boolean>;
    findAll(): Promise<HousingTypeTable[]>;
    findOne(housingTableTypeId: number): Promise<HousingTypeTable>;
    update(housingTableTypeId: number, updateHousingTypeTableInput: UpdateHousingTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: HousingTypeTable;
    }>;
    remove(housingTableTypeId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
