"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HousingTypeTableService = exports.NEW_TYPESOFHOUSES_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const housing_type_table_entity_1 = require("./entities/housing-type-table.entity");
exports.NEW_TYPESOFHOUSES_ADD = "NEW_TYPESOFHOUSES_ADD";
let HousingTypeTableService = class HousingTypeTableService {
    constructor(housingTypeTableRepository, pubSub) {
        this.housingTypeTableRepository = housingTypeTableRepository;
        this.pubSub = pubSub;
    }
    async create(createHousingTypeTableInput) {
        let checkIfExists = await this.checkIfExists(createHousingTypeTableInput.housingTableTypeName);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new housing_type_table_entity_1.HousingTypeTable();
            dd.housingTableTypeName = createHousingTypeTableInput.housingTableTypeName;
            let result = await this.housingTypeTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_TYPESOFHOUSES_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(housingTableTypeName) {
        let result = await this.housingTypeTableRepository.count({
            where: {
                housingTableTypeName: housingTableTypeName
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.housingTypeTableRepository.find();
    }
    async findOne(housingTableTypeId) {
        return await this.housingTypeTableRepository.findOne({
            where: {
                housingTableTypeId: housingTableTypeId
            }
        });
    }
    async update(housingTableTypeId, updateHousingTypeTableInput) {
        let result = await this.housingTypeTableRepository.findOne({
            where: {
                housingTableTypeId: housingTableTypeId
            }
        });
        if (result) {
            result.housingTableTypeName = updateHousingTypeTableInput.housingTableTypeName;
            let r = await this.housingTypeTableRepository.save(result);
            this.pubSub.publish(exports.NEW_TYPESOFHOUSES_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(housingTableTypeId) {
        let result = await this.housingTypeTableRepository.findOne({
            where: {
                housingTableTypeId: housingTableTypeId
            }
        });
        if (result) {
            await this.housingTypeTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_TYPESOFHOUSES_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
HousingTypeTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(housing_type_table_entity_1.HousingTypeTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], HousingTypeTableService);
exports.HousingTypeTableService = HousingTypeTableService;
