import { IncomeSourceTableService } from './income-source-table.service';
import { IncomeSourceTable } from './entities/income-source-table.entity';
import { CreateIncomeSourceTableInput } from './dto/create-income-source-table.input';
import { UpdateIncomeSourceTableInput } from './dto/update-income-source-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_INCOME_SOURCE_ADD = "NEW_INCOME_SOURCE_ADD";
export declare class IncomeSourceTableResolver {
    private readonly incomeSourceTableService;
    private pubSub;
    constructor(incomeSourceTableService: IncomeSourceTableService, pubSub: RedisPubSub);
    createIncomeSourceTable(createIncomeSourceTableInput: CreateIncomeSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IncomeSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllIncomeSource(): Promise<IncomeSourceTable[]>;
    findOneIncomeSource(incomeSourceId: number): Promise<IncomeSourceTable>;
    updateIncomeSourceTable(updateIncomeSourceTableInput: UpdateIncomeSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IncomeSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeIncomeSourceTable(incomeSourceId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    incomeSourceSubscription(): AsyncIterator<unknown, any, undefined>;
}
