"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IncomeSourceTableResolver = exports.NEW_INCOME_SOURCE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const income_source_table_service_1 = require("./income-source-table.service");
const income_source_table_entity_1 = require("./entities/income-source-table.entity");
const create_income_source_table_input_1 = require("./dto/create-income-source-table.input");
const update_income_source_table_input_1 = require("./dto/update-income-source-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const income_source_table_return_type_1 = require("./types/income-source-table-return.type");
const income_source_table_type_1 = require("./types/income-source-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_INCOME_SOURCE_ADD = "NEW_INCOME_SOURCE_ADD";
let IncomeSourceTableResolver = exports.IncomeSourceTableResolver = class IncomeSourceTableResolver {
    constructor(incomeSourceTableService, pubSub) {
        this.incomeSourceTableService = incomeSourceTableService;
        this.pubSub = pubSub;
    }
    createIncomeSourceTable(createIncomeSourceTableInput) {
        return this.incomeSourceTableService.create(createIncomeSourceTableInput);
    }
    findAllIncomeSource() {
        return this.incomeSourceTableService.findAll();
    }
    findOneIncomeSource(incomeSourceId) {
        return this.incomeSourceTableService.findOne(incomeSourceId);
    }
    updateIncomeSourceTable(updateIncomeSourceTableInput) {
        return this.incomeSourceTableService.update(updateIncomeSourceTableInput.incomeSourceId, updateIncomeSourceTableInput);
    }
    removeIncomeSourceTable(incomeSourceId) {
        return this.incomeSourceTableService.remove(incomeSourceId);
    }
    incomeSourceSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_INCOME_SOURCE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => income_source_table_return_type_1.IncomeSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('createIncomeSourceTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_income_source_table_input_1.CreateIncomeSourceTableInput]),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "createIncomeSourceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [income_source_table_type_1.IncomeSourceTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "findAllIncomeSource", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => income_source_table_type_1.IncomeSourceTableType),
    __param(0, (0, graphql_1.Args)('incomeSourceId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "findOneIncomeSource", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => income_source_table_return_type_1.IncomeSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('updateIncomeSourceTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_income_source_table_input_1.UpdateIncomeSourceTableInput]),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "updateIncomeSourceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => income_source_table_return_type_1.IncomeSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('incomeSourceId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "removeIncomeSourceTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IncomeSourceTableResolver.prototype, "incomeSourceSubscription", null);
exports.IncomeSourceTableResolver = IncomeSourceTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => income_source_table_entity_1.IncomeSourceTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [income_source_table_service_1.IncomeSourceTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], IncomeSourceTableResolver);
