import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateIncomeSourceTableInput } from './dto/create-income-source-table.input';
import { UpdateIncomeSourceTableInput } from './dto/update-income-source-table.input';
import { IncomeSourceTable } from './entities/income-source-table.entity';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
export declare const NEW_INCOME_SOURCE_ADD = "NEW_INCOME_SOURCE_ADD";
export declare class IncomeSourceTableService {
    private readonly incomeSourceTableRepository;
    private pubSub;
    private readonly livelihoodSourceTableService;
    constructor(incomeSourceTableRepository: Repository<IncomeSourceTable>, pubSub: RedisPubSub, livelihoodSourceTableService: LivelihoodSourceTableService);
    create(createIncomeSourceTableInput: CreateIncomeSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IncomeSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createIncomeSourceTableInput: CreateIncomeSourceTableInput): Promise<IncomeSourceTable>;
    checkIfAlreadyExists(createIncomeSourceTableInput: CreateIncomeSourceTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<IncomeSourceTable[]>;
    findOne(incomeSourceId: number): Promise<IncomeSourceTable>;
    findAllHeader(): Promise<IncomeSourceTable[]>;
    update(incomeSourceId: number, updateIncomeSourceTableInput: UpdateIncomeSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IncomeSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(incomeSourceId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
