"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IncomeSourceTableService = exports.NEW_INCOME_SOURCE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const income_source_table_entity_1 = require("./entities/income-source-table.entity");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
exports.NEW_INCOME_SOURCE_ADD = "NEW_INCOME_SOURCE_ADD";
let IncomeSourceTableService = exports.IncomeSourceTableService = class IncomeSourceTableService {
    constructor(incomeSourceTableRepository, pubSub, livelihoodSourceTableService) {
        this.incomeSourceTableRepository = incomeSourceTableRepository;
        this.pubSub = pubSub;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
    }
    async create(createIncomeSourceTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createIncomeSourceTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new income_source_table_entity_1.IncomeSourceTable();
            st.incomeSourceCode = createIncomeSourceTableInput.incomeSourceCode;
            st.incomeSourceName = createIncomeSourceTableInput.incomeSourceName;
            let result = await this.incomeSourceTableRepository.save(st);
            this.pubSub.publish(exports.NEW_INCOME_SOURCE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createIncomeSourceTableInput) {
        let checkIfAlreadyExists = await this.incomeSourceTableRepository.findOne({
            where: {
                incomeSourceCode: createIncomeSourceTableInput.incomeSourceCode.trim(),
                incomeSourceName: createIncomeSourceTableInput.incomeSourceName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new income_source_table_entity_1.IncomeSourceTable();
            st.incomeSourceName = createIncomeSourceTableInput.incomeSourceName.trim();
            let result = await this.incomeSourceTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createIncomeSourceTableInput) {
        let result = await this.incomeSourceTableRepository.count({
            where: {
                incomeSourceCode: createIncomeSourceTableInput.incomeSourceCode,
                incomeSourceName: createIncomeSourceTableInput.incomeSourceName
            }
        });
        return result;
    }
    async getCount() {
        return await this.incomeSourceTableRepository.count();
    }
    async findAll() {
        return await this.incomeSourceTableRepository.find();
    }
    async findOne(incomeSourceId) {
        return await this.incomeSourceTableRepository.findOne({
            where: {
                incomeSourceId
            }
        });
    }
    async findAllHeader() {
        let result = await this.incomeSourceTableRepository.find({
            where: {
                needInIntervention: "YES"
            },
        });
        let index = 0;
        for (const r of result) {
            result[index]['lsData'] = await this.livelihoodSourceTableService.findAllByIncomeActivityCode(r.incomeSourceCode);
            index++;
        }
        return result;
    }
    async update(incomeSourceId, updateIncomeSourceTableInput) {
        let result = await this.findOne(incomeSourceId);
        if (result) {
            result.incomeSourceCode = updateIncomeSourceTableInput.incomeSourceCode;
            result.incomeSourceName = updateIncomeSourceTableInput.incomeSourceName;
            let updatedResult = await this.incomeSourceTableRepository.save(result);
            this.pubSub.publish(exports.NEW_INCOME_SOURCE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(incomeSourceId) {
        let result = await this.findOne(incomeSourceId);
        if (result) {
            await this.incomeSourceTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_INCOME_SOURCE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.IncomeSourceTableService = IncomeSourceTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(income_source_table_entity_1.IncomeSourceTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        livelihood_source_table_service_1.LivelihoodSourceTableService])
], IncomeSourceTableService);
