import { IngredientTableService } from './ingredient-table.service';
import { IngredientTable } from './entities/ingredient-table.entity';
import { CreateIngredientTableInput } from './dto/create-ingredient-table.input';
import { UpdateIngredientTableInput } from './dto/update-ingredient-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_INGREDIENT_ADD = "NEW_INGREDIENT_ADD";
export declare class IngredientTableResolver {
    private readonly ingredientTableService;
    private pubSub;
    constructor(ingredientTableService: IngredientTableService, pubSub: RedisPubSub);
    createIngredientTable(createIngredientTableInput: CreateIngredientTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: IngredientTable;
    }>;
    findAllIngredient(): Promise<IngredientTable[]>;
    findOneIngredient(ingredientId: number): Promise<IngredientTable>;
    updateIngredientTable(updateIngredientTableInput: UpdateIngredientTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: IngredientTable;
    }>;
    removeIngredientTable(ingredientId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    ingredientSubscription(): AsyncIterator<unknown, any, undefined>;
}
