"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IngredientTableResolver = exports.NEW_INGREDIENT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const ingredient_table_service_1 = require("./ingredient-table.service");
const ingredient_table_entity_1 = require("./entities/ingredient-table.entity");
const create_ingredient_table_input_1 = require("./dto/create-ingredient-table.input");
const update_ingredient_table_input_1 = require("./dto/update-ingredient-table.input");
const ingredient_table_type_1 = require("./types/ingredient-table.type");
const ingredient_table_return_type_1 = require("./types/ingredient-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const ingredient_count_changed_type_1 = require("./types/ingredient-count-changed.type");
exports.NEW_INGREDIENT_ADD = "NEW_INGREDIENT_ADD";
let IngredientTableResolver = class IngredientTableResolver {
    constructor(ingredientTableService, pubSub) {
        this.ingredientTableService = ingredientTableService;
        this.pubSub = pubSub;
    }
    createIngredientTable(createIngredientTableInput, user) {
        return this.ingredientTableService.create(createIngredientTableInput, user);
    }
    findAllIngredient() {
        return this.ingredientTableService.findAll();
    }
    findOneIngredient(ingredientId) {
        return this.ingredientTableService.findOne(ingredientId);
    }
    updateIngredientTable(updateIngredientTableInput, user) {
        return this.ingredientTableService.update(updateIngredientTableInput.ingredientId, updateIngredientTableInput, user);
    }
    removeIngredientTable(ingredientId) {
        return this.ingredientTableService.remove(ingredientId);
    }
    ingredientSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_INGREDIENT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ingredient_table_return_type_1.IngredientTableReturnType),
    __param(0, (0, graphql_1.Args)('createIngredientTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_ingredient_table_input_1.CreateIngredientTableInput, Object]),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "createIngredientTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ingredient_table_type_1.IngredientTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "findAllIngredient", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => ingredient_table_type_1.IngredientTableType),
    __param(0, (0, graphql_1.Args)('ingredientId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "findOneIngredient", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ingredient_table_return_type_1.IngredientTableReturnType),
    __param(0, (0, graphql_1.Args)('updateIngredientTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_ingredient_table_input_1.UpdateIngredientTableInput, Object]),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "updateIngredientTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ingredient_table_return_type_1.IngredientTableReturnType),
    __param(0, (0, graphql_1.Args)('ingredientId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "removeIngredientTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => ingredient_count_changed_type_1.IngredientCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IngredientTableResolver.prototype, "ingredientSubscription", null);
IngredientTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => ingredient_table_entity_1.IngredientTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [ingredient_table_service_1.IngredientTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], IngredientTableResolver);
exports.IngredientTableResolver = IngredientTableResolver;
