import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateIngredientTableInput } from './dto/create-ingredient-table.input';
import { UpdateIngredientTableInput } from './dto/update-ingredient-table.input';
import { IngredientTable } from './entities/ingredient-table.entity';
export declare const NEW_INGREDIENT_ADD = "NEW_INGREDIENT_ADD";
export declare class IngredientTableService {
    private readonly ingredientTableRepository;
    private pubSub;
    constructor(ingredientTableRepository: Repository<IngredientTable>, pubSub: RedisPubSub);
    create(createIngredientTableInput: CreateIngredientTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: IngredientTable;
    }>;
    checkIfExists(createIngredientTableInput: CreateIngredientTableInput): Promise<boolean>;
    findAll(): Promise<IngredientTable[]>;
    findOne(ingredientId: number): Promise<IngredientTable>;
    update(ingredientId: number, updateIngredientTableInput: UpdateIngredientTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: IngredientTable;
    }>;
    remove(ingredientId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
