"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IngredientTableService = exports.NEW_INGREDIENT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const ingredient_table_entity_1 = require("./entities/ingredient-table.entity");
exports.NEW_INGREDIENT_ADD = "NEW_INGREDIENT_ADD";
let IngredientTableService = class IngredientTableService {
    constructor(ingredientTableRepository, pubSub) {
        this.ingredientTableRepository = ingredientTableRepository;
        this.pubSub = pubSub;
    }
    async create(createIngredientTableInput, user) {
        let checkIfExists = await this.checkIfExists(createIngredientTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new ingredient_table_entity_1.IngredientTable();
            dd.ingredientName = createIngredientTableInput.ingredientName;
            dd.ingredientUnit = createIngredientTableInput.ingredientUnit;
            let result = await this.ingredientTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_INGREDIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createIngredientTableInput) {
        let rr = await this.ingredientTableRepository.count({
            where: {
                ingredientName: createIngredientTableInput.ingredientName,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.ingredientTableRepository.find();
    }
    async findOne(ingredientId) {
        return await this.ingredientTableRepository.findOne({
            where: {
                ingredientId: ingredientId
            }
        });
    }
    async update(ingredientId, updateIngredientTableInput, user) {
        let ht = await this.ingredientTableRepository.findOne({
            where: {
                ingredientId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.ingredientName = updateIngredientTableInput.ingredientName;
            ht.ingredientUnit = updateIngredientTableInput.ingredientUnit;
            let result = await this.ingredientTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_INGREDIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(ingredientId) {
        let ht = await this.ingredientTableRepository.findOne({
            where: {
                ingredientId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.ingredientTableRepository.remove(ht);
            this.pubSub.publish(exports.NEW_INGREDIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
};
IngredientTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ingredient_table_entity_1.IngredientTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], IngredientTableService);
exports.IngredientTableService = IngredientTableService;
