"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionAdoptionIpdmTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const intervention_adoption_ipdm_table_entity_1 = require("./entities/intervention-adoption-ipdm-table.entity");
const typeorm_2 = require("typeorm");
const ls_ipdm_master_table_service_1 = require("../ls-ipdm-master-table/ls-ipdm-master-table.service");
let InterventionAdoptionIpdmTableService = exports.InterventionAdoptionIpdmTableService = class InterventionAdoptionIpdmTableService {
    constructor(interventionAdoptionIpdmTableRepository, lsIpdmMasterTableService) {
        this.interventionAdoptionIpdmTableRepository = interventionAdoptionIpdmTableRepository;
        this.lsIpdmMasterTableService = lsIpdmMasterTableService;
    }
    async createBulk(ids, InterventionAdoptionTable) {
        await this.removeById(InterventionAdoptionTable.interventionAdoptionId);
        let result = [];
        for (const el of ids) {
            let rr = await this.create(el, InterventionAdoptionTable);
            result.push(rr);
        }
        return result;
    }
    async create(id, InterventionAdoptionTable) {
        let checkIfExists = await this.checkIfExists(id, InterventionAdoptionTable.interventionAdoptionId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new intervention_adoption_ipdm_table_entity_1.InterventionAdoptionIpdmTable();
            let lsTypeData = await this.lsIpdmMasterTableService.findOne(id);
            dd.LsIpdmMasterTable = lsTypeData;
            dd.InterventionAdoptionTable = InterventionAdoptionTable;
            let result = await this.interventionAdoptionIpdmTableRepository.save(dd);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(id, interventionAdoptionId) {
        let result = await this.interventionAdoptionIpdmTableRepository.count({
            where: {
                LsIpdmMasterTable: {
                    lsIpdmMasterId: id
                },
                InterventionAdoptionTable: {
                    interventionAdoptionId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getBySurveyId(interventionAdoptionId) {
        let result = await this.interventionAdoptionIpdmTableRepository.find({
            where: {
                InterventionAdoptionTable: {
                    interventionAdoptionId
                }
            }
        });
        return result;
    }
    async removeById(interventionAdoptionId) {
        let result = await this.interventionAdoptionIpdmTableRepository.find({
            where: {
                InterventionAdoptionTable: {
                    interventionAdoptionId
                }
            }
        });
        if (result.length > 0) {
            await this.interventionAdoptionIpdmTableRepository.remove(result);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.InterventionAdoptionIpdmTableService = InterventionAdoptionIpdmTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(intervention_adoption_ipdm_table_entity_1.InterventionAdoptionIpdmTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => ls_ipdm_master_table_service_1.LsIpdmMasterTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        ls_ipdm_master_table_service_1.LsIpdmMasterTableService])
], InterventionAdoptionIpdmTableService);
