"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionAdoptionTable = void 0;
const income_source_table_entity_1 = require("../../income-source-table/entities/income-source-table.entity");
const intervention_adoption_feed_table_entity_1 = require("../../intervention-adoption-feed-table/entities/intervention-adoption-feed-table.entity");
const intervention_adoption_ipdm_table_entity_1 = require("../../intervention-adoption-ipdm-table/entities/intervention-adoption-ipdm-table.entity");
const intervention_adoption_irrigation_table_entity_1 = require("../../intervention-adoption-irrigation-table/entities/intervention-adoption-irrigation-table.entity");
const intervention_adoption_organic_table_entity_1 = require("../../intervention-adoption-organic-table/entities/intervention-adoption-organic-table.entity");
const intervention_adoption_pop_table_entity_1 = require("../../intervention-adoption-pop-table/entities/intervention-adoption-pop-table.entity");
const intervention_adoption_sub_type_table_entity_1 = require("../../intervention-adoption-sub-type-table/entities/intervention-adoption-sub-type-table.entity");
const intervention_adoption_type_table_entity_1 = require("../../intervention-adoption-type-table/entities/intervention-adoption-type-table.entity");
const intervention_adoption_vaccination_table_entity_1 = require("../../intervention-adoption-vaccination-table/entities/intervention-adoption-vaccination-table.entity");
const intervention_table_entity_1 = require("../../intervention-table/entities/intervention-table.entity");
const livelihood_source_table_entity_1 = require("../../livelihood-source-table/entities/livelihood-source-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
let InterventionAdoptionTable = exports.InterventionAdoptionTable = class InterventionAdoptionTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], InterventionAdoptionTable.prototype, "interventionAdoptionId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => intervention_table_entity_1.InterventionTable, dt => dt.InterventionAdoptionTable),
    (0, typeorm_1.JoinColumn)({ name: "interventionId" }),
    __metadata("design:type", intervention_table_entity_1.InterventionTable)
], InterventionAdoptionTable.prototype, "InterventionTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 200, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "season", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => income_source_table_entity_1.IncomeSourceTable, dt => dt.InterventionAdoptionTable),
    (0, typeorm_1.JoinColumn)({ name: "incomeSourceId" }),
    __metadata("design:type", income_source_table_entity_1.IncomeSourceTable)
], InterventionAdoptionTable.prototype, "IncomeSourceTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => livelihood_source_table_entity_1.LivelihoodSourceTable, dt => dt.InterventionAdoptionTable),
    (0, typeorm_1.JoinColumn)({ name: "lsId" }),
    __metadata("design:type", livelihood_source_table_entity_1.LivelihoodSourceTable)
], InterventionAdoptionTable.prototype, "LivelihoodSourceTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], InterventionAdoptionTable.prototype, "year", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "entryDate", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "areaOfLand", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "areaOfLandUnit", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 100, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "conversionToBigha", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "herdSize", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "irrigationReceived", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "flockSize", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "shedConstructed", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "sourceOfLeverage", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'simple-array', nullable: true }),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "sourceOfLeverages", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: 'json', nullable: true }),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "sourceOfLeverageData", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "schemeAvailed", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "amountLeveraged", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "vaccinationDone", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "pondSize", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "fingerlings", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "newPondConstructed", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "breedingUnitConstructed", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 300, nullable: true }),
    __metadata("design:type", String)
], InterventionAdoptionTable.prototype, "noOfVerminBed", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, dt => dt.InterventionAdoptionTable),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], InterventionAdoptionTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_type_table_entity_1.InterventionAdoptionTypeTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionTypeTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_ipdm_table_entity_1.InterventionAdoptionIpdmTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionIpdmTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_organic_table_entity_1.InterventionAdoptionOrganicTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionOrganicTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_pop_table_entity_1.InterventionAdoptionPopTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionPopTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_sub_type_table_entity_1.InterventionAdoptionSubTypeTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionSubTypeTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_irrigation_table_entity_1.InterventionAdoptionIrrigationTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionIrrigationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_feed_table_entity_1.InterventionAdoptionFeedTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionFeedTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_vaccination_table_entity_1.InterventionAdoptionVaccinationTable, et => et.InterventionAdoptionTable),
    __metadata("design:type", Array)
], InterventionAdoptionTable.prototype, "InterventionAdoptionVaccinationTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], InterventionAdoptionTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], InterventionAdoptionTable.prototype, "updatedAt", void 0);
exports.InterventionAdoptionTable = InterventionAdoptionTable = __decorate([
    (0, typeorm_1.Entity)()
], InterventionAdoptionTable);
