"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionAdoptionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const intervention_adoption_table_service_1 = require("./intervention-adoption-table.service");
const intervention_adoption_table_entity_1 = require("./entities/intervention-adoption-table.entity");
const create_intervention_adoption_table_input_1 = require("./dto/create-intervention-adoption-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const Intervention_adoption_table_return_type_1 = require("./types/Intervention-adoption-table-return.type");
const intervention_adoption_table_type_1 = require("./types/intervention-adoption-table.type");
let InterventionAdoptionTableResolver = exports.InterventionAdoptionTableResolver = class InterventionAdoptionTableResolver {
    constructor(interventionAdoptionTableService) {
        this.interventionAdoptionTableService = interventionAdoptionTableService;
    }
    createInterventionAdoptionTable(createInterventionAdoptionTableInputMain, user) {
        return this.interventionAdoptionTableService.create(createInterventionAdoptionTableInputMain, user);
    }
    findOneAdoptionByInterventionId(interventionId) {
        return this.interventionAdoptionTableService.findOneAdoptionByInterventionId(interventionId);
    }
    findOneAdoptionByInterventionIdLsId(interventionId, lsId) {
        return this.interventionAdoptionTableService.findOneAdoptionByInterventionIdLsId(interventionId, lsId);
    }
    updateInterventionAdoptionTable(createInterventionAdoptionTableInputMain, user) {
        return this.interventionAdoptionTableService.update(createInterventionAdoptionTableInputMain.interventionId, createInterventionAdoptionTableInputMain, user);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => Intervention_adoption_table_return_type_1.InterventionAdoptionTableReturnType),
    __param(0, (0, graphql_1.Args)('createInterventionAdoptionTableInputMain')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_intervention_adoption_table_input_1.CreateInterventionAdoptionTableInputMain, Object]),
    __metadata("design:returntype", void 0)
], InterventionAdoptionTableResolver.prototype, "createInterventionAdoptionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [intervention_adoption_table_type_1.InterventionAdoptionTableType]),
    __param(0, (0, graphql_1.Args)('interventionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], InterventionAdoptionTableResolver.prototype, "findOneAdoptionByInterventionId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [intervention_adoption_table_type_1.InterventionAdoptionTableType]),
    __param(0, (0, graphql_1.Args)('interventionId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('lsId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", void 0)
], InterventionAdoptionTableResolver.prototype, "findOneAdoptionByInterventionIdLsId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => Intervention_adoption_table_return_type_1.InterventionAdoptionTableReturnType),
    __param(0, (0, graphql_1.Args)('createInterventionAdoptionTableInputMain')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_intervention_adoption_table_input_1.CreateInterventionAdoptionTableInputMain, Object]),
    __metadata("design:returntype", void 0)
], InterventionAdoptionTableResolver.prototype, "updateInterventionAdoptionTable", null);
exports.InterventionAdoptionTableResolver = InterventionAdoptionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => intervention_adoption_table_entity_1.InterventionAdoptionTable),
    __metadata("design:paramtypes", [intervention_adoption_table_service_1.InterventionAdoptionTableService])
], InterventionAdoptionTableResolver);
