import { CreateInterventionAdoptionTableInputMain } from './dto/create-intervention-adoption-table.input';
import { InterventionAdoptionTable } from './entities/intervention-adoption-table.entity';
import { Repository } from 'typeorm';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { InterventionTableService } from 'src/intervention-table/intervention-table.service';
import { InterventionAdoptionTypeTableService } from 'src/intervention-adoption-type-table/intervention-adoption-type-table.service';
import { InterventionAdoptionSubTypeTableService } from 'src/intervention-adoption-sub-type-table/intervention-adoption-sub-type-table.service';
import { InterventionAdoptionPopTableService } from 'src/intervention-adoption-pop-table/intervention-adoption-pop-table.service';
import { InterventionAdoptionIpdmTableService } from 'src/intervention-adoption-ipdm-table/intervention-adoption-ipdm-table.service';
import { InterventionAdoptionOrganicTableService } from 'src/intervention-adoption-organic-table/intervention-adoption-organic-table.service';
import { InterventionAdoptionIrrigationTableService } from 'src/intervention-adoption-irrigation-table/intervention-adoption-irrigation-table.service';
import { InterventionAdoptionFeedTableService } from 'src/intervention-adoption-feed-table/intervention-adoption-feed-table.service';
import { InterventionAdoptionVaccinationTableService } from 'src/intervention-adoption-vaccination-table/intervention-adoption-vaccination-table.service';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
import { IncomeSourceTableService } from 'src/income-source-table/income-source-table.service';
import { VaccinationMasterTableService } from 'src/vaccination-master-table/vaccination-master-table.service';
import { LsIpdmMasterTableService } from 'src/ls-ipdm-master-table/ls-ipdm-master-table.service';
import { OrganicMethodMasterService } from 'src/organic-method-master/organic-method-master.service';
export declare class InterventionAdoptionTableService {
    private readonly interventionAdoptionTableRepository;
    private readonly userCollectionService;
    private readonly interventionTableService;
    private readonly InterventionAdoptionTypeTableService;
    private readonly InterventionAdoptionSubTypeTableService;
    private readonly InterventionAdoptionPopTableService;
    private readonly InterventionAdoptionIpdmTableService;
    private readonly InterventionAdoptionOrganicTableService;
    private readonly InterventionAdoptionIrrigationTableService;
    private readonly InterventionAdoptionFeedTableService;
    private readonly InterventionAdoptionVaccinationTableService;
    private readonly LivelihoodSourceTableService;
    private readonly IncomeSourceTableService;
    private readonly vaccinationMasterTableService;
    private readonly lsIpdmMasterTableService;
    private readonly organicMethodMasterService;
    constructor(interventionAdoptionTableRepository: Repository<InterventionAdoptionTable>, userCollectionService: UserCollectionService, interventionTableService: InterventionTableService, InterventionAdoptionTypeTableService: InterventionAdoptionTypeTableService, InterventionAdoptionSubTypeTableService: InterventionAdoptionSubTypeTableService, InterventionAdoptionPopTableService: InterventionAdoptionPopTableService, InterventionAdoptionIpdmTableService: InterventionAdoptionIpdmTableService, InterventionAdoptionOrganicTableService: InterventionAdoptionOrganicTableService, InterventionAdoptionIrrigationTableService: InterventionAdoptionIrrigationTableService, InterventionAdoptionFeedTableService: InterventionAdoptionFeedTableService, InterventionAdoptionVaccinationTableService: InterventionAdoptionVaccinationTableService, LivelihoodSourceTableService: LivelihoodSourceTableService, IncomeSourceTableService: IncomeSourceTableService, vaccinationMasterTableService: VaccinationMasterTableService, lsIpdmMasterTableService: LsIpdmMasterTableService, organicMethodMasterService: OrganicMethodMasterService);
    create(createInterventionAdoptionTableInputMain: CreateInterventionAdoptionTableInputMain, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAll(): string;
    findOneAdoptionByInterventionId(interventionId: number): Promise<InterventionAdoptionTable[]>;
    findOneAdoptionByInterventionIdLsId(interventionId: number, lsId: number): Promise<InterventionAdoptionTable[]>;
    update(interventionId: number, createInterventionAdoptionTableInputMain: CreateInterventionAdoptionTableInputMain, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(id: number): string;
    removeByInterventionId(interventionId: number): Promise<boolean>;
    removeByInterventionIdAndLsId(interventionId: number, lsId: number): Promise<boolean>;
    getInterventionAdoptionReport(sessionId: number, stateId: number, districtId: number, blockId: number, type: string): Promise<any>;
    checkAdoptedOrNot(mkData: any[], sessionId: number): Promise<any[]>;
}
