"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionAdoptionTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const intervention_adoption_table_entity_1 = require("./entities/intervention-adoption-table.entity");
const typeorm_2 = require("typeorm");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const intervention_table_service_1 = require("../intervention-table/intervention-table.service");
const intervention_adoption_type_table_service_1 = require("../intervention-adoption-type-table/intervention-adoption-type-table.service");
const intervention_adoption_sub_type_table_service_1 = require("../intervention-adoption-sub-type-table/intervention-adoption-sub-type-table.service");
const intervention_adoption_pop_table_service_1 = require("../intervention-adoption-pop-table/intervention-adoption-pop-table.service");
const intervention_adoption_ipdm_table_service_1 = require("../intervention-adoption-ipdm-table/intervention-adoption-ipdm-table.service");
const intervention_adoption_organic_table_service_1 = require("../intervention-adoption-organic-table/intervention-adoption-organic-table.service");
const intervention_adoption_irrigation_table_service_1 = require("../intervention-adoption-irrigation-table/intervention-adoption-irrigation-table.service");
const intervention_adoption_feed_table_service_1 = require("../intervention-adoption-feed-table/intervention-adoption-feed-table.service");
const intervention_adoption_vaccination_table_service_1 = require("../intervention-adoption-vaccination-table/intervention-adoption-vaccination-table.service");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
const moment_1 = __importDefault(require("moment"));
const HelperFunctions_1 = require("../helper/HelperFunctions");
const income_source_table_service_1 = require("../income-source-table/income-source-table.service");
const vaccination_master_table_service_1 = require("../vaccination-master-table/vaccination-master-table.service");
const ls_ipdm_master_table_service_1 = require("../ls-ipdm-master-table/ls-ipdm-master-table.service");
const organic_method_master_service_1 = require("../organic-method-master/organic-method-master.service");
const GlobalConstants_1 = require("../helper/GlobalConstants");
let InterventionAdoptionTableService = exports.InterventionAdoptionTableService = class InterventionAdoptionTableService {
    constructor(interventionAdoptionTableRepository, userCollectionService, interventionTableService, InterventionAdoptionTypeTableService, InterventionAdoptionSubTypeTableService, InterventionAdoptionPopTableService, InterventionAdoptionIpdmTableService, InterventionAdoptionOrganicTableService, InterventionAdoptionIrrigationTableService, InterventionAdoptionFeedTableService, InterventionAdoptionVaccinationTableService, LivelihoodSourceTableService, IncomeSourceTableService, vaccinationMasterTableService, lsIpdmMasterTableService, organicMethodMasterService) {
        this.interventionAdoptionTableRepository = interventionAdoptionTableRepository;
        this.userCollectionService = userCollectionService;
        this.interventionTableService = interventionTableService;
        this.InterventionAdoptionTypeTableService = InterventionAdoptionTypeTableService;
        this.InterventionAdoptionSubTypeTableService = InterventionAdoptionSubTypeTableService;
        this.InterventionAdoptionPopTableService = InterventionAdoptionPopTableService;
        this.InterventionAdoptionIpdmTableService = InterventionAdoptionIpdmTableService;
        this.InterventionAdoptionOrganicTableService = InterventionAdoptionOrganicTableService;
        this.InterventionAdoptionIrrigationTableService = InterventionAdoptionIrrigationTableService;
        this.InterventionAdoptionFeedTableService = InterventionAdoptionFeedTableService;
        this.InterventionAdoptionVaccinationTableService = InterventionAdoptionVaccinationTableService;
        this.LivelihoodSourceTableService = LivelihoodSourceTableService;
        this.IncomeSourceTableService = IncomeSourceTableService;
        this.vaccinationMasterTableService = vaccinationMasterTableService;
        this.lsIpdmMasterTableService = lsIpdmMasterTableService;
        this.organicMethodMasterService = organicMethodMasterService;
    }
    async create(createInterventionAdoptionTableInputMain, user) {
        let intervention = null;
        if (createInterventionAdoptionTableInputMain.interventionId == 0) {
            intervention = await this.interventionTableService.create({
                mkId: createInterventionAdoptionTableInputMain.mkId,
            }, user, "adoption");
        }
        else {
            intervention = await this.interventionTableService.findOneAndUpdateTime(createInterventionAdoptionTableInputMain.interventionId, "adoption");
        }
        let userData = await this.userCollectionService.getUserByUsername(user.username);
        await this.removeByInterventionIdAndLsId(intervention.interventionId, createInterventionAdoptionTableInputMain.lsId);
        for (const el of createInterventionAdoptionTableInputMain.data) {
            let iat = new intervention_adoption_table_entity_1.InterventionAdoptionTable();
            iat.season = el.season;
            iat.InterventionTable = intervention;
            iat.season = el.season;
            let incomeSourceData = await this.IncomeSourceTableService.findOne(el.incomeSourceId);
            iat.IncomeSourceTable = incomeSourceData;
            let lsData = await this.LivelihoodSourceTableService.findOne(el.lsId);
            iat.LivelihoodSourceTable = lsData;
            iat.year = parseFloat((0, moment_1.default)().format("YYYY"));
            iat.entryDate = (0, moment_1.default)().format("DD-MM-YYYY");
            iat.areaOfLand = el.areaOfLand;
            iat.areaOfLandUnit = el.areaOfLandUnit;
            iat.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(parseFloat(el.areaOfLand), el.areaOfLandUnit);
            iat.herdSize = el.herdSize;
            iat.flockSize = el.flockSize;
            iat.irrigationReceived = el.irrigationReceived;
            iat.shedConstructed = el.shedConstructed;
            iat.amountLeveraged = el.amountLeveraged;
            iat.vaccinationDone = el.vaccinationDone;
            if (el.pondSize && parseFloat(el.pondSize) > 0) {
                iat.pondSize = el.pondSize;
                iat.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(parseFloat(el.pondSize), el.areaOfLandUnit);
            }
            iat.newPondConstructed = el.newPondConstructed;
            iat.noOfVerminBed = el.noOfVerminBed;
            iat.sourceOfLeverage = el.sourceOfLeverage;
            iat.sourceOfLeverages = el.sourceOfLeverages;
            iat.sourceOfLeverageData = el.sourceOfLeverageData;
            iat.schemeAvailed = el.schemeAvailed;
            iat.breedingUnitConstructed = el.breedingUnitConstructed;
            iat.fingerlings = el.fingerlings;
            iat.UserTable = userData;
            let result = await this.interventionAdoptionTableRepository.save(iat);
            await this.InterventionAdoptionTypeTableService.createBulk(el.lsType, result);
            await this.InterventionAdoptionSubTypeTableService.createBulk(el.lsTypeSecondary, result);
            await this.InterventionAdoptionPopTableService.createBulk(el.lsPop, result);
            await this.InterventionAdoptionIpdmTableService.createBulk(el.lsIpdm, result);
            await this.InterventionAdoptionOrganicTableService.createBulk(el.lsOrganicMethod, result);
            await this.InterventionAdoptionIrrigationTableService.createBulk(el.irrigationAdopted, result);
            await this.InterventionAdoptionFeedTableService.createBulk(el.lsFeed, result);
            await this.InterventionAdoptionVaccinationTableService.createBulk(el.vaccinationType, result);
        }
        return {
            status: true,
            status_text: "Successfully Created"
        };
    }
    findAll() {
        return `This action returns all interventionAdoptionTable`;
    }
    async findOneAdoptionByInterventionId(interventionId) {
        return await this.interventionAdoptionTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                }
            },
            relations: {
                IncomeSourceTable: true,
                LivelihoodSourceTable: true,
                InterventionAdoptionTypeTable: {
                    LsTypeTable: true
                },
                InterventionAdoptionSubTypeTable: {
                    LsTypeTable: true
                },
                InterventionAdoptionIpdmTable: {
                    LsIpdmMasterTable: true
                },
                InterventionAdoptionOrganicTable: {
                    OrganicMethodMaster: true
                },
                InterventionAdoptionPopTable: {
                    PopTable: true
                },
                InterventionAdoptionIrrigationTable: {
                    SourceOfIrrigationTable: true
                },
                InterventionAdoptionFeedTable: {
                    LsFeedMasterTable: true
                },
                InterventionAdoptionVaccinationTable: {
                    VaccinationMasterTable: true
                },
                UserTable: true
            }
        });
    }
    async findOneAdoptionByInterventionIdLsId(interventionId, lsId) {
        return await this.interventionAdoptionTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                },
                LivelihoodSourceTable: {
                    lsId
                }
            },
            relations: {
                IncomeSourceTable: true,
                LivelihoodSourceTable: true,
                InterventionAdoptionTypeTable: {
                    LsTypeTable: true
                },
                InterventionAdoptionSubTypeTable: {
                    LsTypeTable: true
                },
                InterventionAdoptionIpdmTable: {
                    LsIpdmMasterTable: true
                },
                InterventionAdoptionOrganicTable: {
                    OrganicMethodMaster: true
                },
                InterventionAdoptionPopTable: {
                    PopTable: true
                },
                InterventionAdoptionIrrigationTable: {
                    SourceOfIrrigationTable: true
                },
                InterventionAdoptionFeedTable: {
                    LsFeedMasterTable: true
                },
                InterventionAdoptionVaccinationTable: {
                    VaccinationMasterTable: true
                },
                UserTable: true
            }
        });
    }
    async update(interventionId, createInterventionAdoptionTableInputMain, user) {
        let intervention = await this.interventionTableService.findOneAndUpdateTime(interventionId, "adoption");
        let userData = await this.userCollectionService.getUserByUsername(user.username);
        await this.removeByInterventionIdAndLsId(intervention.interventionId, createInterventionAdoptionTableInputMain.lsId);
        for (const el of createInterventionAdoptionTableInputMain.data) {
            let iat = new intervention_adoption_table_entity_1.InterventionAdoptionTable();
            iat.season = el.season;
            iat.InterventionTable = intervention;
            iat.season = el.season;
            let incomeSourceData = await this.IncomeSourceTableService.findOne(el.incomeSourceId);
            iat.IncomeSourceTable = incomeSourceData;
            let lsData = await this.LivelihoodSourceTableService.findOne(el.lsId);
            iat.LivelihoodSourceTable = lsData;
            iat.year = parseFloat((0, moment_1.default)().format("YYYY"));
            iat.entryDate = (0, moment_1.default)().format("DD-MM-YYYY");
            iat.areaOfLand = el.areaOfLand;
            iat.areaOfLandUnit = el.areaOfLandUnit;
            iat.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(parseFloat(el.areaOfLand), el.areaOfLandUnit);
            iat.herdSize = el.herdSize;
            iat.flockSize = el.flockSize;
            iat.irrigationReceived = el.irrigationReceived;
            iat.shedConstructed = el.shedConstructed;
            iat.amountLeveraged = el.amountLeveraged;
            iat.vaccinationDone = el.vaccinationDone;
            if (el.pondSize && parseFloat(el.pondSize) > 0) {
                iat.pondSize = el.pondSize;
                iat.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(parseFloat(el.pondSize), el.areaOfLandUnit);
            }
            iat.newPondConstructed = el.newPondConstructed;
            iat.noOfVerminBed = el.noOfVerminBed;
            iat.sourceOfLeverage = el.sourceOfLeverage;
            iat.sourceOfLeverages = el.sourceOfLeverages;
            iat.sourceOfLeverageData = el.sourceOfLeverageData;
            iat.schemeAvailed = el.schemeAvailed;
            iat.breedingUnitConstructed = el.breedingUnitConstructed;
            iat.fingerlings = el.fingerlings;
            iat.UserTable = userData;
            let result = await this.interventionAdoptionTableRepository.save(iat);
            await this.InterventionAdoptionTypeTableService.createBulk(el.lsType, result);
            await this.InterventionAdoptionSubTypeTableService.createBulk(el.lsTypeSecondary, result);
            await this.InterventionAdoptionPopTableService.createBulk(el.lsPop, result);
            await this.InterventionAdoptionIpdmTableService.createBulk(el.lsIpdm, result);
            await this.InterventionAdoptionOrganicTableService.createBulk(el.lsOrganicMethod, result);
            await this.InterventionAdoptionIrrigationTableService.createBulk(el.irrigationAdopted, result);
            await this.InterventionAdoptionFeedTableService.createBulk(el.lsFeed, result);
            await this.InterventionAdoptionVaccinationTableService.createBulk(el.vaccinationType, result);
        }
        return {
            status: true,
            status_text: "Successfully Updated"
        };
    }
    remove(id) {
        return `This action removes a #${id} interventionAdoptionTable`;
    }
    async removeByInterventionId(interventionId) {
        let data = await this.interventionAdoptionTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                }
            }
        });
        if (data.length > 0) {
            await this.interventionAdoptionTableRepository.remove(data);
            return true;
        }
        else {
            return false;
        }
    }
    async removeByInterventionIdAndLsId(interventionId, lsId) {
        let data = await this.interventionAdoptionTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                },
                LivelihoodSourceTable: {
                    lsId
                }
            }
        });
        if (data.length > 0) {
            await this.interventionAdoptionTableRepository.remove(data);
            return true;
        }
        else {
            return false;
        }
    }
    async getInterventionAdoptionReport(sessionId, stateId, districtId, blockId, type) {
        let ffData = [];
        const livelihoodData = await this.LivelihoodSourceTableService.findAllForIntervention();
        if (type == "block") {
            ffData = await this.interventionAdoptionTableRepository.find({
                where: {
                    InterventionTable: {
                        MkTable: {
                            ShgTable: {
                                VillageTable: {
                                    GrampanchayatTable: {
                                        BlockTable: {
                                            blockId,
                                        },
                                    },
                                },
                            },
                        },
                        SessionmasterTable: {
                            sessionId
                        }
                    },
                },
                relations: {
                    InterventionTable: {
                        MkTable: true
                    },
                    LivelihoodSourceTable: true,
                    InterventionAdoptionVaccinationTable: {
                        VaccinationMasterTable: true
                    },
                    InterventionAdoptionIpdmTable: {
                        LsIpdmMasterTable: true
                    },
                    InterventionAdoptionOrganicTable: {
                        OrganicMethodMaster: true
                    }
                },
            });
        }
        if (type == "organisation") {
            ffData = await this.interventionAdoptionTableRepository.find({
                where: {
                    InterventionTable: {
                        SessionmasterTable: {
                            sessionId
                        }
                    },
                },
                relations: {
                    InterventionTable: {
                        MkTable: true
                    },
                    LivelihoodSourceTable: true,
                    InterventionAdoptionVaccinationTable: {
                        VaccinationMasterTable: true
                    },
                    InterventionAdoptionIpdmTable: {
                        LsIpdmMasterTable: true
                    },
                    InterventionAdoptionOrganicTable: {
                        OrganicMethodMaster: true
                    }
                },
            });
        }
        let InterventionAdoptionVaccinationTable = [];
        for (const el of ffData) {
            InterventionAdoptionVaccinationTable = [...InterventionAdoptionVaccinationTable, ...el.InterventionAdoptionVaccinationTable];
        }
        let InterventionAdoptionIpdmTable = [];
        for (const el of ffData) {
            InterventionAdoptionIpdmTable = [...InterventionAdoptionIpdmTable, ...el.InterventionAdoptionIpdmTable];
        }
        let InterventionAdoptionOrganicTable = [];
        for (const el of ffData) {
            InterventionAdoptionOrganicTable = [...InterventionAdoptionOrganicTable, ...el.InterventionAdoptionOrganicTable];
        }
        let lsData = [];
        for (const lsd of livelihoodData) {
            let filteredData = ffData.filter(el => el.LivelihoodSourceTable.lsCode === lsd.lsCode);
            let averageLandSize = 0;
            if (lsd.incomeActivityCode == "AGRICULTURE" && filteredData.length > 0) {
                const landSizes = filteredData.map(land => land.conversionToBigha);
                const sumLandSizes = landSizes.reduce((total, size) => parseFloat(total) + parseFloat(size), 0);
                averageLandSize = sumLandSizes / landSizes.length;
            }
            lsData.push({
                lsName: lsd.lsName,
                lsCode: lsd.lsCode,
                incomeActivityCode: lsd.incomeActivityCode,
                count: filteredData.length,
                avg: averageLandSize
            });
        }
        let vaccinationData = [];
        let vaccinationMasterTable = await this.vaccinationMasterTableService.findAll();
        for (const vmt of vaccinationMasterTable) {
            let ff = InterventionAdoptionVaccinationTable.filter((el) => el.VaccinationMasterTable.vaccineMasterId === vmt.vaccineMasterId);
            vaccinationData.push(Object.assign(Object.assign({}, vmt), { name: vmt.vaccineName, count: ff.length }));
        }
        let ipdmData = [];
        let ipdmMasterTable = await this.lsIpdmMasterTableService.findAll();
        for (const imt of ipdmMasterTable) {
            let ff = InterventionAdoptionIpdmTable.filter((el) => el.LsIpdmMasterTable.lsIpdmMasterId === imt.lsIpdmMasterId);
            ipdmData.push(Object.assign(Object.assign({}, imt), { name: imt.ipdmName, count: ff.length }));
        }
        let organicMethodsData = [];
        let organicMethodMasterTable = await this.organicMethodMasterService.findAll();
        for (const omt of organicMethodMasterTable) {
            let ff = InterventionAdoptionOrganicTable.filter((el) => el.OrganicMethodMaster.organicMethodId === omt.organicMethodId);
            organicMethodsData.push(Object.assign(Object.assign({}, omt), { name: omt.organicMethodName, count: ff.length }));
        }
        let data = {};
        let activityCodeData = [];
        let mkIdData = [];
        let avgHerdSize = 0;
        let herdSizeTotal = 0;
        let herdSizeCount = 0;
        let avgFlockSize = 0;
        let flockSizeTotal = 0;
        let flockSizeCount = 0;
        let avgLandSize = 0;
        let landSizeTotal = 0;
        let landSizeCount = 0;
        let shedConstructedTotal = 0;
        let pondConstructedTotal = 0;
        let breedingUnitConstructedTotal = 0;
        let avgPondSize = 0;
        let pondSizeTotal = 0;
        let pondSizeCount = 0;
        let verminBedCount = 0;
        let irrigationReceived = 0;
        let amountLeveragedTotal = 0;
        for (const el of ffData) {
            let ff = activityCodeData.findIndex(el1 => el1.mkId === el.InterventionTable.MkTable.mkId);
            if (ff > -1) {
                if (!activityCodeData[ff].data.includes(el.LivelihoodSourceTable.lsCode)) {
                    activityCodeData[ff].data = [...activityCodeData[ff].data, el.LivelihoodSourceTable.lsCode];
                }
            }
            else {
                activityCodeData.push({
                    mkId: el.InterventionTable.MkTable.mkId,
                    data: [el.LivelihoodSourceTable.lsCode]
                });
            }
            if (el.LivelihoodSourceTable.requiredDetails == "HERD") {
                herdSizeCount++;
                herdSizeTotal += parseFloat(el.herdSize);
            }
            if (el.LivelihoodSourceTable.requiredDetails == "FLOCK") {
                flockSizeCount++;
                flockSizeTotal += parseFloat(el.flockSize);
            }
            if (el.LivelihoodSourceTable.requiredDetails == "LAND") {
                landSizeCount++;
                landSizeTotal += parseFloat(el.conversionToBigha);
            }
            if (el.LivelihoodSourceTable.requiredDetails == "POND") {
                pondSizeCount++;
                pondSizeTotal += parseFloat(el.conversionToBigha);
            }
            if (el.shedConstructed && el.shedConstructed == "YES") {
                shedConstructedTotal++;
                if (!mkIdData.includes(el.InterventionTable.MkTable.mkId)) {
                    mkIdData.push(el.InterventionTable.MkTable.mkId);
                }
            }
            if (el.newPondConstructed && el.newPondConstructed == "YES") {
                pondConstructedTotal++;
                if (!mkIdData.includes(el.InterventionTable.MkTable.mkId)) {
                    mkIdData.push(el.InterventionTable.MkTable.mkId);
                }
            }
            if (el.breedingUnitConstructed && el.breedingUnitConstructed == "YES") {
                breedingUnitConstructedTotal++;
                if (!mkIdData.includes(el.InterventionTable.MkTable.mkId)) {
                    mkIdData.push(el.InterventionTable.MkTable.mkId);
                }
            }
            if (el.irrigationReceived && el.irrigationReceived == "YES") {
                irrigationReceived++;
            }
            if (el.noOfVerminBed) {
                verminBedCount += parseFloat(el.noOfVerminBed);
            }
            if (el.amountLeveraged) {
                amountLeveragedTotal += parseFloat(el.amountLeveraged);
            }
        }
        if (herdSizeCount > 0) {
            avgHerdSize = herdSizeTotal / herdSizeCount;
        }
        if (flockSizeCount > 0) {
            avgFlockSize = flockSizeTotal / flockSizeCount;
        }
        if (landSizeCount > 0) {
            avgLandSize = landSizeTotal / landSizeCount;
        }
        if (pondSizeCount > 0) {
            avgPondSize = pondSizeTotal / pondSizeCount;
        }
        let oneActivity = 0;
        let twoActivity = 0;
        let threeActivityMore = 0;
        for (const el of activityCodeData) {
            if (el.data.length == 1) {
                oneActivity++;
            }
            if (el.data.length == 2) {
                twoActivity++;
            }
            if (el.data.length >= 3) {
                threeActivityMore++;
            }
        }
        let fundLeveragedData = [];
        for (const sol of GlobalConstants_1.SOURCE_OF_LEVERAGE) {
            let smallAmountLeveraged = 0;
            for (const el of ffData) {
                let sld = el.sourceOfLeverageData || [];
                for (const el2 of sld) {
                    if (el2.schemeType == sol) {
                        if (el.amountLeveraged) {
                            smallAmountLeveraged += parseFloat(el.amountLeveraged);
                        }
                    }
                }
            }
            fundLeveragedData.push({
                sol: sol,
                amount: smallAmountLeveraged.toFixed(2)
            });
        }
        data = {
            avgHerdSize: avgHerdSize.toFixed(2),
            avgFlockSize: avgFlockSize.toFixed(2),
            avgLandSize: avgLandSize.toFixed(2),
            shedConstructedTotal,
            pondConstructedTotal,
            breedingUnitConstructedTotal,
            avgPondSize: avgPondSize.toFixed(2),
            irrigationReceived,
            verminBedCount,
            oneActivity,
            twoActivity,
            threeActivityMore,
            mkWithAssetsCreation: mkIdData.length,
            amountLeveragedTotal: amountLeveragedTotal.toFixed(2),
            mkIdData,
            fundLeveragedData
        };
        return Object.assign(Object.assign({ lsData: lsData }, data), { vaccinationData: (0, HelperFunctions_1.sortByCountDescending)(vaccinationData), ipdmData: (0, HelperFunctions_1.sortByCountDescending)(ipdmData), organicMethodsData: (0, HelperFunctions_1.sortByCountDescending)(organicMethodsData) });
    }
    async checkAdoptedOrNot(mkData, sessionId) {
        let mkIds = mkData.map(el => el.mkId);
        let mkAdoptionData = await this.interventionAdoptionTableRepository.find({
            where: {
                InterventionTable: {
                    MkTable: {
                        mkId: (0, typeorm_2.In)(mkIds)
                    }
                }
            },
            relations: {
                InterventionTable: {
                    MkTable: true
                },
                LivelihoodSourceTable: true
            }
        });
        let index = 0;
        for (const el of mkData) {
            let llData = [];
            let ll = mkAdoptionData.filter(el1 => el1.InterventionTable.MkTable.mkId == el.mkId);
            console.log("🚀 ~ file: intervention-adoption-table.service.ts:801 ~ InterventionAdoptionTableService ~ checkAdoptedOrNot ~ ll:", ll);
            if (ll.length > 0) {
                llData = ll.map(el2 => el2.LivelihoodSourceTable.lsCode);
            }
            mkData[index]['lsData'] = llData;
            index++;
        }
        return mkData;
    }
};
exports.InterventionAdoptionTableService = InterventionAdoptionTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(intervention_adoption_table_entity_1.InterventionAdoptionTable)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_table_service_1.InterventionTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_type_table_service_1.InterventionAdoptionTypeTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_sub_type_table_service_1.InterventionAdoptionSubTypeTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_pop_table_service_1.InterventionAdoptionPopTableService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_ipdm_table_service_1.InterventionAdoptionIpdmTableService))),
    __param(7, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_organic_table_service_1.InterventionAdoptionOrganicTableService))),
    __param(8, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_irrigation_table_service_1.InterventionAdoptionIrrigationTableService))),
    __param(9, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_feed_table_service_1.InterventionAdoptionFeedTableService))),
    __param(10, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_adoption_vaccination_table_service_1.InterventionAdoptionVaccinationTableService))),
    __param(11, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __param(12, (0, common_1.Inject)((0, common_1.forwardRef)(() => income_source_table_service_1.IncomeSourceTableService))),
    __param(13, (0, common_1.Inject)((0, common_1.forwardRef)(() => vaccination_master_table_service_1.VaccinationMasterTableService))),
    __param(14, (0, common_1.Inject)((0, common_1.forwardRef)(() => ls_ipdm_master_table_service_1.LsIpdmMasterTableService))),
    __param(15, (0, common_1.Inject)((0, common_1.forwardRef)(() => organic_method_master_service_1.OrganicMethodMasterService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        user_collection_service_1.UserCollectionService,
        intervention_table_service_1.InterventionTableService,
        intervention_adoption_type_table_service_1.InterventionAdoptionTypeTableService,
        intervention_adoption_sub_type_table_service_1.InterventionAdoptionSubTypeTableService,
        intervention_adoption_pop_table_service_1.InterventionAdoptionPopTableService,
        intervention_adoption_ipdm_table_service_1.InterventionAdoptionIpdmTableService,
        intervention_adoption_organic_table_service_1.InterventionAdoptionOrganicTableService,
        intervention_adoption_irrigation_table_service_1.InterventionAdoptionIrrigationTableService,
        intervention_adoption_feed_table_service_1.InterventionAdoptionFeedTableService,
        intervention_adoption_vaccination_table_service_1.InterventionAdoptionVaccinationTableService,
        livelihood_source_table_service_1.LivelihoodSourceTableService,
        income_source_table_service_1.IncomeSourceTableService,
        vaccination_master_table_service_1.VaccinationMasterTableService,
        ls_ipdm_master_table_service_1.LsIpdmMasterTableService,
        organic_method_master_service_1.OrganicMethodMasterService])
], InterventionAdoptionTableService);
