import { CreateInterventionProductionSubTableInput } from './dto/create-intervention-production-sub-table.input';
import { UpdateInterventionProductionSubTableInput } from './dto/update-intervention-production-sub-table.input';
import { InterventionProductionSubTable } from './entities/intervention-production-sub-table.entity';
import { Repository } from 'typeorm';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
import { InterventionProductionTable } from 'src/intervention-production-table/entities/intervention-production-table.entity';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
export declare class InterventionProductionSubTableService {
    private readonly interventionProductionSubTableRepository;
    private readonly livelihoodSourceTableService;
    private readonly sessionmasterTableService;
    constructor(interventionProductionSubTableRepository: Repository<InterventionProductionSubTable>, livelihoodSourceTableService: LivelihoodSourceTableService, sessionmasterTableService: SessionmasterTableService);
    create(createInterventionProductionSubTableInput: CreateInterventionProductionSubTableInput[], interventionProductionTable: InterventionProductionTable): Promise<any[]>;
    findAll(): string;
    findOne(id: number): string;
    update(id: number, updateInterventionProductionSubTableInput: UpdateInterventionProductionSubTableInput): string;
    remove(id: number): string;
    removeByInterventionProductionId(interventionProductionId: number): Promise<boolean>;
    getProductionReport(sessionId: number, blockId: number, type: string): Promise<{
        lsData: any[];
        mortalityData: any[];
    }>;
}
