"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionProductionSubTableService = void 0;
const common_1 = require("@nestjs/common");
const intervention_production_sub_table_entity_1 = require("./entities/intervention-production-sub-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
const moment_1 = __importDefault(require("moment"));
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
let InterventionProductionSubTableService = exports.InterventionProductionSubTableService = class InterventionProductionSubTableService {
    constructor(interventionProductionSubTableRepository, livelihoodSourceTableService, sessionmasterTableService) {
        this.interventionProductionSubTableRepository = interventionProductionSubTableRepository;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
        this.sessionmasterTableService = sessionmasterTableService;
    }
    async create(createInterventionProductionSubTableInput, interventionProductionTable) {
        let results = [];
        let session = await this.sessionmasterTableService.findActiveSession();
        await this.removeByInterventionProductionId(interventionProductionTable.interventionProductionId);
        for (const el of createInterventionProductionSubTableInput) {
            let ipSub = new intervention_production_sub_table_entity_1.InterventionProductionSubTable();
            let livelihood = await this.livelihoodSourceTableService.findOne(el.lsId);
            ipSub.LivelihoodSourceTable = livelihood;
            ipSub.year = parseFloat((0, moment_1.default)().format("YYYY"));
            ipSub.productionInKg = el.productionInKg;
            ipSub.costOfProduction = el.costOfProduction;
            ipSub.income = el.income;
            ipSub.season = el.season;
            ipSub.SessionmasterTable = session;
            ipSub.noOfSold = el.noOfSold;
            ipSub.noOfSaleable = el.noOfSaleable;
            ipSub.expenseOnReared = el.expenseOnReared;
            ipSub.mortalityPercentage = el.mortalityPercentage;
            ipSub.InterventionProductionTable = interventionProductionTable;
            let result = await this.interventionProductionSubTableRepository.save(ipSub);
            results.push(result);
        }
        return results;
    }
    findAll() {
        return `This action returns all interventionProductionSubTable`;
    }
    findOne(id) {
        return `This action returns a #${id} interventionProductionSubTable`;
    }
    update(id, updateInterventionProductionSubTableInput) {
        return `This action updates a #${id} interventionProductionSubTable`;
    }
    remove(id) {
        return `This action removes a #${id} interventionProductionSubTable`;
    }
    async removeByInterventionProductionId(interventionProductionId) {
        let results = await this.interventionProductionSubTableRepository.find({
            where: {
                InterventionProductionTable: {
                    interventionProductionId
                }
            }
        });
        await this.interventionProductionSubTableRepository.remove(results);
        return true;
    }
    async getProductionReport(sessionId, blockId, type) {
        let ffData = [];
        if (type == "block") {
            ffData = await this.interventionProductionSubTableRepository.find({
                where: {
                    SessionmasterTable: {
                        sessionId,
                    },
                    InterventionProductionTable: {
                        InterventionTable: {
                            MkTable: {
                                VillageTable: {
                                    GrampanchayatTable: {
                                        BlockTable: {
                                            blockId
                                        }
                                    }
                                }
                            }
                        }
                    }
                },
                relations: {
                    LivelihoodSourceTable: true
                }
            });
        }
        if (type == "organisation") {
            ffData = await this.interventionProductionSubTableRepository.find({
                where: {
                    SessionmasterTable: {
                        sessionId,
                    },
                },
                relations: {
                    LivelihoodSourceTable: true
                }
            });
        }
        let lsMasterData = await this.livelihoodSourceTableService.findAllForIntervention();
        let lsData = [];
        for (const el of lsMasterData) {
            let totalIncome = 0;
            let totalIncomeCount = 0;
            let avgIncome = 0;
            let dd = ffData.filter((el1) => el1.LivelihoodSourceTable.lsId === el.lsId);
            if (dd.length > 0) {
                dd.map((el1) => {
                    totalIncome += parseFloat(el1.income);
                });
                totalIncomeCount = dd.length;
            }
            if (totalIncomeCount > 0) {
                avgIncome = totalIncome / totalIncomeCount;
            }
            lsData.push({
                lsName: el.lsName,
                lsCode: el.lsCode,
                income: avgIncome.toFixed(2)
            });
        }
        let lsLivestockData = lsMasterData.filter((el) => (el.incomeActivityCode == "LIVESTOCK" || el.incomeActivityCode == "FISHERY"));
        let mortalityData = [];
        for (const el of lsLivestockData) {
            let totalMortality = 0;
            let totalMortalityCount = 0;
            let avgMortality = 0;
            let dd = ffData.filter((el1) => el1.LivelihoodSourceTable.lsId === el.lsId);
            if (dd.length > 0) {
                dd.map((el1) => {
                    totalMortality += parseFloat(el1.mortalityPercentage);
                });
                totalMortalityCount = dd.length;
            }
            if (totalMortalityCount > 0) {
                avgMortality = totalMortality / totalMortalityCount;
            }
            mortalityData.push({
                lsName: el.lsName,
                lsCode: el.lsCode,
                mortality: avgMortality.toFixed(2)
            });
        }
        return {
            lsData,
            mortalityData
        };
    }
};
exports.InterventionProductionSubTableService = InterventionProductionSubTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(intervention_production_sub_table_entity_1.InterventionProductionSubTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        livelihood_source_table_service_1.LivelihoodSourceTableService,
        sessionmaster_table_service_1.SessionmasterTableService])
], InterventionProductionSubTableService);
