"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionProductionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const intervention_production_table_service_1 = require("./intervention-production-table.service");
const intervention_production_table_entity_1 = require("./entities/intervention-production-table.entity");
const create_intervention_production_table_input_1 = require("./dto/create-intervention-production-table.input");
const update_intervention_production_table_input_1 = require("./dto/update-intervention-production-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const intervention_production_table_return_type_1 = require("./types/intervention-production-table-return.type");
const intervention_production_table_type_1 = require("./types/intervention-production-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
let InterventionProductionTableResolver = exports.InterventionProductionTableResolver = class InterventionProductionTableResolver {
    constructor(interventionProductionTableService) {
        this.interventionProductionTableService = interventionProductionTableService;
    }
    createInterventionProductionTable(createInterventionProductionTableInput, user) {
        return this.interventionProductionTableService.create(createInterventionProductionTableInput, user);
    }
    findAllInterventionProduction() {
        return this.interventionProductionTableService.findAll();
    }
    findOneInterventionProductionByInterventionId(interventionId) {
        return this.interventionProductionTableService.findOneInterventionProductionByInterventionId(interventionId);
    }
    updateInterventionProductionTable(updateInterventionProductionTableInput, user) {
        return this.interventionProductionTableService.update(updateInterventionProductionTableInput.interventionProductionId, updateInterventionProductionTableInput, user);
    }
    removeInterventionProductionTable(interventionProductionId) {
        return this.interventionProductionTableService.remove(interventionProductionId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => intervention_production_table_return_type_1.InterventionProductionTableReturnType),
    __param(0, (0, graphql_1.Args)('createInterventionProductionTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_intervention_production_table_input_1.CreateInterventionProductionTableInput, Object]),
    __metadata("design:returntype", void 0)
], InterventionProductionTableResolver.prototype, "createInterventionProductionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [intervention_production_table_type_1.InterventionProductionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], InterventionProductionTableResolver.prototype, "findAllInterventionProduction", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [intervention_production_table_type_1.InterventionProductionTableType]),
    __param(0, (0, graphql_1.Args)('interventionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], InterventionProductionTableResolver.prototype, "findOneInterventionProductionByInterventionId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => intervention_production_table_return_type_1.InterventionProductionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateInterventionProductionTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_intervention_production_table_input_1.UpdateInterventionProductionTableInput, Object]),
    __metadata("design:returntype", void 0)
], InterventionProductionTableResolver.prototype, "updateInterventionProductionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => intervention_production_table_return_type_1.InterventionProductionTableReturnType),
    __param(0, (0, graphql_1.Args)('interventionProductionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], InterventionProductionTableResolver.prototype, "removeInterventionProductionTable", null);
exports.InterventionProductionTableResolver = InterventionProductionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => intervention_production_table_entity_1.InterventionProductionTable),
    __metadata("design:paramtypes", [intervention_production_table_service_1.InterventionProductionTableService])
], InterventionProductionTableResolver);
