import { CreateInterventionProductionTableInput } from './dto/create-intervention-production-table.input';
import { UpdateInterventionProductionTableInput } from './dto/update-intervention-production-table.input';
import { InterventionProductionTable } from './entities/intervention-production-table.entity';
import { Repository } from 'typeorm';
import { InterventionTableService } from 'src/intervention-table/intervention-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { InterventionProductionSubTableService } from 'src/intervention-production-sub-table/intervention-production-sub-table.service';
export declare class InterventionProductionTableService {
    private readonly interventionProductionTableRepository;
    private readonly interventionTableService;
    private readonly userCollectionService;
    private readonly interventionProductionSubTableService;
    constructor(interventionProductionTableRepository: Repository<InterventionProductionTable>, interventionTableService: InterventionTableService, userCollectionService: UserCollectionService, interventionProductionSubTableService: InterventionProductionSubTableService);
    create(createInterventionProductionTableInput: CreateInterventionProductionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAll(): string;
    findOneInterventionProductionByInterventionId(interventionId: number): Promise<InterventionProductionTable[]>;
    findOne(id: number): string;
    update(interventionProductionId: number, updateInterventionProductionTableInput: UpdateInterventionProductionTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(id: number): string;
}
