"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionProductionTableService = void 0;
const common_1 = require("@nestjs/common");
const intervention_production_table_entity_1 = require("./entities/intervention-production-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const intervention_table_service_1 = require("../intervention-table/intervention-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
const intervention_production_sub_table_service_1 = require("../intervention-production-sub-table/intervention-production-sub-table.service");
let InterventionProductionTableService = exports.InterventionProductionTableService = class InterventionProductionTableService {
    constructor(interventionProductionTableRepository, interventionTableService, userCollectionService, interventionProductionSubTableService) {
        this.interventionProductionTableRepository = interventionProductionTableRepository;
        this.interventionTableService = interventionTableService;
        this.userCollectionService = userCollectionService;
        this.interventionProductionSubTableService = interventionProductionSubTableService;
    }
    async create(createInterventionProductionTableInput, user) {
        let intervention = null;
        if (createInterventionProductionTableInput.interventionId == 0) {
            intervention = await this.interventionTableService.create({
                mkId: createInterventionProductionTableInput.mkId,
            }, user, "production");
        }
        else {
            intervention = await this.interventionTableService.findOneAndUpdateTime(createInterventionProductionTableInput.interventionId, "production");
        }
        let userData = await this.userCollectionService.getUserByUsername(user.username);
        let interventionProductionTable = new intervention_production_table_entity_1.InterventionProductionTable();
        interventionProductionTable.UserTable = userData;
        interventionProductionTable.entryDate = (0, moment_1.default)().format("DD-MM-YYYY");
        interventionProductionTable.InterventionTable = intervention;
        let result = await this.interventionProductionTableRepository.save(interventionProductionTable);
        if (createInterventionProductionTableInput.data.length > 0) {
            await this.interventionProductionSubTableService.create(createInterventionProductionTableInput.data, result);
        }
        return {
            status: true,
            status_text: "Successfully Created"
        };
    }
    findAll() {
        return `This action returns all interventionProductionTable`;
    }
    async findOneInterventionProductionByInterventionId(interventionId) {
        console.log("🚀 ~ file: intervention-production-table.service.ts:82 ~ InterventionProductionTableService ~ findOneInterventionProductionByInterventionId ~ interventionId:", interventionId);
        let result = await this.interventionProductionTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                }
            },
            relations: {
                InterventionProductionSubTable: {
                    LivelihoodSourceTable: true
                },
                UserTable: true
            }
        });
        console.log("🚀 ~ file: intervention-production-table.service.ts:96 ~ InterventionProductionTableService ~ findOneInterventionProductionByInterventionId ~ result:", result);
        return result;
    }
    findOne(id) {
        return `This action returns a #${id} interventionProductionTable`;
    }
    async update(interventionProductionId, updateInterventionProductionTableInput, user) {
        let interventionProductionTable = await this.interventionProductionTableRepository.findOne({
            where: {
                interventionProductionId
            }
        });
        if (interventionProductionTable) {
            let userData = await this.userCollectionService.getUserByUsername(user.username);
            interventionProductionTable.UserTable = userData;
            interventionProductionTable.entryDate = (0, moment_1.default)().format("DD-MM-YYYY");
            let result = await this.interventionProductionTableRepository.save(interventionProductionTable);
            if (updateInterventionProductionTableInput.data.length > 0) {
                await this.interventionProductionSubTableService.create(updateInterventionProductionTableInput.data, result);
            }
            return {
                status: true,
                status_text: "Successfully Updated"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    remove(id) {
        return `This action removes a #${id} interventionProductionTable`;
    }
};
exports.InterventionProductionTableService = InterventionProductionTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(intervention_production_table_entity_1.InterventionProductionTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_table_service_1.InterventionTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_production_sub_table_service_1.InterventionProductionSubTableService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        intervention_table_service_1.InterventionTableService,
        user_collection_service_1.UserCollectionService,
        intervention_production_sub_table_service_1.InterventionProductionSubTableService])
], InterventionProductionTableService);
