"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionTable = void 0;
const intervention_adoption_table_entity_1 = require("../../intervention-adoption-table/entities/intervention-adoption-table.entity");
const intervention_production_table_entity_1 = require("../../intervention-production-table/entities/intervention-production-table.entity");
const intervention_training_table_entity_1 = require("../../intervention-training-table/entities/intervention-training-table.entity");
const mk_table_entity_1 = require("../../mk-table/entities/mk-table.entity");
const sessionmaster_table_entity_1 = require("../../sessionmaster-table/entities/sessionmaster-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
let InterventionTable = exports.InterventionTable = class InterventionTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], InterventionTable.prototype, "interventionId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => mk_table_entity_1.MkTable, dt => dt.InterventionTable),
    (0, typeorm_1.JoinColumn)({ name: "mkId" }),
    __metadata("design:type", mk_table_entity_1.MkTable)
], InterventionTable.prototype, "MkTable", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], InterventionTable.prototype, "year", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "entryDate", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "trainingSubmitted", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 200, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "trainingSubmittedTime", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "adoptionSubmitted", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 200, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "adoptionSubmittedTime", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 50, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "productionSubmitted", void 0);
__decorate([
    (0, typeorm_1.Column)({ length: 200, nullable: true }),
    __metadata("design:type", String)
], InterventionTable.prototype, "productionSubmittedTime", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => sessionmaster_table_entity_1.SessionmasterTable, dt => dt.InterventionTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "sessionId" }),
    __metadata("design:type", sessionmaster_table_entity_1.SessionmasterTable)
], InterventionTable.prototype, "SessionmasterTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_training_table_entity_1.InterventionTrainingTable, et => et.InterventionTable),
    __metadata("design:type", Array)
], InterventionTable.prototype, "InterventionTrainingTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_production_table_entity_1.InterventionProductionTable, et => et.InterventionTable),
    __metadata("design:type", Array)
], InterventionTable.prototype, "InterventionProductionTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => intervention_adoption_table_entity_1.InterventionAdoptionTable, et => et.InterventionTable),
    __metadata("design:type", Array)
], InterventionTable.prototype, "InterventionAdoptionTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, dt => dt.InterventionTable),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], InterventionTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], InterventionTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], InterventionTable.prototype, "updatedAt", void 0);
exports.InterventionTable = InterventionTable = __decorate([
    (0, typeorm_1.Entity)()
], InterventionTable);
