"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const intervention_table_service_1 = require("./intervention-table.service");
const intervention_table_entity_1 = require("./entities/intervention-table.entity");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const intervention_table_type_1 = require("./types/intervention-table-type");
let InterventionTableResolver = exports.InterventionTableResolver = class InterventionTableResolver {
    constructor(interventionTableService) {
        this.interventionTableService = interventionTableService;
    }
    findOneInterventionById(interventionId) {
        return this.interventionTableService.findOne(interventionId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => intervention_table_type_1.InterventionTableType),
    __param(0, (0, graphql_1.Args)('interventionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], InterventionTableResolver.prototype, "findOneInterventionById", null);
exports.InterventionTableResolver = InterventionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => intervention_table_entity_1.InterventionTable),
    __metadata("design:paramtypes", [intervention_table_service_1.InterventionTableService])
], InterventionTableResolver);
