import { CreateInterventionTableInput } from './dto/create-intervention-table.input';
import { UpdateInterventionTableInput } from './dto/update-intervention-table.input';
import { InterventionTable } from './entities/intervention-table.entity';
import { Repository } from 'typeorm';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { InterventionTrainingTableService } from 'src/intervention-training-table/intervention-training-table.service';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { PopTableService } from 'src/pop-table/pop-table.service';
export declare class InterventionTableService {
    private readonly interventionTableRepository;
    private readonly userCollectionService;
    private readonly mkTableService;
    private readonly interventionTrainingTableService;
    private readonly sessionmasterTableService;
    private readonly popTableService;
    constructor(interventionTableRepository: Repository<InterventionTable>, userCollectionService: UserCollectionService, mkTableService: MkTableService, interventionTrainingTableService: InterventionTrainingTableService, sessionmasterTableService: SessionmasterTableService, popTableService: PopTableService);
    create(createInterventionTableInput: CreateInterventionTableInput, user: any, type: string): Promise<InterventionTable>;
    findAll(): string;
    findOne(interventionId: number): Promise<InterventionTable>;
    findOneAndUpdateTime(interventionId: number, type: string): Promise<InterventionTable>;
    findByMkId(mkId: number): Promise<InterventionTable[]>;
    getTrainingAndProductionReport(sessionId: number, blockId: number, type: string): Promise<{
        trainingData: any[];
    }>;
    update(id: number, updateInterventionTableInput: UpdateInterventionTableInput): string;
    remove(id: number): string;
    getCountByMonth(month: string): Promise<any>;
}
