import { InterventionTrainingTable } from './entities/intervention-training-table.entity';
import { Repository } from 'typeorm';
import { InterventionTableService } from 'src/intervention-table/intervention-table.service';
import { TrainingTableService } from 'src/training-table/training-table.service';
import { CreateInterventionTrainingTableDataInput } from './dto/create-intervention-training-table-data.input';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class InterventionTrainingTableService {
    private readonly interventionTrainingTableRepository;
    private readonly interventionTableService;
    private readonly trainingTableService;
    private readonly userCollectionService;
    constructor(interventionTrainingTableRepository: Repository<InterventionTrainingTable>, interventionTableService: InterventionTableService, trainingTableService: TrainingTableService, userCollectionService: UserCollectionService);
    create(createInterventionTrainingTableDataInput: CreateInterventionTrainingTableDataInput, user: any, mkId: number, interventionId: number): Promise<{
        status: boolean;
        status_text: string;
        interventionId: any;
    }>;
    removeByInterventionId(interventionId: number): Promise<boolean>;
    getTrainingsByInterventionId(interventionId: number): Promise<InterventionTrainingTable[]>;
}
