"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InterventionTrainingTableService = void 0;
const common_1 = require("@nestjs/common");
const intervention_training_table_entity_1 = require("./entities/intervention-training-table.entity");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const intervention_table_service_1 = require("../intervention-table/intervention-table.service");
const training_table_service_1 = require("../training-table/training-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
let InterventionTrainingTableService = exports.InterventionTrainingTableService = class InterventionTrainingTableService {
    constructor(interventionTrainingTableRepository, interventionTableService, trainingTableService, userCollectionService) {
        this.interventionTrainingTableRepository = interventionTrainingTableRepository;
        this.interventionTableService = interventionTableService;
        this.trainingTableService = trainingTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createInterventionTrainingTableDataInput, user, mkId, interventionId) {
        let intervention = null;
        if (interventionId == 0) {
            intervention = await this.interventionTableService.create({
                mkId,
            }, user, "training");
        }
        else {
            intervention = await this.interventionTableService.findOneAndUpdateTime(interventionId, "training");
        }
        let userData = await this.userCollectionService.getUserByUsername(user.username);
        await this.removeByInterventionId(intervention.interventionId);
        for (const el of createInterventionTrainingTableDataInput.data) {
            let tt = new intervention_training_table_entity_1.InterventionTrainingTable();
            tt.InterventionTable = intervention;
            tt.TrainingTable = await this.trainingTableService.findOne(el.trainingId);
            tt.training = el.training;
            tt.exposure = el.exposure;
            tt.UserTable = userData;
            await this.interventionTrainingTableRepository.save(tt);
        }
        return {
            status: true,
            status_text: "Successfully Updated",
            interventionId: intervention.interventionId
        };
    }
    async removeByInterventionId(interventionId) {
        let data = await this.interventionTrainingTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                }
            }
        });
        if (data.length > 0) {
            await this.interventionTrainingTableRepository.remove(data);
            return true;
        }
        else {
            return false;
        }
    }
    async getTrainingsByInterventionId(interventionId) {
        let data = await this.interventionTrainingTableRepository.find({
            where: {
                InterventionTable: {
                    interventionId
                }
            },
            relations: {
                TrainingTable: true
            }
        });
        return data;
    }
};
exports.InterventionTrainingTableService = InterventionTrainingTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(intervention_training_table_entity_1.InterventionTrainingTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_table_service_1.InterventionTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => training_table_service_1.TrainingTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        intervention_table_service_1.InterventionTableService,
        training_table_service_1.TrainingTableService,
        user_collection_service_1.UserCollectionService])
], InterventionTrainingTableService);
