import { ObjectID } from "typeorm";
import * as mongoose from 'mongoose';
import { CurrentStockCollection } from "src/current-stock-collection/entities/current-stock-collection.entity";
import { ClientCollection } from "src/client-collection/entities/client-collection.entity";
export declare type InvoiceCollectionDocument = InvoiceCollection & Document;
export declare class InvoiceData {
    CurrentStock: CurrentStockCollection;
    barcode: string;
    productName: string;
    size: string;
    currentStock: number;
    qty: number;
    rate: number;
    taxRate: number;
    subTotal: number;
    taxAmount: number;
    total: number;
}
export declare class InvoiceCollection {
    _id: ObjectID;
    Client: ClientCollection;
    invoiceNo: string;
    invoiceCodeIndex: number;
    entryDate: string;
    grandTotal: number;
    billTotal: number;
    grandTax: number;
    amountPaid: number;
    paymentMode: string;
    chequeNo: string;
    paymentTerms: string;
    deliveryDate: string;
    deliveryStatus: string;
    invoiceStatus: boolean;
    createdBy: string;
    invoiceData: InvoiceData[];
}
export declare const InvoiceCollectionSchema: mongoose.Schema<mongoose.Document<InvoiceCollection, any, any>, mongoose.Model<mongoose.Document<InvoiceCollection, any, any>, any, any, any>, any, any>;
