/// <reference types="mongoose" />
import { InvoiceCollection } from './entities/invoice-collection.entity';
import { InvoiceCollectionService } from './invoice-collection.service';
import { CreateInvoiceCollectionInput } from './input/create-invoice-collection.input';
import { UpdateInvoiceCollectionInput } from './input/update-invoice-collection.input';
import { InvoicePaginationType } from './types/invoice-pagination.type';
export declare class InvoiceCollectionResolver {
    private readonly invoiceCollectionService;
    constructor(invoiceCollectionService: InvoiceCollectionService);
    createInvoiceCollection(user: any, createInvoiceCollectionInput: CreateInvoiceCollectionInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllInvoices(limit: number, page: number, search?: string): Promise<InvoicePaginationType>;
    findSingleInvoice(id: string): Promise<InvoicePaginationType>;
    updateInvoiceCollection(updateInvoiceCollectionInput: UpdateInvoiceCollectionInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeInvoiceCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getInvoiceForClient(user: any): Promise<(import("mongoose").Document<unknown, any, import("./entities/invoice-collection.entity").InvoiceCollectionDocument> & InvoiceCollection & Document & {
        _id: import("typeorm").ObjectID;
    })[]>;
}
