"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvoiceCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const invoice_collection_entity_1 = require("./entities/invoice-collection.entity");
const invoice_collection_service_1 = require("./invoice-collection.service");
const invoice_collection_create_type_1 = require("./types/invoice-collection-create.type");
const create_invoice_collection_input_1 = require("./input/create-invoice-collection.input");
const invoice_collection_type_1 = require("./types/invoice-collection.type");
const update_invoice_collection_input_1 = require("./input/update-invoice-collection.input");
const invoice_pagination_type_1 = require("./types/invoice-pagination.type");
let InvoiceCollectionResolver = class InvoiceCollectionResolver {
    constructor(invoiceCollectionService) {
        this.invoiceCollectionService = invoiceCollectionService;
    }
    createInvoiceCollection(user, createInvoiceCollectionInput) {
        return this.invoiceCollectionService.create(createInvoiceCollectionInput, user.username);
    }
    async findAllInvoices(limit, page, search) {
        const result = await this.invoiceCollectionService.findAll(limit, page, search);
        return {
            data: result.result,
            page: result.page,
            totalCount: result.count,
        };
    }
    async findSingleInvoice(id) {
        const result = await this.invoiceCollectionService.findSingleInvoice(id);
        return {
            data: result.result,
            page: result.page,
            totalCount: result.count,
        };
    }
    updateInvoiceCollection(updateInvoiceCollectionInput, user) {
        return this.invoiceCollectionService.update(updateInvoiceCollectionInput.id, updateInvoiceCollectionInput, user.username);
    }
    removeInvoiceCollection(id) {
        return this.invoiceCollectionService.remove(id);
    }
    getInvoiceForClient(user) {
        return this.invoiceCollectionService.findAllWithUsername(user.username);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => invoice_collection_create_type_1.InvoiceCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createInvoiceCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_invoice_collection_input_1.CreateInvoiceCollectionInput]),
    __metadata("design:returntype", void 0)
], InvoiceCollectionResolver.prototype, "createInvoiceCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => invoice_pagination_type_1.InvoicePaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('search')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String]),
    __metadata("design:returntype", Promise)
], InvoiceCollectionResolver.prototype, "findAllInvoices", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => invoice_pagination_type_1.InvoicePaginationType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], InvoiceCollectionResolver.prototype, "findSingleInvoice", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => invoice_collection_create_type_1.InvoiceCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateInvoiceCollectionInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_invoice_collection_input_1.UpdateInvoiceCollectionInput, Object]),
    __metadata("design:returntype", void 0)
], InvoiceCollectionResolver.prototype, "updateInvoiceCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => invoice_collection_create_type_1.InvoiceCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], InvoiceCollectionResolver.prototype, "removeInvoiceCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [invoice_collection_type_1.InvoiceCollectionType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], InvoiceCollectionResolver.prototype, "getInvoiceForClient", null);
InvoiceCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => invoice_collection_entity_1.InvoiceCollection),
    __metadata("design:paramtypes", [invoice_collection_service_1.InvoiceCollectionService])
], InvoiceCollectionResolver);
exports.InvoiceCollectionResolver = InvoiceCollectionResolver;
