import { Model } from 'mongoose';
import { ClientCollectionService } from 'src/client-collection/client-collection.service';
import { CurrentStockCollectionService } from 'src/current-stock-collection/current-stock-collection.service';
import { StockRegisterCollectionService } from 'src/stock-register-collection/stock-register-collection.service';
import { InvoiceCollection, InvoiceCollectionDocument } from './entities/invoice-collection.entity';
import { CreateInvoiceCollectionInput } from './input/create-invoice-collection.input';
import { UpdateInvoiceCollectionInput } from './input/update-invoice-collection.input';
import * as mongoose from 'mongoose';
export declare class InvoiceCollectionService {
    private invoiceCollectionRepository;
    private readonly clientCollectionService;
    private currentStockCollectionService;
    private stockRegisterCollectionService;
    private readonly connection;
    constructor(invoiceCollectionRepository: Model<InvoiceCollectionDocument>, clientCollectionService: ClientCollectionService, currentStockCollectionService: CurrentStockCollectionService, stockRegisterCollectionService: StockRegisterCollectionService, connection: mongoose.Connection);
    create(createInvoiceCollectionInput: CreateInvoiceCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getLatestInvoice(): Promise<string>;
    getLatestIndex(): Promise<number>;
    findAll(limit: number, page: number, search?: string): Promise<{
        result: (mongoose.Document<unknown, any, InvoiceCollectionDocument> & InvoiceCollection & Document & {
            _id: import("typeorm").ObjectID;
        })[];
        count: number;
        page: number;
    }>;
    findOne(id: string): Promise<mongoose.Document<unknown, any, InvoiceCollectionDocument> & InvoiceCollection & Document & {
        _id: import("typeorm").ObjectID;
    }>;
    findSingleInvoice(id: string): Promise<{
        result: (mongoose.Document<unknown, any, InvoiceCollectionDocument> & InvoiceCollection & Document & {
            _id: import("typeorm").ObjectID;
        })[];
        count: number;
        page: number;
    }>;
    findAllWithUsername(username: string): Promise<(mongoose.Document<unknown, any, InvoiceCollectionDocument> & InvoiceCollection & Document & {
        _id: import("typeorm").ObjectID;
    })[]>;
    update(id: string, updateInvoiceCollectionInput: UpdateInvoiceCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
