"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InvoiceCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const moment_1 = __importDefault(require("moment"));
const mongoose_2 = require("mongoose");
const client_category_collection_entity_1 = require("../client-category-collection/entities/client-category-collection.entity");
const client_collection_service_1 = require("../client-collection/client-collection.service");
const current_stock_collection_service_1 = require("../current-stock-collection/current-stock-collection.service");
const current_stock_collection_entity_1 = require("../current-stock-collection/entities/current-stock-collection.entity");
const product_collection_entity_1 = require("../product-collection/entities/product-collection.entity");
const stock_register_collection_service_1 = require("../stock-register-collection/stock-register-collection.service");
const invoice_collection_entity_1 = require("./entities/invoice-collection.entity");
const mongoose = __importStar(require("mongoose"));
let InvoiceCollectionService = class InvoiceCollectionService {
    constructor(invoiceCollectionRepository, clientCollectionService, currentStockCollectionService, stockRegisterCollectionService, connection) {
        this.invoiceCollectionRepository = invoiceCollectionRepository;
        this.clientCollectionService = clientCollectionService;
        this.currentStockCollectionService = currentStockCollectionService;
        this.stockRegisterCollectionService = stockRegisterCollectionService;
        this.connection = connection;
    }
    async create(createInvoiceCollectionInput, username) {
        const session = await this.connection.startSession();
        session.startTransaction();
        try {
            let cc = await this.clientCollectionService.findOneById(createInvoiceCollectionInput.clientId);
            let cm = new invoice_collection_entity_1.InvoiceCollection();
            cm.Client = cc;
            cm.invoiceNo = await this.getLatestInvoice();
            cm.invoiceCodeIndex = await this.getLatestIndex();
            cm.createdBy = username;
            let newpcd = [];
            for (const el of createInvoiceCollectionInput.invoiceData) {
                let currentStock = await this.currentStockCollectionService.getStockWithBarcode(el.barcode, createInvoiceCollectionInput.clientId);
                await this.currentStockCollectionService.updateStock(currentStock.id, -el.qty).then(async (us) => {
                    console.log("🚀 ~ file: invoice-collection.service.ts ~ line 71 ~ InvoiceCollectionService ~ awaitthis.currentStockCollectionService.updateStock ~ us", us);
                    if (us.status) {
                        newpcd.push({
                            CurrentStockData: currentStock._id,
                            barcode: el.barcode,
                            productName: el.productName,
                            size: el.size,
                            qty: el.qty,
                            rate: el.rate,
                            subTotal: el.subTotal,
                            total: el.total,
                            currentStock: el.currentStock,
                            taxRate: el.taxRate,
                            taxAmount: el.taxAmount
                        });
                    }
                    else {
                        throw new common_1.NotFoundException();
                    }
                });
            }
            cm.invoiceData = newpcd;
            cm.entryDate = createInvoiceCollectionInput.entryDate;
            cm.billTotal = createInvoiceCollectionInput.billTotal;
            cm.grandTotal = createInvoiceCollectionInput.grandTotal;
            cm.grandTax = createInvoiceCollectionInput.grandTax;
            cm.amountPaid = createInvoiceCollectionInput.amountPaid;
            cm.paymentMode = createInvoiceCollectionInput.paymentMode;
            cm.chequeNo = createInvoiceCollectionInput.chequeNo;
            cm.paymentTerms = createInvoiceCollectionInput.paymentTerms;
            cm.deliveryDate = createInvoiceCollectionInput.deliveryDate;
            let r = await this.invoiceCollectionRepository.create(cm);
            for (const el of newpcd) {
                let data = {
                    entryDate: createInvoiceCollectionInput.entryDate,
                    qty: el.qty,
                    accountType: 'PRODUCT',
                    entryType: 'SALE',
                    narration: 'Sale entry.',
                    receiptNo: r.id,
                    currentStockId: el.CurrentStockData,
                    createdBy: username
                };
                let sr = await this.stockRegisterCollectionService.create(data);
            }
            await session.commitTransaction();
            return {
                status: true,
                status_text: 'Invoice Successfully Generated',
            };
        }
        catch (error) {
            await session.abortTransaction();
            throw error;
        }
        finally {
            session.endSession();
        }
    }
    async getLatestInvoice() {
        let d1 = (0, moment_1.default)().format('YYYY');
        let d2 = (parseInt(d1) + 1).toString().slice(-2);
        let r = await this.invoiceCollectionRepository
            .find()
            .sort({ invoiceCodeIndex: -1 })
            .limit(1);
        if (r.length == 0) {
            return `INV/${d1}-${d2}/00001`;
        }
        else {
            return `INV/${d1}-${d2}/${String(r[0].invoiceCodeIndex + 1).padStart(5, '0')}`;
        }
    }
    async getLatestIndex() {
        let r = await this.invoiceCollectionRepository.find().sort({ invoiceCodeIndex: -1 }).limit(1);
        if (r.length == 0) {
            return 1;
        }
        else {
            return r[0].invoiceCodeIndex + 1;
        }
    }
    async findAll(limit, page, search) {
        const offset = limit * (page - 1);
        const filters = {};
        if (search) {
            filters.$text = {
                $search: search,
            };
        }
        let count = await this.invoiceCollectionRepository.count();
        let result = await this.invoiceCollectionRepository
            .find(filters)
            .limit(limit)
            .skip(offset)
            .populate({
            path: 'Client',
            populate: {
                path: 'ClientCategory',
                model: client_category_collection_entity_1.ClientCategoryCollection
            }
        })
            .populate({
            path: 'invoiceData',
            populate: {
                path: 'CurrentStockData',
                model: current_stock_collection_entity_1.CurrentStockCollection,
                populate: {
                    path: 'Product',
                    model: product_collection_entity_1.ProductCollection
                }
            }
        })
            .exec();
        return { result: result, count: count, page: page };
    }
    async findOne(id) {
        return await this.invoiceCollectionRepository.findOne({ _id: id }).exec();
    }
    async findSingleInvoice(id) {
        let result = await this.invoiceCollectionRepository
            .find({ _id: id })
            .populate({
            path: 'Client',
            populate: {
                path: 'ClientCategory',
                model: client_category_collection_entity_1.ClientCategoryCollection
            }
        })
            .populate({
            path: 'invoiceData',
            populate: {
                path: 'CurrentStockData',
                model: current_stock_collection_entity_1.CurrentStockCollection,
                populate: {
                    path: 'Product',
                    model: product_collection_entity_1.ProductCollection
                }
            }
        })
            .exec();
        return { result: result, count: 1, page: 1 };
    }
    async findAllWithUsername(username) {
        let result = await this.invoiceCollectionRepository
            .find({
            isDefault: true
        })
            .populate({
            path: 'invoiceData',
            populate: { path: 'CurrentStock', model: current_stock_collection_entity_1.CurrentStockCollection },
        })
            .exec();
        let result1 = await this.invoiceCollectionRepository
            .find({
            isDefault: false,
            createdBy: username
        })
            .populate({
            path: 'invoiceData',
            populate: { path: 'CurrentStock', model: current_stock_collection_entity_1.CurrentStockCollection },
        })
            .exec();
        let r = result.concat(result1);
        await Promise.all(r.map(async (el, index) => {
            let total = 0;
            let countNone = 0;
            await Promise.all(el.invoiceData.map(async (el1, index1) => {
                let pr = await this.currentStockCollectionService.getStockWithPriceSpecific(el1.Product, el1.size, el1.qty, username);
                r[index]['invoiceData'][index1]['price'] = pr;
                if (pr == null) {
                    countNone = countNone + 1;
                }
                if (pr != null) {
                    total = total + parseFloat(pr);
                }
            }));
            r[index]['countNone'] = countNone;
            r[index]['total'] = total;
        }));
        return r;
    }
    async update(id, updateInvoiceCollectionInput, username) {
        let cm = await this.invoiceCollectionRepository.findOne({ _id: id }).populate('Client').exec();
        console.log("🚀 ~ file: invoice-collection.service.ts ~ line 240 ~ InvoiceCollectionService ~ update ~ cm", cm);
        if (cm != null) {
            for (const el of cm.invoiceData) {
                let currentStock = await this.currentStockCollectionService.getStockWithBarcode(el.barcode, cm.Client._id.toString());
                await this.currentStockCollectionService.updateStock(currentStock.id, el.qty);
            }
            let cc = await this.clientCollectionService.findOneById(updateInvoiceCollectionInput.clientId);
            cm.Client = cc;
            let newpcd = [];
            for (const el of updateInvoiceCollectionInput.invoiceData) {
                let currentStock = await this.currentStockCollectionService.getStockWithBarcode(el.barcode, updateInvoiceCollectionInput.clientId);
                await this.currentStockCollectionService.updateStock(currentStock.id, -el.qty).then((us) => {
                    if (us.status) {
                        newpcd.push({
                            CurrentStockData: currentStock._id,
                            barcode: el.barcode,
                            productName: el.productName,
                            size: el.size,
                            qty: el.qty,
                            rate: el.rate,
                            subTotal: el.subTotal,
                            total: el.total,
                            currentStock: el.currentStock,
                            taxRate: el.taxRate,
                            taxAmount: el.taxAmount
                        });
                    }
                });
            }
            cm.invoiceData = newpcd;
            cm.entryDate = updateInvoiceCollectionInput.entryDate;
            cm.billTotal = updateInvoiceCollectionInput.billTotal;
            cm.grandTotal = updateInvoiceCollectionInput.grandTotal;
            cm.grandTax = updateInvoiceCollectionInput.grandTax;
            cm.amountPaid = updateInvoiceCollectionInput.amountPaid;
            cm.paymentMode = updateInvoiceCollectionInput.paymentMode;
            cm.chequeNo = updateInvoiceCollectionInput.chequeNo;
            cm.paymentTerms = updateInvoiceCollectionInput.paymentTerms;
            cm.deliveryDate = updateInvoiceCollectionInput.deliveryDate;
            await this.invoiceCollectionRepository.updateOne({ _id: id }, cm);
            return {
                status: true,
                status_text: 'Invoice Successfully Updated',
            };
        }
        else {
            return {
                status: false,
                status_text: 'Invoice Not Found.',
            };
        }
    }
    async remove(id) {
        await this.invoiceCollectionRepository.deleteOne({ _id: id }).exec();
        return {
            status: true,
            status_text: "Invoice Successfully Deleted"
        };
    }
};
InvoiceCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(invoice_collection_entity_1.InvoiceCollection.name)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_collection_service_1.CurrentStockCollectionService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => stock_register_collection_service_1.StockRegisterCollectionService))),
    __param(4, (0, mongoose_1.InjectConnection)()),
    __metadata("design:paramtypes", [mongoose_2.Model,
        client_collection_service_1.ClientCollectionService,
        current_stock_collection_service_1.CurrentStockCollectionService,
        stock_register_collection_service_1.StockRegisterCollectionService, mongoose.Connection])
], InvoiceCollectionService);
exports.InvoiceCollectionService = InvoiceCollectionService;
