import { IrrigationMethodTableService } from './irrigation-method-table.service';
import { IrrigationMethodTable } from './entities/irrigation-method-table.entity';
import { CreateIrrigationMethodTableInput } from './dto/create-irrigation-method-table.input';
import { UpdateIrrigationMethodTableInput } from './dto/update-irrigation-method-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_IRRIGATION_METHOD_ADD = "NEW_IRRIGATION_METHOD_ADD";
export declare class IrrigationMethodTableResolver {
    private readonly irrigationMethodTableService;
    private pubSub;
    constructor(irrigationMethodTableService: IrrigationMethodTableService, pubSub: RedisPubSub);
    createIrrigationMethodTable(createIrrigationMethodTableInput: CreateIrrigationMethodTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IrrigationMethodTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllIrrigationMethods(): Promise<IrrigationMethodTable[]>;
    findOne(irrigationMethodId: number): Promise<IrrigationMethodTable>;
    updateIrrigationMethodTable(updateIrrigationMethodTableInput: UpdateIrrigationMethodTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IrrigationMethodTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeIrrigationMethodTable(irrigationMethodId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    irrigationMethodSubscription(): AsyncIterator<unknown, any, undefined>;
}
