"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IrrigationMethodTableResolver = exports.NEW_IRRIGATION_METHOD_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const irrigation_method_table_service_1 = require("./irrigation-method-table.service");
const irrigation_method_table_entity_1 = require("./entities/irrigation-method-table.entity");
const create_irrigation_method_table_input_1 = require("./dto/create-irrigation-method-table.input");
const update_irrigation_method_table_input_1 = require("./dto/update-irrigation-method-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const irrigation_method_table_return_type_1 = require("./types/irrigation-method-table-return.type");
const irrigation_method_table_type_1 = require("./types/irrigation-method-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_IRRIGATION_METHOD_ADD = "NEW_IRRIGATION_METHOD_ADD";
let IrrigationMethodTableResolver = exports.IrrigationMethodTableResolver = class IrrigationMethodTableResolver {
    constructor(irrigationMethodTableService, pubSub) {
        this.irrigationMethodTableService = irrigationMethodTableService;
        this.pubSub = pubSub;
    }
    createIrrigationMethodTable(createIrrigationMethodTableInput) {
        return this.irrigationMethodTableService.create(createIrrigationMethodTableInput);
    }
    findAllIrrigationMethods() {
        return this.irrigationMethodTableService.findAll();
    }
    findOne(irrigationMethodId) {
        return this.irrigationMethodTableService.findOne(irrigationMethodId);
    }
    updateIrrigationMethodTable(updateIrrigationMethodTableInput) {
        return this.irrigationMethodTableService.update(updateIrrigationMethodTableInput.irrigationMethodId, updateIrrigationMethodTableInput);
    }
    removeIrrigationMethodTable(irrigationMethodId) {
        return this.irrigationMethodTableService.remove(irrigationMethodId);
    }
    irrigationMethodSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_IRRIGATION_METHOD_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => irrigation_method_table_return_type_1.IrrigationMethodTableReturnType),
    __param(0, (0, graphql_1.Args)('createIrrigationMethodTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_irrigation_method_table_input_1.CreateIrrigationMethodTableInput]),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "createIrrigationMethodTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [irrigation_method_table_type_1.IrrigationMethodTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "findAllIrrigationMethods", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => irrigation_method_table_type_1.IrrigationMethodTableType),
    __param(0, (0, graphql_1.Args)('irrigationMethodId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => irrigation_method_table_return_type_1.IrrigationMethodTableReturnType),
    __param(0, (0, graphql_1.Args)('updateIrrigationMethodTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_irrigation_method_table_input_1.UpdateIrrigationMethodTableInput]),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "updateIrrigationMethodTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => irrigation_method_table_return_type_1.IrrigationMethodTableReturnType),
    __param(0, (0, graphql_1.Args)('irrigationMethodId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "removeIrrigationMethodTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], IrrigationMethodTableResolver.prototype, "irrigationMethodSubscription", null);
exports.IrrigationMethodTableResolver = IrrigationMethodTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => irrigation_method_table_entity_1.IrrigationMethodTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [irrigation_method_table_service_1.IrrigationMethodTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], IrrigationMethodTableResolver);
