import { CreateIrrigationMethodTableInput } from './dto/create-irrigation-method-table.input';
import { UpdateIrrigationMethodTableInput } from './dto/update-irrigation-method-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { IrrigationMethodTable } from './entities/irrigation-method-table.entity';
import { Repository } from 'typeorm';
export declare const NEW_IRRIGATION_METHOD_ADD = "NEW_IRRIGATION_METHOD_ADD";
export declare class IrrigationMethodTableService {
    private readonly irrigationMethodRepository;
    private pubSub;
    constructor(irrigationMethodRepository: Repository<IrrigationMethodTable>, pubSub: RedisPubSub);
    create(createIrrigationMethodTableInput: CreateIrrigationMethodTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IrrigationMethodTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createIrrigationMethodTableInput: CreateIrrigationMethodTableInput): Promise<number>;
    findAll(): Promise<IrrigationMethodTable[]>;
    findOne(irrigationMethodId: number): Promise<IrrigationMethodTable>;
    update(irrigationMethodId: number, updateIrrigationMethodTableInput: UpdateIrrigationMethodTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: IrrigationMethodTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(irrigationMethodId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
