"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IrrigationMethodTableService = exports.NEW_IRRIGATION_METHOD_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const irrigation_method_table_entity_1 = require("./entities/irrigation-method-table.entity");
const typeorm_2 = require("typeorm");
exports.NEW_IRRIGATION_METHOD_ADD = "NEW_IRRIGATION_METHOD_ADD";
let IrrigationMethodTableService = exports.IrrigationMethodTableService = class IrrigationMethodTableService {
    constructor(irrigationMethodRepository, pubSub) {
        this.irrigationMethodRepository = irrigationMethodRepository;
        this.pubSub = pubSub;
    }
    async create(createIrrigationMethodTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createIrrigationMethodTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new irrigation_method_table_entity_1.IrrigationMethodTable();
            st.irrigationMethodName = createIrrigationMethodTableInput.irrigationMethodName;
            let result = await this.irrigationMethodRepository.save(st);
            this.pubSub.publish(exports.NEW_IRRIGATION_METHOD_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createIrrigationMethodTableInput) {
        let result = await this.irrigationMethodRepository.count({
            where: {
                irrigationMethodName: createIrrigationMethodTableInput.irrigationMethodName
            }
        });
        return result;
    }
    async findAll() {
        return await this.irrigationMethodRepository.find();
    }
    async findOne(irrigationMethodId) {
        return await this.irrigationMethodRepository.findOne({
            where: {
                irrigationMethodId
            }
        });
    }
    async update(irrigationMethodId, updateIrrigationMethodTableInput) {
        let result = await this.findOne(irrigationMethodId);
        if (result) {
            result.irrigationMethodName = updateIrrigationMethodTableInput.irrigationMethodName;
            let updatedResult = await this.irrigationMethodRepository.save(result);
            this.pubSub.publish(exports.NEW_IRRIGATION_METHOD_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(irrigationMethodId) {
        let result = await this.findOne(irrigationMethodId);
        if (result) {
            await this.irrigationMethodRepository.remove(result);
            this.pubSub.publish(exports.NEW_IRRIGATION_METHOD_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.IrrigationMethodTableService = IrrigationMethodTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(irrigation_method_table_entity_1.IrrigationMethodTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], IrrigationMethodTableService);
