import { LandTypeTableService } from './land-type-table.service';
import { LandTypeTable } from './entities/land-type-table.entity';
import { CreateLandTypeTableInput } from './dto/create-land-type-table.input';
import { UpdateLandTypeTableInput } from './dto/update-land-type-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LAND_TYPE_ADD = "NEW_LAND_TYPE_ADD";
export declare class LandTypeTableResolver {
    private readonly landTypeTableService;
    private pubSub;
    constructor(landTypeTableService: LandTypeTableService, pubSub: RedisPubSub);
    createLandTypeTable(createLandTypeTableInput: CreateLandTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllTypeOfLand(): Promise<LandTypeTable[]>;
    findOneTypeOfLand(landTypeId: number): Promise<LandTypeTable>;
    updateLandTypeTable(updateLandTypeTableInput: UpdateLandTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLandTypeTable(landTypeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    landTypeSubscription(): AsyncIterator<unknown, any, undefined>;
}
