"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LandTypeTableResolver = exports.NEW_LAND_TYPE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const land_type_table_service_1 = require("./land-type-table.service");
const land_type_table_entity_1 = require("./entities/land-type-table.entity");
const create_land_type_table_input_1 = require("./dto/create-land-type-table.input");
const update_land_type_table_input_1 = require("./dto/update-land-type-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const land_type_table_return_type_1 = require("./types/land-type-table-return.type");
const land_type_table_type_1 = require("./types/land-type-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_LAND_TYPE_ADD = "NEW_LAND_TYPE_ADD";
let LandTypeTableResolver = exports.LandTypeTableResolver = class LandTypeTableResolver {
    constructor(landTypeTableService, pubSub) {
        this.landTypeTableService = landTypeTableService;
        this.pubSub = pubSub;
    }
    createLandTypeTable(createLandTypeTableInput) {
        return this.landTypeTableService.create(createLandTypeTableInput);
    }
    findAllTypeOfLand() {
        return this.landTypeTableService.findAll();
    }
    findOneTypeOfLand(landTypeId) {
        return this.landTypeTableService.findOne(landTypeId);
    }
    updateLandTypeTable(updateLandTypeTableInput) {
        return this.landTypeTableService.update(updateLandTypeTableInput.landTypeId, updateLandTypeTableInput);
    }
    removeLandTypeTable(landTypeId) {
        return this.landTypeTableService.remove(landTypeId);
    }
    landTypeSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_LAND_TYPE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => land_type_table_return_type_1.LandTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('createLandTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_land_type_table_input_1.CreateLandTypeTableInput]),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "createLandTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [land_type_table_type_1.LandTypeTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "findAllTypeOfLand", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => land_type_table_type_1.LandTypeTableType),
    __param(0, (0, graphql_1.Args)('landTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "findOneTypeOfLand", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => land_type_table_return_type_1.LandTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('updateLandTypeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_land_type_table_input_1.UpdateLandTypeTableInput]),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "updateLandTypeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => land_type_table_return_type_1.LandTypeTableReturnType),
    __param(0, (0, graphql_1.Args)('landTypeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "removeLandTypeTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LandTypeTableResolver.prototype, "landTypeSubscription", null);
exports.LandTypeTableResolver = LandTypeTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => land_type_table_entity_1.LandTypeTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [land_type_table_service_1.LandTypeTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LandTypeTableResolver);
