import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateLandTypeTableInput } from './dto/create-land-type-table.input';
import { UpdateLandTypeTableInput } from './dto/update-land-type-table.input';
import { LandTypeTable } from './entities/land-type-table.entity';
export declare const NEW_LAND_TYPE_ADD = "NEW_LAND_TYPE_ADD";
export declare class LandTypeTableService {
    private readonly landTypeTableRepository;
    private pubSub;
    constructor(landTypeTableRepository: Repository<LandTypeTable>, pubSub: RedisPubSub);
    create(createLandTypeTableInput: CreateLandTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLandTypeTableInput: CreateLandTypeTableInput): Promise<LandTypeTable>;
    checkIfAlreadyExists(createLandTypeTableInput: CreateLandTypeTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<LandTypeTable[]>;
    findOne(landTypeId: number): Promise<LandTypeTable>;
    update(landTypeId: number, updateLandTypeTableInput: UpdateLandTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(landTypeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
