"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LandTypeTableService = exports.NEW_LAND_TYPE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const land_type_table_entity_1 = require("./entities/land-type-table.entity");
exports.NEW_LAND_TYPE_ADD = "NEW_LAND_TYPE_ADD";
let LandTypeTableService = exports.LandTypeTableService = class LandTypeTableService {
    constructor(landTypeTableRepository, pubSub) {
        this.landTypeTableRepository = landTypeTableRepository;
        this.pubSub = pubSub;
    }
    async create(createLandTypeTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLandTypeTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new land_type_table_entity_1.LandTypeTable();
            st.landTypeName = createLandTypeTableInput.landTypeName;
            st.requiredDetails = createLandTypeTableInput.requiredDetails;
            let result = await this.landTypeTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LAND_TYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLandTypeTableInput) {
        let checkIfAlreadyExists = await this.landTypeTableRepository.findOne({
            where: {
                landTypeName: createLandTypeTableInput.landTypeName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new land_type_table_entity_1.LandTypeTable();
            st.landTypeName = createLandTypeTableInput.landTypeName.trim();
            let result = await this.landTypeTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createLandTypeTableInput) {
        let result = await this.landTypeTableRepository.count({
            where: {
                landTypeName: createLandTypeTableInput.landTypeName
            }
        });
        return result;
    }
    async getCount() {
        return await this.landTypeTableRepository.count();
    }
    async findAll() {
        return await this.landTypeTableRepository.find();
    }
    async findOne(landTypeId) {
        return await this.landTypeTableRepository.findOne({
            where: {
                landTypeId
            }
        });
    }
    async update(landTypeId, updateLandTypeTableInput) {
        let result = await this.findOne(landTypeId);
        if (result) {
            result.landTypeName = updateLandTypeTableInput.landTypeName;
            result.requiredDetails = updateLandTypeTableInput.requiredDetails;
            let updatedResult = await this.landTypeTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LAND_TYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(landTypeId) {
        let result = await this.findOne(landTypeId);
        if (result) {
            await this.landTypeTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LAND_TYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LandTypeTableService = LandTypeTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(land_type_table_entity_1.LandTypeTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], LandTypeTableService);
