import { LandareaunitTableService } from './landareaunit-table.service';
import { LandareaunitTable } from './entities/landareaunit-table.entity';
import { CreateLandareaunitTableInput } from './dto/create-landareaunit-table.input';
import { UpdateLandareaunitTableInput } from './dto/update-landareaunit-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LANDAREAUNIT_ADD = "NEW_LANDAREAUNIT_ADD";
export declare class LandareaunitTableResolver {
    private readonly landareaunitTableService;
    private pubSub;
    constructor(landareaunitTableService: LandareaunitTableService, pubSub: RedisPubSub);
    createLandareaunitTable(createLandareaunitTableInput: CreateLandareaunitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandareaunitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAll(): Promise<LandareaunitTable[]>;
    findOne(landAreaUnitId: number): Promise<LandareaunitTable>;
    updateLandareaunitTable(updateLandareaunitTableInput: UpdateLandareaunitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandareaunitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLandareaunitTable(landAreaUnitId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    landAreaUnitSubscription(): AsyncIterator<unknown, any, undefined>;
}
