"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LandareaunitTableResolver = exports.NEW_LANDAREAUNIT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const landareaunit_table_service_1 = require("./landareaunit-table.service");
const landareaunit_table_entity_1 = require("./entities/landareaunit-table.entity");
const create_landareaunit_table_input_1 = require("./dto/create-landareaunit-table.input");
const update_landareaunit_table_input_1 = require("./dto/update-landareaunit-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const landareaunit_table_return_type_1 = require("./types/landareaunit-table-return.type");
const landareaunit_table_type_1 = require("./types/landareaunit-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_LANDAREAUNIT_ADD = "NEW_LANDAREAUNIT_ADD";
let LandareaunitTableResolver = exports.LandareaunitTableResolver = class LandareaunitTableResolver {
    constructor(landareaunitTableService, pubSub) {
        this.landareaunitTableService = landareaunitTableService;
        this.pubSub = pubSub;
    }
    createLandareaunitTable(createLandareaunitTableInput) {
        return this.landareaunitTableService.create(createLandareaunitTableInput);
    }
    findAll() {
        return this.landareaunitTableService.findAll();
    }
    findOne(landAreaUnitId) {
        return this.landareaunitTableService.findOne(landAreaUnitId);
    }
    updateLandareaunitTable(updateLandareaunitTableInput) {
        return this.landareaunitTableService.update(updateLandareaunitTableInput.landAreaUnitId, updateLandareaunitTableInput);
    }
    removeLandareaunitTable(landAreaUnitId) {
        return this.landareaunitTableService.remove(landAreaUnitId);
    }
    landAreaUnitSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_LANDAREAUNIT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => landareaunit_table_return_type_1.LandAreaUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('createLandareaunitTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_landareaunit_table_input_1.CreateLandareaunitTableInput]),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "createLandareaunitTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [landareaunit_table_type_1.LandAreaUnitTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "findAll", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => landareaunit_table_type_1.LandAreaUnitTableType),
    __param(0, (0, graphql_1.Args)('landAreaUnitId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => landareaunit_table_return_type_1.LandAreaUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('updateLandareaunitTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_landareaunit_table_input_1.UpdateLandareaunitTableInput]),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "updateLandareaunitTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => landareaunit_table_return_type_1.LandAreaUnitTableReturnType),
    __param(0, (0, graphql_1.Args)('landAreaUnitId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "removeLandareaunitTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LandareaunitTableResolver.prototype, "landAreaUnitSubscription", null);
exports.LandareaunitTableResolver = LandareaunitTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => landareaunit_table_entity_1.LandareaunitTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [landareaunit_table_service_1.LandareaunitTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LandareaunitTableResolver);
