import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateLandareaunitTableInput } from './dto/create-landareaunit-table.input';
import { UpdateLandareaunitTableInput } from './dto/update-landareaunit-table.input';
import { LandareaunitTable } from './entities/landareaunit-table.entity';
export declare const NEW_LANDAREAUNIT_ADD = "NEW_LANDAREAUNIT_ADD";
export declare class LandareaunitTableService {
    private readonly landAreaUnitTableRepository;
    private pubSub;
    constructor(landAreaUnitTableRepository: Repository<LandareaunitTable>, pubSub: RedisPubSub);
    create(createLandareaunitTableInput: CreateLandareaunitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandareaunitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLandareaunitTableInput: CreateLandareaunitTableInput): Promise<LandareaunitTable>;
    checkIfAlreadyExists(createLandareaunitTableInput: CreateLandareaunitTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<LandareaunitTable[]>;
    findOne(landAreaUnitId: number): Promise<LandareaunitTable>;
    update(landAreaUnitId: number, updateLandareaunitTableInput: UpdateLandareaunitTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LandareaunitTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(landAreaUnitId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
