"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LandareaunitTableService = exports.NEW_LANDAREAUNIT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const landareaunit_table_entity_1 = require("./entities/landareaunit-table.entity");
exports.NEW_LANDAREAUNIT_ADD = "NEW_LANDAREAUNIT_ADD";
let LandareaunitTableService = exports.LandareaunitTableService = class LandareaunitTableService {
    constructor(landAreaUnitTableRepository, pubSub) {
        this.landAreaUnitTableRepository = landAreaUnitTableRepository;
        this.pubSub = pubSub;
    }
    async create(createLandareaunitTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLandareaunitTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new landareaunit_table_entity_1.LandareaunitTable();
            st.landAreaUnitName = createLandareaunitTableInput.landAreaUnitName;
            st.landConversionFactor = createLandareaunitTableInput.landConversionFactor;
            let result = await this.landAreaUnitTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LANDAREAUNIT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLandareaunitTableInput) {
        let checkIfAlreadyExists = await this.landAreaUnitTableRepository.findOne({
            where: {
                landAreaUnitName: createLandareaunitTableInput.landAreaUnitName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new landareaunit_table_entity_1.LandareaunitTable();
            st.landAreaUnitName = createLandareaunitTableInput.landAreaUnitName.trim();
            st.landConversionFactor = createLandareaunitTableInput.landConversionFactor.trim();
            let result = await this.landAreaUnitTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createLandareaunitTableInput) {
        let result = await this.landAreaUnitTableRepository.count({
            where: {
                landAreaUnitName: createLandareaunitTableInput.landAreaUnitName
            }
        });
        return result;
    }
    async getCount() {
        return await this.landAreaUnitTableRepository.count();
    }
    async findAll() {
        return await this.landAreaUnitTableRepository.find();
    }
    async findOne(landAreaUnitId) {
        return await this.landAreaUnitTableRepository.findOne({
            where: {
                landAreaUnitId
            }
        });
    }
    async update(landAreaUnitId, updateLandareaunitTableInput) {
        let result = await this.findOne(landAreaUnitId);
        if (result) {
            result.landAreaUnitName = updateLandareaunitTableInput.landAreaUnitName;
            result.landConversionFactor = updateLandareaunitTableInput.landConversionFactor;
            let updatedResult = await this.landAreaUnitTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LANDAREAUNIT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(landAreaUnitId) {
        let result = await this.findOne(landAreaUnitId);
        if (result) {
            await this.landAreaUnitTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LANDAREAUNIT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LandareaunitTableService = LandareaunitTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(landareaunit_table_entity_1.LandareaunitTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], LandareaunitTableService);
