"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LedgerEntryTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const ledger_entry_table_service_1 = require("./ledger-entry-table.service");
const create_ledger_table_input_1 = require("./dto/create-ledger-table.input");
const ledger_entry_table_return_type_1 = require("./types/ledger-entry-table-return.type");
const ledger_entry_table_type_1 = require("./types/ledger-entry-table.type");
const ledger_entry_table_entity_1 = require("./entities/ledger-entry-table.entity");
let LedgerEntryTableResolver = class LedgerEntryTableResolver {
    constructor(ledgerEntryTableService) {
        this.ledgerEntryTableService = ledgerEntryTableService;
    }
    createLedgerEntryTable(createLedgerTableInput, user) {
        return this.ledgerEntryTableService.create(createLedgerTableInput, user);
    }
    findAllLedger() {
        return this.ledgerEntryTableService.findAll();
    }
    findLedgerByHousingId(housingId) {
        return this.ledgerEntryTableService.findByHousingId(housingId);
    }
    findLedgerByLedgerId(ledgerId) {
        return this.ledgerEntryTableService.findOne(ledgerId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ledger_entry_table_return_type_1.LedgerEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createLedgerTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_ledger_table_input_1.CreateLedgerTableInput, Object]),
    __metadata("design:returntype", void 0)
], LedgerEntryTableResolver.prototype, "createLedgerEntryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ledger_entry_table_type_1.LedgerEntryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LedgerEntryTableResolver.prototype, "findAllLedger", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ledger_entry_table_type_1.LedgerEntryTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LedgerEntryTableResolver.prototype, "findLedgerByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => ledger_entry_table_type_1.LedgerEntryTableType),
    __param(0, (0, graphql_1.Args)('ledgerId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LedgerEntryTableResolver.prototype, "findLedgerByLedgerId", null);
LedgerEntryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => ledger_entry_table_entity_1.LedgerEntryTable),
    __metadata("design:paramtypes", [ledger_entry_table_service_1.LedgerEntryTableService])
], LedgerEntryTableResolver);
exports.LedgerEntryTableResolver = LedgerEntryTableResolver;
