import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { BreedTableService } from 'src/breed-table/breed-table.service';
import { CreateLedgerTableInput } from './dto/create-ledger-table.input';
import { LedgerEntryTable } from './entities/ledger-entry-table.entity';
export declare class LedgerEntryTableService {
    private readonly ledgerTableRepository;
    private readonly userCollectionService;
    private readonly farmersTableService;
    private readonly housingTableService;
    private readonly breedTableService;
    constructor(ledgerTableRepository: Repository<LedgerEntryTable>, userCollectionService: UserCollectionService, farmersTableService: FarmersTableService, housingTableService: HousingTableService, breedTableService: BreedTableService);
    create(createLedgerTableInput: CreateLedgerTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: LedgerEntryTable;
    }>;
    findByHousingId(housingId: number): Promise<LedgerEntryTable[]>;
    findAll(): Promise<LedgerEntryTable[]>;
    findOne(ledgerId: number): Promise<LedgerEntryTable>;
}
