"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LedgerEntryTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const typeorm_2 = require("typeorm");
const housing_table_service_1 = require("../housing-table/housing-table.service");
const farmers_table_service_1 = require("../farmers-table/farmers-table.service");
const breed_table_service_1 = require("../breed-table/breed-table.service");
const ledger_entry_table_entity_1 = require("./entities/ledger-entry-table.entity");
let LedgerEntryTableService = class LedgerEntryTableService {
    constructor(ledgerTableRepository, userCollectionService, farmersTableService, housingTableService, breedTableService) {
        this.ledgerTableRepository = ledgerTableRepository;
        this.userCollectionService = userCollectionService;
        this.farmersTableService = farmersTableService;
        this.housingTableService = housingTableService;
        this.breedTableService = breedTableService;
    }
    async create(createLedgerTableInput, user) {
        let ht = new ledger_entry_table_entity_1.LedgerEntryTable();
        let userTable = await this.userCollectionService.getOneByUserId(user.userId);
        let housingTable = await this.housingTableService.findOne(createLedgerTableInput.housingId);
        let breedTable = await this.breedTableService.findOne(createLedgerTableInput.breedId);
        ht.UserTable = userTable;
        ht.HousingTable = housingTable;
        ht.BreedTable = breedTable;
        ht.entryType = createLedgerTableInput.entryType;
        ht.dateOfEntry = createLedgerTableInput.dateOfEntry;
        ht.ageGroup = createLedgerTableInput.ageGroup;
        ht.qtyMale = createLedgerTableInput.qtyMale;
        ht.qtyFemale = createLedgerTableInput.qtyFemale;
        ht.qtyTotal = createLedgerTableInput.qtyTotal;
        ht.avgWeight = createLedgerTableInput.avgWeight;
        ht.referenceId = createLedgerTableInput.referenceId;
        let result = await this.ledgerTableRepository.save(ht);
        return {
            status: true,
            status_text: "Successfully Submitted",
            data: result
        };
    }
    async findByHousingId(housingId) {
        return await this.ledgerTableRepository.find({
            where: {
                HousingTable: {
                    housingId: housingId
                }
            },
            relations: ["UserTable", "BreedTable", "HousingTable", "HousingTable.FarmersTable"]
        });
    }
    async findAll() {
        return await this.ledgerTableRepository.find({
            relations: ["UserTable", "BreedTable", "HousingTable", "HousingTable.FarmersTable"]
        });
    }
    async findOne(ledgerId) {
        return await this.ledgerTableRepository.findOne({
            where: {
                ledgerId
            },
            relations: ["UserTable", "BreedTable", "HousingTable", "HousingTable.FarmersTable"]
        });
    }
};
LedgerEntryTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ledger_entry_table_entity_1.LedgerEntryTable)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        user_collection_service_1.UserCollectionService,
        farmers_table_service_1.FarmersTableService,
        housing_table_service_1.HousingTableService,
        breed_table_service_1.BreedTableService])
], LedgerEntryTableService);
exports.LedgerEntryTableService = LedgerEntryTableService;
