import { LivelihoodSourceTableService } from './livelihood-source-table.service';
import { LivelihoodSourceTable } from './entities/livelihood-source-table.entity';
import { CreateLivelihoodSourceTableInput } from './dto/create-livelihood-source-table.input';
import { UpdateLivelihoodSourceTableInput } from './dto/update-livelihood-source-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LS_ADD = "NEW_LS_ADD";
export declare class LivelihoodSourceTableResolver {
    private readonly livelihoodSourceTableService;
    private pubSub;
    constructor(livelihoodSourceTableService: LivelihoodSourceTableService, pubSub: RedisPubSub);
    createLivelihoodSourceTable(createLivelihoodSourceTableInput: CreateLivelihoodSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllLivelihoodSource(): Promise<LivelihoodSourceTable[]>;
    findOneLivelihoodSource(lsId: number): Promise<LivelihoodSourceTable>;
    toggleLsTypeStatus(lsId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    updateLivelihoodSourceTable(updateLivelihoodSourceTableInput: UpdateLivelihoodSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLivelihoodSourceTable(lsId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    livelihoodSourceSubscription(): AsyncIterator<unknown, any, undefined>;
}
