"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LivelihoodSourceTableResolver = exports.NEW_LS_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const livelihood_source_table_service_1 = require("./livelihood-source-table.service");
const livelihood_source_table_entity_1 = require("./entities/livelihood-source-table.entity");
const create_livelihood_source_table_input_1 = require("./dto/create-livelihood-source-table.input");
const update_livelihood_source_table_input_1 = require("./dto/update-livelihood-source-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const livelihood_source_table_return_type_1 = require("./types/livelihood-source-table-return.type");
const livelihood_source_table_type_1 = require("./types/livelihood-source-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_LS_ADD = "NEW_LS_ADD";
let LivelihoodSourceTableResolver = exports.LivelihoodSourceTableResolver = class LivelihoodSourceTableResolver {
    constructor(livelihoodSourceTableService, pubSub) {
        this.livelihoodSourceTableService = livelihoodSourceTableService;
        this.pubSub = pubSub;
    }
    createLivelihoodSourceTable(createLivelihoodSourceTableInput) {
        return this.livelihoodSourceTableService.create(createLivelihoodSourceTableInput);
    }
    findAllLivelihoodSource() {
        return this.livelihoodSourceTableService.findAll();
    }
    findOneLivelihoodSource(lsId) {
        return this.livelihoodSourceTableService.findOne(lsId);
    }
    toggleLsTypeStatus(lsId, type) {
        return this.livelihoodSourceTableService.toggleLsTypeStatus(lsId, type);
    }
    updateLivelihoodSourceTable(updateLivelihoodSourceTableInput) {
        return this.livelihoodSourceTableService.update(updateLivelihoodSourceTableInput.lsId, updateLivelihoodSourceTableInput);
    }
    removeLivelihoodSourceTable(lsId) {
        return this.livelihoodSourceTableService.remove(lsId);
    }
    livelihoodSourceSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_LS_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => livelihood_source_table_return_type_1.LivelihoodSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('createLivelihoodSourceTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_livelihood_source_table_input_1.CreateLivelihoodSourceTableInput]),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "createLivelihoodSourceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [livelihood_source_table_type_1.LivelihoodSourceTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "findAllLivelihoodSource", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => livelihood_source_table_type_1.LivelihoodSourceTableType),
    __param(0, (0, graphql_1.Args)('lsId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "findOneLivelihoodSource", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => livelihood_source_table_return_type_1.LivelihoodSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('lsId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('type', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String]),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "toggleLsTypeStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => livelihood_source_table_return_type_1.LivelihoodSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('updateLivelihoodSourceTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_livelihood_source_table_input_1.UpdateLivelihoodSourceTableInput]),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "updateLivelihoodSourceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => livelihood_source_table_return_type_1.LivelihoodSourceTableReturnType),
    __param(0, (0, graphql_1.Args)('lsId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "removeLivelihoodSourceTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LivelihoodSourceTableResolver.prototype, "livelihoodSourceSubscription", null);
exports.LivelihoodSourceTableResolver = LivelihoodSourceTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => livelihood_source_table_entity_1.LivelihoodSourceTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [livelihood_source_table_service_1.LivelihoodSourceTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LivelihoodSourceTableResolver);
