import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateLivelihoodSourceTableInput } from './dto/create-livelihood-source-table.input';
import { UpdateLivelihoodSourceTableInput } from './dto/update-livelihood-source-table.input';
import { LivelihoodSourceTable } from './entities/livelihood-source-table.entity';
export declare const NEW_LS_ADD = "NEW_LS_ADD";
export declare class LivelihoodSourceTableService {
    private readonly livelihoodSourceTableRepository;
    private pubSub;
    constructor(livelihoodSourceTableRepository: Repository<LivelihoodSourceTable>, pubSub: RedisPubSub);
    create(createLivelihoodSourceTableInput: CreateLivelihoodSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLivelihoodSourceTableInput: CreateLivelihoodSourceTableInput): Promise<LivelihoodSourceTable>;
    checkIfAlreadyExists(createLivelihoodSourceTableInput: CreateLivelihoodSourceTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<LivelihoodSourceTable[]>;
    findAllOrdered(): Promise<LivelihoodSourceTable[]>;
    findAllOrderedForFblp(): Promise<LivelihoodSourceTable[]>;
    findAllForIntervention(): Promise<LivelihoodSourceTable[]>;
    findAllByIncomeActivityCode(incomeActivityCode: string): Promise<LivelihoodSourceTable[]>;
    findOne(lsId: number): Promise<LivelihoodSourceTable>;
    toggleLsTypeStatus(lsId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    update(lsId: number, updateLivelihoodSourceTableInput: UpdateLivelihoodSourceTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LivelihoodSourceTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(lsId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
