"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LivelihoodSourceTableService = exports.NEW_LS_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const livelihood_source_table_entity_1 = require("./entities/livelihood-source-table.entity");
exports.NEW_LS_ADD = "NEW_LS_ADD";
let LivelihoodSourceTableService = exports.LivelihoodSourceTableService = class LivelihoodSourceTableService {
    constructor(livelihoodSourceTableRepository, pubSub) {
        this.livelihoodSourceTableRepository = livelihoodSourceTableRepository;
        this.pubSub = pubSub;
    }
    async create(createLivelihoodSourceTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLivelihoodSourceTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new livelihood_source_table_entity_1.LivelihoodSourceTable();
            st.lsName = createLivelihoodSourceTableInput.lsName;
            st.lsCode = createLivelihoodSourceTableInput.lsCode;
            st.incomeActivityCode = createLivelihoodSourceTableInput.incomeActivityCode;
            st.requiredDetails = createLivelihoodSourceTableInput.requiredDetails;
            let result = await this.livelihoodSourceTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLivelihoodSourceTableInput) {
        let checkIfAlreadyExists = await this.livelihoodSourceTableRepository.findOne({
            where: {
                lsName: createLivelihoodSourceTableInput.lsName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new livelihood_source_table_entity_1.LivelihoodSourceTable();
            st.lsName = createLivelihoodSourceTableInput.lsName.trim();
            st.lsCode = createLivelihoodSourceTableInput.lsCode;
            st.incomeActivityCode = createLivelihoodSourceTableInput.incomeActivityCode;
            st.requiredDetails = createLivelihoodSourceTableInput.requiredDetails;
            let result = await this.livelihoodSourceTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createLivelihoodSourceTableInput) {
        let result = await this.livelihoodSourceTableRepository.count({
            where: {
                lsName: createLivelihoodSourceTableInput.lsName
            }
        });
        return result;
    }
    async getCount() {
        return await this.livelihoodSourceTableRepository.count();
    }
    async findAll() {
        return await this.livelihoodSourceTableRepository.find();
    }
    async findAllOrdered() {
        return await this.livelihoodSourceTableRepository.find({
            order: {
                incomeActivityCode: "ASC"
            }
        });
    }
    async findAllOrderedForFblp() {
        return await this.livelihoodSourceTableRepository.find({
            where: {
                needInIntervention: "YES"
            },
            order: {
                incomeActivityCode: "ASC",
            }
        });
    }
    async findAllForIntervention() {
        return await this.livelihoodSourceTableRepository.find({
            where: {
                needInIntervention: "YES"
            }
        });
    }
    async findAllByIncomeActivityCode(incomeActivityCode) {
        return await this.livelihoodSourceTableRepository.find({
            where: {
                incomeActivityCode: incomeActivityCode
            }
        });
    }
    async findOne(lsId) {
        return await this.livelihoodSourceTableRepository.findOne({
            where: {
                lsId
            }
        });
    }
    async toggleLsTypeStatus(lsId, type) {
        let dd = await this.findOne(lsId);
        if (dd) {
            if (type == "hasType") {
                let oldHasType = dd.hasType;
                if (oldHasType == "YES") {
                    dd.hasType = "NO";
                }
                if (oldHasType == "NO") {
                    dd.hasType = "YES";
                }
            }
            if (type == "hasIpdm") {
                let oldHasIpdm = dd.hasIpdm;
                if (oldHasIpdm == "YES") {
                    dd.hasIpdm = "NO";
                }
                if (oldHasIpdm == "NO") {
                    dd.hasIpdm = "YES";
                }
            }
            if (type == "needFeed") {
                let oldNeedFeed = dd.needFeed;
                if (oldNeedFeed == "YES") {
                    dd.needFeed = "NO";
                }
                if (oldNeedFeed == "NO") {
                    dd.needFeed = "YES";
                }
            }
            let result = await this.livelihoodSourceTableRepository.save(dd);
            return {
                status: true,
                status_text: "Updated",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async update(lsId, updateLivelihoodSourceTableInput) {
        let result = await this.findOne(lsId);
        if (result) {
            result.lsName = updateLivelihoodSourceTableInput.lsName;
            result.lsCode = updateLivelihoodSourceTableInput.lsCode;
            result.incomeActivityCode = updateLivelihoodSourceTableInput.incomeActivityCode;
            result.requiredDetails = updateLivelihoodSourceTableInput.requiredDetails;
            let updatedResult = await this.livelihoodSourceTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(lsId) {
        let result = await this.findOne(lsId);
        if (result) {
            await this.livelihoodSourceTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LivelihoodSourceTableService = LivelihoodSourceTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(livelihood_source_table_entity_1.LivelihoodSourceTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], LivelihoodSourceTableService);
