import { LsFeedMasterTableService } from './ls-feed-master-table.service';
import { LsFeedMasterTable } from './entities/ls-feed-master-table.entity';
import { CreateLsFeedMasterTableInput } from './dto/create-ls-feed-master-table.input';
import { UpdateLsFeedMasterTableInput } from './dto/update-ls-feed-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LSFEED_ADD = "NEW_LSFEED_ADD";
export declare class LsFeedMasterTableResolver {
    private readonly lsFeedMasterTableService;
    private pubSub;
    constructor(lsFeedMasterTableService: LsFeedMasterTableService, pubSub: RedisPubSub);
    createLsFeedMasterTable(createLsFeedMasterTableInput: CreateLsFeedMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsFeedMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllLsFeed(): Promise<LsFeedMasterTable[]>;
    findOne(lsFeedMasterId: number): Promise<LsFeedMasterTable>;
    updateLsFeedMasterTable(updateLsFeedMasterTableInput: UpdateLsFeedMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsFeedMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLsFeedMasterTable(lsFeedMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    lsFeedSubscription(): AsyncIterator<unknown, any, undefined>;
}
