"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LsFeedMasterTableResolver = exports.NEW_LSFEED_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const ls_feed_master_table_service_1 = require("./ls-feed-master-table.service");
const ls_feed_master_table_entity_1 = require("./entities/ls-feed-master-table.entity");
const create_ls_feed_master_table_input_1 = require("./dto/create-ls-feed-master-table.input");
const update_ls_feed_master_table_input_1 = require("./dto/update-ls-feed-master-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const ls_feed_master_table_return_type_1 = require("./types/ls-feed-master-table-return.type");
const ls_feed_master_table_type_1 = require("./types/ls-feed-master-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_LSFEED_ADD = "NEW_LSFEED_ADD";
let LsFeedMasterTableResolver = exports.LsFeedMasterTableResolver = class LsFeedMasterTableResolver {
    constructor(lsFeedMasterTableService, pubSub) {
        this.lsFeedMasterTableService = lsFeedMasterTableService;
        this.pubSub = pubSub;
    }
    createLsFeedMasterTable(createLsFeedMasterTableInput) {
        return this.lsFeedMasterTableService.create(createLsFeedMasterTableInput);
    }
    findAllLsFeed() {
        return this.lsFeedMasterTableService.findAll();
    }
    findOne(lsFeedMasterId) {
        return this.lsFeedMasterTableService.findOne(lsFeedMasterId);
    }
    updateLsFeedMasterTable(updateLsFeedMasterTableInput) {
        return this.lsFeedMasterTableService.update(updateLsFeedMasterTableInput.lsFeedMasterId, updateLsFeedMasterTableInput);
    }
    removeLsFeedMasterTable(lsFeedMasterId) {
        return this.lsFeedMasterTableService.remove(lsFeedMasterId);
    }
    lsFeedSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_LSFEED_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_feed_master_table_return_type_1.LsFeedMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('createLsFeedMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_ls_feed_master_table_input_1.CreateLsFeedMasterTableInput]),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "createLsFeedMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ls_feed_master_table_type_1.LsFeedMasterTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "findAllLsFeed", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => ls_feed_master_table_type_1.LsFeedMasterTableType),
    __param(0, (0, graphql_1.Args)('lsFeedMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_feed_master_table_return_type_1.LsFeedMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('updateLsFeedMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_ls_feed_master_table_input_1.UpdateLsFeedMasterTableInput]),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "updateLsFeedMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_feed_master_table_return_type_1.LsFeedMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('lsFeedMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "removeLsFeedMasterTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LsFeedMasterTableResolver.prototype, "lsFeedSubscription", null);
exports.LsFeedMasterTableResolver = LsFeedMasterTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => ls_feed_master_table_entity_1.LsFeedMasterTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [ls_feed_master_table_service_1.LsFeedMasterTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LsFeedMasterTableResolver);
