import { CreateLsFeedMasterTableInput } from './dto/create-ls-feed-master-table.input';
import { UpdateLsFeedMasterTableInput } from './dto/update-ls-feed-master-table.input';
import { LsFeedMasterTable } from './entities/ls-feed-master-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
export declare const NEW_LSFEED_ADD = "NEW_LSFEED_ADD";
export declare class LsFeedMasterTableService {
    private readonly lsFeedMasterTableRepository;
    private readonly livelihoodSourceTableService;
    private pubSub;
    constructor(lsFeedMasterTableRepository: Repository<LsFeedMasterTable>, livelihoodSourceTableService: LivelihoodSourceTableService, pubSub: RedisPubSub);
    create(createLsFeedMasterTableInput: CreateLsFeedMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsFeedMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLsFeedMasterTableInput: CreateLsFeedMasterTableInput): Promise<LsFeedMasterTable>;
    checkIfAlreadyExists(createLsFeedMasterTableInput: CreateLsFeedMasterTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<LsFeedMasterTable[]>;
    findOne(lsFeedMasterId: number): Promise<LsFeedMasterTable>;
    update(lsFeedMasterId: number, updateLsFeedMasterTableInput: UpdateLsFeedMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsFeedMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(lsFeedMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
