"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LsFeedMasterTableService = exports.NEW_LSFEED_ADD = void 0;
const common_1 = require("@nestjs/common");
const ls_feed_master_table_entity_1 = require("./entities/ls-feed-master-table.entity");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
exports.NEW_LSFEED_ADD = "NEW_LSFEED_ADD";
let LsFeedMasterTableService = exports.LsFeedMasterTableService = class LsFeedMasterTableService {
    constructor(lsFeedMasterTableRepository, livelihoodSourceTableService, pubSub) {
        this.lsFeedMasterTableRepository = lsFeedMasterTableRepository;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
        this.pubSub = pubSub;
    }
    async create(createLsFeedMasterTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLsFeedMasterTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new ls_feed_master_table_entity_1.LsFeedMasterTable();
            st.feedName = createLsFeedMasterTableInput.feedName;
            st.LivelihoodSourceTable = await this.livelihoodSourceTableService.findOne(createLsFeedMasterTableInput.lsId);
            let result = await this.lsFeedMasterTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LSFEED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLsFeedMasterTableInput) {
        let checkIfAlreadyExists = await this.lsFeedMasterTableRepository.findOne({
            where: {
                feedName: createLsFeedMasterTableInput.feedName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new ls_feed_master_table_entity_1.LsFeedMasterTable();
            st.feedName = createLsFeedMasterTableInput.feedName.trim();
            let result = await this.lsFeedMasterTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createLsFeedMasterTableInput) {
        let result = await this.lsFeedMasterTableRepository.count({
            where: {
                feedName: createLsFeedMasterTableInput.feedName,
                LivelihoodSourceTable: {
                    lsId: createLsFeedMasterTableInput.lsId
                }
            }
        });
        return result;
    }
    async getCount() {
        return await this.lsFeedMasterTableRepository.count();
    }
    async findAll() {
        return await this.lsFeedMasterTableRepository.find({
            relations: {
                LivelihoodSourceTable: true
            }
        });
    }
    async findOne(lsFeedMasterId) {
        return await this.lsFeedMasterTableRepository.findOne({
            where: {
                lsFeedMasterId
            }
        });
    }
    async update(lsFeedMasterId, updateLsFeedMasterTableInput) {
        let result = await this.findOne(lsFeedMasterId);
        if (result) {
            result.feedName = updateLsFeedMasterTableInput.feedName;
            result.LivelihoodSourceTable = await this.livelihoodSourceTableService.findOne(updateLsFeedMasterTableInput.lsId);
            let updatedResult = await this.lsFeedMasterTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LSFEED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(lsFeedMasterId) {
        let result = await this.findOne(lsFeedMasterId);
        if (result) {
            await this.lsFeedMasterTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LSFEED_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LsFeedMasterTableService = LsFeedMasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ls_feed_master_table_entity_1.LsFeedMasterTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        livelihood_source_table_service_1.LivelihoodSourceTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LsFeedMasterTableService);
