import { LsIpdmMasterTableService } from './ls-ipdm-master-table.service';
import { LsIpdmMasterTable } from './entities/ls-ipdm-master-table.entity';
import { CreateLsIpdmMasterTableInput } from './dto/create-ls-ipdm-master-table.input';
import { UpdateLsIpdmMasterTableInput } from './dto/update-ls-ipdm-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LSIPDM_ADD = "NEW_LSIPDM_ADD";
export declare class LsIpdmMasterTableResolver {
    private readonly lsIpdmMasterTableService;
    private pubSub;
    constructor(lsIpdmMasterTableService: LsIpdmMasterTableService, pubSub: RedisPubSub);
    createLsIpdmMasterTable(createLsIpdmMasterTableInput: CreateLsIpdmMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsIpdmMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllIpdm(): Promise<LsIpdmMasterTable[]>;
    findOne(lsIpdmMasterId: number): Promise<LsIpdmMasterTable>;
    updateLsIpdmMasterTable(updateLsIpdmMasterTableInput: UpdateLsIpdmMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsIpdmMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLsIpdmMasterTable(lsIpdmMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    lsIpdmSubscription(): AsyncIterator<unknown, any, undefined>;
}
