"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LsIpdmMasterTableResolver = exports.NEW_LSIPDM_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const ls_ipdm_master_table_service_1 = require("./ls-ipdm-master-table.service");
const ls_ipdm_master_table_entity_1 = require("./entities/ls-ipdm-master-table.entity");
const create_ls_ipdm_master_table_input_1 = require("./dto/create-ls-ipdm-master-table.input");
const update_ls_ipdm_master_table_input_1 = require("./dto/update-ls-ipdm-master-table.input");
const ls_ipdm_master_table_type_1 = require("./types/ls-ipdm-master-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const ls_ipdm_master_table_return_type_1 = require("./types/ls-ipdm-master-table-return.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_LSIPDM_ADD = "NEW_LSIPDM_ADD";
let LsIpdmMasterTableResolver = exports.LsIpdmMasterTableResolver = class LsIpdmMasterTableResolver {
    constructor(lsIpdmMasterTableService, pubSub) {
        this.lsIpdmMasterTableService = lsIpdmMasterTableService;
        this.pubSub = pubSub;
    }
    createLsIpdmMasterTable(createLsIpdmMasterTableInput) {
        return this.lsIpdmMasterTableService.create(createLsIpdmMasterTableInput);
    }
    findAllIpdm() {
        return this.lsIpdmMasterTableService.findAll();
    }
    findOne(lsIpdmMasterId) {
        return this.lsIpdmMasterTableService.findOne(lsIpdmMasterId);
    }
    updateLsIpdmMasterTable(updateLsIpdmMasterTableInput) {
        return this.lsIpdmMasterTableService.update(updateLsIpdmMasterTableInput.lsIpdmMasterId, updateLsIpdmMasterTableInput);
    }
    removeLsIpdmMasterTable(lsIpdmMasterId) {
        return this.lsIpdmMasterTableService.remove(lsIpdmMasterId);
    }
    lsIpdmSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_LSIPDM_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_ipdm_master_table_return_type_1.LsIpdmMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('createLsIpdmMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_ls_ipdm_master_table_input_1.CreateLsIpdmMasterTableInput]),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "createLsIpdmMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ls_ipdm_master_table_type_1.LsIpdmMasterTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "findAllIpdm", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => ls_ipdm_master_table_type_1.LsIpdmMasterTableType),
    __param(0, (0, graphql_1.Args)('lsIpdmMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_ipdm_master_table_return_type_1.LsIpdmMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('updateLsIpdmMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_ls_ipdm_master_table_input_1.UpdateLsIpdmMasterTableInput]),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "updateLsIpdmMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ls_ipdm_master_table_return_type_1.LsIpdmMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('lsIpdmMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "removeLsIpdmMasterTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], LsIpdmMasterTableResolver.prototype, "lsIpdmSubscription", null);
exports.LsIpdmMasterTableResolver = LsIpdmMasterTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => ls_ipdm_master_table_entity_1.LsIpdmMasterTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [ls_ipdm_master_table_service_1.LsIpdmMasterTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LsIpdmMasterTableResolver);
