import { CreateLsIpdmMasterTableInput } from './dto/create-ls-ipdm-master-table.input';
import { UpdateLsIpdmMasterTableInput } from './dto/update-ls-ipdm-master-table.input';
import { LsIpdmMasterTable } from './entities/ls-ipdm-master-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LSIPDM_ADD = "NEW_LSIPDM_ADD";
export declare class LsIpdmMasterTableService {
    private readonly lsIpdmTableRepository;
    private pubSub;
    constructor(lsIpdmTableRepository: Repository<LsIpdmMasterTable>, pubSub: RedisPubSub);
    create(createLsIpdmMasterTableInput: CreateLsIpdmMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsIpdmMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLsIpdmMasterTableInput: CreateLsIpdmMasterTableInput): Promise<LsIpdmMasterTable>;
    findAll(): Promise<LsIpdmMasterTable[]>;
    checkIfAlreadyExists(createLsIpdmMasterTableInput: CreateLsIpdmMasterTableInput): Promise<number>;
    getCount(): Promise<number>;
    findOne(lsIpdmMasterId: number): Promise<LsIpdmMasterTable>;
    update(lsIpdmMasterId: number, updateLsIpdmMasterTableInput: UpdateLsIpdmMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsIpdmMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(lsIpdmMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
