"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LsIpdmMasterTableService = exports.NEW_LSIPDM_ADD = void 0;
const common_1 = require("@nestjs/common");
const ls_ipdm_master_table_entity_1 = require("./entities/ls-ipdm-master-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_LSIPDM_ADD = "NEW_LSIPDM_ADD";
let LsIpdmMasterTableService = exports.LsIpdmMasterTableService = class LsIpdmMasterTableService {
    constructor(lsIpdmTableRepository, pubSub) {
        this.lsIpdmTableRepository = lsIpdmTableRepository;
        this.pubSub = pubSub;
    }
    async create(createLsIpdmMasterTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLsIpdmMasterTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new ls_ipdm_master_table_entity_1.LsIpdmMasterTable();
            st.ipdmName = createLsIpdmMasterTableInput.ipdmName;
            let result = await this.lsIpdmTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LSIPDM_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLsIpdmMasterTableInput) {
        let checkIfAlreadyExists = await this.lsIpdmTableRepository.findOne({
            where: {
                ipdmName: createLsIpdmMasterTableInput.ipdmName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new ls_ipdm_master_table_entity_1.LsIpdmMasterTable();
            st.ipdmName = createLsIpdmMasterTableInput.ipdmName.trim();
            let result = await this.lsIpdmTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async findAll() {
        return await this.lsIpdmTableRepository.find();
    }
    async checkIfAlreadyExists(createLsIpdmMasterTableInput) {
        let result = await this.lsIpdmTableRepository.count({
            where: {
                ipdmName: createLsIpdmMasterTableInput.ipdmName
            }
        });
        return result;
    }
    async getCount() {
        return await this.lsIpdmTableRepository.count();
    }
    async findOne(lsIpdmMasterId) {
        return await this.lsIpdmTableRepository.findOne({
            where: {
                lsIpdmMasterId
            }
        });
    }
    async update(lsIpdmMasterId, updateLsIpdmMasterTableInput) {
        let result = await this.findOne(lsIpdmMasterId);
        if (result) {
            result.ipdmName = updateLsIpdmMasterTableInput.ipdmName;
            let updatedResult = await this.lsIpdmTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LSIPDM_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(lsIpdmMasterId) {
        let result = await this.findOne(lsIpdmMasterId);
        if (result) {
            await this.lsIpdmTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LSIPDM_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LsIpdmMasterTableService = LsIpdmMasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(ls_ipdm_master_table_entity_1.LsIpdmMasterTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], LsIpdmMasterTableService);
