import { LsTypeTableService } from './ls-type-table.service';
import { LsTypeTable } from './entities/ls-type-table.entity';
import { CreateLsTypeTableInput } from './dto/create-ls-type-table.input';
import { UpdateLsTypeTableInput } from './dto/update-ls-type-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_LSTYPE_ADD = "NEW_LSTYPE_ADD";
export declare class LsTypeTableResolver {
    private readonly lsTypeTableService;
    private pubSub;
    constructor(lsTypeTableService: LsTypeTableService, pubSub: RedisPubSub);
    createLsTypeTable(createLsTypeTableInput: CreateLsTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllLsType(): Promise<LsTypeTable[]>;
    findOne(lsTypeId: number): Promise<LsTypeTable>;
    toggleLsTypeStatus(lsTypeId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    updateLsTypeTable(updateLsTypeTableInput: UpdateLsTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeLsTypeTable(lsTypeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    lsTypeSubscription(): AsyncIterator<unknown, any, undefined>;
}
