import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateLsTypeTableInput } from './dto/create-ls-type-table.input';
import { UpdateLsTypeTableInput } from './dto/update-ls-type-table.input';
import { LsTypeTable } from './entities/ls-type-table.entity';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
export declare const NEW_LSTYPE_ADD = "NEW_LSTYPE_ADD";
export declare class LsTypeTableService {
    private readonly lsTypeTableRepository;
    private readonly livelihoodSourceTableService;
    private pubSub;
    constructor(lsTypeTableRepository: Repository<LsTypeTable>, livelihoodSourceTableService: LivelihoodSourceTableService, pubSub: RedisPubSub);
    create(createLsTypeTableInput: CreateLsTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createLsTypeTableInput: CreateLsTypeTableInput): Promise<LsTypeTable>;
    checkIfAlreadyExists(createLsTypeTableInput: CreateLsTypeTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<LsTypeTable[]>;
    findOne(lsTypeId: number): Promise<LsTypeTable>;
    toggleLsTypeStatus(lsTypeId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    update(lsTypeId: number, updateLsTypeTableInput: UpdateLsTypeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: LsTypeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(lsTypeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
