"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LsTypeTableService = exports.NEW_LSTYPE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const ls_type_table_entity_1 = require("./entities/ls-type-table.entity");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
exports.NEW_LSTYPE_ADD = "NEW_LSTYPE_ADD";
let LsTypeTableService = exports.LsTypeTableService = class LsTypeTableService {
    constructor(lsTypeTableRepository, livelihoodSourceTableService, pubSub) {
        this.lsTypeTableRepository = lsTypeTableRepository;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
        this.pubSub = pubSub;
    }
    async create(createLsTypeTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createLsTypeTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new ls_type_table_entity_1.LsTypeTable();
            st.typeName = createLsTypeTableInput.typeName;
            st.LivelihoodSourceTable = await this.livelihoodSourceTableService.findOne(createLsTypeTableInput.lsId);
            let result = await this.lsTypeTableRepository.save(st);
            this.pubSub.publish(exports.NEW_LSTYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createLsTypeTableInput) {
        let checkIfAlreadyExists = await this.lsTypeTableRepository.findOne({
            where: {
                typeName: createLsTypeTableInput.typeName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new ls_type_table_entity_1.LsTypeTable();
            st.typeName = createLsTypeTableInput.typeName.trim();
            let result = await this.lsTypeTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createLsTypeTableInput) {
        let result = await this.lsTypeTableRepository.count({
            where: {
                typeName: createLsTypeTableInput.typeName,
                LivelihoodSourceTable: {
                    lsId: createLsTypeTableInput.lsId
                }
            }
        });
        return result;
    }
    async getCount() {
        return await this.lsTypeTableRepository.count();
    }
    async findAll() {
        return await this.lsTypeTableRepository.find({
            relations: {
                LivelihoodSourceTable: true
            }
        });
    }
    async findOne(lsTypeId) {
        return await this.lsTypeTableRepository.findOne({
            where: {
                lsTypeId
            }
        });
    }
    async toggleLsTypeStatus(lsTypeId, type) {
        let dd = await this.findOne(lsTypeId);
        if (dd) {
            if (type == "isPrimary") {
                let oldHasType = dd.isPrimary;
                if (oldHasType == "YES") {
                    dd.isPrimary = "NO";
                }
                if (oldHasType == "NO") {
                    dd.isPrimary = "YES";
                }
            }
            let result = await this.lsTypeTableRepository.save(dd);
            return {
                status: true,
                status_text: "Updated",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async update(lsTypeId, updateLsTypeTableInput) {
        let result = await this.findOne(lsTypeId);
        if (result) {
            result.typeName = updateLsTypeTableInput.typeName;
            result.LivelihoodSourceTable = await this.livelihoodSourceTableService.findOne(updateLsTypeTableInput.lsId);
            let updatedResult = await this.lsTypeTableRepository.save(result);
            this.pubSub.publish(exports.NEW_LSTYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(lsTypeId) {
        let result = await this.findOne(lsTypeId);
        if (result) {
            await this.lsTypeTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_LSTYPE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.LsTypeTableService = LsTypeTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ls_type_table_entity_1.LsTypeTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        livelihood_source_table_service_1.LivelihoodSourceTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], LsTypeTableService);
