"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PORT1 = exports.PORT = void 0;
const core_1 = require("@nestjs/core");
const app_module_1 = require("./app.module");
const bodyParser = __importStar(require("body-parser"));
const compression_1 = __importDefault(require("compression"));
const helmet = require('helmet');
const fs = __importStar(require("fs"));
const common_1 = require("@nestjs/common");
exports.PORT = 9000;
exports.PORT1 = 9001;
async function bootstrap() {
    try {
        const nestApp = await core_1.NestFactory.create(app_module_1.AppModule);
        nestApp.use((0, compression_1.default)({ filter: shouldCompress }))
            .use(bodyParser.json({ limit: '50mb' }))
            .use(bodyParser.urlencoded({
            extended: true,
            limit: '50mb'
        }));
        nestApp.useGlobalPipes(new common_1.ValidationPipe({
            transform: true,
            transformOptions: {
                enableImplicitConversion: true
            },
        }));
        nestApp.setGlobalPrefix(`api`);
        nestApp.enableCors();
        await nestApp.listen(exports.PORT);
    }
    catch (err) {
        throw new Error(err);
    }
}
bootstrap();
async function bootstrap1() {
    try {
        const httpsOptions = {
            key: fs.readFileSync('/etc/letsencrypt/live/sesta.in/privkey.pem'),
            cert: fs.readFileSync('/etc/letsencrypt/live/sesta.in/fullchain.pem'),
        };
        const nestApp = await core_1.NestFactory.create(app_module_1.AppModule, { httpsOptions });
        nestApp.use((0, compression_1.default)({ filter: shouldCompress }))
            .use(bodyParser.json({ limit: '50mb' }))
            .use(bodyParser.urlencoded({
            extended: true,
            limit: '50mb'
        }));
        nestApp.useGlobalPipes(new common_1.ValidationPipe({
            transform: true,
            transformOptions: {
                enableImplicitConversion: true
            },
        }));
        nestApp.setGlobalPrefix(`api`);
        nestApp.enableCors();
        await nestApp.listen(exports.PORT1);
    }
    catch (err) {
        throw new Error(err);
    }
}
function shouldCompress(req, res) {
    if (req.headers['x-no-compression']) {
        return false;
    }
    return compression_1.default.filter(req, res);
}
