import { ManufacturerCollectionService } from './manufacturer-collection.service';
import { ManufacturerCollection } from './entities/manufacturer-collection.entity';
import { CreateManufacturerCollectionInput } from './dto/create-manufacturer-collection.input';
import { UpdateManufacturerCollectionInput } from './dto/update-manufacturer-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_MANUFACTURER_ADD = "NEW_MANUFACTURER_ADD";
export declare class ManufacturerCollectionResolver {
    private readonly manufacturerCollectionService;
    private pubSub;
    constructor(manufacturerCollectionService: ManufacturerCollectionService, pubSub: RedisPubSub);
    createManufacturerCollection(user: any, createManufacturerCollectionInput: CreateManufacturerCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ManufacturerCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllManufacturer(): Promise<(ManufacturerCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    updateManufacturerCollection(updateManufacturerCollectionInput: UpdateManufacturerCollectionInput): Promise<any>;
    removeManufacturerCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: ManufacturerCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    manufacturerSubscription(): AsyncIterator<unknown, any, undefined>;
}
