"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManufacturerCollectionResolver = exports.NEW_MANUFACTURER_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const manufacturer_collection_service_1 = require("./manufacturer-collection.service");
const manufacturer_collection_entity_1 = require("./entities/manufacturer-collection.entity");
const create_manufacturer_collection_input_1 = require("./dto/create-manufacturer-collection.input");
const update_manufacturer_collection_input_1 = require("./dto/update-manufacturer-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const manufacturer_collection_create_type_1 = require("./types/manufacturer-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const manufacturer_collection_type_1 = require("./types/manufacturer-collection.type");
const new_brand_type_1 = require("../brand-collection/types/new-brand.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_MANUFACTURER_ADD = 'NEW_MANUFACTURER_ADD';
let ManufacturerCollectionResolver = class ManufacturerCollectionResolver {
    constructor(manufacturerCollectionService, pubSub) {
        this.manufacturerCollectionService = manufacturerCollectionService;
        this.pubSub = pubSub;
    }
    createManufacturerCollection(user, createManufacturerCollectionInput) {
        return this.manufacturerCollectionService.create(createManufacturerCollectionInput);
    }
    findAllManufacturer() {
        return this.manufacturerCollectionService.findAll();
    }
    updateManufacturerCollection(updateManufacturerCollectionInput) {
        return this.manufacturerCollectionService.update(updateManufacturerCollectionInput.id, updateManufacturerCollectionInput);
    }
    removeManufacturerCollection(id) {
        return this.manufacturerCollectionService.remove(id);
    }
    manufacturerSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_MANUFACTURER_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => manufacturer_collection_create_type_1.ManufacturerCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createManufacturerCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_manufacturer_collection_input_1.CreateManufacturerCollectionInput]),
    __metadata("design:returntype", void 0)
], ManufacturerCollectionResolver.prototype, "createManufacturerCollection", null);
__decorate([
    (0, graphql_1.Query)(() => [manufacturer_collection_type_1.ManufacturerCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ManufacturerCollectionResolver.prototype, "findAllManufacturer", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => manufacturer_collection_create_type_1.ManufacturerCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateManufacturerCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_manufacturer_collection_input_1.UpdateManufacturerCollectionInput]),
    __metadata("design:returntype", void 0)
], ManufacturerCollectionResolver.prototype, "updateManufacturerCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => manufacturer_collection_create_type_1.ManufacturerCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ManufacturerCollectionResolver.prototype, "removeManufacturerCollection", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_brand_type_1.NewBrandAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        },
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ManufacturerCollectionResolver.prototype, "manufacturerSubscription", null);
ManufacturerCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => manufacturer_collection_entity_1.ManufacturerCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [manufacturer_collection_service_1.ManufacturerCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ManufacturerCollectionResolver);
exports.ManufacturerCollectionResolver = ManufacturerCollectionResolver;
