import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { CreateManufacturerCollectionInput } from './dto/create-manufacturer-collection.input';
import { UpdateManufacturerCollectionInput } from './dto/update-manufacturer-collection.input';
import { ManufacturerCollection, ManufacturerCollectionDocument } from './entities/manufacturer-collection.entity';
export declare const NEW_MANUFACTURER_ADD = "NEW_MANUFACTURER_ADD";
export declare class ManufacturerCollectionService {
    private manufacturerRepository;
    private pubSub;
    constructor(manufacturerRepository: Model<ManufacturerCollectionDocument>, pubSub: RedisPubSub);
    create(createManufacturerCollectionInput: CreateManufacturerCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ManufacturerCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(manufacturerName: string): Promise<boolean>;
    findAll(): Promise<(ManufacturerCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneById(id: string): Promise<ManufacturerCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: ManufacturerCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    update(id: string, updateManufacturerCollectionInput: UpdateManufacturerCollectionInput): Promise<any>;
}
