"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ManufacturerCollectionService = exports.NEW_MANUFACTURER_ADD = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const manufacturer_collection_entity_1 = require("./entities/manufacturer-collection.entity");
exports.NEW_MANUFACTURER_ADD = 'NEW_MANUFACTURER_ADD';
let ManufacturerCollectionService = class ManufacturerCollectionService {
    constructor(manufacturerRepository, pubSub) {
        this.manufacturerRepository = manufacturerRepository;
        this.pubSub = pubSub;
    }
    async create(createManufacturerCollectionInput) {
        let checkIfExists = await this.checkIfExists(createManufacturerCollectionInput.manufacturerName);
        if (!checkIfExists) {
            let cm = new manufacturer_collection_entity_1.ManufacturerCollection();
            cm.manufacturerName = createManufacturerCollectionInput.manufacturerName;
            let c = await this.manufacturerRepository.create(cm);
            this.pubSub.publish(exports.NEW_MANUFACTURER_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(manufacturerName) {
        let r = await this.manufacturerRepository.count({
            manufacturerName: manufacturerName
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.manufacturerRepository.find().exec();
    }
    async findOneById(id) {
        return await this.manufacturerRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        let cc = await this.manufacturerRepository.findOne({ _id: id }).exec();
        await this.manufacturerRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_MANUFACTURER_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: cc
        };
    }
    async update(id, updateManufacturerCollectionInput) {
        let cc = await this.manufacturerRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.manufacturerName = updateManufacturerCollectionInput.manufacturerName;
            let cc1 = await this.manufacturerRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_MANUFACTURER_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
ManufacturerCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(manufacturer_collection_entity_1.ManufacturerCollection.name)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        graphql_redis_subscriptions_1.RedisPubSub])
], ManufacturerCollectionService);
exports.ManufacturerCollectionService = ManufacturerCollectionService;
