"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkAssesmentTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const mk_assesment_table_service_1 = require("./mk-assesment-table.service");
const mk_assesment_table_entity_1 = require("./entities/mk-assesment-table.entity");
const create_mk_assesment_table_input_1 = require("./dto/create-mk-assesment-table.input");
const update_mk_assesment_table_input_1 = require("./dto/update-mk-assesment-table.input");
const mk_assesment_return_type_1 = require("./types/mk-assesment-return.type");
const mk_assesment_type_1 = require("./types/mk-assesment.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const mk_assesment_pagination_type_1 = require("./types/mk-assesment-pagination.type");
let MkAssesmentTableResolver = exports.MkAssesmentTableResolver = class MkAssesmentTableResolver {
    constructor(mkAssesmentTableService) {
        this.mkAssesmentTableService = mkAssesmentTableService;
    }
    createMkAssesmentTable(createMkAssesmentTableInput, user) {
        return this.mkAssesmentTableService.create(createMkAssesmentTableInput, user);
    }
    findAllMkAssesment() {
        return this.mkAssesmentTableService.findAll();
    }
    findOneMkAssesment(mkAssesmentId) {
        return this.mkAssesmentTableService.findOne(mkAssesmentId);
    }
    findOneMkAssesmentByMkId(mkId) {
        return this.mkAssesmentTableService.findOneByMkId(mkId);
    }
    getMkAssesmentByUser(limit, page, search, user) {
        return this.mkAssesmentTableService.getMkAssesmentByUser(limit, page, search, user);
    }
    updateMkAssesmentTable(updateMkAssesmentTableInput, user) {
        return this.mkAssesmentTableService.update(updateMkAssesmentTableInput.mkAssesmentId, updateMkAssesmentTableInput, user);
    }
    removeMkAssesmentTable(mkAssesmentId) {
        return this.mkAssesmentTableService.remove(mkAssesmentId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_assesment_return_type_1.MkAssesmentReturnType),
    __param(0, (0, graphql_1.Args)('createMkAssesmentTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_mk_assesment_table_input_1.CreateMkAssesmentTableInput, Object]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "createMkAssesmentTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mk_assesment_type_1.MkAssesmentType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "findAllMkAssesment", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_assesment_type_1.MkAssesmentType),
    __param(0, (0, graphql_1.Args)('mkAssesmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "findOneMkAssesment", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_assesment_type_1.MkAssesmentType),
    __param(0, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "findOneMkAssesmentByMkId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_assesment_pagination_type_1.MkAssesmentPaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('search')),
    __param(3, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, Object]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "getMkAssesmentByUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_assesment_return_type_1.MkAssesmentReturnType),
    __param(0, (0, graphql_1.Args)('updateMkAssesmentTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_mk_assesment_table_input_1.UpdateMkAssesmentTableInput, Object]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "updateMkAssesmentTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_assesment_return_type_1.MkAssesmentReturnType),
    __param(0, (0, graphql_1.Args)('mkAssesmentId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkAssesmentTableResolver.prototype, "removeMkAssesmentTable", null);
exports.MkAssesmentTableResolver = MkAssesmentTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => mk_assesment_table_entity_1.MkAssesmentTable),
    __metadata("design:paramtypes", [mk_assesment_table_service_1.MkAssesmentTableService])
], MkAssesmentTableResolver);
