import { CreateMkAssesmentTableInput } from './dto/create-mk-assesment-table.input';
import { UpdateMkAssesmentTableInput } from './dto/update-mk-assesment-table.input';
import { MkAssesmentTable } from './entities/mk-assesment-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class MkAssesmentTableService {
    private readonly mkAssesmentTableRepository;
    private pubSub;
    private readonly mkTableService;
    private readonly userCollectionService;
    constructor(mkAssesmentTableRepository: Repository<MkAssesmentTable>, pubSub: RedisPubSub, mkTableService: MkTableService, userCollectionService: UserCollectionService);
    create(createMkAssesmentTableInput: CreateMkAssesmentTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: MkAssesmentTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfExists(createMkAssesmentTableInput: CreateMkAssesmentTableInput, entryDate: string, year: string): Promise<boolean>;
    findAll(): Promise<MkAssesmentTable[]>;
    findOne(mkAssesmentId: number): Promise<MkAssesmentTable>;
    findOneByMkId(mkId: number): Promise<MkAssesmentTable>;
    getMkAssesmentByUser(limit: number, page: number, search: string, user: any): Promise<{
        data: any;
        total: any;
    }>;
    update(mkAssesmentId: number, updateMkAssesmentTableInput: UpdateMkAssesmentTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(mkAssesmentId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
