"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkAssesmentTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const mk_assesment_table_entity_1 = require("./entities/mk-assesment-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
const user_collection_entity_1 = require("../user-collection/entities/user-collection.entity");
const mk_table_entity_1 = require("../mk-table/entities/mk-table.entity");
const shg_table_entity_1 = require("../shg-table/entities/shg-table.entity");
let MkAssesmentTableService = exports.MkAssesmentTableService = class MkAssesmentTableService {
    constructor(mkAssesmentTableRepository, pubSub, mkTableService, userCollectionService) {
        this.mkAssesmentTableRepository = mkAssesmentTableRepository;
        this.pubSub = pubSub;
        this.mkTableService = mkTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createMkAssesmentTableInput, user) {
        let entryDate = (0, moment_1.default)().format("DD-MM-YYYY");
        let year = (0, moment_1.default)().format("YYYY");
        const checkIfExists = await this.checkIfExists(createMkAssesmentTableInput, entryDate, year);
        if (!checkIfExists) {
            let mat = new mk_assesment_table_entity_1.MkAssesmentTable();
            mat.entryDate = entryDate;
            mat.year = year;
            mat.savingsFromIncome = createMkAssesmentTableInput.savingsFromIncome;
            mat.whoUsesIncome = createMkAssesmentTableInput.whoUsesIncome;
            mat.howMuchIncomeUse = createMkAssesmentTableInput.howMuchIncomeUse;
            mat.doYouDecideWhereToSpendMoney = createMkAssesmentTableInput.doYouDecideWhereToSpendMoney;
            mat.incomeSpentCloth = createMkAssesmentTableInput.incomeSpentCloth;
            mat.incomeSpentCosmetic = createMkAssesmentTableInput.incomeSpentCosmetic;
            mat.incomeSpentJewellery = createMkAssesmentTableInput.incomeSpentJewellery;
            mat.incomeSpentTravelling = createMkAssesmentTableInput.incomeSpentTravelling;
            mat.incomeSpentOther = createMkAssesmentTableInput.incomeSpentOther;
            mat.doAllExpensesRequireDecision = createMkAssesmentTableInput.doAllExpensesRequireDecision;
            mat.percentageOfDecision = createMkAssesmentTableInput.percentageOfDecision;
            mat.stackholderForConvergence = createMkAssesmentTableInput.stackholderForConvergence;
            mat.confidentToApproachStakeholder = createMkAssesmentTableInput.confidentToApproachStakeholder;
            mat.gramSabhaAttends = createMkAssesmentTableInput.gramSabhaAttends;
            mat.govtInstitutionToVisit = createMkAssesmentTableInput.govtInstitutionToVisit;
            mat.haveDesignationInVillage = createMkAssesmentTableInput.haveDesignationInVillage;
            mat.areYouASuggestion = createMkAssesmentTableInput.areYouASuggestion;
            mat.whoDecideHouseholdWork = createMkAssesmentTableInput.whoDecideHouseholdWork;
            mat.areYouMajorDecisionMaker = createMkAssesmentTableInput.areYouMajorDecisionMaker;
            mat.ableToInfluenceFamily = createMkAssesmentTableInput.ableToInfluenceFamily;
            mat.participationInDecisionMaking = createMkAssesmentTableInput.participationInDecisionMaking;
            mat.increaseInKnowledge = createMkAssesmentTableInput.increaseInKnowledge;
            const mkTable = await this.mkTableService.findOne(createMkAssesmentTableInput.mkId);
            mat.MkTable = mkTable;
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            mat.UserTable = userTable;
            let result = await this.mkAssesmentTableRepository.save(mat);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfExists(createMkAssesmentTableInput, entryDate, year) {
        let result = await this.mkAssesmentTableRepository.findOne({
            where: {
                entryDate,
                year,
                MkTable: {
                    mkId: createMkAssesmentTableInput.mkId
                }
            }
        });
        if (result) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAll() {
        return await this.mkAssesmentTableRepository.find({
            relations: {
                MkTable: {
                    ShgTable: {
                        VoTable: true
                    },
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true,
                                },
                            },
                        },
                    },
                },
                UserTable: true
            }
        });
    }
    async findOne(mkAssesmentId) {
        return await this.mkAssesmentTableRepository.findOne({
            where: {
                mkAssesmentId
            },
            relations: {
                MkTable: {
                    ShgTable: {
                        VoTable: true
                    },
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true,
                                },
                            },
                        },
                    },
                },
                UserTable: true
            }
        });
    }
    async findOneByMkId(mkId) {
        return await this.mkAssesmentTableRepository.findOne({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                MkTable: {
                    ShgTable: {
                        VoTable: true
                    },
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true,
                                },
                            },
                        },
                    },
                },
                UserTable: true
            },
            order: {
                mkAssesmentId: "DESC"
            }
        });
    }
    async getMkAssesmentByUser(limit, page, search, user) {
        let data = await this.mkAssesmentTableRepository
            .createQueryBuilder('r')
            .where('r.userId=:userId', { userId: user.id })
            .leftJoinAndMapOne('r.MkTable', mk_table_entity_1.MkTable, 'ml1', 'ml1.mkId=r.mkId')
            .leftJoinAndMapOne('ml1.ShgTable', shg_table_entity_1.ShgTable, 'ml2', 'ml2.shgId=ml1.shgId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml3', 'ml3.id=r.userId')
            .take(limit)
            .skip(page);
        if (search != '') {
            let s = `${search}%`;
            data = await data.andWhere('r.MkTable.mkName LIKE :mkName', { mkName: s });
        }
        data = await data.getManyAndCount();
        let [result, count] = data;
        return {
            data: result,
            total: count,
        };
    }
    async update(mkAssesmentId, updateMkAssesmentTableInput, user) {
        let mat = await this.mkAssesmentTableRepository.findOne({
            where: {
                mkAssesmentId
            }
        });
        if (mat) {
            mat.savingsFromIncome = updateMkAssesmentTableInput.savingsFromIncome;
            mat.whoUsesIncome = updateMkAssesmentTableInput.whoUsesIncome;
            mat.howMuchIncomeUse = updateMkAssesmentTableInput.howMuchIncomeUse;
            mat.doYouDecideWhereToSpendMoney = updateMkAssesmentTableInput.doYouDecideWhereToSpendMoney;
            mat.incomeSpentCloth = updateMkAssesmentTableInput.incomeSpentCloth;
            mat.incomeSpentCosmetic = updateMkAssesmentTableInput.incomeSpentCosmetic;
            mat.incomeSpentJewellery = updateMkAssesmentTableInput.incomeSpentJewellery;
            mat.incomeSpentTravelling = updateMkAssesmentTableInput.incomeSpentTravelling;
            mat.incomeSpentOther = updateMkAssesmentTableInput.incomeSpentOther;
            mat.doAllExpensesRequireDecision = updateMkAssesmentTableInput.doAllExpensesRequireDecision;
            mat.percentageOfDecision = updateMkAssesmentTableInput.percentageOfDecision;
            mat.stackholderForConvergence = updateMkAssesmentTableInput.stackholderForConvergence;
            mat.confidentToApproachStakeholder = updateMkAssesmentTableInput.confidentToApproachStakeholder;
            mat.gramSabhaAttends = updateMkAssesmentTableInput.gramSabhaAttends;
            mat.govtInstitutionToVisit = updateMkAssesmentTableInput.govtInstitutionToVisit;
            mat.haveDesignationInVillage = updateMkAssesmentTableInput.haveDesignationInVillage;
            mat.areYouASuggestion = updateMkAssesmentTableInput.areYouASuggestion;
            mat.whoDecideHouseholdWork = updateMkAssesmentTableInput.whoDecideHouseholdWork;
            mat.areYouMajorDecisionMaker = updateMkAssesmentTableInput.areYouMajorDecisionMaker;
            mat.ableToInfluenceFamily = updateMkAssesmentTableInput.ableToInfluenceFamily;
            mat.participationInDecisionMaking = updateMkAssesmentTableInput.participationInDecisionMaking;
            mat.increaseInKnowledge = updateMkAssesmentTableInput.increaseInKnowledge;
            const mkTable = await this.mkTableService.findOne(updateMkAssesmentTableInput.mkId);
            mat.MkTable = mkTable;
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            mat.UserTable = userTable;
            let result = await this.mkAssesmentTableRepository.save(mat);
            return {
                status: true,
                status_text: "Successfully Updated"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(mkAssesmentId) {
        let mat = await this.mkAssesmentTableRepository.findOne({
            where: {
                mkAssesmentId
            }
        });
        if (mat) {
            await this.mkAssesmentTableRepository.remove(mat);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.MkAssesmentTableService = MkAssesmentTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mk_assesment_table_entity_1.MkAssesmentTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        mk_table_service_1.MkTableService,
        user_collection_service_1.UserCollectionService])
], MkAssesmentTableService);
