"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkEntitlementsTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const mk_entitlements_table_entity_1 = require("./entities/mk-entitlements-table.entity");
const typeorm_2 = require("@nestjs/typeorm");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const scheme_master_sub_table_service_1 = require("../scheme-master-sub-table/scheme-master-sub-table.service");
const moment_1 = __importDefault(require("moment"));
let MkEntitlementsTableService = exports.MkEntitlementsTableService = class MkEntitlementsTableService {
    constructor(mkEntitlementsTableRepository, mkTableService, schemeMasterSubTableService, userCollectionService) {
        this.mkEntitlementsTableRepository = mkEntitlementsTableRepository;
        this.mkTableService = mkTableService;
        this.schemeMasterSubTableService = schemeMasterSubTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createMkEntitlementsTableDataInput, user) {
        await this.removeByMkId(createMkEntitlementsTableDataInput.mkId);
        let mkData = await this.mkTableService.findOne(createMkEntitlementsTableDataInput.mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        for (const el of createMkEntitlementsTableDataInput.data) {
            let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
            met.MkTable = mkData;
            met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el.schemeMasterSubId);
            met.applied = el.applied;
            met.appliedDate = el.appliedDate;
            met.UserTable = userData;
            met.availed = el.availed;
            met.availedDate = el.availedDate;
            met.amountLeveraged = el.amountLeveraged;
            met.sanctionCopyFile = el.sanctionCopyFile;
            met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
            await this.mkEntitlementsTableRepository.save(met);
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async createFromFblp(entitlements, user, mkId) {
        let mkData = await this.mkTableService.findOneSingle(mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        for (const el of entitlements) {
            let rr = await this.mkEntitlementsTableRepository.findOne({
                where: {
                    SchemeMasterSubTable: {
                        schemeMasterSubId: el
                    },
                    MkTable: {
                        mkId
                    }
                }
            });
            if (!rr) {
                let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
                met.MkTable = mkData;
                met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el);
                met.applied = "YES";
                met.appliedDate = "";
                met.UserTable = userData;
                met.availed = "YES";
                met.availedDate = "";
                met.amountLeveraged = "";
                met.sanctionCopyFile = "";
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async findAllByMkId(mkId) {
        return await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                SchemeMasterSubTable: {
                    SchemeMasterTable: true
                }
            }
        });
    }
    findOne(id) {
        return `This action returns a #${id} mkEntitlementsTable`;
    }
    update(id, updateMkEntitlementsTableInput) {
        return `This action updates a #${id} mkEntitlementsTable`;
    }
    async removeByMkId(mkId) {
        let results = await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
        if (results) {
            await this.mkEntitlementsTableRepository.remove(results);
            return true;
        }
        else {
            return false;
        }
    }
};
exports.MkEntitlementsTableService = MkEntitlementsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(mk_entitlements_table_entity_1.MkEntitlementsTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => scheme_master_sub_table_service_1.SchemeMasterSubTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        mk_table_service_1.MkTableService,
        scheme_master_sub_table_service_1.SchemeMasterSubTableService,
        user_collection_service_1.UserCollectionService])
], MkEntitlementsTableService);
