"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkEntitlementsTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const mk_entitlements_table_service_1 = require("./mk-entitlements-table.service");
const mk_entitlements_table_entity_1 = require("./entities/mk-entitlements-table.entity");
const update_mk_entitlements_table_input_1 = require("./dto/update-mk-entitlements-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const mk_entitlements_table_return_type_1 = require("./types/mk-entitlements-table-return.type");
const mk_entitlements_table_type_1 = require("./types/mk-entitlements-table.type");
const create_mk_entitlements_table_data_input_1 = require("./dto/create-mk-entitlements-table-data.input");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
let MkEntitlementsTableResolver = exports.MkEntitlementsTableResolver = class MkEntitlementsTableResolver {
    constructor(mkEntitlementsTableService) {
        this.mkEntitlementsTableService = mkEntitlementsTableService;
    }
    createMkEntitlementsTable(createMkEntitlementsTableDataInput, user) {
        return this.mkEntitlementsTableService.create(createMkEntitlementsTableDataInput, user);
    }
    findAllEntitlementsByMkId(mkId) {
        return this.mkEntitlementsTableService.findAllByMkId(mkId);
    }
    findOne(mkEntitlementId) {
        return this.mkEntitlementsTableService.findOne(mkEntitlementId);
    }
    updateMkEntitlementsTable(updateMkEntitlementsTableInput) {
        return this.mkEntitlementsTableService.update(updateMkEntitlementsTableInput.mkEntitlementId, updateMkEntitlementsTableInput);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_entitlements_table_return_type_1.MkEntitlementsTableReturnType),
    __param(0, (0, graphql_1.Args)('createMkEntitlementsTableDataInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_mk_entitlements_table_data_input_1.CreateMkEntitlementsTableDataInput, Object]),
    __metadata("design:returntype", void 0)
], MkEntitlementsTableResolver.prototype, "createMkEntitlementsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mk_entitlements_table_type_1.MkEntitlementsTableType]),
    __param(0, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkEntitlementsTableResolver.prototype, "findAllEntitlementsByMkId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_entitlements_table_type_1.MkEntitlementsTableType),
    __param(0, (0, graphql_1.Args)('mkEntitlementId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkEntitlementsTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_entitlements_table_return_type_1.MkEntitlementsTableReturnType),
    __param(0, (0, graphql_1.Args)('updateMkEntitlementsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_mk_entitlements_table_input_1.UpdateMkEntitlementsTableInput]),
    __metadata("design:returntype", void 0)
], MkEntitlementsTableResolver.prototype, "updateMkEntitlementsTable", null);
exports.MkEntitlementsTableResolver = MkEntitlementsTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => mk_entitlements_table_entity_1.MkEntitlementsTable),
    __metadata("design:paramtypes", [mk_entitlements_table_service_1.MkEntitlementsTableService])
], MkEntitlementsTableResolver);
