import { UpdateMkEntitlementsTableInput } from './dto/update-mk-entitlements-table.input';
import { Repository } from 'typeorm';
import { MkEntitlementsTable } from './entities/mk-entitlements-table.entity';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { SchemeMasterSubTableService } from 'src/scheme-master-sub-table/scheme-master-sub-table.service';
import { CreateMkEntitlementsTableDataInput } from './dto/create-mk-entitlements-table-data.input';
export declare class MkEntitlementsTableService {
    private readonly mkEntitlementsTableRepository;
    private readonly mkTableService;
    private readonly schemeMasterSubTableService;
    private readonly userCollectionService;
    constructor(mkEntitlementsTableRepository: Repository<MkEntitlementsTable>, mkTableService: MkTableService, schemeMasterSubTableService: SchemeMasterSubTableService, userCollectionService: UserCollectionService);
    create(createMkEntitlementsTableDataInput: CreateMkEntitlementsTableDataInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createFromFblp(entitlements: number[], user: any, mkId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllByMkId(mkId: number): Promise<MkEntitlementsTable[]>;
    findOne(id: number): string;
    update(id: number, updateMkEntitlementsTableInput: UpdateMkEntitlementsTableInput): string;
    removeByMkId(mkId: number): Promise<boolean>;
}
