import { CreateMkEntitlementsTableInput } from './dto/create-mk-entitlements-table.input';
import { UpdateMkEntitlementsTableInput } from './dto/update-mk-entitlements-table.input';
import { Repository } from 'typeorm';
import { MkEntitlementsTable } from './entities/mk-entitlements-table.entity';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { SchemeMasterSubTableService } from 'src/scheme-master-sub-table/scheme-master-sub-table.service';
import { CreateMkEntitlementsTableDataInput } from './dto/create-mk-entitlements-table-data.input';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { SessionmasterTable } from 'src/sessionmaster-table/entities/sessionmaster-table.entity';
export declare class MkEntitlementsTableService {
    private readonly mkEntitlementsTableRepository;
    private readonly mkTableService;
    private readonly schemeMasterSubTableService;
    private readonly userCollectionService;
    private readonly sessionmasterTableService;
    constructor(mkEntitlementsTableRepository: Repository<MkEntitlementsTable>, mkTableService: MkTableService, schemeMasterSubTableService: SchemeMasterSubTableService, userCollectionService: UserCollectionService, sessionmasterTableService: SessionmasterTableService);
    create(createMkEntitlementsTableDataInput: CreateMkEntitlementsTableDataInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createNew(createMkEntitlementsTableDataInput: CreateMkEntitlementsTableDataInput, user: any, mkId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExixts(createMkEntitlementsTableInput: CreateMkEntitlementsTableInput, mkId: number, session: SessionmasterTable): Promise<MkEntitlementsTable>;
    createFromMk(entitlements: number[], user: any, mkId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createFromFblp(entitlements: number[], user: any, mkId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllByMkId(mkId: number): Promise<MkEntitlementsTable[]>;
    findAllByMkIdNew(mkId: number, type: string): Promise<MkEntitlementsTable[]>;
    findOne(id: number): string;
    update(id: number, updateMkEntitlementsTableInput: UpdateMkEntitlementsTableInput): string;
    removeByMkId(mkId: number): Promise<boolean>;
    removeByMkIdAndType(mkId: number, type: string): Promise<boolean>;
    removeById(mkEntitlementId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getEntitlementsCount(schemeMasterSubId: number, stateId: number, districtId: number, blockId: number): Promise<{
        count: any;
    }>;
    convergenceListDownload(schemeMasterSubId: number, sessionId: number): Promise<MkEntitlementsTable[]>;
    getConvergenceReport(sessionId: number): Promise<{
        mgnregaSchemes: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        lineDepartment: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        entitlements: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        healthInsurance: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
    }>;
    getConvergenceReportIntegrator(sessionId: number, body: any): Promise<{
        mgnregaSchemes: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        lineDepartment: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        entitlements: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
        healthInsurance: import("../scheme-master-sub-table/entities/scheme-master-sub-table.entity").SchemeMasterSubTable[];
    }>;
}
