"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkEntitlementsTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const mk_entitlements_table_entity_1 = require("./entities/mk-entitlements-table.entity");
const typeorm_2 = require("@nestjs/typeorm");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const scheme_master_sub_table_service_1 = require("../scheme-master-sub-table/scheme-master-sub-table.service");
const moment_1 = __importDefault(require("moment"));
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const mk_table_entity_1 = require("../mk-table/entities/mk-table.entity");
const village_table_entity_1 = require("../village-table/entities/village-table.entity");
const grampanchayat_table_entity_1 = require("../grampanchayat-table/entities/grampanchayat-table.entity");
const block_table_entity_1 = require("../block-table/entities/block-table.entity");
const district_table_entity_1 = require("../district-table/entities/district-table.entity");
const state_table_entity_1 = require("../state-table/entities/state-table.entity");
let MkEntitlementsTableService = exports.MkEntitlementsTableService = class MkEntitlementsTableService {
    constructor(mkEntitlementsTableRepository, mkTableService, schemeMasterSubTableService, userCollectionService, sessionmasterTableService) {
        this.mkEntitlementsTableRepository = mkEntitlementsTableRepository;
        this.mkTableService = mkTableService;
        this.schemeMasterSubTableService = schemeMasterSubTableService;
        this.userCollectionService = userCollectionService;
        this.sessionmasterTableService = sessionmasterTableService;
    }
    async create(createMkEntitlementsTableDataInput, user) {
        let mkData = await this.mkTableService.findOne(createMkEntitlementsTableDataInput.mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        let session = await this.sessionmasterTableService.findActiveSession();
        for (const el of createMkEntitlementsTableDataInput.data) {
            const checkIfExixts = await this.checkIfExixts(el, createMkEntitlementsTableDataInput.mkId, session);
            console.log("🚀 ~ file: mk-entitlements-table.service.ts:59 ~ MkEntitlementsTableService ~ create ~ checkIfExixts:", checkIfExixts);
            if (!checkIfExixts) {
                let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
                met.MkTable = mkData;
                met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el.schemeMasterSubId);
                met.status = el.status;
                met.SessionmasterTable = session;
                met.date = el.date;
                met.UserTable = userData;
                met.type = el.type;
                met.amountLeveraged = el.amountLeveraged;
                met.amountSanctioned = el.amountSanctioned;
                met.dateOfSanction = el.dateOfSanction;
                met.sanctionCopyFile = el.sanctionCopyFile;
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
            else {
                let met = checkIfExixts;
                met.date = el.date;
                met.amountLeveraged = el.amountLeveraged;
                met.amountSanctioned = el.amountSanctioned;
                met.dateOfSanction = el.dateOfSanction;
                met.sanctionCopyFile = el.sanctionCopyFile;
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async createNew(createMkEntitlementsTableDataInput, user, mkId) {
        let mkData = await this.mkTableService.findOne(createMkEntitlementsTableDataInput.mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        let session = await this.sessionmasterTableService.findActiveSession();
        for (const el of createMkEntitlementsTableDataInput.data) {
            const checkIfExixts = await this.checkIfExixts(el, mkId, session);
            if (!checkIfExixts) {
                let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
                met.MkTable = mkData;
                met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el.schemeMasterSubId);
                met.status = el.status;
                met.date = el.date;
                met.UserTable = userData;
                met.SessionmasterTable = session;
                met.type = el.type;
                met.amountLeveraged = el.amountLeveraged;
                met.amountSanctioned = el.amountSanctioned;
                met.dateOfSanction = el.dateOfSanction;
                met.sanctionCopyFile = el.sanctionCopyFile;
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
            else {
                let met = checkIfExixts;
                met.status = el.status;
                met.date = el.date;
                met.amountLeveraged = el.amountLeveraged;
                met.amountSanctioned = el.amountSanctioned;
                met.dateOfSanction = el.dateOfSanction;
                met.sanctionCopyFile = el.sanctionCopyFile;
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async checkIfExixts(createMkEntitlementsTableInput, mkId, session) {
        let result = await this.mkEntitlementsTableRepository.findOne({
            where: {
                MkTable: {
                    mkId
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                },
                SchemeMasterSubTable: {
                    schemeMasterSubId: createMkEntitlementsTableInput.schemeMasterSubId
                },
                type: createMkEntitlementsTableInput.type,
                status: createMkEntitlementsTableInput.status
            }
        });
        return result;
    }
    async createFromMk(entitlements, user, mkId) {
        await this.removeByMkIdAndType(mkId, "MK");
        let mkData = await this.mkTableService.findOneSingle(mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        for (const el of entitlements) {
            let rr = await this.mkEntitlementsTableRepository.findOne({
                where: {
                    SchemeMasterSubTable: {
                        schemeMasterSubId: el
                    },
                    MkTable: {
                        mkId
                    }
                }
            });
            if (!rr) {
                let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
                met.MkTable = mkData;
                met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el);
                met.status = "AVAILED";
                met.date = "";
                met.type = "MK";
                met.UserTable = userData;
                met.amountLeveraged = "";
                met.sanctionCopyFile = "";
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async createFromFblp(entitlements, user, mkId) {
        await this.removeByMkIdAndType(mkId, "FBLP");
        let mkData = await this.mkTableService.findOneSingle(mkId);
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        for (const el of entitlements) {
            let rr = await this.mkEntitlementsTableRepository.findOne({
                where: {
                    SchemeMasterSubTable: {
                        schemeMasterSubId: el
                    },
                    MkTable: {
                        mkId
                    }
                }
            });
            if (!rr) {
                let met = new mk_entitlements_table_entity_1.MkEntitlementsTable();
                met.MkTable = mkData;
                met.SchemeMasterSubTable = await this.schemeMasterSubTableService.findOne(el);
                met.status = "TO_BE_AVAILED";
                met.date = (0, moment_1.default)().format('DD-MM-YYYY');
                met.type = "FBLP";
                met.UserTable = userData;
                met.amountLeveraged = "";
                met.sanctionCopyFile = "";
                met.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
                await this.mkEntitlementsTableRepository.save(met);
            }
        }
        return {
            status: true,
            status_text: "Sucessfully Submitted"
        };
    }
    async findAllByMkId(mkId) {
        return await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                SchemeMasterSubTable: {
                    SchemeMasterTable: true
                }
            }
        });
    }
    async findAllByMkIdNew(mkId, type) {
        return await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                },
                type
            },
            relations: {
                SchemeMasterSubTable: {
                    SchemeMasterTable: true
                }
            }
        });
    }
    findOne(id) {
        return `This action returns a #${id} mkEntitlementsTable`;
    }
    update(id, updateMkEntitlementsTableInput) {
        return `This action updates a #${id} mkEntitlementsTable`;
    }
    async removeByMkId(mkId) {
        let results = await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
        if (results) {
            await this.mkEntitlementsTableRepository.remove(results);
            return true;
        }
        else {
            return false;
        }
    }
    async removeByMkIdAndType(mkId, type) {
        let results = await this.mkEntitlementsTableRepository.find({
            where: {
                MkTable: {
                    mkId
                },
                type
            }
        });
        if (results) {
            await this.mkEntitlementsTableRepository.remove(results);
            return true;
        }
        else {
            return false;
        }
    }
    async removeById(mkEntitlementId) {
        let results = await this.mkEntitlementsTableRepository.find({
            where: {
                mkEntitlementId
            }
        });
        if (results) {
            await this.mkEntitlementsTableRepository.remove(results);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async getEntitlementsCount(schemeMasterSubId, stateId, districtId, blockId) {
        let data = await this.mkEntitlementsTableRepository
            .createQueryBuilder('ia')
            .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: schemeMasterSubId })
            .andWhere('ia.type=:type', { type: "MK" })
            .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'r', 'r.mkId=ia.mkId')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(r.mkId)', 'count')
            .groupBy('ia.schemeMasterSubId');
        if (stateId > 0) {
            data = await data.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            data = await data.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            data = await data.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        data = await data.getRawOne();
        return {
            count: data === null || data === void 0 ? void 0 : data.count,
        };
    }
    async convergenceListDownload(schemeMasterSubId, sessionId) {
        let data = await this.mkEntitlementsTableRepository.find({
            where: {
                SchemeMasterSubTable: {
                    schemeMasterSubId
                },
                SessionmasterTable: {
                    sessionId
                }
            },
            relations: {
                MkTable: {
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true
                                }
                            }
                        }
                    }
                },
                SchemeMasterSubTable: {
                    SchemeMasterTable: true
                },
                UserTable: true
            }
        });
        return data;
    }
    async getConvergenceReport(sessionId) {
        let mgnregaSchemes = await this.schemeMasterSubTableService.findAllMgnrega();
        let index = 0;
        for (const el of mgnregaSchemes) {
            let data = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .select('COUNT(ia.mkId)', 'count')
                .addSelect('SUM(ia.amountSanctioned)', 'amountSanctioned')
                .addSelect('SUM(ia.amountLeveraged)', 'amountLeveraged')
                .groupBy('ia.schemeMasterSubId');
            data = await data.getRawOne();
            mgnregaSchemes[index]['data'] = data;
            index++;
        }
        let lineDepartment = await this.schemeMasterSubTableService.findAllLineDepartment();
        let index1 = 0;
        for (const el of lineDepartment) {
            let data = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .select('COUNT(ia.mkId)', 'count')
                .addSelect('SUM(ia.amountSanctioned)', 'amountSanctioned')
                .addSelect('SUM(ia.amountLeveraged)', 'amountLeveraged')
                .groupBy('ia.schemeMasterSubId');
            data = await data.getRawOne();
            lineDepartment[index1]['data'] = data;
            index1++;
        }
        let entitlements = await this.schemeMasterSubTableService.findAllEntitlements();
        let index2 = 0;
        for (const el of entitlements) {
            let dataApplied = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "APPLIED" })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataApplied = await dataApplied.getRawOne();
            entitlements[index2]['dataApplied'] = dataApplied;
            let dataAvailed = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "AVAILED" })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataAvailed = await dataAvailed.getRawOne();
            entitlements[index2]['dataAvailed'] = dataAvailed;
            index2++;
        }
        let healthInsurance = await this.schemeMasterSubTableService.findAllHealthInsurance();
        let index3 = 0;
        for (const el of healthInsurance) {
            let dataApplied = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "APPLIED" })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataApplied = await dataApplied.getRawOne();
            healthInsurance[index3]['dataApplied'] = dataApplied;
            let dataAvailed = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "AVAILED" })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataAvailed = await dataAvailed.getRawOne();
            healthInsurance[index3]['dataAvailed'] = dataAvailed;
            index3++;
        }
        return {
            mgnregaSchemes,
            lineDepartment,
            entitlements,
            healthInsurance
        };
    }
    async getConvergenceReportIntegrator(sessionId, body) {
        let mgnregaSchemes = await this.schemeMasterSubTableService.findAllMgnrega();
        let index = 0;
        for (const el of mgnregaSchemes) {
            let data = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .addSelect('SUM(ia.amountSanctioned)', 'amountSanctioned')
                .addSelect('SUM(ia.amountLeveraged)', 'amountLeveraged')
                .groupBy('ia.schemeMasterSubId');
            data = await data.getRawOne();
            console.log("🚀 ~ MkEntitlementsTableService ~ getConvergenceReportIntegrator ~ data:", data);
            mgnregaSchemes[index]['data'] = data;
            index++;
        }
        let lineDepartment = await this.schemeMasterSubTableService.findAllLineDepartment();
        let index1 = 0;
        for (const el of lineDepartment) {
            let data = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .addSelect('SUM(ia.amountSanctioned)', 'amountSanctioned')
                .addSelect('SUM(ia.amountLeveraged)', 'amountLeveraged')
                .groupBy('ia.schemeMasterSubId');
            data = await data.getRawOne();
            lineDepartment[index1]['data'] = data;
            index1++;
        }
        let entitlements = await this.schemeMasterSubTableService.findAllEntitlements();
        let index2 = 0;
        for (const el of entitlements) {
            let dataApplied = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "APPLIED" })
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataApplied = await dataApplied.getRawOne();
            entitlements[index2]['dataApplied'] = dataApplied;
            let dataAvailed = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "AVAILED" })
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataAvailed = await dataAvailed.getRawOne();
            entitlements[index2]['dataAvailed'] = dataAvailed;
            index2++;
        }
        let healthInsurance = await this.schemeMasterSubTableService.findAllHealthInsurance();
        let index3 = 0;
        for (const el of healthInsurance) {
            let dataApplied = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "APPLIED" })
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataApplied = await dataApplied.getRawOne();
            healthInsurance[index3]['dataApplied'] = dataApplied;
            let dataAvailed = await this.mkEntitlementsTableRepository
                .createQueryBuilder('ia')
                .where('ia.schemeMasterSubId=:schemeMasterSubId', { schemeMasterSubId: el.schemeMasterSubId })
                .andWhere('ia.sessionId=:sessionId', { sessionId: sessionId })
                .andWhere('ia.status = :status', { status: "AVAILED" })
                .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'mk', 'mk.mkId=ia.mkId')
                .leftJoinAndMapOne('mk.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=mk.villageId')
                .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
                .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
                .andWhere('ml3.blockId=:blockId', { blockId: body.blockId })
                .select('COUNT(ia.mkId)', 'count')
                .groupBy('ia.schemeMasterSubId');
            dataAvailed = await dataAvailed.getRawOne();
            healthInsurance[index3]['dataAvailed'] = dataAvailed;
            index3++;
        }
        return {
            mgnregaSchemes,
            lineDepartment,
            entitlements,
            healthInsurance
        };
    }
};
exports.MkEntitlementsTableService = MkEntitlementsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(mk_entitlements_table_entity_1.MkEntitlementsTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => scheme_master_sub_table_service_1.SchemeMasterSubTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        mk_table_service_1.MkTableService,
        scheme_master_sub_table_service_1.SchemeMasterSubTableService,
        user_collection_service_1.UserCollectionService,
        sessionmaster_table_service_1.SessionmasterTableService])
], MkEntitlementsTableService);
