import { RedisPubSub } from 'graphql-redis-subscriptions';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { Repository } from 'typeorm';
import { CreateMkIncomeActivityTableInput } from './dto/create-mk-income-activity-table.input';
import { UpdateMkIncomeActivityTableInput } from './dto/update-mk-income-activity-table.input';
import { MkIncomeActivityTable } from './entities/mk-income-activity-table.entity';
export declare const NEW_INCOMEACTIVITY_ADD = "NEW_INCOMEACTIVITY_ADD";
export declare class MkIncomeActivityTableService {
    private readonly mkIncomeActivityTableRepository;
    private pubSub;
    private readonly mkTableService;
    constructor(mkIncomeActivityTableRepository: Repository<MkIncomeActivityTable>, pubSub: RedisPubSub, mkTableService: MkTableService);
    createBulk(createMkIncomeActivityTableInput: CreateMkIncomeActivityTableInput[], mkId: number): Promise<{
        total: number;
        data: any;
    }>;
    create(createMkIncomeActivityTableInput: CreateMkIncomeActivityTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkIncomeActivityTable;
    }>;
    checkIfExists(mkId: number, landSize: number, landUnit: string, conversionToBigha: number, livelihoodActivityIncomeSub: string, income: string, herdSize: string, livelihoodActivityIncomeCode: string): Promise<boolean>;
    findAll(): Promise<MkIncomeActivityTable[]>;
    findAllByMkId(mkId: number): Promise<MkIncomeActivityTable[]>;
    findAllByMkIdNew(mkId: number): Promise<MkIncomeActivityTable[]>;
    findOne(mkIncomeActivityId: number): Promise<MkIncomeActivityTable>;
    update(mkIncomeActivityId: number, updateMkIncomeActivityTableInput: UpdateMkIncomeActivityTableInput, year: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkIncomeActivityTable;
    }>;
    remove(mkIncomeActivityId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    removeByMkId(mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getIncomeAvgAndCount(incomeActivityCode: string, stateId: number, districtId: number, blockId: number): Promise<{
        count: any;
        avg: number;
    }>;
    getIncomeAvgAndCountLs(incomeActivityCode: string, stateId: number, districtId: number, blockId: number): Promise<{
        count: any;
        avg: number;
    }>;
}
