"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkIncomeActivityTableService = exports.NEW_INCOMEACTIVITY_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const typeorm_2 = require("typeorm");
const mk_income_activity_table_entity_1 = require("./entities/mk-income-activity-table.entity");
const HelperFunctions_1 = require("../helper/HelperFunctions");
const mk_table_entity_1 = require("../mk-table/entities/mk-table.entity");
const village_table_entity_1 = require("../village-table/entities/village-table.entity");
const grampanchayat_table_entity_1 = require("../grampanchayat-table/entities/grampanchayat-table.entity");
const block_table_entity_1 = require("../block-table/entities/block-table.entity");
const district_table_entity_1 = require("../district-table/entities/district-table.entity");
const state_table_entity_1 = require("../state-table/entities/state-table.entity");
exports.NEW_INCOMEACTIVITY_ADD = "NEW_INCOMEACTIVITY_ADD";
let MkIncomeActivityTableService = exports.MkIncomeActivityTableService = class MkIncomeActivityTableService {
    constructor(mkIncomeActivityTableRepository, pubSub, mkTableService) {
        this.mkIncomeActivityTableRepository = mkIncomeActivityTableRepository;
        this.pubSub = pubSub;
        this.mkTableService = mkTableService;
    }
    async createBulk(createMkIncomeActivityTableInput, mkId) {
        await this.removeByMkId(mkId);
        let total = 0;
        let result = [];
        for (const el of createMkIncomeActivityTableInput) {
            let rr = await this.create(el, mkId);
            if (rr.status == true) {
                total = total + parseFloat(rr.data.income);
            }
            result.push(rr);
        }
        return {
            total: total,
            data: result
        };
    }
    async create(createMkIncomeActivityTableInput, mkId) {
        let checkIfExists = await this.checkIfExists(mkId, createMkIncomeActivityTableInput.landSize, createMkIncomeActivityTableInput.landUnit, createMkIncomeActivityTableInput.conversionToBigha, createMkIncomeActivityTableInput.livelihoodActivityIncomeSub, createMkIncomeActivityTableInput.income, createMkIncomeActivityTableInput.herdSize, createMkIncomeActivityTableInput.livelihoodActivityIncomeCode);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new mk_income_activity_table_entity_1.MkIncomeActivityTable();
            if (createMkIncomeActivityTableInput.landSize) {
                dd.landSize = createMkIncomeActivityTableInput.landSize.toString();
            }
            if (createMkIncomeActivityTableInput.landUnit) {
                dd.landUnit = createMkIncomeActivityTableInput.landUnit;
            }
            dd.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(createMkIncomeActivityTableInput.landSize, createMkIncomeActivityTableInput.landUnit);
            dd.livelihoodActivityIncomeCode = createMkIncomeActivityTableInput.livelihoodActivityIncomeCode;
            dd.livelihoodActivityIncomeSub = createMkIncomeActivityTableInput.livelihoodActivityIncomeSub;
            dd.income = createMkIncomeActivityTableInput.income;
            if (createMkIncomeActivityTableInput.herdSize) {
                dd.herdSize = createMkIncomeActivityTableInput.herdSize;
            }
            if (createMkIncomeActivityTableInput.flockSize) {
                dd.flockSize = createMkIncomeActivityTableInput.flockSize;
            }
            if (createMkIncomeActivityTableInput.pondSize) {
                dd.pondSize = (0, HelperFunctions_1.convertToBigha)(parseFloat(createMkIncomeActivityTableInput.pondSize), createMkIncomeActivityTableInput.landUnit);
                dd.landUnit = "BIGHA";
            }
            if (createMkIncomeActivityTableInput.productionInKg) {
                dd.productionInKg = createMkIncomeActivityTableInput.productionInKg;
            }
            let mk = await this.mkTableService.findOneSingle(mkId);
            dd.MkTable = mk;
            let result = await this.mkIncomeActivityTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_INCOMEACTIVITY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(mkId, landSize, landUnit, conversionToBigha, livelihoodActivityIncomeSub, income, herdSize, livelihoodActivityIncomeCode) {
        let result = await this.mkIncomeActivityTableRepository.count({
            where: {
                landSize: landSize ? landSize.toString() : '',
                landUnit: landUnit,
                livelihoodActivityIncomeSub: livelihoodActivityIncomeSub,
                livelihoodActivityIncomeCode: livelihoodActivityIncomeCode,
                income: income,
                herdSize: herdSize,
                MkTable: {
                    mkId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.mkIncomeActivityTableRepository.find({
            relations: {
                MkTable: true
            }
        });
    }
    async findAllByMkId(mkId) {
        return await this.mkIncomeActivityTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                MkTable: true
            }
        });
    }
    async findAllByMkIdNew(mkId) {
        return await this.mkIncomeActivityTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
    }
    async findOne(mkIncomeActivityId) {
        return await this.mkIncomeActivityTableRepository.findOne({
            where: {
                mkIncomeActivityId: mkIncomeActivityId
            },
            relations: {
                MkTable: true
            }
        });
    }
    async update(mkIncomeActivityId, updateMkIncomeActivityTableInput, year) {
        let result = await this.mkIncomeActivityTableRepository.findOne({
            where: {
                mkIncomeActivityId: mkIncomeActivityId
            }
        });
        if (result) {
            result.landSize = updateMkIncomeActivityTableInput.landSize.toString();
            result.landUnit = updateMkIncomeActivityTableInput.landUnit;
            result.conversionToBigha = (0, HelperFunctions_1.convertToBigha)(updateMkIncomeActivityTableInput.landSize, updateMkIncomeActivityTableInput.landUnit);
            result.livelihoodActivityIncomeSub = updateMkIncomeActivityTableInput.livelihoodActivityIncomeSub;
            result.income = updateMkIncomeActivityTableInput.income;
            result.herdSize = updateMkIncomeActivityTableInput.herdSize;
            let mk = await this.mkTableService.findOne(updateMkIncomeActivityTableInput.mkIncomeActivityId);
            result.MkTable = mk;
            let r = await this.mkIncomeActivityTableRepository.save(result);
            this.pubSub.publish(exports.NEW_INCOMEACTIVITY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(mkIncomeActivityId) {
        let result = await this.mkIncomeActivityTableRepository.findOne({
            where: {
                mkIncomeActivityId: mkIncomeActivityId
            }
        });
        if (result) {
            await this.mkIncomeActivityTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_INCOMEACTIVITY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async removeByMkId(mkId) {
        let result = await this.mkIncomeActivityTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
        if (result.length > 0) {
            await this.mkIncomeActivityTableRepository.remove(result);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async getIncomeAvgAndCount(incomeActivityCode, stateId, districtId, blockId) {
        let iaActivity = await this.mkIncomeActivityTableRepository
            .createQueryBuilder('ia')
            .where('ia.livelihoodActivityIncomeCode=:livelihoodActivityIncomeCode', { livelihoodActivityIncomeCode: incomeActivityCode })
            .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'r', 'r.mkId=ia.mkId')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(r.mkId)', 'count')
            .addSelect('SUM(ia.income)', 'income')
            .groupBy('ia.livelihoodActivityIncomeCode');
        if (stateId > 0) {
            iaActivity = await iaActivity.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            iaActivity = await iaActivity.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            iaActivity = await iaActivity.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        iaActivity = await iaActivity.getRawOne();
        let avg = 0;
        if (iaActivity) {
            if (iaActivity.count > 0) {
                avg = parseFloat(iaActivity.income) / parseFloat(iaActivity.count);
            }
        }
        return {
            count: iaActivity === null || iaActivity === void 0 ? void 0 : iaActivity.count,
            avg: avg
        };
    }
    async getIncomeAvgAndCountLs(incomeActivityCode, stateId, districtId, blockId) {
        let iaActivity = await this.mkIncomeActivityTableRepository
            .createQueryBuilder('ia')
            .where('ia.livelihoodActivityIncomeSub=:livelihoodActivityIncomeSub', { livelihoodActivityIncomeSub: incomeActivityCode })
            .leftJoinAndMapOne('ia.MkTable', mk_table_entity_1.MkTable, 'r', 'r.mkId=ia.mkId')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(r.mkId)', 'count')
            .addSelect('SUM(ia.income)', 'income')
            .groupBy('ia.livelihoodActivityIncomeSub');
        if (stateId > 0) {
            iaActivity = await iaActivity.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            iaActivity = await iaActivity.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            iaActivity = await iaActivity.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        iaActivity = await iaActivity.getRawOne();
        let avg = 0;
        if (iaActivity) {
            if (iaActivity.count > 0) {
                avg = parseFloat(iaActivity.income) / parseFloat(iaActivity.count);
            }
        }
        return {
            count: iaActivity === null || iaActivity === void 0 ? void 0 : iaActivity.count,
            avg: avg
        };
    }
};
exports.MkIncomeActivityTableService = MkIncomeActivityTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mk_income_activity_table_entity_1.MkIncomeActivityTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        mk_table_service_1.MkTableService])
], MkIncomeActivityTableService);
