import { RedisPubSub } from 'graphql-redis-subscriptions';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { Repository } from 'typeorm';
import { CreateMkIrrigationTableInput } from './dto/create-mk-irrigation-table.input';
import { UpdateMkIrrigationTableInput } from './dto/update-mk-irrigation-table.input';
import { MkIrrigationTable } from './entities/mk-irrigation-table.entity';
export declare const NEW_MKIRRIGATION_ADD = "NEW_MKIRRIGATION_ADD";
export declare class MkIrrigationTableService {
    private readonly mkIrrigationTableRepository;
    private pubSub;
    private readonly mkTableService;
    constructor(mkIrrigationTableRepository: Repository<MkIrrigationTable>, pubSub: RedisPubSub, mkTableService: MkTableService);
    createBulk(createMkIrrigationTableInput: CreateMkIrrigationTableInput[], mkId: number): Promise<any>;
    create(createMkIrrigationTableInput: CreateMkIrrigationTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkIrrigationTable;
    }>;
    checkIfExists(sourceOfIrrigation: string, mkId: number): Promise<boolean>;
    findAll(): Promise<MkIrrigationTable[]>;
    findAllByMkId(mkId: number): Promise<MkIrrigationTable[]>;
    findOne(mkIrrigationId: number): Promise<MkIrrigationTable>;
    update(mkIrrigationId: number, updateMkIrrigationTableInput: UpdateMkIrrigationTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkIrrigationTable;
    }>;
    remove(mkIrrigationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    removeByMkId(mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getTotalIrrigationCount(type: string, stateId: number, districtId: number, blockId: number): Promise<any>;
}
