"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkIrrigationTableService = exports.NEW_MKIRRIGATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const typeorm_2 = require("typeorm");
const mk_irrigation_table_entity_1 = require("./entities/mk-irrigation-table.entity");
const mk_table_entity_1 = require("../mk-table/entities/mk-table.entity");
const village_table_entity_1 = require("../village-table/entities/village-table.entity");
const grampanchayat_table_entity_1 = require("../grampanchayat-table/entities/grampanchayat-table.entity");
const block_table_entity_1 = require("../block-table/entities/block-table.entity");
const district_table_entity_1 = require("../district-table/entities/district-table.entity");
const state_table_entity_1 = require("../state-table/entities/state-table.entity");
exports.NEW_MKIRRIGATION_ADD = "NEW_MKIRRIGATION_ADD";
let MkIrrigationTableService = exports.MkIrrigationTableService = class MkIrrigationTableService {
    constructor(mkIrrigationTableRepository, pubSub, mkTableService) {
        this.mkIrrigationTableRepository = mkIrrigationTableRepository;
        this.pubSub = pubSub;
        this.mkTableService = mkTableService;
    }
    async createBulk(createMkIrrigationTableInput, mkId) {
        await this.removeByMkId(mkId);
        let result = [];
        for (const el of createMkIrrigationTableInput) {
            let rr = await this.create(el, mkId);
            result.push(rr);
        }
        return result;
    }
    async create(createMkIrrigationTableInput, mkId) {
        let checkIfExists = await this.checkIfExists(createMkIrrigationTableInput.sourceOfIrrigation, mkId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new mk_irrigation_table_entity_1.MkIrrigationTable();
            dd.sourceOfIrrigation = createMkIrrigationTableInput.sourceOfIrrigation;
            let mk = await this.mkTableService.findOneSingle(mkId);
            dd.MkTable = mk;
            let result = await this.mkIrrigationTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_MKIRRIGATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(sourceOfIrrigation, mkId) {
        let result = await this.mkIrrigationTableRepository.count({
            where: {
                sourceOfIrrigation: sourceOfIrrigation,
                MkTable: {
                    mkId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.mkIrrigationTableRepository.find({
            relations: {
                MkTable: true
            }
        });
    }
    async findAllByMkId(mkId) {
        return await this.mkIrrigationTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                MkTable: true
            }
        });
    }
    async findOne(mkIrrigationId) {
        return await this.mkIrrigationTableRepository.findOne({
            where: {
                mkIrrigationId: mkIrrigationId
            },
            relations: {
                MkTable: true
            }
        });
    }
    async update(mkIrrigationId, updateMkIrrigationTableInput, mkId) {
        let result = await this.mkIrrigationTableRepository.findOne({
            where: {
                mkIrrigationId: mkIrrigationId
            }
        });
        if (result) {
            result.sourceOfIrrigation = updateMkIrrigationTableInput.sourceOfIrrigation;
            let mk = await this.mkTableService.findOne(mkId);
            result.MkTable = mk;
            let r = await this.mkIrrigationTableRepository.save(result);
            this.pubSub.publish(exports.NEW_MKIRRIGATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(mkIrrigationId) {
        let result = await this.mkIrrigationTableRepository.findOne({
            where: {
                mkIrrigationId: mkIrrigationId
            }
        });
        if (result) {
            await this.mkIrrigationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_MKIRRIGATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async removeByMkId(mkId) {
        let result = await this.mkIrrigationTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
        if (result.length > 0) {
            await this.mkIrrigationTableRepository.remove(result);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async getTotalIrrigationCount(type, stateId, districtId, blockId) {
        let data = await this.mkIrrigationTableRepository
            .createQueryBuilder('tt')
            .leftJoinAndMapOne('tt.MkTable', mk_table_entity_1.MkTable, 'r', 'r.mkId=tt.mkId')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(tt.mkIrrigationId)', 'value')
            .addSelect('MAX(tt.sourceOfIrrigation)', 'title')
            .groupBy('tt.sourceOfIrrigation');
        if (stateId > 0) {
            data = await data.andWhere('ml5.stateId=:stateId', { stateId: stateId });
        }
        if (districtId > 0) {
            data = await data.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            data = await data.andWhere('ml3.blockId=:blockId', { blockId: blockId });
        }
        data = await data.getRawMany();
        return data;
    }
};
exports.MkIrrigationTableService = MkIrrigationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mk_irrigation_table_entity_1.MkIrrigationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        mk_table_service_1.MkTableService])
], MkIrrigationTableService);
