"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkTableController = void 0;
const common_1 = require("@nestjs/common");
const mk_table_service_1 = require("./mk-table.service");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const jwt_auth_guard_1 = require("../auth/guards/jwt-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const moment_1 = __importDefault(require("moment"));
let MkTableController = exports.MkTableController = class MkTableController {
    constructor(mkTableService) {
        this.mkTableService = mkTableService;
    }
    async getDashboardCounts(req) {
        let limit = req.query.hasOwnProperty('per_page') ? req.query.per_page : 50;
        let page = req.query.hasOwnProperty('page') ? req.query.page : 1;
        let search = req.query.hasOwnProperty('search') ? req.query.search : '';
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        return await this.mkTableService.getAllMkPaginatedStateDistrictBlock(limit, page, search, stateId, districtId, blockId);
    }
    async getTotalMkReport(req) {
        let type = req.query.hasOwnProperty('type') ? req.query.type : "";
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        return await this.mkTableService.getTotalMkReport(type, stateId, districtId, blockId);
    }
    async getMkAvgIncome(req) {
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        return await this.mkTableService.calculateAvgIncome(stateId, districtId, blockId);
    }
    async getMkLevelIncome(req) {
        let stateId = req.query.hasOwnProperty('stateId') ? req.query.stateId : 0;
        let districtId = req.query.hasOwnProperty('districtId') ? req.query.districtId : 0;
        let blockId = req.query.hasOwnProperty('blockId') ? req.query.blockId : 0;
        return await this.mkTableService.calculateLevelIncome(stateId, districtId, blockId);
    }
    async mkListDownload(body, res) {
        let stateId = body.stateId ? body.stateId : 0;
        let districtId = body.districtId ? body.districtId : 0;
        let blockId = body.blockId ? body.blockId : 0;
        var fileName = `mk-report-download-${(0, moment_1.default)().toISOString()}.xlsx`;
        res.setHeader('Content-Type', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
        res.setHeader("Content-Disposition", "attachment; filename=" + fileName);
        var Excel = require('exceljs');
        var workbook = new Excel.Workbook();
        var worksheet = workbook.addWorksheet('MK Table');
        workbook.creator = 'Sesta MIS';
        workbook.lastModifiedBy = 'Sesta MIS';
        workbook.created = new Date();
        workbook.modified = new Date();
        const data = await this.mkTableService.getAllMkNonPaginatedStateDistrictBlock(stateId, districtId, blockId);
        worksheet.columns = [
            { header: 'MK ID', key: 'mkId', width: 10 },
            { header: 'Name', key: 'mkName', width: 32 },
            { header: 'Age', key: 'mkAge', width: 10 },
            { header: 'Weath Ranking', key: 'wealthRanking', width: 10 },
            { header: 'Intervention', key: 'typeOfIntervention', width: 10 },
            { header: 'Band', key: 'farmerBand', width: 10 },
            { header: 'Contact No', key: 'contactNumber', width: 10 },
            { header: 'ID Card Type', key: 'identityCardType', width: 10 },
            { header: 'ID Card No', key: 'identityCardId', width: 10 },
            { header: 'State', key: 'stateName', width: 10 },
            { header: 'District', key: 'districtName', width: 10 },
            { header: 'Block', key: 'blockName', width: 10 },
            { header: 'Grampanchayat', key: 'gpName', width: 10 },
            { header: 'Village', key: 'villageName', width: 10 },
            { header: 'Vulnerability Category', key: 'vulcatName', width: 10 },
            { header: 'Guardian Type', key: 'guardianType', width: 10 },
            { header: 'Guardian Name', key: 'guardianName', width: 10 },
            { header: 'Social Category', key: 'socialCategory', width: 10 },
            { header: 'Religion', key: 'religion', width: 10 },
            { header: 'Education', key: 'education', width: 10 },
            { header: 'Total Family Member', key: 'totalFamilyMember', width: 10 },
            { header: 'Total Male Member', key: 'familyMemberMale', width: 10 },
            { header: 'Total Female Member', key: 'familyMemberFemale', width: 10 },
            { header: 'Total Children', key: 'familyMemberChildren', width: 10 },
            { header: 'Primary Source of Income', key: 'primarySourceOfIncome', width: 10 },
            { header: 'Secondary Source of Income', key: 'secondarySourceOfIncome', width: 10 },
            { header: 'Total Land Size (Bigha)', key: 'totalLandSize', width: 10 },
            { header: 'Other Source of Income', key: 'otherIncomeSourceName', width: 10 },
            { header: 'Has Health Insurance ?', key: 'hasHealthInsurance', width: 10 },
            { header: 'Has Job Card ?', key: 'hasJobCard', width: 10 },
            { header: 'is BPL ?', key: 'isBpl', width: 10 },
            { header: 'is Member of PG ?', key: 'isMemberOfPg', width: 10 },
            { header: 'PG Name', key: 'pgName', width: 10 },
            { header: 'IrrigationAdopted', key: 'MkIrrigationTable', width: 30 },
            { header: 'Type of tools', key: 'MkTypeOfToolsTable', width: 30 },
            ...data.landTypes.map(el2 => ({ header: el2.landTypeName, key: `land-${el2.landTypeId}`, width: 10 })),
            ...data.lsData.map(el2 => ({ header: el2.lsName, key: el2.lsCode, width: 10 })),
            { header: 'Entered On', key: 'createdAtReadable', width: 10 },
            { header: 'Entered By', key: 'userName', width: 10 },
        ];
        for (const el of data.data) {
            let landData = el.MkTypeOfLandTable;
            let incomeData = el.MkIncomeActivityTable;
            let rowData = Object.assign(Object.assign({}, el), { stateName: el.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.StateTable.stateName, districtName: el.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.districtName, blockName: el.VillageTable.GrampanchayatTable.BlockTable.blockName, gpName: el.VillageTable.GrampanchayatTable.gpName, villageName: el.VillageTable.villageName, vulcatName: el.VulnerabilityCategoryTable.vulcatName, userName: el.UserTable.name, createdAtReadable: (0, moment_1.default)(el.createdAt).format("DD-MM-YYYY hh:mm:ss a"), pgName: el.ProducerGroupsTable ? el.ProducerGroupsTable.pgName : 'Not-Alotted', MkIrrigationTable: el.MkIrrigationTable.map(el1 => el1.sourceOfIrrigation).join(','), MkTypeOfToolsTable: el.MkTypeOfToolsTable.map(el1 => el1.typeOfTools).join(',') });
            for (const el2 of data.landTypes) {
                let ld = landData.find(el1 => el1.LandTypeTable.landTypeId === el2.landTypeId);
                if (ld) {
                    rowData[`land-${el2.landTypeId}`] = ld.conversionToBigha;
                }
                else {
                    rowData[`land-${el2.landTypeId}`] = '-';
                }
            }
            for (const el2 of data.lsData) {
                let ld = incomeData.find(el1 => el1.livelihoodActivityIncomeSub === el2.lsCode);
                if (ld) {
                    rowData[el2.lsCode] = ld.income;
                }
                else {
                    rowData[el2.lsCode] = '-';
                }
            }
            worksheet.addRow(Object.assign({}, rowData));
        }
        await workbook.xlsx.write(res);
        res.end();
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('mk-list-paginated'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], MkTableController.prototype, "getDashboardCounts", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('mk-total-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], MkTableController.prototype, "getTotalMkReport", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('mk-average-income-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], MkTableController.prototype, "getMkAvgIncome", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Get)('mk-level-income-report'),
    __param(0, (0, common_1.Req)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], MkTableController.prototype, "getMkLevelIncome", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(jwt_auth_guard_1.JwtAuthGuard, roles_guard_1.RolesGuard),
    (0, common_1.Post)('mk-list-download'),
    __param(0, (0, common_1.Body)()),
    __param(1, (0, common_1.Res)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MkTableController.prototype, "mkListDownload", null);
exports.MkTableController = MkTableController = __decorate([
    (0, common_1.Controller)('mk-table'),
    __metadata("design:paramtypes", [mk_table_service_1.MkTableService])
], MkTableController);
