import { MkTableService } from './mk-table.service';
import { MkTable } from './entities/mk-table.entity';
import { CreateMkTableInput } from './dto/create-mk-table.input';
import { UpdateMkTableInput } from './dto/update-mk-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_MK_ADD = "NEW_MK_ADD";
export declare class MkTableResolver {
    private readonly mkTableService;
    private pubSub;
    constructor(mkTableService: MkTableService, pubSub: RedisPubSub);
    createMkTable(createMkTableInput: CreateMkTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        status: boolean;
        status_text: string;
        data: MkTable;
    }>;
    updateProducerGroup(mkId: number, isMemberOfPg: string, pgId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: MkTable;
    }>;
    findAllMkTable(user: any): Promise<MkTable[]>;
    findAllMkTableByShgId(shgId: number): Promise<MkTable[]>;
    findOneMk(mkId: number): Promise<MkTable>;
    getMkCountByShgId(user: any, shgId: number): Promise<{
        count: number;
    }>;
    getMkFblpCountByShgId(user: any, shgId: number): Promise<{
        count: number;
        fblpCount: number;
    }>;
    updateMkTable(updateMkTableInput: UpdateMkTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: MkTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    getMkTableByShgIdPaginated(limit: number, page: number, shgId: number, search: string): Promise<{
        data: any;
        total: any;
    }>;
    getMkTableByStateDistrictBlockIdPaginated(limit: number, page: number, search: string, stateId: number, districtId: number, blockId: number): Promise<{
        data: any;
        total: any;
        page: number;
    }>;
    removeMkTable(mkId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    mkSubscription(): AsyncIterator<unknown, any, undefined>;
}
