"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkTableResolver = exports.NEW_MK_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const mk_table_service_1 = require("./mk-table.service");
const mk_table_entity_1 = require("./entities/mk-table.entity");
const create_mk_table_input_1 = require("./dto/create-mk-table.input");
const update_mk_table_input_1 = require("./dto/update-mk-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const common_1 = require("@nestjs/common");
const mk_table_return_type_1 = require("./types/mk-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const mk_table_type_1 = require("./types/mk-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mk_table_count_type_1 = require("./types/mk-table-count.type");
const mk_table_pagination_type_1 = require("./types/mk-table-pagination.type");
exports.NEW_MK_ADD = "NEW_MK_ADD";
let MkTableResolver = exports.MkTableResolver = class MkTableResolver {
    constructor(mkTableService, pubSub) {
        this.mkTableService = mkTableService;
        this.pubSub = pubSub;
    }
    createMkTable(createMkTableInput, user) {
        return this.mkTableService.create(createMkTableInput, user);
    }
    updateProducerGroup(mkId, isMemberOfPg, pgId, user) {
        return this.mkTableService.updateProducerGroup(mkId, isMemberOfPg, pgId);
    }
    findAllMkTable(user) {
        return this.mkTableService.findAll();
    }
    findAllMkTableByShgId(shgId) {
        return this.mkTableService.findAllByShg(shgId);
    }
    findOneMk(mkId) {
        return this.mkTableService.findOne(mkId);
    }
    getMkCountByShgId(user, shgId) {
        return this.mkTableService.getMkCountByShgId(shgId);
    }
    getMkFblpCountByShgId(user, shgId) {
        return this.mkTableService.getMkFblpCountByShgId(shgId);
    }
    updateMkTable(updateMkTableInput, user) {
        return this.mkTableService.update(updateMkTableInput.mkId, updateMkTableInput, user);
    }
    getMkTableByShgIdPaginated(limit, page, shgId, search) {
        return this.mkTableService.getAllMkPaginated(limit, page, shgId, search);
    }
    getMkTableByStateDistrictBlockIdPaginated(limit, page, search, stateId, districtId, blockId) {
        return this.mkTableService.getAllMkPaginatedStateDistrictBlock(limit, page, search, stateId, districtId, blockId);
    }
    removeMkTable(mkId, user) {
        return this.mkTableService.remove(mkId);
    }
    mkSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_MK_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_table_return_type_1.MkTableReturnType),
    __param(0, (0, graphql_1.Args)('createMkTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_mk_table_input_1.CreateMkTableInput, Object]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "createMkTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_table_return_type_1.MkTableReturnType),
    __param(0, (0, graphql_1.Args)('mkId')),
    __param(1, (0, graphql_1.Args)('isMemberOfPg')),
    __param(2, (0, graphql_1.Args)('pgId', { nullable: true })),
    __param(3, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, Number, Object]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "updateProducerGroup", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mk_table_type_1.MkTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "findAllMkTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mk_table_type_1.MkTableType]),
    __param(0, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "findAllMkTableByShgId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_table_type_1.MkTableType),
    __param(0, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "findOneMk", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_table_count_type_1.MkTableCountType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "getMkCountByShgId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_table_count_type_1.MkTableCountType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "getMkFblpCountByShgId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_table_return_type_1.MkTableReturnType),
    __param(0, (0, graphql_1.Args)('updateMkTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_mk_table_input_1.UpdateMkTableInput, Object]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "updateMkTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_table_pagination_type_1.MkTablePaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('shgId')),
    __param(3, (0, graphql_1.Args)('search')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Number, String]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "getMkTableByShgIdPaginated", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mk_table_pagination_type_1.MkTablePaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('search')),
    __param(3, (0, graphql_1.Args)('stateId')),
    __param(4, (0, graphql_1.Args)('districtId')),
    __param(5, (0, graphql_1.Args)('blockId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, Number, Number, Number]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "getMkTableByStateDistrictBlockIdPaginated", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mk_table_return_type_1.MkTableReturnType),
    __param(0, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "removeMkTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MkTableResolver.prototype, "mkSubscription", null);
exports.MkTableResolver = MkTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => mk_table_entity_1.MkTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mk_table_service_1.MkTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], MkTableResolver);
