"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkTableService = exports.NEW_MK_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const mk_table_entity_1 = require("./entities/mk-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const village_table_service_1 = require("../village-table/village-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const shg_table_service_1 = require("../shg-table/shg-table.service");
const moment_1 = __importDefault(require("moment"));
const mk_irrigation_table_service_1 = require("../mk-irrigation-table/mk-irrigation-table.service");
const mk_income_activity_table_service_1 = require("../mk-income-activity-table/mk-income-activity-table.service");
const mk_type_of_land_table_service_1 = require("../mk-type-of-land-table/mk-type-of-land-table.service");
const mk_type_of_tools_table_service_1 = require("../mk-type-of-tools-table/mk-type-of-tools-table.service");
const vulnerability_category_table_service_1 = require("../vulnerability-category-table/vulnerability-category-table.service");
const producer_groups_table_service_1 = require("../producer-groups-table/producer-groups-table.service");
const shg_table_entity_1 = require("../shg-table/entities/shg-table.entity");
const village_table_entity_1 = require("../village-table/entities/village-table.entity");
const user_collection_entity_1 = require("../user-collection/entities/user-collection.entity");
const intervention_table_service_1 = require("../intervention-table/intervention-table.service");
const fblp_table_service_1 = require("../fblp-table/fblp-table.service");
const grampanchayat_table_entity_1 = require("../grampanchayat-table/entities/grampanchayat-table.entity");
const block_table_entity_1 = require("../block-table/entities/block-table.entity");
const district_table_entity_1 = require("../district-table/entities/district-table.entity");
const state_table_entity_1 = require("../state-table/entities/state-table.entity");
const vulnerability_category_table_entity_1 = require("../vulnerability-category-table/entities/vulnerability-category-table.entity");
const mk_entitlements_table_service_1 = require("../mk-entitlements-table/mk-entitlements-table.service");
const income_source_table_service_1 = require("../income-source-table/income-source-table.service");
const livelihood_source_table_service_1 = require("../livelihood-source-table/livelihood-source-table.service");
const HelperFunctions_1 = require("../helper/HelperFunctions");
const scheme_master_sub_table_service_1 = require("../scheme-master-sub-table/scheme-master-sub-table.service");
const producer_groups_table_entity_1 = require("../producer-groups-table/entities/producer-groups-table.entity");
const vo_table_service_1 = require("../vo-table/vo-table.service");
exports.NEW_MK_ADD = 'NEW_MK_ADD';
let MkTableService = exports.MkTableService = class MkTableService {
    constructor(mkTableRepository, pubSub, shgTableService, villageTableService, userCollectionService, vulnerabilityCategoryTableService, mkIrrigationTableService, mkIncomeActivityTableService, schemeMasterSubTableService, mkTypeOfLandTableService, mkTypeOfToolsTableService, producerGroupsTableService, interventionTableService, fblpTableService, mkEntitlementsTableService, incomeSourceTableService, livelihoodSourceTableService, voTableService) {
        this.mkTableRepository = mkTableRepository;
        this.pubSub = pubSub;
        this.shgTableService = shgTableService;
        this.villageTableService = villageTableService;
        this.userCollectionService = userCollectionService;
        this.vulnerabilityCategoryTableService = vulnerabilityCategoryTableService;
        this.mkIrrigationTableService = mkIrrigationTableService;
        this.mkIncomeActivityTableService = mkIncomeActivityTableService;
        this.schemeMasterSubTableService = schemeMasterSubTableService;
        this.mkTypeOfLandTableService = mkTypeOfLandTableService;
        this.mkTypeOfToolsTableService = mkTypeOfToolsTableService;
        this.producerGroupsTableService = producerGroupsTableService;
        this.interventionTableService = interventionTableService;
        this.fblpTableService = fblpTableService;
        this.mkEntitlementsTableService = mkEntitlementsTableService;
        this.incomeSourceTableService = incomeSourceTableService;
        this.livelihoodSourceTableService = livelihoodSourceTableService;
        this.voTableService = voTableService;
    }
    async create(createMkTableInput, user) {
        let checkIfExists = await this.checkIfExists(createMkTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: 'Data Already Exists',
            };
        }
        else {
            let mk = new mk_table_entity_1.MkTable();
            if (createMkTableInput.shgId) {
                let shg = await this.shgTableService.findOne(createMkTableInput.shgId);
                mk.ShgTable = shg;
                if (shg) {
                    let village = shg.VillageTable;
                    mk.VillageTable = village;
                }
            }
            if (createMkTableInput.voId && createMkTableInput.voId > 0) {
                let vo = await this.voTableService.findOne(createMkTableInput.voId);
                mk.VoTable = vo;
            }
            mk.mkName = createMkTableInput.mkName.trim();
            mk.mkAge = createMkTableInput.mkAge.trim();
            if (createMkTableInput.vulnerabilityCategoryId > 0) {
                let vulCat = await this.vulnerabilityCategoryTableService.findOne(createMkTableInput.vulnerabilityCategoryId);
                mk.VulnerabilityCategoryTable = vulCat;
            }
            mk.guardianType = createMkTableInput.guardianType.trim();
            if (createMkTableInput.guardianType == 'FATHER') {
                mk.fatherName = createMkTableInput.fatherName.trim();
            }
            if (createMkTableInput.guardianType == 'HUSBAND') {
                mk.husbandName = createMkTableInput.husbandName.trim();
            }
            mk.contactNumber = createMkTableInput.contactNumber.trim();
            mk.socialCategory = createMkTableInput.socialCategory.trim();
            mk.religion = createMkTableInput.religion.trim();
            mk.education = createMkTableInput.education.trim();
            mk.familyMemberMale = createMkTableInput.familyMemberMale;
            mk.familyMemberFemale = createMkTableInput.familyMemberFemale;
            mk.familyMemberChildren = createMkTableInput.familyMemberChildren;
            mk.totalFamilyMember = createMkTableInput.totalFamilyMember;
            mk.isMemberOfPg = createMkTableInput.isMemberOfPg;
            if (createMkTableInput.isMemberOfPg == 'YES') {
                let pgt = await this.producerGroupsTableService.findOne(createMkTableInput.producerGroupId);
                mk.ProducerGroupTable = pgt;
            }
            else {
                mk.ProducerGroupTable = null;
            }
            mk.identityCardType = createMkTableInput.identityCardType;
            mk.identityCardId = createMkTableInput.identityCardId;
            mk.hasJobCard = createMkTableInput.hasJobCard;
            if (createMkTableInput.hasJobCard == 'YES') {
                mk.jobCardId = createMkTableInput.jobCardId;
            }
            mk.isBpl = createMkTableInput.isBpl;
            mk.hasHealthInsurance = createMkTableInput.hasHealthInsurance;
            mk.primarySourceOfIncome = createMkTableInput.primarySourceOfIncome;
            mk.secondarySourceOfIncome = createMkTableInput.secondarySourceOfIncome;
            mk.otherIncomeSourceName = createMkTableInput.otherIncomeSourceName;
            mk.wealthRanking = createMkTableInput.wealthRanking;
            mk.typeOfIntervention = createMkTableInput.typeOfIntervention;
            mk.editableTill = (0, moment_1.default)().add(7, 'days').format("DD-MM-YYYY");
            mk.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
            mk.entryTime = (0, moment_1.default)().format('hh:mm:ss a');
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            mk.UserTable = userData;
            let result = await this.mkTableRepository.save(mk);
            await this.mkIrrigationTableService.createBulk(createMkTableInput.MkIrrigationTable, result.mkId);
            let income = await this.mkIncomeActivityTableService.createBulk(createMkTableInput.MkIncomeActivityTable, result.mkId);
            await this.mkTypeOfToolsTableService.createBulk(createMkTableInput.MkTypeOfToolsTable, result.mkId);
            let landTypes = await this.mkTypeOfLandTableService.createBulk(createMkTableInput.MkTypeOfLandTable, result.mkId);
            if (createMkTableInput.entitlements.length > 0) {
                await this.mkEntitlementsTableService.createFromMk(createMkTableInput.entitlements, user, result.mkId);
            }
            result.totalIncome = income.total.toFixed(2);
            result.totalLandSize = landTypes.total;
            let farmerBand = (0, HelperFunctions_1.determineFarmerBand)(result.totalLandSize);
            mk.farmerBand = farmerBand;
            let result1 = await this.mkTableRepository.save(mk);
            this.pubSub.publish(exports.NEW_MK_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: result1,
            };
        }
    }
    async getMkCountByShgId(shgId) {
        let count = await this.mkTableRepository.count({
            where: {
                ShgTable: {
                    shgId,
                },
            },
        });
        return {
            count,
        };
    }
    async getMkFblpCountByShgId(shgId) {
        console.log("🚀 ~ MkTableService ~ getMkFblpCountByShgId ~ shgId:", shgId);
        let mkCount = await this.mkTableRepository.count({
            where: {
                ShgTable: {
                    shgId,
                },
            },
        });
        let fblpCount = await this.fblpTableService.countByShgId(shgId);
        return {
            count: mkCount,
            fblpCount,
        };
    }
    async checkIfExists(createMkTableInput) {
        let result = await this.mkTableRepository.findOne({
            where: {
                identityCardId: createMkTableInput.identityCardId,
            },
        });
        if (result) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAll() {
        return await this.mkTableRepository.find({
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true,
                            },
                        },
                    },
                },
                ProducerGroupTable: true
            },
        });
    }
    async findAllByShg(shgId) {
        return await this.mkTableRepository.find({
            where: {
                ShgTable: {
                    shgId
                }
            },
            relations: {
                ShgTable: true
            }
        });
    }
    async findAllOneSingle(mkId) {
        return await this.mkTableRepository.findOne({
            where: {
                mkId
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true,
                            },
                        },
                    },
                },
                ProducerGroupTable: true
            },
        });
    }
    async findOne(mkId) {
        return await this.mkTableRepository.findOne({
            where: {
                mkId,
            },
            relations: {
                VulnerabilityCategoryTable: true,
                ProducerGroupTable: true,
                MkTypeOfToolsTable: true,
                MkIrrigationTable: true,
                UserTable: true,
                MkEntitlementsTable: {
                    SchemeMasterSubTable: true
                },
                MkTypeOfLandTable: {
                    LandTypeTable: true,
                },
                MkIncomeActivityTable: true,
                ShgTable: {
                    VoTable: true
                },
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true,
                            },
                        },
                    },
                },
            },
        });
    }
    async findOneSingle(mkId) {
        return await this.mkTableRepository.findOne({
            where: {
                mkId,
            },
        });
    }
    async update(mkId, updateMkTableInput, user) {
        let mk = await this.findOneSingle(mkId);
        if (mk) {
            if (updateMkTableInput.shgId) {
                let shg = await this.shgTableService.findOne(updateMkTableInput.shgId);
                mk.ShgTable = shg;
                if (shg) {
                    let village = shg.VillageTable;
                    mk.VillageTable = village;
                }
            }
            mk.mkName = updateMkTableInput.mkName.trim();
            mk.mkAge = updateMkTableInput.mkAge.trim();
            if (updateMkTableInput.vulnerabilityCategoryId > 0) {
                let vulCat = await this.vulnerabilityCategoryTableService.findOne(updateMkTableInput.vulnerabilityCategoryId);
                mk.VulnerabilityCategoryTable = vulCat;
            }
            mk.guardianType = updateMkTableInput.guardianType.trim();
            if (updateMkTableInput.guardianType == 'FATHER') {
                mk.fatherName = updateMkTableInput.fatherName.trim();
            }
            if (updateMkTableInput.guardianType == 'HUSBAND') {
                mk.husbandName = updateMkTableInput.husbandName.trim();
            }
            mk.contactNumber = updateMkTableInput.contactNumber.trim();
            mk.socialCategory = updateMkTableInput.socialCategory.trim();
            mk.religion = updateMkTableInput.religion.trim();
            mk.education = updateMkTableInput.education.trim();
            mk.familyMemberMale = updateMkTableInput.familyMemberMale;
            mk.familyMemberFemale = updateMkTableInput.familyMemberFemale;
            mk.familyMemberChildren = updateMkTableInput.familyMemberChildren;
            mk.totalFamilyMember = updateMkTableInput.totalFamilyMember;
            mk.isMemberOfPg = updateMkTableInput.isMemberOfPg;
            if (updateMkTableInput.isMemberOfPg == 'YES') {
                let pgt = await this.producerGroupsTableService.findOne(updateMkTableInput.producerGroupId);
                mk.ProducerGroupTable = pgt;
            }
            else {
                mk.ProducerGroupTable = null;
            }
            mk.identityCardType = updateMkTableInput.identityCardType;
            mk.identityCardId = updateMkTableInput.identityCardId;
            mk.hasJobCard = updateMkTableInput.hasJobCard;
            mk.isBpl = updateMkTableInput.isBpl;
            mk.hasHealthInsurance = updateMkTableInput.hasHealthInsurance;
            mk.primarySourceOfIncome = updateMkTableInput.primarySourceOfIncome;
            mk.secondarySourceOfIncome = updateMkTableInput.secondarySourceOfIncome;
            mk.otherIncomeSourceName = updateMkTableInput.otherIncomeSourceName;
            mk.wealthRanking = updateMkTableInput.wealthRanking;
            mk.typeOfIntervention = updateMkTableInput.typeOfIntervention;
            mk.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
            mk.entryTime = (0, moment_1.default)().format('hh:mm:ss a');
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            mk.UserTable = userData;
            let result = await this.mkTableRepository.save(mk);
            await this.mkIrrigationTableService.createBulk(updateMkTableInput.MkIrrigationTable, result.mkId);
            let income = await this.mkIncomeActivityTableService.createBulk(updateMkTableInput.MkIncomeActivityTable, result.mkId);
            await this.mkTypeOfToolsTableService.createBulk(updateMkTableInput.MkTypeOfToolsTable, result.mkId);
            let landTypes = await this.mkTypeOfLandTableService.createBulk(updateMkTableInput.MkTypeOfLandTable, result.mkId);
            if (updateMkTableInput.entitlements.length > 0) {
                await this.mkEntitlementsTableService.createFromMk(updateMkTableInput.entitlements, user, result.mkId);
            }
            result.totalIncome = income.total.toFixed(2);
            result.totalLandSize = landTypes.total;
            let farmerBand = (0, HelperFunctions_1.determineFarmerBand)(result.totalLandSize);
            mk.farmerBand = farmerBand;
            let result1 = await this.mkTableRepository.save(result);
            this.pubSub.publish(exports.NEW_MK_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: result,
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not Found',
            };
        }
    }
    async getCount() {
        return await this.mkTableRepository.count();
    }
    async updateProducerGroup(mkId, isMemberOfPg, pgId) {
        let mk = await this.findOneSingle(mkId);
        if (mk) {
            if (isMemberOfPg == "YES") {
                mk.isMemberOfPg = "YES";
                let pgt = await this.producerGroupsTableService.findOne(pgId);
                mk.ProducerGroupTable = pgt;
            }
            else {
                mk.isMemberOfPg = "NO";
                mk.ProducerGroupTable = null;
            }
            let result = await this.mkTableRepository.save(mk);
            let data = await this.findAllOneSingle(result.mkId);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: data,
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not Found',
                data: null
            };
        }
    }
    async remove(mkId) {
        let result = await this.findOne(mkId);
        if (result) {
            await this.mkTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_MK_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Deleted',
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not Found',
            };
        }
    }
    async getCountByUsername(username) {
        return await this.mkTableRepository.count({
            where: {
                UserTable: {
                    username,
                },
            },
        });
    }
    async getAllMkPaginated(limit, page, shgId, search) {
        let data = await this.mkTableRepository
            .createQueryBuilder('r')
            .where('r.shgId=:shgId', { shgId: shgId })
            .leftJoinAndMapOne('r.ShgTable', shg_table_entity_1.ShgTable, 'ml', 'ml.shgId=r.shgId')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml2', 'ml2.id=r.userId')
            .take(limit)
            .skip(page);
        if (search != '') {
            let s = `${search}%`;
            data = await data.andWhere('r.mkName LIKE :mkName', { mkName: s });
        }
        data = await data.getManyAndCount();
        let [result, count] = data;
        let index = 0;
        for (const el of result) {
            let intervetion = await this.interventionTableService.findByMkId(el.mkId);
            result[index]['InterventionTable'] = intervetion;
            index++;
        }
        return {
            data: result,
            total: count,
        };
    }
    async getAllMkPaginatedStateDistrictBlock(limit, page, search, stateId, districtId, blockId) {
        let skip = (page - 1) * limit;
        let data = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .leftJoinAndMapOne('r.VulnerabilityCategoryTable', vulnerability_category_table_entity_1.VulnerabilityCategoryTable, 'ml7', 'ml7.vulcatId=r.vulnerabilityCategoryId')
            .take(limit)
            .skip(skip);
        if (search != '') {
            let s = `%${search}%`;
            data = await data.andWhere('r.mkName LIKE :mkName', { mkName: s });
        }
        if (stateId > 0) {
            data = await data.andWhere('ml5.stateId=:stateId', { stateId: stateId });
        }
        if (districtId > 0) {
            data = await data.andWhere('ml4.districtId=:districtId', {
                districtId: districtId,
            });
        }
        if (blockId > 0) {
            data = await data.andWhere('ml3.blockId=:blockId', { blockId: blockId });
        }
        data = await data.getManyAndCount();
        let [result, count] = data;
        return {
            data: result,
            total: count,
            page,
        };
    }
    async getAllMkNonPaginatedStateDistrictBlock(stateId, districtId, blockId) {
        let data = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .leftJoinAndMapOne('r.ProducerGroupsTable', producer_groups_table_entity_1.ProducerGroupsTable, 'ml8', 'ml8.pgId=r.producerGroupId')
            .leftJoinAndMapOne('r.VulnerabilityCategoryTable', vulnerability_category_table_entity_1.VulnerabilityCategoryTable, 'ml7', 'ml7.vulcatId=r.vulnerabilityCategoryId')
            .leftJoinAndSelect('r.MkIrrigationTable', "MkIrrigationTable")
            .leftJoinAndSelect('r.MkTypeOfToolsTable', "MkTypeOfToolsTable");
        if (stateId > 0) {
            data = await data.andWhere('ml5.stateId=:stateId', { stateId: stateId });
        }
        if (districtId > 0) {
            data = await data.andWhere('ml4.districtId=:districtId', {
                districtId: districtId,
            });
        }
        if (blockId > 0) {
            data = await data.andWhere('ml3.blockId=:blockId', { blockId: blockId });
        }
        data = await data.getManyAndCount();
        let [result, count] = data;
        let landTypes = await this.mkTypeOfLandTableService.getLandTypeMasterData();
        let index = 0;
        for (const el of result) {
            result[index]['MkTypeOfLandTable'] = await this.mkTypeOfLandTableService.findAllByMkId(el.mkId);
            result[index]['MkIncomeActivityTable'] = await this.mkIncomeActivityTableService.findAllByMkIdNew(el.mkId);
            index++;
        }
        let lsData = await this.livelihoodSourceTableService.findAllOrdered();
        return {
            data: result,
            total: count,
            landTypes,
            lsData
        };
    }
    async getCountByMonth(month) {
        const startOfMonth = (0, moment_1.default)(month).startOf('month').format('YYYY-MM-DD');
        const endOfMonth = (0, moment_1.default)(month).endOf('month').format('YYYY-MM-DD');
        let result = await this.mkTableRepository
            .createQueryBuilder('mk')
            .andWhere("STR_TO_DATE(mk.entryDate, '%d-%m-%Y') BETWEEN :startDate AND :endDate", {
            endDate: endOfMonth,
            startDate: startOfMonth,
        })
            .getCount();
        return result;
    }
    async getTotalMkReport(type, stateId, districtId, blockId) {
        let aplBplData = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(r.isBpl)', 'title')
            .groupBy('r.isBpl');
        if (stateId > 0) {
            aplBplData = await aplBplData.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            aplBplData = await aplBplData.andWhere('ml4.districtId=:districtId', {
                districtId: districtId,
            });
        }
        if (blockId > 0) {
            aplBplData = await aplBplData.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        aplBplData = await aplBplData.getRawMany();
        let vulData = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .leftJoinAndMapOne('r.VulnerabilityCategoryTable', vulnerability_category_table_entity_1.VulnerabilityCategoryTable, 'ml7', 'ml7.vulcatId=r.vulnerabilityCategoryId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(ml7.vulcatName)', 'title')
            .groupBy('r.vulnerabilityCategoryId');
        if (stateId > 0) {
            vulData = await vulData.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            vulData = await vulData.andWhere('ml4.districtId=:districtId', {
                districtId: districtId,
            });
        }
        if (blockId > 0) {
            vulData = await vulData.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        vulData = await vulData.getRawMany();
        let toolsData = await this.mkTypeOfToolsTableService.getTotalTypeOfToolsCount(type, stateId, districtId, blockId);
        let irrigationData = await this.mkIrrigationTableService.getTotalIrrigationCount(type, stateId, districtId, blockId);
        let primarySource = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(r.primarySourceOfIncome)', 'title')
            .groupBy('r.primarySourceOfIncome');
        if (stateId > 0) {
            primarySource = await primarySource.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            primarySource = await primarySource.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            primarySource = await primarySource.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        primarySource = await primarySource.getRawMany();
        let secondarySource = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(r.secondarySourceOfIncome)', 'title')
            .groupBy('r.secondarySourceOfIncome');
        if (stateId > 0) {
            secondarySource = await secondarySource.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            secondarySource = await secondarySource.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            secondarySource = await secondarySource.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        secondarySource = await secondarySource.getRawMany();
        let incomeActivities = await this.incomeSourceTableService.findAll();
        let index = 0;
        for (const ia of incomeActivities) {
            let iaData = await this.mkIncomeActivityTableService.getIncomeAvgAndCount(ia.incomeSourceCode, stateId, districtId, blockId);
            incomeActivities[index]['data'] = iaData;
            index++;
        }
        let lsData = await this.livelihoodSourceTableService.findAll();
        let index1 = 0;
        for (const ls of lsData) {
            let lsData1 = await this.mkIncomeActivityTableService.getIncomeAvgAndCountLs(ls.lsCode, stateId, districtId, blockId);
            lsData[index1]['data'] = lsData1;
            index1++;
        }
        let bands = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(r.farmerBand)', 'title')
            .groupBy('r.farmerBand');
        if (stateId > 0) {
            bands = await bands.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            bands = await bands.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            bands = await bands.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        bands = await bands.getRawMany();
        bands = bands.map(el => (Object.assign(Object.assign({}, el), { title: (0, HelperFunctions_1.getBandName)(el.title) })));
        let wealthRanking = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .select('COUNT(r.mkId)', 'value')
            .addSelect('MAX(r.wealthRanking)', 'title')
            .groupBy('r.wealthRanking');
        if (stateId > 0) {
            wealthRanking = await wealthRanking.andWhere('ml5.stateId=:stateId', {
                stateId: stateId,
            });
        }
        if (districtId > 0) {
            wealthRanking = await wealthRanking.andWhere('ml4.districtId=:districtId', { districtId: districtId });
        }
        if (blockId > 0) {
            wealthRanking = await wealthRanking.andWhere('ml3.blockId=:blockId', {
                blockId: blockId,
            });
        }
        wealthRanking = await wealthRanking.getRawMany();
        let schemeList = await this.schemeMasterSubTableService.findAllEntitlements();
        let index2 = 0;
        for (const el of schemeList) {
            schemeList[index2]['data'] = await this.mkEntitlementsTableService.getEntitlementsCount(el.schemeMasterSubId, stateId, districtId, blockId);
            index2++;
        }
        return {
            aplBplData,
            vulData,
            toolsData,
            irrigationData,
            primarySource,
            secondarySource,
            incomeActivities,
            lsData,
            bands,
            wealthRanking,
            schemeList
        };
    }
    async calculateAvgIncome(stateId, districtId, blockId) {
        const livelihoodData = await this.livelihoodSourceTableService.findAll();
        let ffData = [];
        if (stateId > 0) {
            ffData = await this.mkTableRepository.find({
                where: {
                    ShgTable: {
                        VillageTable: {
                            GrampanchayatTable: {
                                BlockTable: {
                                    DistrictTable: {
                                        StateTable: {
                                            stateId,
                                        },
                                    },
                                },
                            },
                        },
                    },
                },
                relations: {
                    MkIncomeActivityTable: true,
                },
            });
        }
        if (districtId > 0) {
            ffData = await this.mkTableRepository.find({
                where: {
                    ShgTable: {
                        VillageTable: {
                            GrampanchayatTable: {
                                BlockTable: {
                                    DistrictTable: {
                                        districtId: districtId,
                                    },
                                },
                            },
                        },
                    },
                },
                relations: {
                    MkIncomeActivityTable: true,
                },
            });
        }
        if (blockId > 0) {
            ffData = await this.mkTableRepository.find({
                where: {
                    ShgTable: {
                        VillageTable: {
                            GrampanchayatTable: {
                                BlockTable: {
                                    blockId,
                                },
                            },
                        },
                    },
                },
                relations: {
                    MkIncomeActivityTable: true,
                },
            });
        }
        if (stateId == 0 && districtId == 0 && blockId == 0) {
            ffData = await this.mkTableRepository.find({
                relations: {
                    MkIncomeActivityTable: true,
                },
            });
        }
        let data = [];
        for (const lsd of livelihoodData) {
            let total = 0;
            let count = 0;
            let totalLand = 0;
            let herdSize = 0;
            let flockSize = 0;
            let incomeArr = [];
            for (const fd of ffData) {
                fd.MkIncomeActivityTable.map((el, index) => {
                    if (el.livelihoodActivityIncomeSub == lsd.lsCode) {
                        count++;
                        total = total + parseFloat(el.income);
                        totalLand = totalLand + parseFloat(el.conversionToBigha);
                        herdSize = herdSize + parseFloat(el.herdSize);
                        flockSize = flockSize + parseFloat(el.flockSize);
                        incomeArr.push(parseFloat(el.income));
                    }
                });
            }
            let avg = 0;
            let avgLand = 0;
            let avgHerd = 0;
            let avgFlock = 0;
            if (count > 0) {
                avg = total / count;
                avgLand = totalLand / count;
                avgHerd = herdSize / count;
                avgFlock = flockSize / count;
            }
            let median = (0, HelperFunctions_1.calculateMedian)(incomeArr);
            data.push({
                lsCode: lsd.lsCode,
                total: total,
                count: count,
                avgIncome: avg.toFixed(2),
                medianIncome: median.toFixed(2),
                avgLand: avgLand.toFixed(2),
                avgFlock: avgFlock.toFixed(2),
                avgHerd: avgHerd.toFixed(2),
            });
        }
        return data;
    }
    async calculateLevelIncome(stateId, districtId, blockId) {
        let organisationData = await this.calculateAvgIncome(0, 0, 0);
        let stateData = await this.calculateAvgIncome(stateId, 0, 0);
        let districtData = await this.calculateAvgIncome(0, districtId, 0);
        let blockData = await this.calculateAvgIncome(0, 0, blockId);
        const livelihoodData = await this.livelihoodSourceTableService.findAll();
        let data = [];
        for (const ls of livelihoodData) {
            let fOrganisationData = organisationData.find((el) => el.lsCode == ls.lsCode);
            let fStateData = stateData.find((el) => el.lsCode == ls.lsCode);
            let fDistrictData = districtData.find((el) => el.lsCode == ls.lsCode);
            let fBlockData = blockData.find((el) => el.lsCode == ls.lsCode);
            data.push({
                lsCode: ls.lsCode,
                oAvgIncome: fOrganisationData === null || fOrganisationData === void 0 ? void 0 : fOrganisationData.avgIncome,
                oMedianIncome: fOrganisationData === null || fOrganisationData === void 0 ? void 0 : fOrganisationData.medianIncome,
                sAvgIncome: fStateData === null || fStateData === void 0 ? void 0 : fStateData.avgIncome,
                sMedianIncome: fStateData === null || fStateData === void 0 ? void 0 : fStateData.medianIncome,
                dAvgIncome: fDistrictData === null || fDistrictData === void 0 ? void 0 : fDistrictData.avgIncome,
                dMedianIncome: fDistrictData === null || fDistrictData === void 0 ? void 0 : fDistrictData.medianIncome,
                bAvgIncome: fBlockData === null || fBlockData === void 0 ? void 0 : fBlockData.avgIncome,
                bMedianIncome: fBlockData === null || fBlockData === void 0 ? void 0 : fBlockData.medianIncome,
            });
        }
        return data;
    }
    async getMkListPaginated(limit, page) {
        let skip = (page - 1) * limit;
        let data = await this.mkTableRepository
            .createQueryBuilder('r')
            .leftJoinAndMapOne('r.VillageTable', village_table_entity_1.VillageTable, 'ml1', 'ml1.villageId=r.villageId')
            .leftJoinAndMapOne('ml1.GrampanchayatTable', grampanchayat_table_entity_1.GrampanchayatTable, 'ml2', 'ml2.gpId=ml1.gpId')
            .leftJoinAndMapOne('ml2.BlockTable', block_table_entity_1.BlockTable, 'ml3', 'ml2.blockId=ml3.blockId')
            .leftJoinAndMapOne('ml3.DistrictTable', district_table_entity_1.DistrictTable, 'ml4', 'ml4.districtId=ml3.districtId')
            .leftJoinAndMapOne('ml4.StateTable', state_table_entity_1.StateTable, 'ml5', 'ml4.stateId=ml5.stateId')
            .leftJoinAndMapOne('r.ShgTable', shg_table_entity_1.ShgTable, 'ml8', 'ml8.shgId=r.shgId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml6', 'ml6.id=r.userId')
            .leftJoinAndMapOne('r.VulnerabilityCategoryTable', vulnerability_category_table_entity_1.VulnerabilityCategoryTable, 'ml7', 'ml7.vulcatId=r.vulnerabilityCategoryId')
            .take(limit)
            .skip(skip);
        data = await data.getManyAndCount();
        let [result, count] = data;
        return {
            data: result,
            total: count,
            page,
        };
    }
    async createMkShortExcel(data, user) {
        let mk = new mk_table_entity_1.MkTable();
        if (data.shgId) {
            let shg = await this.shgTableService.findOne(data.shgId);
            mk.ShgTable = shg;
            if (shg) {
                let village = shg.VillageTable;
                mk.VillageTable = village;
            }
        }
        if (data.villageId && data.villageId > 0) {
            let village = await this.villageTableService.findOne(data.villageId);
            mk.VillageTable = village;
        }
        mk.mkName = data.mkName.trim();
        mk.mkAge = data.mkAge;
        if (data.vulnerabilityCategory) {
            let vulCat = await this.vulnerabilityCategoryTableService.findOneByName(data.vulnerabilityCategory);
            mk.VulnerabilityCategoryTable = vulCat;
        }
        mk.guardianType = data.guardianType;
        if (data.guardianType == 'FATHER') {
            mk.fatherName = data.guardianName;
        }
        if (data.guardianType == 'HUSBAND') {
            mk.husbandName = data.guardianName;
        }
        mk.contactNumber = data.contactNumber;
        mk.socialCategory = data.socialCategory;
        mk.religion = data.religion;
        mk.education = data.education;
        mk.familyMemberMale = data.familyMemberMale;
        mk.familyMemberFemale = data.familyMemberFemale;
        mk.familyMemberChildren = data.familyMemberChildren;
        mk.totalFamilyMember = data.totalFamilyMember;
        mk.typeOfIntervention = data.interventionType;
        mk.wealthRanking = data.wealthRanking;
        mk.isBpl = data.isBpl;
        mk.editableTill = (0, moment_1.default)().add(7, 'days').format("DD-MM-YYYY");
        mk.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
        mk.entryTime = (0, moment_1.default)().format('hh:mm:ss a');
        let userData = await this.userCollectionService.findOneByUsername(user.username);
        mk.UserTable = userData;
        let result = await this.mkTableRepository.save(mk);
        return result;
    }
};
exports.MkTableService = MkTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mk_table_entity_1.MkTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_irrigation_table_service_1.MkIrrigationTableService))),
    __param(7, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_income_activity_table_service_1.MkIncomeActivityTableService))),
    __param(8, (0, common_1.Inject)((0, common_1.forwardRef)(() => scheme_master_sub_table_service_1.SchemeMasterSubTableService))),
    __param(9, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_type_of_land_table_service_1.MkTypeOfLandTableService))),
    __param(10, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_type_of_tools_table_service_1.MkTypeOfToolsTableService))),
    __param(11, (0, common_1.Inject)((0, common_1.forwardRef)(() => producer_groups_table_service_1.ProducerGroupsTableService))),
    __param(12, (0, common_1.Inject)((0, common_1.forwardRef)(() => intervention_table_service_1.InterventionTableService))),
    __param(13, (0, common_1.Inject)((0, common_1.forwardRef)(() => fblp_table_service_1.FblpTableService))),
    __param(14, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_entitlements_table_service_1.MkEntitlementsTableService))),
    __param(15, (0, common_1.Inject)((0, common_1.forwardRef)(() => income_source_table_service_1.IncomeSourceTableService))),
    __param(16, (0, common_1.Inject)((0, common_1.forwardRef)(() => livelihood_source_table_service_1.LivelihoodSourceTableService))),
    __param(17, (0, common_1.Inject)((0, common_1.forwardRef)(() => vo_table_service_1.VoTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        shg_table_service_1.ShgTableService,
        village_table_service_1.VillageTableService,
        user_collection_service_1.UserCollectionService,
        vulnerability_category_table_service_1.VulnerabilityCategoryTableService,
        mk_irrigation_table_service_1.MkIrrigationTableService,
        mk_income_activity_table_service_1.MkIncomeActivityTableService,
        scheme_master_sub_table_service_1.SchemeMasterSubTableService,
        mk_type_of_land_table_service_1.MkTypeOfLandTableService,
        mk_type_of_tools_table_service_1.MkTypeOfToolsTableService,
        producer_groups_table_service_1.ProducerGroupsTableService,
        intervention_table_service_1.InterventionTableService,
        fblp_table_service_1.FblpTableService,
        mk_entitlements_table_service_1.MkEntitlementsTableService,
        income_source_table_service_1.IncomeSourceTableService,
        livelihood_source_table_service_1.LivelihoodSourceTableService,
        vo_table_service_1.VoTableService])
], MkTableService);
