import { RedisPubSub } from 'graphql-redis-subscriptions';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { Repository } from 'typeorm';
import { CreateMkTypeOfLandTableInput } from './dto/create-mk-type-of-land-table.input';
import { UpdateMkTypeOfLandTableInput } from './dto/update-mk-type-of-land-table.input';
import { MkTypeOfLandTable } from './entities/mk-type-of-land-table.entity';
import { LandTypeTableService } from 'src/land-type-table/land-type-table.service';
export declare const NEW_TYPEOFLAND_ADD = "NEW_TYPEOFLAND_ADD";
export declare class MkTypeOfLandTableService {
    private readonly mkTypeOfLandTableRepository;
    private pubSub;
    private readonly mkTableService;
    private readonly landTypeTableService;
    constructor(mkTypeOfLandTableRepository: Repository<MkTypeOfLandTable>, pubSub: RedisPubSub, mkTableService: MkTableService, landTypeTableService: LandTypeTableService);
    createBulk(createMkTypeOfLandTableInput: CreateMkTypeOfLandTableInput[], mkId: number): Promise<{
        total: number;
        data: any;
    }>;
    create(createMkTypeOfLandTableInput: CreateMkTypeOfLandTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkTypeOfLandTable;
    }>;
    checkIfExists(landTypeId: number, mkId: number, landSize: number, landUnit: string, conversionToBigha: number): Promise<boolean>;
    findAll(): Promise<MkTypeOfLandTable[]>;
    findAllByMkId(mkId: number): Promise<MkTypeOfLandTable[]>;
    findOne(mkTypeOfLandId: number): Promise<MkTypeOfLandTable>;
    getLandTypeMasterData(): Promise<import("../land-type-table/entities/land-type-table.entity").LandTypeTable[]>;
    update(mkTypeOfLandId: number, updateMkTypeOfLandTableInput: UpdateMkTypeOfLandTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkTypeOfLandTable;
    }>;
    remove(mkTypeOfLandId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    removeByMkId(mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
