"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkTypeOfLandTableService = exports.NEW_TYPEOFLAND_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const typeorm_2 = require("typeorm");
const mk_type_of_land_table_entity_1 = require("./entities/mk-type-of-land-table.entity");
const land_type_table_service_1 = require("../land-type-table/land-type-table.service");
const HelperFunctions_1 = require("../helper/HelperFunctions");
exports.NEW_TYPEOFLAND_ADD = "NEW_TYPEOFLAND_ADD";
let MkTypeOfLandTableService = exports.MkTypeOfLandTableService = class MkTypeOfLandTableService {
    constructor(mkTypeOfLandTableRepository, pubSub, mkTableService, landTypeTableService) {
        this.mkTypeOfLandTableRepository = mkTypeOfLandTableRepository;
        this.pubSub = pubSub;
        this.mkTableService = mkTableService;
        this.landTypeTableService = landTypeTableService;
    }
    async createBulk(createMkTypeOfLandTableInput, mkId) {
        await this.removeByMkId(mkId);
        let totalLand = 0;
        let result = [];
        for (const el of createMkTypeOfLandTableInput) {
            let rr = await this.create(el, mkId);
            if (rr.status == true) {
                totalLand = totalLand + rr.data.conversionToBigha;
            }
            result.push(rr);
        }
        return {
            total: totalLand,
            data: result
        };
    }
    async create(createMkTypeOfLandTableInput, mkId) {
        let checkIfExists = await this.checkIfExists(createMkTypeOfLandTableInput.landTypeId, mkId, createMkTypeOfLandTableInput.landSize, createMkTypeOfLandTableInput.landUnit, createMkTypeOfLandTableInput.conversionToBigha);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new mk_type_of_land_table_entity_1.MkTypeOfLandTable();
            if (createMkTypeOfLandTableInput.landTypeId) {
                let landTypeTable = await this.landTypeTableService.findOne(createMkTypeOfLandTableInput.landTypeId);
                dd.LandTypeTable = landTypeTable;
            }
            dd.landSize = createMkTypeOfLandTableInput.landSize;
            dd.landUnit = createMkTypeOfLandTableInput.landUnit;
            dd.conversionToBigha = parseFloat((0, HelperFunctions_1.convertToBigha)(createMkTypeOfLandTableInput.landSize, createMkTypeOfLandTableInput.landUnit));
            let mk = await this.mkTableService.findOneSingle(mkId);
            dd.MkTable = mk;
            let result = await this.mkTypeOfLandTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_TYPEOFLAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(landTypeId, mkId, landSize, landUnit, conversionToBigha) {
        let result = await this.mkTypeOfLandTableRepository.count({
            where: {
                LandTypeTable: {
                    landTypeId
                },
                landSize: landSize,
                landUnit: landUnit,
                MkTable: {
                    mkId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.mkTypeOfLandTableRepository.find({
            relations: {
                MkTable: true
            }
        });
    }
    async findAllByMkId(mkId) {
        return await this.mkTypeOfLandTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            },
            relations: {
                MkTable: true,
                LandTypeTable: true
            }
        });
    }
    async findOne(mkTypeOfLandId) {
        return await this.mkTypeOfLandTableRepository.findOne({
            where: {
                mkTypeOfLandId: mkTypeOfLandId
            },
            relations: {
                MkTable: true,
                LandTypeTable: true
            }
        });
    }
    async getLandTypeMasterData() {
        return await this.landTypeTableService.findAll();
    }
    async update(mkTypeOfLandId, updateMkTypeOfLandTableInput, mkId) {
        let result = await this.mkTypeOfLandTableRepository.findOne({
            where: {
                mkTypeOfLandId: mkTypeOfLandId
            }
        });
        if (result) {
            if (updateMkTypeOfLandTableInput.landTypeId) {
                let landTypeTable = await this.landTypeTableService.findOne(updateMkTypeOfLandTableInput.landTypeId);
                result.LandTypeTable = landTypeTable;
            }
            result.landSize = updateMkTypeOfLandTableInput.landSize;
            result.landUnit = updateMkTypeOfLandTableInput.landUnit;
            result.conversionToBigha = parseFloat((0, HelperFunctions_1.convertToBigha)(updateMkTypeOfLandTableInput.landSize, updateMkTypeOfLandTableInput.landUnit));
            let mk = await this.mkTableService.findOne(mkId);
            result.MkTable = mk;
            let r = await this.mkTypeOfLandTableRepository.save(result);
            this.pubSub.publish(exports.NEW_TYPEOFLAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(mkTypeOfLandId) {
        let result = await this.mkTypeOfLandTableRepository.findOne({
            where: {
                mkTypeOfLandId: mkTypeOfLandId
            }
        });
        if (result) {
            await this.mkTypeOfLandTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_TYPEOFLAND_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async removeByMkId(mkId) {
        let result = await this.mkTypeOfLandTableRepository.find({
            where: {
                MkTable: {
                    mkId
                }
            }
        });
        if (result.length > 0) {
            await this.mkTypeOfLandTableRepository.remove(result);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.MkTypeOfLandTableService = MkTypeOfLandTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(mk_type_of_land_table_entity_1.MkTypeOfLandTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        mk_table_service_1.MkTableService,
        land_type_table_service_1.LandTypeTableService])
], MkTypeOfLandTableService);
