"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MkTypeOfToolsTableResolver = exports.NEW_TYPEOFTOOLS_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const mk_type_of_tools_table_service_1 = require("./mk-type-of-tools-table.service");
const mk_type_of_tools_table_entity_1 = require("./entities/mk-type-of-tools-table.entity");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const mktypeoftools_table_return_type_1 = require("./types/mktypeoftools-table-return.type");
const mktypeoftools_table_type_1 = require("./types/mktypeoftools-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_TYPEOFTOOLS_ADD = "NEW_TYPEOFTOOLS_ADD";
let MkTypeOfToolsTableResolver = exports.MkTypeOfToolsTableResolver = class MkTypeOfToolsTableResolver {
    constructor(mkTypeOfToolsTableService, pubSub) {
        this.mkTypeOfToolsTableService = mkTypeOfToolsTableService;
        this.pubSub = pubSub;
    }
    findAllMkTypeOfTools(user) {
        return this.mkTypeOfToolsTableService.findAll();
    }
    getAllMkTypeOfTools(user, mkId) {
        return this.mkTypeOfToolsTableService.findAllByMkId(mkId);
    }
    findOneMkTypeOfTools(mkTypeOfToolsId) {
        return this.mkTypeOfToolsTableService.findOne(mkTypeOfToolsId);
    }
    removeMkTypeOfToolsTable(mkTypeOfToolsId) {
        return this.mkTypeOfToolsTableService.remove(mkTypeOfToolsId);
    }
    mkTypeOfToolsSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_TYPEOFTOOLS_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mktypeoftools_table_type_1.MkTypeOfToolsTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], MkTypeOfToolsTableResolver.prototype, "findAllMkTypeOfTools", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [mktypeoftools_table_type_1.MkTypeOfToolsTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], MkTypeOfToolsTableResolver.prototype, "getAllMkTypeOfTools", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mktypeoftools_table_type_1.MkTypeOfToolsTableType),
    __param(0, (0, graphql_1.Args)('mkTypeOfToolsId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkTypeOfToolsTableResolver.prototype, "findOneMkTypeOfTools", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => mktypeoftools_table_return_type_1.MkTypeOfToolsTableReturnType),
    __param(0, (0, graphql_1.Args)('mkTypeOfToolsId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], MkTypeOfToolsTableResolver.prototype, "removeMkTypeOfToolsTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MkTypeOfToolsTableResolver.prototype, "mkTypeOfToolsSubscription", null);
exports.MkTypeOfToolsTableResolver = MkTypeOfToolsTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => mk_type_of_tools_table_entity_1.MkTypeOfToolsTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mk_type_of_tools_table_service_1.MkTypeOfToolsTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], MkTypeOfToolsTableResolver);
