import { RedisPubSub } from 'graphql-redis-subscriptions';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { Repository } from 'typeorm';
import { CreateMkTypeOfToolsTableInput } from './dto/create-mk-type-of-tools-table.input';
import { UpdateMkTypeOfToolsTableInput } from './dto/update-mk-type-of-tools-table.input';
import { MkTypeOfToolsTable } from './entities/mk-type-of-tools-table.entity';
export declare const NEW_TYPEOFTOOLS_ADD = "NEW_TYPEOFTOOLS_ADD";
export declare class MkTypeOfToolsTableService {
    private readonly mkTypeOfToolsTableRepository;
    private pubSub;
    private readonly mkTableService;
    constructor(mkTypeOfToolsTableRepository: Repository<MkTypeOfToolsTable>, pubSub: RedisPubSub, mkTableService: MkTableService);
    createBulk(createMkTypeOfToolsTableInput: CreateMkTypeOfToolsTableInput[], mkId: number): Promise<any>;
    create(createMkTypeOfToolsTableInput: CreateMkTypeOfToolsTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkTypeOfToolsTable;
    }>;
    checkIfExists(typeOfTools: string, mkId: number): Promise<boolean>;
    findAll(): Promise<MkTypeOfToolsTable[]>;
    findAllByMkId(mkId: number): Promise<MkTypeOfToolsTable[]>;
    findOne(mkTypeOfToolsId: number): Promise<MkTypeOfToolsTable>;
    update(mkTypeOfToolsId: number, updateMkTypeOfToolsTableInput: UpdateMkTypeOfToolsTableInput, mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: MkTypeOfToolsTable;
    }>;
    remove(mkTypeOfToolsId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    removeByMkId(mkId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getTotalTypeOfToolsCount(type: string, stateId: number, districtId: number, blockId: number): Promise<any>;
}
