import { NeutrientRequirementTableService } from './neutrient-requirement-table.service';
import { NeutrientRequirementTable } from './entities/neutrient-requirement-table.entity';
import { CreateNeutrientRequirementTableInput } from './dto/create-neutrient-requirement-table.input';
import { UpdateNeutrientRequirementTableInput } from './dto/update-neutrient-requirement-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { BalancingCalculationInput } from './dto/blancing-calculation.input';
export declare const NEW_NEUTRIENT_ADD = "NEW_NEUTRIENT_ADD";
export declare class NeutrientRequirementTableResolver {
    private readonly neutrientRequirementTableService;
    private pubSub;
    constructor(neutrientRequirementTableService: NeutrientRequirementTableService, pubSub: RedisPubSub);
    createNeutrientRequirementTable(createNeutrientRequirementTableInput: CreateNeutrientRequirementTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllNeutrientRequirmentTable(): Promise<NeutrientRequirementTable[]>;
    findOneNeutrientRequiementTable(neutrientRequirementId: number): Promise<NeutrientRequirementTable>;
    updateNeutrientRequirementTable(updateNeutrientRequirementTableInput: UpdateNeutrientRequirementTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeNeutrientRequirementTable(neutrientRequirementId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    neutrientRequirementSubscription(): AsyncIterator<unknown, any, undefined>;
    getBalacingReportWithInput(balancingCalculationInput: BalancingCalculationInput): Promise<{
        rationData: any;
        data: any;
        sugessions: any;
    }>;
}
