"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NeutrientRequirementTableResolver = exports.NEW_NEUTRIENT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const neutrient_requirement_table_service_1 = require("./neutrient-requirement-table.service");
const neutrient_requirement_table_entity_1 = require("./entities/neutrient-requirement-table.entity");
const create_neutrient_requirement_table_input_1 = require("./dto/create-neutrient-requirement-table.input");
const update_neutrient_requirement_table_input_1 = require("./dto/update-neutrient-requirement-table.input");
const neutrient_requirement_table_return_type_1 = require("./types/neutrient-requirement-table-return.type");
const neutrient_requirement_table_table_type_1 = require("./types/neutrient-requirement-table-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const neutrient_requirement_count_change_type_1 = require("./types/neutrient-requirement-count-change.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const neutrient_requirement_suggession_type_1 = require("./types/neutrient-requirement-suggession.type");
const blancing_calculation_input_1 = require("./dto/blancing-calculation.input");
exports.NEW_NEUTRIENT_ADD = "NEW_NEUTRIENT_ADD";
let NeutrientRequirementTableResolver = class NeutrientRequirementTableResolver {
    constructor(neutrientRequirementTableService, pubSub) {
        this.neutrientRequirementTableService = neutrientRequirementTableService;
        this.pubSub = pubSub;
    }
    createNeutrientRequirementTable(createNeutrientRequirementTableInput) {
        return this.neutrientRequirementTableService.create(createNeutrientRequirementTableInput);
    }
    findAllNeutrientRequirmentTable() {
        return this.neutrientRequirementTableService.findAll();
    }
    findOneNeutrientRequiementTable(neutrientRequirementId) {
        return this.neutrientRequirementTableService.findOne(neutrientRequirementId);
    }
    updateNeutrientRequirementTable(updateNeutrientRequirementTableInput) {
        return this.neutrientRequirementTableService.update(updateNeutrientRequirementTableInput.neutrientRequirementId, updateNeutrientRequirementTableInput);
    }
    removeNeutrientRequirementTable(neutrientRequirementId) {
        return this.neutrientRequirementTableService.remove(neutrientRequirementId);
    }
    neutrientRequirementSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_NEUTRIENT_ADD);
    }
    getBalacingReportWithInput(balancingCalculationInput) {
        return this.neutrientRequirementTableService.getBalacingReportWithInput(balancingCalculationInput);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => neutrient_requirement_table_return_type_1.NeutrientRequiementTableReturnType),
    __param(0, (0, graphql_1.Args)('createNeutrientRequirementTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_neutrient_requirement_table_input_1.CreateNeutrientRequirementTableInput]),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "createNeutrientRequirementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [neutrient_requirement_table_table_type_1.NeutrientRequirementTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "findAllNeutrientRequirmentTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => neutrient_requirement_table_table_type_1.NeutrientRequirementTableType),
    __param(0, (0, graphql_1.Args)('neutrientRequirementId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "findOneNeutrientRequiementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => neutrient_requirement_table_return_type_1.NeutrientRequiementTableReturnType),
    __param(0, (0, graphql_1.Args)('updateNeutrientRequirementTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_neutrient_requirement_table_input_1.UpdateNeutrientRequirementTableInput]),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "updateNeutrientRequirementTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => neutrient_requirement_table_return_type_1.NeutrientRequiementTableReturnType),
    __param(0, (0, graphql_1.Args)('neutrientRequirementId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "removeNeutrientRequirementTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => neutrient_requirement_count_change_type_1.NeutrientRequirementCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "neutrientRequirementSubscription", null);
__decorate([
    (0, graphql_1.Query)(() => neutrient_requirement_suggession_type_1.NeutrientRequiementSugessionType),
    __param(0, (0, graphql_1.Args)('balancingCalculationInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [blancing_calculation_input_1.BalancingCalculationInput]),
    __metadata("design:returntype", void 0)
], NeutrientRequirementTableResolver.prototype, "getBalacingReportWithInput", null);
NeutrientRequirementTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => neutrient_requirement_table_entity_1.NeutrientRequirementTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [neutrient_requirement_table_service_1.NeutrientRequirementTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], NeutrientRequirementTableResolver);
exports.NeutrientRequirementTableResolver = NeutrientRequirementTableResolver;
