import { RedisPubSub } from 'graphql-redis-subscriptions';
import { IngredientTableService } from 'src/ingredient-table/ingredient-table.service';
import { RationTableService } from 'src/ration-table/ration-table.service';
import { Repository } from 'typeorm';
import { BalancingCalculationInput } from './dto/blancing-calculation.input';
import { CreateNeutrientRequirementTableInput } from './dto/create-neutrient-requirement-table.input';
import { UpdateNeutrientRequirementTableInput } from './dto/update-neutrient-requirement-table.input';
import { NeutrientRequirementTable } from './entities/neutrient-requirement-table.entity';
export declare const NEW_NEUTRIENT_ADD = "NEW_NEUTRIENT_ADD";
export declare class NeutrientRequirementTableService {
    private readonly neutrientRequirementTableRepository;
    private readonly ingredientTableService;
    private readonly rationTableService;
    private pubSub;
    constructor(neutrientRequirementTableRepository: Repository<NeutrientRequirementTable>, ingredientTableService: IngredientTableService, rationTableService: RationTableService, pubSub: RedisPubSub);
    create(createNeutrientRequirementTableInput: CreateNeutrientRequirementTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(createNeutrientRequirementTableInput: CreateNeutrientRequirementTableInput): Promise<boolean>;
    findAll(): Promise<NeutrientRequirementTable[]>;
    findOne(neutrientRequirementId: number): Promise<NeutrientRequirementTable>;
    update(neutrientRequirementId: number, updateNeutrientRequirementTableInput: UpdateNeutrientRequirementTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(neutrientRequirementId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getBalacingReportWithInput(balancingCalculationInput: BalancingCalculationInput): Promise<{
        rationData: any;
        data: any;
        sugessions: any;
    }>;
}
