"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NeutrientRequirementTableService = exports.NEW_NEUTRIENT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const ingredient_table_entity_1 = require("../ingredient-table/entities/ingredient-table.entity");
const ingredient_table_service_1 = require("../ingredient-table/ingredient-table.service");
const ration_table_service_1 = require("../ration-table/ration-table.service");
const typeorm_2 = require("typeorm");
const neutrient_requirement_table_entity_1 = require("./entities/neutrient-requirement-table.entity");
exports.NEW_NEUTRIENT_ADD = "NEW_NEUTRIENT_ADD";
let NeutrientRequirementTableService = class NeutrientRequirementTableService {
    constructor(neutrientRequirementTableRepository, ingredientTableService, rationTableService, pubSub) {
        this.neutrientRequirementTableRepository = neutrientRequirementTableRepository;
        this.ingredientTableService = ingredientTableService;
        this.rationTableService = rationTableService;
        this.pubSub = pubSub;
    }
    async create(createNeutrientRequirementTableInput) {
        let checkIfExists = await this.checkIfExists(createNeutrientRequirementTableInput);
        if (!checkIfExists) {
            let nrt = new neutrient_requirement_table_entity_1.NeutrientRequirementTable();
            nrt.value = createNeutrientRequirementTableInput.value;
            nrt.startingAge = createNeutrientRequirementTableInput.startingAge;
            nrt.endingAge = createNeutrientRequirementTableInput.endingAge;
            let ing = await this.ingredientTableService.findOne(createNeutrientRequirementTableInput.ingredientId);
            nrt.IngredientTable = ing;
            await this.neutrientRequirementTableRepository.save(nrt);
            this.pubSub.publish(exports.NEW_NEUTRIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully added"
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfExists(createNeutrientRequirementTableInput) {
        let result = await this.neutrientRequirementTableRepository.findOne({
            where: {
                IngredientTable: {
                    ingredientId: createNeutrientRequirementTableInput.ingredientId
                },
                value: createNeutrientRequirementTableInput.value,
                startingAge: createNeutrientRequirementTableInput.startingAge,
                endingAge: createNeutrientRequirementTableInput.endingAge
            }
        });
        if (result) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAll() {
        return await this.neutrientRequirementTableRepository.find({
            relations: {
                IngredientTable: true
            }
        });
    }
    async findOne(neutrientRequirementId) {
        return await this.neutrientRequirementTableRepository.findOne({
            where: {
                neutrientRequirementId: neutrientRequirementId
            },
            relations: {
                IngredientTable: true
            }
        });
    }
    async update(neutrientRequirementId, updateNeutrientRequirementTableInput) {
        let res = await this.neutrientRequirementTableRepository.findOne({
            where: {
                neutrientRequirementId: neutrientRequirementId
            }
        });
        if (res) {
            res.value = updateNeutrientRequirementTableInput.value;
            res.startingAge = updateNeutrientRequirementTableInput.startingAge;
            res.endingAge = updateNeutrientRequirementTableInput.endingAge;
            let ing = await this.ingredientTableService.findOne(updateNeutrientRequirementTableInput.ingredientId);
            res.IngredientTable = ing;
            await this.neutrientRequirementTableRepository.save(res);
            this.pubSub.publish(exports.NEW_NEUTRIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(neutrientRequirementId) {
        let res = await this.neutrientRequirementTableRepository.findOne({
            where: {
                neutrientRequirementId: neutrientRequirementId
            }
        });
        if (res) {
            await this.neutrientRequirementTableRepository.remove(res);
            this.pubSub.publish(exports.NEW_NEUTRIENT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async getBalacingReportWithInput(balancingCalculationInput) {
        let data = [];
        let rationData = [];
        const suggessions = [];
        for (const el1 of balancingCalculationInput.rationDetails) {
            let rationDetails = await this.rationTableService.findOne(el1.rationId);
            rationData.push(rationDetails);
            for (const el2 of rationDetails.RationSubTable) {
                let result = await this.neutrientRequirementTableRepository.createQueryBuilder("r")
                    .leftJoinAndMapOne("r.IngredientTable", ingredient_table_entity_1.IngredientTable, "ml2", "ml2.ingredientId=r.ingredientId")
                    .where("convert(r.startingAge, signed integer) < convert(:givenAge, signed integer) AND convert(r.endingAge, signed integer) >= convert(:givenAge1, signed integer)", { givenAge: balancingCalculationInput.age, givenAge1: balancingCalculationInput.age })
                    .andWhere("r.ingredientId=:ingredientId", { ingredientId: el2.IngredientTable.ingredientId })
                    .getOne();
                let defi1 = 0;
                let extra1 = 0;
                if (parseFloat(result.value) > parseFloat(el2.value)) {
                    defi1 = parseFloat(result.value) - parseFloat(el2.value);
                }
                else {
                    extra1 = parseFloat(el2.value) - parseFloat(result.value);
                }
                let gvv = 0;
                if (el2.IngredientTable.ingredientId != 2) {
                    gvv = (parseFloat(el2.value)).toFixed(3);
                }
                else {
                    gvv = ((parseFloat(el2.value) * parseFloat(el1.rationTotal)) / (parseFloat(balancingCalculationInput.qty))).toFixed(3);
                }
                let b = {
                    IngredientTable: result.IngredientTable,
                    standardValue: result.value,
                    givenValue: gvv,
                    deficiency: defi1.toFixed(3),
                    extra: extra1.toFixed(3)
                };
                let d1 = data.findIndex((el31) => { var _a; return ((_a = el31.IngredientTable) === null || _a === void 0 ? void 0 : _a.ingredientId) === result.IngredientTable.ingredientId; });
                if (d1 != -1) {
                    let newGivenValue = parseFloat(data[d1].givenValue) + parseFloat(b.givenValue);
                    data[d1]['givenValue'] = newGivenValue.toFixed(3);
                    let deficiency = 0;
                    let extra = 0;
                    if (parseFloat(result.value) > newGivenValue) {
                        deficiency = parseFloat(result.value) - newGivenValue;
                    }
                    else {
                        extra = newGivenValue - parseFloat(result.value);
                    }
                    data[d1]['deficiency'] = deficiency.toFixed(3);
                    data[d1]['extra'] = extra.toFixed(3);
                }
                else {
                    data.push(b);
                }
            }
        }
        for (const el45 of data) {
            if (parseFloat(el45.deficiency) > 0) {
                suggessions.push(`There is a deficiency of ${el45.IngredientTable.ingredientName} by ${el45.deficiency}${el45.IngredientTable.ingredientUnit}`);
            }
            if (parseFloat(el45.extra) > 0) {
                suggessions.push(`There is an excess of ${el45.IngredientTable.ingredientName} by ${el45.extra}${el45.IngredientTable.ingredientUnit}`);
            }
        }
        return {
            rationData: rationData,
            data: data,
            sugessions: suggessions
        };
    }
};
NeutrientRequirementTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(neutrient_requirement_table_entity_1.NeutrientRequirementTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => ingredient_table_service_1.IngredientTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => ration_table_service_1.RationTableService))),
    __param(3, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        ingredient_table_service_1.IngredientTableService,
        ration_table_service_1.RationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], NeutrientRequirementTableService);
exports.NeutrientRequirementTableService = NeutrientRequirementTableService;
