import { NotificationTableService } from './notification-table.service';
import { NotificationTable } from './entities/notification-table.entity';
import { CreateNotificationTableInput } from './dto/create-notification-table.input';
import { UpdateNotificationTableInput } from './dto/update-notification-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_NOTIFICATION_ADD = "NEW_NOTIFICATION_ADD";
export declare class NotificationTableResolver {
    private readonly notificationTableService;
    private pubSub;
    constructor(notificationTableService: NotificationTableService, pubSub: RedisPubSub);
    createNotificationTable(createNotificationTableInput: CreateNotificationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllNotifications(): Promise<NotificationTable[]>;
    updateNotificationTable(updateNotificationTableInput: UpdateNotificationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    removeNotificationTable(notificationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    notificationSubscription(): AsyncIterator<unknown, any, undefined>;
}
