"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationTableResolver = exports.NEW_NOTIFICATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const notification_table_service_1 = require("./notification-table.service");
const notification_table_entity_1 = require("./entities/notification-table.entity");
const create_notification_table_input_1 = require("./dto/create-notification-table.input");
const update_notification_table_input_1 = require("./dto/update-notification-table.input");
const notification_table_type_1 = require("./types/notification-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const notification_table_return_type_1 = require("./types/notification-table-return-type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const new_notification_add_type_1 = require("./types/new-notification-add.type");
exports.NEW_NOTIFICATION_ADD = "NEW_NOTIFICATION_ADD";
let NotificationTableResolver = exports.NotificationTableResolver = class NotificationTableResolver {
    constructor(notificationTableService, pubSub) {
        this.notificationTableService = notificationTableService;
        this.pubSub = pubSub;
    }
    createNotificationTable(createNotificationTableInput) {
        return this.notificationTableService.addNew(createNotificationTableInput);
    }
    findAllNotifications() {
        return this.notificationTableService.getAllActive();
    }
    updateNotificationTable(updateNotificationTableInput) {
        return this.notificationTableService.updateTable(updateNotificationTableInput.notificationId, updateNotificationTableInput);
    }
    removeNotificationTable(notificationId) {
        return this.notificationTableService.deleteTable(notificationId);
    }
    notificationSubscription() {
        console.log('Async Iterator Called');
        return this.pubSub.asyncIterator(exports.NEW_NOTIFICATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => notification_table_return_type_1.NotificationTableReturnType),
    __param(0, (0, graphql_1.Args)('createNotificationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_notification_table_input_1.CreateNotificationTableInput]),
    __metadata("design:returntype", void 0)
], NotificationTableResolver.prototype, "createNotificationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [notification_table_type_1.NotificationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NotificationTableResolver.prototype, "findAllNotifications", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => notification_table_return_type_1.NotificationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateNotificationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_notification_table_input_1.UpdateNotificationTableInput]),
    __metadata("design:returntype", void 0)
], NotificationTableResolver.prototype, "updateNotificationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => notification_table_return_type_1.NotificationTableReturnType),
    __param(0, (0, graphql_1.Args)('notificationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], NotificationTableResolver.prototype, "removeNotificationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_notification_add_type_1.NewNotificationAdd, {
        resolve: (payload) => {
            return payload;
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], NotificationTableResolver.prototype, "notificationSubscription", null);
exports.NotificationTableResolver = NotificationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => notification_table_entity_1.NotificationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [notification_table_service_1.NotificationTableService, graphql_redis_subscriptions_1.RedisPubSub])
], NotificationTableResolver);
