import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateNotificationTableInput } from './dto/create-notification-table.input';
import { UpdateNotificationTableInput } from './dto/update-notification-table.input';
import { NotificationTable } from './entities/notification-table.entity';
export declare const NEW_NOTIFICATION_ADD = "NEW_NOTIFICATION_ADD";
export declare class NotificationTableService {
    private readonly notificationTableRepository;
    private pubSub;
    constructor(notificationTableRepository: Repository<NotificationTable>, pubSub: RedisPubSub);
    addNew(createTestTableDto: CreateNotificationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfExists(createTestTableDto: CreateNotificationTableInput): Promise<boolean>;
    getAll(): Promise<NotificationTable[]>;
    getAllActive(): Promise<NotificationTable[]>;
    getById(notificationId: number): Promise<NotificationTable>;
    updateTable(notificationId: number, createTestTableDto: UpdateNotificationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    toggleServiceStatus(notificationId: number, newStatus: boolean): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    deleteTable(notificationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: NotificationTable;
    } | {
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
}
