"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationTableService = exports.NEW_NOTIFICATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const moment_1 = __importDefault(require("moment"));
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const notification_table_entity_1 = require("./entities/notification-table.entity");
exports.NEW_NOTIFICATION_ADD = "NEW_NOTIFICATION_ADD";
let NotificationTableService = exports.NotificationTableService = class NotificationTableService {
    constructor(notificationTableRepository, pubSub) {
        this.notificationTableRepository = notificationTableRepository;
        this.pubSub = pubSub;
    }
    async addNew(createTestTableDto) {
        let checkIfExists = await this.checkIfExists(createTestTableDto);
        if (!checkIfExists) {
            let lt = new notification_table_entity_1.NotificationTable();
            lt.title = createTestTableDto.title;
            lt.description = createTestTableDto.description;
            lt.link = createTestTableDto.link;
            lt.date = (0, moment_1.default)().format('DD-MM-YYYY');
            lt.status = 1;
            let result = await this.notificationTableRepository.save(lt);
            this.pubSub.publish(exports.NEW_NOTIFICATION_ADD, {
                title: result.title,
                message: result.description
            });
            return {
                status: true,
                status_text: "Successfully created",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already exist"
            };
        }
    }
    async checkIfExists(createTestTableDto) {
        let result = await this.notificationTableRepository.findOne({
            where: {
                title: createTestTableDto.title,
            }
        });
        if (result !== null && result !== undefined) {
            return true;
        }
        else {
            return false;
        }
    }
    async getAll() {
        return await this.notificationTableRepository.find();
    }
    async getAllActive() {
        let result = await this.notificationTableRepository.find({
            where: {
                status: 1
            },
            order: {
                notificationId: 'DESC'
            }
        });
        console.log("🚀 ~ file: notification-table.service.ts ~ line 77 ~ NotificationTableService ~ getAllActive ~ result", result);
        return result;
    }
    async getById(notificationId) {
        return await this.notificationTableRepository.findOne({
            where: {
                notificationId
            }
        });
    }
    async updateTable(notificationId, createTestTableDto) {
        let em = await this.notificationTableRepository.findOne({
            where: {
                notificationId
            }
        });
        if (em != null && em != undefined) {
            em.title = createTestTableDto.title;
            em.description = createTestTableDto.description;
            em.link = createTestTableDto.link;
            let result = await this.notificationTableRepository.save(em);
            this.pubSub.publish(exports.NEW_NOTIFICATION_ADD, { title: null });
            return {
                status: true,
                status_text: "Updated Successfully",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Test not found",
                data: false
            };
        }
    }
    async toggleServiceStatus(notificationId, newStatus) {
        let em = await this.notificationTableRepository.findOne({
            where: {
                notificationId
            }
        });
        if (em != null && em != undefined) {
            em.status = newStatus ? 1 : 0;
            let result = await this.notificationTableRepository.save(em);
            return {
                status: true,
                status_text: "Updated Successfully",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Test not found",
                data: false
            };
        }
    }
    async deleteTable(notificationId) {
        let em = await this.notificationTableRepository.findOne({
            where: {
                notificationId
            }
        });
        if (em != null && em != undefined) {
            let result = await this.notificationTableRepository.remove(em);
            this.pubSub.publish(exports.NEW_NOTIFICATION_ADD, { title: null });
            return {
                status: true,
                status_text: 'Successfully deleted',
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "not found",
                data: false
            };
        }
    }
};
exports.NotificationTableService = NotificationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(notification_table_entity_1.NotificationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], NotificationTableService);
