import { OrganicMethodMasterService } from './organic-method-master.service';
import { OrganicMethodMaster } from './entities/organic-method-master.entity';
import { CreateOrganicMethodMasterInput } from './dto/create-organic-method-master.input';
import { UpdateOrganicMethodMasterInput } from './dto/update-organic-method-master.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ORGANIC_METHOD_ADD = "NEW_ORGANIC_METHOD_ADD";
export declare class OrganicMethodMasterResolver {
    private readonly organicMethodMasterService;
    private pubSub;
    constructor(organicMethodMasterService: OrganicMethodMasterService, pubSub: RedisPubSub);
    createOrganicMethodMaster(createOrganicMethodMasterInput: CreateOrganicMethodMasterInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganicMethodMaster;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllOrganicMethods(): Promise<OrganicMethodMaster[]>;
    findOne(organicMethodId: number): Promise<OrganicMethodMaster>;
    updateOrganicMethodMaster(updateOrganicMethodMasterInput: UpdateOrganicMethodMasterInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganicMethodMaster;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeOrganicMethodMaster(organicMethodId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    organicMethodSubscription(): AsyncIterator<unknown, any, undefined>;
}
