"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganicMethodMasterResolver = exports.NEW_ORGANIC_METHOD_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const organic_method_master_service_1 = require("./organic-method-master.service");
const organic_method_master_entity_1 = require("./entities/organic-method-master.entity");
const create_organic_method_master_input_1 = require("./dto/create-organic-method-master.input");
const update_organic_method_master_input_1 = require("./dto/update-organic-method-master.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const organic_method_master_return_type_1 = require("./types/organic-method-master-return.type");
const organic_method_master_type_1 = require("./types/organic-method-master.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_ORGANIC_METHOD_ADD = "NEW_ORGANIC_METHOD_ADD";
let OrganicMethodMasterResolver = exports.OrganicMethodMasterResolver = class OrganicMethodMasterResolver {
    constructor(organicMethodMasterService, pubSub) {
        this.organicMethodMasterService = organicMethodMasterService;
        this.pubSub = pubSub;
    }
    createOrganicMethodMaster(createOrganicMethodMasterInput) {
        return this.organicMethodMasterService.create(createOrganicMethodMasterInput);
    }
    findAllOrganicMethods() {
        return this.organicMethodMasterService.findAll();
    }
    findOne(organicMethodId) {
        return this.organicMethodMasterService.findOne(organicMethodId);
    }
    updateOrganicMethodMaster(updateOrganicMethodMasterInput) {
        return this.organicMethodMasterService.update(updateOrganicMethodMasterInput.organicMethodId, updateOrganicMethodMasterInput);
    }
    removeOrganicMethodMaster(organicMethodId) {
        return this.organicMethodMasterService.remove(organicMethodId);
    }
    organicMethodSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_ORGANIC_METHOD_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organic_method_master_return_type_1.OrganicMethodMasterReturnType),
    __param(0, (0, graphql_1.Args)('createOrganicMethodMasterInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_organic_method_master_input_1.CreateOrganicMethodMasterInput]),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "createOrganicMethodMaster", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [organic_method_master_type_1.OrganicMethodMasterType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "findAllOrganicMethods", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => organic_method_master_type_1.OrganicMethodMasterType),
    __param(0, (0, graphql_1.Args)('organicMethodId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organic_method_master_return_type_1.OrganicMethodMasterReturnType),
    __param(0, (0, graphql_1.Args)('updateOrganicMethodMasterInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_organic_method_master_input_1.UpdateOrganicMethodMasterInput]),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "updateOrganicMethodMaster", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organic_method_master_return_type_1.OrganicMethodMasterReturnType),
    __param(0, (0, graphql_1.Args)('organicMethodId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "removeOrganicMethodMaster", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], OrganicMethodMasterResolver.prototype, "organicMethodSubscription", null);
exports.OrganicMethodMasterResolver = OrganicMethodMasterResolver = __decorate([
    (0, graphql_1.Resolver)(() => organic_method_master_entity_1.OrganicMethodMaster),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [organic_method_master_service_1.OrganicMethodMasterService,
        graphql_redis_subscriptions_1.RedisPubSub])
], OrganicMethodMasterResolver);
