import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateOrganicMethodMasterInput } from './dto/create-organic-method-master.input';
import { UpdateOrganicMethodMasterInput } from './dto/update-organic-method-master.input';
import { OrganicMethodMaster } from './entities/organic-method-master.entity';
export declare const NEW_ORGANIC_METHOD_ADD = "NEW_ORGANIC_METHOD_ADD";
export declare class OrganicMethodMasterService {
    private readonly organicMethodRepository;
    private pubSub;
    constructor(organicMethodRepository: Repository<OrganicMethodMaster>, pubSub: RedisPubSub);
    create(createOrganicMethodMasterInput: CreateOrganicMethodMasterInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganicMethodMaster;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createOrganicMethodMasterInput: CreateOrganicMethodMasterInput): Promise<number>;
    findAll(): Promise<OrganicMethodMaster[]>;
    findOne(organicMethodId: number): Promise<OrganicMethodMaster>;
    update(organicMethodId: number, updateOrganicMethodMasterInput: UpdateOrganicMethodMasterInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganicMethodMaster;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(organicMethodId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
