import { OrganisationTableService } from './organisation-table.service';
import { OrganisationTable } from './entities/organisation-table.entity';
import { CreateOrganisationTableInput } from './dto/create-organisation-table.input';
import { UpdateOrganisationTableInput } from './dto/update-organisation-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ORGANISATION_ADD = "NEW_ORGANISATION_ADD";
export declare class OrganisationTableResolver {
    private readonly organisationTableService;
    private pubSub;
    constructor(organisationTableService: OrganisationTableService, pubSub: RedisPubSub);
    createOrganisationTable(createOrganisationTableInput: CreateOrganisationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganisationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllOrganisations(): Promise<OrganisationTable[]>;
    findOneOrganisation(organisationId: number): Promise<any>;
    updateOrganisationTable(updateOrganisationTableInput: UpdateOrganisationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeOrganisationTable(organisationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    organisationSubscription(): AsyncIterator<unknown, any, undefined>;
}
