"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganisationTableResolver = exports.NEW_ORGANISATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const organisation_table_service_1 = require("./organisation-table.service");
const organisation_table_entity_1 = require("./entities/organisation-table.entity");
const create_organisation_table_input_1 = require("./dto/create-organisation-table.input");
const update_organisation_table_input_1 = require("./dto/update-organisation-table.input");
const organisation_table_return_type_1 = require("./types/organisation-table-return.type");
const organisation_table_type_1 = require("./types/organisation-table.type");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const count_changed_type_1 = require("../types/count-changed.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_ORGANISATION_ADD = "NEW_ORGANISATION_ADD";
let OrganisationTableResolver = exports.OrganisationTableResolver = class OrganisationTableResolver {
    constructor(organisationTableService, pubSub) {
        this.organisationTableService = organisationTableService;
        this.pubSub = pubSub;
    }
    createOrganisationTable(createOrganisationTableInput) {
        return this.organisationTableService.create(createOrganisationTableInput);
    }
    findAllOrganisations() {
        return this.organisationTableService.findAll();
    }
    findOneOrganisation(organisationId) {
        return this.organisationTableService.findOne(organisationId);
    }
    updateOrganisationTable(updateOrganisationTableInput) {
        return this.organisationTableService.update(updateOrganisationTableInput.organisationId, updateOrganisationTableInput);
    }
    removeOrganisationTable(organisationId) {
        return this.organisationTableService.remove(organisationId);
    }
    organisationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_ORGANISATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organisation_table_return_type_1.OrganisationTableReturnType),
    __param(0, (0, graphql_1.Args)('createOrganisationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_organisation_table_input_1.CreateOrganisationTableInput]),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "createOrganisationTable", null);
__decorate([
    (0, graphql_1.Query)(() => [organisation_table_type_1.OrganisationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "findAllOrganisations", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => organisation_table_type_1.OrganisationTableType),
    __param(0, (0, graphql_1.Args)('organisationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "findOneOrganisation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organisation_table_return_type_1.OrganisationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateOrganisationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_organisation_table_input_1.UpdateOrganisationTableInput]),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "updateOrganisationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => organisation_table_return_type_1.OrganisationTableReturnType),
    __param(0, (0, graphql_1.Args)('organisationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "removeOrganisationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], OrganisationTableResolver.prototype, "organisationSubscription", null);
exports.OrganisationTableResolver = OrganisationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => organisation_table_entity_1.OrganisationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [organisation_table_service_1.OrganisationTableService, graphql_redis_subscriptions_1.RedisPubSub])
], OrganisationTableResolver);
