import { CreateOrganisationTableInput } from './dto/create-organisation-table.input';
import { UpdateOrganisationTableInput } from './dto/update-organisation-table.input';
import { OrganisationTable } from './entities/organisation-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_ORGANISATION_ADD = "NEW_ORGANISATION_ADD";
export declare class OrganisationTableService {
    private readonly OrganisationTableRepository;
    private pubSub;
    constructor(OrganisationTableRepository: Repository<OrganisationTable>, pubSub: RedisPubSub);
    create(createOrganisationTableInput: CreateOrganisationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: OrganisationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createOrganisationTableInput: CreateOrganisationTableInput): Promise<number>;
    findAll(): Promise<OrganisationTable[]>;
    findOne(organisationId: number): Promise<any>;
    update(organisationId: number, updateOrganisationTableInput: UpdateOrganisationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(organisationId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
