"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrganisationTableService = exports.NEW_ORGANISATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const organisation_table_entity_1 = require("./entities/organisation-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_ORGANISATION_ADD = "NEW_ORGANISATION_ADD";
let OrganisationTableService = exports.OrganisationTableService = class OrganisationTableService {
    constructor(OrganisationTableRepository, pubSub) {
        this.OrganisationTableRepository = OrganisationTableRepository;
        this.pubSub = pubSub;
    }
    async create(createOrganisationTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createOrganisationTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new organisation_table_entity_1.OrganisationTable();
            st.organisationName = createOrganisationTableInput.organisationName;
            st.organisationCode = createOrganisationTableInput.organisationCode;
            st.organisationAddress = createOrganisationTableInput.organisationAddress;
            st.isOwn = createOrganisationTableInput.isOwn;
            let result = await this.OrganisationTableRepository.save(st);
            this.pubSub.publish(exports.NEW_ORGANISATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createOrganisationTableInput) {
        let result = await this.OrganisationTableRepository.count({
            where: {
                organisationCode: createOrganisationTableInput.organisationCode,
            }
        });
        return result;
    }
    async findAll() {
        let result = await this.OrganisationTableRepository.find();
        return result;
    }
    async findOne(organisationId) {
        let result = await this.OrganisationTableRepository.findOne({
            where: {
                organisationId
            }
        });
        return result;
    }
    async update(organisationId, updateOrganisationTableInput) {
        let result = await this.findOne(organisationId);
        if (result) {
            result.organisationName = updateOrganisationTableInput.organisationName;
            result.organisationCode = updateOrganisationTableInput.organisationCode;
            result.organisationAddress = updateOrganisationTableInput.organisationAddress;
            result.isOwn = updateOrganisationTableInput.isOwn;
            let updatedResult = await this.OrganisationTableRepository.save(result);
            this.pubSub.publish(exports.NEW_ORGANISATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(organisationId) {
        let result = await this.findOne(organisationId);
        if (result) {
            await this.OrganisationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_ORGANISATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.OrganisationTableService = OrganisationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(organisation_table_entity_1.OrganisationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], OrganisationTableService);
