import { OtpTable } from './otp-table.entity';
import { Repository } from 'typeorm';
import { MailService } from 'src/mail/mail.service';
export declare class OtpTableService {
    private readonly otpTableRepository;
    private otpGenerator;
    private readonly mailService;
    constructor(otpTableRepository: Repository<OtpTable>, otpGenerator: any, mailService: MailService);
    generateOtpNow(phone: string, employeeName: string, email: string): Promise<{
        status: boolean;
        status_text: string;
        data: boolean;
        otp: string;
    }>;
    checkOtp(phone: string, otp: string): Promise<{
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    getOtpViaPhone(phone: string): Promise<false | OtpTable>;
    generateOtp(): Promise<string>;
}
