"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OtpTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const otp_table_entity_1 = require("./otp-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const mail_service_1 = require("../mail/mail.service");
let OtpTableService = exports.OtpTableService = class OtpTableService {
    constructor(otpTableRepository, otpGenerator, mailService) {
        this.otpTableRepository = otpTableRepository;
        this.otpGenerator = otpGenerator;
        this.mailService = mailService;
    }
    async generateOtpNow(phone, employeeName, email) {
        let result = await this.getOtpViaPhone(phone);
        let otp = await this.generateOtp();
        if (result === false) {
            let otpTable = new otp_table_entity_1.OtpTable();
            otpTable.otp = otp;
            otpTable.phone = phone;
            let res = await this.otpTableRepository.save(otpTable);
            this.mailService.forgotPasswordOTp({
                toEmail: email,
                otp,
                name: employeeName
            });
            let firstPart = email.split('@')[0];
            var last = email.substr(firstPart.length - 2);
            var first = email.substring(0, 2);
            return {
                status: true,
                status_text: `An otp has been sent to your email ending with: ${first}***${last}`,
                data: false,
                otp: ''
            };
        }
        else {
            result.otp = otp;
            let res = await this.otpTableRepository.save(result);
            this.mailService.forgotPasswordOTp({
                toEmail: email,
                otp,
                name: employeeName
            });
            let firstPart = email.split('@')[0];
            var last = email.substr(firstPart.length - 2);
            var first = email.substring(0, 2);
            return {
                status: true,
                status_text: `An otp has been sent to your email ending with: ${first}*****${last}`,
                data: false,
                otp: ''
            };
        }
    }
    async checkOtp(phone, otp) {
        let result = await this.otpTableRepository.findOne({
            where: {
                phone,
                otp
            }
        });
        if (result === null || result === undefined) {
            return {
                status: false,
                status_text: 'OTP doesnot match. Try again',
                data: false
            };
        }
        else {
            return {
                status: true,
                status_text: 'Enter new password now',
                data: false
            };
        }
    }
    async getOtpViaPhone(phone) {
        let result = await this.otpTableRepository.findOne({
            where: {
                phone
            }
        });
        if (result === null || result === undefined) {
            return false;
        }
        else {
            return result;
        }
    }
    async generateOtp() {
        var digits = '0123456789';
        let OTP = '';
        for (let i = 0; i < 6; i++) {
            OTP += digits[Math.floor(Math.random() * 10)];
        }
        return OTP;
    }
};
exports.OtpTableService = OtpTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(otp_table_entity_1.OtpTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.OTP_GENERATOR)),
    __metadata("design:paramtypes", [typeorm_2.Repository, Object, mail_service_1.MailService])
], OtpTableService);
