import { PackCollectionService } from './pack-collection.service';
import { PackCollection } from './entities/pack-collection.entity';
import { CreatePackCollectionInput } from './dto/create-pack-collection.input';
import { UpdatePackCollectionInput } from './dto/update-pack-collection.input';
import { CreatePackCollectionUserInput } from './dto/create-pack-collection-user.input';
export declare class PackCollectionResolver {
    private readonly packCollectionService;
    constructor(packCollectionService: PackCollectionService);
    createPackCollection(user: any, createPackCollectionInput: CreatePackCollectionInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createPackCollectionUser(user: any, createPackCollectionUserInput: CreatePackCollectionUserInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    addItemToThePack(user: any, id: string, productId: string, size: string, qty: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAllPacks(): Promise<(PackCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    updatePackCollection(updatePackCollectionInput: UpdatePackCollectionInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updatePackByUsersMutation(updatePackCollectionInput: UpdatePackCollectionInput, user: any, id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    deletePackByUserMutation(user: any, id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    deleteItemFromPackByUserMutation(user: any, id: string, productId: string, size: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removePackCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getPackForClient(user: any): Promise<(PackCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
}
