"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PackCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const pack_collection_service_1 = require("./pack-collection.service");
const pack_collection_entity_1 = require("./entities/pack-collection.entity");
const create_pack_collection_input_1 = require("./dto/create-pack-collection.input");
const update_pack_collection_input_1 = require("./dto/update-pack-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const pack_collection_create_type_1 = require("./types/pack-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const pack_collection_type_1 = require("./types/pack-collection.type");
const create_pack_collection_user_input_1 = require("./dto/create-pack-collection-user.input");
let PackCollectionResolver = class PackCollectionResolver {
    constructor(packCollectionService) {
        this.packCollectionService = packCollectionService;
    }
    createPackCollection(user, createPackCollectionInput) {
        return this.packCollectionService.create(createPackCollectionInput, user.username);
    }
    createPackCollectionUser(user, createPackCollectionUserInput) {
        return this.packCollectionService.createUser(createPackCollectionUserInput, user.username);
    }
    addItemToThePack(user, id, productId, size, qty) {
        return this.packCollectionService.addItemToThePack(id, productId, size, qty, user.username);
    }
    findAllPacks() {
        return this.packCollectionService.findAll();
    }
    updatePackCollection(updatePackCollectionInput, user) {
        return this.packCollectionService.update(updatePackCollectionInput.id, updatePackCollectionInput, user.username);
    }
    updatePackByUsersMutation(updatePackCollectionInput, user, id) {
        return this.packCollectionService.updateByUser(id, updatePackCollectionInput, user.username);
    }
    deletePackByUserMutation(user, id) {
        return this.packCollectionService.removePackByUser(id, user.username);
    }
    deleteItemFromPackByUserMutation(user, id, productId, size) {
        return this.packCollectionService.removeItemFromPack(id, productId, size, user.username);
    }
    removePackCollection(id) {
        return this.packCollectionService.remove(id);
    }
    getPackForClient(user) {
        return this.packCollectionService.findAllWithUsername(user.username);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createPackCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_pack_collection_input_1.CreatePackCollectionInput]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "createPackCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createPackCollectionUserInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_pack_collection_user_input_1.CreatePackCollectionUserInput]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "createPackCollectionUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('id')),
    __param(2, (0, graphql_1.Args)('productId')),
    __param(3, (0, graphql_1.Args)('size')),
    __param(4, (0, graphql_1.Args)('qty')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, String, String, Number]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "addItemToThePack", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pack_collection_type_1.PackCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "findAllPacks", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updatePackCollectionInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_pack_collection_input_1.UpdatePackCollectionInput, Object]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "updatePackCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updatePackCollectionInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __param(2, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_pack_collection_input_1.UpdatePackCollectionInput, Object, String]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "updatePackByUsersMutation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "deletePackByUserMutation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('id')),
    __param(2, (0, graphql_1.Args)('productId')),
    __param(3, (0, graphql_1.Args)('size')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, String, String]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "deleteItemFromPackByUserMutation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pack_collection_create_type_1.PackCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "removePackCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pack_collection_type_1.PackCollectionType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], PackCollectionResolver.prototype, "getPackForClient", null);
PackCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => pack_collection_entity_1.PackCollection),
    __metadata("design:paramtypes", [pack_collection_service_1.PackCollectionService])
], PackCollectionResolver);
exports.PackCollectionResolver = PackCollectionResolver;
