import { Model } from 'mongoose';
import { CurrentStockCollectionService } from 'src/current-stock-collection/current-stock-collection.service';
import { ProductCollectionService } from 'src/product-collection/product-collection.service';
import { CreatePackCollectionUserInput } from './dto/create-pack-collection-user.input';
import { CreatePackCollectionInput } from './dto/create-pack-collection.input';
import { UpdatePackCollectionInput } from './dto/update-pack-collection.input';
import { PackCollection, PackCollectionDocument } from './entities/pack-collection.entity';
export declare class PackCollectionService {
    private packCollectionRepository;
    private readonly productCollectionService;
    private currentStockCollectionService;
    constructor(packCollectionRepository: Model<PackCollectionDocument>, productCollectionService: ProductCollectionService, currentStockCollectionService: CurrentStockCollectionService);
    create(createPackCollectionInput: CreatePackCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createUser(createPackCollectionUserInput: CreatePackCollectionUserInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(packName: string, username: string): Promise<boolean>;
    addItemToThePack(id: string, productId: string, size: string, qty: number, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAll(): Promise<(PackCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findAllWithUsername(username: string): Promise<(PackCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOne(id: string): Promise<PackCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    update(id: string, updatePackCollectionInput: UpdatePackCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateByUser(id: string, updatePackCollectionInput: UpdatePackCollectionInput, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removePackByUser(id: string, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeItemFromPack(id: string, productId: string, size: string, username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
