"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PackCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const current_stock_collection_service_1 = require("../current-stock-collection/current-stock-collection.service");
const product_collection_entity_1 = require("../product-collection/entities/product-collection.entity");
const product_collection_service_1 = require("../product-collection/product-collection.service");
const pack_collection_entity_1 = require("./entities/pack-collection.entity");
let PackCollectionService = class PackCollectionService {
    constructor(packCollectionRepository, productCollectionService, currentStockCollectionService) {
        this.packCollectionRepository = packCollectionRepository;
        this.productCollectionService = productCollectionService;
        this.currentStockCollectionService = currentStockCollectionService;
    }
    async create(createPackCollectionInput, username) {
        let checkIfExists = await this.checkIfExists(createPackCollectionInput.packName, username);
        if (checkIfExists) {
            return {
                status: false,
                status_text: 'Pack with smae name already exists',
            };
        }
        else {
            let pc = new pack_collection_entity_1.PackCollection();
            pc.packName = createPackCollectionInput.packName;
            pc.isDefault = createPackCollectionInput.isDefault;
            pc.maxLimit = createPackCollectionInput.maxLimit;
            if (createPackCollectionInput.isDefault == true) {
                pc.createdBy = username;
            }
            else {
                pc.createdBy = createPackCollectionInput.createdBy;
            }
            let newpcd = [];
            await Promise.all(createPackCollectionInput.packData.map(async (el) => {
                let product = await this.productCollectionService.findOneById(el.productId);
                newpcd.push({
                    Product: product._id,
                    qty: el.qty,
                    size: el.size,
                });
            }));
            pc.packData = newpcd;
            await this.packCollectionRepository.create(pc);
            return {
                status: true,
                status_text: 'Pack Successfully Created',
            };
        }
    }
    async createUser(createPackCollectionUserInput, username) {
        let checkIfExists = await this.checkIfExists(createPackCollectionUserInput.packName, username);
        if (checkIfExists) {
            return {
                status: false,
                status_text: 'Pack with smae name already exists',
            };
        }
        else {
            let pc = new pack_collection_entity_1.PackCollection();
            pc.packName = createPackCollectionUserInput.packName;
            pc.isDefault = false;
            pc.maxLimit = createPackCollectionUserInput.maxLimit;
            pc.createdBy = username;
            pc.packData = [];
            await this.packCollectionRepository.create(pc);
            return {
                status: true,
                status_text: 'Pack Successfully Created',
            };
        }
    }
    async checkIfExists(packName, username) {
        let result = await this.packCollectionRepository
            .count({
            createdBy: username,
            packName: packName,
        })
            .exec();
        if (result > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    async addItemToThePack(id, productId, size, qty, username) {
        let product = await this.productCollectionService.findOneById(productId);
        let pc = await this.packCollectionRepository.findOne({
            _id: id,
            createdBy: username,
        }).populate({
            path: 'packData',
            populate: { path: 'Product', model: product_collection_entity_1.ProductCollection },
        }).exec();
        if (pc) {
            let packData = pc.packData;
            let findProductIndex = packData.findIndex((el) => el.Product.id == productId && el.size == size);
            if (findProductIndex == -1) {
                let dd = {
                    Product: product._id,
                    qty: qty,
                    size: size,
                };
                await this.packCollectionRepository.updateOne({ _id: id }, {
                    $push: {
                        packData: dd
                    }
                });
            }
            else {
                await this.packCollectionRepository.updateOne({ _id: id }, {
                    $pull: {
                        packData: {
                            "Product": product._id
                        }
                    }
                });
                let dd = {
                    Product: product._id,
                    qty: qty,
                    size: size,
                };
                await this.packCollectionRepository.updateOne({ _id: id }, {
                    $push: {
                        packData: dd
                    }
                });
            }
            return {
                status: true,
                status_text: 'Successfully Inserted'
            };
        }
        else {
            return {
                status: false,
                status_text: 'You cannot edit this pack'
            };
        }
    }
    findAll() {
        return this.packCollectionRepository
            .find({})
            .populate({
            path: 'packData',
            populate: { path: 'Product', model: product_collection_entity_1.ProductCollection },
        })
            .exec();
    }
    async findAllWithUsername(username) {
        let result = await this.packCollectionRepository
            .find({
            isDefault: true
        })
            .populate({
            path: 'packData',
            populate: { path: 'Product', model: product_collection_entity_1.ProductCollection },
        })
            .exec();
        let result1 = await this.packCollectionRepository
            .find({
            isDefault: false,
            createdBy: username
        })
            .populate({
            path: 'packData',
            populate: { path: 'Product', model: product_collection_entity_1.ProductCollection },
        })
            .exec();
        let r = result.concat(result1);
        await Promise.all(r.map(async (el, index) => {
            let total = 0;
            let countNone = 0;
            await Promise.all(el.packData.map(async (el1, index1) => {
                let pr = await this.currentStockCollectionService.getStockWithPriceSpecific(el1.Product, el1.size, el1.qty, username);
                r[index]['packData'][index1]['price'] = pr;
                if (pr == null) {
                    countNone = countNone + 1;
                }
                if (pr != null) {
                    total = total + parseFloat(pr);
                }
            }));
            r[index]['countNone'] = countNone;
            r[index]['total'] = total;
        }));
        return r;
    }
    async findOne(id) {
        return await this.packCollectionRepository.findOne({ _id: id }).exec();
    }
    async update(id, updatePackCollectionInput, username) {
        let pc = await this.packCollectionRepository.findById(id);
        pc.packName = updatePackCollectionInput.packName;
        pc.isDefault = updatePackCollectionInput.isDefault;
        pc.maxLimit = updatePackCollectionInput.maxLimit;
        if (updatePackCollectionInput.isDefault == true) {
            pc.createdBy = username;
        }
        else {
            pc.createdBy = updatePackCollectionInput.createdBy;
        }
        let newpcd = [];
        await Promise.all(updatePackCollectionInput.packData.map(async (el) => {
            let product = await this.productCollectionService.findOneById(el.productId);
            newpcd.push({
                Product: product._id,
                qty: el.qty,
                size: el.size,
            });
        }));
        pc.packData = newpcd;
        await this.packCollectionRepository.updateOne({ _id: id }, pc);
        return {
            status: true,
            status_text: 'Pack Successfully Updated',
        };
    }
    async updateByUser(id, updatePackCollectionInput, username) {
        let pc = await this.packCollectionRepository.findOne({
            _id: id,
            createdBy: username
        });
        if (pc) {
            let newpcd = [];
            await Promise.all(updatePackCollectionInput.packData.map(async (el) => {
                let product = await this.productCollectionService.findOneById(el.productId);
                newpcd.push({
                    Product: product._id,
                    qty: el.qty,
                    size: el.size,
                });
            }));
            await this.packCollectionRepository.updateOne({ _id: id }, {
                $set: {
                    packData: newpcd
                }
            });
            return {
                status: true,
                status_text: 'Pack Successfully Updated',
            };
        }
        else {
            return {
                status: false,
                status_text: 'Edit not successful',
            };
        }
    }
    async remove(id) {
        await this.packCollectionRepository.deleteOne({ _id: id }).exec();
        return {
            status: true,
            status_text: "Successfully Deleted"
        };
    }
    async removePackByUser(id, username) {
        await this.packCollectionRepository.deleteOne({ _id: id, createdBy: username }).exec();
        return {
            status: true,
            status_text: "Successfully Deleted"
        };
    }
    async removeItemFromPack(id, productId, size, username) {
        let product = await this.productCollectionService.findOneById(productId);
        await this.packCollectionRepository.updateOne({ _id: id }, {
            $pull: {
                packData: {
                    "Product": product._id,
                    "size": size
                }
            }
        });
        return {
            status: true,
            status_text: "Item removed Successfully"
        };
    }
};
PackCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(pack_collection_entity_1.PackCollection.name)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_collection_service_1.CurrentStockCollectionService))),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_collection_service_1.ProductCollectionService,
        current_stock_collection_service_1.CurrentStockCollectionService])
], PackCollectionService);
exports.PackCollectionService = PackCollectionService;
