import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { ParentTable } from './entities/parent-table.entity';
import { CreateParentTableInput } from './dto/create-parent-table.input';
export declare class ParentTableService {
    private readonly parentTableRepository;
    private pubSub;
    private readonly animalEntryTableService;
    constructor(parentTableRepository: Repository<ParentTable>, pubSub: RedisPubSub, animalEntryTableService: AnimalEntryTableService);
    create(createParentTableInput: CreateParentTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ParentTable;
    }>;
    checkIfExists(createParentTableInput: CreateParentTableInput): Promise<boolean>;
    checkBreedingPossibility(sowId: number, boarId?: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAll(): Promise<ParentTable[]>;
    findOne(animalId: number): Promise<ParentTable>;
}
