"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParentTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const animal_entry_table_service_1 = require("../animal-table/animal-entry-table.service");
const parent_table_entity_1 = require("./entities/parent-table.entity");
let ParentTableService = class ParentTableService {
    constructor(parentTableRepository, pubSub, animalEntryTableService) {
        this.parentTableRepository = parentTableRepository;
        this.pubSub = pubSub;
        this.animalEntryTableService = animalEntryTableService;
    }
    async create(createParentTableInput, user) {
        let checkIfExists = await this.checkIfExists(createParentTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let ht = new parent_table_entity_1.ParentTable();
            ht.AnimalTable = await this.animalEntryTableService.findByAnimalId(createParentTableInput.animalId);
            if (createParentTableInput.boarId != null && createParentTableInput.sowId != null && createParentTableInput.boarId != undefined && createParentTableInput.sowId != undefined) {
                ht.BoarTable = await this.animalEntryTableService.findByAnimalId(createParentTableInput.boarId);
                ht.SowTable = await this.animalEntryTableService.findByAnimalId(createParentTableInput.sowId);
            }
            let result = await this.parentTableRepository.save(ht);
            return {
                status: true,
                status_text: "Successfully Submitted",
                data: result
            };
        }
    }
    async checkIfExists(createParentTableInput) {
        let rr = await this.parentTableRepository.count({
            where: {
                AnimalTable: {
                    animalId: createParentTableInput.animalId
                }
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async checkBreedingPossibility(sowId, boarId) {
        let animals = [boarId];
        let list = [boarId];
        while (animals.length > 0) {
            let current = animals[0];
            let result = await this.parentTableRepository.findOne({
                where: {
                    AnimalTable: {
                        animalId: current
                    },
                },
                relations: {
                    BoarTable: true,
                    SowTable: true
                }
            });
            if (result != null && result != undefined) {
                if (result.BoarTable != null) {
                    if (!list.includes(result.BoarTable.animalId)) {
                        animals.push(result.BoarTable.animalId);
                        list.push(result.BoarTable.animalId);
                    }
                }
                if (result.SowTable != null) {
                    if (!list.includes(result.SowTable.animalId)) {
                        animals.push(result.SowTable.animalId);
                        list.push(result.SowTable.animalId);
                    }
                }
            }
            animals.shift();
        }
        animals = [...list];
        while (animals.length > 0) {
            let c = await this.parentTableRepository.find({
                where: {
                    BoarTable: {
                        animalId: animals[0]
                    },
                },
                relations: {
                    AnimalTable: true,
                    SowTable: true
                }
            });
            if (c != null && c != undefined) {
                for (const cc of c) {
                    if (cc.AnimalTable != null) {
                        if (!list.includes(cc.AnimalTable.animalId))
                            animals.push(cc.AnimalTable.animalId);
                        if (!list.includes(cc.AnimalTable.animalId))
                            list.push(cc.AnimalTable.animalId);
                    }
                }
            }
            let cc = await this.parentTableRepository.find({
                where: {
                    SowTable: {
                        animalId: animals[0]
                    },
                },
                relations: {
                    AnimalTable: true,
                    BoarTable: true
                }
            });
            if (cc != null && cc != undefined) {
                for (const ccc of cc) {
                    if (ccc.AnimalTable != null) {
                        if (!list.includes(ccc.AnimalTable.animalId))
                            animals.push(ccc.AnimalTable.animalId);
                        if (!list.includes(ccc.AnimalTable.animalId))
                            list.push(ccc.AnimalTable.animalId);
                    }
                }
            }
            animals.shift();
        }
        let status = list.includes(sowId);
        return {
            status: !status,
            status_text: status == false ? 'Possible' : 'Not Possible',
            data: null
        };
    }
    async findAll() {
        let r = await this.parentTableRepository.find();
        return r;
    }
    async findOne(animalId) {
        return await this.parentTableRepository.findOne({
            where: {
                AnimalTable: {
                    animalId
                }
            }
        });
    }
};
ParentTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(parent_table_entity_1.ParentTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_entry_table_service_1.AnimalEntryTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        animal_entry_table_service_1.AnimalEntryTableService])
], ParentTableService);
exports.ParentTableService = ParentTableService;
