import { PigInsuranceTableService } from './pig-insurance-table.service';
import { PigInsuranceTable } from './entities/pig-insurance-table.entity';
import { CreatePigInsuranceTableInput } from './dto/create-pig-insurance-table.input';
import { UpdatePigInsuranceTableInput } from './dto/update-pig-insurance-table.input';
export declare class PigInsuranceTableResolver {
    private readonly pigInsuranceTableService;
    constructor(pigInsuranceTableService: PigInsuranceTableService);
    createPigInsuranceTable(createPigInsuranceTableInput: CreatePigInsuranceTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findAllPigInsurance(): Promise<PigInsuranceTable[]>;
    findOnePigInsurance(pigInsuranceId: number): Promise<PigInsuranceTable>;
    findPigInsuranceByFarmerId(farmerId: number): Promise<PigInsuranceTable[]>;
    updatePigInsuranceTable(updatePigInsuranceTableInput: UpdatePigInsuranceTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: PigInsuranceTable;
    }>;
    removePigInsuranceTable(pigInsuranceId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findPigInsuranceByHousingd(housingId: number): Promise<PigInsuranceTable[]>;
    getInsuranceDetailsOfOneAnimal(animalId: number): Promise<PigInsuranceTable[]>;
    getInsuranceDetailsDistrictWise(districtId: number): Promise<any>;
}
