"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PigInsuranceTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const pig_insurance_table_service_1 = require("./pig-insurance-table.service");
const pig_insurance_table_entity_1 = require("./entities/pig-insurance-table.entity");
const create_pig_insurance_table_input_1 = require("./dto/create-pig-insurance-table.input");
const update_pig_insurance_table_input_1 = require("./dto/update-pig-insurance-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const pig_insurance_table_return_type_1 = require("./types/pig-insurance-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const pig_insurance_table_type_1 = require("./types/pig-insurance-table.type");
const pig_insurance_details_report_type_1 = require("./types/pig-insurance-details-report.type");
let PigInsuranceTableResolver = class PigInsuranceTableResolver {
    constructor(pigInsuranceTableService) {
        this.pigInsuranceTableService = pigInsuranceTableService;
    }
    createPigInsuranceTable(createPigInsuranceTableInput, user) {
        return this.pigInsuranceTableService.create(createPigInsuranceTableInput, user);
    }
    findAllPigInsurance() {
        return this.pigInsuranceTableService.findAll();
    }
    findOnePigInsurance(pigInsuranceId) {
        return this.pigInsuranceTableService.findOne(pigInsuranceId);
    }
    findPigInsuranceByFarmerId(farmerId) {
        return this.pigInsuranceTableService.findOneByFarmerId(farmerId);
    }
    updatePigInsuranceTable(updatePigInsuranceTableInput, user) {
        return this.pigInsuranceTableService.update(updatePigInsuranceTableInput.pigInsuranceId, updatePigInsuranceTableInput, user);
    }
    removePigInsuranceTable(pigInsuranceId, user) {
        return this.pigInsuranceTableService.remove(pigInsuranceId, user);
    }
    findPigInsuranceByHousingd(housingId) {
        return this.pigInsuranceTableService.findPigInsuranceByHousingd(housingId);
    }
    getInsuranceDetailsOfOneAnimal(animalId) {
        return this.pigInsuranceTableService.getInsuranceDetailsOfOneAnimal(animalId);
    }
    getInsuranceDetailsDistrictWise(districtId) {
        return this.pigInsuranceTableService.getInsuranceDetailsDistrictWise(districtId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pig_insurance_table_return_type_1.PigInsuranceTableReturnType),
    __param(0, (0, graphql_1.Args)('createPigInsuranceTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_pig_insurance_table_input_1.CreatePigInsuranceTableInput, Object]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "createPigInsuranceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pig_insurance_table_type_1.PigInsuranceTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "findAllPigInsurance", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => pig_insurance_table_type_1.PigInsuranceTableType),
    __param(0, (0, graphql_1.Args)('pigInsuranceId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "findOnePigInsurance", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pig_insurance_table_type_1.PigInsuranceTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "findPigInsuranceByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pig_insurance_table_return_type_1.PigInsuranceTableReturnType),
    __param(0, (0, graphql_1.Args)('updatePigInsuranceTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_pig_insurance_table_input_1.UpdatePigInsuranceTableInput, Object]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "updatePigInsuranceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pig_insurance_table_return_type_1.PigInsuranceTableReturnType),
    __param(0, (0, graphql_1.Args)('pigInsuranceId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "removePigInsuranceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pig_insurance_table_type_1.PigInsuranceTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "findPigInsuranceByHousingd", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pig_insurance_table_type_1.PigInsuranceTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "getInsuranceDetailsOfOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pig_insurance_details_report_type_1.PigInsuranceDetailsReport]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PigInsuranceTableResolver.prototype, "getInsuranceDetailsDistrictWise", null);
PigInsuranceTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => pig_insurance_table_entity_1.PigInsuranceTable),
    __metadata("design:paramtypes", [pig_insurance_table_service_1.PigInsuranceTableService])
], PigInsuranceTableResolver);
exports.PigInsuranceTableResolver = PigInsuranceTableResolver;
