import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { SubDivisionTableService } from 'src/sub-division-table/sub-division-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreatePigInsuranceTableInput } from './dto/create-pig-insurance-table.input';
import { UpdatePigInsuranceTableInput } from './dto/update-pig-insurance-table.input';
import { PigInsuranceTable } from './entities/pig-insurance-table.entity';
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class PigInsuranceTableService {
    private readonly pigInsuranceTableRepository;
    private readonly userCollectionService;
    private readonly dataEntryTableService;
    private readonly housingTableService;
    private readonly animalEntryTableService;
    private readonly subDivisionTableService;
    constructor(pigInsuranceTableRepository: Repository<PigInsuranceTable>, userCollectionService: UserCollectionService, dataEntryTableService: DataEntryTableService, housingTableService: HousingTableService, animalEntryTableService: AnimalEntryTableService, subDivisionTableService: SubDivisionTableService);
    create(createPigInsuranceTableInput: CreatePigInsuranceTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    checkIfExists(animalId: number): Promise<boolean>;
    findByFarmerId(animalId: number): Promise<PigInsuranceTable[]>;
    findPigInsuranceByHousingd(housingId: number): Promise<PigInsuranceTable[]>;
    findAll(): Promise<PigInsuranceTable[]>;
    findOne(pigInsuranceId: number): Promise<PigInsuranceTable>;
    findOneByFarmerId(farmerId: number): Promise<PigInsuranceTable[]>;
    update(pigInsuranceId: number, updatePigInsuranceTableInput: UpdatePigInsuranceTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: PigInsuranceTable;
    }>;
    remove(pigInsuranceId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    getInsuranceDetailsOfOneAnimal(animalId: number): Promise<PigInsuranceTable[]>;
    getInsuranceDetailsDistrictWise(districtId: number): Promise<any>;
    checkDaysLeft(date: string): string;
    getExpiredOrNearlyExpiredData(farmerId: number, days: number): Promise<any>;
}
