import { PopTableService } from './pop-table.service';
import { PopTable } from './entities/pop-table.entity';
import { CreatePopTableInput } from './dto/create-pop-table.input';
import { UpdatePopTableInput } from './dto/update-pop-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_POP_ADD = "NEW_POP_ADD";
export declare class PopTableResolver {
    private readonly popTableService;
    private pubSub;
    constructor(popTableService: PopTableService, pubSub: RedisPubSub);
    createPopTable(createPopTableInput: CreatePopTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllPop(): Promise<PopTable[]>;
    findOne(popId: number): Promise<PopTable>;
    updatePopTable(updatePopTableInput: UpdatePopTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    toggleRequiredTypeStatus(popId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removePopTable(popId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    popSubscription(): AsyncIterator<unknown, any, undefined>;
}
