"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopTableResolver = exports.NEW_POP_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const pop_table_service_1 = require("./pop-table.service");
const pop_table_entity_1 = require("./entities/pop-table.entity");
const create_pop_table_input_1 = require("./dto/create-pop-table.input");
const update_pop_table_input_1 = require("./dto/update-pop-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const pop_table_return_type_1 = require("./types/pop-table-return.type");
const pop_table_type_1 = require("./types/pop-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_POP_ADD = "NEW_POP_ADD";
let PopTableResolver = exports.PopTableResolver = class PopTableResolver {
    constructor(popTableService, pubSub) {
        this.popTableService = popTableService;
        this.pubSub = pubSub;
    }
    createPopTable(createPopTableInput) {
        return this.popTableService.create(createPopTableInput);
    }
    findAllPop() {
        return this.popTableService.findAll();
    }
    findOne(popId) {
        return this.popTableService.findOne(popId);
    }
    updatePopTable(updatePopTableInput) {
        return this.popTableService.update(updatePopTableInput.popId, updatePopTableInput);
    }
    toggleRequiredTypeStatus(popId, type) {
        return this.popTableService.toggleRequiredTypeStatus(popId, type);
    }
    removePopTable(popId) {
        return this.popTableService.remove(popId);
    }
    popSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_POP_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pop_table_return_type_1.PopTableReturnType),
    __param(0, (0, graphql_1.Args)('createPopTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_pop_table_input_1.CreatePopTableInput]),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "createPopTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [pop_table_type_1.PopTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "findAllPop", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => pop_table_type_1.PopTableType),
    __param(0, (0, graphql_1.Args)('popId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pop_table_return_type_1.PopTableReturnType),
    __param(0, (0, graphql_1.Args)('updatePopTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_pop_table_input_1.UpdatePopTableInput]),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "updatePopTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pop_table_return_type_1.PopTableReturnType),
    __param(0, (0, graphql_1.Args)('popId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('type', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String]),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "toggleRequiredTypeStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => pop_table_return_type_1.PopTableReturnType),
    __param(0, (0, graphql_1.Args)('popId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "removePopTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], PopTableResolver.prototype, "popSubscription", null);
exports.PopTableResolver = PopTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => pop_table_entity_1.PopTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [pop_table_service_1.PopTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], PopTableResolver);
