import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreatePopTableInput } from './dto/create-pop-table.input';
import { UpdatePopTableInput } from './dto/update-pop-table.input';
import { PopTable } from './entities/pop-table.entity';
export declare const NEW_POP_ADD = "NEW_POP_ADD";
export declare class PopTableService {
    private readonly popTableRepository;
    private pubSub;
    constructor(popTableRepository: Repository<PopTable>, pubSub: RedisPubSub);
    create(createPopTableInput: CreatePopTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createPopTableInput: CreatePopTableInput): Promise<PopTable>;
    checkIfAlreadyExists(createPopTableInput: CreatePopTableInput): Promise<number>;
    toggleRequiredTypeStatus(popId: number, type: string): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    getCount(): Promise<number>;
    findAll(): Promise<PopTable[]>;
    findOne(popId: number): Promise<PopTable>;
    findOneArray(popIds: number[]): Promise<PopTable[]>;
    update(popId: number, updatePopTableInput: UpdatePopTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: PopTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(popId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
