"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopTableService = exports.NEW_POP_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const pop_table_entity_1 = require("./entities/pop-table.entity");
exports.NEW_POP_ADD = "NEW_POP_ADD";
let PopTableService = exports.PopTableService = class PopTableService {
    constructor(popTableRepository, pubSub) {
        this.popTableRepository = popTableRepository;
        this.pubSub = pubSub;
    }
    async create(createPopTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createPopTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new pop_table_entity_1.PopTable();
            st.popName = createPopTableInput.popName;
            st.incomeActivityCode = createPopTableInput.incomeActivityCode;
            let result = await this.popTableRepository.save(st);
            this.pubSub.publish(exports.NEW_POP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createPopTableInput) {
        let checkIfAlreadyExists = await this.popTableRepository.findOne({
            where: {
                popName: createPopTableInput.popName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new pop_table_entity_1.PopTable();
            st.popName = createPopTableInput.popName.trim();
            st.incomeActivityCode = createPopTableInput.incomeActivityCode.trim();
            let result = await this.popTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createPopTableInput) {
        let result = await this.popTableRepository.count({
            where: {
                popName: createPopTableInput.popName
            }
        });
        return result;
    }
    async toggleRequiredTypeStatus(popId, type) {
        let dd = await this.findOne(popId);
        if (dd) {
            if (type == "requiredInHorticulture") {
                let oldRequiredInHorticulture = dd.requiredInHorticulture;
                if (oldRequiredInHorticulture == "YES") {
                    dd.requiredInHorticulture = "NO";
                }
                if (oldRequiredInHorticulture == "NO") {
                    dd.requiredInHorticulture = "YES";
                }
            }
            let result = await this.popTableRepository.save(dd);
            return {
                status: true,
                status_text: "Updated",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async getCount() {
        return await this.popTableRepository.count();
    }
    async findAll() {
        return await this.popTableRepository.find();
    }
    async findOne(popId) {
        return await this.popTableRepository.findOne({
            where: {
                popId
            }
        });
    }
    async findOneArray(popIds) {
        return await this.popTableRepository.find({
            where: {
                popId: (0, typeorm_2.In)(popIds)
            }
        });
    }
    async update(popId, updatePopTableInput) {
        let result = await this.findOne(popId);
        if (result) {
            result.popName = updatePopTableInput.popName;
            result.incomeActivityCode = updatePopTableInput.incomeActivityCode;
            let updatedResult = await this.popTableRepository.save(result);
            this.pubSub.publish(exports.NEW_POP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(popId) {
        let result = await this.findOne(popId);
        if (result) {
            await this.popTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_POP_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.PopTableService = PopTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(pop_table_entity_1.PopTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], PopTableService);
