import { ProducerGroupsTableService } from './producer-groups-table.service';
import { ProducerGroupsTable } from './entities/producer-groups-table.entity';
import { CreateProducerGroupsTableInput } from './dto/create-producer-groups-table.input';
import { UpdateProducerGroupsTableInput } from './dto/update-producer-groups-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_PG_ADD = "NEW_PG_ADD";
export declare class ProducerGroupsTableResolver {
    private readonly producerGroupsTableService;
    private pubSub;
    constructor(producerGroupsTableService: ProducerGroupsTableService, pubSub: RedisPubSub);
    createProducerGroupsTable(createProducerGroupsTableInput: CreateProducerGroupsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProducerGroupsTable;
    }>;
    findAllProducerGroups(user: any): Promise<ProducerGroupsTable[]>;
    findAllProducerGroupsByBlockId(user: any, blockId: number): Promise<ProducerGroupsTable[]>;
    findAllProducerGroupsByShgId(user: any, shgId: number): Promise<ProducerGroupsTable[]>;
    findOneProducerGroup(pgId: number): Promise<ProducerGroupsTable>;
    updateProducerGroupsTable(updateProducerGroupsTableInput: UpdateProducerGroupsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProducerGroupsTable;
    }>;
    removeProducerGroupsTable(pgId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    producerGroupsSubscription(): AsyncIterator<unknown, any, undefined>;
}
