"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProducerGroupsTableResolver = exports.NEW_PG_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const producer_groups_table_service_1 = require("./producer-groups-table.service");
const producer_groups_table_entity_1 = require("./entities/producer-groups-table.entity");
const create_producer_groups_table_input_1 = require("./dto/create-producer-groups-table.input");
const update_producer_groups_table_input_1 = require("./dto/update-producer-groups-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const role_enum_1 = require("../user-collection/roles/role.enum");
const producer_groups_table_return_type_1 = require("./types/producer-groups-table-return.type");
const producer_groups_table_type_1 = require("./types/producer-groups-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_PG_ADD = "NEW_PG_ADD";
let ProducerGroupsTableResolver = exports.ProducerGroupsTableResolver = class ProducerGroupsTableResolver {
    constructor(producerGroupsTableService, pubSub) {
        this.producerGroupsTableService = producerGroupsTableService;
        this.pubSub = pubSub;
    }
    createProducerGroupsTable(createProducerGroupsTableInput) {
        return this.producerGroupsTableService.create(createProducerGroupsTableInput);
    }
    findAllProducerGroups(user) {
        return this.producerGroupsTableService.findAll();
    }
    findAllProducerGroupsByBlockId(user, blockId) {
        return this.producerGroupsTableService.findAllByBlockId(blockId);
    }
    findAllProducerGroupsByShgId(user, shgId) {
        return this.producerGroupsTableService.findAllProducerGroupsByShgId(shgId);
    }
    findOneProducerGroup(pgId) {
        return this.producerGroupsTableService.findOne(pgId);
    }
    updateProducerGroupsTable(updateProducerGroupsTableInput) {
        return this.producerGroupsTableService.update(updateProducerGroupsTableInput.pgId, updateProducerGroupsTableInput);
    }
    removeProducerGroupsTable(pgId) {
        return this.producerGroupsTableService.remove(pgId);
    }
    producerGroupsSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_PG_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => producer_groups_table_return_type_1.ProducerGroupsTableReturnType),
    __param(0, (0, graphql_1.Args)('createProducerGroupsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_producer_groups_table_input_1.CreateProducerGroupsTableInput]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "createProducerGroupsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [producer_groups_table_type_1.ProducerGroupsTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "findAllProducerGroups", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [producer_groups_table_type_1.ProducerGroupsTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('blockId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "findAllProducerGroupsByBlockId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [producer_groups_table_type_1.ProducerGroupsTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "findAllProducerGroupsByShgId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => producer_groups_table_type_1.ProducerGroupsTableType),
    __param(0, (0, graphql_1.Args)('pgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "findOneProducerGroup", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => producer_groups_table_return_type_1.ProducerGroupsTableReturnType),
    __param(0, (0, graphql_1.Args)('updateProducerGroupsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_producer_groups_table_input_1.UpdateProducerGroupsTableInput]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "updateProducerGroupsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => producer_groups_table_return_type_1.ProducerGroupsTableReturnType),
    __param(0, (0, graphql_1.Args)('pgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "removeProducerGroupsTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProducerGroupsTableResolver.prototype, "producerGroupsSubscription", null);
exports.ProducerGroupsTableResolver = ProducerGroupsTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => producer_groups_table_entity_1.ProducerGroupsTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [producer_groups_table_service_1.ProducerGroupsTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProducerGroupsTableResolver);
