import { RedisPubSub } from 'graphql-redis-subscriptions';
import { BlockTableService } from 'src/block-table/block-table.service';
import { Repository } from 'typeorm';
import { CreateProducerGroupsTableInput } from './dto/create-producer-groups-table.input';
import { UpdateProducerGroupsTableInput } from './dto/update-producer-groups-table.input';
import { ProducerGroupsTable } from './entities/producer-groups-table.entity';
import { ShgTableService } from 'src/shg-table/shg-table.service';
export declare const NEW_PG_ADD = "NEW_PG_ADD";
export declare class ProducerGroupsTableService {
    private readonly producerGroupsTableRepository;
    private pubSub;
    private readonly blockTableService;
    private readonly shgTableService;
    constructor(producerGroupsTableRepository: Repository<ProducerGroupsTable>, pubSub: RedisPubSub, blockTableService: BlockTableService, shgTableService: ShgTableService);
    create(createProducerGroupsTableInput: CreateProducerGroupsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProducerGroupsTable;
    }>;
    createorElseReturnObject(createProducerGroupsTableInput: CreateProducerGroupsTableInput): Promise<ProducerGroupsTable>;
    checkIfExists(pgName: string, blockId: number): Promise<boolean>;
    getCount(): Promise<number>;
    findAll(): Promise<ProducerGroupsTable[]>;
    findAllByBlockId(blockId: number): Promise<ProducerGroupsTable[]>;
    findAllByBlockIds(ids: number[]): Promise<ProducerGroupsTable[]>;
    findAllProducerGroupsByShgId(shgId: number): Promise<ProducerGroupsTable[]>;
    findOne(pgId: number): Promise<ProducerGroupsTable>;
    update(pgId: number, updateProducerGroupsTableInput: UpdateProducerGroupsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProducerGroupsTable;
    }>;
    remove(pgId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
