"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProducerGroupsTableService = exports.NEW_PG_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const block_table_service_1 = require("../block-table/block-table.service");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const producer_groups_table_entity_1 = require("./entities/producer-groups-table.entity");
const shg_table_service_1 = require("../shg-table/shg-table.service");
exports.NEW_PG_ADD = "NEW_PG_ADD";
let ProducerGroupsTableService = exports.ProducerGroupsTableService = class ProducerGroupsTableService {
    constructor(producerGroupsTableRepository, pubSub, blockTableService, shgTableService) {
        this.producerGroupsTableRepository = producerGroupsTableRepository;
        this.pubSub = pubSub;
        this.blockTableService = blockTableService;
        this.shgTableService = shgTableService;
    }
    async create(createProducerGroupsTableInput) {
        let checkIfExists = await this.checkIfExists(createProducerGroupsTableInput.pgName, createProducerGroupsTableInput.blockId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new producer_groups_table_entity_1.ProducerGroupsTable();
            dd.pgName = createProducerGroupsTableInput.pgName;
            dd.dateOfFormation = createProducerGroupsTableInput.dateOfFormation;
            dd.nrlmRegistration = createProducerGroupsTableInput.nrlmRegistration;
            dd.bankName = createProducerGroupsTableInput.bankName;
            dd.bankAccountNo = createProducerGroupsTableInput.bankAccountNo;
            dd.bankBranch = createProducerGroupsTableInput.bankBranch;
            dd.bankIfsc = createProducerGroupsTableInput.bankIfsc;
            let block = await this.blockTableService.findOne(createProducerGroupsTableInput.blockId);
            dd.BlockTable = block;
            let result = await this.producerGroupsTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_PG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async createorElseReturnObject(createProducerGroupsTableInput) {
        let checkIfAlreadyExists = await this.producerGroupsTableRepository.findOne({
            where: {
                pgName: createProducerGroupsTableInput.pgName.trim(),
                BlockTable: {
                    blockId: createProducerGroupsTableInput.blockId
                }
            }
        });
        if (!checkIfAlreadyExists) {
            let dd = new producer_groups_table_entity_1.ProducerGroupsTable();
            dd.pgName = createProducerGroupsTableInput.pgName.trim();
            if (createProducerGroupsTableInput.dateOfFormation) {
                dd.dateOfFormation = createProducerGroupsTableInput.dateOfFormation;
            }
            if (createProducerGroupsTableInput.nrlmRegistration) {
                dd.nrlmRegistration = createProducerGroupsTableInput.nrlmRegistration;
            }
            if (createProducerGroupsTableInput.bankName) {
                dd.bankName = createProducerGroupsTableInput.bankName;
            }
            if (createProducerGroupsTableInput.bankAccountNo) {
                dd.bankAccountNo = createProducerGroupsTableInput.bankAccountNo;
            }
            if (createProducerGroupsTableInput.bankBranch) {
                dd.bankBranch = createProducerGroupsTableInput.bankBranch;
            }
            if (createProducerGroupsTableInput.bankIfsc) {
                dd.bankIfsc = createProducerGroupsTableInput.bankIfsc;
            }
            let block = await this.blockTableService.findOne(createProducerGroupsTableInput.blockId);
            dd.BlockTable = block;
            dd.StateTable = block.DistrictTable.StateTable;
            dd.DistrictTable = block.DistrictTable;
            let result = await this.producerGroupsTableRepository.save(dd);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfExists(pgName, blockId) {
        let result = await this.producerGroupsTableRepository.count({
            where: {
                pgName: pgName,
                BlockTable: {
                    blockId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getCount() {
        return await this.producerGroupsTableRepository.count();
    }
    async findAll() {
        return await this.producerGroupsTableRepository.find({
            relations: {
                BlockTable: true
            }
        });
    }
    async findAllByBlockId(blockId) {
        return await this.producerGroupsTableRepository.find({
            where: {
                BlockTable: {
                    blockId
                }
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async findAllByBlockIds(ids) {
        return await this.producerGroupsTableRepository.find({
            where: {
                BlockTable: {
                    blockId: (0, typeorm_2.In)(ids)
                }
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async findAllProducerGroupsByShgId(shgId) {
        var _a, _b, _c;
        let shg = await this.shgTableService.findOne(shgId);
        return await this.producerGroupsTableRepository.find({
            where: {
                BlockTable: {
                    blockId: (_c = (_b = (_a = shg === null || shg === void 0 ? void 0 : shg.VillageTable) === null || _a === void 0 ? void 0 : _a.GrampanchayatTable) === null || _b === void 0 ? void 0 : _b.BlockTable) === null || _c === void 0 ? void 0 : _c.blockId
                }
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async findOne(pgId) {
        return await this.producerGroupsTableRepository.findOne({
            where: {
                pgId: pgId
            },
            relations: {
                BlockTable: true
            }
        });
    }
    async update(pgId, updateProducerGroupsTableInput) {
        let result = await this.producerGroupsTableRepository.findOne({
            where: {
                pgId: pgId
            }
        });
        if (result) {
            result.pgName = updateProducerGroupsTableInput.pgName;
            if (updateProducerGroupsTableInput.dateOfFormation) {
                result.dateOfFormation = updateProducerGroupsTableInput.dateOfFormation;
            }
            if (updateProducerGroupsTableInput.nrlmRegistration) {
                result.nrlmRegistration = updateProducerGroupsTableInput.nrlmRegistration;
            }
            if (updateProducerGroupsTableInput.bankName) {
                result.bankName = updateProducerGroupsTableInput.bankName;
            }
            if (updateProducerGroupsTableInput.bankAccountNo) {
                result.bankAccountNo = updateProducerGroupsTableInput.bankAccountNo;
            }
            if (updateProducerGroupsTableInput.bankBranch) {
                result.bankBranch = updateProducerGroupsTableInput.bankBranch;
            }
            if (updateProducerGroupsTableInput.bankIfsc) {
                result.bankIfsc = updateProducerGroupsTableInput.bankIfsc;
            }
            let block = await this.blockTableService.findOne(updateProducerGroupsTableInput.blockId);
            result.BlockTable = block;
            let r = await this.producerGroupsTableRepository.save(result);
            this.pubSub.publish(exports.NEW_PG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(pgId) {
        let result = await this.producerGroupsTableRepository.findOne({
            where: {
                pgId: pgId
            }
        });
        if (result) {
            await this.producerGroupsTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_PG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.ProducerGroupsTableService = ProducerGroupsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(producer_groups_table_entity_1.ProducerGroupsTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => shg_table_service_1.ShgTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        block_table_service_1.BlockTableService,
        shg_table_service_1.ShgTableService])
], ProducerGroupsTableService);
