/// <reference types="mongoose" />
import { ProductCategoryCollectionService } from './product-category-collection.service';
import { ProductCategoryCollection } from './entities/product-category-collection.entity';
import { CreateProductCategoryCollectionInput } from './input/create-product-category-collection.input';
import { UpdateProductCategoryCollectionInput } from './input/update-product-category-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_CATEGORY_ADD = "NEW_CATEGORY_ADD";
export declare class ProductCategoryCollectionResolver {
    private readonly productCategoryCollectionService;
    private pubSub;
    constructor(productCategoryCollectionService: ProductCategoryCollectionService, pubSub: RedisPubSub);
    createProductCategoryCollection(user: any, createProductCategoryCollectionInput: CreateProductCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllProductCategory(): Promise<(ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findAllProductCategoryForWebsite(): Promise<(ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    updateProductCategoryCollection(updateProductCategoryCollectionInput: UpdateProductCategoryCollectionInput): Promise<any>;
    removeProductCategoryCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    newCategoryAdd(): AsyncIterator<unknown, any, undefined>;
}
