import { CreateProductCategoryCollectionInput } from './input/create-product-category-collection.input';
import { UpdateProductCategoryCollectionInput } from './input/update-product-category-collection.input';
import { ProductCategoryCollection, ProductCategoryDocument } from './entities/product-category-collection.entity';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { ProductCollectionService } from 'src/product-collection/product-collection.service';
export declare const NEW_CATEGORY_ADD = "NEW_CATEGORY_ADD";
export declare class ProductCategoryCollectionService {
    private productCategoryRepository;
    private productCollectionService;
    private pubSub;
    constructor(productCategoryRepository: Model<ProductCategoryDocument>, productCollectionService: ProductCollectionService, pubSub: RedisPubSub);
    create(createProductCategoryCollectionInput: CreateProductCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(categoryCode: string): Promise<boolean>;
    findAll(): Promise<(ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findAllWithProductCount(): Promise<(ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    getSortOrder(prop: any): (a: any, b: any) => 0 | 1 | -1;
    findOneById(id: string): Promise<ProductCategoryCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateProductCategoryCollectionInput: UpdateProductCategoryCollectionInput): Promise<any>;
}
