"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCategoryCollectionService = exports.NEW_CATEGORY_ADD = void 0;
const common_1 = require("@nestjs/common");
const product_category_collection_entity_1 = require("./entities/product-category-collection.entity");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const product_collection_service_1 = require("../product-collection/product-collection.service");
exports.NEW_CATEGORY_ADD = "NEW_CATEGORY_ADD";
let ProductCategoryCollectionService = class ProductCategoryCollectionService {
    constructor(productCategoryRepository, productCollectionService, pubSub) {
        this.productCategoryRepository = productCategoryRepository;
        this.productCollectionService = productCollectionService;
        this.pubSub = pubSub;
    }
    async create(createProductCategoryCollectionInput) {
        let checkIfExists = await this.checkIfExists(createProductCategoryCollectionInput.categoryCode);
        if (!checkIfExists) {
            let cm = new product_category_collection_entity_1.ProductCategoryCollection();
            cm.productCategory = createProductCategoryCollectionInput.productCategory;
            cm.categoryCode = createProductCategoryCollectionInput.categoryCode;
            let c = await this.productCategoryRepository.create(cm);
            this.pubSub.publish(exports.NEW_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(categoryCode) {
        let r = await this.productCategoryRepository.count({
            categoryCode: categoryCode
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.productCategoryRepository.find().exec();
    }
    async findAllWithProductCount() {
        let result = await this.productCategoryRepository.find().exec();
        await Promise.all(result.map(async (el, index) => {
            result[index]['count'] = await this.productCollectionService.getCountByCategory(el);
        }));
        return result.sort(this.getSortOrder("count"));
    }
    getSortOrder(prop) {
        return function (a, b) {
            if (a[prop] > b[prop]) {
                return -1;
            }
            else if (a[prop] < b[prop]) {
                return 1;
            }
            return 0;
        };
    }
    async findOneById(id) {
        return await this.productCategoryRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        await this.productCategoryRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_CATEGORY_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: null
        };
    }
    async update(id, updateProductCategoryCollectionInput) {
        let cc = await this.productCategoryRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.productCategory = updateProductCategoryCollectionInput.productCategory;
            let cc1 = await this.productCategoryRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
ProductCategoryCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(product_category_collection_entity_1.ProductCategoryCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => product_collection_service_1.ProductCollectionService))),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_collection_service_1.ProductCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProductCategoryCollectionService);
exports.ProductCategoryCollectionService = ProductCategoryCollectionService;
