import { ObjectID } from 'typeorm';
import * as mongoose from 'mongoose';
import { Document } from 'mongoose';
import { ProductCategoryCollection } from 'src/product-category-collection/entities/product-category-collection.entity';
import { ProductSubCategoryCollection } from 'src/product-sub-category-collection/entities/product-sub-category-collection.entity';
import { BrandCollection } from 'src/brand-collection/entities/brand-collection.entity';
import { UnitCollection } from 'src/unit-collection/entities/unit-collection.entity';
import { ManufacturerCollection } from 'src/manufacturer-collection/entities/manufacturer-collection.entity';
export declare type ProductCollectionDocument = ProductCollection & Document;
export declare class ProductPhoto {
    fileName: string;
    fileType: string;
    url: string;
}
export declare class ProductCollection {
    _id: ObjectID;
    productName: string;
    productDescription: string;
    productCodeIndex: number;
    productCode: string;
    ProductCategory: ProductCategoryCollection;
    ProductSubCategory: ProductSubCategoryCollection;
    Brand: BrandCollection;
    Manufacturer: ManufacturerCollection;
    taxRate: string;
    pricingMethod: string;
    Unit: UnitCollection;
    hsn: string;
    countryOfOrigin: string;
    isFeatured: boolean;
    productLogo: ProductPhoto;
}
export declare const ProductCollectionSchema: mongoose.Schema<mongoose.Document<ProductCollection, any, any>, mongoose.Model<mongoose.Document<ProductCollection, any, any>, any, any, any>, any, any>;
