"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCollectionSchema = exports.ProductCollection = exports.ProductPhoto = void 0;
const typeorm_1 = require("typeorm");
const mongoose = __importStar(require("mongoose"));
const mongoose_1 = require("@nestjs/mongoose");
const product_category_collection_entity_1 = require("../../product-category-collection/entities/product-category-collection.entity");
const product_sub_category_collection_entity_1 = require("../../product-sub-category-collection/entities/product-sub-category-collection.entity");
const brand_collection_entity_1 = require("../../brand-collection/entities/brand-collection.entity");
const unit_collection_entity_1 = require("../../unit-collection/entities/unit-collection.entity");
const manufacturer_collection_entity_1 = require("../../manufacturer-collection/entities/manufacturer-collection.entity");
class ProductPhoto {
}
__decorate([
    (0, mongoose_1.Prop)(),
    __metadata("design:type", String)
], ProductPhoto.prototype, "fileName", void 0);
__decorate([
    (0, mongoose_1.Prop)(),
    __metadata("design:type", String)
], ProductPhoto.prototype, "fileType", void 0);
__decorate([
    (0, mongoose_1.Prop)({ nullable: true }),
    __metadata("design:type", String)
], ProductPhoto.prototype, "url", void 0);
exports.ProductPhoto = ProductPhoto;
let ProductCollection = class ProductCollection {
};
__decorate([
    (0, typeorm_1.ObjectIdColumn)(),
    __metadata("design:type", typeorm_1.ObjectID)
], ProductCollection.prototype, "_id", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true }),
    __metadata("design:type", String)
], ProductCollection.prototype, "productName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: false }),
    __metadata("design:type", String)
], ProductCollection.prototype, "productDescription", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true }),
    __metadata("design:type", Number)
], ProductCollection.prototype, "productCodeIndex", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true }),
    __metadata("design:type", String)
], ProductCollection.prototype, "productCode", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose.Schema.Types.ObjectId, ref: product_category_collection_entity_1.ProductCategoryCollection.name }),
    __metadata("design:type", product_category_collection_entity_1.ProductCategoryCollection)
], ProductCollection.prototype, "ProductCategory", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose.Schema.Types.ObjectId, ref: product_sub_category_collection_entity_1.ProductSubCategoryCollection.name }),
    __metadata("design:type", product_sub_category_collection_entity_1.ProductSubCategoryCollection)
], ProductCollection.prototype, "ProductSubCategory", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose.Schema.Types.ObjectId, ref: brand_collection_entity_1.BrandCollection.name }),
    __metadata("design:type", brand_collection_entity_1.BrandCollection)
], ProductCollection.prototype, "Brand", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose.Schema.Types.ObjectId, ref: manufacturer_collection_entity_1.ManufacturerCollection.name }),
    __metadata("design:type", manufacturer_collection_entity_1.ManufacturerCollection)
], ProductCollection.prototype, "Manufacturer", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true }),
    __metadata("design:type", String)
], ProductCollection.prototype, "taxRate", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true, enum: ['DISCOUNT_METHOD', 'MARKUP_METHOD'], default: 'DISCOUNT_METHOD' }),
    __metadata("design:type", String)
], ProductCollection.prototype, "pricingMethod", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose.Schema.Types.ObjectId, ref: unit_collection_entity_1.UnitCollection.name }),
    __metadata("design:type", unit_collection_entity_1.UnitCollection)
], ProductCollection.prototype, "Unit", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true }),
    __metadata("design:type", String)
], ProductCollection.prototype, "hsn", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: false }),
    __metadata("design:type", String)
], ProductCollection.prototype, "countryOfOrigin", void 0);
__decorate([
    (0, mongoose_1.Prop)({ isRequired: true, default: false }),
    __metadata("design:type", Boolean)
], ProductCollection.prototype, "isFeatured", void 0);
__decorate([
    (0, mongoose_1.Prop)({ nullable: true }),
    __metadata("design:type", ProductPhoto)
], ProductCollection.prototype, "productLogo", void 0);
ProductCollection = __decorate([
    (0, mongoose_1.Schema)()
], ProductCollection);
exports.ProductCollection = ProductCollection;
exports.ProductCollectionSchema = mongoose_1.SchemaFactory.createForClass(ProductCollection);
