"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCollectionModule = void 0;
const common_1 = require("@nestjs/common");
const product_collection_service_1 = require("./product-collection.service");
const product_collection_resolver_1 = require("./product-collection.resolver");
const mongoose_1 = require("@nestjs/mongoose");
const product_collection_entity_1 = require("./entities/product-collection.entity");
const product_category_collection_module_1 = require("../product-category-collection/product-category-collection.module");
const product_sub_category_collection_module_1 = require("../product-sub-category-collection/product-sub-category-collection.module");
const unit_collection_module_1 = require("../unit-collection/unit-collection.module");
const brand_collection_module_1 = require("../brand-collection/brand-collection.module");
const manufacturer_collection_module_1 = require("../manufacturer-collection/manufacturer-collection.module");
const user_collection_module_1 = require("../user-collection/user-collection.module");
const current_stock_collection_module_1 = require("../current-stock-collection/current-stock-collection.module");
const wishlist_collection_module_1 = require("../wishlist-collection/wishlist-collection.module");
let ProductCollectionModule = class ProductCollectionModule {
};
ProductCollectionModule = __decorate([
    (0, common_1.Module)({
        imports: [mongoose_1.MongooseModule.forFeature([{ name: product_collection_entity_1.ProductCollection.name, schema: product_collection_entity_1.ProductCollectionSchema }]), (0, common_1.forwardRef)(() => product_category_collection_module_1.ProductCategoryCollectionModule), (0, common_1.forwardRef)(() => product_sub_category_collection_module_1.ProductSubCategoryCollectionModule), unit_collection_module_1.UnitCollectionModule, brand_collection_module_1.BrandCollectionModule, manufacturer_collection_module_1.ManufacturerCollectionModule, user_collection_module_1.UserCollectionModule, (0, common_1.forwardRef)(() => current_stock_collection_module_1.CurrentStockCollectionModule), (0, common_1.forwardRef)(() => wishlist_collection_module_1.WishlistCollectionModule)],
        providers: [product_collection_resolver_1.ProductCollectionResolver, product_collection_service_1.ProductCollectionService],
        exports: [product_collection_service_1.ProductCollectionService]
    })
], ProductCollectionModule);
exports.ProductCollectionModule = ProductCollectionModule;
