/// <reference types="mongoose" />
import { ProductCollectionService } from './product-collection.service';
import { ProductCollection } from './entities/product-collection.entity';
import { CreateProductCollectionInput } from './dto/create-product-collection.input';
import { UpdateProductCollectionInput } from './dto/update-product-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { FileUpload } from 'graphql-upload';
import ProductCollectionResponse from './product.responses';
import ConnectionArgs from 'src/connection.args';
export declare const NEW_PRODUCT_ADD = "NEW_PRODUCT_ADD";
export declare class ProductCollectionResolver {
    private readonly productCollectionService;
    private pubSub;
    constructor(productCollectionService: ProductCollectionService, pubSub: RedisPubSub);
    createProductCollection(user: any, createProductCollectionInput: CreateProductCollectionInput, fileUpload?: FileUpload): Promise<void | {
        status: boolean;
        status_text: string;
        data: ProductCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllProduct(): Promise<(ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    updateProductCollection(updateProductCollectionInput: UpdateProductCollectionInput, fileUpload?: FileUpload): Promise<any>;
    getProductForWebsite(user: any): Promise<(ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    getProductSingleForWebsite(user: any, id: string): Promise<ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    getProductForWebsitePaginated(args: ConnectionArgs, user: any, categoryId?: string, subCategoryId?: string): Promise<ProductCollectionResponse>;
    updateProductCollectionWithOutFile(updateProductCollectionInput: UpdateProductCollectionInput): Promise<any>;
    removeProductCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: ProductCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    productSubscription(): AsyncIterator<unknown, any, undefined>;
}
