"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCollectionResolver = exports.NEW_PRODUCT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const product_collection_service_1 = require("./product-collection.service");
const product_collection_entity_1 = require("./entities/product-collection.entity");
const create_product_collection_input_1 = require("./dto/create-product-collection.input");
const update_product_collection_input_1 = require("./dto/update-product-collection.input");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const product_collection_create_type_1 = require("./types/product-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const graphql_upload_1 = require("graphql-upload");
const uuid_1 = require("uuid");
const path_1 = require("path");
const fs_1 = require("fs");
const product_collection_type_1 = require("./types/product-collection.type");
const new_product_type_1 = require("./types/new-product.type");
const product_responses_1 = __importDefault(require("./product.responses"));
const connection_args_1 = __importDefault(require("../connection.args"));
const graphql_relay_1 = require("graphql-relay");
exports.NEW_PRODUCT_ADD = "NEW_PRODUCT_ADD";
let ProductCollectionResolver = class ProductCollectionResolver {
    constructor(productCollectionService, pubSub) {
        this.productCollectionService = productCollectionService;
        this.pubSub = pubSub;
    }
    createProductCollection(user, createProductCollectionInput, fileUpload) {
        if (fileUpload.filename != undefined) {
            let newFileName = `${(0, uuid_1.v4)()}${(0, path_1.extname)(fileUpload.filename)}`;
            let path = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, 'products', newFileName);
            let sweetPath = `/uploads/products/${newFileName}`;
            return new Promise(async (resolve, reject) => fileUpload.createReadStream()
                .pipe((0, fs_1.createWriteStream)(path))
                .on('finish', () => resolve(true))
                .on('error', () => reject(false)))
                .then(() => {
                return this.productCollectionService.create(createProductCollectionInput, sweetPath, newFileName);
            })
                .catch(() => { });
        }
        else {
            return this.productCollectionService.create(createProductCollectionInput, null, null);
        }
    }
    findAllProduct() {
        return this.productCollectionService.findAll();
    }
    updateProductCollection(updateProductCollectionInput, fileUpload) {
        if (fileUpload.filename != undefined) {
            let newFileName = `${(0, uuid_1.v4)()}${(0, path_1.extname)(fileUpload.filename)}`;
            let path = (0, path_1.join)(__dirname, '..', '..', GlobalConstants_1.UPLOAD_PATH, 'products', newFileName);
            let sweetPath = `/uploads/products/${newFileName}`;
            return new Promise(async (resolve, reject) => fileUpload.createReadStream()
                .pipe((0, fs_1.createWriteStream)(path))
                .on('finish', () => resolve(true))
                .on('error', () => reject(false)))
                .then(() => {
                return this.productCollectionService.update(updateProductCollectionInput.id, updateProductCollectionInput, sweetPath, newFileName);
            })
                .catch(() => { });
        }
        else {
            return this.productCollectionService.update(updateProductCollectionInput.id, updateProductCollectionInput, null, null);
        }
    }
    getProductForWebsite(user) {
        return this.productCollectionService.findAllWithPrice(user.username);
    }
    getProductSingleForWebsite(user, id) {
        return this.productCollectionService.getProductSingleForWebsite(user.username, id);
    }
    async getProductForWebsitePaginated(args, user, categoryId, subCategoryId) {
        const { limit, offset } = args.pagingParams();
        const { result, count } = await this.productCollectionService.findAllWithPricePaginated(user.username, limit, offset, categoryId, subCategoryId);
        const page = (0, graphql_relay_1.connectionFromArraySlice)(result, args, { arrayLength: count, sliceStart: offset || 0 });
        return { page, pageData: { count: count, limit, offset } };
    }
    updateProductCollectionWithOutFile(updateProductCollectionInput) {
        return this.productCollectionService.update(updateProductCollectionInput.id, updateProductCollectionInput, null, null);
    }
    removeProductCollection(id) {
        return this.productCollectionService.remove(id);
    }
    productSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_PRODUCT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_collection_create_type_1.ProductCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createProductCollectionInput')),
    __param(2, (0, graphql_1.Args)({ name: 'file', type: () => graphql_upload_1.GraphQLUpload })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_product_collection_input_1.CreateProductCollectionInput, typeof (_a = typeof graphql_upload_1.FileUpload !== "undefined" && graphql_upload_1.FileUpload) === "function" ? _a : Object]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "createProductCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [product_collection_type_1.ProductCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "findAllProduct", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_collection_create_type_1.ProductCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateProductCollectionInput')),
    __param(1, (0, graphql_1.Args)({ name: 'file', type: () => graphql_upload_1.GraphQLUpload })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_product_collection_input_1.UpdateProductCollectionInput, typeof (_b = typeof graphql_upload_1.FileUpload !== "undefined" && graphql_upload_1.FileUpload) === "function" ? _b : Object]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "updateProductCollection", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard),
    (0, graphql_1.Query)(() => [product_collection_type_1.ProductCollectionType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "getProductForWebsite", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard),
    (0, graphql_1.Query)(() => product_collection_type_1.ProductCollectionType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "getProductSingleForWebsite", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard),
    (0, graphql_1.Query)(() => product_responses_1.default),
    __param(0, (0, graphql_1.Args)()),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __param(2, (0, graphql_1.Args)("categoryId", { nullable: true })),
    __param(3, (0, graphql_1.Args)("subCategoryId", { nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [connection_args_1.default, Object, String, String]),
    __metadata("design:returntype", Promise)
], ProductCollectionResolver.prototype, "getProductForWebsitePaginated", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_collection_create_type_1.ProductCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateProductCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_product_collection_input_1.UpdateProductCollectionInput]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "updateProductCollectionWithOutFile", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_collection_create_type_1.ProductCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "removeProductCollection", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_product_type_1.NewProductAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProductCollectionResolver.prototype, "productSubscription", null);
ProductCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => product_collection_entity_1.ProductCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [product_collection_service_1.ProductCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProductCollectionResolver);
exports.ProductCollectionResolver = ProductCollectionResolver;
