import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { CreateProductCollectionInput } from './dto/create-product-collection.input';
import { UpdateProductCollectionInput } from './dto/update-product-collection.input';
import { ProductCollection, ProductCollectionDocument } from './entities/product-collection.entity';
import { ProductCategoryCollectionService } from 'src/product-category-collection/product-category-collection.service';
import { ProductSubCategoryCollectionService } from 'src/product-sub-category-collection/product-sub-category-collection.service';
import { BrandCollectionService } from 'src/brand-collection/brand-collection.service';
import { UnitCollectionService } from 'src/unit-collection/unit-collection.service';
import { ManufacturerCollectionService } from 'src/manufacturer-collection/manufacturer-collection.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CurrentStockCollectionService } from 'src/current-stock-collection/current-stock-collection.service';
import { WishlistCollectionService } from 'src/wishlist-collection/wishlist-collection.service';
import { ProductCategoryCollection } from 'src/product-category-collection/entities/product-category-collection.entity';
export declare const NEW_PRODUCT_ADD = "NEW_PRODUCT_ADD";
export declare class ProductCollectionService {
    private productRepository;
    private productCategoryService;
    private productSubCategoryService;
    private readonly brandCollectionService;
    private readonly manufacturerCollectionService;
    private readonly unitCollectionService;
    private readonly userCollectionService;
    private currentStockCollectionService;
    private wishlistCollectionService;
    private pubSub;
    constructor(productRepository: Model<ProductCollectionDocument>, productCategoryService: ProductCategoryCollectionService, productSubCategoryService: ProductSubCategoryCollectionService, brandCollectionService: BrandCollectionService, manufacturerCollectionService: ManufacturerCollectionService, unitCollectionService: UnitCollectionService, userCollectionService: UserCollectionService, currentStockCollectionService: CurrentStockCollectionService, wishlistCollectionService: WishlistCollectionService, pubSub: RedisPubSub);
    create(createProductCollectionInput: CreateProductCollectionInput, path: string, filename: string): Promise<{
        status: boolean;
        status_text: string;
        data: ProductCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    padWithZero(num: number, targetLength: number): string;
    getLatestIndex(): Promise<number>;
    getCountByCategory(cat: ProductCategoryCollection): Promise<number>;
    checkIfExists(productName: string): Promise<boolean>;
    findAll(): Promise<(ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findAllWithPrice(username: string): Promise<(ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    getProductSingleForWebsite(username: string, id: string): Promise<ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    findAllWithPricePaginated(username: string, limit: number, offset: number, categoryId?: string, subCategoryId?: string): Promise<{
        result: (ProductCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        })[];
        count: number;
    }>;
    totalProductCount(filter: any): Promise<number>;
    findOneById(id: string): Promise<ProductCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: ProductCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    update(id: string, updateProductCollectionInput: UpdateProductCollectionInput, path: string, filename: string): Promise<any>;
    deleteFileWithFileName(file: any): Promise<boolean>;
}
