"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCollectionService = exports.NEW_PRODUCT_ADD = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_2 = require("mongoose");
const path_1 = __importDefault(require("path"));
const GlobalConstants_1 = require("../helper/GlobalConstants");
const product_collection_entity_1 = require("./entities/product-collection.entity");
const fs = __importStar(require("fs"));
const product_category_collection_service_1 = require("../product-category-collection/product-category-collection.service");
const product_sub_category_collection_service_1 = require("../product-sub-category-collection/product-sub-category-collection.service");
const brand_collection_service_1 = require("../brand-collection/brand-collection.service");
const unit_collection_service_1 = require("../unit-collection/unit-collection.service");
const manufacturer_collection_service_1 = require("../manufacturer-collection/manufacturer-collection.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const current_stock_collection_service_1 = require("../current-stock-collection/current-stock-collection.service");
const wishlist_collection_service_1 = require("../wishlist-collection/wishlist-collection.service");
exports.NEW_PRODUCT_ADD = "NEW_PRODUCT_ADD";
let ProductCollectionService = class ProductCollectionService {
    constructor(productRepository, productCategoryService, productSubCategoryService, brandCollectionService, manufacturerCollectionService, unitCollectionService, userCollectionService, currentStockCollectionService, wishlistCollectionService, pubSub) {
        this.productRepository = productRepository;
        this.productCategoryService = productCategoryService;
        this.productSubCategoryService = productSubCategoryService;
        this.brandCollectionService = brandCollectionService;
        this.manufacturerCollectionService = manufacturerCollectionService;
        this.unitCollectionService = unitCollectionService;
        this.userCollectionService = userCollectionService;
        this.currentStockCollectionService = currentStockCollectionService;
        this.wishlistCollectionService = wishlistCollectionService;
        this.pubSub = pubSub;
    }
    async create(createProductCollectionInput, path, filename) {
        let checkIfExists = await this.checkIfExists(createProductCollectionInput.productName);
        if (!checkIfExists) {
            let cm = new product_collection_entity_1.ProductCollection();
            cm.productName = createProductCollectionInput.productName;
            let pcIndex = await this.getLatestIndex();
            cm.productCodeIndex = pcIndex;
            cm.productCode = this.padWithZero(pcIndex, 5);
            let pc = await this.productCategoryService.findOneById(createProductCollectionInput.productCategoryId);
            cm.ProductCategory = pc;
            let mf = await this.manufacturerCollectionService.findOneById(createProductCollectionInput.manufacturerId);
            cm.Manufacturer = mf;
            let psc = await this.productSubCategoryService.findOneById(createProductCollectionInput.productSubCategoryId);
            cm.ProductSubCategory = psc;
            let brand = await this.brandCollectionService.findOneById(createProductCollectionInput.brandId);
            cm.Brand = brand;
            let unit = await this.unitCollectionService.findOneById(createProductCollectionInput.unitId);
            cm.Unit = unit;
            cm.taxRate = createProductCollectionInput.taxRate;
            cm.pricingMethod = createProductCollectionInput.pricingMethod;
            cm.hsn = createProductCollectionInput.hsn;
            cm.countryOfOrigin = createProductCollectionInput.countryOfOrigin;
            cm.isFeatured = createProductCollectionInput.isFeatured;
            cm.productDescription = createProductCollectionInput.productDescription;
            if (filename != null) {
                cm.productLogo = {
                    fileName: filename,
                    url: path,
                    fileType: 'products'
                };
            }
            let c = await this.productRepository.create(cm);
            this.pubSub.publish(exports.NEW_PRODUCT_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    padWithZero(num, targetLength) {
        return String(num).padStart(targetLength, '0');
    }
    async getLatestIndex() {
        let r = await this.productRepository.find().sort({ productCodeIndex: -1 }).limit(1);
        if (r.length == 0) {
            return 1;
        }
        else {
            return r[0].productCodeIndex + 1;
        }
    }
    async getCountByCategory(cat) {
        return await this.productRepository.count({
            ProductCategory: cat
        }).exec();
    }
    async checkIfExists(productName) {
        let r = await this.productRepository.count({
            productName: productName
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.productRepository.find().populate('ProductCategory').populate('ProductSubCategory').populate('Manufacturer').populate('Brand').populate('Unit').exec();
    }
    async findAllWithPrice(username) {
        let user = await this.userCollectionService.getUserDetailsWithUsername(username);
        let result = await this.productRepository.find().populate('ProductCategory').populate('ProductSubCategory').populate('Manufacturer').populate('Brand').populate('Unit').exec();
        await Promise.all(result.map(async (el, index) => {
            result[index]['currentStock'] = await this.currentStockCollectionService.getStockWithPrice(el, user.Client.discountPercentage, user.Client.markupPercentage);
            result[index]['isWished'] = await this.wishlistCollectionService.checkIfExistsInWishList(username, el);
        }));
        return result;
    }
    async getProductSingleForWebsite(username, id) {
        let user = await this.userCollectionService.getUserDetailsWithUsername(username);
        let result = await this.productRepository.findOne({ _id: id }).populate('ProductCategory').populate('ProductSubCategory').populate('Manufacturer').populate('Brand').populate('Unit').exec();
        result['currentStock'] = await this.currentStockCollectionService.getStockWithPrice(result, user.Client.discountPercentage, user.Client.markupPercentage);
        result['isWished'] = await this.wishlistCollectionService.checkIfExistsInWishList(username, result);
        return result;
    }
    async findAllWithPricePaginated(username, limit, offset, categoryId, subCategoryId) {
        let user = await this.userCollectionService.getUserDetailsWithUsername(username);
        let filter = {};
        if (categoryId && categoryId != "") {
            let prc = await this.productCategoryService.findOneById(categoryId);
            filter.ProductCategory = prc;
        }
        if (subCategoryId && subCategoryId != "") {
            let prc1 = await this.productSubCategoryService.findOneById(subCategoryId);
            filter.ProductSubCategory = prc1;
        }
        let result = await this.productRepository.find(filter).populate('ProductCategory').populate('ProductSubCategory').populate('Manufacturer').populate('Brand').populate('Unit').limit(limit).skip(offset).exec();
        await Promise.all(result.map(async (el, index) => {
            result[index]['currentStock'] = await this.currentStockCollectionService.getStockWithPrice(el, user.Client.discountPercentage, user.Client.markupPercentage);
            result[index]['isWished'] = await this.wishlistCollectionService.checkIfExistsInWishList(username, el);
        }));
        return { result, count: await this.totalProductCount(filter) };
    }
    async totalProductCount(filter) {
        return await this.productRepository.count(filter).exec();
    }
    async findOneById(id) {
        return await this.productRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        let cc = await this.productRepository.findOne({ _id: id }).exec();
        this.deleteFileWithFileName(cc.productLogo);
        await this.productRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_PRODUCT_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: cc
        };
    }
    async update(id, updateProductCollectionInput, path, filename) {
        let cc = await this.productRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.productName = updateProductCollectionInput.productName;
            if (filename != null) {
                this.deleteFileWithFileName(cc.productLogo);
                cc.productLogo = {
                    fileName: filename,
                    url: path,
                    fileType: 'products'
                };
            }
            let pc = await this.productCategoryService.findOneById(updateProductCollectionInput.productCategoryId);
            cc.ProductCategory = pc;
            let mf = await this.manufacturerCollectionService.findOneById(updateProductCollectionInput.manufacturerId);
            cc.Manufacturer = mf;
            let psc = await this.productSubCategoryService.findOneById(updateProductCollectionInput.productSubCategoryId);
            cc.ProductSubCategory = psc;
            let brand = await this.brandCollectionService.findOneById(updateProductCollectionInput.brandId);
            cc.Brand = brand;
            let unit = await this.unitCollectionService.findOneById(updateProductCollectionInput.unitId);
            cc.Unit = unit;
            cc.taxRate = updateProductCollectionInput.taxRate;
            cc.pricingMethod = updateProductCollectionInput.pricingMethod;
            cc.hsn = updateProductCollectionInput.hsn;
            cc.countryOfOrigin = updateProductCollectionInput.countryOfOrigin;
            cc.isFeatured = updateProductCollectionInput.isFeatured;
            cc.productDescription = updateProductCollectionInput.productDescription;
            let cc1 = await this.productRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_PRODUCT_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
    async deleteFileWithFileName(file) {
        if (file.url != undefined) {
            let p = path_1.default.join(__dirname, '..', '..', 'uploads', 'products', file.fileName);
            let ifExists = fs.existsSync(p);
            if (ifExists) {
                fs.unlinkSync(p);
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }
};
ProductCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(product_collection_entity_1.ProductCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => product_category_collection_service_1.ProductCategoryCollectionService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => product_sub_category_collection_service_1.ProductSubCategoryCollectionService))),
    __param(7, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_collection_service_1.CurrentStockCollectionService))),
    __param(8, (0, common_1.Inject)((0, common_1.forwardRef)(() => wishlist_collection_service_1.WishlistCollectionService))),
    __param(9, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_category_collection_service_1.ProductCategoryCollectionService,
        product_sub_category_collection_service_1.ProductSubCategoryCollectionService,
        brand_collection_service_1.BrandCollectionService,
        manufacturer_collection_service_1.ManufacturerCollectionService,
        unit_collection_service_1.UnitCollectionService,
        user_collection_service_1.UserCollectionService,
        current_stock_collection_service_1.CurrentStockCollectionService,
        wishlist_collection_service_1.WishlistCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProductCollectionService);
exports.ProductCollectionService = ProductCollectionService;
