"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductSizeCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const product_size_collection_service_1 = require("./product-size-collection.service");
const product_size_collection_entity_1 = require("./entities/product-size-collection.entity");
const create_product_size_collection_input_1 = require("./input/create-product-size-collection.input");
const update_product_size_collection_input_1 = require("./input/update-product-size-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const product_size_collection_create_type_1 = require("./types/product-size-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const product_size_collection_type_1 = require("./types/product-size-collection.type");
let ProductSizeCollectionResolver = class ProductSizeCollectionResolver {
    constructor(productSizeCollectionService) {
        this.productSizeCollectionService = productSizeCollectionService;
    }
    createProductSizeCollection(user, createProductSizeCollectionInput) {
        return this.productSizeCollectionService.create(createProductSizeCollectionInput);
    }
    findAllProductSize() {
        return this.productSizeCollectionService.findAll();
    }
    updateProductSizeCollection(updateProductSizeCollectionInput) {
        return this.productSizeCollectionService.update(updateProductSizeCollectionInput.id, updateProductSizeCollectionInput);
    }
    removeProductSizeCollection(id) {
        return this.productSizeCollectionService.remove(id);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_size_collection_create_type_1.ProductSizeCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createProductSizeCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_product_size_collection_input_1.CreateProductSizeCollectionInput]),
    __metadata("design:returntype", void 0)
], ProductSizeCollectionResolver.prototype, "createProductSizeCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [product_size_collection_type_1.ProductSizeCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProductSizeCollectionResolver.prototype, "findAllProductSize", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_size_collection_create_type_1.ProductSizeCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateProductSizeCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_product_size_collection_input_1.UpdateProductSizeCollectionInput]),
    __metadata("design:returntype", void 0)
], ProductSizeCollectionResolver.prototype, "updateProductSizeCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_size_collection_create_type_1.ProductSizeCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ProductSizeCollectionResolver.prototype, "removeProductSizeCollection", null);
ProductSizeCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => product_size_collection_entity_1.ProductSizeCollection),
    __metadata("design:paramtypes", [product_size_collection_service_1.ProductSizeCollectionService])
], ProductSizeCollectionResolver);
exports.ProductSizeCollectionResolver = ProductSizeCollectionResolver;
