"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductSizeCollectionService = void 0;
const common_1 = require("@nestjs/common");
const product_size_collection_entity_1 = require("./entities/product-size-collection.entity");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
let ProductSizeCollectionService = class ProductSizeCollectionService {
    constructor(productSizeRepository) {
        this.productSizeRepository = productSizeRepository;
    }
    async create(createProductSizeCollectionInput) {
        let checkIfExists = await this.checkIfExists(createProductSizeCollectionInput.productSize);
        if (!checkIfExists) {
            let cm = new product_size_collection_entity_1.ProductSizeCollection();
            cm.productSize = createProductSizeCollectionInput.productSize;
            let c = await this.productSizeRepository.create(cm);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(productSize) {
        let r = await this.productSizeRepository.count({
            productSize: productSize
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.productSizeRepository.find().exec();
    }
    async findOneById(id) {
        return await this.productSizeRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        await this.productSizeRepository.deleteOne({ _id: id });
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: []
        };
    }
    async update(id, updateProductSizeCollectionInput) {
        let cc = await this.productSizeRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.productSize = updateProductSizeCollectionInput.productSize;
            let cc1 = await this.productSizeRepository.updateOne({ _id: id }, cc);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: cc
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
ProductSizeCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(product_size_collection_entity_1.ProductSizeCollection.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], ProductSizeCollectionService);
exports.ProductSizeCollectionService = ProductSizeCollectionService;
