/// <reference types="mongoose" />
import { ProductSubCategoryCollectionService } from './product-sub-category-collection.service';
import { ProductSubCategoryCollection } from './entities/product-sub-category-collection.entity';
import { CreateProductSubCategoryCollectionInput } from './input/create-product-sub-category-collection.input';
import { UpdateProductSubCategoryCollectionInput } from './input/update-product-sub-category-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SUB_CATEGORY_ADD = "NEW_SUB_CATEGORY_ADD";
export declare class ProductSubCategoryCollectionResolver {
    private readonly productSubCategoryCollectionService;
    private pubSub;
    constructor(productSubCategoryCollectionService: ProductSubCategoryCollectionService, pubSub: RedisPubSub);
    createProductSubCategoryCollection(user: any, createProductSubCategoryCollectionInput: CreateProductSubCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    findAllProductSubCategory(): Promise<(import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findAllProductSubCategoryForWebsiteForWebsite(categoryId: string): Promise<(import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    updateProductSubCategoryCollection(updateProductSubCategoryCollectionInput: UpdateProductSubCategoryCollectionInput): Promise<any>;
    removeProductSubCategoryCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    productSubCategorySubscription(): AsyncIterator<unknown, any, undefined>;
}
