"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductSubCategoryCollectionResolver = exports.NEW_SUB_CATEGORY_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const product_sub_category_collection_service_1 = require("./product-sub-category-collection.service");
const product_sub_category_collection_entity_1 = require("./entities/product-sub-category-collection.entity");
const create_product_sub_category_collection_input_1 = require("./input/create-product-sub-category-collection.input");
const update_product_sub_category_collection_input_1 = require("./input/update-product-sub-category-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const product_sub_category_collection_create_type_1 = require("./types/product-sub-category-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const product_sub_category_collection_type_1 = require("./types/product-sub-category-collection.type");
const new_product_category_type_1 = require("../product-category-collection/types/new-product-category.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_SUB_CATEGORY_ADD = "NEW_SUB_CATEGORY_ADD";
let ProductSubCategoryCollectionResolver = class ProductSubCategoryCollectionResolver {
    constructor(productSubCategoryCollectionService, pubSub) {
        this.productSubCategoryCollectionService = productSubCategoryCollectionService;
        this.pubSub = pubSub;
    }
    createProductSubCategoryCollection(user, createProductSubCategoryCollectionInput) {
        return this.productSubCategoryCollectionService.create(createProductSubCategoryCollectionInput);
    }
    findAllProductSubCategory() {
        return this.productSubCategoryCollectionService.findAll();
    }
    findAllProductSubCategoryForWebsiteForWebsite(categoryId) {
        return this.productSubCategoryCollectionService.findAllWithCategory(categoryId);
    }
    updateProductSubCategoryCollection(updateProductSubCategoryCollectionInput) {
        return this.productSubCategoryCollectionService.update(updateProductSubCategoryCollectionInput.id, updateProductSubCategoryCollectionInput);
    }
    removeProductSubCategoryCollection(id) {
        return this.productSubCategoryCollectionService.remove(id);
    }
    productSubCategorySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SUB_CATEGORY_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_sub_category_collection_create_type_1.ProductSubCategoryCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createProductSubCategoryCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_product_sub_category_collection_input_1.CreateProductSubCategoryCollectionInput]),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "createProductSubCategoryCollection", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [product_sub_category_collection_type_1.ProductSubCategoryCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "findAllProductSubCategory", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [product_sub_category_collection_type_1.ProductSubCategoryCollectionType]),
    __param(0, (0, graphql_1.Args)('categoryId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "findAllProductSubCategoryForWebsiteForWebsite", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_sub_category_collection_create_type_1.ProductSubCategoryCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateProductSubCategoryCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_product_sub_category_collection_input_1.UpdateProductSubCategoryCollectionInput]),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "updateProductSubCategoryCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => product_sub_category_collection_create_type_1.ProductSubCategoryCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "removeProductSubCategoryCollection", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_product_category_type_1.NewCategoryAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ProductSubCategoryCollectionResolver.prototype, "productSubCategorySubscription", null);
ProductSubCategoryCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => product_sub_category_collection_entity_1.ProductSubCategoryCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [product_sub_category_collection_service_1.ProductSubCategoryCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProductSubCategoryCollectionResolver);
exports.ProductSubCategoryCollectionResolver = ProductSubCategoryCollectionResolver;
