import { CreateProductSubCategoryCollectionInput } from './input/create-product-sub-category-collection.input';
import { UpdateProductSubCategoryCollectionInput } from './input/update-product-sub-category-collection.input';
import { ProductSubCategoryCollection } from './entities/product-sub-category-collection.entity';
import { ProductCategoryCollectionService } from 'src/product-category-collection/product-category-collection.service';
import { Model } from 'mongoose';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SUB_CATEGORY_ADD = "NEW_SUB_CATEGORY_ADD";
export declare class ProductSubCategoryCollectionService {
    private productSubCategoryRepository;
    private productCategoryService;
    private pubSub;
    constructor(productSubCategoryRepository: Model<ProductSubCategoryCollection>, productCategoryService: ProductCategoryCollectionService, pubSub: RedisPubSub);
    create(createProductSubCategoryCollectionInput: CreateProductSubCategoryCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    checkIfExists(subCategoryCode: string): Promise<boolean>;
    findAll(): Promise<(import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findAllWithCategory(categoryId: string): Promise<(import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findOneById(id: string): Promise<import("mongoose").Document<unknown, any, ProductSubCategoryCollection> & ProductSubCategoryCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateProductSubCategoryCollectionInput: UpdateProductSubCategoryCollectionInput): Promise<any>;
}
