"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductSubCategoryCollectionService = exports.NEW_SUB_CATEGORY_ADD = void 0;
const common_1 = require("@nestjs/common");
const product_sub_category_collection_entity_1 = require("./entities/product-sub-category-collection.entity");
const product_category_collection_service_1 = require("../product-category-collection/product-category-collection.service");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_SUB_CATEGORY_ADD = "NEW_SUB_CATEGORY_ADD";
let ProductSubCategoryCollectionService = class ProductSubCategoryCollectionService {
    constructor(productSubCategoryRepository, productCategoryService, pubSub) {
        this.productSubCategoryRepository = productSubCategoryRepository;
        this.productCategoryService = productCategoryService;
        this.pubSub = pubSub;
    }
    async create(createProductSubCategoryCollectionInput) {
        let checkIfExists = await this.checkIfExists(createProductSubCategoryCollectionInput.subCategoryCode);
        if (!checkIfExists) {
            let pc = await this.productCategoryService.findOneById(createProductSubCategoryCollectionInput.productCategoryId);
            let cm = new product_sub_category_collection_entity_1.ProductSubCategoryCollection();
            cm.productSubCategory = createProductSubCategoryCollectionInput.productSubCategory;
            cm.subCategoryCode = createProductSubCategoryCollectionInput.subCategoryCode;
            cm.ProductCategory = pc;
            let c = await this.productSubCategoryRepository.create(cm);
            this.pubSub.publish(exports.NEW_SUB_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(subCategoryCode) {
        let r = await this.productSubCategoryRepository.count({
            subCategoryCode: subCategoryCode
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAll() {
        let result = await this.productSubCategoryRepository.find().populate('ProductCategory').exec();
        return result;
    }
    async findAllWithCategory(categoryId) {
        let pc = await this.productCategoryService.findOneById(categoryId);
        let result = await this.productSubCategoryRepository.find({
            ProductCategory: pc
        }).populate('ProductCategory').exec();
        return result;
    }
    async findOneById(id) {
        return await this.productSubCategoryRepository.findOne({ _id: id }).populate('ProductCategory').exec();
    }
    async remove(id) {
        await this.productSubCategoryRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_SUB_CATEGORY_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: null
        };
    }
    async update(id, updateProductSubCategoryCollectionInput) {
        let cc = await this.productSubCategoryRepository.findOne({ _id: id }).exec();
        if (cc) {
            let pc = await this.productCategoryService.findOneById(updateProductSubCategoryCollectionInput.productCategoryId);
            cc.productSubCategory = updateProductSubCategoryCollectionInput.productSubCategory;
            cc.ProductCategory = pc;
            let cc1 = await this.productSubCategoryRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_SUB_CATEGORY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
ProductSubCategoryCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(product_sub_category_collection_entity_1.ProductSubCategoryCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => product_category_collection_service_1.ProductCategoryCollectionService))),
    __param(2, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_category_collection_service_1.ProductCategoryCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ProductSubCategoryCollectionService);
exports.ProductSubCategoryCollectionService = ProductSubCategoryCollectionService;
