"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RationSubTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const ingredient_table_service_1 = require("../ingredient-table/ingredient-table.service");
const typeorm_2 = require("typeorm");
const ration_sub_table_entity_1 = require("./entity/ration-sub-table.entity");
let RationSubTableService = class RationSubTableService {
    constructor(rationSubTableRepository, ingredientTableService) {
        this.rationSubTableRepository = rationSubTableRepository;
        this.ingredientTableService = ingredientTableService;
    }
    async create(createRationSubTableInput, rationTable) {
        await this.deleteSpecific(rationTable);
        for (const el of createRationSubTableInput) {
            let ingredientTable = await this.ingredientTableService.findOne(el.ingredientId);
            let rst = new ration_sub_table_entity_1.RationSubTable();
            rst.IngredientTable = ingredientTable;
            rst.RationTable = rationTable;
            rst.value = el.value;
            await this.rationSubTableRepository.save(rst);
        }
        return true;
    }
    async fetchSubTable(rationTable) {
        let result = await this.rationSubTableRepository.find({
            where: {
                RationTable: {
                    rationId: rationTable.rationId
                }
            },
            relations: {
                IngredientTable: true
            }
        });
        return result;
    }
    async deleteSpecific(rationTable) {
        let result = await this.rationSubTableRepository.find({
            where: {
                RationTable: {
                    rationId: rationTable.rationId
                }
            }
        });
        if (result) {
            await this.rationSubTableRepository.remove(result);
            return true;
        }
        else {
            return false;
        }
    }
};
RationSubTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(ration_sub_table_entity_1.RationSubTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => ingredient_table_service_1.IngredientTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        ingredient_table_service_1.IngredientTableService])
], RationSubTableService);
exports.RationSubTableService = RationSubTableService;
