import { RedisPubSub } from 'graphql-redis-subscriptions';
import { RationTable } from './entities/ration-table.entity';
import { RationTableService } from './ration-table.service';
import { CreateRationTableInput } from './dto/create-ration-table.input';
import { UpdateRationTableInput } from './dto/update-ration-table.input';
export declare const NEW_RATION_ADD = "NEW_RATION_ADD";
export declare class RationTableResolver {
    private readonly rationTableService;
    private pubSub;
    constructor(rationTableService: RationTableService, pubSub: RedisPubSub);
    createRationTable(createRationTableInput: CreateRationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: RationTable;
    }>;
    findAllRation(): Promise<RationTable[]>;
    findOneRation(rationId: number): Promise<RationTable>;
    updateRationTable(updateRationTableInput: UpdateRationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: RationTable;
    }>;
    removeRationTable(rationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    rationSubscription(): AsyncIterator<unknown, any, undefined>;
}
