"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RationTableResolver = exports.NEW_RATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const ration_table_entity_1 = require("./entities/ration-table.entity");
const ration_table_service_1 = require("./ration-table.service");
const ration_table_return_type_1 = require("./types/ration-table-return.type");
const create_ration_table_input_1 = require("./dto/create-ration-table.input");
const ration_table_table_type_1 = require("./types/ration-table-table.type");
const update_ration_table_input_1 = require("./dto/update-ration-table.input");
const ration_count_changed_type_1 = require("./types/ration-count-changed.type");
exports.NEW_RATION_ADD = "NEW_RATION_ADD";
let RationTableResolver = class RationTableResolver {
    constructor(rationTableService, pubSub) {
        this.rationTableService = rationTableService;
        this.pubSub = pubSub;
    }
    createRationTable(createRationTableInput) {
        return this.rationTableService.create(createRationTableInput);
    }
    findAllRation() {
        return this.rationTableService.findAll();
    }
    findOneRation(rationId) {
        return this.rationTableService.findOne(rationId);
    }
    updateRationTable(updateRationTableInput) {
        return this.rationTableService.update(updateRationTableInput.rationId, updateRationTableInput);
    }
    removeRationTable(rationId) {
        return this.rationTableService.remove(rationId);
    }
    rationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_RATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ration_table_return_type_1.RationTableReturnType),
    __param(0, (0, graphql_1.Args)('createRationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_ration_table_input_1.CreateRationTableInput]),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "createRationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [ration_table_table_type_1.RationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "findAllRation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => ration_table_table_type_1.RationTableType),
    __param(0, (0, graphql_1.Args)('rationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "findOneRation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ration_table_return_type_1.RationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateRationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_ration_table_input_1.UpdateRationTableInput]),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "updateRationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => ration_table_return_type_1.RationTableReturnType),
    __param(0, (0, graphql_1.Args)('rationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "removeRationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => ration_count_changed_type_1.RationCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], RationTableResolver.prototype, "rationSubscription", null);
RationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => ration_table_entity_1.RationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [ration_table_service_1.RationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], RationTableResolver);
exports.RationTableResolver = RationTableResolver;
