import { RedisPubSub } from 'graphql-redis-subscriptions';
import { BrandTableService } from 'src/brand-table/brand-table.service';
import { RationSubTableService } from 'src/ration-sub-table/ration-sub-table.service';
import { Repository } from 'typeorm';
import { CreateRationTableInput } from './dto/create-ration-table.input';
import { UpdateRationTableInput } from './dto/update-ration-table.input';
import { RationTable } from './entities/ration-table.entity';
export declare const NEW_RATION_ADD = "NEW_RATION_ADD";
export declare class RationTableService {
    private readonly rationTableRepository;
    private pubSub;
    private readonly brandTableService;
    private readonly rationSubTableService;
    constructor(rationTableRepository: Repository<RationTable>, pubSub: RedisPubSub, brandTableService: BrandTableService, rationSubTableService: RationSubTableService);
    create(createRationTableInput: CreateRationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: RationTable;
    }>;
    checkIfExists(createRationTableInput: CreateRationTableInput): Promise<boolean>;
    findAll(): Promise<RationTable[]>;
    findOne(rationId: number): Promise<RationTable>;
    update(rationId: number, updateRationTableInput: UpdateRationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: RationTable;
    }>;
    remove(rationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
