import { ReligionTableService } from './religion-table.service';
import { ReligionTable } from './entities/religion-table.entity';
import { CreateReligionTableInput } from './dto/create-religion-table.input';
import { UpdateReligionTableInput } from './dto/update-religion-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_RELIGION_ADD = "NEW_RELIGION_ADD";
export declare class ReligionTableResolver {
    private readonly religionTableService;
    private pubSub;
    constructor(religionTableService: ReligionTableService, pubSub: RedisPubSub);
    createReligionTable(createReligionTableInput: CreateReligionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ReligionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllReligion(): Promise<ReligionTable[]>;
    findOneReligion(religionId: number): Promise<ReligionTable>;
    updateReligionTable(updateReligionTableInput: UpdateReligionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ReligionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeReligionTable(religionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    religionSubscription(): AsyncIterator<unknown, any, undefined>;
}
