"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReligionTableResolver = exports.NEW_RELIGION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const religion_table_service_1 = require("./religion-table.service");
const religion_table_entity_1 = require("./entities/religion-table.entity");
const create_religion_table_input_1 = require("./dto/create-religion-table.input");
const update_religion_table_input_1 = require("./dto/update-religion-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const religion_table_return_type_1 = require("./types/religion-table-return.type");
const religion_table_type_1 = require("./types/religion-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_RELIGION_ADD = "NEW_RELIGION_ADD";
let ReligionTableResolver = exports.ReligionTableResolver = class ReligionTableResolver {
    constructor(religionTableService, pubSub) {
        this.religionTableService = religionTableService;
        this.pubSub = pubSub;
    }
    createReligionTable(createReligionTableInput) {
        return this.religionTableService.create(createReligionTableInput);
    }
    findAllReligion() {
        return this.religionTableService.findAll();
    }
    findOneReligion(religionId) {
        return this.religionTableService.findOne(religionId);
    }
    updateReligionTable(updateReligionTableInput) {
        return this.religionTableService.update(updateReligionTableInput.religionId, updateReligionTableInput);
    }
    removeReligionTable(religionId) {
        return this.religionTableService.remove(religionId);
    }
    religionSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_RELIGION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => religion_table_return_type_1.ReligionTableReturnType),
    __param(0, (0, graphql_1.Args)('createReligionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_religion_table_input_1.CreateReligionTableInput]),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "createReligionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [religion_table_type_1.ReligionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "findAllReligion", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => religion_table_type_1.ReligionTableType),
    __param(0, (0, graphql_1.Args)('religionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "findOneReligion", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => religion_table_return_type_1.ReligionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateReligionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_religion_table_input_1.UpdateReligionTableInput]),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "updateReligionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => religion_table_return_type_1.ReligionTableReturnType),
    __param(0, (0, graphql_1.Args)('religionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "removeReligionTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ReligionTableResolver.prototype, "religionSubscription", null);
exports.ReligionTableResolver = ReligionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => religion_table_entity_1.ReligionTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [religion_table_service_1.ReligionTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ReligionTableResolver);
