import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateReligionTableInput } from './dto/create-religion-table.input';
import { UpdateReligionTableInput } from './dto/update-religion-table.input';
import { ReligionTable } from './entities/religion-table.entity';
export declare const NEW_RELIGION_ADD = "NEW_RELIGION_ADD";
export declare class ReligionTableService {
    private readonly religionTableRepository;
    private pubSub;
    constructor(religionTableRepository: Repository<ReligionTable>, pubSub: RedisPubSub);
    create(createReligionTableInput: CreateReligionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ReligionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createReligionTableInput: CreateReligionTableInput): Promise<number>;
    findAll(): Promise<ReligionTable[]>;
    findOne(religionId: number): Promise<ReligionTable>;
    update(religionId: number, updateReligionTableInput: UpdateReligionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ReligionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(religionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
