"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReligionTableService = exports.NEW_RELIGION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const religion_table_entity_1 = require("./entities/religion-table.entity");
exports.NEW_RELIGION_ADD = "NEW_RELIGION_ADD";
let ReligionTableService = exports.ReligionTableService = class ReligionTableService {
    constructor(religionTableRepository, pubSub) {
        this.religionTableRepository = religionTableRepository;
        this.pubSub = pubSub;
    }
    async create(createReligionTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createReligionTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new religion_table_entity_1.ReligionTable();
            st.religionName = createReligionTableInput.religionName;
            let result = await this.religionTableRepository.save(st);
            this.pubSub.publish(exports.NEW_RELIGION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createReligionTableInput) {
        let result = await this.religionTableRepository.count({
            where: {
                religionName: createReligionTableInput.religionName
            }
        });
        return result;
    }
    async findAll() {
        return await this.religionTableRepository.find();
    }
    async findOne(religionId) {
        return await this.religionTableRepository.findOne({
            where: {
                religionId
            }
        });
    }
    async update(religionId, updateReligionTableInput) {
        let result = await this.findOne(religionId);
        if (result) {
            result.religionName = updateReligionTableInput.religionName;
            let updatedResult = await this.religionTableRepository.save(result);
            this.pubSub.publish(exports.NEW_RELIGION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(religionId) {
        let result = await this.findOne(religionId);
        if (result) {
            await this.religionTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_RELIGION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.ReligionTableService = ReligionTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(religion_table_entity_1.ReligionTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], ReligionTableService);
