"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaleEntrySubTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const sale_entry_sub_table_return_type_1 = require("./types/sale-entry-sub-table-return.type");
const marketing_return_type_1 = require("./types/marketing-return.type");
const sale_entry_sub_table_entity_1 = require("./entities/sale-entry-sub-table.entity");
const create_sale_entry_sub_table_input_1 = require("./dto/create-sale-entry-sub-table.input");
const sale_entry_sub_table_service_1 = require("./sale-entry-sub-table.service");
const sale_entry_sub_table_type_1 = require("./types/sale-entry-sub-table.type");
const sale_report_type_1 = require("./types/sale-report.type");
const sale_summary_districtwise_type_1 = require("./types/sale-summary-districtwise.type");
const sale_summary_grapgh_type_1 = require("./types/sale-summary-grapgh.type");
let SaleEntrySubTableResolver = class SaleEntrySubTableResolver {
    constructor(saleEntrySubTableService) {
        this.saleEntrySubTableService = saleEntrySubTableService;
    }
    createSaleEntrySubTable(createSaleEntrySubTableInput, user) {
        return this.saleEntrySubTableService.create(createSaleEntrySubTableInput, user);
    }
    findAllSaleEntrySub() {
        return this.saleEntrySubTableService.findAll();
    }
    findSaleEntrySubByAnimalId(animalId) {
        return this.saleEntrySubTableService.findByAnimalId(animalId);
    }
    findSaleEntrySubById(saleEntryId) {
        return this.saleEntrySubTableService.findOne(saleEntryId);
    }
    findSaleMarketing(startDate, endDate, farmerId) {
        return this.saleEntrySubTableService.findMarketingData(startDate, endDate, farmerId);
    }
    getSaleDetailsOfOneAnimal(animalId) {
        return this.saleEntrySubTableService.getSaleDetailsOfOneAnimal(animalId);
    }
    getSaleReportDistrictWise(districtId, startingDate, endingDate) {
        return this.saleEntrySubTableService.getSaleReportDistrictWise(districtId, startingDate, endingDate);
    }
    getSaleReportSumarryDistrictWise() {
        return this.saleEntrySubTableService.getSaleReportSumarryDistrictWise();
    }
    getSalesVolumeDistrictMonthWise(districtId, year) {
        return this.saleEntrySubTableService.getSalesVolumeDistrictMonthWise(districtId, year);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sale_entry_sub_table_return_type_1.SaleEntrySubTableReturnType),
    __param(0, (0, graphql_1.Args)('createSaleEntrySubTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_sale_entry_sub_table_input_1.CreateSaleEntrySubTableInput, Object]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "createSaleEntrySubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_sub_table_type_1.SaleEntrySubTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "findAllSaleEntrySub", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_sub_table_type_1.SaleEntrySubTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "findSaleEntrySubByAnimalId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sale_entry_sub_table_type_1.SaleEntrySubTableType),
    __param(0, (0, graphql_1.Args)('saleEntryId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "findSaleEntrySubById", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => marketing_return_type_1.MarketingReturnType),
    __param(0, (0, graphql_1.Args)('startDate', { type: () => String })),
    __param(1, (0, graphql_1.Args)('endDate', { type: () => String })),
    __param(2, (0, graphql_1.Args)('farmerId', { type: () => Number, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Number]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "findSaleMarketing", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_sub_table_type_1.SaleEntrySubTableType]),
    __param(0, (0, graphql_1.Args)('animalId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "getSaleDetailsOfOneAnimal", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_report_type_1.SaleReport]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('startingDate', { type: () => String })),
    __param(2, (0, graphql_1.Args)('endingDate', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "getSaleReportDistrictWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_summary_districtwise_type_1.SaleSummaryReport]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "getSaleReportSumarryDistrictWise", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_summary_grapgh_type_1.SaleSummaryGraph]),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int, nullable: true })),
    __param(1, (0, graphql_1.Args)('year', { type: () => String, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String]),
    __metadata("design:returntype", void 0)
], SaleEntrySubTableResolver.prototype, "getSalesVolumeDistrictMonthWise", null);
SaleEntrySubTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => sale_entry_sub_table_entity_1.SaleEntrySubTable),
    __metadata("design:paramtypes", [sale_entry_sub_table_service_1.SaleEntrySubTableService])
], SaleEntrySubTableResolver);
exports.SaleEntrySubTableResolver = SaleEntrySubTableResolver;
