import { Repository } from "typeorm";
import { HousingTableService } from "src/housing-table/housing-table.service";
import { CurrentStockTableService } from "src/current-stock/current-stock-table.service";
import { StockBalanceTableService } from "src/stock-balance/stock-balance-table.service";
import { LedgerEntryTableService } from "src/ledger-table/ledger-entry-table.service";
import { AnimalEntryTableService } from "src/animal-table/animal-entry-table.service";
import { SaleEntrySubTable } from "./entities/sale-entry-sub-table.entity";
import { CreateSaleEntrySubTableInput } from "./dto/create-sale-entry-sub-table.input";
import { SaleEntryTableService } from "src/sale-entry/sale-entry-table.service";
import { SubDivisionTableService } from "src/sub-division-table/sub-division-table.service";
import { DistrictTableService } from "src/district-table/district-table.service";
export declare class SaleEntrySubTableService {
    private readonly saleEntrySubTableRepository;
    private readonly housingTableService;
    private readonly currentStockTableService;
    private readonly stockBalanceTableService;
    private readonly ledgerEntryTableService;
    private readonly animalEntryTableService;
    private readonly saleEntryTableService;
    private readonly subDivisionTableService;
    private readonly districtTableService;
    constructor(saleEntrySubTableRepository: Repository<SaleEntrySubTable>, housingTableService: HousingTableService, currentStockTableService: CurrentStockTableService, stockBalanceTableService: StockBalanceTableService, ledgerEntryTableService: LedgerEntryTableService, animalEntryTableService: AnimalEntryTableService, saleEntryTableService: SaleEntryTableService, subDivisionTableService: SubDivisionTableService, districtTableService: DistrictTableService);
    create(createSaleEntrySubTableInput: CreateSaleEntrySubTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: SaleEntrySubTable;
    }>;
    findByAnimalId(animalId: number): Promise<SaleEntrySubTable[]>;
    findAll(): Promise<SaleEntrySubTable[]>;
    findOne(saleEntryId: number): Promise<SaleEntrySubTable>;
    findAllSaleEntryByHousingId(housingId: number): Promise<SaleEntrySubTable[]>;
    findMarketingData(startDate: string, endDate: string, farmerId?: number): Promise<{
        status: boolean;
        data: string[];
    }>;
    getSaleDetailsOfOneAnimal(animalId: number): Promise<SaleEntrySubTable[]>;
    getSaleReportDistrictWise(districtId: number, startingDate: string, endingDate: string): Promise<any>;
    getSaleReportSumarryDistrictWise(): Promise<any>;
    getSalesVolumeDistrictMonthWise(districtId: number, year: string): Promise<any>;
}
