"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaleEntrySubTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const typeorm_2 = require("typeorm");
const moment_1 = __importDefault(require("moment"));
const housing_table_service_1 = require("../housing-table/housing-table.service");
const current_stock_table_service_1 = require("../current-stock/current-stock-table.service");
const stock_balance_table_service_1 = require("../stock-balance/stock-balance-table.service");
const ledger_entry_table_service_1 = require("../ledger-table/ledger-entry-table.service");
const animal_entry_table_service_1 = require("../animal-table/animal-entry-table.service");
const sale_entry_sub_table_entity_1 = require("./entities/sale-entry-sub-table.entity");
const sale_entry_table_service_1 = require("../sale-entry/sale-entry-table.service");
const animal_entry_table_entity_1 = require("../animal-table/entities/animal-entry-table.entity");
const sale_entry_table_entity_1 = require("../sale-entry/entities/sale-entry-table.entity");
const sub_division_table_service_1 = require("../sub-division-table/sub-division-table.service");
const housing_table_entity_1 = require("../housing-table/entities/housing-table.entity");
const farmers_table_entity_1 = require("../farmers-table/entities/farmers-table.entity");
const district_table_service_1 = require("../district-table/district-table.service");
let SaleEntrySubTableService = class SaleEntrySubTableService {
    constructor(saleEntrySubTableRepository, housingTableService, currentStockTableService, stockBalanceTableService, ledgerEntryTableService, animalEntryTableService, saleEntryTableService, subDivisionTableService, districtTableService) {
        this.saleEntrySubTableRepository = saleEntrySubTableRepository;
        this.housingTableService = housingTableService;
        this.currentStockTableService = currentStockTableService;
        this.stockBalanceTableService = stockBalanceTableService;
        this.ledgerEntryTableService = ledgerEntryTableService;
        this.animalEntryTableService = animalEntryTableService;
        this.saleEntryTableService = saleEntryTableService;
        this.subDivisionTableService = subDivisionTableService;
        this.districtTableService = districtTableService;
    }
    async create(createSaleEntrySubTableInput, user) {
        let saleEntry = await this.saleEntryTableService.findOne(createSaleEntrySubTableInput.saleEntryId);
        if (Array.isArray(createSaleEntrySubTableInput.animalData) && createSaleEntrySubTableInput.animalData.length > 0) {
            for (const el of createSaleEntrySubTableInput.animalData) {
                let ht = new sale_entry_sub_table_entity_1.SaleEntrySubTable();
                let animalTable = await this.animalEntryTableService.findByAnimalId(el.animalId);
                let temp = {
                    dateOfEntry: createSaleEntrySubTableInput.dateOfEntry,
                    housingId: animalTable.HousingTable.housingId,
                    breedId: animalTable.BreedTable.breedId,
                    ageGroup: animalTable.age,
                    qtyMale: animalTable.gender == "MALE" ? -1 : 0,
                    qtyFemale: animalTable.gender == "FEMALE" ? -1 : 0,
                    qtyTotal: -1,
                    totalWeight: -animalTable.weight,
                };
                let cs = await this.currentStockTableService.create(temp);
                if (cs.status) {
                    ht.AnimalTable = animalTable;
                    ht.weight = el.weight;
                    ht.ratePerKg = el.ratePerKg;
                    ht.amount = el.amount;
                    ht.dateOfEntry = createSaleEntrySubTableInput.dateOfEntry;
                    ht.SaleEntryTable = saleEntry;
                    let sb = await this.stockBalanceTableService.create(temp);
                    if (sb.status) {
                        let result = await this.saleEntrySubTableRepository.save(ht);
                        let temp2 = Object.assign(Object.assign({}, temp), { entryType: "SALE", qtyMale: animalTable.gender == "MALE" ? 1 : 0, qtyFemale: animalTable.gender == "FEMALE" ? 1 : 0, qtyTotal: 1, avgWeight: el.weight, referenceId: createSaleEntrySubTableInput.saleEntryId });
                        let lg = await this.ledgerEntryTableService.create(temp2, user);
                        if (lg.status) {
                            await this.animalEntryTableService.deceaseEntry(animalTable.animalId, 2);
                            return {
                                status: true,
                                status_text: "Successfully Submitted",
                                data: result,
                            };
                        }
                    }
                }
            }
        }
        else {
            return {
                status: false,
                status_text: "Invalid Data",
                data: null,
            };
        }
    }
    async findByAnimalId(animalId) {
        let animalTable = await this.animalEntryTableService.findByAnimalId(animalId);
        return await this.saleEntrySubTableRepository.find({
            where: {
                AnimalTable: animalTable,
            },
            relations: [
                "UserTable",
                "AnimalTable",
                "AnimalTable.HousingTable",
                "AnimalTable.BreedTable",
                "AnimalTable.HousingTable.FarmersTable",
            ],
        });
    }
    async findAll() {
        return await this.saleEntrySubTableRepository.find({
            relations: [
                "UserTable",
                "AnimalTable",
                "AnimalTable.HousingTable",
                "AnimalTable.BreedTable",
                "AnimalTable.HousingTable.FarmersTable",
            ],
        });
    }
    async findOne(saleEntryId) {
        return await this.saleEntrySubTableRepository.findOne({
            where: {
                SaleEntryTable: {
                    saleEntryId
                },
            },
            relations: [
                "UserTable",
                "AnimalTable",
                "AnimalTable.HousingTable",
                "AnimalTable.BreedTable",
                "AnimalTable.HousingTable.FarmersTable",
            ],
        });
    }
    async findAllSaleEntryByHousingId(housingId) {
        return await this.saleEntrySubTableRepository.find({
            where: {
                AnimalTable: {
                    HousingTable: {
                        housingId
                    }
                }
            },
            relations: {
                AnimalTable: {
                    HousingTable: {
                        FarmersTable: true
                    }
                },
                SaleEntryTable: true
            }
        });
    }
    async findMarketingData(startDate, endDate, farmerId) {
        let male = 0, female = 0, data = [];
        if (farmerId != null && farmerId != undefined) {
            data = await this.saleEntrySubTableRepository.find({
                where: {
                    AnimalTable: {
                        HousingTable: {
                            FarmersTable: {
                                farmerId: farmerId
                            }
                        }
                    },
                    dateOfEntry: (0, typeorm_2.Between)(startDate, endDate)
                },
                relations: {
                    AnimalTable: true
                }
            });
        }
        else {
            data = await this.saleEntrySubTableRepository.find({
                where: {
                    dateOfEntry: (0, typeorm_2.Between)(startDate, endDate)
                },
                relations: {
                    AnimalTable: true
                }
            });
        }
        for (const el of data) {
            if (el.AnimalTable.gender == 'MALE')
                male++;
            if (el.AnimalTable.gender == 'FEMALE')
                female++;
        }
        return {
            status: true,
            data: [male.toFixed(3), female.toFixed(3)]
        };
    }
    async getSaleDetailsOfOneAnimal(animalId) {
        let result = await this.saleEntrySubTableRepository.createQueryBuilder("r")
            .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
            .leftJoinAndMapOne("r.SaleEntryTable", sale_entry_table_entity_1.SaleEntryTable, "ml2", "ml2.saleEntryId=r.saleEntryId")
            .where("r.animalId=:animalId", { animalId: animalId })
            .getMany();
        console.log(result);
        return result;
    }
    async getSaleReportDistrictWise(districtId, startingDate, endingDate) {
        const subdivisions = await this.subDivisionTableService.fetchSubDivisionByDistrictId(districtId);
        let data = [];
        for (const e of subdivisions) {
            let d1 = await this.saleEntrySubTableRepository.createQueryBuilder("r")
                .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
                .leftJoinAndMapOne("ml1.HousingTable", housing_table_entity_1.HousingTable, "ml2", "ml2.housingId=ml1.housingId")
                .leftJoinAndMapOne("ml2.FarmersTable", farmers_table_entity_1.FarmersTable, "ml3", "ml3.farmerId=ml2.farmerId")
                .where("ml3.subDivisionId=:subDivisionId", { subDivisionId: e.subDivisionId })
                .andWhere("STR_TO_DATE(r.dateOfEntry,'%Y-%m-%d') BETWEEN STR_TO_DATE(:startingDate,'%Y-%m-%d') AND STR_TO_DATE(:endingDate,'%Y-%m-%d')", {
                startingDate: startingDate,
                endingDate: endingDate,
            })
                .select("SUM(r.weight)", "totalWeight")
                .addSelect("AVG(r.ratePerKg)", "avgRate")
                .addSelect("SUM(r.amount)", "totalAmount")
                .addSelect("COUNT(r.animalId)", "totalAnimalsSold")
                .groupBy("ml3.subDivisionId")
                .getRawOne();
            console.log(d1);
            let d2 = {
                SubDivisionTable: e,
                totalWeight: d1 ? d1.totalWeight : 0,
                avgRate: d1 ? d1.avgRate : 0,
                totalAmount: d1 ? d1.totalAmount : 0,
                totalAnimalsSold: d1 ? d1.totalAnimalsSold : 0
            };
            data.push(d2);
        }
        return data;
    }
    async getSaleReportSumarryDistrictWise() {
        let districts = await this.districtTableService.findAll();
        let data = [];
        for (const d of districts) {
            let d1 = await this.saleEntrySubTableRepository.createQueryBuilder("r")
                .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
                .leftJoinAndMapOne("ml1.HousingTable", housing_table_entity_1.HousingTable, "ml2", "ml2.housingId=ml1.housingId")
                .leftJoinAndMapOne("ml2.FarmersTable", farmers_table_entity_1.FarmersTable, "ml3", "ml3.farmerId=ml2.farmerId")
                .where("ml3.districtId=:districtId", { districtId: d.districtId })
                .select("SUM(r.weight)", "totalWeight")
                .addSelect("SUM(r.amount)", "totalAmount")
                .addSelect("COUNT(r.animalId)", "totalAnimalsSold")
                .groupBy("ml3.districtId")
                .getRawOne();
            let d2 = {
                DistrictTable: d,
                totalWeight: d1 ? d1.totalWeight : 0,
                totalAmount: d1 ? d1.totalAmount : 0,
                totalAnimalsSold: d1 ? d1.totalAnimalsSold : 0,
            };
            data.push(d2);
        }
        return data;
    }
    async getSalesVolumeDistrictMonthWise(districtId = 0, year) {
        let selectedYear = (0, moment_1.default)().format("YYYY");
        if (year) {
            selectedYear = year;
        }
        let data = [];
        let monthName = ["01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12"];
        for (const el of monthName) {
            const startOfMonth = (0, moment_1.default)(`${el}-${selectedYear}`, "MM-YYYY").startOf('month').format('YYYY-MM-DD');
            const endOfMonth = (0, moment_1.default)(`${el}-${selectedYear}`, "MM-YYYY").endOf('month').format('YYYY-MM-DD');
            let d1 = await this.saleEntrySubTableRepository.createQueryBuilder("r")
                .leftJoinAndMapOne("r.AnimalTable", animal_entry_table_entity_1.AnimalEntryTable, "ml1", "ml1.animalId=r.animalId")
                .leftJoinAndMapOne("ml1.HousingTable", housing_table_entity_1.HousingTable, "ml2", "ml2.housingId=ml1.housingId")
                .leftJoinAndMapOne("ml2.FarmersTable", farmers_table_entity_1.FarmersTable, "ml3", "ml3.farmerId=ml2.farmerId")
                .select("SUM(r.weight)", "totalWeight")
                .addSelect("SUM(r.amount)", "totalAmount")
                .addSelect("COUNT(r.animalId)", "totalAnimalsSold")
                .where("STR_TO_DATE(r.dateOfEntry,'%Y-%m-%d') BETWEEN STR_TO_DATE(:startingDate,'%Y-%m-%d') AND STR_TO_DATE(:endingDate,'%Y-%m-%d')", {
                startingDate: startOfMonth,
                endingDate: endOfMonth,
            });
            if (districtId != 0) {
                d1 = await d1.where("ml3.districtId=:districtId", { districtId: districtId });
                d1 = await d1.groupBy("ml3.districtId");
            }
            d1 = await d1.getRawOne();
            console.log("🚀 ~ file: sale-entry-sub-table.service.ts:376 ~ SaleEntrySubTableService ~ getSalesVolumeDistrictMonthWise ~ d1", d1);
            let d2 = {
                totalWeight: d1 ? d1.totalWeight : 0,
                totalAmount: d1 ? d1.totalAmount : 0,
                totalAnimalsSold: d1 ? d1.totalAnimalsSold : 0,
            };
            data.push({
                month: `${el}-${selectedYear}`,
                data: d2
            });
        }
        return data;
    }
};
SaleEntrySubTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(sale_entry_sub_table_entity_1.SaleEntrySubTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => housing_table_service_1.HousingTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_table_service_1.CurrentStockTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => stock_balance_table_service_1.StockBalanceTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => ledger_entry_table_service_1.LedgerEntryTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => animal_entry_table_service_1.AnimalEntryTableService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => sale_entry_table_service_1.SaleEntryTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        housing_table_service_1.HousingTableService,
        current_stock_table_service_1.CurrentStockTableService,
        stock_balance_table_service_1.StockBalanceTableService,
        ledger_entry_table_service_1.LedgerEntryTableService,
        animal_entry_table_service_1.AnimalEntryTableService,
        sale_entry_table_service_1.SaleEntryTableService,
        sub_division_table_service_1.SubDivisionTableService,
        district_table_service_1.DistrictTableService])
], SaleEntrySubTableService);
exports.SaleEntrySubTableService = SaleEntrySubTableService;
