"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaleEntryTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const sale_entry_table_entity_1 = require("./entities/sale-entry-table.entity");
const sale_entry_table_service_1 = require("./sale-entry-table.service");
const sale_entry_table_return_type_1 = require("./types/sale-entry-table-return.type");
const create_sale_entry_table_input_1 = require("./dto/create-sale-entry-table.input");
const sale_entry_table_type_1 = require("./types/sale-entry-table.type");
const sale_entry_table_forhousing_type_1 = require("./types/sale-entry-table-forhousing.type");
let SaleEntryTableResolver = class SaleEntryTableResolver {
    constructor(saleEntryTableService) {
        this.saleEntryTableService = saleEntryTableService;
    }
    createSaleEntryTable(createSaleEntryTableInput, user) {
        return this.saleEntryTableService.create(createSaleEntryTableInput, user);
    }
    findAllSaleEntry() {
        return this.saleEntryTableService.findAll();
    }
    findSaleEntryById(saleEntryId) {
        return this.saleEntryTableService.findOne(saleEntryId);
    }
    findSaleEntryByFarmerId(farmerId) {
        return this.saleEntryTableService.findByFarmerId(farmerId);
    }
    findSaleEntryByHousingId(housingId) {
        return this.saleEntryTableService.findSaleEntryByHousingId(housingId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sale_entry_table_return_type_1.SaleEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createSaleEntryTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_sale_entry_table_input_1.CreateSaleEntryTableInput, Object]),
    __metadata("design:returntype", void 0)
], SaleEntryTableResolver.prototype, "createSaleEntryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_table_type_1.SaleEntryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SaleEntryTableResolver.prototype, "findAllSaleEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sale_entry_table_type_1.SaleEntryTableType),
    __param(0, (0, graphql_1.Args)('saleEntryId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntryTableResolver.prototype, "findSaleEntryById", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_table_type_1.SaleEntryTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntryTableResolver.prototype, "findSaleEntryByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_entry_table_forhousing_type_1.SaleEntryTableForHousing]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleEntryTableResolver.prototype, "findSaleEntryByHousingId", null);
SaleEntryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => sale_entry_table_entity_1.SaleEntryTable),
    __metadata("design:paramtypes", [sale_entry_table_service_1.SaleEntryTableService])
], SaleEntryTableResolver);
exports.SaleEntryTableResolver = SaleEntryTableResolver;
