import { UserCollectionService } from "src/user-collection/user-collection.service";
import { Repository } from "typeorm";
import { HousingTableService } from "src/housing-table/housing-table.service";
import { BreedTableService } from "src/breed-table/breed-table.service";
import { CurrentStockTableService } from "src/current-stock/current-stock-table.service";
import { StockBalanceTableService } from "src/stock-balance/stock-balance-table.service";
import { LedgerEntryTableService } from "src/ledger-table/ledger-entry-table.service";
import { AnimalEntryTableService } from "src/animal-table/animal-entry-table.service";
import { SaleEntryTable } from "./entities/sale-entry-table.entity";
import { CreateSaleEntryTableInput } from "./dto/create-sale-entry-table.input";
import { SaleEntrySubTableService } from "src/sale-entry-sub-table/sale-entry-sub-table.service";
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class SaleEntryTableService {
    private readonly saleEntryTableRepository;
    private readonly dataEntryTableService;
    private readonly userCollectionService;
    private readonly housingTableService;
    private readonly breedTableService;
    private readonly currentStockTableService;
    private readonly stockBalanceTableService;
    private readonly ledgerEntryTableService;
    private readonly animalEntryTableService;
    private readonly saleEntrySubTableService;
    constructor(saleEntryTableRepository: Repository<SaleEntryTable>, dataEntryTableService: DataEntryTableService, userCollectionService: UserCollectionService, housingTableService: HousingTableService, breedTableService: BreedTableService, currentStockTableService: CurrentStockTableService, stockBalanceTableService: StockBalanceTableService, ledgerEntryTableService: LedgerEntryTableService, animalEntryTableService: AnimalEntryTableService, saleEntrySubTableService: SaleEntrySubTableService);
    create(createSaleEntryTableInput: CreateSaleEntryTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: SaleEntryTable;
    }>;
    findAll(): Promise<SaleEntryTable[]>;
    findOne(saleEntryId: number): Promise<SaleEntryTable>;
    findByFarmerId(farmerId: number): Promise<SaleEntryTable[]>;
    findSaleEntryByHousingId(housingId: number): Promise<import("../sale-entry-sub-table/entities/sale-entry-sub-table.entity").SaleEntrySubTable[]>;
}
