"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SaleReadyTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const sale_ready_table_service_1 = require("./sale-ready-table.service");
const sale_ready_table_entity_1 = require("./entities/sale-ready-table.entity");
const create_sale_ready_table_input_1 = require("./dto/create-sale-ready-table.input");
const role_enum_1 = require("../user-collection/roles/role.enum");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const sale_ready_table_return_type_1 = require("./types/sale-ready-table-return.type");
const sale_ready_table_type_1 = require("./types/sale-ready-table.type");
let SaleReadyTableResolver = class SaleReadyTableResolver {
    constructor(saleReadyTableService) {
        this.saleReadyTableService = saleReadyTableService;
    }
    createSaleReadyTable(createSaleReadyTableInput, user) {
        return this.saleReadyTableService.create(createSaleReadyTableInput, user);
    }
    findAllSaleReady() {
        return this.saleReadyTableService.findAll();
    }
    findOneSaleReady(saleReadyId) {
        return this.saleReadyTableService.findOne(saleReadyId);
    }
    findSaleReadyByFarmerId(farmerId) {
        return this.saleReadyTableService.findByFarmerId(farmerId);
    }
    findSaleReadyByHousingId(housingId) {
        return this.saleReadyTableService.findAllSaleReadyByHousingId(housingId);
    }
    removeSaleReadyTable(saleReadyId) {
        return this.saleReadyTableService.remove(saleReadyId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sale_ready_table_return_type_1.SaleReadyTableReturnType),
    __param(0, (0, graphql_1.Args)('createSaleReadyTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_sale_ready_table_input_1.CreateSaleReadyTableInput, Object]),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "createSaleReadyTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_ready_table_type_1.SaleReadyTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "findAllSaleReady", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sale_ready_table_type_1.SaleReadyTableType),
    __param(0, (0, graphql_1.Args)('saleReadyId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "findOneSaleReady", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_ready_table_type_1.SaleReadyTableType]),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "findSaleReadyByFarmerId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sale_ready_table_type_1.SaleReadyTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "findSaleReadyByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sale_ready_table_return_type_1.SaleReadyTableReturnType),
    __param(0, (0, graphql_1.Args)('saleReadyId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SaleReadyTableResolver.prototype, "removeSaleReadyTable", null);
SaleReadyTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => sale_ready_table_entity_1.SaleReadyTable),
    __metadata("design:paramtypes", [sale_ready_table_service_1.SaleReadyTableService])
], SaleReadyTableResolver);
exports.SaleReadyTableResolver = SaleReadyTableResolver;
