import { AnimalEntryTableService } from 'src/animal-table/animal-entry-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { Repository } from 'typeorm';
import { CreateSaleReadyTableInput } from './dto/create-sale-ready-table.input';
import { UpdateSaleReadyTableInput } from './dto/update-sale-ready-table.input';
import { SaleReadyTable } from './entities/sale-ready-table.entity';
export declare class SaleReadyTableService {
    private readonly saleReadyTableRepository;
    private readonly userCollectionService;
    private readonly housingTableService;
    private readonly animalEntryTableService;
    constructor(saleReadyTableRepository: Repository<SaleReadyTable>, userCollectionService: UserCollectionService, housingTableService: HousingTableService, animalEntryTableService: AnimalEntryTableService);
    create(createSaleReadyTableInput: CreateSaleReadyTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: SaleReadyTable;
    }>;
    findAll(): Promise<SaleReadyTable[]>;
    findOne(saleReadyId: number): Promise<SaleReadyTable>;
    findByFarmerId(farmerId: number): Promise<SaleReadyTable[]>;
    findAllSaleReadyByHousingId(housingId: number): Promise<SaleReadyTable[]>;
    update(id: number, updateSaleReadyTableInput: UpdateSaleReadyTableInput): Promise<string>;
    remove(saleReadyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
