import { SchemeMasterSubTableService } from './scheme-master-sub-table.service';
import { SchemeMasterSubTable } from './entities/scheme-master-sub-table.entity';
import { CreateSchemeMasterSubTableInput } from './dto/create-scheme-master-sub-table.input';
import { UpdateSchemeMasterSubTableInput } from './dto/update-scheme-master-sub-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SUB_SCHEME_ADD = "NEW_SUB_SCHEME_ADD";
export declare class SchemeMasterSubTableResolver {
    private readonly schemeMasterSubTableService;
    private pubSub;
    constructor(schemeMasterSubTableService: SchemeMasterSubTableService, pubSub: RedisPubSub);
    createSchemeMasterSubTable(createSchemeMasterSubTableInput: CreateSchemeMasterSubTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterSubTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSchemeMasterSubTable(): Promise<SchemeMasterSubTable[]>;
    findOneSchemeMasterSubTable(schemeMasterSubId: number): Promise<SchemeMasterSubTable>;
    updateSchemeMasterSubTable(updateSchemeMasterSubTableInput: UpdateSchemeMasterSubTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterSubTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSchemeMasterSubTable(schemeMasterSubId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    schemeSubSubscription(): AsyncIterator<unknown, any, undefined>;
}
