"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemeMasterSubTableResolver = exports.NEW_SUB_SCHEME_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const scheme_master_sub_table_service_1 = require("./scheme-master-sub-table.service");
const scheme_master_sub_table_entity_1 = require("./entities/scheme-master-sub-table.entity");
const create_scheme_master_sub_table_input_1 = require("./dto/create-scheme-master-sub-table.input");
const update_scheme_master_sub_table_input_1 = require("./dto/update-scheme-master-sub-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const scheme_master_sub_table_return_type_1 = require("./types/scheme-master-sub-table-return.type");
const scheme_master_sub_table_type_1 = require("./types/scheme-master-sub-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_SUB_SCHEME_ADD = "NEW_SUB_SCHEME_ADD";
let SchemeMasterSubTableResolver = exports.SchemeMasterSubTableResolver = class SchemeMasterSubTableResolver {
    constructor(schemeMasterSubTableService, pubSub) {
        this.schemeMasterSubTableService = schemeMasterSubTableService;
        this.pubSub = pubSub;
    }
    createSchemeMasterSubTable(createSchemeMasterSubTableInput) {
        return this.schemeMasterSubTableService.create(createSchemeMasterSubTableInput);
    }
    findAllSchemeMasterSubTable() {
        return this.schemeMasterSubTableService.findAll();
    }
    findOneSchemeMasterSubTable(schemeMasterSubId) {
        return this.schemeMasterSubTableService.findOne(schemeMasterSubId);
    }
    updateSchemeMasterSubTable(updateSchemeMasterSubTableInput) {
        return this.schemeMasterSubTableService.update(updateSchemeMasterSubTableInput.schemeMasterSubId, updateSchemeMasterSubTableInput);
    }
    removeSchemeMasterSubTable(schemeMasterSubId) {
        return this.schemeMasterSubTableService.remove(schemeMasterSubId);
    }
    schemeSubSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SUB_SCHEME_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_sub_table_return_type_1.SchemeMasterSubTableReturnType),
    __param(0, (0, graphql_1.Args)('createSchemeMasterSubTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_scheme_master_sub_table_input_1.CreateSchemeMasterSubTableInput]),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "createSchemeMasterSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [scheme_master_sub_table_type_1.SchemeMasterSubTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "findAllSchemeMasterSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => scheme_master_sub_table_type_1.SchemeMasterSubTableType),
    __param(0, (0, graphql_1.Args)('schemeMasterSubId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "findOneSchemeMasterSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_sub_table_return_type_1.SchemeMasterSubTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSchemeMasterSubTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_scheme_master_sub_table_input_1.UpdateSchemeMasterSubTableInput]),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "updateSchemeMasterSubTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_sub_table_return_type_1.SchemeMasterSubTableReturnType),
    __param(0, (0, graphql_1.Args)('schemeMasterSubId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "removeSchemeMasterSubTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SchemeMasterSubTableResolver.prototype, "schemeSubSubscription", null);
exports.SchemeMasterSubTableResolver = SchemeMasterSubTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => scheme_master_sub_table_entity_1.SchemeMasterSubTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [scheme_master_sub_table_service_1.SchemeMasterSubTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SchemeMasterSubTableResolver);
