import { CreateSchemeMasterSubTableInput } from './dto/create-scheme-master-sub-table.input';
import { UpdateSchemeMasterSubTableInput } from './dto/update-scheme-master-sub-table.input';
import { SchemeMasterSubTable } from './entities/scheme-master-sub-table.entity';
import { Repository } from 'typeorm';
import { SchemeMasterTableService } from 'src/scheme-master-table/scheme-master-table.service';
import { SchemeMasterTable } from 'src/scheme-master-table/entities/scheme-master-table.entity';
import { MkTableService } from 'src/mk-table/mk-table.service';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SUB_SCHEME_ADD = "NEW_SUB_SCHEME_ADD";
export declare class SchemeMasterSubTableService {
    private readonly schemeMasterSubTableRepository;
    private readonly schemeMasterTableService;
    private readonly mkTableService;
    private pubSub;
    constructor(schemeMasterSubTableRepository: Repository<SchemeMasterSubTable>, schemeMasterTableService: SchemeMasterTableService, mkTableService: MkTableService, pubSub: RedisPubSub);
    create(createSchemeMasterSubTableInput: CreateSchemeMasterSubTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterSubTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createSchemeMasterSubTableInput: CreateSchemeMasterSubTableInput): Promise<SchemeMasterSubTable>;
    checkIfAlreadyExists(createSchemeMasterSubTableInput: CreateSchemeMasterSubTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<SchemeMasterSubTable[]>;
    findAllEntitlements(): Promise<SchemeMasterSubTable[]>;
    findAllMgnrega(): Promise<SchemeMasterSubTable[]>;
    findAllLineDepartment(): Promise<SchemeMasterSubTable[]>;
    findAllHealthInsurance(): Promise<SchemeMasterSubTable[]>;
    findOne(schemeMasterSubId: number): Promise<SchemeMasterSubTable>;
    findOneWithRemarks(schemeMasterTable: SchemeMasterTable, mkId: number): Promise<SchemeMasterSubTable[]>;
    update(schemeMasterSubId: number, updateSchemeMasterSubTableInput: UpdateSchemeMasterSubTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterSubTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(schemeMasterSubId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
