"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemeMasterSubTableService = exports.NEW_SUB_SCHEME_ADD = void 0;
const common_1 = require("@nestjs/common");
const scheme_master_sub_table_entity_1 = require("./entities/scheme-master-sub-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const scheme_master_table_service_1 = require("../scheme-master-table/scheme-master-table.service");
const mk_table_service_1 = require("../mk-table/mk-table.service");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_SUB_SCHEME_ADD = "NEW_SUB_SCHEME_ADD";
let SchemeMasterSubTableService = exports.SchemeMasterSubTableService = class SchemeMasterSubTableService {
    constructor(schemeMasterSubTableRepository, schemeMasterTableService, mkTableService, pubSub) {
        this.schemeMasterSubTableRepository = schemeMasterSubTableRepository;
        this.schemeMasterTableService = schemeMasterTableService;
        this.mkTableService = mkTableService;
        this.pubSub = pubSub;
    }
    async create(createSchemeMasterSubTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createSchemeMasterSubTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new scheme_master_sub_table_entity_1.SchemeMasterSubTable();
            st.schemeMasterSubName = createSchemeMasterSubTableInput.schemeMasterSubName;
            let schemeMaster = await this.schemeMasterTableService.findOne(createSchemeMasterSubTableInput.schemeMasterId);
            st.SchemeMasterTable = schemeMaster;
            st.minimumAge = createSchemeMasterSubTableInput.minimumAge;
            st.maximumAge = createSchemeMasterSubTableInput.maximumAge;
            st.assamState = createSchemeMasterSubTableInput.assamState;
            st.disability = createSchemeMasterSubTableInput.disability;
            st.minimumIncome = createSchemeMasterSubTableInput.minimumIncome;
            st.maximumIncome = createSchemeMasterSubTableInput.maximumIncome;
            let result = await this.schemeMasterSubTableRepository.save(st);
            this.pubSub.publish(exports.NEW_SUB_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createSchemeMasterSubTableInput) {
        let checkIfAlreadyExists = await this.schemeMasterSubTableRepository.findOne({
            where: {
                schemeMasterSubName: createSchemeMasterSubTableInput.schemeMasterSubName
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new scheme_master_sub_table_entity_1.SchemeMasterSubTable();
            st.schemeMasterSubName = createSchemeMasterSubTableInput.schemeMasterSubName.trim();
            let schemeMaster = await this.schemeMasterTableService.findOne(createSchemeMasterSubTableInput.schemeMasterId);
            st.SchemeMasterTable = schemeMaster;
            st.minimumAge = createSchemeMasterSubTableInput.minimumAge;
            st.maximumAge = createSchemeMasterSubTableInput.maximumAge;
            st.assamState = createSchemeMasterSubTableInput.assamState;
            st.disability = createSchemeMasterSubTableInput.disability;
            st.minimumIncome = createSchemeMasterSubTableInput.minimumIncome;
            st.maximumIncome = createSchemeMasterSubTableInput.maximumIncome;
            let result = await this.schemeMasterSubTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createSchemeMasterSubTableInput) {
        let result = await this.schemeMasterSubTableRepository.count({
            where: {
                schemeMasterSubName: createSchemeMasterSubTableInput.schemeMasterSubName
            }
        });
        return result;
    }
    async getCount() {
        return await this.schemeMasterSubTableRepository.count();
    }
    async findAll() {
        return await this.schemeMasterSubTableRepository.find({
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findAllEntitlements() {
        return await this.schemeMasterSubTableRepository.find({
            where: {
                SchemeMasterTable: {
                    schemeMasterType: "ENTITLEMENTS"
                }
            },
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findAllMgnrega() {
        return await this.schemeMasterSubTableRepository.find({
            where: {
                SchemeMasterTable: {
                    schemeMasterType: "MGNREGA"
                }
            },
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findAllLineDepartment() {
        return await this.schemeMasterSubTableRepository.find({
            where: {
                SchemeMasterTable: {
                    schemeMasterType: "LINE_DEPARTMENT"
                }
            },
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findAllHealthInsurance() {
        return await this.schemeMasterSubTableRepository.find({
            where: {
                SchemeMasterTable: {
                    schemeMasterType: "ENTITLEMENTS",
                    schemeMasterCode: "HEALTH_INSURANCE"
                }
            },
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findOne(schemeMasterSubId) {
        return await this.schemeMasterSubTableRepository.findOne({
            where: {
                schemeMasterSubId
            },
            relations: {
                SchemeMasterTable: true
            }
        });
    }
    async findOneWithRemarks(schemeMasterTable, mkId) {
        let results = await this.schemeMasterSubTableRepository.find({
            where: {
                SchemeMasterTable: {
                    schemeMasterId: schemeMasterTable.schemeMasterId
                }
            }
        });
        let index = 0;
        for (const el of results) {
            let remarks = [];
            let isEligible = true;
            let mkData = await this.mkTableService.findOne(mkId);
            if (el.minimumAge != 0 && el.maximumAge != 0) {
                let age = parseFloat(mkData.mkAge);
                if (el.minimumAge > age && el.maximumAge < age) {
                    isEligible = false;
                }
                else {
                    remarks.push("Age criteria matched");
                }
            }
            if (el.assamState == "YES") {
                let state = mkData === null || mkData === void 0 ? void 0 : mkData.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.StateTable.stateName;
                if (state != "Assam") {
                    isEligible = false;
                }
                else {
                    remarks.push(`State Criteria Matched`);
                }
            }
            if (el.disability == "YES") {
                let disabled = mkData === null || mkData === void 0 ? void 0 : mkData.VulnerabilityCategoryTable.vulcatName;
                if (disabled != "Disabled") {
                    isEligible = false;
                }
                else {
                    remarks.push(`Disability Criteria Matched`);
                }
            }
            results[index]['remarks'] = remarks;
            results[index]['isEligible'] = isEligible;
            index++;
        }
        return results;
    }
    async update(schemeMasterSubId, updateSchemeMasterSubTableInput) {
        let result = await this.findOne(schemeMasterSubId);
        if (result) {
            result.schemeMasterSubName = updateSchemeMasterSubTableInput.schemeMasterSubName;
            let schemeMaster = await this.schemeMasterTableService.findOne(updateSchemeMasterSubTableInput.schemeMasterId);
            result.SchemeMasterTable = schemeMaster;
            result.minimumAge = updateSchemeMasterSubTableInput.minimumAge;
            result.maximumAge = updateSchemeMasterSubTableInput.maximumAge;
            result.assamState = updateSchemeMasterSubTableInput.assamState;
            result.disability = updateSchemeMasterSubTableInput.disability;
            result.minimumIncome = updateSchemeMasterSubTableInput.minimumIncome;
            result.maximumIncome = updateSchemeMasterSubTableInput.maximumIncome;
            let updatedResult = await this.schemeMasterSubTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SUB_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(schemeMasterSubId) {
        let result = await this.findOne(schemeMasterSubId);
        if (result) {
            await this.schemeMasterSubTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SUB_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.SchemeMasterSubTableService = SchemeMasterSubTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(scheme_master_sub_table_entity_1.SchemeMasterSubTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => scheme_master_table_service_1.SchemeMasterTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => mk_table_service_1.MkTableService))),
    __param(3, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        scheme_master_table_service_1.SchemeMasterTableService,
        mk_table_service_1.MkTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SchemeMasterSubTableService);
