import { SchemeMasterTableService } from './scheme-master-table.service';
import { SchemeMasterTable } from './entities/scheme-master-table.entity';
import { CreateSchemeMasterTableInput } from './dto/create-scheme-master-table.input';
import { UpdateSchemeMasterTableInput } from './dto/update-scheme-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SCHEME_ADD = "NEW_SCHEME_ADD";
export declare class SchemeMasterTableResolver {
    private readonly schemeMasterTableService;
    private pubSub;
    constructor(schemeMasterTableService: SchemeMasterTableService, pubSub: RedisPubSub);
    createSchemeMasterTable(createSchemeMasterTableInput: CreateSchemeMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSchemeMasters(mkId: number): Promise<SchemeMasterTable[]>;
    findOneSchemeMaster(schemeMasterId: number): Promise<SchemeMasterTable>;
    updateSchemeMasterTable(updateSchemeMasterTableInput: UpdateSchemeMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSchemeMasterTable(schemeMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    schemeSubscription(): AsyncIterator<unknown, any, undefined>;
}
