"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemeMasterTableResolver = exports.NEW_SCHEME_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const scheme_master_table_service_1 = require("./scheme-master-table.service");
const scheme_master_table_entity_1 = require("./entities/scheme-master-table.entity");
const create_scheme_master_table_input_1 = require("./dto/create-scheme-master-table.input");
const update_scheme_master_table_input_1 = require("./dto/update-scheme-master-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const scheme_master_table_return_type_1 = require("./types/scheme-master-table-return.type");
const scheme_master_table_type_1 = require("./types/scheme-master-table.type");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_SCHEME_ADD = "NEW_SCHEME_ADD";
let SchemeMasterTableResolver = exports.SchemeMasterTableResolver = class SchemeMasterTableResolver {
    constructor(schemeMasterTableService, pubSub) {
        this.schemeMasterTableService = schemeMasterTableService;
        this.pubSub = pubSub;
    }
    createSchemeMasterTable(createSchemeMasterTableInput) {
        return this.schemeMasterTableService.create(createSchemeMasterTableInput);
    }
    findAllSchemeMasters(mkId) {
        return this.schemeMasterTableService.findAll(mkId);
    }
    findOneSchemeMaster(schemeMasterId) {
        return this.schemeMasterTableService.findOne(schemeMasterId);
    }
    updateSchemeMasterTable(updateSchemeMasterTableInput) {
        return this.schemeMasterTableService.update(updateSchemeMasterTableInput.schemeMasterId, updateSchemeMasterTableInput);
    }
    removeSchemeMasterTable(schemeMasterId) {
        return this.schemeMasterTableService.remove(schemeMasterId);
    }
    schemeSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SCHEME_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_table_return_type_1.SchemeMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('createSchemeMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_scheme_master_table_input_1.CreateSchemeMasterTableInput]),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "createSchemeMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [scheme_master_table_type_1.SchemeMasterTableType]),
    __param(0, (0, graphql_1.Args)('mkId', { type: () => graphql_1.Int, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "findAllSchemeMasters", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => scheme_master_table_type_1.SchemeMasterTableType),
    __param(0, (0, graphql_1.Args)('schemeMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "findOneSchemeMaster", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_table_return_type_1.SchemeMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSchemeMasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_scheme_master_table_input_1.UpdateSchemeMasterTableInput]),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "updateSchemeMasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => scheme_master_table_return_type_1.SchemeMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('schemeMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "removeSchemeMasterTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SchemeMasterTableResolver.prototype, "schemeSubscription", null);
exports.SchemeMasterTableResolver = SchemeMasterTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => scheme_master_table_entity_1.SchemeMasterTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [scheme_master_table_service_1.SchemeMasterTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SchemeMasterTableResolver);
