import { CreateSchemeMasterTableInput } from './dto/create-scheme-master-table.input';
import { UpdateSchemeMasterTableInput } from './dto/update-scheme-master-table.input';
import { SchemeMasterTable } from './entities/scheme-master-table.entity';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { SchemeMasterSubTableService } from 'src/scheme-master-sub-table/scheme-master-sub-table.service';
export declare const NEW_SCHEME_ADD = "NEW_SCHEME_ADD";
export declare class SchemeMasterTableService {
    private readonly schemeMasterTableRepository;
    private pubSub;
    private readonly schemeMasterSubTableService;
    constructor(schemeMasterTableRepository: Repository<SchemeMasterTable>, pubSub: RedisPubSub, schemeMasterSubTableService: SchemeMasterSubTableService);
    create(createSchemeMasterTableInput: CreateSchemeMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createSchemeMasterTableInput: CreateSchemeMasterTableInput): Promise<SchemeMasterTable>;
    checkIfAlreadyExists(createSchemeMasterTableInput: CreateSchemeMasterTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(mkId?: number): Promise<SchemeMasterTable[]>;
    findOne(schemeMasterId: number): Promise<SchemeMasterTable>;
    update(schemeMasterId: number, updateSchemeMasterTableInput: UpdateSchemeMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SchemeMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(schemeMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
