"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemeMasterTableService = exports.NEW_SCHEME_ADD = void 0;
const common_1 = require("@nestjs/common");
const scheme_master_table_entity_1 = require("./entities/scheme-master-table.entity");
const typeorm_1 = require("@nestjs/typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const typeorm_2 = require("typeorm");
const scheme_master_sub_table_service_1 = require("../scheme-master-sub-table/scheme-master-sub-table.service");
exports.NEW_SCHEME_ADD = "NEW_SCHEME_ADD";
let SchemeMasterTableService = exports.SchemeMasterTableService = class SchemeMasterTableService {
    constructor(schemeMasterTableRepository, pubSub, schemeMasterSubTableService) {
        this.schemeMasterTableRepository = schemeMasterTableRepository;
        this.pubSub = pubSub;
        this.schemeMasterSubTableService = schemeMasterSubTableService;
    }
    async create(createSchemeMasterTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createSchemeMasterTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new scheme_master_table_entity_1.SchemeMasterTable();
            st.schemeMasterName = createSchemeMasterTableInput.schemeMasterName;
            st.schemeMasterCode = createSchemeMasterTableInput.schemeMasterCode;
            st.schemeMasterType = createSchemeMasterTableInput.schemeMasterType;
            let result = await this.schemeMasterTableRepository.save(st);
            this.pubSub.publish(exports.NEW_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createSchemeMasterTableInput) {
        let checkIfAlreadyExists = await this.schemeMasterTableRepository.findOne({
            where: {
                schemeMasterName: createSchemeMasterTableInput.schemeMasterName,
                schemeMasterCode: createSchemeMasterTableInput.schemeMasterCode,
                schemeMasterType: createSchemeMasterTableInput.schemeMasterType,
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new scheme_master_table_entity_1.SchemeMasterTable();
            st.schemeMasterName = createSchemeMasterTableInput.schemeMasterName.trim();
            let result = await this.schemeMasterTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createSchemeMasterTableInput) {
        let result = await this.schemeMasterTableRepository.count({
            where: {
                schemeMasterName: createSchemeMasterTableInput.schemeMasterName,
                schemeMasterCode: createSchemeMasterTableInput.schemeMasterCode,
                schemeMasterType: createSchemeMasterTableInput.schemeMasterType,
            }
        });
        return result;
    }
    async getCount() {
        return await this.schemeMasterTableRepository.count();
    }
    async findAll(mkId) {
        if (mkId) {
            let results = await this.schemeMasterTableRepository.find();
            let index = 0;
            for (const el of results) {
                results[index]['SchemeMasterSubTable'] = await this.schemeMasterSubTableService.findOneWithRemarks(el, mkId);
                index++;
            }
            return results;
        }
        else {
            return await this.schemeMasterTableRepository.find({
                relations: {
                    SchemeMasterSubTable: true
                }
            });
        }
    }
    async findOne(schemeMasterId) {
        return await this.schemeMasterTableRepository.findOne({
            where: {
                schemeMasterId
            }
        });
    }
    async update(schemeMasterId, updateSchemeMasterTableInput) {
        let result = await this.findOne(schemeMasterId);
        if (result) {
            result.schemeMasterName = updateSchemeMasterTableInput.schemeMasterName;
            result.schemeMasterCode = updateSchemeMasterTableInput.schemeMasterCode;
            result.schemeMasterType = updateSchemeMasterTableInput.schemeMasterType;
            let updatedResult = await this.schemeMasterTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(schemeMasterId) {
        let result = await this.findOne(schemeMasterId);
        if (result) {
            await this.schemeMasterTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SCHEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.SchemeMasterTableService = SchemeMasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(scheme_master_table_entity_1.SchemeMasterTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => scheme_master_sub_table_service_1.SchemeMasterSubTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        scheme_master_sub_table_service_1.SchemeMasterSubTableService])
], SchemeMasterTableService);
