import { SessionmasterTableService } from './sessionmaster-table.service';
import { SessionmasterTable } from './entities/sessionmaster-table.entity';
import { CreateSessionmasterTableInput } from './dto/create-sessionmaster-table.input';
import { UpdateSessionmasterTableInput } from './dto/update-sessionmaster-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SESSION_ADD = "NEW_SESSION_ADD";
export declare class SessionmasterTableResolver {
    private readonly sessionmasterTableService;
    private pubSub;
    constructor(sessionmasterTableService: SessionmasterTableService, pubSub: RedisPubSub);
    createSessionmasterTable(createSessionmasterTableInput: CreateSessionmasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SessionmasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSession(): Promise<SessionmasterTable[]>;
    findActiveSession(): Promise<SessionmasterTable>;
    findOneSession(sessionId: number): Promise<SessionmasterTable>;
    updateSessionmasterTable(updateSessionmasterTableInput: UpdateSessionmasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SessionmasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSessionmasterTable(sessionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    sessionSubscription(): AsyncIterator<unknown, any, undefined>;
}
