"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionmasterTableResolver = exports.NEW_SESSION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const sessionmaster_table_service_1 = require("./sessionmaster-table.service");
const sessionmaster_table_entity_1 = require("./entities/sessionmaster-table.entity");
const create_sessionmaster_table_input_1 = require("./dto/create-sessionmaster-table.input");
const update_sessionmaster_table_input_1 = require("./dto/update-sessionmaster-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const sessionmaster_table_return_type_1 = require("./types/sessionmaster-table-return.type");
const sessionmaster_table_type_1 = require("./types/sessionmaster-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_SESSION_ADD = "NEW_SESSION_ADD";
let SessionmasterTableResolver = exports.SessionmasterTableResolver = class SessionmasterTableResolver {
    constructor(sessionmasterTableService, pubSub) {
        this.sessionmasterTableService = sessionmasterTableService;
        this.pubSub = pubSub;
    }
    createSessionmasterTable(createSessionmasterTableInput) {
        return this.sessionmasterTableService.create(createSessionmasterTableInput);
    }
    findAllSession() {
        return this.sessionmasterTableService.findAll();
    }
    findActiveSession() {
        return this.sessionmasterTableService.findActiveSession();
    }
    findOneSession(sessionId) {
        return this.sessionmasterTableService.findOne(sessionId);
    }
    updateSessionmasterTable(updateSessionmasterTableInput) {
        return this.sessionmasterTableService.update(updateSessionmasterTableInput.sessionId, updateSessionmasterTableInput);
    }
    removeSessionmasterTable(sessionId) {
        return this.sessionmasterTableService.remove(sessionId);
    }
    sessionSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SESSION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sessionmaster_table_return_type_1.SessionMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('createSessionmasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_sessionmaster_table_input_1.CreateSessionmasterTableInput]),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "createSessionmasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sessionmaster_table_type_1.SessionMasterTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "findAllSession", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sessionmaster_table_type_1.SessionMasterTableType),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "findActiveSession", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sessionmaster_table_type_1.SessionMasterTableType),
    __param(0, (0, graphql_1.Args)('sessionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "findOneSession", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sessionmaster_table_return_type_1.SessionMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSessionmasterTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_sessionmaster_table_input_1.UpdateSessionmasterTableInput]),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "updateSessionmasterTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sessionmaster_table_return_type_1.SessionMasterTableReturnType),
    __param(0, (0, graphql_1.Args)('sessionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "removeSessionmasterTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SessionmasterTableResolver.prototype, "sessionSubscription", null);
exports.SessionmasterTableResolver = SessionmasterTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => sessionmaster_table_entity_1.SessionmasterTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [sessionmaster_table_service_1.SessionmasterTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SessionmasterTableResolver);
