import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateSessionmasterTableInput } from './dto/create-sessionmaster-table.input';
import { UpdateSessionmasterTableInput } from './dto/update-sessionmaster-table.input';
import { SessionmasterTable } from './entities/sessionmaster-table.entity';
export declare const NEW_SESSION_ADD = "NEW_SESSION_ADD";
export declare class SessionmasterTableService {
    private readonly sessionMasterTableRepository;
    private pubSub;
    constructor(sessionMasterTableRepository: Repository<SessionmasterTable>, pubSub: RedisPubSub);
    create(createSessionmasterTableInput: CreateSessionmasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SessionmasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createSessionmasterTableInput: CreateSessionmasterTableInput): Promise<number>;
    findAll(): Promise<SessionmasterTable[]>;
    findOne(sessionId: number): Promise<SessionmasterTable>;
    findActiveSession(): Promise<SessionmasterTable>;
    update(sessionId: number, updateSessionmasterTableInput: UpdateSessionmasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SessionmasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(sessionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getListOfMonthsFromSession(sessionId: number): Promise<any[]>;
}
