"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SessionmasterTableService = exports.NEW_SESSION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const sessionmaster_table_entity_1 = require("./entities/sessionmaster-table.entity");
const moment_1 = __importDefault(require("moment"));
exports.NEW_SESSION_ADD = "NEW_SESSION_ADD";
let SessionmasterTableService = exports.SessionmasterTableService = class SessionmasterTableService {
    constructor(sessionMasterTableRepository, pubSub) {
        this.sessionMasterTableRepository = sessionMasterTableRepository;
        this.pubSub = pubSub;
    }
    async create(createSessionmasterTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createSessionmasterTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new sessionmaster_table_entity_1.SessionmasterTable();
            st.sessionName = createSessionmasterTableInput.sessionName;
            let result = await this.sessionMasterTableRepository.save(st);
            this.pubSub.publish(exports.NEW_SESSION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createSessionmasterTableInput) {
        let result = await this.sessionMasterTableRepository.count({
            where: {
                sessionName: createSessionmasterTableInput.sessionName
            }
        });
        return result;
    }
    async findAll() {
        return await this.sessionMasterTableRepository.find();
    }
    async findOne(sessionId) {
        return await this.sessionMasterTableRepository.findOne({
            where: {
                sessionId
            }
        });
    }
    async findActiveSession() {
        return await this.sessionMasterTableRepository.findOne({
            where: {
                isActive: 1
            }
        });
    }
    async update(sessionId, updateSessionmasterTableInput) {
        let result = await this.findOne(sessionId);
        if (result) {
            result.sessionName = updateSessionmasterTableInput.sessionName;
            let updatedResult = await this.sessionMasterTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SESSION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(sessionId) {
        let result = await this.findOne(sessionId);
        if (result) {
            await this.sessionMasterTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SESSION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async getListOfMonthsFromSession(sessionId) {
        let monthList = [];
        let session = await this.sessionMasterTableRepository.findOne({
            where: {
                sessionId
            }
        });
        if (session) {
            const MONTH_LIST = [
                "04",
                "05",
                "06",
                "07",
                "08",
                "09",
                "10",
                "11",
                "12",
                "01",
                "02",
                "03",
            ];
            let sessionNameArr = session.sessionName.split("-");
            if (sessionNameArr.length > 0) {
                let sessionStart = sessionNameArr[0];
                let sessionEnd = parseFloat(sessionNameArr[0]) + 1;
                monthList = MONTH_LIST.map((el) => {
                    if (["01", "02", "03"].includes(el)) {
                        return (0, moment_1.default)(`${el}-${sessionEnd}`, "MM-YYYY").format("MM-YYYY");
                    }
                    else {
                        return (0, moment_1.default)(`${el} -${sessionStart} `, "MM-YYYY").format("MM-YYYY");
                    }
                });
            }
        }
        return monthList;
    }
};
exports.SessionmasterTableService = SessionmasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(sessionmaster_table_entity_1.SessionmasterTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], SessionmasterTableService);
