import { ShgTableService } from './shg-table.service';
import { ShgTable } from './entities/shg-table.entity';
import { CreateShgTableInput } from './dto/create-shg-table.input';
import { UpdateShgTableInput } from './dto/update-shg-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SHG_ADD = "NEW_SHG_ADD";
export declare class ShgTableResolver {
    private readonly shgTableService;
    private pubSub;
    constructor(shgTableService: ShgTableService, pubSub: RedisPubSub);
    createShgTable(createShgTableInput: CreateShgTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ShgTable;
    }>;
    findAllShg(user: any): Promise<ShgTable[]>;
    findOneShg(shgId: number): Promise<ShgTable>;
    findShgByVillageId(villageId: number): Promise<ShgTable[]>;
    findShgByVillageIdAndVoId(villageId: number, voId: number): Promise<ShgTable[]>;
    findOneShgByGpId(gpId: number): Promise<ShgTable>;
    findOneShgByBlockId(blockId: number): Promise<ShgTable>;
    findOneShgByDistrictId(districtId: number): Promise<ShgTable>;
    updateShgTable(updateShgTableInput: UpdateShgTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ShgTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeShgTable(shgId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    shgSubscription(): AsyncIterator<unknown, any, undefined>;
}
