"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShgTableResolver = exports.NEW_SHG_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const shg_table_service_1 = require("./shg-table.service");
const shg_table_entity_1 = require("./entities/shg-table.entity");
const create_shg_table_input_1 = require("./dto/create-shg-table.input");
const update_shg_table_input_1 = require("./dto/update-shg-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
const shg_table_return_type_1 = require("./types/shg-table-return.type");
const shg_table_type_1 = require("./types/shg-table.type");
exports.NEW_SHG_ADD = "NEW_SHG_ADD";
let ShgTableResolver = exports.ShgTableResolver = class ShgTableResolver {
    constructor(shgTableService, pubSub) {
        this.shgTableService = shgTableService;
        this.pubSub = pubSub;
    }
    createShgTable(createShgTableInput, user) {
        return this.shgTableService.create(createShgTableInput, user);
    }
    findAllShg(user) {
        return this.shgTableService.findAll();
    }
    findOneShg(shgId) {
        return this.shgTableService.findOne(shgId);
    }
    findShgByVillageId(villageId) {
        return this.shgTableService.findOneByVillageId(villageId);
    }
    findShgByVillageIdAndVoId(villageId, voId) {
        return this.shgTableService.findShgByVillageIdAndVoId(villageId, voId);
    }
    findOneShgByGpId(gpId) {
        return this.shgTableService.findOneByGpId(gpId);
    }
    findOneShgByBlockId(blockId) {
        return this.shgTableService.findOneByBlockId(blockId);
    }
    findOneShgByDistrictId(districtId) {
        return this.shgTableService.findOneByDistrictId(districtId);
    }
    updateShgTable(updateShgTableInput, user) {
        return this.shgTableService.update(updateShgTableInput.shgId, updateShgTableInput, user);
    }
    removeShgTable(shgId, user) {
        return this.shgTableService.remove(shgId);
    }
    shgSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SHG_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => shg_table_return_type_1.ShgTableReturnType),
    __param(0, (0, graphql_1.Args)('createShgTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_shg_table_input_1.CreateShgTableInput, Object]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "createShgTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [shg_table_type_1.ShgTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findAllShg", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => shg_table_type_1.ShgTableType),
    __param(0, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findOneShg", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [shg_table_type_1.ShgTableType]),
    __param(0, (0, graphql_1.Args)('villageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findShgByVillageId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [shg_table_type_1.ShgTableType]),
    __param(0, (0, graphql_1.Args)('villageId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('voId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findShgByVillageIdAndVoId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => shg_table_type_1.ShgTableType),
    __param(0, (0, graphql_1.Args)('gpId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findOneShgByGpId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => shg_table_type_1.ShgTableType),
    __param(0, (0, graphql_1.Args)('blockId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findOneShgByBlockId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => shg_table_type_1.ShgTableType),
    __param(0, (0, graphql_1.Args)('districtId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "findOneShgByDistrictId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => shg_table_return_type_1.ShgTableReturnType),
    __param(0, (0, graphql_1.Args)('updateShgTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_shg_table_input_1.UpdateShgTableInput, Object]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "updateShgTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => shg_table_return_type_1.ShgTableReturnType),
    __param(0, (0, graphql_1.Args)('shgId', { type: () => graphql_1.Int })),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object]),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "removeShgTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ShgTableResolver.prototype, "shgSubscription", null);
exports.ShgTableResolver = ShgTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => shg_table_entity_1.ShgTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [shg_table_service_1.ShgTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ShgTableResolver);
