import { CreateShgTableInput } from './dto/create-shg-table.input';
import { UpdateShgTableInput } from './dto/update-shg-table.input';
import { ShgTable } from './entities/shg-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { VillageTableService } from 'src/village-table/village-table.service';
import { VoTableService } from 'src/vo-table/vo-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare const NEW_SHG_ADD = "NEW_SHG_ADD";
export declare class ShgTableService {
    private readonly shgTableRepository;
    private pubSub;
    private readonly voTableService;
    private readonly villageTableService;
    private readonly userCollectionService;
    constructor(shgTableRepository: Repository<ShgTable>, pubSub: RedisPubSub, voTableService: VoTableService, villageTableService: VillageTableService, userCollectionService: UserCollectionService);
    create(createShgTableInput: CreateShgTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ShgTable;
    }>;
    createorElseReturnObject(createShgTableInput: CreateShgTableInput, user: any): Promise<any>;
    checkIfExists(shgName: string, voId: number, villageId: number): Promise<boolean>;
    findAll(): Promise<ShgTable[]>;
    findAllByBlockId(ids: number[]): Promise<ShgTable[]>;
    getCount(): Promise<number>;
    findOne(shgId: number): Promise<ShgTable>;
    findOneByVillageId(villageId: number): Promise<ShgTable[]>;
    findShgByVillageIdAndVoId(villageId: number, voId: number): Promise<ShgTable[]>;
    findOneByGpId(gpId: number): Promise<ShgTable>;
    findOneByBlockId(blockId: number): Promise<ShgTable>;
    findOneByDistrictId(districtId: number): Promise<ShgTable>;
    update(shgId: number, updateShgTableInput: UpdateShgTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: ShgTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(shgId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
