"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ShgTableService = exports.NEW_SHG_ADD = void 0;
const common_1 = require("@nestjs/common");
const shg_table_entity_1 = require("./entities/shg-table.entity");
const typeorm_1 = require("typeorm");
const typeorm_2 = require("@nestjs/typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const village_table_service_1 = require("../village-table/village-table.service");
const vo_table_service_1 = require("../vo-table/vo-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
exports.NEW_SHG_ADD = "NEW_SHG_ADD";
let ShgTableService = exports.ShgTableService = class ShgTableService {
    constructor(shgTableRepository, pubSub, voTableService, villageTableService, userCollectionService) {
        this.shgTableRepository = shgTableRepository;
        this.pubSub = pubSub;
        this.voTableService = voTableService;
        this.villageTableService = villageTableService;
        this.userCollectionService = userCollectionService;
    }
    async create(createShgTableInput, user) {
        let checkIfExists = await this.checkIfExists(createShgTableInput.shgName, createShgTableInput.voId, createShgTableInput.villageId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new shg_table_entity_1.ShgTable();
            dd.shgName = createShgTableInput.shgName;
            if (createShgTableInput.noOfMembers) {
                dd.noOfMembers = createShgTableInput.noOfMembers.toString();
            }
            dd.dateOfFormation = createShgTableInput.dateOfFormation;
            dd.nrlmRegistration = createShgTableInput.nrlmRegistration;
            dd.bankName = createShgTableInput.bankName;
            dd.bankAccountNo = createShgTableInput.bankAccountNo;
            dd.bankBranch = createShgTableInput.bankBranch;
            dd.bankIfsc = createShgTableInput.bankIfsc;
            let village = await this.villageTableService.findOne(createShgTableInput.villageId);
            dd.VillageTable = village;
            let vo = await this.voTableService.findOne(createShgTableInput.voId);
            dd.VoTable = vo;
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            dd.UserTable = userData;
            let result = await this.shgTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_SHG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async createorElseReturnObject(createShgTableInput, user) {
        let checkIfAlreadyExists = null;
        if (createShgTableInput.voId > 0) {
            checkIfAlreadyExists = await this.shgTableRepository.findOne({
                where: {
                    shgName: createShgTableInput.shgName.trim(),
                    VillageTable: {
                        villageId: createShgTableInput.villageId
                    },
                    VoTable: {
                        voId: createShgTableInput.voId
                    }
                }
            });
        }
        else {
            checkIfAlreadyExists = await this.shgTableRepository.findOne({
                where: {
                    shgName: createShgTableInput.shgName.trim(),
                    VillageTable: {
                        villageId: createShgTableInput.villageId
                    },
                }
            });
        }
        if (!checkIfAlreadyExists) {
            let dd = new shg_table_entity_1.ShgTable();
            dd.shgName = createShgTableInput.shgName.trim();
            dd.noOfMembers = createShgTableInput.noOfMembers.toString();
            if (createShgTableInput.dateOfFormation) {
                dd.dateOfFormation = createShgTableInput.dateOfFormation;
            }
            if (createShgTableInput.nrlmRegistration) {
                dd.nrlmRegistration = createShgTableInput.nrlmRegistration;
            }
            if (createShgTableInput.bankName) {
                dd.bankName = createShgTableInput.bankName;
            }
            if (createShgTableInput.bankAccountNo) {
                dd.bankAccountNo = createShgTableInput.bankAccountNo;
            }
            if (createShgTableInput.bankBranch) {
                dd.bankBranch = createShgTableInput.bankBranch;
            }
            if (createShgTableInput.bankIfsc) {
                dd.bankIfsc = createShgTableInput.bankIfsc;
            }
            let village = await this.villageTableService.findOne(createShgTableInput.villageId);
            dd.VillageTable = village;
            if (createShgTableInput.voId > 0) {
                let vo = await this.voTableService.findOne(createShgTableInput.voId);
                dd.VoTable = vo;
            }
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            dd.UserTable = userData;
            let result = await this.shgTableRepository.save(dd);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfExists(shgName, voId, villageId) {
        let result = await this.shgTableRepository.count({
            where: {
                shgName: shgName,
                VillageTable: {
                    villageId
                },
                VoTable: {
                    voId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.shgTableRepository.find({
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                }
            }
        });
    }
    async findAllByBlockId(ids) {
        return await this.shgTableRepository.find({
            where: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            blockId: (0, typeorm_1.In)(ids)
                        }
                    }
                }
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                }
            }
        });
    }
    async getCount() {
        return await this.shgTableRepository.count();
    }
    async findOne(shgId) {
        return await this.shgTableRepository.findOne({
            where: {
                shgId
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: true
            }
        });
    }
    async findOneByVillageId(villageId) {
        return await this.shgTableRepository.find({
            where: {
                VillageTable: {
                    villageId
                }
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: true
            }
        });
    }
    async findShgByVillageIdAndVoId(villageId, voId) {
        if (voId > 0) {
            return await this.shgTableRepository.find({
                where: {
                    VillageTable: {
                        villageId
                    },
                    VoTable: {
                        voId
                    }
                },
                relations: {
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true
                                }
                            }
                        }
                    },
                    VoTable: true
                }
            });
        }
        else {
            return await this.shgTableRepository.find({
                where: {
                    VillageTable: {
                        villageId
                    },
                },
                relations: {
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true
                                }
                            }
                        }
                    },
                    VoTable: true
                }
            });
        }
    }
    async findOneByGpId(gpId) {
        return await this.shgTableRepository.findOne({
            where: {
                VillageTable: {
                    GrampanchayatTable: {
                        gpId
                    }
                }
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: true
            }
        });
    }
    async findOneByBlockId(blockId) {
        return await this.shgTableRepository.findOne({
            where: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            blockId
                        }
                    }
                }
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: true
            }
        });
    }
    async findOneByDistrictId(districtId) {
        return await this.shgTableRepository.findOne({
            where: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                districtId
                            }
                        }
                    }
                }
            },
            relations: {
                VillageTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                VoTable: true
            }
        });
    }
    async update(shgId, updateShgTableInput, user) {
        let result = await this.findOne(shgId);
        if (result) {
            result.shgName = updateShgTableInput.shgName;
            result.noOfMembers = updateShgTableInput.noOfMembers.toString();
            if (updateShgTableInput.dateOfFormation) {
                result.dateOfFormation = updateShgTableInput.dateOfFormation;
            }
            if (updateShgTableInput.nrlmRegistration) {
                result.nrlmRegistration = updateShgTableInput.nrlmRegistration;
            }
            if (updateShgTableInput.bankName) {
                result.bankName = updateShgTableInput.bankName;
            }
            if (updateShgTableInput.bankAccountNo) {
                result.bankAccountNo = updateShgTableInput.bankAccountNo;
            }
            if (updateShgTableInput.bankBranch) {
                result.bankBranch = updateShgTableInput.bankBranch;
            }
            if (updateShgTableInput.bankIfsc) {
                result.bankIfsc = updateShgTableInput.bankIfsc;
            }
            let village = await this.villageTableService.findOne(updateShgTableInput.villageId);
            result.VillageTable = village;
            if (updateShgTableInput.voId) {
                let vo = await this.voTableService.findOne(updateShgTableInput.voId);
                result.VoTable = vo;
            }
            else {
                result.VoTable = null;
            }
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            result.UserTable = userData;
            let result1 = await this.shgTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SHG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result1
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async remove(shgId) {
        let result = await this.findOne(shgId);
        if (result) {
            await this.shgTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SHG_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
};
exports.ShgTableService = ShgTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_2.InjectRepository)(shg_table_entity_1.ShgTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_1.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        vo_table_service_1.VoTableService,
        village_table_service_1.VillageTableService,
        user_collection_service_1.UserCollectionService])
], ShgTableService);
