import { SocialCategoryTableService } from './social-category-table.service';
import { SocialCategoryTable } from './entities/social-category-table.entity';
import { CreateSocialCategoryTableInput } from './dto/create-social-category-table.input';
import { UpdateSocialCategoryTableInput } from './dto/update-social-category-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SOCIALCAT_ADD = "NEW_SOCIALCAT_ADD";
export declare class SocialCategoryTableResolver {
    private readonly socialCategoryTableService;
    private pubSub;
    constructor(socialCategoryTableService: SocialCategoryTableService, pubSub: RedisPubSub);
    createSocialCategoryTable(createSocialCategoryTableInput: CreateSocialCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SocialCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSocialCategory(): Promise<SocialCategoryTable[]>;
    findOneSocialCategory(scId: number): Promise<SocialCategoryTable>;
    updateSocialCategoryTable(updateSocialCategoryTableInput: UpdateSocialCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SocialCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSocialCategoryTable(scId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    socialCategorySubscription(): AsyncIterator<unknown, any, undefined>;
}
