"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocialCategoryTableResolver = exports.NEW_SOCIALCAT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const social_category_table_service_1 = require("./social-category-table.service");
const social_category_table_entity_1 = require("./entities/social-category-table.entity");
const create_social_category_table_input_1 = require("./dto/create-social-category-table.input");
const update_social_category_table_input_1 = require("./dto/update-social-category-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const social_category_table_return_type_1 = require("./types/social-category-table-return.type");
const social_category_table_type_1 = require("./types/social-category-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_SOCIALCAT_ADD = "NEW_SOCIALCAT_ADD";
let SocialCategoryTableResolver = exports.SocialCategoryTableResolver = class SocialCategoryTableResolver {
    constructor(socialCategoryTableService, pubSub) {
        this.socialCategoryTableService = socialCategoryTableService;
        this.pubSub = pubSub;
    }
    createSocialCategoryTable(createSocialCategoryTableInput) {
        return this.socialCategoryTableService.create(createSocialCategoryTableInput);
    }
    findAllSocialCategory() {
        return this.socialCategoryTableService.findAll();
    }
    findOneSocialCategory(scId) {
        return this.socialCategoryTableService.findOne(scId);
    }
    updateSocialCategoryTable(updateSocialCategoryTableInput) {
        return this.socialCategoryTableService.update(updateSocialCategoryTableInput.scId, updateSocialCategoryTableInput);
    }
    removeSocialCategoryTable(scId) {
        return this.socialCategoryTableService.remove(scId);
    }
    socialCategorySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SOCIALCAT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => social_category_table_return_type_1.SocialCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('createSocialCategoryTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_social_category_table_input_1.CreateSocialCategoryTableInput]),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "createSocialCategoryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [social_category_table_type_1.SocialCategoryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "findAllSocialCategory", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => social_category_table_type_1.SocialCategoryTableType),
    __param(0, (0, graphql_1.Args)('scId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "findOneSocialCategory", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => social_category_table_return_type_1.SocialCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSocialCategoryTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_social_category_table_input_1.UpdateSocialCategoryTableInput]),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "updateSocialCategoryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => social_category_table_return_type_1.SocialCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('scId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "removeSocialCategoryTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SocialCategoryTableResolver.prototype, "socialCategorySubscription", null);
exports.SocialCategoryTableResolver = SocialCategoryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => social_category_table_entity_1.SocialCategoryTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [social_category_table_service_1.SocialCategoryTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SocialCategoryTableResolver);
