import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateSocialCategoryTableInput } from './dto/create-social-category-table.input';
import { UpdateSocialCategoryTableInput } from './dto/update-social-category-table.input';
import { SocialCategoryTable } from './entities/social-category-table.entity';
export declare const NEW_SOCIALCAT_ADD = "NEW_SOCIALCAT_ADD";
export declare class SocialCategoryTableService {
    private readonly socialCategoryTableRepository;
    private pubSub;
    constructor(socialCategoryTableRepository: Repository<SocialCategoryTable>, pubSub: RedisPubSub);
    create(createSocialCategoryTableInput: CreateSocialCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SocialCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createSocialCategoryTableInput: CreateSocialCategoryTableInput): Promise<number>;
    findAll(): Promise<SocialCategoryTable[]>;
    findOne(scId: number): Promise<SocialCategoryTable>;
    findOneByName(scName: string): Promise<SocialCategoryTable>;
    update(scId: number, updateSocialCategoryTableInput: UpdateSocialCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SocialCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(scId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
