"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SocialCategoryTableService = exports.NEW_SOCIALCAT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const social_category_table_entity_1 = require("./entities/social-category-table.entity");
exports.NEW_SOCIALCAT_ADD = "NEW_SOCIALCAT_ADD";
let SocialCategoryTableService = exports.SocialCategoryTableService = class SocialCategoryTableService {
    constructor(socialCategoryTableRepository, pubSub) {
        this.socialCategoryTableRepository = socialCategoryTableRepository;
        this.pubSub = pubSub;
    }
    async create(createSocialCategoryTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createSocialCategoryTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new social_category_table_entity_1.SocialCategoryTable();
            st.scName = createSocialCategoryTableInput.scName;
            let result = await this.socialCategoryTableRepository.save(st);
            this.pubSub.publish(exports.NEW_SOCIALCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createSocialCategoryTableInput) {
        let result = await this.socialCategoryTableRepository.count({
            where: {
                scName: createSocialCategoryTableInput.scName
            }
        });
        return result;
    }
    async findAll() {
        return await this.socialCategoryTableRepository.find();
    }
    async findOne(scId) {
        return await this.socialCategoryTableRepository.findOne({
            where: {
                scId
            }
        });
    }
    async findOneByName(scName) {
        return await this.socialCategoryTableRepository.findOne({
            where: {
                scName
            }
        });
    }
    async update(scId, updateSocialCategoryTableInput) {
        let result = await this.findOne(scId);
        if (result) {
            result.scName = updateSocialCategoryTableInput.scName;
            let updatedResult = await this.socialCategoryTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SOCIALCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(scId) {
        let result = await this.findOne(scId);
        if (result) {
            await this.socialCategoryTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SOCIALCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.SocialCategoryTableService = SocialCategoryTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(social_category_table_entity_1.SocialCategoryTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], SocialCategoryTableService);
