import { SourceOfIrrigationTableService } from './source-of-irrigation-table.service';
import { SourceOfIrrigationTable } from './entities/source-of-irrigation-table.entity';
import { CreateSourceOfIrrigationTableInput } from './dto/create-source-of-irrigation-table.input';
import { UpdateSourceOfIrrigationTableInput } from './dto/update-source-of-irrigation-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SI_ADD = "NEW_SI_ADD";
export declare class SourceOfIrrigationTableResolver {
    private readonly sourceOfIrrigationTableService;
    private pubSub;
    constructor(sourceOfIrrigationTableService: SourceOfIrrigationTableService, pubSub: RedisPubSub);
    createSourceOfIrrigationTable(createSourceOfIrrigationTableInput: CreateSourceOfIrrigationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SourceOfIrrigationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSourceOfIrrigation(): Promise<SourceOfIrrigationTable[]>;
    findOneSourceOfIrrigation(siId: number): Promise<SourceOfIrrigationTable>;
    updateSourceOfIrrigationTable(updateSourceOfIrrigationTableInput: UpdateSourceOfIrrigationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SourceOfIrrigationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSourceOfIrrigationTable(siId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    sourceOfIrrigationSubscription(): AsyncIterator<unknown, any, undefined>;
}
