"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SourceOfIrrigationTableResolver = exports.NEW_SI_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const source_of_irrigation_table_service_1 = require("./source-of-irrigation-table.service");
const source_of_irrigation_table_entity_1 = require("./entities/source-of-irrigation-table.entity");
const create_source_of_irrigation_table_input_1 = require("./dto/create-source-of-irrigation-table.input");
const update_source_of_irrigation_table_input_1 = require("./dto/update-source-of-irrigation-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const source_of_irrigation_table_return_type_1 = require("./types/source-of-irrigation-table-return.type");
const source_of_irrigation_table_type_1 = require("./types/source-of-irrigation-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_SI_ADD = "NEW_SI_ADD";
let SourceOfIrrigationTableResolver = exports.SourceOfIrrigationTableResolver = class SourceOfIrrigationTableResolver {
    constructor(sourceOfIrrigationTableService, pubSub) {
        this.sourceOfIrrigationTableService = sourceOfIrrigationTableService;
        this.pubSub = pubSub;
    }
    createSourceOfIrrigationTable(createSourceOfIrrigationTableInput) {
        return this.sourceOfIrrigationTableService.create(createSourceOfIrrigationTableInput);
    }
    findAllSourceOfIrrigation() {
        return this.sourceOfIrrigationTableService.findAll();
    }
    findOneSourceOfIrrigation(siId) {
        return this.sourceOfIrrigationTableService.findOne(siId);
    }
    updateSourceOfIrrigationTable(updateSourceOfIrrigationTableInput) {
        return this.sourceOfIrrigationTableService.update(updateSourceOfIrrigationTableInput.siId, updateSourceOfIrrigationTableInput);
    }
    removeSourceOfIrrigationTable(siId) {
        return this.sourceOfIrrigationTableService.remove(siId);
    }
    sourceOfIrrigationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SI_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => source_of_irrigation_table_return_type_1.SourceOfIrrigationTableReturnType),
    __param(0, (0, graphql_1.Args)('createSourceOfIrrigationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_source_of_irrigation_table_input_1.CreateSourceOfIrrigationTableInput]),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "createSourceOfIrrigationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [source_of_irrigation_table_type_1.SourceOfIrrigationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "findAllSourceOfIrrigation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => source_of_irrigation_table_type_1.SourceOfIrrigationTableType),
    __param(0, (0, graphql_1.Args)('siId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "findOneSourceOfIrrigation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => source_of_irrigation_table_return_type_1.SourceOfIrrigationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSourceOfIrrigationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_source_of_irrigation_table_input_1.UpdateSourceOfIrrigationTableInput]),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "updateSourceOfIrrigationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => source_of_irrigation_table_return_type_1.SourceOfIrrigationTableReturnType),
    __param(0, (0, graphql_1.Args)('siId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "removeSourceOfIrrigationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SourceOfIrrigationTableResolver.prototype, "sourceOfIrrigationSubscription", null);
exports.SourceOfIrrigationTableResolver = SourceOfIrrigationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => source_of_irrigation_table_entity_1.SourceOfIrrigationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [source_of_irrigation_table_service_1.SourceOfIrrigationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SourceOfIrrigationTableResolver);
