import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateSourceOfIrrigationTableInput } from './dto/create-source-of-irrigation-table.input';
import { UpdateSourceOfIrrigationTableInput } from './dto/update-source-of-irrigation-table.input';
import { SourceOfIrrigationTable } from './entities/source-of-irrigation-table.entity';
export declare const NEW_SI_ADD = "NEW_SI_ADD";
export declare class SourceOfIrrigationTableService {
    private readonly sourceOfIrrigationTableRepository;
    private pubSub;
    constructor(sourceOfIrrigationTableRepository: Repository<SourceOfIrrigationTable>, pubSub: RedisPubSub);
    create(createSourceOfIrrigationTableInput: CreateSourceOfIrrigationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SourceOfIrrigationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createSourceOfIrrigationTableInput: CreateSourceOfIrrigationTableInput): Promise<SourceOfIrrigationTable>;
    checkIfAlreadyExists(createSourceOfIrrigationTableInput: CreateSourceOfIrrigationTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<SourceOfIrrigationTable[]>;
    findOne(siId: number): Promise<SourceOfIrrigationTable>;
    update(siId: number, updateSourceOfIrrigationTableInput: UpdateSourceOfIrrigationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SourceOfIrrigationTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(siId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
