"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SourceOfIrrigationTableService = exports.NEW_SI_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const source_of_irrigation_table_entity_1 = require("./entities/source-of-irrigation-table.entity");
exports.NEW_SI_ADD = "NEW_SI_ADD";
let SourceOfIrrigationTableService = exports.SourceOfIrrigationTableService = class SourceOfIrrigationTableService {
    constructor(sourceOfIrrigationTableRepository, pubSub) {
        this.sourceOfIrrigationTableRepository = sourceOfIrrigationTableRepository;
        this.pubSub = pubSub;
    }
    async create(createSourceOfIrrigationTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createSourceOfIrrigationTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new source_of_irrigation_table_entity_1.SourceOfIrrigationTable();
            st.siName = createSourceOfIrrigationTableInput.siName;
            st.siLocalName = createSourceOfIrrigationTableInput.siLocalName;
            let result = await this.sourceOfIrrigationTableRepository.save(st);
            this.pubSub.publish(exports.NEW_SI_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createSourceOfIrrigationTableInput) {
        let checkIfAlreadyExists = await this.sourceOfIrrigationTableRepository.findOne({
            where: {
                siName: createSourceOfIrrigationTableInput.siName.trim(),
                siLocalName: createSourceOfIrrigationTableInput.siLocalName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new source_of_irrigation_table_entity_1.SourceOfIrrigationTable();
            st.siName = createSourceOfIrrigationTableInput.siName.trim();
            st.siLocalName = createSourceOfIrrigationTableInput.siLocalName.trim();
            let result = await this.sourceOfIrrigationTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createSourceOfIrrigationTableInput) {
        let result = await this.sourceOfIrrigationTableRepository.count({
            where: {
                siName: createSourceOfIrrigationTableInput.siName,
                siLocalName: createSourceOfIrrigationTableInput.siLocalName
            }
        });
        return result;
    }
    async getCount() {
        return await this.sourceOfIrrigationTableRepository.count();
    }
    async findAll() {
        return await this.sourceOfIrrigationTableRepository.find();
    }
    async findOne(siId) {
        return await this.sourceOfIrrigationTableRepository.findOne({
            where: {
                siId
            }
        });
    }
    async update(siId, updateSourceOfIrrigationTableInput) {
        let result = await this.findOne(siId);
        if (result) {
            result.siName = updateSourceOfIrrigationTableInput.siName;
            result.siLocalName = updateSourceOfIrrigationTableInput.siLocalName;
            let updatedResult = await this.sourceOfIrrigationTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SI_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(siId) {
        let result = await this.findOne(siId);
        if (result) {
            await this.sourceOfIrrigationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SI_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.SourceOfIrrigationTableService = SourceOfIrrigationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(source_of_irrigation_table_entity_1.SourceOfIrrigationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], SourceOfIrrigationTableService);
