import { SpecialityCollectionService } from './speciality-collection.service';
import { SpecialityCollection } from './entities/speciality-collection.entity';
import { CreateSpecialityCollectionInput } from './dto/create-speciality-collection.input';
import { UpdateSpecialityCollectionInput } from './dto/update-speciality-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SPECIALITY_ADD = "NEW_SPECIALITY_ADD";
export declare class SpecialityCollectionResolver {
    private readonly specialityCollectionService;
    private pubSub;
    constructor(specialityCollectionService: SpecialityCollectionService, pubSub: RedisPubSub);
    createSpecialityCollection(user: any, createSpecialityCollectionInput: CreateSpecialityCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: SpecialityCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    findAllSpeciality(): Promise<(SpecialityCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneSpeciality(id: string): string;
    updateSpecialityCollection(updateSpecialityCollectionInput: UpdateSpecialityCollectionInput): Promise<any>;
    removeSpecialityCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any[];
    }>;
    specialitySubscription(): AsyncIterator<unknown, any, undefined>;
}
