"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpecialityCollectionResolver = exports.NEW_SPECIALITY_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const speciality_collection_service_1 = require("./speciality-collection.service");
const speciality_collection_entity_1 = require("./entities/speciality-collection.entity");
const create_speciality_collection_input_1 = require("./dto/create-speciality-collection.input");
const update_speciality_collection_input_1 = require("./dto/update-speciality-collection.input");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const create_speciality_collection_result_type_1 = require("./input/create-speciality-collection-result.type");
const new_product_category_type_1 = require("../product-category-collection/types/new-product-category.type");
const speciality_collection_type_1 = require("./input/speciality-collection.type");
exports.NEW_SPECIALITY_ADD = "NEW_SPECIALITY_ADD";
let SpecialityCollectionResolver = class SpecialityCollectionResolver {
    constructor(specialityCollectionService, pubSub) {
        this.specialityCollectionService = specialityCollectionService;
        this.pubSub = pubSub;
    }
    createSpecialityCollection(user, createSpecialityCollectionInput) {
        return this.specialityCollectionService.create(createSpecialityCollectionInput);
    }
    findAllSpeciality() {
        return this.specialityCollectionService.findAll();
    }
    findOneSpeciality(id) {
        return this.specialityCollectionService.findOne(id);
    }
    updateSpecialityCollection(updateSpecialityCollectionInput) {
        return this.specialityCollectionService.update(updateSpecialityCollectionInput.id, updateSpecialityCollectionInput);
    }
    removeSpecialityCollection(id) {
        return this.specialityCollectionService.remove(id);
    }
    specialitySubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SPECIALITY_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => create_speciality_collection_result_type_1.SpecialityCollectionResultType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createSpecialityCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_speciality_collection_input_1.CreateSpecialityCollectionInput]),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "createSpecialityCollection", null);
__decorate([
    (0, graphql_1.Query)(() => [speciality_collection_type_1.SpecialityCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "findAllSpeciality", null);
__decorate([
    (0, graphql_1.Query)(() => speciality_collection_type_1.SpecialityCollectionType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "findOneSpeciality", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => create_speciality_collection_result_type_1.SpecialityCollectionResultType),
    __param(0, (0, graphql_1.Args)('updateSpecialityCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_speciality_collection_input_1.UpdateSpecialityCollectionInput]),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "updateSpecialityCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => create_speciality_collection_result_type_1.SpecialityCollectionResultType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "removeSpecialityCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, graphql_1.Subscription)(() => new_product_category_type_1.NewCategoryAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SpecialityCollectionResolver.prototype, "specialitySubscription", null);
SpecialityCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => speciality_collection_entity_1.SpecialityCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [speciality_collection_service_1.SpecialityCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SpecialityCollectionResolver);
exports.SpecialityCollectionResolver = SpecialityCollectionResolver;
