import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { CreateSpecialityCollectionInput } from './dto/create-speciality-collection.input';
import { UpdateSpecialityCollectionInput } from './dto/update-speciality-collection.input';
import { SpecialityCollection, SpecialityDocument } from './entities/speciality-collection.entity';
export declare const NEW_SPECIALITY_ADD = "NEW_SPECIALITY_ADD";
export declare class SpecialityCollectionService {
    private specialityRepository;
    private pubSub;
    constructor(specialityRepository: Model<SpecialityDocument>, pubSub: RedisPubSub);
    create(createSpecialityCollectionInput: CreateSpecialityCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: SpecialityCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(name: string): Promise<boolean>;
    findAll(): Promise<(SpecialityCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneById(id: string): Promise<SpecialityCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    findOne(id: string): string;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any[];
    }>;
    update(id: string, updateSpecialityCollectionInput: UpdateSpecialityCollectionInput): Promise<any>;
}
