"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpecialityCollectionService = exports.NEW_SPECIALITY_ADD = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const speciality_collection_entity_1 = require("./entities/speciality-collection.entity");
exports.NEW_SPECIALITY_ADD = "NEW_SPECIALITY_ADD";
let SpecialityCollectionService = class SpecialityCollectionService {
    constructor(specialityRepository, pubSub) {
        this.specialityRepository = specialityRepository;
        this.pubSub = pubSub;
    }
    async create(createSpecialityCollectionInput) {
        let checkIfExists = await this.checkIfExists(createSpecialityCollectionInput.name);
        if (!checkIfExists) {
            let cm = new speciality_collection_entity_1.SpecialityCollection();
            cm.name = createSpecialityCollectionInput.name;
            let c = await this.specialityRepository.create(cm);
            this.pubSub.publish(exports.NEW_SPECIALITY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(name) {
        let r = await this.specialityRepository.count({
            name: name
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.specialityRepository.find().exec();
    }
    async findOneById(id) {
        return await this.specialityRepository.findOne({ _id: id }).exec();
    }
    findOne(id) {
        return `This action returns a #${id} clientCollection`;
    }
    async remove(id) {
        await this.specialityRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_SPECIALITY_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: []
        };
    }
    async update(id, updateSpecialityCollectionInput) {
        let cc = await this.specialityRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.name = updateSpecialityCollectionInput.name;
            let cc1 = await this.specialityRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_SPECIALITY_ADD, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
SpecialityCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(speciality_collection_entity_1.SpecialityCollection.name)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        graphql_redis_subscriptions_1.RedisPubSub])
], SpecialityCollectionService);
exports.SpecialityCollectionService = SpecialityCollectionService;
