import { StateTableService } from './state-table.service';
import { StateTable } from './entities/state-table.entity';
import { CreateStateTableInput } from './dto/create-state-table.input';
import { UpdateStateTableInput } from './dto/update-state-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_STATE_ADD = "NEW_STATE_ADD";
export declare class StateTableResolver {
    private readonly stateTableService;
    private pubSub;
    constructor(stateTableService: StateTableService, pubSub: RedisPubSub);
    createStateTable(createStateTableInput: CreateStateTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: StateTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllState(): Promise<StateTable[]>;
    findOneState(stateId: number): Promise<StateTable>;
    updateStateTable(updateStateTableInput: UpdateStateTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: StateTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeStateTable(stateId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    stateSubscription(): AsyncIterator<unknown, any, undefined>;
}
