"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateTableResolver = exports.NEW_STATE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const state_table_service_1 = require("./state-table.service");
const state_table_entity_1 = require("./entities/state-table.entity");
const create_state_table_input_1 = require("./dto/create-state-table.input");
const update_state_table_input_1 = require("./dto/update-state-table.input");
const state_table_return_type_1 = require("./types/state-table-return.type");
const state_table_type_1 = require("./types/state-table.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_STATE_ADD = "NEW_STATE_ADD";
let StateTableResolver = exports.StateTableResolver = class StateTableResolver {
    constructor(stateTableService, pubSub) {
        this.stateTableService = stateTableService;
        this.pubSub = pubSub;
    }
    createStateTable(createStateTableInput) {
        return this.stateTableService.create(createStateTableInput);
    }
    findAllState() {
        return this.stateTableService.findAll();
    }
    findOneState(stateId) {
        return this.stateTableService.findOne(stateId);
    }
    updateStateTable(updateStateTableInput) {
        return this.stateTableService.update(updateStateTableInput.stateId, updateStateTableInput);
    }
    removeStateTable(stateId) {
        return this.stateTableService.remove(stateId);
    }
    stateSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_STATE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => state_table_return_type_1.StateTableReturnType),
    __param(0, (0, graphql_1.Args)('createStateTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_state_table_input_1.CreateStateTableInput]),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "createStateTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [state_table_type_1.StateTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "findAllState", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => state_table_type_1.StateTableType),
    __param(0, (0, graphql_1.Args)('stateId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "findOneState", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => state_table_return_type_1.StateTableReturnType),
    __param(0, (0, graphql_1.Args)('updateStateTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_state_table_input_1.UpdateStateTableInput]),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "updateStateTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => state_table_return_type_1.StateTableReturnType),
    __param(0, (0, graphql_1.Args)('stateId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "removeStateTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StateTableResolver.prototype, "stateSubscription", null);
exports.StateTableResolver = StateTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => state_table_entity_1.StateTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [state_table_service_1.StateTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], StateTableResolver);
