import { CreateStateTableInput } from './dto/create-state-table.input';
import { UpdateStateTableInput } from './dto/update-state-table.input';
import { StateTable } from './entities/state-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_STATE_ADD = "NEW_STATE_ADD";
export declare class StateTableService {
    private readonly stateTableRepository;
    private pubSub;
    constructor(stateTableRepository: Repository<StateTable>, pubSub: RedisPubSub);
    create(createStateTableInput: CreateStateTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: StateTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createStateTableInput: CreateStateTableInput): Promise<StateTable>;
    checkIfAlreadyExists(createStateTableInput: CreateStateTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<StateTable[]>;
    findAllByIds(ids: number[]): Promise<StateTable[]>;
    findOne(stateId: number): Promise<StateTable>;
    update(stateId: number, updateStateTableInput: UpdateStateTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: StateTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(stateId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
