"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateTableService = exports.NEW_STATE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const state_table_entity_1 = require("./entities/state-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_STATE_ADD = "NEW_STATE_ADD";
let StateTableService = exports.StateTableService = class StateTableService {
    constructor(stateTableRepository, pubSub) {
        this.stateTableRepository = stateTableRepository;
        this.pubSub = pubSub;
    }
    async create(createStateTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createStateTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new state_table_entity_1.StateTable();
            st.stateName = createStateTableInput.stateName;
            let result = await this.stateTableRepository.save(st);
            this.pubSub.publish(exports.NEW_STATE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createStateTableInput) {
        let checkIfAlreadyExists = await this.stateTableRepository.findOne({
            where: {
                stateName: createStateTableInput.stateName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new state_table_entity_1.StateTable();
            st.stateName = createStateTableInput.stateName.trim();
            let result = await this.stateTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createStateTableInput) {
        let result = await this.stateTableRepository.count({
            where: {
                stateName: createStateTableInput.stateName
            }
        });
        return result;
    }
    async getCount() {
        return await this.stateTableRepository.count();
    }
    async findAll() {
        return await this.stateTableRepository.find();
    }
    async findAllByIds(ids) {
        return await this.stateTableRepository.find({
            where: {
                stateId: (0, typeorm_2.In)(ids)
            }
        });
    }
    async findOne(stateId) {
        return await this.stateTableRepository.findOne({
            where: {
                stateId
            }
        });
    }
    async update(stateId, updateStateTableInput) {
        let result = await this.findOne(stateId);
        if (result) {
            result.stateName = updateStateTableInput.stateName;
            let updatedResult = await this.stateTableRepository.save(result);
            this.pubSub.publish(exports.NEW_STATE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(stateId) {
        let result = await this.findOne(stateId);
        if (result) {
            await this.stateTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_STATE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.StateTableService = StateTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(state_table_entity_1.StateTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], StateTableService);
