"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockBalanceTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const stock_balance_table_return_type_1 = require("./types/stock-balance-table-return.type");
const stock_balance_table_type_1 = require("./types/stock-balance-table.type");
const stock_balance_table_entity_1 = require("./entities/stock-balance-table.entity");
const stock_balance_table_service_1 = require("./stock-balance-table.service");
const create_stock_balance_table_input_1 = require("./dto/create-stock-balance-table-input");
let StockBalanceTableResolver = class StockBalanceTableResolver {
    constructor(stockBalanceTableService) {
        this.stockBalanceTableService = stockBalanceTableService;
    }
    createStockBalanceTable(createStockBalanceTableInput, user) {
        return this.stockBalanceTableService.create(createStockBalanceTableInput);
    }
    findAllStockBalance() {
        return this.stockBalanceTableService.findAll();
    }
    findAllStockBalanceByHousingWithDate(housingId, startingDate, endingDate) {
        return this.stockBalanceTableService.findAllStockBalanceByHousingWithDate(housingId, startingDate, endingDate);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_balance_table_return_type_1.StockBalanceTableReturnType),
    __param(0, (0, graphql_1.Args)('createCurrentStockTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_stock_balance_table_input_1.CreateStockBalanceTableInput, Object]),
    __metadata("design:returntype", void 0)
], StockBalanceTableResolver.prototype, "createStockBalanceTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_balance_table_type_1.StockBalanceTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StockBalanceTableResolver.prototype, "findAllStockBalance", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_balance_table_type_1.StockBalanceTableType]),
    __param(0, (0, graphql_1.Args)("housingId")),
    __param(1, (0, graphql_1.Args)("startingDate")),
    __param(2, (0, graphql_1.Args)("endingDate")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, String, String]),
    __metadata("design:returntype", void 0)
], StockBalanceTableResolver.prototype, "findAllStockBalanceByHousingWithDate", null);
StockBalanceTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => stock_balance_table_entity_1.StockBalanceTable),
    __metadata("design:paramtypes", [stock_balance_table_service_1.StockBalanceTableService])
], StockBalanceTableResolver);
exports.StockBalanceTableResolver = StockBalanceTableResolver;
