import { BreedTableService } from 'src/breed-table/breed-table.service';
import { FarmersTableService } from 'src/farmers-table/farmers-table.service';
import { HousingTableService } from 'src/housing-table/housing-table.service';
import { Repository } from 'typeorm';
import { CreateStockBalanceTableInput } from './dto/create-stock-balance-table-input';
import { StockBalanceTable } from './entities/stock-balance-table.entity';
export declare class StockBalanceTableService {
    private readonly stockBalanceTableRepository;
    private readonly farmersTableService;
    private readonly housingTableService;
    private readonly breedTableService;
    constructor(stockBalanceTableRepository: Repository<StockBalanceTable>, farmersTableService: FarmersTableService, housingTableService: HousingTableService, breedTableService: BreedTableService);
    create(createTableDto: CreateStockBalanceTableInput): Promise<{
        status: boolean;
    }>;
    checkIfExists(createTableDto: CreateStockBalanceTableInput): Promise<false | StockBalanceTable>;
    updateGreaterDate(createTableDto: CreateStockBalanceTableInput): Promise<boolean>;
    findAll(): Promise<StockBalanceTable[]>;
    getByHousingId(housingId: number): Promise<StockBalanceTable>;
    getByBreedId(breedId: number): Promise<StockBalanceTable>;
    findAllStockBalanceByHousingWithDate(housingId: number, startingDate: string, endingDate: string): Promise<StockBalanceTable[]>;
}
