"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockBalanceTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const breed_table_service_1 = require("../breed-table/breed-table.service");
const farmers_table_service_1 = require("../farmers-table/farmers-table.service");
const housing_table_service_1 = require("../housing-table/housing-table.service");
const typeorm_2 = require("typeorm");
const stock_balance_table_entity_1 = require("./entities/stock-balance-table.entity");
const housing_table_entity_1 = require("../housing-table/entities/housing-table.entity");
const breed_table_entity_1 = require("../breed-table/entities/breed-table.entity");
let StockBalanceTableService = class StockBalanceTableService {
    constructor(stockBalanceTableRepository, farmersTableService, housingTableService, breedTableService) {
        this.stockBalanceTableRepository = stockBalanceTableRepository;
        this.farmersTableService = farmersTableService;
        this.housingTableService = housingTableService;
        this.breedTableService = breedTableService;
    }
    async create(createTableDto) {
        let result = await this.checkIfExists(createTableDto);
        if (!result) {
            let lt = new stock_balance_table_entity_1.StockBalanceTable();
            lt.HousingTable = await this.housingTableService.findOne(createTableDto.housingId);
            lt.BreedTable = await this.breedTableService.findOne(createTableDto.breedId);
            lt.opMale = 0;
            lt.opFemale = 0;
            lt.opTotal = 0;
            lt.opWeight = 0.000;
            lt.crMale = createTableDto.qtyMale;
            lt.crFemale = createTableDto.qtyFemale;
            lt.crTotal = createTableDto.qtyTotal;
            lt.crTotal = createTableDto.qtyTotal;
            lt.crWeight = createTableDto.totalWeight;
            lt.dateOfEntry = createTableDto.dateOfEntry;
            lt.ageGroup = createTableDto.ageGroup;
            await this.stockBalanceTableRepository.save(lt);
            await this.updateGreaterDate(createTableDto);
        }
        else {
            if (result.dateOfEntry == createTableDto.dateOfEntry) {
                result.crMale = parseFloat(result.crMale.toString()) + createTableDto.qtyMale;
                result.crFemale = parseFloat(result.crFemale.toString()) + createTableDto.qtyFemale;
                result.crTotal = parseFloat(result.crTotal.toString()) + createTableDto.qtyTotal;
                result.crWeight = parseFloat(result.crWeight.toString()) + createTableDto.totalWeight;
                await this.stockBalanceTableRepository.save(result);
                await this.updateGreaterDate(createTableDto);
            }
            else {
                let lt = new stock_balance_table_entity_1.StockBalanceTable();
                lt.HousingTable = await this.housingTableService.findOne(createTableDto.housingId);
                lt.BreedTable = await this.breedTableService.findOne(createTableDto.breedId);
                lt.opMale = result.crMale;
                lt.opFemale = result.crFemale;
                lt.opTotal = result.crTotal;
                lt.opWeight = result.crWeight;
                lt.crMale = parseFloat(result.crMale.toString()) + createTableDto.qtyMale;
                lt.crFemale = parseFloat(result.crFemale.toString()) + createTableDto.qtyFemale;
                lt.crTotal = parseFloat(result.crTotal.toString()) + createTableDto.qtyTotal;
                lt.crWeight = parseFloat(result.crWeight.toString()) + createTableDto.totalWeight;
                lt.dateOfEntry = createTableDto.dateOfEntry;
                lt.ageGroup = createTableDto.ageGroup;
                await this.stockBalanceTableRepository.save(lt);
                await this.updateGreaterDate(createTableDto);
            }
        }
        return {
            status: true
        };
    }
    async checkIfExists(createTableDto) {
        let result = await this.stockBalanceTableRepository.findOne({
            where: {
                HousingTable: {
                    housingId: createTableDto.housingId
                },
                BreedTable: {
                    breedId: createTableDto.breedId
                },
                ageGroup: createTableDto.ageGroup,
                dateOfEntry: (0, typeorm_2.Raw)((alias) => `${alias} <= :dateOfEntry`, { dateOfEntry: createTableDto.dateOfEntry })
            },
            order: {
                dateOfEntry: "DESC"
            }
        });
        if (result !== null && result !== undefined) {
            return result;
        }
        else {
            return false;
        }
    }
    async updateGreaterDate(createTableDto) {
        let result = await this.stockBalanceTableRepository.find({
            where: {
                HousingTable: {
                    housingId: createTableDto.housingId
                },
                BreedTable: {
                    breedId: createTableDto.breedId
                },
                ageGroup: createTableDto.ageGroup,
                dateOfEntry: (0, typeorm_2.Raw)((alias) => `${alias} > :dateOfEntry`, { dateOfEntry: createTableDto.dateOfEntry })
            },
            order: {
                dateOfEntry: "ASC"
            }
        });
        if (result !== null && result !== undefined) {
            result.forEach(async (el) => {
                el.opMale = parseFloat(el.opMale.toString()) + createTableDto.qtyMale;
                el.opFemale = parseFloat(el.opFemale.toString()) + createTableDto.qtyFemale;
                el.opTotal = parseFloat(el.opTotal.toString()) + createTableDto.qtyTotal;
                el.opWeight = parseFloat(el.opWeight.toString()) + createTableDto.totalWeight;
                el.crMale = parseFloat(el.crMale.toString()) + createTableDto.qtyMale;
                el.crFemale = parseFloat(el.crFemale.toString()) + createTableDto.qtyFemale;
                el.crTotal = parseFloat(el.crTotal.toString()) + createTableDto.qtyTotal;
                el.crWeight = parseFloat(el.crWeight.toString()) + createTableDto.totalWeight;
                await this.stockBalanceTableRepository.save(el);
            });
            return true;
        }
        else {
            return false;
        }
    }
    async findAll() {
        return await this.stockBalanceTableRepository.find({
            relations: ['HousingTable', 'BreedTable', 'HousingTable.FarmersTable']
        });
    }
    async getByHousingId(housingId) {
        return await this.stockBalanceTableRepository.findOne({
            where: {
                HousingTable: {
                    housingId: housingId
                }
            },
        });
    }
    async getByBreedId(breedId) {
        return await this.stockBalanceTableRepository.findOne({
            where: {
                BreedTable: {
                    breedId: breedId
                }
            },
        });
    }
    async findAllStockBalanceByHousingWithDate(housingId, startingDate, endingDate) {
        let result = await this.stockBalanceTableRepository.createQueryBuilder("r")
            .leftJoinAndMapOne("r.HousingTable", housing_table_entity_1.HousingTable, "ml1", "ml1.housingId=r.housingId")
            .leftJoinAndMapOne("r.BreedTable", breed_table_entity_1.BreedTable, "ml2", "ml2.breedId=r.breedId")
            .where("r.housingId=:housingId", { housingId: housingId })
            .andWhere("STR_TO_DATE(r.dateOfEntry,'%Y-%m-%d') BETWEEN STR_TO_DATE(:startingDate,'%Y-%m-%d') AND STR_TO_DATE(:endingDate,'%Y-%m-%d')", {
            startingDate: startingDate,
            endingDate: endingDate,
        }).getMany();
        return result;
    }
};
StockBalanceTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(stock_balance_table_entity_1.StockBalanceTable)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => farmers_table_service_1.FarmersTableService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => housing_table_service_1.HousingTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => breed_table_service_1.BreedTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        farmers_table_service_1.FarmersTableService,
        housing_table_service_1.HousingTableService,
        breed_table_service_1.BreedTableService])
], StockBalanceTableService);
exports.StockBalanceTableService = StockBalanceTableService;
