/// <reference types="mongoose" />
import { StockCollectionService } from './stock-collection.service';
import { StockCollection } from './entities/stock-collection.entity';
import { CreateStockCollectionInput } from './input/create-stock-collection.input';
import { UpdateStockCollectionInput } from './input/update-stock-collection.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_STOCK_ADD = "NEW_STOCK_ADD";
export declare class StockCollectionResolver {
    private readonly stockCollectionService;
    private pubSub;
    constructor(stockCollectionService: StockCollectionService, pubSub: RedisPubSub);
    createStockCollection(user: any, createStockCollectionInput: CreateStockCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, StockCollection> & StockCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    findAllStock(): Promise<(import("mongoose").Document<unknown, any, StockCollection> & StockCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    updateStockCollection(updateStockCollectionInput: UpdateStockCollectionInput): Promise<any>;
    removeStockCollection(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    stockSubscription(): AsyncIterator<unknown, any, undefined>;
}
