"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockCollectionResolver = exports.NEW_STOCK_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const stock_collection_service_1 = require("./stock-collection.service");
const stock_collection_entity_1 = require("./entities/stock-collection.entity");
const create_stock_collection_input_1 = require("./input/create-stock-collection.input");
const update_stock_collection_input_1 = require("./input/update-stock-collection.input");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const stock_collection_create_type_1 = require("./types/stock-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const stock_collection_type_1 = require("./types/stock-collection.type");
const new_product_category_type_1 = require("../product-category-collection/types/new-product-category.type");
exports.NEW_STOCK_ADD = "NEW_STOCK_ADD";
let StockCollectionResolver = class StockCollectionResolver {
    constructor(stockCollectionService, pubSub) {
        this.stockCollectionService = stockCollectionService;
        this.pubSub = pubSub;
    }
    createStockCollection(user, createStockCollectionInput) {
        return this.stockCollectionService.create(createStockCollectionInput, user.username);
    }
    findAllStock() {
        return this.stockCollectionService.findAll();
    }
    updateStockCollection(updateStockCollectionInput) {
        return this.stockCollectionService.update(updateStockCollectionInput.id, updateStockCollectionInput);
    }
    removeStockCollection(id) {
        return this.stockCollectionService.remove(id);
    }
    stockSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_STOCK_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_collection_create_type_1.StockCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createStockCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_stock_collection_input_1.CreateStockCollectionInput]),
    __metadata("design:returntype", void 0)
], StockCollectionResolver.prototype, "createStockCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_collection_type_1.StockCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StockCollectionResolver.prototype, "findAllStock", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_collection_create_type_1.StockCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateStockCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_stock_collection_input_1.UpdateStockCollectionInput]),
    __metadata("design:returntype", void 0)
], StockCollectionResolver.prototype, "updateStockCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_collection_create_type_1.StockCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], StockCollectionResolver.prototype, "removeStockCollection", null);
__decorate([
    (0, graphql_1.Subscription)(() => new_product_category_type_1.NewCategoryAdd, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StockCollectionResolver.prototype, "stockSubscription", null);
StockCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => stock_collection_entity_1.StockCollection),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [stock_collection_service_1.StockCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], StockCollectionResolver);
exports.StockCollectionResolver = StockCollectionResolver;
