import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Model } from 'mongoose';
import { ProductCollectionService } from 'src/product-collection/product-collection.service';
import { CreateStockCollectionInput } from './input/create-stock-collection.input';
import { UpdateStockCollectionInput } from './input/update-stock-collection.input';
import { StockCollection } from './entities/stock-collection.entity';
import { CurrentStockCollectionService } from 'src/current-stock-collection/current-stock-collection.service';
import { StockRegisterCollectionService } from 'src/stock-register-collection/stock-register-collection.service';
export declare const NEW_STOCK_ADD = "NEW_STOCK_ADD";
export declare class StockCollectionService {
    private stockCollectionRepository;
    private readonly productService;
    private readonly currentStockCollectionService;
    private readonly stockRegisterCollectionService;
    private pubSub;
    constructor(stockCollectionRepository: Model<StockCollection>, productService: ProductCollectionService, currentStockCollectionService: CurrentStockCollectionService, stockRegisterCollectionService: StockRegisterCollectionService, pubSub: RedisPubSub);
    create(createStockCollectionInput: CreateStockCollectionInput, username: any): Promise<{
        status: boolean;
        status_text: string;
        data: import("mongoose").Document<unknown, any, StockCollection> & StockCollection & {
            _id: import("typeorm").ObjectID;
        };
    }>;
    padWithZero(num: number, targetLength: number): string;
    findAll(): Promise<(import("mongoose").Document<unknown, any, StockCollection> & StockCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findOneById(id: string): Promise<import("mongoose").Document<unknown, any, StockCollection> & StockCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateStockCollectionInput: UpdateStockCollectionInput): Promise<any>;
}
