"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockCollectionService = exports.NEW_STOCK_ADD = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const mongoose_2 = require("mongoose");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const product_collection_service_1 = require("../product-collection/product-collection.service");
const stock_collection_entity_1 = require("./entities/stock-collection.entity");
const moment_1 = __importDefault(require("moment"));
const current_stock_collection_service_1 = require("../current-stock-collection/current-stock-collection.service");
const stock_register_collection_service_1 = require("../stock-register-collection/stock-register-collection.service");
exports.NEW_STOCK_ADD = "NEW_STOCK_ADD";
let StockCollectionService = class StockCollectionService {
    constructor(stockCollectionRepository, productService, currentStockCollectionService, stockRegisterCollectionService, pubSub) {
        this.stockCollectionRepository = stockCollectionRepository;
        this.productService = productService;
        this.currentStockCollectionService = currentStockCollectionService;
        this.stockRegisterCollectionService = stockRegisterCollectionService;
        this.pubSub = pubSub;
    }
    async create(createStockCollectionInput, username) {
        let pc = await this.productService.findOneById(createStockCollectionInput.productId);
        let cm = new stock_collection_entity_1.StockCollection();
        cm.qty = createStockCollectionInput.qty;
        cm.basePrice = createStockCollectionInput.basePrice;
        cm.size = createStockCollectionInput.size;
        cm.mrp = createStockCollectionInput.mrp;
        cm.batchNo = createStockCollectionInput.batchNo;
        if (createStockCollectionInput.expiryDate != "") {
            cm.expiryDate = createStockCollectionInput.expiryDate;
        }
        else {
            cm.expiryDate = null;
        }
        if (createStockCollectionInput.mfgDate != "") {
            cm.mfgDate = createStockCollectionInput.mfgDate;
        }
        else {
            cm.mfgDate = null;
        }
        cm.entryDate = (0, moment_1.default)().format('DD-MM-YYYY');
        cm.Product = pc;
        cm.barcode = createStockCollectionInput.barcode;
        let c = await this.stockCollectionRepository.create(cm);
        let cs = await this.currentStockCollectionService.updateCurrentStock(createStockCollectionInput.productId, createStockCollectionInput.size, createStockCollectionInput.qty, createStockCollectionInput.basePrice, createStockCollectionInput.mrp, createStockCollectionInput.barcode, createStockCollectionInput.mfgDate, createStockCollectionInput.expiryDate, createStockCollectionInput.batchNo, 1);
        let data = {
            entryDate: (0, moment_1.default)().format('DD-MM-YYYY'),
            qty: createStockCollectionInput.qty,
            accountType: 'PRODUCT',
            entryType: 'OPENING',
            narration: 'Opening stock entry.',
            receiptNo: c.id,
            currentStockId: cs.id,
            createdBy: username
        };
        let sr = await this.stockRegisterCollectionService.create(data);
        this.pubSub.publish(exports.NEW_STOCK_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully Added',
            data: c
        };
    }
    padWithZero(num, targetLength) {
        return String(num).padStart(targetLength, '0');
    }
    async findAll() {
        let result = await this.stockCollectionRepository.find().populate('Product').exec();
        return result;
    }
    async findOneById(id) {
        return await this.stockCollectionRepository.findOne({ _id: id }).populate('Product').exec();
    }
    async remove(id) {
        let pp = await this.findOneById(id);
        await this.currentStockCollectionService.updateCurrentStock(pp.Product._id.toString(), pp.size, pp.qty, pp.basePrice, pp.mrp, pp.barcode, pp.mfgDate, pp.expiryDate, pp.batchNo, -1);
        await this.stockCollectionRepository.deleteOne({ _id: id });
        this.pubSub.publish(exports.NEW_STOCK_ADD, 1);
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: null
        };
    }
    async update(id, updateStockCollectionInput) {
        console.log("🚀 ~ file: stock-collection.service.ts ~ line 151 ~ StockCollectionService ~ update ~ updateStockCollectionInput", updateStockCollectionInput);
        let cc = await this.stockCollectionRepository.findOne({ _id: id }).populate('Product').exec();
        if (cc) {
            await this.currentStockCollectionService.updateCurrentStock(cc.Product._id.toString(), cc.size, cc.qty, cc.basePrice, cc.mrp, cc.barcode, cc.mfgDate, cc.expiryDate, cc.batchNo, -1);
            let pc = await this.productService.findOneById(updateStockCollectionInput.productId);
            cc.Product = pc;
            cc.basePrice = updateStockCollectionInput.basePrice;
            cc.qty = updateStockCollectionInput.qty;
            cc.size = updateStockCollectionInput.size;
            cc.mrp = updateStockCollectionInput.mrp;
            cc.batchNo = updateStockCollectionInput.batchNo;
            cc.expiryDate = updateStockCollectionInput.expiryDate;
            cc.mfgDate = updateStockCollectionInput.mfgDate;
            let cc1 = await this.stockCollectionRepository.updateOne({ _id: id }, cc);
            this.pubSub.publish(exports.NEW_STOCK_ADD, 1);
            await this.currentStockCollectionService.updateCurrentStock(updateStockCollectionInput.productId, updateStockCollectionInput.size, updateStockCollectionInput.qty, updateStockCollectionInput.basePrice, updateStockCollectionInput.mrp, updateStockCollectionInput.barcode, updateStockCollectionInput.mfgDate, updateStockCollectionInput.expiryDate, updateStockCollectionInput.batchNo, 1);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
StockCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(stock_collection_entity_1.StockCollection.name)),
    __param(4, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_collection_service_1.ProductCollectionService,
        current_stock_collection_service_1.CurrentStockCollectionService,
        stock_register_collection_service_1.StockRegisterCollectionService,
        graphql_redis_subscriptions_1.RedisPubSub])
], StockCollectionService);
exports.StockCollectionService = StockCollectionService;
