"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockEntryTable = exports.StockEntryType = void 0;
const breed_table_entity_1 = require("../../breed-table/entities/breed-table.entity");
const disease_table_entity_1 = require("../../disease-table/entities/disease-table.entity");
const housing_table_entity_1 = require("../../housing-table/entities/housing-table.entity");
const user_collection_entity_1 = require("../../user-collection/entities/user-collection.entity");
const typeorm_1 = require("typeorm");
var StockEntryType;
(function (StockEntryType) {
    StockEntryType["BIRTH"] = "BIRTH";
    StockEntryType["PURCHASE"] = "PURCHASE";
    StockEntryType["OPENING"] = "OPENING";
    StockEntryType["DECEASE"] = "DECEASE";
})(StockEntryType = exports.StockEntryType || (exports.StockEntryType = {}));
let StockEntryTable = class StockEntryTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], StockEntryTable.prototype, "stockEntryId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => housing_table_entity_1.HousingTable, et => et.StockEntryTable),
    (0, typeorm_1.JoinColumn)({ name: "housingId" }),
    __metadata("design:type", housing_table_entity_1.HousingTable)
], StockEntryTable.prototype, "HousingTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String }),
    __metadata("design:type", String)
], StockEntryTable.prototype, "dateOfEntry", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: StockEntryType,
        nullable: true
    }),
    __metadata("design:type", String)
], StockEntryTable.prototype, "entryType", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => breed_table_entity_1.BreedTable, et => et.StockEntryTable),
    (0, typeorm_1.JoinColumn)({ name: "breedId" }),
    __metadata("design:type", breed_table_entity_1.BreedTable)
], StockEntryTable.prototype, "BreedTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: String }),
    __metadata("design:type", String)
], StockEntryTable.prototype, "ageGroup", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: 0 }),
    __metadata("design:type", Number)
], StockEntryTable.prototype, "qtyMale", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: 0 }),
    __metadata("design:type", Number)
], StockEntryTable.prototype, "qtyFemale", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: 0 }),
    __metadata("design:type", Number)
], StockEntryTable.prototype, "qtyTotal", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "decimal", precision: 10, scale: 3, default: 0.000 }),
    __metadata("design:type", Number)
], StockEntryTable.prototype, "avgWeight", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "text", nullable: true }),
    __metadata("design:type", String)
], StockEntryTable.prototype, "remarks", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => disease_table_entity_1.DiseaseTable, et => et.StockEntryTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "diseaseId" }),
    __metadata("design:type", disease_table_entity_1.DiseaseTable)
], StockEntryTable.prototype, "DiseaseTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => user_collection_entity_1.UserTable, et => et.StockEntryTable, { nullable: true }),
    (0, typeorm_1.JoinColumn)({ name: "userId" }),
    __metadata("design:type", user_collection_entity_1.UserTable)
], StockEntryTable.prototype, "UserTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], StockEntryTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], StockEntryTable.prototype, "updatedAt", void 0);
StockEntryTable = __decorate([
    (0, typeorm_1.Entity)()
], StockEntryTable);
exports.StockEntryTable = StockEntryTable;
