import { StockEntryTableService } from './stock-entry-table.service';
import { StockEntryTable } from './entities/stock-entry-table.entity';
import { CreateStockEntryTableInput } from './dto/create-stock-entry-table.input';
import { CreateDeceaseEntryInput } from './dto/create-decease-entry.input';
export declare class StockEntryTableResolver {
    private readonly stockEntryTableService;
    constructor(stockEntryTableService: StockEntryTableService);
    createStockEntryTable(createStockEntryTableInput: CreateStockEntryTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: StockEntryTable;
    }>;
    findAllStockEntry(): Promise<StockEntryTable[]>;
    findStockEntryByHousingId(housingId: number): Promise<StockEntryTable[]>;
    findStockEntryById(stockEntryId: number): Promise<StockEntryTable>;
    deceaseEntry(createDeceaseEntryInput: CreateDeceaseEntryInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findMortalityRate(farmerId?: number): Promise<{
        status: boolean;
        data: string;
    }>;
    findMortalityRateWithDisease(farmerId?: number): Promise<{
        data: any[];
    }>;
}
