"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockEntryTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const stock_entry_table_service_1 = require("./stock-entry-table.service");
const stock_entry_table_entity_1 = require("./entities/stock-entry-table.entity");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const stock_entry_table_return_type_1 = require("./types/stock-entry-table-return.type");
const create_stock_entry_table_input_1 = require("./dto/create-stock-entry-table.input");
const stock_entry_table_type_1 = require("./types/stock-entry-table.type");
const create_decease_entry_input_1 = require("./dto/create-decease-entry.input");
const mortality_rate_return_type_1 = require("./types/mortality-rate-return.type");
const mortality_rate_with_diseae_return_type_1 = require("./types/mortality-rate-with-diseae-return-type");
let StockEntryTableResolver = class StockEntryTableResolver {
    constructor(stockEntryTableService) {
        this.stockEntryTableService = stockEntryTableService;
    }
    createStockEntryTable(createStockEntryTableInput, user) {
        return this.stockEntryTableService.create(createStockEntryTableInput, user);
    }
    findAllStockEntry() {
        return this.stockEntryTableService.findAll();
    }
    findStockEntryByHousingId(housingId) {
        return this.stockEntryTableService.findByHousingId(housingId);
    }
    findStockEntryById(stockEntryId) {
        return this.stockEntryTableService.findOne(stockEntryId);
    }
    deceaseEntry(createDeceaseEntryInput, user) {
        return this.stockEntryTableService.deceaseEntry(createDeceaseEntryInput, user);
    }
    findMortalityRate(farmerId) {
        return this.stockEntryTableService.findMortalityRate(farmerId);
    }
    findMortalityRateWithDisease(farmerId) {
        return this.stockEntryTableService.findMortalityRateWithDisease(farmerId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_entry_table_return_type_1.StockEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createStockEntryTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_stock_entry_table_input_1.CreateStockEntryTableInput, Object]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "createStockEntryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_entry_table_type_1.StockEntryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "findAllStockEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_entry_table_type_1.StockEntryTableType]),
    __param(0, (0, graphql_1.Args)('housingId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "findStockEntryByHousingId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => stock_entry_table_type_1.StockEntryTableType),
    __param(0, (0, graphql_1.Args)('stockEntryId', { type: () => Number })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "findStockEntryById", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => stock_entry_table_return_type_1.StockEntryTableReturnType),
    __param(0, (0, graphql_1.Args)('createDeceaseEntryInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_decease_entry_input_1.CreateDeceaseEntryInput, Object]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "deceaseEntry", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mortality_rate_return_type_1.MortalityRateReturnType),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => Number, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "findMortalityRate", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => mortality_rate_with_diseae_return_type_1.MortalityRateWithDiseaseReturnType),
    __param(0, (0, graphql_1.Args)('farmerId', { type: () => Number, nullable: true })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], StockEntryTableResolver.prototype, "findMortalityRateWithDisease", null);
StockEntryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => stock_entry_table_entity_1.StockEntryTable),
    __metadata("design:paramtypes", [stock_entry_table_service_1.StockEntryTableService])
], StockEntryTableResolver);
exports.StockEntryTableResolver = StockEntryTableResolver;
