import { UserCollectionService } from "src/user-collection/user-collection.service";
import { Repository } from "typeorm";
import { StockEntryTable } from "./entities/stock-entry-table.entity";
import { HousingTableService } from "src/housing-table/housing-table.service";
import { CreateStockEntryTableInput } from "./dto/create-stock-entry-table.input";
import { BreedTableService } from "src/breed-table/breed-table.service";
import { CurrentStockTableService } from "src/current-stock/current-stock-table.service";
import { StockBalanceTableService } from "src/stock-balance/stock-balance-table.service";
import { LedgerEntryTableService } from "src/ledger-table/ledger-entry-table.service";
import { AnimalEntryTableService } from "src/animal-table/animal-entry-table.service";
import { CreateDeceaseEntryInput } from "./dto/create-decease-entry.input";
import { DiseaseTableService } from "src/disease-table/disease-table.service";
import { DataEntryTableService } from 'src/data-entry-table/data-entry-table.service';
export declare class StockEntryTableService {
    private readonly stockEntryTableRepository;
    private readonly dataEntryTableService;
    private readonly userCollectionService;
    private readonly housingTableService;
    private readonly breedTableService;
    private readonly currentStockTableService;
    private readonly stockBalanceTableService;
    private readonly ledgerEntryTableService;
    private readonly animalEntryTableService;
    private readonly diseaseTableService;
    constructor(stockEntryTableRepository: Repository<StockEntryTable>, dataEntryTableService: DataEntryTableService, userCollectionService: UserCollectionService, housingTableService: HousingTableService, breedTableService: BreedTableService, currentStockTableService: CurrentStockTableService, stockBalanceTableService: StockBalanceTableService, ledgerEntryTableService: LedgerEntryTableService, animalEntryTableService: AnimalEntryTableService, diseaseTableService: DiseaseTableService);
    create(createStockEntryTableInput: CreateStockEntryTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: StockEntryTable;
    }>;
    deceaseEntry(createDeceaseEntryInput: CreateDeceaseEntryInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    findByHousingId(housingId: number): Promise<StockEntryTable[]>;
    findAll(): Promise<StockEntryTable[]>;
    findOne(stockEntryId: number): Promise<StockEntryTable>;
    findMortalityRate(farmerId?: number): Promise<{
        status: boolean;
        data: string;
    }>;
    findMortalityRateWithDisease(farmerId?: number): Promise<{
        data: any[];
    }>;
}
