import { Model } from 'mongoose';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { StockRegisterCollection } from './entities/stock-register-collection.entity';
import { CurrentStockCollectionService } from 'src/current-stock-collection/current-stock-collection.service';
import { CreateStockRegisterCollectionInput } from './dto/create-stock-register-collection.input';
import { CurrentStockCollection } from 'src/current-stock-collection/entities/current-stock-collection.entity';
export declare class StockRegisterCollectionService {
    private stockRegisterCollectionRepository;
    private currentStockService;
    private userCollectionService;
    constructor(stockRegisterCollectionRepository: Model<StockRegisterCollection>, currentStockService: CurrentStockCollectionService, userCollectionService: UserCollectionService);
    checkIfExists(currentStock: CurrentStockCollection, accountType: string, entryType: string, receiptNo: string): Promise<import("mongoose").Document<unknown, any, StockRegisterCollection> & StockRegisterCollection & {
        _id: import("typeorm").ObjectID;
    }>;
    create(data: CreateStockRegisterCollectionInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    findAll(): Promise<(import("mongoose").Document<unknown, any, StockRegisterCollection> & StockRegisterCollection & {
        _id: import("typeorm").ObjectID;
    })[]>;
    findOneById(id: string): Promise<import("mongoose").Document<unknown, any, StockRegisterCollection> & StockRegisterCollection & {
        _id: import("typeorm").ObjectID;
    }>;
}
