"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockRegisterCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const stock_register_collection_entity_1 = require("./entities/stock-register-collection.entity");
const current_stock_collection_service_1 = require("../current-stock-collection/current-stock-collection.service");
let StockRegisterCollectionService = class StockRegisterCollectionService {
    constructor(stockRegisterCollectionRepository, currentStockService, userCollectionService) {
        this.stockRegisterCollectionRepository = stockRegisterCollectionRepository;
        this.currentStockService = currentStockService;
        this.userCollectionService = userCollectionService;
    }
    async checkIfExists(currentStock, accountType, entryType, receiptNo) {
        let result = await this.stockRegisterCollectionRepository
            .findOne({
            CurrentStock: currentStock,
            accountType: accountType,
            entryType: entryType,
            receiptNo: receiptNo,
        })
            .exec();
        return result;
    }
    async create(data) {
        let cs = await this.currentStockService.findOneById(data.currentStockId);
        let result = await this.checkIfExists(cs, data.accountType, data.entryType, data.receiptNo);
        if (result == null) {
            let sr = new stock_register_collection_entity_1.StockRegisterCollection();
            sr.CurrentStock = cs;
            sr.qty = data.qty;
            sr.accountType = data.accountType;
            sr.entryType = data.entryType;
            sr.entryDate = data.entryDate;
            sr.narration = data.narration;
            sr.receiptNo = data.receiptNo;
            sr.createdBy = data.createdBy;
            await this.stockRegisterCollectionRepository.create(sr);
            return {
                status: true,
                status_text: 'Success'
            };
        }
        else {
            return {
                status: false,
                status_text: 'Failed'
            };
        }
    }
    async findAll() {
        let result = await this.stockRegisterCollectionRepository
            .find()
            .populate('CurrentStock')
            .exec();
        return result;
    }
    async findOneById(id) {
        return await this.stockRegisterCollectionRepository
            .findOne({ _id: id })
            .populate('CurrentStock')
            .exec();
    }
};
StockRegisterCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(stock_register_collection_entity_1.StockRegisterCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => current_stock_collection_service_1.CurrentStockCollectionService))),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [mongoose_2.Model,
        current_stock_collection_service_1.CurrentStockCollectionService,
        user_collection_service_1.UserCollectionService])
], StockRegisterCollectionService);
exports.StockRegisterCollectionService = StockRegisterCollectionService;
