"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StockRegisterCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const stock_register_collection_entity_1 = require("./entities/stock-register-collection.entity");
const stock_register_collection_service_1 = require("./stock-register-collection.service");
const stock_register_collection_type_1 = require("./types/stock-register-collection.type");
let StockRegisterCollectionResolver = class StockRegisterCollectionResolver {
    constructor(stockRegisterCollectionService) {
        this.stockRegisterCollectionService = stockRegisterCollectionService;
    }
    findAllStockRegister() {
        return this.stockRegisterCollectionService.findAll();
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [stock_register_collection_type_1.StockRegisterCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], StockRegisterCollectionResolver.prototype, "findAllStockRegister", null);
StockRegisterCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => stock_register_collection_entity_1.StockRegisterCollection),
    __metadata("design:paramtypes", [stock_register_collection_service_1.StockRegisterCollectionService])
], StockRegisterCollectionResolver);
exports.StockRegisterCollectionResolver = StockRegisterCollectionResolver;
