import { SubDivisionTableService } from './sub-division-table.service';
import { SubDivisionTable } from './entities/sub-division-table.entity';
import { CreateSubDivisionTableInput } from './dto/create-sub-division-table.input';
import { UpdateSubDivisionTableInput } from './dto/update-sub-division-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SUBDIVISION_ADD = "NEW_SUBDIVISION_ADD";
export declare class SubDivisionTableResolver {
    private readonly subDivisionTableService;
    private pubSub;
    constructor(subDivisionTableService: SubDivisionTableService, pubSub: RedisPubSub);
    createSubDivisionTable(CreateSubDivisionTableInput: CreateSubDivisionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SubDivisionTable;
    }>;
    findAllSubDivision(): Promise<SubDivisionTable[]>;
    findOneSubDivision(subDivisionId: number): Promise<SubDivisionTable>;
    updateSubDivisionTable(UpdateSubDivisionTableInput: UpdateSubDivisionTableInput): Promise<void>;
    removeSubDivisionTable(subDivisionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    subDivisionSubscription(): AsyncIterator<unknown, any, undefined>;
}
