"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubDivisionTableResolver = exports.NEW_SUBDIVISION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const sub_division_table_service_1 = require("./sub-division-table.service");
const sub_division_table_entity_1 = require("./entities/sub-division-table.entity");
const create_sub_division_table_input_1 = require("./dto/create-sub-division-table.input");
const update_sub_division_table_input_1 = require("./dto/update-sub-division-table.input");
const sub_division_table_type_1 = require("./types/sub-division-table.type");
const sub_division_table_return_type_1 = require("./types/sub-division-table-return.type");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const count_changed_type_1 = require("./types/count-changed.type");
exports.NEW_SUBDIVISION_ADD = "NEW_SUBDIVISION_ADD";
let SubDivisionTableResolver = exports.SubDivisionTableResolver = class SubDivisionTableResolver {
    constructor(subDivisionTableService, pubSub) {
        this.subDivisionTableService = subDivisionTableService;
        this.pubSub = pubSub;
    }
    createSubDivisionTable(CreateSubDivisionTableInput) {
        return this.subDivisionTableService.create(CreateSubDivisionTableInput);
    }
    findAllSubDivision() {
        return this.subDivisionTableService.findAll();
    }
    findOneSubDivision(subDivisionId) {
        return this.subDivisionTableService.findOne(subDivisionId);
    }
    updateSubDivisionTable(UpdateSubDivisionTableInput) {
        return this.subDivisionTableService.update(UpdateSubDivisionTableInput.subDivisionId, UpdateSubDivisionTableInput);
    }
    removeSubDivisionTable(subDivisionId) {
        return this.subDivisionTableService.remove(subDivisionId);
    }
    subDivisionSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_SUBDIVISION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sub_division_table_return_type_1.SubDivisionTableReturnType),
    __param(0, (0, graphql_1.Args)('createSubDivisionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_sub_division_table_input_1.CreateSubDivisionTableInput]),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "createSubDivisionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [sub_division_table_type_1.SubDivisionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "findAllSubDivision", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => sub_division_table_type_1.SubDivisionTableType),
    __param(0, (0, graphql_1.Args)('subDivisionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "findOneSubDivision", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sub_division_table_return_type_1.SubDivisionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSubDivisionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_sub_division_table_input_1.UpdateSubDivisionTableInput]),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "updateSubDivisionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => sub_division_table_return_type_1.SubDivisionTableReturnType),
    __param(0, (0, graphql_1.Args)('subDivisionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "removeSubDivisionTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.countChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SubDivisionTableResolver.prototype, "subDivisionSubscription", null);
exports.SubDivisionTableResolver = SubDivisionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => sub_division_table_entity_1.SubDivisionTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [sub_division_table_service_1.SubDivisionTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SubDivisionTableResolver);
