import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateSubDivisionTableInput } from './dto/create-sub-division-table.input';
import { UpdateSubDivisionTableInput } from './dto/update-sub-division-table.input';
import { SubDivisionTable } from './entities/sub-division-table.entity';
export declare const NEW_SUBDIVISION_ADD = "NEW_SUBDIVISION_ADD";
export declare class SubDivisionTableService {
    private readonly subDivisionTableRepository;
    private pubSub;
    constructor(subDivisionTableRepository: Repository<SubDivisionTable>, pubSub: RedisPubSub);
    create(CreateSubDivisionTableInput: CreateSubDivisionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SubDivisionTable;
    }>;
    checkIfExists(subDivisionName: string): Promise<boolean>;
    findAll(): Promise<SubDivisionTable[]>;
    findOne(subDivisionId: number): Promise<SubDivisionTable>;
    fetchSubDivisionByDistrictId(districtId: number): Promise<SubDivisionTable[]>;
    update(subDivisionId: number, UpdateSubDivisionTableInput: UpdateSubDivisionTableInput): Promise<void>;
    remove(subDivisionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
