"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubDivisionTableService = exports.NEW_SUBDIVISION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const sub_division_table_entity_1 = require("./entities/sub-division-table.entity");
exports.NEW_SUBDIVISION_ADD = "NEW_SUBDIVISION_ADD";
let SubDivisionTableService = exports.SubDivisionTableService = class SubDivisionTableService {
    constructor(subDivisionTableRepository, pubSub) {
        this.subDivisionTableRepository = subDivisionTableRepository;
        this.pubSub = pubSub;
    }
    async create(CreateSubDivisionTableInput) {
        let checkIfExists = await this.checkIfExists(CreateSubDivisionTableInput.subDivisionName);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new sub_division_table_entity_1.SubDivisionTable();
            dd.subDivisionName = CreateSubDivisionTableInput.subDivisionName;
            let result = await this.subDivisionTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_SUBDIVISION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(subDivisionName) {
        let result = await this.subDivisionTableRepository.count({
            where: {
                subDivisionName: subDivisionName
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.subDivisionTableRepository.find({
            relations: ["DistrictTable"]
        });
    }
    async findOne(subDivisionId) {
        return await this.subDivisionTableRepository.findOne({
            where: {
                subDivisionId: subDivisionId
            },
            relations: ["DistrictTable"]
        });
    }
    async fetchSubDivisionByDistrictId(districtId) {
        let result = await this.subDivisionTableRepository.find({
            where: {}
        });
        console.log('', result);
        return result;
    }
    async update(subDivisionId, UpdateSubDivisionTableInput) {
        let result = await this.subDivisionTableRepository.findOne({
            where: {
                subDivisionId: subDivisionId
            }
        });
    }
    async remove(subDivisionId) {
        let result = await this.subDivisionTableRepository.findOne({
            where: {
                subDivisionId: subDivisionId
            }
        });
        if (result) {
            await this.subDivisionTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SUBDIVISION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.SubDivisionTableService = SubDivisionTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(sub_division_table_entity_1.SubDivisionTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], SubDivisionTableService);
