import { SubscriptionTableService } from './subscription-table.service';
import { SubscriptionTable } from './entities/subscription-table.entity';
import { CreateSubscriptionTableInput } from './dto/create-subscription-table.input';
import { UpdateSubscriptionTableInput } from './dto/update-subscription-table.input';
export declare class SubscriptionTableResolver {
    private readonly subscriptionTableService;
    constructor(subscriptionTableService: SubscriptionTableService);
    createSubscriptionTable(createSubscriptionTableInput: CreateSubscriptionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSubscriptions(): Promise<SubscriptionTable[]>;
    toggleStatusofSubscription(subscriptionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSubscriptionsByCourseId(courseId: number): Promise<SubscriptionTable[]>;
    findOneSubscription(subscriptionId: number): Promise<any>;
    enrollMyself(courseId: number, courseSessionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    }>;
    markAsComplete(courseId: number, courseSessionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateSubscriptionTable(updateSubscriptionTableInput: UpdateSubscriptionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeSubscriptionTable(subscriptionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
