"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const subscription_table_service_1 = require("./subscription-table.service");
const subscription_table_entity_1 = require("./entities/subscription-table.entity");
const create_subscription_table_input_1 = require("./dto/create-subscription-table.input");
const update_subscription_table_input_1 = require("./dto/update-subscription-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const subscription_table_return_type_1 = require("./types/subscription-table-return.type");
const subscription_table_type_1 = require("./types/subscription-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
let SubscriptionTableResolver = exports.SubscriptionTableResolver = class SubscriptionTableResolver {
    constructor(subscriptionTableService) {
        this.subscriptionTableService = subscriptionTableService;
    }
    createSubscriptionTable(createSubscriptionTableInput) {
        return this.subscriptionTableService.create(createSubscriptionTableInput);
    }
    findAllSubscriptions() {
        return this.subscriptionTableService.findAll();
    }
    toggleStatusofSubscription(subscriptionId) {
        return this.subscriptionTableService.toggleStatusofSubscription(subscriptionId);
    }
    findAllSubscriptionsByCourseId(courseId) {
        return this.subscriptionTableService.findAllSubscriptionsByCourseId(courseId);
    }
    findOneSubscription(subscriptionId) {
        return this.subscriptionTableService.findOne(subscriptionId);
    }
    enrollMyself(courseId, courseSessionId, user) {
        return this.subscriptionTableService.enrollMyself(courseId, courseSessionId, user);
    }
    markAsComplete(courseId, courseSessionId, user) {
        return this.subscriptionTableService.markAsComplete(courseId, courseSessionId, user);
    }
    updateSubscriptionTable(updateSubscriptionTableInput) {
        return this.subscriptionTableService.update(updateSubscriptionTableInput.subscriptionId, updateSubscriptionTableInput);
    }
    removeSubscriptionTable(subscriptionId) {
        return this.subscriptionTableService.remove(subscriptionId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('createSubscriptionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_subscription_table_input_1.CreateSubscriptionTableInput]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "createSubscriptionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [subscription_table_type_1.SubscriptionTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "findAllSubscriptions", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('subscriptionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "toggleStatusofSubscription", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [subscription_table_type_1.SubscriptionTableType]),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "findAllSubscriptionsByCourseId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => subscription_table_type_1.SubscriptionTableType),
    __param(0, (0, graphql_1.Args)('subscriptionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "findOneSubscription", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('courseSessionId', { type: () => graphql_1.Int })),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "enrollMyself", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('courseId', { type: () => graphql_1.Int })),
    __param(1, (0, graphql_1.Args)('courseSessionId', { type: () => graphql_1.Int })),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, Object]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "markAsComplete", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSubscriptionTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_subscription_table_input_1.UpdateSubscriptionTableInput]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "updateSubscriptionTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => subscription_table_return_type_1.SubscriptionTableReturnType),
    __param(0, (0, graphql_1.Args)('subscriptionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SubscriptionTableResolver.prototype, "removeSubscriptionTable", null);
exports.SubscriptionTableResolver = SubscriptionTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => subscription_table_entity_1.SubscriptionTable),
    __metadata("design:paramtypes", [subscription_table_service_1.SubscriptionTableService])
], SubscriptionTableResolver);
