import { CreateSubscriptionTableInput } from './dto/create-subscription-table.input';
import { UpdateSubscriptionTableInput } from './dto/update-subscription-table.input';
import { SubscriptionTable } from './entities/subscription-table.entity';
import { Repository } from 'typeorm';
import { CourseTableService } from 'src/course-table/course-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CourseSessionTableService } from 'src/course-session-table/course-session-table.service';
export declare class SubscriptionTableService {
    private readonly subscriptionTableRepository;
    private readonly courseTableService;
    private readonly courseSessionTableService;
    private readonly userCollectionService;
    constructor(subscriptionTableRepository: Repository<SubscriptionTable>, courseTableService: CourseTableService, courseSessionTableService: CourseSessionTableService, userCollectionService: UserCollectionService);
    create(createSubscriptionTableInput: CreateSubscriptionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createSubscriptionTableInput: CreateSubscriptionTableInput): Promise<number>;
    findAll(): Promise<SubscriptionTable[]>;
    findAllSubscriptionsByCourseId(courseId: number): Promise<SubscriptionTable[]>;
    findOne(subscriptionId: number): Promise<any>;
    enrollMyself(courseId: number, courseSessionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    }>;
    markAsComplete(courseId: number, courseSessionId: number, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfAllowed(courseId: number, userId: number): Promise<boolean>;
    divideDateRangeIntoWeeks(startDate: string, endDate: string): any[];
    getCurrentWeekNumber(startDate: string, endDate: string): number;
    getDetails(courseId: number, userId: number): Promise<any>;
    update(subscriptionId: number, updateSubscriptionTableInput: UpdateSubscriptionTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(subscriptionId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleStatusofSubscription(subscriptionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: SubscriptionTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
