"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyAnswersTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const survey_answers_table_service_1 = require("./survey-answers-table.service");
const survey_answers_table_entity_1 = require("./entities/survey-answers-table.entity");
const create_survey_answers_table_input_1 = require("./dto/create-survey-answers-table.input");
const survey_answers_table_return_type_1 = require("./types/survey-answers-table-return.type");
const role_enum_1 = require("../user-collection/roles/role.enum");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const survey_answers_table_type_1 = require("./types/survey-answers-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const survey_answers_table_pagination_type_1 = require("./types/survey-answers-table-pagination.type");
let SurveyAnswersTableResolver = exports.SurveyAnswersTableResolver = class SurveyAnswersTableResolver {
    constructor(surveyAnswersTableService) {
        this.surveyAnswersTableService = surveyAnswersTableService;
    }
    createSurveyAnswersTable(createSurveyAnswersTableInput, user) {
        return this.surveyAnswersTableService.create(createSurveyAnswersTableInput, user);
    }
    findOneAnswerById(answerId) {
        return this.surveyAnswersTableService.findOne(answerId);
    }
    getListOfAnswersByUser(limit, page, type, search, user) {
        return this.surveyAnswersTableService.getListOfAnswersByUser(limit, page, type, search, user);
    }
    recalculateScoreForShgAndVo(answerId) {
        return this.surveyAnswersTableService.recalculateScore(answerId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_answers_table_return_type_1.SurveyAnswersTableReturnType),
    __param(0, (0, graphql_1.Args)('createSurveyAnswersTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_survey_answers_table_input_1.CreateSurveyAnswersTableInput, Object]),
    __metadata("design:returntype", void 0)
], SurveyAnswersTableResolver.prototype, "createSurveyAnswersTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_answers_table_type_1.SurveyAnswersTableType),
    __param(0, (0, graphql_1.Args)('answerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyAnswersTableResolver.prototype, "findOneAnswerById", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_answers_table_pagination_type_1.SurveyAnswersTablePaginationType),
    __param(0, (0, graphql_1.Args)('limit')),
    __param(1, (0, graphql_1.Args)('page')),
    __param(2, (0, graphql_1.Args)('type')),
    __param(3, (0, graphql_1.Args)('search')),
    __param(4, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, String, Object]),
    __metadata("design:returntype", void 0)
], SurveyAnswersTableResolver.prototype, "getListOfAnswersByUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_answers_table_type_1.SurveyAnswersTableType),
    __param(0, (0, graphql_1.Args)('answerId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyAnswersTableResolver.prototype, "recalculateScoreForShgAndVo", null);
exports.SurveyAnswersTableResolver = SurveyAnswersTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => survey_answers_table_entity_1.SurveyAnswersTable),
    __metadata("design:paramtypes", [survey_answers_table_service_1.SurveyAnswersTableService])
], SurveyAnswersTableResolver);
