import { CreateSurveyAnswersTableInput } from './dto/create-survey-answers-table.input';
import { SurveyAnswersTable } from './entities/survey-answers-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { ShgTableService } from 'src/shg-table/shg-table.service';
import { VoTableService } from 'src/vo-table/vo-table.service';
import { SurveyInterpretationTableService } from 'src/survey-interpretation-table/survey-interpretation-table.service';
import { SurveyMasterTableService } from 'src/survey-master-table/survey-master-table.service';
import { SurveyQuestionsTableService } from 'src/survey-questions-table/survey-questions-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare const NEW_ANSWER_ADD = "NEW_ANSWER_ADD";
export declare class SurveyAnswersTableService {
    private readonly surveyAnswersTableRepository;
    private pubSub;
    private readonly sessionMasterTableService;
    private readonly surveyMasterTableService;
    private readonly shgTableService;
    private readonly userCollectionService;
    private readonly voTableService;
    private readonly surveyQuestionsTableService;
    private readonly surveyInterpretationTableService;
    constructor(surveyAnswersTableRepository: Repository<SurveyAnswersTable>, pubSub: RedisPubSub, sessionMasterTableService: SessionmasterTableService, surveyMasterTableService: SurveyMasterTableService, shgTableService: ShgTableService, userCollectionService: UserCollectionService, voTableService: VoTableService, surveyQuestionsTableService: SurveyQuestionsTableService, surveyInterpretationTableService: SurveyInterpretationTableService);
    create(createSurveyAnswersTableInput: CreateSurveyAnswersTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyAnswersTable;
    }>;
    convertedArray(array: any[]): {}[];
    recalculateScore(answerId: number): Promise<false | SurveyAnswersTable>;
    checkIfExists(sessionId: number, voId?: number, shgId?: number): Promise<boolean>;
    findAll(): Promise<SurveyAnswersTable[]>;
    findOne(answerId: number): Promise<SurveyAnswersTable>;
    getListOfAnswersByUser(limit: number, page: number, type: string, search: string, user: any): Promise<{
        data: any;
        total: any;
    }>;
    remove(answerId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
