"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyAnswersTableService = exports.NEW_ANSWER_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const survey_answers_table_entity_1 = require("./entities/survey-answers-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const shg_table_service_1 = require("../shg-table/shg-table.service");
const vo_table_service_1 = require("../vo-table/vo-table.service");
const survey_interpretation_table_service_1 = require("../survey-interpretation-table/survey-interpretation-table.service");
const survey_master_table_service_1 = require("../survey-master-table/survey-master-table.service");
const survey_questions_table_service_1 = require("../survey-questions-table/survey-questions-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
const shg_table_entity_1 = require("../shg-table/entities/shg-table.entity");
const user_collection_entity_1 = require("../user-collection/entities/user-collection.entity");
const vo_table_entity_1 = require("../vo-table/entities/vo-table.entity");
const survey_interpretation_table_entity_1 = require("../survey-interpretation-table/entities/survey-interpretation-table.entity");
const survey_master_table_entity_1 = require("../survey-master-table/entities/survey-master-table.entity");
const sessionmaster_table_entity_1 = require("../sessionmaster-table/entities/sessionmaster-table.entity");
exports.NEW_ANSWER_ADD = "NEW_ANSWER_ADD";
let SurveyAnswersTableService = exports.SurveyAnswersTableService = class SurveyAnswersTableService {
    constructor(surveyAnswersTableRepository, pubSub, sessionMasterTableService, surveyMasterTableService, shgTableService, userCollectionService, voTableService, surveyQuestionsTableService, surveyInterpretationTableService) {
        this.surveyAnswersTableRepository = surveyAnswersTableRepository;
        this.pubSub = pubSub;
        this.sessionMasterTableService = sessionMasterTableService;
        this.surveyMasterTableService = surveyMasterTableService;
        this.shgTableService = shgTableService;
        this.userCollectionService = userCollectionService;
        this.voTableService = voTableService;
        this.surveyQuestionsTableService = surveyQuestionsTableService;
        this.surveyInterpretationTableService = surveyInterpretationTableService;
    }
    async create(createSurveyAnswersTableInput, user) {
        let session = await this.sessionMasterTableService.findActiveSession();
        let checkIfExists = await this.checkIfExists(session.sessionId, createSurveyAnswersTableInput.voId, createSurveyAnswersTableInput.shgId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new survey_answers_table_entity_1.SurveyAnswersTable();
            let surveyMaster = await this.surveyMasterTableService.findOne(createSurveyAnswersTableInput.surveyMasterId);
            dd.type = surveyMaster.type;
            dd.SurveyMasterTable = surveyMaster;
            dd.answers = JSON.parse(createSurveyAnswersTableInput.answers);
            let today = (0, moment_1.default)().format("DD-MM-YYYY");
            let thisYear = (0, moment_1.default)().format("YYYY");
            dd.entryDate = today;
            dd.year = thisYear;
            if (createSurveyAnswersTableInput.voId) {
                let vo = await this.voTableService.findOne(createSurveyAnswersTableInput.voId);
                dd.VoTable = vo;
            }
            if (createSurveyAnswersTableInput.shgId) {
                let shg = await this.shgTableService.findOne(createSurveyAnswersTableInput.shgId);
                dd.ShgTable = shg;
            }
            dd.SessionmasterTable = session;
            let questions = await this.surveyQuestionsTableService.findOneBySurveyMasterId(createSurveyAnswersTableInput.surveyMasterId);
            let score = 0;
            for (const el of JSON.parse(createSurveyAnswersTableInput.answers)) {
                let selectedQuestion = questions.find(el1 => el1.surveyQuestionId === el.surveyQuestionId);
                if (selectedQuestion) {
                    let selectedAnswers = selectedQuestion.options;
                    let selectedOption = selectedAnswers.find(el3 => el3.optionLabel === el.value);
                    if (selectedOption) {
                        score = score + parseFloat(selectedOption.optionValue);
                    }
                }
            }
            dd.score = score.toFixed(0);
            let interpretation = await this.surveyInterpretationTableService.findInterpretationByScore(createSurveyAnswersTableInput.surveyMasterId, score.toFixed(0));
            if (interpretation) {
                dd.SurveyInterpretationTable = interpretation;
            }
            let userData = await this.userCollectionService.findOneByUsername(user.username);
            dd.UserTable = userData;
            let result = await this.surveyAnswersTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_ANSWER_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    convertedArray(array) {
        return array.map(innerArray => {
            const obj = {};
            innerArray.forEach(([key, value]) => {
                obj[key] = value;
            });
            return obj;
        });
    }
    async recalculateScore(answerId) {
        let dd = await this.surveyAnswersTableRepository.findOne({
            where: {
                answerId
            },
            relations: {
                SurveyMasterTable: true
            }
        });
        if (dd) {
            let questions = await this.surveyQuestionsTableService.findOneBySurveyMasterId(dd.SurveyMasterTable.surveyId);
            let score = 0;
            let answers = dd.answers;
            for (const el of answers) {
                let selectedQuestion = questions.find(el1 => el1.surveyQuestionId === el.surveyQuestionId);
                if (selectedQuestion) {
                    let selectedAnswers = selectedQuestion.options;
                    let selectedOption = selectedAnswers.find(el3 => el3.optionLabel === el.value);
                    if (selectedOption) {
                        score = score + parseFloat(selectedOption.optionValue);
                    }
                }
            }
            dd.score = score.toFixed(0);
            let interpretation = await this.surveyInterpretationTableService.findInterpretationByScore(dd.SurveyMasterTable.surveyId, score.toFixed(0));
            if (interpretation) {
                dd.SurveyInterpretationTable = interpretation;
            }
            let result = await this.surveyAnswersTableRepository.save(dd);
            return result;
        }
        else {
            return false;
        }
    }
    async checkIfExists(sessionId, voId, shgId) {
        if (voId) {
            let result = await this.surveyAnswersTableRepository.count({
                where: {
                    VoTable: {
                        voId
                    },
                    SessionmasterTable: {
                        sessionId
                    }
                }
            });
            if (result == 0) {
                return false;
            }
            else {
                return true;
            }
        }
        if (shgId) {
            let result = await this.surveyAnswersTableRepository.count({
                where: {
                    ShgTable: {
                        shgId
                    },
                    SessionmasterTable: {
                        sessionId
                    }
                }
            });
            if (result == 0) {
                return false;
            }
            else {
                return true;
            }
        }
    }
    async findAll() {
        return await this.surveyAnswersTableRepository.find();
    }
    async findOne(answerId) {
        return await this.surveyAnswersTableRepository.findOne({
            where: {
                answerId: answerId
            },
            relations: {
                SessionmasterTable: true,
                SurveyMasterTable: true,
                SurveyInterpretationTable: true,
                VoTable: {
                    GrampanchayatTable: {
                        BlockTable: {
                            DistrictTable: {
                                StateTable: true
                            }
                        }
                    }
                },
                ShgTable: {
                    VillageTable: {
                        GrampanchayatTable: {
                            BlockTable: {
                                DistrictTable: {
                                    StateTable: true
                                }
                            }
                        }
                    }
                },
                UserTable: {
                    DesignationTable: true
                }
            }
        });
    }
    async getListOfAnswersByUser(limit, page, type, search, user) {
        let data = await this.surveyAnswersTableRepository
            .createQueryBuilder('r')
            .where('r.userId=:userId', { userId: user.id })
            .andWhere('r.type=:type', { type: type })
            .leftJoinAndMapOne('r.SessionmasterTable', sessionmaster_table_entity_1.SessionmasterTable, 'ml', 'ml.sessionId=r.sessionId')
            .leftJoinAndMapOne('r.ShgTable', shg_table_entity_1.ShgTable, 'ml1', 'ml1.shgId=r.shgId')
            .leftJoinAndMapOne('r.VoTable', vo_table_entity_1.VoTable, 'ml2', 'ml2.voId=r.voId')
            .leftJoinAndMapOne('r.UserTable', user_collection_entity_1.UserTable, 'ml3', 'ml3.id=r.userId')
            .leftJoinAndMapOne('r.SurveyInterpretationTable', survey_interpretation_table_entity_1.SurveyInterpretationTable, 'ml4', 'ml4.interpretationId=r.interpretationId')
            .leftJoinAndMapOne('r.SurveyMasterTable', survey_master_table_entity_1.SurveyMasterTable, 'ml5', 'ml5.surveyId=r.surveyMasterId')
            .take(limit)
            .skip(page);
        if (search != '') {
            let s = `${search}%`;
            data = await data.andWhere('r.ShgTable.shgName LIKE :shgName', { shgName: s });
            data = await data.andWhere('r.VoTable.voName LIKE :voName', { shgName: s });
        }
        data = await data.getManyAndCount();
        let [result, count] = data;
        return {
            data: result,
            total: count,
        };
    }
    async remove(answerId) {
        let result = await this.surveyAnswersTableRepository.findOne({
            where: {
                answerId: answerId
            }
        });
        if (result) {
            await this.surveyAnswersTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_ANSWER_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.SurveyAnswersTableService = SurveyAnswersTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(survey_answers_table_entity_1.SurveyAnswersTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        sessionmaster_table_service_1.SessionmasterTableService,
        survey_master_table_service_1.SurveyMasterTableService,
        shg_table_service_1.ShgTableService,
        user_collection_service_1.UserCollectionService,
        vo_table_service_1.VoTableService,
        survey_questions_table_service_1.SurveyQuestionsTableService,
        survey_interpretation_table_service_1.SurveyInterpretationTableService])
], SurveyAnswersTableService);
