import { SurveyInterpretationTableService } from './survey-interpretation-table.service';
import { SurveyInterpretationTable } from './entities/survey-interpretation-table.entity';
import { CreateSurveyInterpretationTableInput } from './dto/create-survey-interpretation-table.input';
import { UpdateSurveyInterpretationTableInput } from './dto/update-survey-interpretation-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
export declare class SurveyInterpretationTableResolver {
    private readonly surveyInterpretationTableService;
    private pubSub;
    constructor(surveyInterpretationTableService: SurveyInterpretationTableService, pubSub: RedisPubSub);
    createSurveyInterpretationTable(createSurveyInterpretationTableInput: CreateSurveyInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyInterpretationTable;
    }>;
    findAllSurveyInterpretation(): Promise<SurveyInterpretationTable[]>;
    findOne(interpretationId: number): Promise<SurveyInterpretationTable>;
    updateSurveyInterpretationTable(updateSurveyInterpretationTableInput: UpdateSurveyInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyInterpretationTable;
    }>;
    removeSurveyInterpretationTable(interpretationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    surveyInterpretationSubscription(): AsyncIterator<unknown, any, undefined>;
}
