"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyInterpretationTableResolver = exports.NEW_INTERPRETATION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const survey_interpretation_table_service_1 = require("./survey-interpretation-table.service");
const survey_interpretation_table_entity_1 = require("./entities/survey-interpretation-table.entity");
const create_survey_interpretation_table_input_1 = require("./dto/create-survey-interpretation-table.input");
const update_survey_interpretation_table_input_1 = require("./dto/update-survey-interpretation-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const survey_interpretation_table_return_type_1 = require("./types/survey-interpretation-table-return.type");
const survey_interpretation_table_type_1 = require("./types/survey-interpretation-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
let SurveyInterpretationTableResolver = exports.SurveyInterpretationTableResolver = class SurveyInterpretationTableResolver {
    constructor(surveyInterpretationTableService, pubSub) {
        this.surveyInterpretationTableService = surveyInterpretationTableService;
        this.pubSub = pubSub;
    }
    createSurveyInterpretationTable(createSurveyInterpretationTableInput) {
        return this.surveyInterpretationTableService.create(createSurveyInterpretationTableInput);
    }
    findAllSurveyInterpretation() {
        return this.surveyInterpretationTableService.findAll();
    }
    findOne(interpretationId) {
        return this.surveyInterpretationTableService.findOne(interpretationId);
    }
    updateSurveyInterpretationTable(updateSurveyInterpretationTableInput) {
        return this.surveyInterpretationTableService.update(updateSurveyInterpretationTableInput.interpretationId, updateSurveyInterpretationTableInput);
    }
    removeSurveyInterpretationTable(interpretationId) {
        return this.surveyInterpretationTableService.remove(interpretationId);
    }
    surveyInterpretationSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_INTERPRETATION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_interpretation_table_return_type_1.SurveyInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('createSurveyInterpretationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_survey_interpretation_table_input_1.CreateSurveyInterpretationTableInput]),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "createSurveyInterpretationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [survey_interpretation_table_type_1.SurveyInterpretationTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "findAllSurveyInterpretation", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_interpretation_table_type_1.SurveyInterpretationTableType),
    __param(0, (0, graphql_1.Args)('interpretationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_interpretation_table_return_type_1.SurveyInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSurveyInterpretationTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_survey_interpretation_table_input_1.UpdateSurveyInterpretationTableInput]),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "updateSurveyInterpretationTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_interpretation_table_return_type_1.SurveyInterpretationTableReturnType),
    __param(0, (0, graphql_1.Args)('interpretationId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "removeSurveyInterpretationTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SurveyInterpretationTableResolver.prototype, "surveyInterpretationSubscription", null);
exports.SurveyInterpretationTableResolver = SurveyInterpretationTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => survey_interpretation_table_entity_1.SurveyInterpretationTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [survey_interpretation_table_service_1.SurveyInterpretationTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SurveyInterpretationTableResolver);
