import { CreateSurveyInterpretationTableInput } from './dto/create-survey-interpretation-table.input';
import { UpdateSurveyInterpretationTableInput } from './dto/update-survey-interpretation-table.input';
import { SurveyInterpretationTable } from './entities/survey-interpretation-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { SurveyMasterTableService } from 'src/survey-master-table/survey-master-table.service';
export declare const NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
export declare class SurveyInterpretationTableService {
    private readonly surveyInterpretationTableRepository;
    private pubSub;
    private readonly surveyMasterTableService;
    constructor(surveyInterpretationTableRepository: Repository<SurveyInterpretationTable>, pubSub: RedisPubSub, surveyMasterTableService: SurveyMasterTableService);
    create(createSurveyInterpretationTableInput: CreateSurveyInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyInterpretationTable;
    }>;
    checkIfExists(interpretation: string, type: string, classification: string, maxScore: string, minScore: string): Promise<boolean>;
    findAll(): Promise<SurveyInterpretationTable[]>;
    findInterpretationByScore(surveyMasterId: number, score: string): Promise<false | SurveyInterpretationTable>;
    findOne(interpretationId: number): Promise<SurveyInterpretationTable>;
    update(interpretationId: number, updateSurveyInterpretationTableInput: UpdateSurveyInterpretationTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyInterpretationTable;
    }>;
    remove(interpretationId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
