"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyInterpretationTableService = exports.NEW_INTERPRETATION_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const survey_interpretation_table_entity_1 = require("./entities/survey-interpretation-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const survey_master_table_service_1 = require("../survey-master-table/survey-master-table.service");
exports.NEW_INTERPRETATION_ADD = "NEW_INTERPRETATION_ADD";
let SurveyInterpretationTableService = exports.SurveyInterpretationTableService = class SurveyInterpretationTableService {
    constructor(surveyInterpretationTableRepository, pubSub, surveyMasterTableService) {
        this.surveyInterpretationTableRepository = surveyInterpretationTableRepository;
        this.pubSub = pubSub;
        this.surveyMasterTableService = surveyMasterTableService;
    }
    async create(createSurveyInterpretationTableInput) {
        let checkIfExists = await this.checkIfExists(createSurveyInterpretationTableInput.interpretation, createSurveyInterpretationTableInput.type, createSurveyInterpretationTableInput.classification, createSurveyInterpretationTableInput.maxScore, createSurveyInterpretationTableInput.minScore);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new survey_interpretation_table_entity_1.SurveyInterpretationTable();
            dd.interpretation = createSurveyInterpretationTableInput.interpretation;
            dd.type = createSurveyInterpretationTableInput.type;
            dd.classification = createSurveyInterpretationTableInput.classification;
            dd.maxScore = createSurveyInterpretationTableInput.maxScore;
            dd.minScore = createSurveyInterpretationTableInput.minScore;
            let surveyMaster = await this.surveyMasterTableService.findOne(createSurveyInterpretationTableInput.surveyMasterId);
            dd.SurveyMasterTable = surveyMaster;
            let result = await this.surveyInterpretationTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_INTERPRETATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(interpretation, type, classification, maxScore, minScore) {
        let result = await this.surveyInterpretationTableRepository.count({
            where: {
                interpretation: interpretation,
                type: type,
                maxScore: maxScore,
                minScore: minScore,
                classification: classification,
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.surveyInterpretationTableRepository.find({
            relations: {
                SurveyMasterTable: true
            }
        });
    }
    async findInterpretationByScore(surveyMasterId, score) {
        let result = await this.surveyInterpretationTableRepository.find({
            where: {
                SurveyMasterTable: {
                    surveyId: surveyMasterId
                },
            }
        });
        for (const el of result) {
            if (parseFloat(el.minScore) <= parseFloat(score) && parseFloat(score) <= parseFloat(el.maxScore)) {
                return el;
            }
        }
        return false;
    }
    async findOne(interpretationId) {
        return await this.surveyInterpretationTableRepository.findOne({
            where: {
                interpretationId: interpretationId
            }
        });
    }
    async update(interpretationId, updateSurveyInterpretationTableInput) {
        let result = await this.surveyInterpretationTableRepository.findOne({
            where: {
                interpretationId: interpretationId
            }
        });
        if (result) {
            let dd = result;
            dd.interpretation = updateSurveyInterpretationTableInput.interpretation;
            dd.type = updateSurveyInterpretationTableInput.type;
            dd.classification = updateSurveyInterpretationTableInput.classification;
            dd.maxScore = updateSurveyInterpretationTableInput.maxScore;
            dd.minScore = updateSurveyInterpretationTableInput.minScore;
            let surveyMaster = await this.surveyMasterTableService.findOne(updateSurveyInterpretationTableInput.surveyMasterId);
            dd.SurveyMasterTable = surveyMaster;
            let result1 = await this.surveyInterpretationTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_INTERPRETATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result1
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
    async remove(interpretationId) {
        let result = await this.surveyInterpretationTableRepository.findOne({
            where: {
                interpretationId: interpretationId
            }
        });
        if (result) {
            await this.surveyInterpretationTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_INTERPRETATION_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.SurveyInterpretationTableService = SurveyInterpretationTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(survey_interpretation_table_entity_1.SurveyInterpretationTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        survey_master_table_service_1.SurveyMasterTableService])
], SurveyInterpretationTableService);
