import { SurveyMasterTableService } from './survey-master-table.service';
import { SurveyMasterTable } from './entities/survey-master-table.entity';
import { CreateSurveyMasterTableInput } from './dto/create-survey-master-table.input';
import { UpdateSurveyMasterTableInput } from './dto/update-survey-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SURVEY_ADD = "NEW_SURVEY_ADD";
export declare class SurveyMasterTableResolver {
    private readonly surveyMasterTableService;
    private pubSub;
    constructor(surveyMasterTableService: SurveyMasterTableService, pubSub: RedisPubSub);
    createSurveyMasterTable(createSurveyMasterTableInput: CreateSurveyMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    findAllSurvey(): Promise<SurveyMasterTable[]>;
    findOne(surveyId: number): Promise<SurveyMasterTable>;
    updateSurveyMasterTable(updateSurveyMasterTableInput: UpdateSurveyMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    toggleActiveStatusSurvey(surveyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    removeSurveyMasterTable(surveyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    surveySubscription(): AsyncIterator<unknown, any, undefined>;
}
