import { CreateSurveyMasterTableInput } from './dto/create-survey-master-table.input';
import { UpdateSurveyMasterTableInput } from './dto/update-survey-master-table.input';
import { SurveyMasterTable } from './entities/survey-master-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_SURVEY_ADD = "NEW_SURVEY_ADD";
export declare class SurveyMasterTableService {
    private readonly surveyMasterTableRepository;
    private pubSub;
    constructor(surveyMasterTableRepository: Repository<SurveyMasterTable>, pubSub: RedisPubSub);
    create(createSurveyMasterTableInput: CreateSurveyMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    checkIfExists(surveyName: string, type: string, maxScore: string, isActive: boolean): Promise<boolean>;
    findAll(): Promise<SurveyMasterTable[]>;
    findOne(surveyId: number): Promise<SurveyMasterTable>;
    update(surveyId: number, updateSurveyMasterTableInput: UpdateSurveyMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    toggleActiveStatus(surveyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyMasterTable;
    }>;
    remove(surveyId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
