"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyMasterTableService = exports.NEW_SURVEY_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const survey_master_table_entity_1 = require("./entities/survey-master-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_SURVEY_ADD = "NEW_SURVEY_ADD";
let SurveyMasterTableService = exports.SurveyMasterTableService = class SurveyMasterTableService {
    constructor(surveyMasterTableRepository, pubSub) {
        this.surveyMasterTableRepository = surveyMasterTableRepository;
        this.pubSub = pubSub;
    }
    async create(createSurveyMasterTableInput) {
        let checkIfExists = await this.checkIfExists(createSurveyMasterTableInput.surveyName, createSurveyMasterTableInput.type, createSurveyMasterTableInput.maxScore, createSurveyMasterTableInput.isActive);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new survey_master_table_entity_1.SurveyMasterTable();
            dd.surveyName = createSurveyMasterTableInput.surveyName;
            dd.type = createSurveyMasterTableInput.type;
            dd.maxScore = createSurveyMasterTableInput.maxScore;
            dd.isActive = createSurveyMasterTableInput.isActive;
            let result = await this.surveyMasterTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_SURVEY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(surveyName, type, maxScore, isActive) {
        let result = await this.surveyMasterTableRepository.count({
            where: {
                surveyName: surveyName,
                type: type,
                maxScore: maxScore,
                isActive: isActive,
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.surveyMasterTableRepository.find();
    }
    async findOne(surveyId) {
        return await this.surveyMasterTableRepository.findOne({
            where: {
                surveyId: surveyId
            }
        });
    }
    async update(surveyId, updateSurveyMasterTableInput) {
        let result = await this.surveyMasterTableRepository.findOne({
            where: {
                surveyId: surveyId
            }
        });
        if (result) {
            result.surveyName = updateSurveyMasterTableInput.surveyName;
            result.type = updateSurveyMasterTableInput.type;
            result.maxScore = updateSurveyMasterTableInput.maxScore;
            result.isActive = updateSurveyMasterTableInput.isActive;
            let r = await this.surveyMasterTableRepository.save(result);
            this.pubSub.publish(exports.NEW_SURVEY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async toggleActiveStatus(surveyId) {
        let u = await this.findOne(surveyId);
        if (!!u) {
            let oldStatus = u.isActive;
            u.isActive = !oldStatus;
            let newStatus = !oldStatus ? 'Activated' : 'De-Activated';
            let u1 = await this.surveyMasterTableRepository.save(u);
            return {
                status: true,
                status_text: "Status Changed",
                data: await this.findOne(surveyId)
            };
        }
        else {
            return {
                status: false,
                status_text: "Survey not found",
                data: null
            };
        }
    }
    async remove(surveyId) {
        let result = await this.surveyMasterTableRepository.findOne({
            where: {
                surveyId: surveyId
            }
        });
        if (result) {
            await this.surveyMasterTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_SURVEY_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.SurveyMasterTableService = SurveyMasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(survey_master_table_entity_1.SurveyMasterTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], SurveyMasterTableService);
