import { SurveyQuestionsTableService } from './survey-questions-table.service';
import { SurveyQuestionsTable } from './entities/survey-questions-table.entity';
import { CreateSurveyQuestionsTableInput } from './dto/create-survey-questions-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { UpdateSurveyQuestionsTableInput } from './dto/update-survey-questions-table.input';
export declare const NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
export declare class SurveyQuestionsTableResolver {
    private readonly surveyQuestionsTableService;
    private pubSub;
    constructor(surveyQuestionsTableService: SurveyQuestionsTableService, pubSub: RedisPubSub);
    createSurveyQuestionsTable(createSurveyQuestionsTableInput: CreateSurveyQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyQuestionsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllSurveyQuestions(): Promise<SurveyQuestionsTable[]>;
    findOne(surveyQuestionId: number): Promise<SurveyQuestionsTable>;
    findOneBySurveyMasterId(surveyMasterId: number): Promise<SurveyQuestionsTable[]>;
    findOneSurveyByType(type: string): Promise<{
        data: any;
        length: number;
        surveyMasterId: number;
    }>;
    updateSurveyQuestionsTable(updateSurveyQuestionsTableInput: UpdateSurveyQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyQuestionsTable;
    }>;
    removeSurveyQuestionsTable(surveyQuestionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    surveyQuestionsSubscription(): AsyncIterator<unknown, any, undefined>;
}
