"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SurveyQuestionsTableResolver = exports.NEW_QUESTION_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const survey_questions_table_service_1 = require("./survey-questions-table.service");
const survey_questions_table_entity_1 = require("./entities/survey-questions-table.entity");
const create_survey_questions_table_input_1 = require("./dto/create-survey-questions-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const survey_questions_table_return_type_1 = require("./types/survey-questions-table-return.type");
const survey_questions_table_type_1 = require("./types/survey-questions-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const update_survey_questions_table_input_1 = require("./dto/update-survey-questions-table.input");
const survey_questions_table_return_app_type_1 = require("./types/survey-questions-table-return-app.type");
exports.NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
let SurveyQuestionsTableResolver = exports.SurveyQuestionsTableResolver = class SurveyQuestionsTableResolver {
    constructor(surveyQuestionsTableService, pubSub) {
        this.surveyQuestionsTableService = surveyQuestionsTableService;
        this.pubSub = pubSub;
    }
    createSurveyQuestionsTable(createSurveyQuestionsTableInput) {
        return this.surveyQuestionsTableService.create(createSurveyQuestionsTableInput);
    }
    findAllSurveyQuestions() {
        return this.surveyQuestionsTableService.findAll();
    }
    findOne(surveyQuestionId) {
        return this.surveyQuestionsTableService.findOne(surveyQuestionId);
    }
    findOneBySurveyMasterId(surveyMasterId) {
        return this.surveyQuestionsTableService.findOneBySurveyMasterId(surveyMasterId);
    }
    findOneSurveyByType(type) {
        return this.surveyQuestionsTableService.findOneSurveyByType(type);
    }
    updateSurveyQuestionsTable(updateSurveyQuestionsTableInput) {
        return this.surveyQuestionsTableService.update(updateSurveyQuestionsTableInput.surveyQuestionId, updateSurveyQuestionsTableInput);
    }
    removeSurveyQuestionsTable(surveyQuestionId) {
        return this.surveyQuestionsTableService.remove(surveyQuestionId);
    }
    surveyQuestionsSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_QUESTION_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_questions_table_return_type_1.SurveyQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('createSurveyQuestionsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_survey_questions_table_input_1.CreateSurveyQuestionsTableInput]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "createSurveyQuestionsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [survey_questions_table_type_1.SurveyQuestionsTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "findAllSurveyQuestions", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_questions_table_return_type_1.SurveyQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('surveyQuestionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [survey_questions_table_type_1.SurveyQuestionsTableType]),
    __param(0, (0, graphql_1.Args)('surveyMasterId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "findOneBySurveyMasterId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => survey_questions_table_return_app_type_1.SurveyQuestionsTableReturnAppType),
    __param(0, (0, graphql_1.Args)('type', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "findOneSurveyByType", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_questions_table_return_type_1.SurveyQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('updateSurveyQuestionsTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_survey_questions_table_input_1.UpdateSurveyQuestionsTableInput]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "updateSurveyQuestionsTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => survey_questions_table_return_type_1.SurveyQuestionsTableReturnType),
    __param(0, (0, graphql_1.Args)('surveyQuestionId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "removeSurveyQuestionsTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], SurveyQuestionsTableResolver.prototype, "surveyQuestionsSubscription", null);
exports.SurveyQuestionsTableResolver = SurveyQuestionsTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => survey_questions_table_entity_1.SurveyQuestionsTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [survey_questions_table_service_1.SurveyQuestionsTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], SurveyQuestionsTableResolver);
