import { CreateSurveyQuestionsTableInput } from './dto/create-survey-questions-table.input';
import { SurveyQuestionsTable } from './entities/survey-questions-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { SurveyMasterTableService } from 'src/survey-master-table/survey-master-table.service';
import { UpdateSurveyQuestionsTableInput } from './dto/update-survey-questions-table.input';
export declare const NEW_QUESTION_ADD = "NEW_QUESTION_ADD";
export declare class SurveyQuestionsTableService {
    private readonly surveyQuestionsTableRepository;
    private pubSub;
    private readonly surveyMasterTableService;
    constructor(surveyQuestionsTableRepository: Repository<SurveyQuestionsTable>, pubSub: RedisPubSub, surveyMasterTableService: SurveyMasterTableService);
    create(createSurveyQuestionsTableInput: CreateSurveyQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyQuestionsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createSurveyQuestionsTableInput: CreateSurveyQuestionsTableInput): Promise<number>;
    findAll(): Promise<SurveyQuestionsTable[]>;
    findOne(surveyQuestionId: number): Promise<SurveyQuestionsTable>;
    findOneBySurveyMasterId(surveyMasterId: number): Promise<SurveyQuestionsTable[]>;
    findOneSurveyByType(type: string): Promise<{
        data: any;
        length: number;
        surveyMasterId: number;
    }>;
    findLargest(arr: number[]): number;
    shuffleArray(array: any): any;
    update(surveyQuestionId: number, updateSurveyQuestionsTableInput: UpdateSurveyQuestionsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: SurveyQuestionsTable;
    }>;
    remove(surveyQuestionId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
