import { CreateTaskAchievementsTableInput } from './dto/create-task-achievements-table.input';
import { TaskAchievementsTable } from './entities/task-achievements-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { TaskTableService } from 'src/task-table/task-table.service';
import { ActivityTableService } from 'src/activity-table/activity-table.service';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
export declare class TaskAchievementsTableService {
    private readonly taskAchievementsTableRepository;
    private pubSub;
    private readonly taskTableService;
    private readonly activityTableService;
    private readonly sessionmasterTableService;
    private readonly userCollectionService;
    constructor(taskAchievementsTableRepository: Repository<TaskAchievementsTable>, pubSub: RedisPubSub, taskTableService: TaskTableService, activityTableService: ActivityTableService, sessionmasterTableService: SessionmasterTableService, userCollectionService: UserCollectionService);
    createSingle(createTaskAchievementsTableInput: CreateTaskAchievementsTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    checkIfExists(createTaskAchievementsTableInput: CreateTaskAchievementsTableInput): Promise<TaskAchievementsTable>;
    fetchAchievementNosOfMonth(month: string, taskId: number, activityId: number, user: any): Promise<number>;
    fetchAchievementNosOfMonthIfNotPresent(month: string, userId: number, sessionId: number): Promise<TaskAchievementsTable[]>;
    fetchAchievementNosHalfYearly(halfNo: number, taskId: number, activityId: number, user: any, sessionId: number): Promise<any>;
    fetchAchievementNosAnnually(taskId: number, activityId: number, user: any, sessionId: number): Promise<any>;
}
