"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskAchievementsTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const task_achievements_table_entity_1 = require("./entities/task-achievements-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const task_table_service_1 = require("../task-table/task-table.service");
const activity_table_service_1 = require("../activity-table/activity-table.service");
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
let TaskAchievementsTableService = exports.TaskAchievementsTableService = class TaskAchievementsTableService {
    constructor(taskAchievementsTableRepository, pubSub, taskTableService, activityTableService, sessionmasterTableService, userCollectionService) {
        this.taskAchievementsTableRepository = taskAchievementsTableRepository;
        this.pubSub = pubSub;
        this.taskTableService = taskTableService;
        this.activityTableService = activityTableService;
        this.sessionmasterTableService = sessionmasterTableService;
        this.userCollectionService = userCollectionService;
    }
    async createSingle(createTaskAchievementsTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        const checkIfExists = await this.checkIfExists(createTaskAchievementsTableInput);
        if (!checkIfExists) {
            let apt = new task_achievements_table_entity_1.TaskAchievementsTable();
            const session = await this.sessionmasterTableService.findActiveSession();
            const task = await this.taskTableService.findOne(createTaskAchievementsTableInput.taskId);
            const activity = await this.activityTableService.findOne(createTaskAchievementsTableInput.activityId);
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            apt.SessionmasterTable = session;
            apt.TaskTable = task;
            apt.ActivityTable = activity;
            apt.UserTable = userTable;
            apt.nosPerformed = createTaskAchievementsTableInput.nosPerformed;
            apt.taskType = createTaskAchievementsTableInput.taskType;
            apt.isVerified = 0;
            apt.month = createTaskAchievementsTableInput.month;
            let hh = (0, moment_1.default)(createTaskAchievementsTableInput.month, "MM-YYYY").format("MM");
            let halfNo = 1;
            if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                halfNo = 1;
            }
            else {
                halfNo = 2;
            }
            apt.halfNo = halfNo;
            await this.taskAchievementsTableRepository.save(apt);
            return {
                status: true,
                status_text: "Acheivement Submitted Successfully."
            };
        }
        else {
            let apt = checkIfExists;
            apt.nosPerformed = createTaskAchievementsTableInput.nosPerformed;
            await this.taskAchievementsTableRepository.save(apt);
            return {
                status: true,
                status_text: "Acheivement Updated Successfully"
            };
        }
    }
    async checkIfExists(createTaskAchievementsTableInput) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let res = await this.taskAchievementsTableRepository.findOne({
            where: {
                TaskTable: {
                    taskId: createTaskAchievementsTableInput.taskId,
                },
                ActivityTable: {
                    activityId: createTaskAchievementsTableInput.activityId
                },
                taskType: createTaskAchievementsTableInput.taskType,
                month: createTaskAchievementsTableInput.month,
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return res;
    }
    async fetchAchievementNosOfMonth(month, taskId, activityId, user) {
        let ac = await this.taskAchievementsTableRepository.findOne({
            where: {
                month,
                TaskTable: {
                    taskId
                },
                ActivityTable: {
                    activityId
                },
                UserTable: {
                    username: user.username
                }
            }
        });
        if (ac) {
            return ac.nosPerformed;
        }
        else {
            return 0;
        }
    }
    async fetchAchievementNosOfMonthIfNotPresent(month, userId, sessionId) {
        let ac = await this.taskAchievementsTableRepository.find({
            where: {
                month,
                SessionmasterTable: {
                    sessionId
                },
                UserTable: {
                    id: userId
                }
            },
            relations: {
                TaskTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        return ac;
    }
    async fetchAchievementNosHalfYearly(halfNo, taskId, activityId, user, sessionId) {
        let ac = await this.taskAchievementsTableRepository.createQueryBuilder('r')
            .andWhere('r.halfNo=:halfNo', { halfNo })
            .andWhere('r.taskId=:taskId', { taskId: taskId })
            .andWhere('r.activityId=:activityId', { activityId: activityId })
            .andWhere('r.sessionMasterId=:sessionMasterId', { sessionMasterId: sessionId })
            .andWhere('r.userId=:userId', { userId: user.id })
            .select('SUM(r.nosPerformed)', 'nosPerformed')
            .getRawOne();
        if (ac) {
            if (ac.nosPerformed) {
                return ac.nosPerformed;
            }
            else {
                return 0;
            }
        }
        else {
            return 0;
        }
    }
    async fetchAchievementNosAnnually(taskId, activityId, user, sessionId) {
        let ac = await this.taskAchievementsTableRepository.createQueryBuilder('r')
            .andWhere('r.taskId=:taskId', { taskId: taskId })
            .andWhere('r.activityId=:activityId', { activityId: activityId })
            .andWhere('r.sessionMasterId=:sessionMasterId', { sessionMasterId: sessionId })
            .andWhere('r.userId=:userId', { userId: user.id })
            .select('SUM(r.nosPerformed)', 'nosPerformed')
            .getRawOne();
        if (ac) {
            if (ac.nosPerformed) {
                return ac.nosPerformed;
            }
            else {
                return 0;
            }
        }
        else {
            return 0;
        }
    }
};
exports.TaskAchievementsTableService = TaskAchievementsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(task_achievements_table_entity_1.TaskAchievementsTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => task_table_service_1.TaskTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => activity_table_service_1.ActivityTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        task_table_service_1.TaskTableService,
        activity_table_service_1.ActivityTableService,
        sessionmaster_table_service_1.SessionmasterTableService,
        user_collection_service_1.UserCollectionService])
], TaskAchievementsTableService);
