import { TaskPlanningTableService } from './task-planning-table.service';
import { TaskPlanningTable } from './entities/task-planning-table.entity';
import { CreateTaskPlanningTableInput } from './dto/create-task-planning-table.input';
import { UpdateTaskPlanningTableInput } from './dto/update-task-planning-table.input';
import { CreateTaskPlanningTableBulkInput } from './dto/create-task-planning-table-bulk.input';
import { TaskPlanningVerificationDtoInput } from './dto/task-planning-verification-dto.input';
export declare class TaskPlanningTableResolver {
    private readonly taskPlanningTableService;
    constructor(taskPlanningTableService: TaskPlanningTableService);
    createTaskPlanningTable(createTaskPlanningTableInput: CreateTaskPlanningTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createTaskHalfYearlyPlanningTable(createTaskPlanningTableBulkInput: CreateTaskPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    createTaskMonthlyPlanningTable(createTaskPlanningTableBulkInput: CreateTaskPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    findAllTaskPlannerBySessionAndUser(user: any, sessionId: number, taskType: string): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerBySessionAndUserVerification(userId: number, sessionId: number, taskType: string): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerHalfYearlyBySessionAndUser(user: any, sessionId: number, taskType: string, halfNo: number): Promise<any>;
    findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId: number, sessionId: number, taskType: string, halfNo: number): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerMonthlyBySessionAndUser(user: any, sessionId: number, taskType: string, month: string): Promise<any>;
    findAllTaskPlannerMonthlyBySessionAndUserVerification(userId: number, sessionId: number, taskType: string, month: string): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerMonthlyBySessionAndUserDashboard(user: any, sessionId: number, taskType: string, month: string): Promise<any>;
    updateTaskPlanningTable(updateTaskPlanningTableInput: UpdateTaskPlanningTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    removeTaskPlanningTable(taskPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateTaskStatus(taskPlanningVerificationDtoInput: TaskPlanningVerificationDtoInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleIsEditableTask(taskPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
        data: TaskPlanningTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
}
