"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskPlanningTableResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const task_planning_table_service_1 = require("./task-planning-table.service");
const task_planning_table_entity_1 = require("./entities/task-planning-table.entity");
const create_task_planning_table_input_1 = require("./dto/create-task-planning-table.input");
const update_task_planning_table_input_1 = require("./dto/update-task-planning-table.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const task_planning_table_return_type_1 = require("./types/task-planning-table-return.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const task_planning_table_type_1 = require("./types/task-planning-table.type");
const task_planning_table_return_bulk_type_1 = require("./types/task-planning-table-return-bulk.type");
const create_task_planning_table_bulk_input_1 = require("./dto/create-task-planning-table-bulk.input");
const task_planning_verification_dto_input_1 = require("./dto/task-planning-verification-dto.input");
let TaskPlanningTableResolver = exports.TaskPlanningTableResolver = class TaskPlanningTableResolver {
    constructor(taskPlanningTableService) {
        this.taskPlanningTableService = taskPlanningTableService;
    }
    createTaskPlanningTable(createTaskPlanningTableInput, user) {
        return this.taskPlanningTableService.create(createTaskPlanningTableInput, user);
    }
    createTaskHalfYearlyPlanningTable(createTaskPlanningTableBulkInput, user) {
        return this.taskPlanningTableService.createHalfYearly(createTaskPlanningTableBulkInput, user);
    }
    createTaskMonthlyPlanningTable(createTaskPlanningTableBulkInput, user) {
        return this.taskPlanningTableService.createMonthly(createTaskPlanningTableBulkInput, user);
    }
    findAllTaskPlannerBySessionAndUser(user, sessionId, taskType) {
        return this.taskPlanningTableService.findAllTaskPlannerBySessionAndUser(user, sessionId, taskType);
    }
    findAllTaskPlannerBySessionAndUserVerification(userId, sessionId, taskType) {
        return this.taskPlanningTableService.findAllTaskPlannerBySessionAndUserVerification(userId, sessionId, taskType);
    }
    findAllTaskPlannerHalfYearlyBySessionAndUser(user, sessionId, taskType, halfNo) {
        return this.taskPlanningTableService.findAllTaskPlannerHalfYearlyBySessionAndUser(user, sessionId, taskType, halfNo);
    }
    findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, taskType, halfNo) {
        return this.taskPlanningTableService.findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, taskType, halfNo);
    }
    findAllTaskPlannerMonthlyBySessionAndUser(user, sessionId, taskType, month) {
        return this.taskPlanningTableService.findAllTaskPlannerMonthlyBySessionAndUser(user, sessionId, taskType, month);
    }
    findAllTaskPlannerMonthlyBySessionAndUserVerification(userId, sessionId, taskType, month) {
        return this.taskPlanningTableService.findAllTaskPlannerMonthlyBySessionAndUserVerification(userId, sessionId, taskType, month);
    }
    findAllTaskPlannerMonthlyBySessionAndUserDashboard(user, sessionId, taskType, month) {
        return this.taskPlanningTableService.findAllTaskPlannerMonthlyBySessionAndUserDashboard(user, sessionId, taskType, month);
    }
    updateTaskPlanningTable(updateTaskPlanningTableInput) {
        return this.taskPlanningTableService.update(updateTaskPlanningTableInput.taskPlanningId, updateTaskPlanningTableInput);
    }
    removeTaskPlanningTable(taskPlanningId) {
        return this.taskPlanningTableService.remove(taskPlanningId);
    }
    updateTaskStatus(taskPlanningVerificationDtoInput, user) {
        return this.taskPlanningTableService.updateTaskStatus(taskPlanningVerificationDtoInput, user);
    }
    toggleIsEditableTask(taskPlanningId) {
        return this.taskPlanningTableService.toggleIsEditable(taskPlanningId);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_type_1.TaskPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('createTaskPlanningTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_planning_table_input_1.CreateTaskPlanningTableInput, Object]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "createTaskPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_bulk_type_1.TaskPlanningTableReturnBulkType),
    __param(0, (0, graphql_1.Args)('createTaskPlanningTableBulkInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_planning_table_bulk_input_1.CreateTaskPlanningTableBulkInput, Object]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "createTaskHalfYearlyPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_bulk_type_1.TaskPlanningTableReturnBulkType),
    __param(0, (0, graphql_1.Args)('createTaskPlanningTableBulkInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_planning_table_bulk_input_1.CreateTaskPlanningTableBulkInput, Object]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "createTaskMonthlyPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __param(3, (0, graphql_1.Args)('halfNo')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, Number]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerHalfYearlyBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __param(3, (0, graphql_1.Args)('halfNo')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, Number]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerHalfYearlyBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, String]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerMonthlyBySessionAndUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, graphql_1.Args)('userId')),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number, String, String]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerMonthlyBySessionAndUserVerification", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_planning_table_type_1.TaskPlanningTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('sessionId')),
    __param(2, (0, graphql_1.Args)('taskType')),
    __param(3, (0, graphql_1.Args)('month')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, String, String]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "findAllTaskPlannerMonthlyBySessionAndUserDashboard", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_type_1.TaskPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('updateTaskPlanningTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_task_planning_table_input_1.UpdateTaskPlanningTableInput]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "updateTaskPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_type_1.TaskPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('taskPlanningId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "removeTaskPlanningTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_type_1.TaskPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('taskPlanningVerificationDtoInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [task_planning_verification_dto_input_1.TaskPlanningVerificationDtoInput, Object]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "updateTaskStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_planning_table_return_type_1.TaskPlanningTableReturnType),
    __param(0, (0, graphql_1.Args)('taskPlanningId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TaskPlanningTableResolver.prototype, "toggleIsEditableTask", null);
exports.TaskPlanningTableResolver = TaskPlanningTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => task_planning_table_entity_1.TaskPlanningTable),
    __metadata("design:paramtypes", [task_planning_table_service_1.TaskPlanningTableService])
], TaskPlanningTableResolver);
