import { CreateTaskPlanningTableInput } from './dto/create-task-planning-table.input';
import { UpdateTaskPlanningTableInput } from './dto/update-task-planning-table.input';
import { TaskPlanningTable } from './entities/task-planning-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { TaskTableService } from 'src/task-table/task-table.service';
import { ActivityTableService } from 'src/activity-table/activity-table.service';
import { SessionmasterTableService } from 'src/sessionmaster-table/sessionmaster-table.service';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { CreateTaskPlanningTableBulkInput } from './dto/create-task-planning-table-bulk.input';
import { TaskAchievementsTableService } from 'src/task-achievements-table/task-achievements-table.service';
import { TaskPlanningVerificationDtoInput } from './dto/task-planning-verification-dto.input';
export declare class TaskPlanningTableService {
    private readonly taskPlanningTableRepository;
    private pubSub;
    private readonly taskTableService;
    private readonly activityTableService;
    private readonly sessionmasterTableService;
    private readonly userCollectionService;
    private readonly taskAchievementsTableService;
    constructor(taskPlanningTableRepository: Repository<TaskPlanningTable>, pubSub: RedisPubSub, taskTableService: TaskTableService, activityTableService: ActivityTableService, sessionmasterTableService: SessionmasterTableService, userCollectionService: UserCollectionService, taskAchievementsTableService: TaskAchievementsTableService);
    create(createTaskPlanningTableInput: CreateTaskPlanningTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    createHalfYearly(createTaskPlanningTableBulkInput: CreateTaskPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    checkIfExistsHalfYearly(createTaskPlanningTableInput: CreateTaskPlanningTableInput, user: any): Promise<TaskPlanningTable>;
    checkIfExists(createTaskPlanningTableInput: CreateTaskPlanningTableInput, user: any): Promise<boolean>;
    checkIfExistsMonthly(createTaskPlanningTableInput: CreateTaskPlanningTableInput, user: any): Promise<TaskPlanningTable>;
    createMonthly(createTaskPlanningTableBulkInput: CreateTaskPlanningTableBulkInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data?: undefined;
    } | {
        data: any;
        status?: undefined;
        status_text?: undefined;
    }>;
    findAllTaskPlannerBySessionAndUser(user: any, sessionId: number, taskType: string): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerBySessionAndUserVerification(userId: number, sessionId: number, taskType: string): Promise<TaskPlanningTable[]>;
    findHalfData(user: any, sessionId: number, taskType: string, halfNo: number): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerHalfYearlyBySessionAndUser(user: any, sessionId: number, taskType: string, halfNo: number): Promise<any>;
    findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId: number, sessionId: number, taskType: string, halfNo: number): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerMonthlyBySessionAndUser(user: any, sessionId: number, taskType: string, month: string): Promise<any>;
    findAllTaskPlannerMonthlyBySessionAndUserVerification(userId: number, sessionId: number, taskType: string, month: string): Promise<TaskPlanningTable[]>;
    findAllTaskPlannerMonthlyBySessionAndUserDashboard(user: any, sessionId: number, taskType: string, month: string): Promise<any>;
    findAll(): string;
    findOne(id: number): string;
    findAllActivityListForUser(user: any, sessionId: number): Promise<import("../activity-table/entities/activity-table.entity").ActivityTable[]>;
    update(taskPlanningId: number, updateTaskPlanningTableInput: UpdateTaskPlanningTableInput): Promise<{
        status: boolean;
        status_text: string;
    }>;
    remove(taskPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    updateTaskStatus(taskPlanningVerificationDtoInput: TaskPlanningVerificationDtoInput, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleIsEditable(taskPlanningId: number): Promise<{
        status: boolean;
        status_text: string;
        data: TaskPlanningTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllTaskPlannerMonthlyBySessionAndUserReports(userId: any, sessionId: number, taskType: string, month: string): Promise<import("../task-achievements-table/entities/task-achievements-table.entity").TaskAchievementsTable[] | TaskPlanningTable[]>;
}
