"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskPlanningTableService = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const task_planning_table_entity_1 = require("./entities/task-planning-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const task_table_service_1 = require("../task-table/task-table.service");
const activity_table_service_1 = require("../activity-table/activity-table.service");
const sessionmaster_table_service_1 = require("../sessionmaster-table/sessionmaster-table.service");
const user_collection_service_1 = require("../user-collection/user-collection.service");
const moment_1 = __importDefault(require("moment"));
const task_achievements_table_service_1 = require("../task-achievements-table/task-achievements-table.service");
let TaskPlanningTableService = exports.TaskPlanningTableService = class TaskPlanningTableService {
    constructor(taskPlanningTableRepository, pubSub, taskTableService, activityTableService, sessionmasterTableService, userCollectionService, taskAchievementsTableService) {
        this.taskPlanningTableRepository = taskPlanningTableRepository;
        this.pubSub = pubSub;
        this.taskTableService = taskTableService;
        this.activityTableService = activityTableService;
        this.sessionmasterTableService = sessionmasterTableService;
        this.userCollectionService = userCollectionService;
        this.taskAchievementsTableService = taskAchievementsTableService;
    }
    async create(createTaskPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        const checkIfExists = await this.checkIfExists(createTaskPlanningTableInput, user);
        if (!checkIfExists) {
            let apt = new task_planning_table_entity_1.TaskPlanningTable();
            const session = await this.sessionmasterTableService.findActiveSession();
            const task = await this.taskTableService.findOne(createTaskPlanningTableInput.taskId);
            const activity = await this.activityTableService.findOne(createTaskPlanningTableInput.activityId);
            const userTable = await this.userCollectionService.findOneByUsername(user.username);
            apt.SessionmasterTable = session;
            apt.TaskTable = task;
            apt.ActivityTable = activity;
            apt.UserTable = userTable;
            apt.nosToBePerformed = createTaskPlanningTableInput.nosToBePerformed;
            apt.taskType = createTaskPlanningTableInput.taskType;
            apt.isVerified = 0;
            apt.isActive = 1;
            await this.taskPlanningTableRepository.save(apt);
            return {
                status: true,
                status_text: "Submitted Successfully. You can submit the task for this activity"
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createHalfYearly(createTaskPlanningTableBulkInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        let data = [];
        for (const createTaskPlanningTableInput of createTaskPlanningTableBulkInput.data) {
            const checkIfExists = await this.checkIfExistsHalfYearly(createTaskPlanningTableInput, user);
            if (!checkIfExists) {
                let apt = new task_planning_table_entity_1.TaskPlanningTable();
                const session = await this.sessionmasterTableService.findActiveSession();
                const task = await this.taskTableService.findOne(createTaskPlanningTableInput.taskId);
                const activity = await this.activityTableService.findOne(createTaskPlanningTableInput.activityId);
                const userTable = await this.userCollectionService.findOneByUsername(user.username);
                apt.SessionmasterTable = session;
                apt.TaskTable = task;
                apt.ActivityTable = activity;
                apt.UserTable = userTable;
                apt.nosToBePerformed = createTaskPlanningTableInput.nosToBePerformed;
                apt.taskType = createTaskPlanningTableInput.taskType;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.halfNo = createTaskPlanningTableInput.halfNo;
                await this.taskPlanningTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Submitted Successfully."
                });
            }
            else {
                let apt = checkIfExists;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.nosToBePerformed = createTaskPlanningTableInput.nosToBePerformed;
                await this.taskPlanningTableRepository.save(apt);
                data.push({
                    status: true,
                    status_text: "Successfully Updated"
                });
            }
        }
        return {
            data: data
        };
    }
    async checkIfExistsHalfYearly(createTaskPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.taskPlanningTableRepository.findOne({
            where: {
                TaskTable: {
                    taskId: createTaskPlanningTableInput.taskId
                },
                ActivityTable: {
                    activityId: createTaskPlanningTableInput.activityId
                },
                taskType: createTaskPlanningTableInput.taskType,
                halfNo: createTaskPlanningTableInput.halfNo,
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return result;
    }
    async checkIfExists(createTaskPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.taskPlanningTableRepository.findOne({
            where: {
                TaskTable: {
                    taskId: createTaskPlanningTableInput.taskId
                },
                ActivityTable: {
                    activityId: createTaskPlanningTableInput.activityId
                },
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        if (result) {
            return true;
        }
        else {
            return false;
        }
    }
    async checkIfExistsMonthly(createTaskPlanningTableInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        let result = await this.taskPlanningTableRepository.findOne({
            where: {
                TaskTable: {
                    taskId: createTaskPlanningTableInput.taskId
                },
                ActivityTable: {
                    activityId: createTaskPlanningTableInput.activityId
                },
                taskType: createTaskPlanningTableInput.taskType,
                month: createTaskPlanningTableInput.month,
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId: session.sessionId
                }
            }
        });
        return result;
    }
    async createMonthly(createTaskPlanningTableBulkInput, user) {
        const session = await this.sessionmasterTableService.findActiveSession();
        if (!session) {
            return {
                status: false,
                status_text: "No active session found"
            };
        }
        let data = [];
        for (const createTaskPlanningTableInput of createTaskPlanningTableBulkInput.data) {
            const checkIfExists = await this.checkIfExistsMonthly(createTaskPlanningTableInput, user);
            if (!checkIfExists) {
                let apt = new task_planning_table_entity_1.TaskPlanningTable();
                const session = await this.sessionmasterTableService.findActiveSession();
                const task = await this.taskTableService.findOne(createTaskPlanningTableInput.taskId);
                const activity = await this.activityTableService.findOne(createTaskPlanningTableInput.activityId);
                const userTable = await this.userCollectionService.findOneByUsername(user.username);
                apt.SessionmasterTable = session;
                apt.TaskTable = task;
                apt.ActivityTable = activity;
                apt.UserTable = userTable;
                apt.nosToBePerformed = createTaskPlanningTableInput.nosToBePerformed;
                apt.taskType = createTaskPlanningTableInput.taskType;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.month = createTaskPlanningTableInput.month;
                await this.taskPlanningTableRepository.save(apt);
                let perviousMonth = (0, moment_1.default)(createTaskPlanningTableInput.month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
                await this.taskAchievementsTableService.createSingle({
                    activityId: createTaskPlanningTableInput.activityId,
                    taskType: createTaskPlanningTableInput.taskType,
                    month: perviousMonth,
                    nosPerformed: createTaskPlanningTableInput.nosPerformed,
                    taskId: createTaskPlanningTableInput.taskId
                }, user);
                data.push({
                    status: true,
                    status_text: "Submitted Successfully."
                });
            }
            else {
                let apt = checkIfExists;
                apt.isVerified = 0;
                apt.isActive = 1;
                apt.nosToBePerformed = createTaskPlanningTableInput.nosToBePerformed;
                await this.taskPlanningTableRepository.save(apt);
                let perviousMonth = (0, moment_1.default)(createTaskPlanningTableInput.month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
                await this.taskAchievementsTableService.createSingle({
                    activityId: createTaskPlanningTableInput.activityId,
                    taskType: createTaskPlanningTableInput.taskType,
                    month: perviousMonth,
                    nosPerformed: createTaskPlanningTableInput.nosPerformed,
                    taskId: createTaskPlanningTableInput.taskId
                }, user);
                data.push({
                    status: true,
                    status_text: "Updated Successfully"
                });
            }
        }
        return {
            data: data
        };
    }
    async findAllTaskPlannerBySessionAndUser(user, sessionId, taskType) {
        let result = await this.taskPlanningTableRepository.find({
            where: {
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId
                },
                taskType
            },
            relations: {
                TaskTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        let index = 0;
        for (const el of result) {
            let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosAnnually(el.TaskTable.taskId, el.ActivityTable.activityId, user, sessionId);
            result[index]['nosPerformed'] = nosPerformed;
            index++;
        }
        return result;
    }
    async findAllTaskPlannerBySessionAndUserVerification(userId, sessionId, taskType) {
        let result = await this.taskPlanningTableRepository.find({
            where: {
                UserTable: {
                    id: userId
                },
                SessionmasterTable: {
                    sessionId
                },
                taskType
            },
            relations: {
                TaskTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        let index = 0;
        for (const el of result) {
            let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosAnnually(el.TaskTable.taskId, el.ActivityTable.activityId, el.UserTable, sessionId);
            result[index]['nosPerformed'] = nosPerformed;
            index++;
        }
        return result;
    }
    async findHalfData(user, sessionId, taskType, halfNo) {
        let result = await this.taskPlanningTableRepository.find({
            where: {
                UserTable: {
                    username: user.username
                },
                halfNo,
                SessionmasterTable: {
                    sessionId
                },
                taskType
            },
            relations: {
                TaskTable: true,
                ActivityTable: true,
                SessionmasterTable: true,
                UserTable: true
            }
        });
        return result;
    }
    async findAllTaskPlannerHalfYearlyBySessionAndUser(user, sessionId, taskType, halfNo) {
        if (taskType == "HALF-YEARLY") {
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    halfNo,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let annualData = await this.findAllTaskPlannerBySessionAndUser(user, sessionId, "ANNUAL");
                if (halfNo == 1) {
                    let data = [];
                    for (const el of annualData) {
                        let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosHalfYearly(1, el.TaskTable.taskId, el.ActivityTable.activityId, user, sessionId);
                        data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(el.nosToBePerformed / 2), nosPerformed: nosPerformed, isSubmitted: false }));
                    }
                    return data;
                }
                if (halfNo == 2) {
                    let firstHalfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", 1);
                    if (firstHalfData.length == 0) {
                        let data = [];
                        for (const el of annualData) {
                            let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosHalfYearly(2, el.TaskTable.taskId, el.ActivityTable.activityId, user, sessionId);
                            data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(el.nosToBePerformed), nosPerformed, isSubmitted: false }));
                        }
                        return data;
                    }
                    else {
                        let data = [];
                        for (const el of annualData) {
                            let ff = firstHalfData.find(el1 => el1.TaskTable.taskId === el.TaskTable.taskId && el1.SessionmasterTable.sessionId === el.SessionmasterTable.sessionId && el1.UserTable.username === el.UserTable.username);
                            let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.TaskTable.taskId, el.ActivityTable.activityId, user, sessionId);
                            if (ff) {
                                let calculated = el.nosToBePerformed - ff.nosToBePerformed;
                                if (calculated < 0) {
                                    calculated = 0;
                                }
                                data.push(Object.assign(Object.assign({}, el), { nosToBePerformed: Math.round(calculated), nosPerformed, isSubmitted: false }));
                            }
                            else {
                                data.push(Object.assign(Object.assign({}, el), { nosPerformed, isSubmitted: false }));
                            }
                        }
                        return data;
                    }
                }
            }
            else {
                let index = 0;
                for (const el of result) {
                    let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.TaskTable.taskId, el.ActivityTable.activityId, user, sessionId);
                    result[index]['nosPerformed'] = nosPerformed;
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    async findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, taskType, halfNo) {
        if (taskType == "HALF-YEARLY") {
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    halfNo,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const el of result) {
                let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosHalfYearly(el.halfNo, el.TaskTable.taskId, el.ActivityTable.activityId, el.UserTable, sessionId);
                result[index]['nosPerformed'] = nosPerformed;
                result[index]['isSubmitted'] = true;
                index++;
            }
            return result;
        }
    }
    async findAllTaskPlannerMonthlyBySessionAndUser(user, sessionId, taskType, month) {
        if (taskType == "MONTHLY") {
            let previousMonth = (0, moment_1.default)(month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let hh = (0, moment_1.default)(month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                let halfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", halfNo);
                let data = [];
                for (const hd of halfData) {
                    let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, hd.TaskTable.taskId, hd.ActivityTable.activityId, user);
                    data.push(Object.assign(Object.assign({}, hd), { nosToBePerformed: Math.round(hd.nosToBePerformed / 6), nosPerformed: nosPerformed, isSubmitted: false }));
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, res.TaskTable.taskId, res.ActivityTable.activityId, user);
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    async findAllTaskPlannerMonthlyBySessionAndUserVerification(userId, sessionId, taskType, month) {
        if (taskType == "MONTHLY") {
            let previousMonth = (0, moment_1.default)(month, "MM-YYYY").subtract(1, 'M').format("MM-YYYY");
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            let index = 0;
            for (const res of result) {
                result[index]['nosPerformed'] = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(previousMonth, res.TaskTable.taskId, res.ActivityTable.activityId, res.UserTable);
                result[index]['isSubmitted'] = true;
                index++;
            }
            return result;
        }
    }
    async findAllTaskPlannerMonthlyBySessionAndUserDashboard(user, sessionId, taskType, month) {
        if (taskType == "MONTHLY") {
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        username: user.username
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let hh = (0, moment_1.default)(month, "MM-YYYY").format("MM");
                let halfNo = 1;
                if (parseFloat(hh) >= 4 && parseFloat(hh) <= 9) {
                    halfNo = 1;
                }
                else {
                    halfNo = 2;
                }
                let halfData = await this.findHalfData(user, sessionId, "HALF-YEARLY", halfNo);
                let data = [];
                for (const hd of halfData) {
                    let nosPerformed = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(month, hd.TaskTable.taskId, hd.ActivityTable.activityId, user);
                    data.push(Object.assign(Object.assign({}, hd), { nosToBePerformed: Math.round(hd.nosToBePerformed / 6), nosPerformed: nosPerformed, isSubmitted: false }));
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(month, res.TaskTable.taskId, res.ActivityTable.activityId, user);
                    result[index]['isSubmitted'] = true;
                    index++;
                }
                return result;
            }
        }
    }
    findAll() {
        return `This action returns all activityPlanningTable`;
    }
    findOne(id) {
        return `This action returns a #${id} activityPlanningTable`;
    }
    async findAllActivityListForUser(user, sessionId) {
        let result = await this.taskPlanningTableRepository.find({
            where: {
                UserTable: {
                    username: user.username
                },
                SessionmasterTable: {
                    sessionId
                }
            },
            relations: {
                ActivityTable: {
                    ThemeTable: true
                }
            }
        });
        let res = result.map(el => el.ActivityTable);
        return res;
    }
    async update(taskPlanningId, updateTaskPlanningTableInput) {
        let res = await this.taskPlanningTableRepository.findOne({
            where: {
                taskPlanningId
            }
        });
        if (res) {
            const session = await this.sessionmasterTableService.findActiveSession();
            const task = await this.taskTableService.findOne(updateTaskPlanningTableInput.taskId);
            const activity = await this.activityTableService.findOne(updateTaskPlanningTableInput.activityId);
            res.SessionmasterTable = session;
            res.TaskTable = task;
            res.ActivityTable = activity;
            res.nosToBePerformed = updateTaskPlanningTableInput.nosToBePerformed;
            res.taskType = updateTaskPlanningTableInput.taskType;
            await this.taskPlanningTableRepository.save(res);
            return {
                status: true,
                status_text: "Submitted Successfully."
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async remove(taskPlanningId) {
        let res = await this.taskPlanningTableRepository.findOne({
            where: {
                taskPlanningId
            }
        });
        if (res) {
            await this.taskPlanningTableRepository.remove(res);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async updateTaskStatus(taskPlanningVerificationDtoInput, user) {
        for (const el of taskPlanningVerificationDtoInput.data) {
            let res = await this.taskPlanningTableRepository.findOne({
                where: {
                    taskPlanningId: el
                }
            });
            if (res) {
                res.isVerified = 1;
                res.verifiedOn = (0, moment_1.default)().format("DD-MM-YYYY h:m:s a");
                res.verifiedBy = user.id;
                res.isEditable = 0;
                await this.taskPlanningTableRepository.save(res);
            }
        }
        return {
            status: true,
            status_text: "Successfully Updated"
        };
    }
    async toggleIsEditable(taskPlanningId) {
        let res = await this.taskPlanningTableRepository.findOne({
            where: {
                taskPlanningId
            }
        });
        if (res) {
            let oldStatus = res.isEditable;
            let newStatus = 0;
            if (oldStatus == 1) {
                newStatus = 0;
            }
            if (oldStatus == 0) {
                newStatus = 1;
            }
            res.isEditable = newStatus;
            let result = await this.taskPlanningTableRepository.save(res);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found"
            };
        }
    }
    async findAllTaskPlannerMonthlyBySessionAndUserReports(userId, sessionId, taskType, month) {
        if (taskType == "MONTHLY") {
            let result = await this.taskPlanningTableRepository.find({
                where: {
                    UserTable: {
                        id: userId
                    },
                    month,
                    SessionmasterTable: {
                        sessionId
                    },
                    taskType
                },
                relations: {
                    TaskTable: true,
                    ActivityTable: true,
                    SessionmasterTable: true,
                    UserTable: true
                }
            });
            if (result.length == 0) {
                let data = await this.taskAchievementsTableService.fetchAchievementNosOfMonthIfNotPresent(month, userId, sessionId);
                let index1 = 0;
                for (const res of data) {
                    let annualData = await this.taskPlanningTableRepository.findOne({
                        where: {
                            UserTable: {
                                id: userId,
                            },
                            SessionmasterTable: {
                                sessionId
                            },
                            taskType: "ANNUAL",
                            TaskTable: {
                                taskId: res.TaskTable.taskId
                            }
                        }
                    });
                    data[index1]['annualTarget'] = annualData === null || annualData === void 0 ? void 0 : annualData.nosToBePerformed;
                    data[index1]['isSubmitted'] = true;
                    data[index1]['nosToBePerformed'] = 0;
                    index1++;
                }
                return data;
            }
            else {
                let index = 0;
                for (const res of result) {
                    result[index]['nosPerformed'] = await this.taskAchievementsTableService.fetchAchievementNosOfMonth(month, res.TaskTable.taskId, res.ActivityTable.activityId, res.UserTable);
                    let annualData = await this.taskPlanningTableRepository.findOne({
                        where: {
                            UserTable: {
                                id: userId,
                            },
                            SessionmasterTable: {
                                sessionId
                            },
                            taskType: "ANNUAL",
                            TaskTable: {
                                taskId: res.TaskTable.taskId
                            }
                        }
                    });
                    result[index]['annualTarget'] = annualData === null || annualData === void 0 ? void 0 : annualData.nosToBePerformed;
                    result[index]['isSubmitted'] = true;
                    index++;
                }
            }
            return result;
        }
    }
};
exports.TaskPlanningTableService = TaskPlanningTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(task_planning_table_entity_1.TaskPlanningTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __param(2, (0, common_1.Inject)((0, common_1.forwardRef)(() => task_table_service_1.TaskTableService))),
    __param(3, (0, common_1.Inject)((0, common_1.forwardRef)(() => activity_table_service_1.ActivityTableService))),
    __param(4, (0, common_1.Inject)((0, common_1.forwardRef)(() => sessionmaster_table_service_1.SessionmasterTableService))),
    __param(5, (0, common_1.Inject)((0, common_1.forwardRef)(() => user_collection_service_1.UserCollectionService))),
    __param(6, (0, common_1.Inject)((0, common_1.forwardRef)(() => task_achievements_table_service_1.TaskAchievementsTableService))),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        task_table_service_1.TaskTableService,
        activity_table_service_1.ActivityTableService,
        sessionmaster_table_service_1.SessionmasterTableService,
        user_collection_service_1.UserCollectionService,
        task_achievements_table_service_1.TaskAchievementsTableService])
], TaskPlanningTableService);
