import { TaskTableService } from './task-table.service';
import { TaskTable } from './entities/task-table.entity';
import { CreateTaskTableInput } from './dto/create-task-table.input';
import { UpdateTaskTableInput } from './dto/update-task-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_TASK_ADD = "NEW_TASK_ADD";
export declare class TaskTableResolver {
    private readonly taskTableService;
    private pubSub;
    constructor(taskTableService: TaskTableService, pubSub: RedisPubSub);
    createTaskTable(createTaskTableInput: CreateTaskTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TaskTable;
    }>;
    findAllTasks(): Promise<TaskTable[]>;
    findOneTask(taskId: number): Promise<TaskTable>;
    updateTaskTable(updateTaskTableInput: UpdateTaskTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TaskTable;
    }>;
    removeTaskTable(taskId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    taskSubscription(): AsyncIterator<unknown, any, undefined>;
}
