"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskTableResolver = exports.NEW_TASK_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const task_table_service_1 = require("./task-table.service");
const task_table_entity_1 = require("./entities/task-table.entity");
const create_task_table_input_1 = require("./dto/create-task-table.input");
const update_task_table_input_1 = require("./dto/update-task-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const task_table_return_type_1 = require("./types/task-table-return.type");
const task_table_type_1 = require("./types/task-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_TASK_ADD = "NEW_TASK_ADD";
let TaskTableResolver = exports.TaskTableResolver = class TaskTableResolver {
    constructor(taskTableService, pubSub) {
        this.taskTableService = taskTableService;
        this.pubSub = pubSub;
    }
    createTaskTable(createTaskTableInput) {
        return this.taskTableService.create(createTaskTableInput);
    }
    findAllTasks() {
        return this.taskTableService.findAll();
    }
    findOneTask(taskId) {
        return this.taskTableService.findOne(taskId);
    }
    updateTaskTable(updateTaskTableInput) {
        return this.taskTableService.update(updateTaskTableInput.taskId, updateTaskTableInput);
    }
    removeTaskTable(taskId) {
        return this.taskTableService.remove(taskId);
    }
    taskSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_TASK_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_table_return_type_1.TaskTableReturnType),
    __param(0, (0, graphql_1.Args)('createTaskTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_task_table_input_1.CreateTaskTableInput]),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "createTaskTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [task_table_type_1.TaskTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "findAllTasks", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => task_table_type_1.TaskTableType),
    __param(0, (0, graphql_1.Args)('taskId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "findOneTask", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_table_return_type_1.TaskTableReturnType),
    __param(0, (0, graphql_1.Args)('updateTaskTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_task_table_input_1.UpdateTaskTableInput]),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "updateTaskTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => task_table_return_type_1.TaskTableReturnType),
    __param(0, (0, graphql_1.Args)('taskId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "removeTaskTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TaskTableResolver.prototype, "taskSubscription", null);
exports.TaskTableResolver = TaskTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => task_table_entity_1.TaskTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [task_table_service_1.TaskTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], TaskTableResolver);
