import { CreateTaskTableInput } from './dto/create-task-table.input';
import { UpdateTaskTableInput } from './dto/update-task-table.input';
import { TaskTable } from './entities/task-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { ActivityTableService } from 'src/activity-table/activity-table.service';
export declare const NEW_TASK_ADD = "NEW_TASK_ADD";
export declare class TaskTableService {
    private readonly taskTableRepository;
    private pubSub;
    private readonly activityTableService;
    constructor(taskTableRepository: Repository<TaskTable>, pubSub: RedisPubSub, activityTableService: ActivityTableService);
    create(createTaskTableInput: CreateTaskTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TaskTable;
    }>;
    checkIfExists(taskName: string, unitOfMeasurement: string, activityId: number): Promise<boolean>;
    getCount(): Promise<number>;
    findAll(): Promise<TaskTable[]>;
    findOne(taskId: number): Promise<TaskTable>;
    update(taskId: number, updateTaskTableInput: UpdateTaskTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TaskTable;
    }>;
    remove(taskId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
