"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskTableService = exports.NEW_TASK_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const task_table_entity_1 = require("./entities/task-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const activity_table_service_1 = require("../activity-table/activity-table.service");
exports.NEW_TASK_ADD = "NEW_TASK_ADD";
let TaskTableService = exports.TaskTableService = class TaskTableService {
    constructor(taskTableRepository, pubSub, activityTableService) {
        this.taskTableRepository = taskTableRepository;
        this.pubSub = pubSub;
        this.activityTableService = activityTableService;
    }
    async create(createTaskTableInput) {
        let checkIfExists = await this.checkIfExists(createTaskTableInput.taskName, createTaskTableInput.unitOfMeasurement, createTaskTableInput.activityId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new task_table_entity_1.TaskTable();
            dd.taskName = createTaskTableInput.taskName;
            dd.unitOfMeasurement = createTaskTableInput.unitOfMeasurement;
            dd.lsCode = createTaskTableInput.lsCode;
            dd.taskSubType = createTaskTableInput.taskSubType;
            let activity = await this.activityTableService.findOne(createTaskTableInput.activityId);
            dd.ActivityTable = activity;
            let result = await this.taskTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_TASK_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(taskName, unitOfMeasurement, activityId) {
        let result = await this.taskTableRepository.count({
            where: {
                taskName: taskName,
                unitOfMeasurement: unitOfMeasurement,
                ActivityTable: {
                    activityId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getCount() {
        return await this.taskTableRepository.count();
    }
    async findAll() {
        return await this.taskTableRepository.find({
            relations: {
                ActivityTable: true
            }
        });
    }
    async findOne(taskId) {
        return await this.taskTableRepository.findOne({
            where: {
                taskId: taskId
            },
            relations: {
                ActivityTable: true
            }
        });
    }
    async update(taskId, updateTaskTableInput) {
        let result = await this.taskTableRepository.findOne({
            where: {
                taskId: taskId
            }
        });
        if (result) {
            result.taskName = updateTaskTableInput.taskName;
            result.unitOfMeasurement = updateTaskTableInput.unitOfMeasurement;
            result.lsCode = updateTaskTableInput.lsCode;
            result.taskSubType = updateTaskTableInput.taskSubType;
            let activity = await this.activityTableService.findOne(updateTaskTableInput.activityId);
            result.ActivityTable = activity;
            let r = await this.taskTableRepository.save(result);
            this.pubSub.publish(exports.NEW_TASK_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(taskId) {
        let result = await this.taskTableRepository.findOne({
            where: {
                taskId: taskId
            }
        });
        if (result) {
            await this.taskTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_TASK_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.TaskTableService = TaskTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(task_table_entity_1.TaskTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        activity_table_service_1.ActivityTableService])
], TaskTableService);
