import { ThemeTableService } from './theme-table.service';
import { ThemeTable } from './entities/theme-table.entity';
import { CreateThemeTableInput } from './dto/create-theme-table.input';
import { UpdateThemeTableInput } from './dto/update-theme-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_THEME_ADD = "NEW_THEME_ADD";
export declare class ThemeTableResolver {
    private readonly themeTableService;
    private pubSub;
    constructor(themeTableService: ThemeTableService, pubSub: RedisPubSub);
    createThemeTable(createThemeTableInput: CreateThemeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ThemeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllThemes(): Promise<ThemeTable[]>;
    findOneTheme(themeId: number): Promise<ThemeTable>;
    updateThemeTable(updateThemeTableInput: UpdateThemeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ThemeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeThemeTable(themeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    themeSubscription(): AsyncIterator<unknown, any, undefined>;
}
