"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThemeTableResolver = exports.NEW_THEME_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const theme_table_service_1 = require("./theme-table.service");
const theme_table_entity_1 = require("./entities/theme-table.entity");
const create_theme_table_input_1 = require("./dto/create-theme-table.input");
const update_theme_table_input_1 = require("./dto/update-theme-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const theme_table_return_type_1 = require("./types/theme-table-return.type");
const theme_table_type_1 = require("./types/theme-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_THEME_ADD = "NEW_THEME_ADD";
let ThemeTableResolver = exports.ThemeTableResolver = class ThemeTableResolver {
    constructor(themeTableService, pubSub) {
        this.themeTableService = themeTableService;
        this.pubSub = pubSub;
    }
    createThemeTable(createThemeTableInput) {
        return this.themeTableService.create(createThemeTableInput);
    }
    findAllThemes() {
        return this.themeTableService.findAll();
    }
    findOneTheme(themeId) {
        return this.themeTableService.findOne(themeId);
    }
    updateThemeTable(updateThemeTableInput) {
        return this.themeTableService.update(updateThemeTableInput.themeId, updateThemeTableInput);
    }
    removeThemeTable(themeId) {
        return this.themeTableService.remove(themeId);
    }
    themeSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_THEME_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => theme_table_return_type_1.ThemeTableReturnType),
    __param(0, (0, graphql_1.Args)('createThemeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_theme_table_input_1.CreateThemeTableInput]),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "createThemeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [theme_table_type_1.ThemeTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "findAllThemes", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.USER, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => theme_table_type_1.ThemeTableType),
    __param(0, (0, graphql_1.Args)('themeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "findOneTheme", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => theme_table_return_type_1.ThemeTableReturnType),
    __param(0, (0, graphql_1.Args)('updateThemeTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_theme_table_input_1.UpdateThemeTableInput]),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "updateThemeTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => theme_table_return_type_1.ThemeTableReturnType),
    __param(0, (0, graphql_1.Args)('themeId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "removeThemeTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], ThemeTableResolver.prototype, "themeSubscription", null);
exports.ThemeTableResolver = ThemeTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => theme_table_entity_1.ThemeTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [theme_table_service_1.ThemeTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], ThemeTableResolver);
