import { CreateThemeTableInput } from './dto/create-theme-table.input';
import { UpdateThemeTableInput } from './dto/update-theme-table.input';
import { ThemeTable } from './entities/theme-table.entity';
import { Repository } from 'typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_THEME_ADD = "NEW_THEME_ADD";
export declare class ThemeTableService {
    private readonly themeTableRepository;
    private pubSub;
    constructor(themeTableRepository: Repository<ThemeTable>, pubSub: RedisPubSub);
    create(createThemeTableInput: CreateThemeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ThemeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createThemeTableInput: CreateThemeTableInput): Promise<number>;
    findAll(): Promise<ThemeTable[]>;
    findOne(themeId: number): Promise<ThemeTable>;
    update(themeId: number, updateThemeTableInput: UpdateThemeTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ThemeTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(themeId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
