"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ThemeTableService = exports.NEW_THEME_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const theme_table_entity_1 = require("./entities/theme-table.entity");
const typeorm_2 = require("typeorm");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
exports.NEW_THEME_ADD = "NEW_THEME_ADD";
let ThemeTableService = exports.ThemeTableService = class ThemeTableService {
    constructor(themeTableRepository, pubSub) {
        this.themeTableRepository = themeTableRepository;
        this.pubSub = pubSub;
    }
    async create(createThemeTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createThemeTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new theme_table_entity_1.ThemeTable();
            st.themeName = createThemeTableInput.themeName;
            let result = await this.themeTableRepository.save(st);
            this.pubSub.publish(exports.NEW_THEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createThemeTableInput) {
        let result = await this.themeTableRepository.count({
            where: {
                themeName: createThemeTableInput.themeName
            }
        });
        return result;
    }
    async findAll() {
        return await this.themeTableRepository.find();
    }
    async findOne(themeId) {
        return await this.themeTableRepository.findOne({
            where: {
                themeId
            }
        });
    }
    async update(themeId, updateThemeTableInput) {
        let result = await this.findOne(themeId);
        if (result) {
            result.themeName = updateThemeTableInput.themeName;
            let updatedResult = await this.themeTableRepository.save(result);
            this.pubSub.publish(exports.NEW_THEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(themeId) {
        let result = await this.findOne(themeId);
        if (result) {
            await this.themeTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_THEME_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.ThemeTableService = ThemeTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(theme_table_entity_1.ThemeTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], ThemeTableService);
