import { ToolsTableService } from './tools-table.service';
import { ToolsTable } from './entities/tools-table.entity';
import { CreateToolsTableInput } from './dto/create-tools-table.input';
import { UpdateToolsTableInput } from './dto/update-tools-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_TOOLS_ADD = "NEW_TOOLS_ADD";
export declare class ToolsTableResolver {
    private readonly toolsTableService;
    private pubSub;
    constructor(toolsTableService: ToolsTableService, pubSub: RedisPubSub);
    createToolsTable(createToolsTableInput: CreateToolsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ToolsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllTypeOfTools(): Promise<ToolsTable[]>;
    findOneTypeOfTool(toolsId: number): Promise<ToolsTable>;
    updateToolsTable(updateToolsTableInput: UpdateToolsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ToolsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeToolsTable(toolsId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toolsSubscription(): AsyncIterator<unknown, any, undefined>;
}
