import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateToolsTableInput } from './dto/create-tools-table.input';
import { UpdateToolsTableInput } from './dto/update-tools-table.input';
import { ToolsTable } from './entities/tools-table.entity';
export declare const NEW_TOOLS_ADD = "NEW_TOOLS_ADD";
export declare class ToolsTableService {
    private readonly toolsTableRepository;
    private pubSub;
    constructor(toolsTableRepository: Repository<ToolsTable>, pubSub: RedisPubSub);
    create(createToolsTableInput: CreateToolsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ToolsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createToolsTableInput: CreateToolsTableInput): Promise<ToolsTable>;
    checkIfAlreadyExists(createToolsTableInput: CreateToolsTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<ToolsTable[]>;
    findOne(toolsId: number): Promise<ToolsTable>;
    update(toolsId: number, updateToolsTableInput: UpdateToolsTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: ToolsTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(toolsId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
