"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolsTableService = exports.NEW_TOOLS_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const tools_table_entity_1 = require("./entities/tools-table.entity");
exports.NEW_TOOLS_ADD = "NEW_TOOLS_ADD";
let ToolsTableService = exports.ToolsTableService = class ToolsTableService {
    constructor(toolsTableRepository, pubSub) {
        this.toolsTableRepository = toolsTableRepository;
        this.pubSub = pubSub;
    }
    async create(createToolsTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createToolsTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new tools_table_entity_1.ToolsTable();
            st.toolsName = createToolsTableInput.toolsName;
            st.toolsLocalName = createToolsTableInput.toolsLocalName;
            let result = await this.toolsTableRepository.save(st);
            this.pubSub.publish(exports.NEW_TOOLS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createToolsTableInput) {
        let checkIfAlreadyExists = await this.toolsTableRepository.findOne({
            where: {
                toolsName: createToolsTableInput.toolsName.trim(),
                toolsLocalName: createToolsTableInput.toolsLocalName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new tools_table_entity_1.ToolsTable();
            st.toolsName = createToolsTableInput.toolsName.trim();
            st.toolsLocalName = createToolsTableInput.toolsLocalName.trim();
            let result = await this.toolsTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createToolsTableInput) {
        let result = await this.toolsTableRepository.count({
            where: {
                toolsName: createToolsTableInput.toolsName,
                toolsLocalName: createToolsTableInput.toolsLocalName
            }
        });
        return result;
    }
    async getCount() {
        return await this.toolsTableRepository.count();
    }
    async findAll() {
        return await this.toolsTableRepository.find();
    }
    async findOne(toolsId) {
        return await this.toolsTableRepository.findOne({
            where: {
                toolsId
            }
        });
    }
    async update(toolsId, updateToolsTableInput) {
        let result = await this.findOne(toolsId);
        if (result) {
            result.toolsName = updateToolsTableInput.toolsName;
            result.toolsLocalName = updateToolsTableInput.toolsLocalName;
            let updatedResult = await this.toolsTableRepository.save(result);
            this.pubSub.publish(exports.NEW_TOOLS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(toolsId) {
        let result = await this.findOne(toolsId);
        if (result) {
            await this.toolsTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_TOOLS_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.ToolsTableService = ToolsTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(tools_table_entity_1.ToolsTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], ToolsTableService);
