import { TrainingTableService } from './training-table.service';
import { TrainingTable } from './entities/training-table.entity';
import { CreateTrainingTableInput } from './dto/create-training-table.input';
import { UpdateTrainingTableInput } from './dto/update-training-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_TRAINING_ADD = "NEW_TRAINING_ADD";
export declare class TrainingTableResolver {
    private readonly trainingTableService;
    private pubSub;
    constructor(trainingTableService: TrainingTableService, pubSub: RedisPubSub);
    createTrainingTable(createTrainingTableInput: CreateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllTraining(): Promise<TrainingTable[]>;
    findOne(trainingId: number): Promise<TrainingTable>;
    updateTrainingTable(updateTrainingTableInput: UpdateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeTrainingTable(trainingId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    trainingSubscription(): AsyncIterator<unknown, any, undefined>;
}
