import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateTrainingTableInput } from './dto/create-training-table.input';
import { UpdateTrainingTableInput } from './dto/update-training-table.input';
import { TrainingTable } from './entities/training-table.entity';
export declare const NEW_TRAINING_ADD = "NEW_TRAINING_ADD";
export declare class TrainingTableService {
    private readonly trainingTableRepository;
    private pubSub;
    constructor(trainingTableRepository: Repository<TrainingTable>, pubSub: RedisPubSub);
    create(createTrainingTableInput: CreateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createTrainingTableInput: CreateTrainingTableInput): Promise<TrainingTable>;
    checkIfAlreadyExists(createTrainingTableInput: CreateTrainingTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<TrainingTable[]>;
    findOne(trainingId: number): Promise<TrainingTable>;
    update(trainingId: number, updateTrainingTableInput: UpdateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(trainingId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
