"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TrainingTableService = exports.NEW_TRAINING_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const training_table_entity_1 = require("./entities/training-table.entity");
exports.NEW_TRAINING_ADD = "NEW_TRAINING_ADD";
let TrainingTableService = exports.TrainingTableService = class TrainingTableService {
    constructor(trainingTableRepository, pubSub) {
        this.trainingTableRepository = trainingTableRepository;
        this.pubSub = pubSub;
    }
    async create(createTrainingTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createTrainingTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new training_table_entity_1.TrainingTable();
            st.trainingName = createTrainingTableInput.trainingName;
            let result = await this.trainingTableRepository.save(st);
            this.pubSub.publish(exports.NEW_TRAINING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createTrainingTableInput) {
        let checkIfAlreadyExists = await this.trainingTableRepository.findOne({
            where: {
                trainingName: createTrainingTableInput.trainingName.trim()
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new training_table_entity_1.TrainingTable();
            st.trainingName = createTrainingTableInput.trainingName.trim();
            let result = await this.trainingTableRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createTrainingTableInput) {
        let result = await this.trainingTableRepository.count({
            where: {
                trainingName: createTrainingTableInput.trainingName
            }
        });
        return result;
    }
    async getCount() {
        return await this.trainingTableRepository.count();
    }
    async findAll() {
        return await this.trainingTableRepository.find();
    }
    async findOne(trainingId) {
        return await this.trainingTableRepository.findOne({
            where: {
                trainingId
            }
        });
    }
    async update(trainingId, updateTrainingTableInput) {
        let result = await this.findOne(trainingId);
        if (result) {
            result.trainingName = updateTrainingTableInput.trainingName;
            let updatedResult = await this.trainingTableRepository.save(result);
            this.pubSub.publish(exports.NEW_TRAINING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(trainingId) {
        let result = await this.findOne(trainingId);
        if (result) {
            await this.trainingTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_TRAINING_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.TrainingTableService = TrainingTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(training_table_entity_1.TrainingTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], TrainingTableService);
