"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TrainingTableResolver = exports.NEW_TRAINING_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const training_table_service_1 = require("./training-table.service");
const training_table_entity_1 = require("./entities/training-table.entity");
const create_training_table_input_1 = require("./dto/create-training-table.input");
const update_training_table_input_1 = require("./dto/update-training-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const training_table_return_type_1 = require("./types/training-table-return.type");
const training_table_type_1 = require("./types/training-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
const training_table_adoption_type_1 = require("./types/training-table-adoption.type");
exports.NEW_TRAINING_ADD = "NEW_TRAINING_ADD";
let TrainingTableResolver = exports.TrainingTableResolver = class TrainingTableResolver {
    constructor(trainingTableService, pubSub) {
        this.trainingTableService = trainingTableService;
        this.pubSub = pubSub;
    }
    createTrainingTable(createTrainingTableInput) {
        return this.trainingTableService.create(createTrainingTableInput);
    }
    findAllTraining() {
        return this.trainingTableService.findAll();
    }
    findAllTrainingForApp() {
        return this.trainingTableService.findAllTrainingForApp();
    }
    findOne(trainingId) {
        return this.trainingTableService.findOne(trainingId);
    }
    updateTrainingTable(updateTrainingTableInput) {
        return this.trainingTableService.update(updateTrainingTableInput.trainingId, updateTrainingTableInput);
    }
    removeTrainingTable(trainingId) {
        return this.trainingTableService.remove(trainingId);
    }
    trainingSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_TRAINING_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => training_table_return_type_1.TrainingTableReturnType),
    __param(0, (0, graphql_1.Args)('createTrainingTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_training_table_input_1.CreateTrainingTableInput]),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "createTrainingTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [training_table_type_1.TrainingTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "findAllTraining", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [training_table_adoption_type_1.TrainingTableAdoptionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "findAllTrainingForApp", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => training_table_type_1.TrainingTableType),
    __param(0, (0, graphql_1.Args)('trainingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => training_table_return_type_1.TrainingTableReturnType),
    __param(0, (0, graphql_1.Args)('updateTrainingTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_training_table_input_1.UpdateTrainingTableInput]),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "updateTrainingTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => training_table_return_type_1.TrainingTableReturnType),
    __param(0, (0, graphql_1.Args)('trainingId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "removeTrainingTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TrainingTableResolver.prototype, "trainingSubscription", null);
exports.TrainingTableResolver = TrainingTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => training_table_entity_1.TrainingTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [training_table_service_1.TrainingTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], TrainingTableResolver);
