import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateTrainingTableInput } from './dto/create-training-table.input';
import { UpdateTrainingTableInput } from './dto/update-training-table.input';
import { TrainingTable } from './entities/training-table.entity';
import { PopTableService } from 'src/pop-table/pop-table.service';
import { IncomeSourceTableService } from 'src/income-source-table/income-source-table.service';
import { LivelihoodSourceTableService } from 'src/livelihood-source-table/livelihood-source-table.service';
export declare const NEW_TRAINING_ADD = "NEW_TRAINING_ADD";
export declare class TrainingTableService {
    private readonly trainingTableRepository;
    private pubSub;
    private readonly popTableService;
    private readonly incomeSourceTableService;
    private readonly livelihoodSourceTableService;
    constructor(trainingTableRepository: Repository<TrainingTable>, pubSub: RedisPubSub, popTableService: PopTableService, incomeSourceTableService: IncomeSourceTableService, livelihoodSourceTableService: LivelihoodSourceTableService);
    create(createTrainingTableInput: CreateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createTrainingTableInput: CreateTrainingTableInput): Promise<TrainingTable>;
    checkIfAlreadyExists(createTrainingTableInput: CreateTrainingTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<any>;
    findAllTrainingForApp(): Promise<any>;
    findOne(trainingId: number): Promise<TrainingTable>;
    update(trainingId: number, updateTrainingTableInput: UpdateTrainingTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: TrainingTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(trainingId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
