"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnitCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const unit_collection_service_1 = require("./unit-collection.service");
const unit_collection_entity_1 = require("./entities/unit-collection.entity");
const create_unit_collection_input_1 = require("./dto/create-unit-collection.input");
const update_unit_collection_input_1 = require("./dto/update-unit-collection.input");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const unit_collection_create_type_1 = require("./types/unit-collection-create.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const unit_collection_type_1 = require("./types/unit-collection.type");
let UnitCollectionResolver = class UnitCollectionResolver {
    constructor(unitCollectionService) {
        this.unitCollectionService = unitCollectionService;
    }
    createUnitCollection(user, createUnitCollectionInput) {
        return this.unitCollectionService.create(createUnitCollectionInput);
    }
    findAllUnit() {
        return this.unitCollectionService.findAll();
    }
    updateUnitCollection(updateUnitCollectionInput) {
        return this.unitCollectionService.update(updateUnitCollectionInput.id, updateUnitCollectionInput);
    }
    removeUnitCollection(id) {
        return this.unitCollectionService.remove(id);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => unit_collection_create_type_1.UnitCollectionCreateType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('createUnitCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_unit_collection_input_1.CreateUnitCollectionInput]),
    __metadata("design:returntype", void 0)
], UnitCollectionResolver.prototype, "createUnitCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [unit_collection_type_1.UnitCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], UnitCollectionResolver.prototype, "findAllUnit", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => unit_collection_create_type_1.UnitCollectionCreateType),
    __param(0, (0, graphql_1.Args)('updateUnitCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_unit_collection_input_1.UpdateUnitCollectionInput]),
    __metadata("design:returntype", void 0)
], UnitCollectionResolver.prototype, "updateUnitCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => unit_collection_create_type_1.UnitCollectionCreateType),
    __param(0, (0, graphql_1.Args)('id', { type: () => String })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", void 0)
], UnitCollectionResolver.prototype, "removeUnitCollection", null);
UnitCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => unit_collection_entity_1.UnitCollection),
    __metadata("design:paramtypes", [unit_collection_service_1.UnitCollectionService])
], UnitCollectionResolver);
exports.UnitCollectionResolver = UnitCollectionResolver;
