import { CreateUnitCollectionInput } from './dto/create-unit-collection.input';
import { UpdateUnitCollectionInput } from './dto/update-unit-collection.input';
import { UnitCollection, UnitCollectionDocument } from './entities/unit-collection.entity';
import { Model } from 'mongoose';
export declare class UnitCollectionService {
    private unitRepository;
    constructor(unitRepository: Model<UnitCollectionDocument>);
    create(createUnitCollectionInput: CreateUnitCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: UnitCollection & import("mongoose").Document<any, any, any> & {
            _id: any;
        };
    }>;
    checkIfExists(unitName: string): Promise<boolean>;
    findAll(): Promise<(UnitCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    })[]>;
    findOneById(id: string): Promise<UnitCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
    remove(id: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    update(id: string, updateUnitCollectionInput: UpdateUnitCollectionInput): Promise<any>;
}
