"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnitCollectionService = void 0;
const common_1 = require("@nestjs/common");
const unit_collection_entity_1 = require("./entities/unit-collection.entity");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
let UnitCollectionService = class UnitCollectionService {
    constructor(unitRepository) {
        this.unitRepository = unitRepository;
    }
    async create(createUnitCollectionInput) {
        let checkIfExists = await this.checkIfExists(createUnitCollectionInput.unitName);
        if (!checkIfExists) {
            let cm = new unit_collection_entity_1.UnitCollection();
            cm.unitName = createUnitCollectionInput.unitName;
            let c = await this.unitRepository.create(cm);
            return {
                status: true,
                status_text: 'Successfully Added',
                data: c
            };
        }
        else {
            return {
                status: false,
                status_text: 'Already exists',
                data: null
            };
        }
    }
    async checkIfExists(unitName) {
        let r = await this.unitRepository.count({
            unitName: unitName
        }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    findAll() {
        return this.unitRepository.find().exec();
    }
    async findOneById(id) {
        return await this.unitRepository.findOne({ _id: id }).exec();
    }
    async remove(id) {
        await this.unitRepository.deleteOne({ _id: id });
        return {
            status: true,
            status_text: 'Successfully deleted',
            data: null
        };
    }
    async update(id, updateUnitCollectionInput) {
        let cc = await this.unitRepository.findOne({ _id: id }).exec();
        if (cc) {
            cc.unitName = updateUnitCollectionInput.unitName;
            await this.unitRepository.updateOne({ _id: id }, cc);
            return {
                status: true,
                status_text: 'Successfully Updated',
                data: await this.findOneById(id)
            };
        }
        else {
            return {
                status: false,
                status_text: 'Not found',
                data: null
            };
        }
    }
};
UnitCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(unit_collection_entity_1.UnitCollection.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], UnitCollectionService);
exports.UnitCollectionService = UnitCollectionService;
