"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserTable = void 0;
const access_table_entity_1 = require("../../access-table/entities/access-table.entity");
const assessment_answer_table_entity_1 = require("../../assessment-answer-table/entities/assessment-answer-table.entity");
const course_progression_table_entity_1 = require("../../course-progression-table/entities/course-progression-table.entity");
const course_table_entity_1 = require("../../course-table/entities/course-table.entity");
const designation_table_entity_1 = require("../../designation-table/entities/designation-table.entity");
const discussion_table_entity_1 = require("../../discussion-table/entities/discussion-table.entity");
const organisation_table_entity_1 = require("../../organisation-table/entities/organisation-table.entity");
const subscription_table_entity_1 = require("../../subscription-table/entities/subscription-table.entity");
const typeorm_1 = require("typeorm");
let UserTable = exports.UserTable = class UserTable {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], UserTable.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], UserTable.prototype, "username", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], UserTable.prototype, "password", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], UserTable.prototype, "designation", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], UserTable.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], UserTable.prototype, "email", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], UserTable.prototype, "phone", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, length: 200 }),
    __metadata("design:type", String)
], UserTable.prototype, "currentClass", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, length: 200 }),
    __metadata("design:type", String)
], UserTable.prototype, "classRollNo", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true, length: 200 }),
    __metadata("design:type", String)
], UserTable.prototype, "semester", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], UserTable.prototype, "role", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: true }),
    __metadata("design:type", Boolean)
], UserTable.prototype, "isActive", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => access_table_entity_1.AccessTable, pt => pt.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "AccessTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => subscription_table_entity_1.SubscriptionTable, pt => pt.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "SubscriptionTable", void 0);
__decorate([
    (0, typeorm_1.Column)({ default: null }),
    __metadata("design:type", Number)
], UserTable.prototype, "integratorId", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => designation_table_entity_1.DesignationTable, dt => dt.UserTable),
    (0, typeorm_1.JoinColumn)({ name: "designationId" }),
    __metadata("design:type", designation_table_entity_1.DesignationTable)
], UserTable.prototype, "DesignationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => course_table_entity_1.CourseTable, et => et.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "CourseTable", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(type => organisation_table_entity_1.OrganisationTable, dt => dt.UserTable),
    (0, typeorm_1.JoinColumn)({ name: "organisationId" }),
    __metadata("design:type", organisation_table_entity_1.OrganisationTable)
], UserTable.prototype, "OrganisationTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => assessment_answer_table_entity_1.AssessmentAnswerTable, et => et.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "AssessmentAnswerTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => course_progression_table_entity_1.CourseProgressionTable, et => et.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "CourseProgressionTable", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(type => discussion_table_entity_1.DiscussionTable, et => et.UserTable),
    __metadata("design:type", Array)
], UserTable.prototype, "DiscussionTable", void 0);
__decorate([
    (0, typeorm_1.CreateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], UserTable.prototype, "createdAt", void 0);
__decorate([
    (0, typeorm_1.UpdateDateColumn)({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" }),
    __metadata("design:type", Date)
], UserTable.prototype, "updatedAt", void 0);
exports.UserTable = UserTable = __decorate([
    (0, typeorm_1.Entity)()
], UserTable);
