import { UserCollectionService } from './user-collection.service';
import { UserTable } from './entities/user-collection.entity';
import { CreateUserCollectionInput } from './dto/create-user-collection.input';
import { UpdateUserCollectionInput } from './dto/update-user-collection.input';
import { NewUserAddInput } from './dto/add-nerw-user.input';
import { Connection, EntityManager } from 'typeorm';
import { OtpTableService } from 'src/otp-table/otp-table.service';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { NewRegistrationInput } from './dto/new-registration.input';
export declare const NEW_USER_ADD = "NEW_USER_ADD";
export declare class UserCollectionResolver {
    private readonly userCollectionService;
    private connection;
    private entityManager;
    private readonly otpTableService;
    private pubSub;
    constructor(userCollectionService: UserCollectionService, connection: Connection, entityManager: EntityManager, otpTableService: OtpTableService, pubSub: RedisPubSub);
    createUserCollection(createUserCollectionInput: CreateUserCollectionInput): Promise<{
        status: boolean;
        staus_text: string;
        data: UserTable;
    } | {
        status: boolean;
        staus_text: string;
        data: Promise<UserTable>;
    }>;
    newRegistrationFromApp(newRegistrationInput: NewRegistrationInput): Promise<{
        status: boolean;
        staus_text: string;
        data: UserTable;
    }>;
    findAllUsers(): Promise<UserTable[]>;
    findOne(id: number): Promise<UserTable>;
    checkIfUserIsIntegrator(user: any): Promise<{
        status: boolean;
        data: UserTable[];
    }>;
    updateUserCollection(updateUserCollectionInput: UpdateUserCollectionInput): Promise<{
        status: boolean;
        status_text: string;
        data: UserTable;
    }>;
    forgotPassword(username: string): Promise<{
        status: boolean;
        status_text: string;
    }>;
    forgotPasswordCheckOtp(username: string, otp: string): Promise<{
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    forgotPasswordFinalSubmit(username: string, otp: string, password: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    changePasswordSecuredByUser(oldPassword: string, newPassword: string, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    toggleActiveStatus(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: UserTable;
    }>;
    changePassword(user: any, password: string): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    addNewUser(newUserAddInput: NewUserAddInput): Promise<{
        status: boolean;
        status_text: string;
        data: UserTable;
    } | {
        status: boolean;
        status_text: any;
        data?: undefined;
    }>;
    getUserByUsername(username: string): Promise<UserTable>;
    addIntegratorToUser(integratorId: number, id: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    getMyUserDetails(user: any): Promise<UserTable>;
    getAllUsers(): Promise<any>;
    removeUserCollection(id: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    changePasswordSecured(oldPassword: string, newPassword: string, user: any): Promise<{
        status: boolean;
        status_text: string;
    }>;
    userSubscription(): AsyncIterator<unknown, any, undefined>;
}
