"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserCollectionResolver = exports.NEW_USER_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const user_collection_service_1 = require("./user-collection.service");
const user_collection_entity_1 = require("./entities/user-collection.entity");
const create_user_collection_input_1 = require("./dto/create-user-collection.input");
const update_user_collection_input_1 = require("./dto/update-user-collection.input");
const user_collection_type_1 = require("./type/user-collection.type");
const forgot_password_type_1 = require("./type/forgot-password.type");
const roles_decorator_1 = require("./decorators/roles.decorator");
const role_enum_1 = require("./roles/role.enum");
const common_1 = require("@nestjs/common");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_collection_return_type_1 = require("./type/user-collection-return.type");
const add_nerw_user_input_1 = require("./dto/add-nerw-user.input");
const user_decorator_1 = require("./decorators/user.decorator");
const typeorm_1 = require("typeorm");
const otp_table_service_1 = require("../otp-table/otp-table.service");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const count_changed_type_1 = require("../types/count-changed.type");
const user_integrator_check_type_1 = require("./type/user-integrator-check.type");
const new_registration_input_1 = require("./dto/new-registration.input");
exports.NEW_USER_ADD = "NEW_USER_ADD";
let UserCollectionResolver = exports.UserCollectionResolver = class UserCollectionResolver {
    constructor(userCollectionService, connection, entityManager, otpTableService, pubSub) {
        this.userCollectionService = userCollectionService;
        this.connection = connection;
        this.entityManager = entityManager;
        this.otpTableService = otpTableService;
        this.pubSub = pubSub;
    }
    createUserCollection(createUserCollectionInput) {
        return this.userCollectionService.create(createUserCollectionInput);
    }
    newRegistrationFromApp(newRegistrationInput) {
        return this.userCollectionService.newRegistrationFromApp(newRegistrationInput);
    }
    findAllUsers() {
        return this.userCollectionService.findAll();
    }
    findOne(id) {
        return this.userCollectionService.findOne(id);
    }
    checkIfUserIsIntegrator(user) {
        return this.userCollectionService.checkIfUserIsIntegrator(user);
    }
    updateUserCollection(updateUserCollectionInput) {
        return this.userCollectionService.update(updateUserCollectionInput.id, updateUserCollectionInput);
    }
    async forgotPassword(username) {
        let result = await this.userCollectionService.getUserByUsername(username);
        if (result !== null && result !== undefined) {
            let resultStr = await this.otpTableService.generateOtpNow(result.phone, result.name, result.email);
            return {
                status: true,
                status_text: resultStr.status_text,
            };
        }
        else {
            return {
                status: false,
                status_text: 'There is no entry for this username',
            };
        }
    }
    async forgotPasswordCheckOtp(username, otp) {
        let result = await this.userCollectionService.getUserByUsername(username);
        if (result !== null && result !== undefined) {
            return await this.otpTableService.checkOtp(result.phone, otp);
        }
        else {
            return {
                status: false,
                status_text: 'There is no entry for this email address',
                data: false
            };
        }
    }
    async forgotPasswordFinalSubmit(username, otp, password) {
        let result = await this.userCollectionService.getUserByUsername(username);
        if (result !== null && result !== undefined) {
            let res = await this.otpTableService.checkOtp(result.phone, otp);
            if (res.status === true) {
                return await this.userCollectionService.changePassword(username, password);
            }
            else {
                return {
                    status: false,
                    status_text: 'Operation Failed',
                    data: false
                };
            }
        }
        else {
            return {
                status: false,
                status_text: 'There is no entry for this email address',
                data: false
            };
        }
    }
    changePasswordSecuredByUser(oldPassword, newPassword, user) {
        return this.userCollectionService.changePasswordSecured(user, oldPassword, newPassword);
    }
    toggleActiveStatus(id) {
        return this.userCollectionService.toggleActiveStatus(id);
    }
    changePassword(user, password) {
        return this.userCollectionService.changePassword(user.username, password);
    }
    async addNewUser(newUserAddInput) {
        return await this.userCollectionService.addNewUser(newUserAddInput);
    }
    async getUserByUsername(username) {
        return await this.userCollectionService.getUserByUsername(username);
    }
    async addIntegratorToUser(integratorId, id) {
        return await this.userCollectionService.addIntegratorToUser(id, integratorId);
    }
    async getMyUserDetails(user) {
        return await this.userCollectionService.getUserByUsername(user.username);
    }
    getAllUsers() {
        return this.userCollectionService.getAllUsersNew();
    }
    removeUserCollection(id) {
        return this.userCollectionService.deleteUser(id);
    }
    changePasswordSecured(oldPassword, newPassword, user) {
        return this.userCollectionService.changePasswordSecured(user, oldPassword, newPassword);
    }
    userSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_USER_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('createUserCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_user_collection_input_1.CreateUserCollectionInput]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "createUserCollection", null);
__decorate([
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('newRegistrationInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [new_registration_input_1.NewRegistrationInput]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "newRegistrationFromApp", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [user_collection_type_1.UserCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "findAllUsers", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => user_collection_type_1.UserCollectionType),
    __param(0, (0, graphql_1.Args)('id', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => user_integrator_check_type_1.UserIntegratorCheckType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "checkIfUserIsIntegrator", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('updateUserCollectionInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_user_collection_input_1.UpdateUserCollectionInput]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "updateUserCollection", null);
__decorate([
    (0, graphql_1.Mutation)(() => forgot_password_type_1.ForgotPasswordType),
    __param(0, (0, graphql_1.Args)('username')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "forgotPassword", null);
__decorate([
    (0, graphql_1.Mutation)(() => forgot_password_type_1.ForgotPasswordType),
    __param(0, (0, graphql_1.Args)('username')),
    __param(1, (0, graphql_1.Args)('otp')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "forgotPasswordCheckOtp", null);
__decorate([
    (0, graphql_1.Mutation)(() => forgot_password_type_1.ForgotPasswordType),
    __param(0, (0, graphql_1.Args)('username')),
    __param(1, (0, graphql_1.Args)('otp')),
    __param(2, (0, graphql_1.Args)('password')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, String]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "forgotPasswordFinalSubmit", null);
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard),
    (0, graphql_1.Mutation)(() => forgot_password_type_1.ForgotPasswordType),
    __param(0, (0, graphql_1.Args)('oldPassword')),
    __param(1, (0, graphql_1.Args)('newPassword')),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Object]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "changePasswordSecuredByUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "toggleActiveStatus", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('password')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "changePassword", null);
__decorate([
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('newUserAddInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [add_nerw_user_input_1.NewUserAddInput]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "addNewUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => user_collection_type_1.UserCollectionType),
    __param(0, (0, graphql_1.Args)('username')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "getUserByUsername", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('integratorId')),
    __param(1, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Number]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "addIntegratorToUser", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.SUPERVISOR, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => user_collection_type_1.UserCollectionType),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], UserCollectionResolver.prototype, "getMyUserDetails", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [user_collection_type_1.UserCollectionType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "getAllUsers", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => user_collection_return_type_1.UserCollectionReturnType),
    __param(0, (0, graphql_1.Args)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "removeUserCollection", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => forgot_password_type_1.ForgotPasswordType),
    __param(0, (0, graphql_1.Args)('oldPassword')),
    __param(1, (0, graphql_1.Args)('newPassword')),
    __param(2, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String, Object]),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "changePasswordSecured", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], UserCollectionResolver.prototype, "userSubscription", null);
exports.UserCollectionResolver = UserCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => user_collection_entity_1.UserTable),
    __param(4, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [user_collection_service_1.UserCollectionService, typeorm_1.Connection, typeorm_1.EntityManager,
        otp_table_service_1.OtpTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], UserCollectionResolver);
