import { VaccinationMasterTableService } from './vaccination-master-table.service';
import { VaccinationMasterTable } from './entities/vaccination-master-table.entity';
import { CreateVaccinationMasterTableInput } from './dto/create-vaccination-master-table.input';
import { UpdateVaccinationMasterTableInput } from './dto/update-vaccination-master-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
export declare class VaccinationMasterTableResolver {
    private readonly vaccinationMasterTableService;
    private pubSub;
    constructor(vaccinationMasterTableService: VaccinationMasterTableService, pubSub: RedisPubSub);
    createVaccinationMasterTable(createVaccinationMasterTableInput: CreateVaccinationMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VaccinationMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllVaccines(): Promise<VaccinationMasterTable[]>;
    findOne(vaccineMasterId: number): Promise<VaccinationMasterTable>;
    updateVaccinationMasterTable(updateVaccinationMasterTableInput: UpdateVaccinationMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VaccinationMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeVaccinationMasterTable(vaccineMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    vaccineSubscription(): AsyncIterator<unknown, any, undefined>;
}
