import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateVaccinationMasterTableInput } from './dto/create-vaccination-master-table.input';
import { UpdateVaccinationMasterTableInput } from './dto/update-vaccination-master-table.input';
import { VaccinationMasterTable } from './entities/vaccination-master-table.entity';
export declare const NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
export declare class VaccinationMasterTableService {
    private readonly vaccinationMasterRepository;
    private pubSub;
    constructor(vaccinationMasterRepository: Repository<VaccinationMasterTable>, pubSub: RedisPubSub);
    create(createVaccinationMasterTableInput: CreateVaccinationMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VaccinationMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    createorElseReturnObject(createVaccinationMasterTableInput: CreateVaccinationMasterTableInput): Promise<VaccinationMasterTable>;
    checkIfAlreadyExists(createVaccinationMasterTableInput: CreateVaccinationMasterTableInput): Promise<number>;
    getCount(): Promise<number>;
    findAll(): Promise<VaccinationMasterTable[]>;
    findOne(vaccineMasterId: number): Promise<VaccinationMasterTable>;
    update(vaccineMasterId: number, updateVaccinationMasterTableInput: UpdateVaccinationMasterTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VaccinationMasterTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(vaccineMasterId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
