"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VaccinationMasterTableService = exports.NEW_VACCINE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const vaccination_master_table_entity_1 = require("./entities/vaccination-master-table.entity");
exports.NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
let VaccinationMasterTableService = exports.VaccinationMasterTableService = class VaccinationMasterTableService {
    constructor(vaccinationMasterRepository, pubSub) {
        this.vaccinationMasterRepository = vaccinationMasterRepository;
        this.pubSub = pubSub;
    }
    async create(createVaccinationMasterTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createVaccinationMasterTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new vaccination_master_table_entity_1.VaccinationMasterTable();
            st.vaccineName = createVaccinationMasterTableInput.vaccineName;
            let result = await this.vaccinationMasterRepository.save(st);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async createorElseReturnObject(createVaccinationMasterTableInput) {
        let checkIfAlreadyExists = await this.vaccinationMasterRepository.findOne({
            where: {
                vaccineName: createVaccinationMasterTableInput.vaccineName.trim(),
            }
        });
        if (!checkIfAlreadyExists) {
            let st = new vaccination_master_table_entity_1.VaccinationMasterTable();
            st.vaccineName = createVaccinationMasterTableInput.vaccineName.trim();
            let result = await this.vaccinationMasterRepository.save(st);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfAlreadyExists(createVaccinationMasterTableInput) {
        let result = await this.vaccinationMasterRepository.count({
            where: {
                vaccineName: createVaccinationMasterTableInput.vaccineName,
            }
        });
        return result;
    }
    async getCount() {
        return await this.vaccinationMasterRepository.count();
    }
    async findAll() {
        return await this.vaccinationMasterRepository.find();
    }
    async findOne(vaccineMasterId) {
        return await this.vaccinationMasterRepository.findOne({
            where: {
                vaccineMasterId
            }
        });
    }
    async update(vaccineMasterId, updateVaccinationMasterTableInput) {
        let result = await this.findOne(vaccineMasterId);
        if (result) {
            result.vaccineName = updateVaccinationMasterTableInput.vaccineName;
            let updatedResult = await this.vaccinationMasterRepository.save(result);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(vaccineMasterId) {
        let result = await this.findOne(vaccineMasterId);
        if (result) {
            await this.vaccinationMasterRepository.remove(result);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.VaccinationMasterTableService = VaccinationMasterTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(vaccination_master_table_entity_1.VaccinationMasterTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], VaccinationMasterTableService);
