import { VaccineTableService } from './vaccine-table.service';
import { VaccineTable } from './entities/vaccine-table.entity';
import { CreateVaccineTableInput } from './dto/create-vaccine-table.input';
import { UpdateVaccineTableInput } from './dto/update-vaccine-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
export declare class VaccineTableResolver {
    private readonly vaccineTableService;
    private pubSub;
    constructor(vaccineTableService: VaccineTableService, pubSub: RedisPubSub);
    createVaccineTable(createVaccineTableInput: CreateVaccineTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: VaccineTable;
    }>;
    findAllVaccine(): Promise<VaccineTable[]>;
    findOne(vaccineId: number): Promise<VaccineTable>;
    updateVaccineTable(updateVaccineTableInput: UpdateVaccineTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: VaccineTable;
    }>;
    removeVaccineTable(vaccineId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    vaccineSubscription(): AsyncIterator<unknown, any, undefined>;
}
