"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VaccineTableResolver = exports.NEW_VACCINE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const vaccine_table_service_1 = require("./vaccine-table.service");
const vaccine_table_entity_1 = require("./entities/vaccine-table.entity");
const create_vaccine_table_input_1 = require("./dto/create-vaccine-table.input");
const update_vaccine_table_input_1 = require("./dto/update-vaccine-table.input");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const common_1 = require("@nestjs/common");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const vaccine_table_return_type_1 = require("./type/vaccine-table-return.type");
const vaccine_table_type_1 = require("./type/vaccine-table.type");
const vaccine_table_count_changed_type_1 = require("./type/vaccine-table-count-changed.type");
exports.NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
let VaccineTableResolver = class VaccineTableResolver {
    constructor(vaccineTableService, pubSub) {
        this.vaccineTableService = vaccineTableService;
        this.pubSub = pubSub;
    }
    createVaccineTable(createVaccineTableInput, user) {
        return this.vaccineTableService.create(createVaccineTableInput, user);
    }
    findAllVaccine() {
        return this.vaccineTableService.findAll();
    }
    findOne(vaccineId) {
        return this.vaccineTableService.findOne(vaccineId);
    }
    updateVaccineTable(updateVaccineTableInput, user) {
        return this.vaccineTableService.update(updateVaccineTableInput.vaccineId, updateVaccineTableInput, user);
    }
    removeVaccineTable(vaccineId) {
        return this.vaccineTableService.remove(vaccineId);
    }
    vaccineSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_VACCINE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vaccine_table_return_type_1.VaccineTableReturnType),
    __param(0, (0, graphql_1.Args)('createVaccineTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_vaccine_table_input_1.CreateVaccineTableInput, Object]),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "createVaccineTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [vaccine_table_type_1.VaccineTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "findAllVaccine", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO, role_enum_1.Role.PIGBONDHU),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => vaccine_table_type_1.VaccineTableType),
    __param(0, (0, graphql_1.Args)('vaccineId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "findOne", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO, role_enum_1.Role.VO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vaccine_table_return_type_1.VaccineTableReturnType),
    __param(0, (0, graphql_1.Args)('updateVaccineTableInput')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_vaccine_table_input_1.UpdateVaccineTableInput, Object]),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "updateVaccineTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.DVO),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vaccine_table_return_type_1.VaccineTableReturnType),
    __param(0, (0, graphql_1.Args)('vaccineId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "removeVaccineTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => vaccine_table_count_changed_type_1.VaccineCountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VaccineTableResolver.prototype, "vaccineSubscription", null);
VaccineTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => vaccine_table_entity_1.VaccineTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [vaccine_table_service_1.VaccineTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], VaccineTableResolver);
exports.VaccineTableResolver = VaccineTableResolver;
