import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateVaccineTableInput } from './dto/create-vaccine-table.input';
import { UpdateVaccineTableInput } from './dto/update-vaccine-table.input';
import { VaccineTable } from './entities/vaccine-table.entity';
export declare const NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
export declare class VaccineTableService {
    private readonly vaccineTableRepository;
    private pubSub;
    constructor(vaccineTableRepository: Repository<VaccineTable>, pubSub: RedisPubSub);
    create(createVaccineTableInput: CreateVaccineTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: VaccineTable;
    }>;
    checkIfExists(createVaccineTableInput: CreateVaccineTableInput): Promise<boolean>;
    findAll(): Promise<VaccineTable[]>;
    findOne(vaccineId: number): Promise<VaccineTable>;
    update(vaccineId: number, updateVaccineTableInput: UpdateVaccineTableInput, user: any): Promise<{
        status: boolean;
        status_text: string;
        data: VaccineTable;
    }>;
    remove(vaccineId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
