"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VaccineTableService = exports.NEW_VACCINE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const vaccine_table_entity_1 = require("./entities/vaccine-table.entity");
exports.NEW_VACCINE_ADD = "NEW_VACCINE_ADD";
let VaccineTableService = class VaccineTableService {
    constructor(vaccineTableRepository, pubSub) {
        this.vaccineTableRepository = vaccineTableRepository;
        this.pubSub = pubSub;
    }
    async create(createVaccineTableInput, user) {
        let checkIfExists = await this.checkIfExists(createVaccineTableInput);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new vaccine_table_entity_1.VaccineTable();
            dd.vaccineName = createVaccineTableInput.vaccineName;
            let result = await this.vaccineTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async checkIfExists(createVaccineTableInput) {
        let rr = await this.vaccineTableRepository.count({
            where: {
                vaccineName: createVaccineTableInput.vaccineName,
            }
        });
        if (rr == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async findAll() {
        return await this.vaccineTableRepository.find();
    }
    async findOne(vaccineId) {
        return await this.vaccineTableRepository.findOne({
            where: {
                vaccineId: vaccineId
            }
        });
    }
    async update(vaccineId, updateVaccineTableInput, user) {
        let ht = await this.vaccineTableRepository.findOne({
            where: {
                vaccineId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            ht.vaccineName = updateVaccineTableInput.vaccineName;
            let result = await this.vaccineTableRepository.save(ht);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: result
            };
        }
    }
    async remove(vaccineId) {
        let ht = await this.vaccineTableRepository.findOne({
            where: {
                vaccineId
            }
        });
        if (!ht) {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
        else {
            await this.vaccineTableRepository.remove(ht);
            this.pubSub.publish(exports.NEW_VACCINE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted",
                data: null
            };
        }
    }
};
VaccineTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(vaccine_table_entity_1.VaccineTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], VaccineTableService);
exports.VaccineTableService = VaccineTableService;
