import { VillageTableService } from './village-table.service';
import { VillageTable } from './entities/village-table.entity';
import { CreateVillageTableInput } from './dto/create-village-table.input';
import { UpdateVillageTableInput } from './dto/update-village-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_VILLAGE_ADD = "NEW_VILLAGE_ADD";
export declare class VillageTableResolver {
    private readonly villageTableService;
    private pubSub;
    constructor(villageTableService: VillageTableService, pubSub: RedisPubSub);
    createVillageTable(createVillageTableInput: CreateVillageTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VillageTable;
    }>;
    findAllVillage(user: any): Promise<VillageTable[]>;
    findAllVillageByGpId(user: any, gpId: number): Promise<VillageTable[]>;
    findOneVillage(villageId: number): Promise<VillageTable>;
    updateVillageTable(updateVillageTableInput: UpdateVillageTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VillageTable;
    }>;
    removeVillageTable(villageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    villageSubscription(): AsyncIterator<unknown, any, undefined>;
}
