"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VillageTableResolver = exports.NEW_VILLAGE_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const village_table_service_1 = require("./village-table.service");
const village_table_entity_1 = require("./entities/village-table.entity");
const create_village_table_input_1 = require("./dto/create-village-table.input");
const update_village_table_input_1 = require("./dto/update-village-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const village_table_return_type_1 = require("./types/village-table-return.type");
const village_table_type_1 = require("./types/village-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_VILLAGE_ADD = "NEW_VILLAGE_ADD";
let VillageTableResolver = exports.VillageTableResolver = class VillageTableResolver {
    constructor(villageTableService, pubSub) {
        this.villageTableService = villageTableService;
        this.pubSub = pubSub;
    }
    createVillageTable(createVillageTableInput) {
        return this.villageTableService.create(createVillageTableInput);
    }
    findAllVillage(user) {
        return this.villageTableService.findAll();
    }
    findAllVillageByGpId(user, gpId) {
        return this.villageTableService.findAllByGpId(gpId);
    }
    findOneVillage(villageId) {
        return this.villageTableService.findOne(villageId);
    }
    updateVillageTable(updateVillageTableInput) {
        return this.villageTableService.update(updateVillageTableInput.villageId, updateVillageTableInput);
    }
    removeVillageTable(villageId) {
        return this.villageTableService.remove(villageId);
    }
    villageSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_VILLAGE_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => village_table_return_type_1.VillageTableReturnType),
    __param(0, (0, graphql_1.Args)('createVillageTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_village_table_input_1.CreateVillageTableInput]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "createVillageTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [village_table_type_1.VillageTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "findAllVillage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [village_table_type_1.VillageTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('gpId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "findAllVillageByGpId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => village_table_type_1.VillageTableType),
    __param(0, (0, graphql_1.Args)('villageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "findOneVillage", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => village_table_return_type_1.VillageTableReturnType),
    __param(0, (0, graphql_1.Args)('updateVillageTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_village_table_input_1.UpdateVillageTableInput]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "updateVillageTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => village_table_return_type_1.VillageTableReturnType),
    __param(0, (0, graphql_1.Args)('villageId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "removeVillageTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VillageTableResolver.prototype, "villageSubscription", null);
exports.VillageTableResolver = VillageTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => village_table_entity_1.VillageTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [village_table_service_1.VillageTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], VillageTableResolver);
