import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateVillageTableInput } from './dto/create-village-table.input';
import { UpdateVillageTableInput } from './dto/update-village-table.input';
import { VillageTable } from './entities/village-table.entity';
import { GrampanchayatTableService } from 'src/grampanchayat-table/grampanchayat-table.service';
export declare const NEW_VILLAGE_ADD = "NEW_VILLAGE_ADD";
export declare class VillageTableService {
    private readonly villageTableRepository;
    private pubSub;
    private readonly grampanchayatTableService;
    constructor(villageTableRepository: Repository<VillageTable>, pubSub: RedisPubSub, grampanchayatTableService: GrampanchayatTableService);
    create(createVillageTableInput: CreateVillageTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VillageTable;
    }>;
    createorElseReturnObject(createVillageTableInput: CreateVillageTableInput): Promise<VillageTable>;
    checkIfExists(villageName: string, gpId: number): Promise<boolean>;
    getCount(): Promise<number>;
    findAll(): Promise<VillageTable[]>;
    findAllByBlockIds(ids: number[]): Promise<VillageTable[]>;
    findAllByGpId(gpId: number): Promise<VillageTable[]>;
    findOne(villageId: number): Promise<VillageTable>;
    update(villageId: number, updateVillageTableInput: UpdateVillageTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VillageTable;
    }>;
    remove(villageId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
