"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VillageTableService = exports.NEW_VILLAGE_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const village_table_entity_1 = require("./entities/village-table.entity");
const grampanchayat_table_service_1 = require("../grampanchayat-table/grampanchayat-table.service");
exports.NEW_VILLAGE_ADD = "NEW_VILLAGE_ADD";
let VillageTableService = exports.VillageTableService = class VillageTableService {
    constructor(villageTableRepository, pubSub, grampanchayatTableService) {
        this.villageTableRepository = villageTableRepository;
        this.pubSub = pubSub;
        this.grampanchayatTableService = grampanchayatTableService;
    }
    async create(createVillageTableInput) {
        let checkIfExists = await this.checkIfExists(createVillageTableInput.villageName, createVillageTableInput.gpId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new village_table_entity_1.VillageTable();
            dd.villageName = createVillageTableInput.villageName;
            let grampanchayat = await this.grampanchayatTableService.findOne(createVillageTableInput.gpId);
            dd.GrampanchayatTable = grampanchayat;
            let result = await this.villageTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_VILLAGE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async createorElseReturnObject(createVillageTableInput) {
        let checkIfAlreadyExists = await this.villageTableRepository.findOne({
            where: {
                villageName: createVillageTableInput.villageName.trim(),
                GrampanchayatTable: {
                    gpId: createVillageTableInput.gpId
                }
            }
        });
        if (!checkIfAlreadyExists) {
            let dd = new village_table_entity_1.VillageTable();
            dd.villageName = createVillageTableInput.villageName.trim();
            let grampanchayat = await this.grampanchayatTableService.findOne(createVillageTableInput.gpId);
            dd.GrampanchayatTable = grampanchayat;
            let result = await this.villageTableRepository.save(dd);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfExists(villageName, gpId) {
        let result = await this.villageTableRepository.count({
            where: {
                villageName: villageName,
                GrampanchayatTable: {
                    gpId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getCount() {
        return await this.villageTableRepository.count();
    }
    async findAll() {
        return await this.villageTableRepository.find({
            relations: {
                GrampanchayatTable: {
                    BlockTable: {
                        DistrictTable: {
                            StateTable: true
                        }
                    }
                }
            }
        });
    }
    async findAllByBlockIds(ids) {
        return await this.villageTableRepository.find({
            where: {
                GrampanchayatTable: {
                    BlockTable: {
                        blockId: (0, typeorm_2.In)(ids)
                    }
                }
            },
            relations: {
                GrampanchayatTable: {
                    BlockTable: {
                        DistrictTable: {
                            StateTable: true
                        }
                    }
                }
            }
        });
    }
    async findAllByGpId(gpId) {
        return await this.villageTableRepository.find({
            where: {
                GrampanchayatTable: {
                    gpId
                }
            },
            relations: {
                GrampanchayatTable: true
            }
        });
    }
    async findOne(villageId) {
        return await this.villageTableRepository.findOne({
            where: {
                villageId: villageId
            },
            relations: {
                GrampanchayatTable: true
            }
        });
    }
    async update(villageId, updateVillageTableInput) {
        let result = await this.villageTableRepository.findOne({
            where: {
                villageId: villageId
            }
        });
        if (result) {
            result.villageName = updateVillageTableInput.villageName;
            let grampanchayat = await this.grampanchayatTableService.findOne(updateVillageTableInput.gpId);
            result.GrampanchayatTable = grampanchayat;
            let r = await this.villageTableRepository.save(result);
            this.pubSub.publish(exports.NEW_VILLAGE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(villageId) {
        let result = await this.villageTableRepository.findOne({
            where: {
                villageId: villageId
            }
        });
        if (result) {
            await this.villageTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_VILLAGE_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.VillageTableService = VillageTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(village_table_entity_1.VillageTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        grampanchayat_table_service_1.GrampanchayatTableService])
], VillageTableService);
