import { VoTableService } from './vo-table.service';
import { VoTable } from './entities/vo-table.entity';
import { CreateVoTableInput } from './dto/create-vo-table.input';
import { UpdateVoTableInput } from './dto/update-vo-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_VO_ADD = "NEW_VO_ADD";
export declare class VoTableResolver {
    private readonly voTableService;
    private pubSub;
    constructor(voTableService: VoTableService, pubSub: RedisPubSub);
    createVoTable(createVoTableInput: CreateVoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VoTable;
    }>;
    findAllVo(user: any): Promise<VoTable[]>;
    findAllVoByGpId(user: any, gpId: number): Promise<VoTable[]>;
    findOneVo(voId: number): Promise<VoTable>;
    updateVoTable(updateVoTableInput: UpdateVoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VoTable;
    }>;
    removeVoTable(voId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
    voSubscription(): AsyncIterator<unknown, any, undefined>;
}
