"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VoTableResolver = exports.NEW_VO_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const vo_table_service_1 = require("./vo-table.service");
const vo_table_entity_1 = require("./entities/vo-table.entity");
const create_vo_table_input_1 = require("./dto/create-vo-table.input");
const update_vo_table_input_1 = require("./dto/update-vo-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const vo_table_return_type_1 = require("./types/vo-table-return.type");
const vo_table_type_1 = require("./types/vo-table.type");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_VO_ADD = "NEW_VO_ADD";
let VoTableResolver = exports.VoTableResolver = class VoTableResolver {
    constructor(voTableService, pubSub) {
        this.voTableService = voTableService;
        this.pubSub = pubSub;
    }
    createVoTable(createVoTableInput) {
        return this.voTableService.create(createVoTableInput);
    }
    findAllVo(user) {
        return this.voTableService.findAll();
    }
    findAllVoByGpId(user, gpId) {
        return this.voTableService.findAllByGpId(gpId);
    }
    findOneVo(voId) {
        return this.voTableService.findOne(voId);
    }
    updateVoTable(updateVoTableInput) {
        return this.voTableService.update(updateVoTableInput.voId, updateVoTableInput);
    }
    removeVoTable(voId) {
        return this.voTableService.remove(voId);
    }
    voSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_VO_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vo_table_return_type_1.VoTableReturnType),
    __param(0, (0, graphql_1.Args)('createVoTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_vo_table_input_1.CreateVoTableInput]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "createVoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [vo_table_type_1.VoTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "findAllVo", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [vo_table_type_1.VoTableType]),
    __param(0, (0, user_decorator_1.CurrentUser)()),
    __param(1, (0, graphql_1.Args)('gpId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "findAllVoByGpId", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => vo_table_type_1.VoTableType),
    __param(0, (0, graphql_1.Args)('voId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "findOneVo", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vo_table_return_type_1.VoTableReturnType),
    __param(0, (0, graphql_1.Args)('updateVoTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_vo_table_input_1.UpdateVoTableInput]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "updateVoTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vo_table_return_type_1.VoTableReturnType),
    __param(0, (0, graphql_1.Args)('voId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "removeVoTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VoTableResolver.prototype, "voSubscription", null);
exports.VoTableResolver = VoTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => vo_table_entity_1.VoTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [vo_table_service_1.VoTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], VoTableResolver);
