import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateVoTableInput } from './dto/create-vo-table.input';
import { UpdateVoTableInput } from './dto/update-vo-table.input';
import { VoTable } from './entities/vo-table.entity';
import { GrampanchayatTableService } from 'src/grampanchayat-table/grampanchayat-table.service';
export declare const NEW_VO_ADD = "NEW_VO_ADD";
export declare class VoTableService {
    private readonly voTableRepository;
    private pubSub;
    private readonly grampanchayatTableService;
    constructor(voTableRepository: Repository<VoTable>, pubSub: RedisPubSub, grampanchayatTableService: GrampanchayatTableService);
    create(createVoTableInput: CreateVoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VoTable;
    }>;
    createorElseReturnObject(createVoTableInput: CreateVoTableInput): Promise<VoTable>;
    checkIfExists(voName: string, gpId: number): Promise<boolean>;
    getCount(): Promise<number>;
    findAll(): Promise<VoTable[]>;
    findAllByBlockIds(ids: number[]): Promise<VoTable[]>;
    findAllByGpId(gpId: number): Promise<VoTable[]>;
    findOne(voId: number): Promise<VoTable>;
    update(voId: number, updateVoTableInput: UpdateVoTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VoTable;
    }>;
    remove(voId: number): Promise<{
        status: boolean;
        status_text: string;
        data: any;
    }>;
}
