"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VoTableService = exports.NEW_VO_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const vo_table_entity_1 = require("./entities/vo-table.entity");
const grampanchayat_table_service_1 = require("../grampanchayat-table/grampanchayat-table.service");
exports.NEW_VO_ADD = "NEW_VO_ADD";
let VoTableService = exports.VoTableService = class VoTableService {
    constructor(voTableRepository, pubSub, grampanchayatTableService) {
        this.voTableRepository = voTableRepository;
        this.pubSub = pubSub;
        this.grampanchayatTableService = grampanchayatTableService;
    }
    async create(createVoTableInput) {
        let checkIfExists = await this.checkIfExists(createVoTableInput.voName, createVoTableInput.gpId);
        if (checkIfExists) {
            return {
                status: false,
                status_text: "Already Exists",
                data: null
            };
        }
        else {
            let dd = new vo_table_entity_1.VoTable();
            dd.voName = createVoTableInput.voName;
            dd.dateOfFormation = createVoTableInput.dateOfFormation;
            dd.nrlmRegistration = createVoTableInput.nrlmRegistration;
            dd.bankName = createVoTableInput.bankName;
            dd.bankAccountNo = createVoTableInput.bankAccountNo;
            dd.bankBranch = createVoTableInput.bankBranch;
            dd.bankIfsc = createVoTableInput.bankIfsc;
            let grampanchayat = await this.grampanchayatTableService.findOne(createVoTableInput.gpId);
            dd.GrampanchayatTable = grampanchayat;
            let result = await this.voTableRepository.save(dd);
            this.pubSub.publish(exports.NEW_VO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Created",
                data: result
            };
        }
    }
    async createorElseReturnObject(createVoTableInput) {
        let checkIfAlreadyExists = await this.voTableRepository.findOne({
            where: {
                voName: createVoTableInput.voName.trim(),
                GrampanchayatTable: {
                    gpId: createVoTableInput.gpId
                }
            }
        });
        if (!checkIfAlreadyExists) {
            let dd = new vo_table_entity_1.VoTable();
            dd.voName = createVoTableInput.voName.trim();
            if (createVoTableInput.dateOfFormation) {
                dd.dateOfFormation = createVoTableInput.dateOfFormation;
            }
            if (createVoTableInput.nrlmRegistration) {
                dd.nrlmRegistration = createVoTableInput.nrlmRegistration;
            }
            if (createVoTableInput.bankName) {
                dd.bankName = createVoTableInput.bankName;
            }
            if (createVoTableInput.bankAccountNo) {
                dd.bankAccountNo = createVoTableInput.bankAccountNo;
            }
            if (createVoTableInput.bankBranch) {
                dd.bankBranch = createVoTableInput.bankBranch;
            }
            if (createVoTableInput.bankIfsc) {
                dd.bankIfsc = createVoTableInput.bankIfsc;
            }
            let grampanchayat = await this.grampanchayatTableService.findOne(createVoTableInput.gpId);
            dd.GrampanchayatTable = grampanchayat;
            let result = await this.voTableRepository.save(dd);
            return result;
        }
        else {
            return checkIfAlreadyExists;
        }
    }
    async checkIfExists(voName, gpId) {
        let result = await this.voTableRepository.count({
            where: {
                voName: voName,
                GrampanchayatTable: {
                    gpId
                }
            }
        });
        if (result == 0) {
            return false;
        }
        else {
            return true;
        }
    }
    async getCount() {
        return await this.voTableRepository.count();
    }
    async findAll() {
        return await this.voTableRepository.find({
            relations: {
                GrampanchayatTable: {
                    BlockTable: {
                        DistrictTable: {
                            StateTable: true
                        }
                    }
                }
            }
        });
    }
    async findAllByBlockIds(ids) {
        return await this.voTableRepository.find({
            where: {
                GrampanchayatTable: {
                    BlockTable: {
                        blockId: (0, typeorm_2.In)(ids)
                    }
                }
            },
            relations: {
                GrampanchayatTable: {
                    BlockTable: {
                        DistrictTable: {
                            StateTable: true
                        }
                    }
                }
            }
        });
    }
    async findAllByGpId(gpId) {
        return await this.voTableRepository.find({
            where: {
                GrampanchayatTable: {
                    gpId
                }
            },
            relations: {
                GrampanchayatTable: true
            }
        });
    }
    async findOne(voId) {
        return await this.voTableRepository.findOne({
            where: {
                voId: voId
            },
            relations: {
                GrampanchayatTable: true
            }
        });
    }
    async update(voId, updateVoTableInput) {
        let result = await this.voTableRepository.findOne({
            where: {
                voId: voId
            }
        });
        if (result) {
            result.voName = updateVoTableInput.voName;
            if (updateVoTableInput.dateOfFormation) {
                result.dateOfFormation = updateVoTableInput.dateOfFormation;
            }
            if (updateVoTableInput.nrlmRegistration) {
                result.nrlmRegistration = updateVoTableInput.nrlmRegistration;
            }
            if (updateVoTableInput.bankName) {
                result.bankName = updateVoTableInput.bankName;
            }
            if (updateVoTableInput.bankAccountNo) {
                result.bankAccountNo = updateVoTableInput.bankAccountNo;
            }
            if (updateVoTableInput.bankBranch) {
                result.bankBranch = updateVoTableInput.bankBranch;
            }
            if (updateVoTableInput.bankIfsc) {
                result.bankIfsc = updateVoTableInput.bankIfsc;
            }
            let grampanchayat = await this.grampanchayatTableService.findOne(updateVoTableInput.gpId);
            result.GrampanchayatTable = grampanchayat;
            let r = await this.voTableRepository.save(result);
            this.pubSub.publish(exports.NEW_VO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: r
            };
        }
        else {
            return {
                status: false,
                status_text: "Not found",
                data: null
            };
        }
    }
    async remove(voId) {
        let result = await this.voTableRepository.findOne({
            where: {
                voId: voId
            }
        });
        if (result) {
            await this.voTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_VO_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Removed",
                data: null
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found",
                data: null
            };
        }
    }
};
exports.VoTableService = VoTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(vo_table_entity_1.VoTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub,
        grampanchayat_table_service_1.GrampanchayatTableService])
], VoTableService);
