"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WishlistCollectionResolver = void 0;
const graphql_1 = require("@nestjs/graphql");
const wishlist_collection_service_1 = require("./wishlist-collection.service");
const wishlist_collection_entity_1 = require("./entities/wishlist-collection.entity");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const common_1 = require("@nestjs/common");
const user_decorator_1 = require("../user-collection/decorators/user.decorator");
const wishlist_collection_create_type_1 = require("./types/wishlist-collection-create.type");
let WishlistCollectionResolver = class WishlistCollectionResolver {
    constructor(wishlistCollectionService) {
        this.wishlistCollectionService = wishlistCollectionService;
    }
    addProductToWishlist(productId, user) {
        return this.wishlistCollectionService.addProductToWishlist(user.username, productId);
    }
};
__decorate([
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard),
    (0, graphql_1.Mutation)(() => wishlist_collection_create_type_1.WhishlistCollectionCreateType),
    __param(0, (0, graphql_1.Args)('productId')),
    __param(1, (0, user_decorator_1.CurrentUser)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Object]),
    __metadata("design:returntype", void 0)
], WishlistCollectionResolver.prototype, "addProductToWishlist", null);
WishlistCollectionResolver = __decorate([
    (0, graphql_1.Resolver)(() => wishlist_collection_entity_1.WishlistCollection),
    __metadata("design:paramtypes", [wishlist_collection_service_1.WishlistCollectionService])
], WishlistCollectionResolver);
exports.WishlistCollectionResolver = WishlistCollectionResolver;
