import { Model } from 'mongoose';
import { ProductCollection } from 'src/product-collection/entities/product-collection.entity';
import { ProductCollectionService } from 'src/product-collection/product-collection.service';
import { WishlistCollection, WishlistCollectionDocument } from './entities/wishlist-collection.entity';
export declare class WishlistCollectionService {
    private wishlistCollectionRepository;
    private productService;
    constructor(wishlistCollectionRepository: Model<WishlistCollectionDocument>, productService: ProductCollectionService);
    addProductToWishlist(username: string, productId: string): Promise<{
        status: boolean;
        status_text: string;
        data: boolean;
    }>;
    checkIfExists(username: string): Promise<boolean>;
    checkIfExistsInWishList(username: string, pc: ProductCollection): Promise<boolean>;
    findAllWithUsername(username: string): Promise<WishlistCollection & import("mongoose").Document<any, any, any> & {
        _id: any;
    }>;
}
