"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WishlistCollectionService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const product_collection_service_1 = require("../product-collection/product-collection.service");
const wishlist_collection_entity_1 = require("./entities/wishlist-collection.entity");
let WishlistCollectionService = class WishlistCollectionService {
    constructor(wishlistCollectionRepository, productService) {
        this.wishlistCollectionRepository = wishlistCollectionRepository;
        this.productService = productService;
    }
    async addProductToWishlist(username, productId) {
        let checkIfExists = await this.checkIfExists(username);
        if (checkIfExists) {
            let pc = await this.productService.findOneById(productId);
            let wc = await this.wishlistCollectionRepository.findOne({ username: username }).populate('Product').exec();
            let ce = wc.Product.filter((el) => el.productCode == pc.productCode);
            if (ce.length == 0) {
                let newP = [...wc.Product, pc];
                await this.wishlistCollectionRepository.updateOne({ username: username }, {
                    Product: newP
                });
                return {
                    status: true,
                    status_text: "Added to wishlist",
                    data: true
                };
            }
            else {
                let newP = [...wc.Product];
                let ind = newP.findIndex((el) => el.productCode == pc.productCode);
                if (ind != -1) {
                    newP.splice(ind, 1);
                }
                await this.wishlistCollectionRepository.updateOne({ username: username }, {
                    Product: newP
                });
                return {
                    status: true,
                    status_text: "Removed from wishlist",
                    data: false
                };
            }
        }
        else {
            let pc = await this.productService.findOneById(productId);
            let wc = new wishlist_collection_entity_1.WishlistCollection();
            wc.username = username;
            wc.Product = [pc];
            await this.wishlistCollectionRepository.create(wc);
            return {
                status: true,
                status_text: "Added to wishlist",
                data: true
            };
        }
    }
    async checkIfExists(username) {
        let r = await this.wishlistCollectionRepository.count({ username: username }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    async checkIfExistsInWishList(username, pc) {
        let r = await this.wishlistCollectionRepository.count({ username: username, Product: {
                $in: pc
            } }).exec();
        if (r > 0) {
            return true;
        }
        else {
            return false;
        }
    }
    async findAllWithUsername(username) {
        return await this.wishlistCollectionRepository.findOne({
            username: username
        }).exec();
    }
};
WishlistCollectionService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(wishlist_collection_entity_1.WishlistCollection.name)),
    __param(1, (0, common_1.Inject)((0, common_1.forwardRef)(() => product_collection_service_1.ProductCollectionService))),
    __metadata("design:paramtypes", [mongoose_2.Model,
        product_collection_service_1.ProductCollectionService])
], WishlistCollectionService);
exports.WishlistCollectionService = WishlistCollectionService;
