import { forwardRef, Module } from '@nestjs/common';
import { AccessTableService } from './access-table.service';
import { AccessTableResolver } from './access-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { AccessTable } from './entities/access-table.entity';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';

@Module({
  imports: [TypeOrmModule.forFeature([AccessTable]), forwardRef(() => UserCollectionModule),],
  providers: [AccessTableResolver, AccessTableService],
  exports: [AccessTableService]
})
export class AccessTableModule {}
