import { forwardRef, Inject, Injectable } from '@nestjs/common';
import { InjectRepository } from '@nestjs/typeorm';
import { RedisPubSub } from 'graphql-redis-subscriptions';
import { PUB_SUB } from 'src/helper/GlobalConstants';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { IsNull, Repository } from 'typeorm';
import { CreateAccessTableInput } from './dto/create-access-table.input';
import { UpdateAccessTableInput } from './dto/update-access-table.input';
import { AccessTable } from './entities/access-table.entity';

@Injectable()
export class AccessTableService {
  constructor(
    @InjectRepository(AccessTable)
    private readonly accessTableRepository: Repository<AccessTable>,
    @Inject(PUB_SUB) private pubSub: RedisPubSub,

    @Inject(forwardRef(() => UserCollectionService))
    private readonly userCollectionService: UserCollectionService,

  ) { }


  async create(createAccessTableInput: CreateAccessTableInput) {



    // let res = await this.checkIfExistsNew(createAccessTableInput)

    // if (!res) {

    //   let UserTable = await this.userCollectionService.getOneByUserId(createAccessTableInput.userId)



    //   let accessLabel = '';

    //   let dt = new AccessTable();
    //   dt.UserTable = UserTable;
    //   // if (createAccessTableInput.stateId) {
    //   //   let StateTable = await this.stateTableService.findOne(createAccessTableInput.stateId)
    //   //   dt.StateTable = StateTable;
    //   //   accessLabel = 'STATE'
    //   // } else {
    //   //   dt.StateTable = null;
    //   // }


    //   // if (createAccessTableInput.districtId) {
    //   //   let district = await this.districtTableService.findOne(createAccessTableInput.districtId)
    //   //   dt.DistrictTable = district;
    //   //   accessLabel = 'DISTRICT'
    //   // } else {
    //   //   dt.DistrictTable = null;
    //   // }



    //   // if (createAccessTableInput.blockId) {
    //   //   let BlockTable = await this.blockTableService.findOne(createAccessTableInput.blockId)
    //   //   dt.BlockTable = BlockTable;
    //   //   accessLabel = 'BLOCK'
    //   // } else {
    //   //   dt.BlockTable = null;
    //   // }

    //   dt.accessLevel = accessLabel;


    //   let result = await this.accessTableRepository.save(dt)

    //   return {
    //     status: true,
    //     status_text: "Successfully Created",
    //     data: result
    //   }


    // } else {
    //   return {
    //     status: false,
    //     status_text: "Already Exists",
    //     data: null
    //   }
    // }


  }

  // async checkIfExistsNew(createAccessTableInput: CreateAccessTableInput) {



  //   let result = await this.accessTableRepository.findOne({
  //     where: {
  //       StateTable: createAccessTableInput.stateId > 0 ? {
  //         stateId: createAccessTableInput.stateId
  //       } : IsNull(),
  //       DistrictTable: createAccessTableInput.districtId > 0 ? {
  //         districtId: createAccessTableInput.districtId
  //       } : IsNull(),
  //       BlockTable: createAccessTableInput.blockId > 0 ? {
  //         blockId: createAccessTableInput.blockId
  //       } : IsNull(),
  //       UserTable: {
  //         id: createAccessTableInput.userId
  //       }
  //     }
  //   })

  //   return result;


  // }

  async checkIfExists(userId: number) {


    let result = await this.accessTableRepository.findOne({
      where: {
        UserTable: {
          id: userId
        }
      }
    })

    return result;
  }

  async findAllByUserName(username: string) {

    return await this.accessTableRepository.find({
      where: {
        UserTable: {
          username: username
        }
      },
      relations: {
        UserTable: true,
      }
    })

  }

  async findAll() {
    return await this.accessTableRepository.findOne({
      relations: {
        UserTable: true,
      }
    })
  }

  async findOne(accessId: number) {
    return await this.accessTableRepository.findOne({
      where: {
        accessId: accessId
      },
      relations: {
        UserTable: true,
      }
    })
  }

  async update(accessId: number, updateAccessTableInput: UpdateAccessTableInput) {
    let rr = await this.accessTableRepository.findOne({
      where: {
        accessId: accessId
      }
    })

    // if(rr){
    //   let UserTable = await this.userCollectionService.getOneByUserId(updateAccessTableInput.userId)  
    //   let district = await this.districtTableService.findOne(updateAccessTableInput.districtId)
    //   let subdiv = await this.subDivisionTableService.findOne(updateAccessTableInput.subDivisionId)



    //   rr.UserTable = UserTable;
    //   rr.DistrictTable = district;

    //   if(subdiv){
    //     rr.SubDivisionTable = subdiv;
    //   }


    //   let result = await this.accessTableRepository.save(rr)

    //   return {
    //     status: true,
    //     status_text: "Successfully Updated",
    //     data: result
    //   }
    // }else{
    //   return {
    //     status: false,
    //     status_text: "Not Found"
    //   }
    // }
  }

  async remove(accessId: number) {
    let rr = await this.accessTableRepository.findOne({
      where: {
        accessId: accessId
      }
    })


    if (rr) {
      await this.accessTableRepository.remove(rr);

      return {
        status: true,
        status_text: "Successfully Deleted"
      }
    } else {
      return {
        status: false,
        status_text: "Not Found"
      }
    }
  }


  async getAllAccessParameterByUsername(username: string) {

   

    let result = await this.accessTableRepository.find({
      where: {
        UserTable: {
          username
        }
      },
      relations: {
        UserTable: true,
      }
    })


    


    return result;
  }
}
