import { UserTable } from "src/user-collection/entities/user-collection.entity";
import { Entity, PrimaryGeneratedColumn, CreateDateColumn, UpdateDateColumn, ManyToOne, JoinColumn, Column } from "typeorm";

@Entity()
export class AccessTable {
    @PrimaryGeneratedColumn()
    accessId: number;


    @Column({ length: 300, nullable: true })
    accessLevel: string;

    @ManyToOne(type => UserTable, et => et.AccessTable)
    @JoinColumn({ name: "userId" })
    UserTable: UserTable;


    @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
    public createdAt: Date;


    @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
    public updatedAt: Date;

}