import { Injectable } from '@nestjs/common';
import { ImportDataType } from './types/import-data-type.type';
import { AccessTableService } from './access-table/access-table.service';
import moment from 'moment';
import { PDFService } from '@t00nday/nestjs-pdf';
import { join } from 'path';
import handlebars from "handlebars";
import { readFileSync } from 'fs';
import { sortByCountDescending } from './helper/HelperFunctions';
import { UserCollectionService } from './user-collection/user-collection.service';
import { ImportDataTypePg } from './types/import-data-type-pg.type';
import { ImportDataTypeUser } from './types/import-data-type-user.type';
import { ImportDataTypeMk } from './types/import-data-type-mk.type';


@Injectable()
export class AppService {
  constructor(

    private readonly accessTableService: AccessTableService,
    private readonly userCollectionService: UserCollectionService,
   
 


    // PDF service
    private readonly pdfService: PDFService,


  ) { }


  // async updateBulkData(data: ImportDataType[], user: any) {


  //   let result: any = [];

  //   for (const el of data) {
  //     // create the state if not exists or return the dataObject

  //     let state = await this.stateTableService.createorElseReturnObject({ stateName: el.stateName });

  //     let district = await this.districtTableService.createorElseReturnObject({
  //       districtName: el.districtName,
  //       stateId: state.stateId
  //     })


  //     let block = await this.blockTableService.createorElseReturnObject({
  //       blockName: el.blockName,
  //       districtId: district.districtId
  //     })


  //     let grampanchayat = await this.grampanchayatTableService.createorElseReturnObject({
  //       gpName: el.gpName,
  //       blockId: block.blockId
  //     })


  //     let village = await this.villageTableService.createorElseReturnObject({
  //       villageName: el.villageName,
  //       gpId: grampanchayat.gpId
  //     })


  //     let vo = null;

  //     if (el.voName != "" && el.voName != null) {
  //       vo = await this.voTableService.createorElseReturnObject({
  //         voName: el.voName,
  //         gpId: grampanchayat.gpId
  //       })
  //     }

  //     // insert SHG now:

  //     if (vo == null) {
  //       let shg = await this.shgTableService.createorElseReturnObject({
  //         shgName: el.shgName,
  //         villageId: village.villageId,
  //         noOfMembers: 0,
  //         voId: 0,
  //         dateOfFormation: el.dateOfFormation,
  //         nrlmRegistration: el.nrlmRegistration,
  //         bankAccountNo: el.bankAccountNo,
  //         bankBranch: el.bankBranch,
  //         bankName: el.bankName,
  //         bankIfsc: el.bankIfsc
  //       }, user)

  //       result.push(`${shg.shgName} successfully inserted`)

  //     } else {
  //       let shg = await this.shgTableService.createorElseReturnObject({
  //         shgName: el.shgName,
  //         villageId: village.villageId,
  //         noOfMembers: 0,
  //         voId: vo.voId,
  //         dateOfFormation: el.dateOfFormation,
  //         nrlmRegistration: el.nrlmRegistration,
  //         bankAccountNo: el.bankAccountNo,
  //         bankBranch: el.bankBranch,
  //         bankName: el.bankName,
  //         bankIfsc: el.bankIfsc
  //       }, user)
  //       result.push(`${shg.shgName} successfully inserted`)
  //     }

  //   }

  //   return {
  //     status: true,
  //     status_text: "Data Uploaded Successfully",
  //     data: result
  //   };
  // }

  // async updateBulkDataPg(data: ImportDataTypePg[], user: any) {


  //   let result: any = [];

  //   for (const el of data) {
  //     // create the state if not exists or return the dataObject

  //     let state = await this.stateTableService.createorElseReturnObject({ stateName: el.stateName });

  //     let district = await this.districtTableService.createorElseReturnObject({
  //       districtName: el.districtName,
  //       stateId: state.stateId
  //     })


  //     let block = await this.blockTableService.createorElseReturnObject({
  //       blockName: el.blockName,
  //       districtId: district.districtId
  //     })


  //     let pg = await this.producerGroupsTableService.createorElseReturnObject({
  //       pgName: el.pgName,
  //       blockId: block.blockId,
  //       dateOfFormation: el.dateOfFormation,
  //       nrlmRegistration: el.nrlmRegistration,
  //       bankAccountNo: el.bankAccountNo,
  //       bankBranch: el.bankBranch,
  //       bankName: el.bankName,
  //       bankIfsc: el.bankIfsc,
  //     })

  //     result.push(`${pg.pgName} successfully inserted`)

  //   }

  //   return {
  //     status: true,
  //     status_text: "Data Uploaded Successfully",
  //     data: result
  //   };
  // }


  async updateBulkDataUser(data: ImportDataTypeUser[], user: any) {


    let result: any = [];

    for (const el of data) {
     


        let user = await this.userCollectionService.create({
          name: el.name,
          email: el.email,
          username: el.username,
          phone: el.phone,
          organisationId: el.organisationId,
          designationId: el.designationId,
          role: el.role,
          password: el.password.toString(),
          isActive: true
        })
        result.push(`${el.name} successfully inserted`)
      

    }

    return {
      status: true,
      status_text: "Data Uploaded Successfully",
      data: result
    };
  }

  // async updateBulkDataMk(data: ImportDataTypeMk[], user: any) {


  //   let result: any = [];

  //   for (const el of data) {
     

  //       await this.mkTableService.createMkShortExcel(el, user)
        
      

  //   }

  //   return {
  //     status: true,
  //     status_text: "Data Uploaded Successfully",
  //     data: result
  //   };
  // }

  async getDashboardCounts() {


    return {
      status: true,
      data: {
      }
    }

  }


  async getDashboardCountForApplication(username: string) {

    let assignedState = [];
    let assignedDistrict = [];
    let assignedBlock = [];
    let mkEntered = 0;
    let fblpPerformed = 0;


    let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);



    for (const el of accessData) {
      if (el.accessLevel == "STATE") {
        // we will get one state + all districts + all blocks
        // if (!assignedState.includes(el.StateTable.stateId)) {
        //   assignedState.push(el.StateTable.stateId)
        // }
        // let districtsUnderState = await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
        // districtsUnderState.map((el) => {
        //   if (!assignedDistrict.includes(el)) {
        //     assignedDistrict.push(el)
        //   }
        // })

        // let blocksUnderState = await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
        // blocksUnderState.map((el) => {
        //   if (!assignedBlock.includes(el)) {
        //     assignedBlock.push(el)
        //   }
        // })
        //assignedDistrict = assignedDistrict + await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
        //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
      }

      // if (el.accessLevel == "DISTRICT") {
      //   // we will get one state + one districts + all blocks
      //   if (!assignedState.includes(el.StateTable.stateId)) {
      //     assignedState.push(el.StateTable.stateId)
      //   }
      //   if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //     assignedDistrict.push(el.DistrictTable.districtId)
      //   }

      //   // let blocksUnderState = await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);;
      //   // blocksUnderState.map((el) => {
      //   //   if (!assignedBlock.includes(el)) {
      //   //     assignedBlock.push(el)
      //   //   }
      //   // })
      //   //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);
      // }

      // if (el.accessLevel == "BLOCK") {
      //   // we will get one state + one districts + one blocks
      //   if (!assignedState.includes(el.StateTable.stateId)) {
      //     assignedState.push(el.StateTable.stateId)
      //   }
      //   if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //     assignedDistrict.push(el.DistrictTable.districtId)
      //   }
      //   if (!assignedBlock.includes(el.BlockTable.blockId)) {
      //     assignedBlock.push(el.BlockTable.blockId)
      //   }

      // }

    }



    // mkEntered = await this.mkTableService.getCountByUsername(username)
    // fblpPerformed = await this.fblpTableService.getCountByUsername(username)



    return {
      assignedState: assignedState.length,
      assignedDistrict: assignedDistrict.length,
      assignedBlock: assignedBlock.length,
      mkEntered,
      fblpPerformed
    }
  }


  async getCountOfMkRelatedDataForGraph(year?: string) {

    let yearToBeTaken = year;

    if (!year) {
      yearToBeTaken = moment().format("YYYY");
    }


    const startOfYear = moment(yearToBeTaken, "YYYY").startOf('year').format('YYYY-MM-DD')
    const endOfYear = moment(yearToBeTaken, "YYYY").endOf('year').format('YYYY-MM-DD')

    let monthObject = {
      Jan: 0,
      Feb: 0,
      Mar: 0,
      Apr: 0,
      May: 0,
      Jun: 0,
      Jul: 0,
      Aug: 0,
      Sep: 0,
      Oct: 0,
      Nov: 0,
      Dec: 0,
    }


    let result: any = [];

    for (var key in monthObject) {
      let month = moment(`${key}-${yearToBeTaken}`, 'MMM-YYYY').format('YYYY-MM');

      result.push({
        month: key,
      })

    }





    return result;
  }


  async getOfflineDataForEntry(username: string, role: string) {

    let assignedState = [];
    let assignedDistrict = [];
    let assignedBlock = [];



    if (role == "USER") {

      let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);



      // for (const el of accessData) {
      //   if (el.accessLevel == "STATE") {
      //     // we will get one state + all districts + all blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     // let districtsUnderState = await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
      //     // districtsUnderState.map((el) => {
      //     //   if (!assignedDistrict.includes(el)) {
      //     //     assignedDistrict.push(el)
      //     //   }
      //     // })

      //     // let blocksUnderState = await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
      //     // blocksUnderState.map((el) => {
      //     //   if (!assignedBlock.includes(el)) {
      //     //     assignedBlock.push(el)
      //     //   }
      //     // })
      //     //assignedDistrict = assignedDistrict + await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
      //     //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
      //   }

      //   if (el.accessLevel == "DISTRICT") {
      //     // we will get one state + one districts + all blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //       assignedDistrict.push(el.DistrictTable.districtId)
      //     }

      //     // let blocksUnderState = await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);;
      //     // blocksUnderState.map((el) => {
      //     //   if (!assignedBlock.includes(el)) {
      //     //     assignedBlock.push(el)
      //     //   }
      //     // })
      //     //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);
      //   }

      //   if (el.accessLevel == "BLOCK") {
      //     // we will get one state + one districts + one blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //       assignedDistrict.push(el.DistrictTable.districtId)
      //     }
      //     if (!assignedBlock.includes(el.BlockTable.blockId)) {
      //       assignedBlock.push(el.BlockTable.blockId)
      //     }

      //   }

      // }


      return {
        // new 
      }

    } else {
      // get all the data
      return {
      }
    }


    // now we need to fetch all the GP, VILLAGE, VO AND SHG under those blocks






  }


  async getAssignedStatesAndAll(username: string, role: string) {

    let assignedState = [];
    let assignedDistrict = [];
    let assignedBlock = [];



    if (role == "USER") {

      let accessData = await this.accessTableService.getAllAccessParameterByUsername(username);



      // for (const el of accessData) {
      //   if (el.accessLevel == "STATE") {
      //     // we will get one state + all districts + all blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     // let districtsUnderState = await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
      //     // districtsUnderState.map((el) => {
      //     //   if (!assignedDistrict.includes(el)) {
      //     //     assignedDistrict.push(el)
      //     //   }
      //     // })

      //     // let blocksUnderState = await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
      //     // blocksUnderState.map((el) => {
      //     //   if (!assignedBlock.includes(el)) {
      //     //     assignedBlock.push(el)
      //     //   }
      //     // })
      //     //assignedDistrict = assignedDistrict + await this.districtTableService.getCountUnderAState(el.StateTable.stateId);
      //     //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderAState(el.StateTable.stateId);
      //   }

      //   if (el.accessLevel == "DISTRICT") {
      //     // we will get one state + one districts + all blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //       assignedDistrict.push(el.DistrictTable.districtId)
      //     }

      //     // let blocksUnderState = await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);;
      //     // blocksUnderState.map((el) => {
      //     //   if (!assignedBlock.includes(el)) {
      //     //     assignedBlock.push(el)
      //     //   }
      //     // })
      //     //assignedBlock = assignedBlock + await this.blockTableService.getCountUnderADistrict(el.DistrictTable.districtId);
      //   }

      //   if (el.accessLevel == "BLOCK") {
      //     // we will get one state + one districts + one blocks
      //     if (!assignedState.includes(el.StateTable.stateId)) {
      //       assignedState.push(el.StateTable.stateId)
      //     }
      //     if (!assignedDistrict.includes(el.DistrictTable.districtId)) {
      //       assignedDistrict.push(el.DistrictTable.districtId)
      //     }
      //     if (!assignedBlock.includes(el.BlockTable.blockId)) {
      //       assignedBlock.push(el.BlockTable.blockId)
      //     }

      //   }

      // }


      return {
        
      }

    } else {
      
      return {
        
      }
    }


    






  }


  async getInterventionOfflineDataForEntry(username: string, role: string) {

    return {
    }
  }



  // async getFblpSingleReport(mkId: number) {
  //   console.log("🚀 ~ AppService ~ getFblpSingleReport ~ mkId:", mkId)
  //   // let fblp = await this.fblpTableService.findOneByMkId(mkId);
  //   console.log("🚀 ~ AppService ~ getFblpSingleReport ~ fblp:", fblp)

  //   // generate the pdf with handlebars

  //   // if (fblp) {
     


  //   //   let templateName = 'fblp-single-report';
  //   //   let fileName = `uploads/generated/FBLP_${fblp.fblpId}_${mkId}.pdf`

  //   //   const source = join(__dirname, 'templates', 'reports', 'fblp-single-report');

  //   //   const sourceHtml = readFileSync(`${source}/html.handlebars`, 'utf-8');
  //   //   const template = handlebars.compile(sourceHtml);


  //   //   let fblpSubTableData = [];

  //   //   fblp.FblpSubTable.map((el:FblpSubTable, index: number) => {
  //   //     if(el.IncomeSourceTable.incomeSourceCode == "AGRICULTURE"){
  //   //       fblp.FblpSubTable[index]['isAgriculture'] = true;
  //   //     }

  //   //     if(el.IncomeSourceTable.incomeSourceCode == "LIVESTOCK"){
  //   //       fblp.FblpSubTable[index]['isLivestock'] = true;
  //   //     }

  //   //     if(el.IncomeSourceTable.incomeSourceCode == "FISHERY"){
  //   //       fblp.FblpSubTable[index]['isFishery'] = true;
  //   //     }

  //   //     if(el.IncomeSourceTable.incomeSourceCode == "VERMICOMPOST"){
  //   //       fblp.FblpSubTable[index]['isVermicompost'] = true;
  //   //     }
        
  //   //   })

  //   //   // we have to get the contents of this file


  //   //   let entitlements = await this.mkEntitlementsTableService.findAllByMkIdNew(fblp.MkTable.mkId, "FBLP");
      
  //   //   var result = template({
  //   //     mkName: fblp.MkTable.mkName,
  //   //     mkAge: fblp.MkTable.mkAge,
  //   //     shgName: fblp.MkTable.ShgTable.shgName,
  //   //     voName: fblp.MkTable.ShgTable.VoTable?.voName,
  //   //     villageName: fblp.MkTable.VillageTable.villageName,
  //   //     gpName: fblp.MkTable.VillageTable.GrampanchayatTable.gpName,
  //   //     blockName: fblp.MkTable.VillageTable.GrampanchayatTable.BlockTable.blockName,
  //   //     districtName: fblp.MkTable.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.districtName,
  //   //     stateName: fblp.MkTable.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.StateTable.stateName,
  //   //     FblpSubTable: fblp.FblpSubTable,
  //   //     MkEntitlementsTable: entitlements,
  //   //     entryDate: fblp.entryDate,
  //   //     userName: fblp.UserTable.name
  //   //   });
      

  //   //   return result;
  //   // }else{
  //   //   return false;
  //   // }






  // }


  // async getMkSingleReport(mkId: number) {
  //   // let mk = await this.mkTableService.findOne(mkId);

  //   // generate the pdf with handlebars

  //   if (mk) {
  //    console.log("🚀 ~ file: app.service.ts:533 ~ AppService ~ getMkSingleReport ~ mk:", mk)
     


  //     let templateName = 'mk-single-report';
  //     let fileName = `uploads/generated/MK_REPORT_${mk.mkId}.pdf`

  //     const source = join(__dirname, 'templates', 'reports', 'mk-single-report');

  //     const sourceHtml = readFileSync(`${source}/html.handlebars`, 'utf-8');
  //     const template = handlebars.compile(sourceHtml);


  //     let fblpSubTableData = [];

  //     // let entitlements = await this.mkEntitlementsTableService.findAllByMkIdNew(mk.mkId, "MK");
     

  //     // we have to get the contents of this file
      
  //     // var result = template({
  //     //   mkName: mk.mkName,
  //     //   mkAge: mk.mkAge,
  //     //   villageName: mk.VillageTable.villageName,
  //     //   gpName: mk.VillageTable.GrampanchayatTable.gpName,
  //     //   blockName: mk.VillageTable.GrampanchayatTable.BlockTable.blockName,
  //     //   shgName: mk.ShgTable.shgName,
  //     //   voName: mk.ShgTable.VoTable?.voName,
  //     //   districtName: mk.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.districtName,
  //     //   stateName: mk.VillageTable.GrampanchayatTable.BlockTable.DistrictTable.StateTable.stateName,
        
  //     //   entryDate: mk.entryDate,
  //     //   userName: mk.UserTable.name,
  //     //   ...mk,
  //     //   vulnerabilityCategory: mk.VulnerabilityCategoryTable?.vulcatName,
  //     //   hasPg : mk.isMemberOfPg == "YES" ? true : false,
  //     //   pgName: mk.ProducerGroupTable?.pgName,
  //     //   MkEntitlementsTable: entitlements,
  //     // });
      

  //     // return result;
  //   }else{
  //     return false;
  //   }






  // }

  // async convergenceListDownload(schemeMasterSubId: number, sessionId: number){
  //   return await this.mkEntitlementsTableService.convergenceListDownload(schemeMasterSubId, sessionId)
  // }


  // async getConvergenceReport(sessionId: number){
  //   return await this.mkEntitlementsTableService.getConvergenceReport(sessionId)
  // }

  // async getConvergenceReportIntegrator(sessionId: number, body: any){
  //   return await this.mkEntitlementsTableService.getConvergenceReportIntegrator(sessionId, body)
  // }

  


  // async getInterventionReport(sessionId: number, stateId: number, districtId: number, blockId: number, type: string){
  //   let result = await this.interventionAdoptionTableService.getInterventionAdoptionReport(sessionId, stateId, districtId, blockId, type)


  //   let fblpRepeatCount = await this.fblpTableService.getRepeatAndNewFarmer(result.mkIdData)


  //   let {trainingData} = await this.interventionTableService.getTrainingAndProductionReport(sessionId, blockId,type);


  //   let productionData = await this.interventionProductionSubTableService.getProductionReport(sessionId, blockId, type)

  //   return {
  //     ...result,
  //     ...fblpRepeatCount,
  //     trainingData: sortByCountDescending(trainingData),
  //     productionData
  //   }

  // }


  // async getActivityParticipationList(sessionId: number, page: number, limit: number){
   

  //   // get the table headers
  //   let tableHeaders = await this.incomeSourceTableService.findAllHeader();

  //   // process the data based on interested and adopted
  //   let mkdata = await this.mkTableService.getMkListPaginated(limit, page);


  //   let mkList = await this.interventionAdoptionTableService.checkAdoptedOrNot(mkdata.data, sessionId)

  //   return {
  //     tableHeaders,
  //     data: mkList,
  //     total: mkdata.total
  //   }
  // }


//   async getActivityPlanningReport(sessionId: number, userId: number){


//     let userData = await this.userCollectionService.findOne(userId)


    

//     let annualActivity:any = await this.activityPlanningTableService.findAllActivityPlannerBySessionAndUserVerification(userId, sessionId, "ANNUAL")


//     let annualTarget = 0;
//     let annualAchievement = 0;
//     for(const el of annualActivity){
//       annualTarget += parseFloat(el.nosToBePerformed)
//       annualAchievement += parseFloat(el.nosPerformed)
//     }

//     let firstHalfAcitity: any = await this.activityPlanningTableService.findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, "HALF-YEARLY", 1)

//     let firstHalfTarget = 0;
//     let firstHalfAchievement = 0;
//     for(const el of firstHalfAcitity){
//       firstHalfTarget += parseFloat(el.nosToBePerformed)
//       firstHalfAchievement += parseFloat(el.nosPerformed)
//     }


//     let secondHalfAcitity: any = await this.activityPlanningTableService.findAllActivityPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, "HALF-YEARLY", 2)

//     let secondHalfTarget = 0;
//     let secondHalfAchievement = 0;
//     for(const el of secondHalfAcitity){
//       secondHalfTarget += parseFloat(el.nosToBePerformed)
//       secondHalfAchievement += parseFloat(el.nosPerformed)
//     }


//     let overallTarget = [];


//     for(const el of annualActivity){

//       let anTarget = el.nosToBePerformed;
//       let fhTarget = 0;
//       let shTarget = 0;

//       let nosPerformed = el.nosPerformed

//       // get the halfyearly target
//       let ff = firstHalfAcitity.find((el1) => el1.ActivityTable.activityId === el.ActivityTable.activityId)

//       if(ff){
//         fhTarget = ff.nosToBePerformed;
//       }

//       // get the halfyearly target
//       let ff1 = secondHalfAcitity.find((el1) => el1.ActivityTable.activityId === el.ActivityTable.activityId)

//       if(ff1){
//         shTarget = ff1.nosToBePerformed;
//       }

//       overallTarget.push({
//         ...el.ActivityTable,
//         anTarget,
//         fhTarget,
//         shTarget,
//         nosPerformed
//       })

//     }
//     // get all the months of this session

//     let monthData = [];

//     let monthList = await this.sessionmasterTableService.getListOfMonthsFromSession(sessionId)

//     for(const ml of monthList){
//       let md = await this.activityPlanningTableService.findAllActivityPlannerMonthlyBySessionAndUserReports(userId,sessionId,"MONTHLY", ml)

//       monthData.push({
//         month: ml,
//         data: md
//       })
//     }





//     // Task Planning


//     let annualTask:any = await this.taskPlanningTableService.findAllTaskPlannerBySessionAndUserVerification(userId, sessionId, "ANNUAL")


//     let annualTargetTask = 0;
//     let annualAchievementTask = 0;
//     for(const el of annualTask){
//       annualTargetTask += parseFloat(el.nosToBePerformed)
//       annualAchievementTask += parseFloat(el.nosPerformed)
//     }

//     let firstHalfTask: any = await this.taskPlanningTableService.findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, "HALF-YEARLY", 1)

//     let firstHalfTargetTask = 0;
//     let firstHalfAchievementTask = 0;
//     for(const el of firstHalfTask){
//       firstHalfTargetTask += parseFloat(el.nosToBePerformed)
//       firstHalfAchievementTask += parseFloat(el.nosPerformed)
//     }


//     let secondHalfTask: any = await this.taskPlanningTableService.findAllTaskPlannerHalfYearlyBySessionAndUserVerification(userId, sessionId, "HALF-YEARLY", 2)

//     let secondHalfTargetTask = 0;
//     let secondHalfAchievementTask = 0;
//     for(const el of secondHalfTask){
//       secondHalfTargetTask += parseFloat(el.nosToBePerformed)
//       secondHalfAchievementTask += parseFloat(el.nosPerformed)
//     }



//     let overallTaskTarget = [];


//     for(const el of annualTask){

//       let anTarget = el.nosToBePerformed;
//       let fhTarget = 0;
//       let shTarget = 0;

//       let nosPerformed = el.nosPerformed

//       // get the halfyearly target
//       let ff = firstHalfTask.find((el1) => el1.ActivityTable.activityId === el.ActivityTable.activityId)

//       if(ff){
//         fhTarget = ff.nosToBePerformed;
//       }

//       // get the halfyearly target
//       let ff1 = secondHalfTask.find((el1) => el1.ActivityTable.activityId === el.ActivityTable.activityId)

//       if(ff1){
//         shTarget = ff1.nosToBePerformed;
//       }

//       overallTaskTarget.push({
//         ...el.TaskTable,
//         anTarget,
//         fhTarget,
//         shTarget,
//         nosPerformed
//       })

//     }

// // get all the months of this session

// let monthDataTask = [];


// for(const ml of monthList){
//   let md = await this.taskPlanningTableService.findAllTaskPlannerMonthlyBySessionAndUserReports(userId,sessionId,"MONTHLY", ml)

//   monthDataTask.push({
//     month: ml,
//     data: md
//   })
// }

//     return {
//       annualActivity : {
//         target: annualTarget,
//         achievement: annualAchievement
//       }, 
//       overallTarget: overallTarget,
//       firstHalfAcitity : {
//         target: firstHalfTarget,
//         annualTarget: annualTarget,
//         achievement: firstHalfAchievement
//       },
      
//       secondHalfAcitity : {
//         target: secondHalfTarget,
//         annualTarget: annualTarget,
//         achievement: secondHalfAchievement
//       },
//       overallTaskTarget,
//       annualTask : {
//         target: annualTargetTask,
//         achievement: annualAchievementTask
//       }, 
//       firstHalfTask : {
//         target: firstHalfTargetTask,
//         annualTarget: annualTargetTask,
//         achievement: firstHalfAchievementTask
//       },
//       secondHalfTask : {
//         target: secondHalfTargetTask,
//         annualTarget: annualTargetTask,
//         achievement: secondHalfAchievementTask
//       },
//       userData,
//       monthData,
//       monthDataTask,
//     }
//   }


}
