import { Module, forwardRef } from '@nestjs/common';
import { AssessmentAnswerTableService } from './assessment-answer-table.service';
import { AssessmentAnswerTableResolver } from './assessment-answer-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { AssessmentAnswerTable } from './entities/assessment-answer-table.entity';
import { AssessmentMasterTableModule } from 'src/assessment-master-table/assessment-master-table.module';
import { AssessmentQuestionsTableModule } from 'src/assessment-questions-table/assessment-questions-table.module';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';
import { CourseProgressionTableModule } from 'src/course-progression-table/course-progression-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([AssessmentAnswerTable]) , AssessmentMasterTableModule, AssessmentQuestionsTableModule, UserCollectionModule, forwardRef(() => CourseProgressionTableModule)],
  providers: [AssessmentAnswerTableResolver, AssessmentAnswerTableService],
  exports: [AssessmentAnswerTableService]
})
export class AssessmentAnswerTableModule {}
