import { AssessmentMasterTable } from 'src/assessment-master-table/entities/assessment-master-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class AssessmentAnswerTable {
  @PrimaryGeneratedColumn()
  answerId: number;

  @Column({ nullable: true, length: 50 })
  assessmentDate: string;

  @Column()
  score: string;


  @Column({default: 1})
  attempt: number;

  @Column("simple-json", { nullable: true })
  answers: any[];

  @ManyToOne(type => AssessmentMasterTable, dt => dt.AssessmentAnswerTable)
  @JoinColumn({ name: "assessmentId" })
  AssessmentMasterTable: AssessmentMasterTable;


  @ManyToOne(type => UserTable, dt => dt.AssessmentAnswerTable)
  @JoinColumn({ name: "userId" })
  UserTable: UserTable;

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
