import { Int, Field, ObjectType } from '@nestjs/graphql';
import { AssessmentMasterTableType } from 'src/assessment-master-table/types/assessment-master-table.type';
import { UserCollectionType } from 'src/user-collection/type/user-collection.type';



@ObjectType("AssessmentAnswersDto")
export class AssessmentAnswersDto {

  @Field(() => Int)
  assessmentQuestionId: number;

  @Field(() => String)
  value: string;
}

@ObjectType("AssessmentAnswersTableType")
export class AssessmentAnswersTableType {

  @Field(() => Int)
  answerId: number;


  @Field(() => String, {nullable: true})
  assessmentDate: string;

  @Field(() => String, {nullable: true})
  score: string;

  @Field(() => Number, {nullable: true})
  attempt: number;



  @Field(() => [AssessmentAnswersDto])
  answers: AssessmentAnswersDto[];

  @Field(() => AssessmentMasterTableType, {nullable: true})
  AssessmentMasterTable: AssessmentMasterTableType;

  @Field(() => UserCollectionType, {nullable: true})
  UserTable: UserCollectionType;
}
