import { Module, forwardRef } from '@nestjs/common';
import { AssessmentMasterTableService } from './assessment-master-table.service';
import { AssessmentMasterTableResolver } from './assessment-master-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { AssessmentMasterTable } from './entities/assessment-master-table.entity';
import { CourseUnitTableModule } from 'src/course-unit-table/course-unit-table.module';
import { CourseProgressionTableModule } from 'src/course-progression-table/course-progression-table.module';
import { CourseTableModule } from 'src/course-table/course-table.module';
import { AssessmentAnswerTableModule } from 'src/assessment-answer-table/assessment-answer-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([AssessmentMasterTable]), forwardRef(() => CourseTableModule), forwardRef(() => CourseProgressionTableModule), forwardRef(() => AssessmentAnswerTableModule)],
  providers: [AssessmentMasterTableResolver, AssessmentMasterTableService],
  exports: [AssessmentMasterTableService]
})
export class AssessmentMasterTableModule {}
