import { AssessmentAnswerTable } from 'src/assessment-answer-table/entities/assessment-answer-table.entity';
import { AssessmentQuestionsTable } from 'src/assessment-questions-table/entities/assessment-questions-table.entity';
import { CourseTable } from 'src/course-table/entities/course-table.entity';
import { CourseUnitTable } from 'src/course-unit-table/entities/course-unit-table.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class AssessmentMasterTable {
  @PrimaryGeneratedColumn()
  assessmentId: number;

  @Column({ length: 300 })
  assessmentName: string;

  @Column({ length: 50 })
  type: string;

  @Column({ length: 50, nullable: true })
  totalScore: string;

  @Column({ length: 50, nullable: true })
  passingScore: string;

  @Column({ nullable: true })
  duration: number;


  @Column({ nullable: true })
  week: number;

  @Column({ default: true })
  isActive: boolean;

  @OneToMany(type => AssessmentAnswerTable, et => et.AssessmentMasterTable)
  AssessmentAnswerTable: AssessmentAnswerTable[];


  @OneToMany(type => AssessmentQuestionsTable, et => et.AssessmentMasterTable)
  AssessmentQuestionsTable: AssessmentQuestionsTable[];

  @ManyToOne(type => CourseTable, dt => dt.AssessmentMasterTable)
  @JoinColumn({ name: "courseId"})
  CourseTable: CourseTable;

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
