import { Field, ObjectType } from '@nestjs/graphql';
import { AssessmentQuestionsTableType } from 'src/assessment-questions-table/types/assessment-questions-table.type';
import { CourseTableType } from 'src/course-table/types/course-table.type';
import { CourseUnitTableType } from 'src/course-unit-table/types/course-unit-table.type';

@ObjectType("AssessmentMasterTableType")
export class AssessmentMasterTableType {

  @Field(() => Number)
  assessmentId: number;

  @Field(() => String)
  assessmentName: string;

  @Field(() => String)
  type: string;

  @Field(() => Number)
  duration: number;

  @Field(() => String, {nullable: true})
  totalScore: string;

  @Field(() => String, {nullable: true})
  passingScore: string;
  
  @Field(() => Boolean, {nullable: true})
  isActive?: boolean;

  @Field(() => Boolean, {nullable: true})
  isAllowed?: boolean;
  
  @Field(() => Number, {nullable: true})
  score?: number;
  
  @Field(() => Number, {nullable: true})
  week?: number;

  
  @Field(() => CourseTableType, {nullable: true})
  CourseTable: CourseTableType;

  @Field(() => [AssessmentQuestionsTableType], {nullable: true})
  AssessmentQuestionsTable: AssessmentQuestionsTableType[];

  
}