import { ObjectType, Field, Int } from '@nestjs/graphql';
import { AssessmentMasterTable } from 'src/assessment-master-table/entities/assessment-master-table.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class AssessmentQuestionsTable {
  @PrimaryGeneratedColumn()
  assessmentQuestionId: number;

  @Column()
  assessmentQuestionLabel: number;

  @Column({nullable: true, type: "text"})
  assessmentQuestionEn: string;

  @Column({nullable: true, type: "text"})
  assessmentQuestionAs: string;


  @Column({nullable: true, length: 50})
  correctAnswer: string;


  @Column({nullable: true})
  marks: number;

  @Column("simple-json", {nullable:true})
  options: any[];

  @ManyToOne(type => AssessmentMasterTable, dt => dt.AssessmentQuestionsTable)
  @JoinColumn({ name: "assessmentId"})
  AssessmentMasterTable: AssessmentMasterTable;

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
