import { Int, Field, ObjectType } from '@nestjs/graphql';
import { AssessmentMasterTableType } from 'src/assessment-master-table/types/assessment-master-table.type';

@ObjectType('AssessmentQuestionOptionType')
export class AssessmentQuestionOptionType {
  @Field(() => String)
  optionLabel: string;

  @Field(() => String)
  optionText: string;


}

@ObjectType('AssessmentQuestionsTableType')
export class AssessmentQuestionsTableType {
  @Field(() => Int)
  assessmentQuestionId: number;

  @Field(() => Int)
  assessmentQuestionLabel: number;

  @Field(() => String)
  assessmentQuestionEn: string;

  @Field(() => Int)
  marks: number;

  @Field(() => String)
  correctAnswer: string;

  @Field(() => String, {nullable: true})
  assessmentQuestionAs: string;

  @Field(() => [AssessmentQuestionOptionType])
  options: AssessmentQuestionOptionType[];

  @Field(() => AssessmentMasterTableType, {nullable: true})
  AssessmentMasterTable: AssessmentMasterTableType;
}
