import { Module } from '@nestjs/common';
import { AuthService } from './auth.service';
import { JwtStrategy } from './strategy/jwt.strategy';
import { PassportModule } from '@nestjs/passport';
import { JwtModule } from '@nestjs/jwt';
import { jwtConstants } from './constants';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';
import { AccessTableModule } from 'src/access-table/access-table.module';
//import { RegistrationTableModule } from 'src/registration-table/registration-table.module';

@Module({
  providers: [AuthService, JwtStrategy],
  imports: [
    UserCollectionModule,
    PassportModule.register({defaultStrategy: 'jwt'}),
    JwtModule.register({
      secret: jwtConstants.secret,
      signOptions: { expiresIn: '365d'}
    }),
    AccessTableModule
  // EmployeeTableModule,
  // CollegeMasterModule,
  ],
  exports: [AuthService]
})
export class AuthModule {}
