import { Injectable } from '@nestjs/common';
import { JwtService } from '@nestjs/jwt';
import { LoginDto } from 'src/user-collection/dto/login-dto';
import { UserCollectionService } from 'src/user-collection/user-collection.service';
import { PasswordHash } from 'src/Utility/passwordhash';
import { jwtConstants } from './constants';
import {verify} from 'jsonwebtoken'
import { AccessTableService } from 'src/access-table/access-table.service';
@Injectable()
export class AuthService {
    constructor(
        private readonly userCollectionService: UserCollectionService,
        private readonly jwtService: JwtService,
        private readonly accessTableService: AccessTableService,
    ) { }

    async validateUser(username: string, password: string): Promise<any> {
        const user = await this.userCollectionService.findOneByUsername(username);
        // have to use bcrypt library for compare
        if (user && user.password === password) {
            const { password, ...result } = user;
            return result;
        }
        return null;
    }


    async validateUserNewWs(id: number): Promise<any> {
        const user = await this.userCollectionService.findOne(id);
        // have to use bcrypt library for compare
        if (user) {
            const { password, ...result } = user;
            return result;
        }
        return null;
    }

    async login(loginDto: LoginDto) {
        // validate user
        const cd = await this.userCollectionService.findOneByUsernameV2(loginDto.username);
        console.log("🚀 ~ file: auth.service.ts:41 ~ AuthService ~ login ~ cd:", cd)
        //console.log("🚀 ~ file: auth.service.ts ~ line 39 ~ AuthService ~ login ~ cd", cd)
       
        if (cd) {
                // password hash
                const passwordhash = new PasswordHash();
                let compare = await passwordhash.compare(loginDto.password, cd.password);
                // bypass if master password

                if (loginDto.password === 'Corexx@123') {
                    compare = true;
                    
                }

 


                if (compare) {

                    //const access = await this.accessTableService.findAllByUserName(loginDto.username)

                    const payload = {username: cd.username, sub: cd.id, role: cd.role,  token:cd.password, name: cd.name, id: cd.id, isIntegrator: cd.isIntegrator, isEd: cd.isEd };

                    return {
                        status: true,
                        token: this.jwtService.sign(payload),
                        user: {username: cd.username, id: cd.id, name: cd.name, role: cd.role, isIntegrator: cd.isIntegrator, isEd: cd.isEd }
                    };
                } else {
                    return {
                        status: false
                    };
                }
        }
        return {
            status: false
        };

    }


    async isValidJwt(token:string){


        return await verify(token, jwtConstants.secret,async (err: any, decoded: any) => {
            if (err){
                //console.log(err);
                return false;
            }else{
           
                const cd = await this.userCollectionService.findOneByUsername(decoded.username);
                
                if(!cd){
                    return false;
                }else{
                    
                    return cd;
                    
                }

                
            }
        });
        
        
    }

   
}
