import { CanActivate, ExecutionContext, Injectable } from "@nestjs/common";
import { Reflector } from "@nestjs/core";
import { GqlExecutionContext } from "@nestjs/graphql";
import { ROLES_KEY } from "src/user-collection/decorators/roles.decorator";
import { Role } from "src/user-collection/roles/role.enum";

@Injectable()
export class RolesGuard implements CanActivate {
    constructor(private reflector: Reflector) {}

    // canActivate(context: ExecutionContext) {
    //     // const roles = this.reflector.get<string[]>("roles", context.getHandler());
    //     // const ctx = GqlExecutionContext.create(context);
    //     // // console.log("roles: ", roles);
    //     // //console.log("context: ", context.switchToHttp().getRequest());
    //     // //console.log("gqlContext: ", ctx.getContext().req.user);

    //     // return true;
        

    //     const requiredRoles = this.reflector.getAllAndOverride<Role[]>(ROLES_KEY, [
    //         context.getHandler(),
    //         context.getClass(),
    //       ]);
    //       if (!requiredRoles) {
    //         return true;
    //       }
    //       const ctx = GqlExecutionContext.create(context);
    //       const { user } = ctx.getContext().req;
    //       return requiredRoles.some((role) => user.roles?.includes(role));
    // }

    canActivate(context: ExecutionContext): boolean {
        const ctx = GqlExecutionContext.create(context);
    
        const requiredRoles = this.reflector.getAllAndOverride<Role[]>(ROLES_KEY, [
          context.getHandler(),
          context.getClass(),
        ]);
    
        if (!requiredRoles) {
          return true;
        }
    
        const { user } = ctx.getContext().req;
        return requiredRoles.some((role) => user.role == role);
      }
}