import { Module, forwardRef } from '@nestjs/common';
import { CourseProgressionTableService } from './course-progression-table.service';
import { CourseProgressionTableResolver } from './course-progression-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { CourseProgressionTable } from './entities/course-progression-table.entity';
import { CourseUnitTableModule } from 'src/course-unit-table/course-unit-table.module';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';
import { AssessmentAnswerTableModule } from 'src/assessment-answer-table/assessment-answer-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([CourseProgressionTable]), forwardRef(() => CourseUnitTableModule), forwardRef(() => UserCollectionModule), forwardRef(() => AssessmentAnswerTableModule)],
  providers: [CourseProgressionTableResolver, CourseProgressionTableService],
  exports: [CourseProgressionTableService]
})
export class CourseProgressionTableModule {}
