import { CourseUnitTable } from 'src/course-unit-table/entities/course-unit-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, NoNeedToReleaseEntityManagerError, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class CourseProgressionTable {
  @PrimaryGeneratedColumn()
  courseProgressionId: number;


  @ManyToOne(type => CourseUnitTable, dt => dt.CourseProgressionTable)
  @JoinColumn({ name: "courseUnitId"})
  CourseUnitTable: CourseUnitTable;


  @ManyToOne(type => UserTable, dt => dt.CourseProgressionTable)
  @JoinColumn({ name: "userId"})
  UserTable: UserTable;

  @Column({ nullable: true, default: 0 })
  isComplete: number;

  @Column({ nullable: true, default: 0 })
  week: number;


  @Column({ nullable: true, default: 0 })
  canTakeAssesment: number;

  @Column({ nullable: true, default: 0 })
  assesmentTaken: number;


  @Column({ nullable: true, length: 100 })
  assesmentTakenOn: string;


  @Column({ nullable: true, length: 100, default: "COURSE" })
  type: string;


  @Column({ nullable: true, default: 0 })
  assesmentScore: number;


  @Column({ nullable: true, default: 0 })
  assesmentStatus: number;


  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
