import { Field, ObjectType } from '@nestjs/graphql';
import { AssessmentAnswerTable } from 'src/assessment-answer-table/entities/assessment-answer-table.entity';
import { AssessmentAnswersTableType } from 'src/assessment-answer-table/types/assessment-answer-table.type';
import { CourseUnitTableType } from 'src/course-unit-table/types/course-unit-table.type';
import { UserCollectionType } from 'src/user-collection/type/user-collection.type';

@ObjectType("CourseProgressionTableType")
export class CourseProgressionTableType {
  @Field(() => Number)
  courseProgressionId: number;

  @Field(() => CourseUnitTableType, {nullable: true})
  CourseUnitTable: CourseUnitTableType;

  @Field(() => UserCollectionType, {nullable: true})
  UserTable: UserCollectionType;

  @Field(() => Number, {nullable: true})
  isComplete: number;

 
  @Field(() => Number, {nullable: true})
  canTakeAssesment: number;

  @Field(() => Number, {nullable: true})
  assesmentTaken: number;

  @Field(() => String, {nullable: true})
  assesmentTakenOn: string;

  @Field(() => Number, {nullable: true})
  assesmentScore: number;

  @Field(() => Number, {nullable: true})
  assesmentStatus: number;

  @Field(() => [AssessmentAnswersTableType], {nullable: true})
  AssessmentAnswersTable: AssessmentAnswersTableType[];

}