import { Module, forwardRef } from '@nestjs/common';
import { CourseSessionTableService } from './course-session-table.service';
import { CourseSessionTableResolver } from './course-session-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { CourseSessionTable } from './entities/course-session-table.entity';
import { CourseTableModule } from 'src/course-table/course-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([CourseSessionTable]), forwardRef(() => CourseTableModule)],
  providers: [CourseSessionTableResolver, CourseSessionTableService],
  exports: [CourseSessionTableService]
})
export class CourseSessionTableModule {}
