import { CourseTable } from 'src/course-table/entities/course-table.entity';
import { SubscriptionTable } from 'src/subscription-table/entities/subscription-table.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class CourseSessionTable {
  @PrimaryGeneratedColumn()
  courseSessionId: number;


  @ManyToOne(type => CourseTable, pt => pt.CourseSessionTable)
  @JoinColumn({ name: 'courseId' })
  CourseTable: CourseTable;

  @Column({ length: 300 })
  sessionName: string;


  @Column({ length: 300, nullable: true })
  sessionStartingDate: string;

  @Column({ length: 300, nullable: true })
  sessionEndingDate: string;

  @Column({ nullable: true })
  capacity: number;

  @Column({ nullable: true, default: 0 })
  isEnrollmentOpen: number;

  @OneToMany(type => SubscriptionTable, pt => pt.CourseSessionTable)
  SubscriptionTable: SubscriptionTable[];

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
