import { Field, ObjectType } from '@nestjs/graphql';
import { CourseTableType } from 'src/course-table/types/course-table.type';
import { CourseUnitTableType } from 'src/course-unit-table/types/course-unit-table.type';

@ObjectType("CourseSessionTableType")
export class CourseSessionTableType {
  @Field(() => Number)
  courseSessionId: number;

  @Field(() => String)
  sessionName: string;

  @Field(() => Number, {nullable:true})
  capacity: number;

  @Field(() => Number, {nullable:true})
  isEnrollmentOpen: number;

  @Field(() => String, {nullable:true})
  sessionStartingDate: string;

  @Field(() => String, {nullable:true})
  sessionEndingDate: string;
 
  @Field(() => CourseTableType, {nullable: true})
  CourseTable: CourseTableType;
}