import { Module, forwardRef } from '@nestjs/common';
import { CourseTableService } from './course-table.service';
import { CourseTableResolver } from './course-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { CourseTable } from './entities/course-table.entity';
import { FileTableModule } from 'src/file-table/file-table.module';
import { SubscriptionTableModule } from 'src/subscription-table/subscription-table.module';
import { CourseUnitTableModule } from 'src/course-unit-table/course-unit-table.module';
import { CourseProgressionTableModule } from 'src/course-progression-table/course-progression-table.module';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';
import { CourseSessionTableModule } from 'src/course-session-table/course-session-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([CourseTable]), forwardRef(() => FileTableModule), forwardRef(() => SubscriptionTableModule), forwardRef(() => CourseUnitTableModule), forwardRef(() => CourseProgressionTableModule), forwardRef(() => UserCollectionModule), forwardRef(() => CourseSessionTableModule)],
  providers: [CourseTableResolver, CourseTableService],
  exports: [CourseTableService]
})
export class CourseTableModule {}
