import { Field, ObjectType } from '@nestjs/graphql';
import { CourseSessionTable } from 'src/course-session-table/entities/course-session-table.entity';
import { CourseSessionTableType } from 'src/course-session-table/types/course-session-table.type';
import { CourseUnitTableType } from 'src/course-unit-table/types/course-unit-table.type';
import { UserCollectionType } from 'src/user-collection/type/user-collection.type';

@ObjectType("CourseTableNewType")
export class CourseTableType {
  @Field(() => Number)
  courseId: number;

  @Field(() => String)
  courseName: string;

  @Field(() => String, {nullable:true})
  courseCode: string;

  @Field(() => String, {nullable:true})
  courseDescription: string;

  @Field(() => String, {nullable:true})
  courseDuration: string;

  @Field(() => String, {nullable: true})
  courseType: string;

  @Field(() => String, {nullable: true})
  hasAssesment: string;

  @Field(() => String, {nullable: true})
  isActive: string;

  @Field(() => String, {nullable: true})
  courseBanner: string;

  @Field(() => String, {nullable: true})
  courseBannerUrl: string;

  @Field(() => Number, {nullable: true})
  courseUnitCount: number;

  @Field(() => Number, {nullable: true})
  courseUnitPages: number;

  @Field(() => Boolean, {nullable: true})
  isAllowed: boolean;
  
  @Field(() => UserCollectionType, {nullable: true})
  UserTable: UserCollectionType;

  @Field(() => [CourseUnitTableType], {nullable: true})
  CourseUnitTable: CourseUnitTableType[];

  @Field(() => [CourseSessionTableType], {nullable: true})
  CourseSessionTable: CourseSessionTableType[];


  @Field(() => [CourseTableWeekType], {nullable: true})
  CourseTableWeek: CourseTableWeekType[];
}


@ObjectType("CourseTableWeekType")
export class CourseTableWeekType {
  @Field(() => Number, {nullable: true})
  week: number;

  @Field(() => [CourseUnitTableType], {nullable: true})
  CourseUnitTable: CourseUnitTableType[];
}