import { Field, ObjectType } from '@nestjs/graphql';
import { AssessmentMasterTableType } from 'src/assessment-master-table/types/assessment-master-table.type';
import { CourseSessionTableType } from 'src/course-session-table/types/course-session-table.type';
import { CourseUnitTableType } from 'src/course-unit-table/types/course-unit-table.type';
import { UserCollectionType } from 'src/user-collection/type/user-collection.type';

@ObjectType("CourseTableType")
export class CourseTableType {
  @Field(() => Number)
  courseId: number;

  @Field(() => String)
  courseName: string;

  @Field(() => String, {nullable:true})
  courseCode: string;

  @Field(() => String, {nullable:true})
  courseDescription: string;

  @Field(() => String, {nullable:true})
  courseDuration: string;

  @Field(() => String, {nullable: true})
  courseType: string;

  @Field(() => String, {nullable: true})
  hasAssesment: string;

  @Field(() => String, {nullable: true})
  isActive: string;

  @Field(() => String, {nullable: true})
  courseBanner: string;

  @Field(() => String, {nullable: true})
  courseBannerUrl: string;

  

  @Field(() => Number, {nullable: true})
  courseUnitCount: number;

  @Field(() => Number, {nullable: true})
  courseUnitPages: number;

  @Field(() => Boolean, {nullable: true})
  isAllowed: boolean;
  
  @Field(() => UserCollectionType, {nullable: true})
  UserTable: UserCollectionType;

  @Field(() => [CourseUnitTableType], {nullable: true})
  CourseUnitTable: CourseUnitTableType[];

  @Field(() => [CourseSessionTableType], {nullable: true})
  CourseSessionTable: CourseSessionTableType[];

  @Field(() => [AssessmentMasterTableType], {nullable: true})
  AssessmentMasterTable: AssessmentMasterTableType[];

  
}