import { Module, forwardRef } from '@nestjs/common';
import { CourseUnitTableService } from './course-unit-table.service';
import { CourseUnitTableResolver } from './course-unit-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { CourseUnitTable } from './entities/course-unit-table.entity';
import { CourseTableModule } from 'src/course-table/course-table.module';
import { FileTableModule } from 'src/file-table/file-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([CourseUnitTable]), forwardRef(() => CourseTableModule), forwardRef(() => FileTableModule)],
  providers: [CourseUnitTableResolver, CourseUnitTableService],
  exports: [CourseUnitTableService]
})
export class CourseUnitTableModule {}
