import { InputType, Int, Field } from '@nestjs/graphql';

@InputType()
export class CreateCourseUnitTableInput {
  @Field(() => Number)
  courseId: number;

  @Field(() => Number)
  week: number;

  @Field(() => String)
  courseUnitName: string;

  @Field(() => String, {nullable: true})
  courseUnitDescription: string;

  @Field(() => Int, {nullable: true})
  courseUnitDuration: number;


  @Field(() => String, {nullable: true})
  courseUnitBanner: string;

  @Field(() => String)
  courseFile?: string;

  @Field(() => Int, {nullable: true})
  numberOfPages?: number;

  @Field(() => Int, {nullable: true})
  weightOfPercentage?: number;

  @Field(() => String, {nullable: true})
  hasAssesment?: string;

  @Field(() => String, {nullable: true})
  link: string;

  @Field(() => String, {nullable: true})
  isLink: string;

  @Field(() => Int, {nullable: true})
  totalScore?: number;

  @Field(() => Int, {nullable: true})
  passingScore?: number;
}
