import { AssessmentMasterTable } from 'src/assessment-master-table/entities/assessment-master-table.entity';
import { CourseProgressionTable } from 'src/course-progression-table/entities/course-progression-table.entity';
import { CourseTable } from 'src/course-table/entities/course-table.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class CourseUnitTable {
  @PrimaryGeneratedColumn()
  courseUnitId: number;


  @ManyToOne(type => CourseTable, pt => pt.CourseUnitTable)
  @JoinColumn({ name: 'courseId' })
  CourseTable: CourseTable;


  @Column({ nullable: true, default: 1 })
  week: number;

  @Column({ length: 300 })
  courseUnitName: string;

  @Column({ length: 1200, nullable: true })
  courseUnitDescription: string;

  @Column({ nullable: true })
  courseUnitDuration: number;


  @Column({ length: 300, nullable: true })
  courseUnitBanner: string;

  @Column({ length: 300, nullable: true })
  courseFile: string;

  @Column({ length: 50, default: "FREE" })
  courseUnitType: string;

  @Column({ default: 1, nullable: true })
  numberOfPages: number;


  @Column({ length: 50, default: "NO" })
  isLink: string;


  @Column({ type: "text", nullable: true })
  link: string;

  @Column({ length: 50, default: "NO" })
  hasAssesment: string;

  @Column({ default: 0, nullable: true })
  totalScore: number;

  @Column({ default: 0, nullable: true })
  passingScore: number;

  @Column({ default: 0, nullable: true })
  weightOfPercentage: number;


  


  @OneToMany(type => CourseProgressionTable, et => et.CourseUnitTable)
  CourseProgressionTable: CourseProgressionTable[];

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
