import { Field, ObjectType } from '@nestjs/graphql';
import { CourseProgressionTableType } from 'src/course-progression-table/types/course-progression-table.type';
import { CourseTableType } from 'src/course-table/types/course-table.type';

@ObjectType("CourseUnitTableType")
export class CourseUnitTableType {
  @Field(() => Number)
  courseUnitId: number;

  @Field(() => Number, {nullable: true})
  week: number;

  @Field(() => String)
  courseUnitName: string;

  @Field(() => String, {nullable: true})
  courseFile: string;

  @Field(() => String, {nullable: true})
  courseFileUrl: string;


  @Field(() => String, {nullable: true})
  courseUnitBanner: string;

  @Field(() => String, {nullable: true})
  courseUnitBannerUrl: string;

  @Field(() => String, {nullable:true})
  courseUnitDescription: string;

  @Field(() => String, {nullable:true})
  courseUnitDuration: string;

  @Field(() => String, {nullable: true})
  courseUnitType: string;

  @Field(() => Number, {nullable: true})
  weightOfPercentage: number;

  @Field(() => Number, {nullable: true})
  numberOfPages: number;


  @Field(() => Number, {nullable: true})
  totalScore: number;

  @Field(() => Number, {nullable: true})
  passingScore: number;

  @Field(() => String, {nullable: true})
  hasAssesment: string;

  @Field(() => String, {nullable: true})
  link: string;

  @Field(() => String, {nullable: true})
  isLink: string;

  @Field(() => Boolean, {nullable: true})
  isAllowedUnit?: boolean;
  


  @Field(() => CourseTableType, {nullable: true})
  CourseTable: CourseTableType;

  @Field(() => CourseProgressionTableType, {nullable: true})
  CourseProgressionTable: CourseProgressionTableType;
}