import { CourseTable } from 'src/course-table/entities/course-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class DiscussionTable {
  @PrimaryGeneratedColumn()
  discussionId: number;


  @ManyToOne(type => CourseTable, pt => pt.DiscussionTable)
  @JoinColumn({ name: 'courseId' })
  CourseTable: CourseTable;

  @Column({ type: "text", nullable: true })
  message: string;

  
  @ManyToOne(type => UserTable, pt => pt.DiscussionTable)
  @JoinColumn({ name: 'userId' })
  UserTable: UserTable;


  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
