import { Module, forwardRef } from '@nestjs/common';
import { FileTableService } from './file-table.service';
import { FileTableController } from './file-table.controller';
import { TypeOrmModule } from '@nestjs/typeorm';
import { FileTable } from './file-table.entity';
import { CourseTableModule } from 'src/course-table/course-table.module';


@Module({
  imports: [TypeOrmModule.forFeature([FileTable]), forwardRef(() => CourseTableModule)],
  providers: [FileTableService],
  controllers: [FileTableController],
  exports: [FileTableService]
})
export class FileTableModule {}
