import { MailerService } from '@nestjs-modules/mailer';
import { Injectable } from '@nestjs/common';

@Injectable()
export class MailService {
    constructor(private mailerService: MailerService) {}

    async forgotPasswordOTp({
        toEmail,
        otp,
        name
      }) {
        try{
          await this.mailerService.sendMail({
            to: toEmail,
            from: '"SeSTA MIS" <notifications@sesta.org>',
            subject: `OTP for Password Recovery`,
            template: './forgot-password-otp',
            context: {
              otp,
              name
            },
          })
        }catch(err:any){
          console.log(err)
        }
       
      }


}
