import { NestFactory } from '@nestjs/core';
import { AppModule } from './app.module';
import * as bodyParser from 'body-parser';
import  compression from 'compression';
//import * as rateLimit from 'express-rate-limit';
//const rateLimit = require('express-rate-limit')
const helmet = require('helmet')
//import * as helmet from 'helmet';


import * as fs from 'fs'
import { join } from 'path'

import { ValidationPipe } from '@nestjs/common';


export const PORT = 9000;
export const PORT1 = 9001;

// const app = express();



async function bootstrap() {
  try {
    // const httpsOptions = {
    //   key: fs.readFileSync(join(__dirname, '..', 'encryption/private.key')),
    //   cert: fs.readFileSync(join(__dirname, '..', 'encryption/primary.crt')),
    // };
    // const nestApp = await NestFactory.create(AppModule, {httpsOptions});
    const nestApp = await NestFactory.create(AppModule);
    // nestApp.use(helmet({
      
    // }))
    
    nestApp.use(compression({ filter: shouldCompress }))
      // .use(rateLimit({
      //   windowMs: 1 * 60 * 1000, // 15 minutes
      //   max: 50000 // limit each IP to 100 requests per windowMs
      // }))
      .use(bodyParser.json({limit: '50mb'}))
      .use(
        bodyParser.urlencoded({
          extended: true,
          limit: '50mb'
        })
      )
      
    

    nestApp.useGlobalPipes(new ValidationPipe({
      transform: true,
      transformOptions: {
        enableImplicitConversion: true
      },
    }))

    nestApp.setGlobalPrefix(`api`)
    nestApp.enableCors();
    await nestApp.listen(PORT);
  } catch (err) {
    throw new Error(err);
  }
}
bootstrap();



async function bootstrap1() {
  try {
    const httpsOptions = {
      key: fs.readFileSync('/etc/letsencrypt/live/sesta.in/privkey.pem'),
      cert: fs.readFileSync('/etc/letsencrypt/live/sesta.in/fullchain.pem'),
    };
    const nestApp = await NestFactory.create(AppModule, {httpsOptions});
    //const nestApp = await NestFactory.create(AppModule);
    // nestApp.use(helmet({
      
    // }))
    
    nestApp.use(compression({ filter: shouldCompress }))
      // .use(rateLimit({
      //   windowMs: 1 * 60 * 1000, // 15 minutes
      //   max: 50000 // limit each IP to 100 requests per windowMs
      // }))
      .use(bodyParser.json({limit: '50mb'}))
      .use(
        bodyParser.urlencoded({
          extended: true,
          limit: '50mb'
        })
      )
    
    nestApp.useGlobalPipes(new ValidationPipe({
      transform: true,
      transformOptions: {
        enableImplicitConversion: true
      },
    }))

    nestApp.setGlobalPrefix(`api`)
    nestApp.enableCors();
    await nestApp.listen(PORT1);
  } catch (err) {
    throw new Error(err);
  }
}
//bootstrap1();


function shouldCompress(req, res) {
  if (req.headers['x-no-compression']) {
    // don't compress responses with this request header
    
    return false
  }
  
  // fallback to standard filter function
  return compression.filter(req, res)
}
