import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { Column, CreateDateColumn, Entity, NoNeedToReleaseEntityManagerError, OneToMany, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class OrganisationTable {
  @PrimaryGeneratedColumn()
  organisationId: number;

  @Column({ length: 300 })
  organisationName: string;

  @Column({ length: 100, nullable: true })
  organisationCode: string;

  @Column({ type:"text", nullable: true })
  organisationAddress: string;


  @Column({  default: 0 })
  isOwn: number;

 
  
  @OneToMany(type => UserTable, pt => pt.OrganisationTable)
  UserTable: UserTable[];

  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
