import { Module } from '@nestjs/common';
import { OtpTableService } from './otp-table.service';
import { TypeOrmModule } from '@nestjs/typeorm';
import { OtpTable } from './otp-table.entity';
import * as otpGenerator from 'otp-generator'
import { OTP_GENERATOR } from 'src/helper/GlobalConstants';
import { ThirdPartyCallModule } from 'src/third-party-call/third-party-call.module';
import { MailModule } from 'src/mail/mail.module';



@Module({
  imports: [TypeOrmModule.forFeature([OtpTable]), ThirdPartyCallModule, MailModule],
  providers: [OtpTableService, {
    provide: OTP_GENERATOR,
    useValue: otpGenerator
  }],
  exports: [OtpTableService]
})
export class OtpTableModule { }
