import { CourseSessionTable } from 'src/course-session-table/entities/course-session-table.entity';
import { CourseTable } from 'src/course-table/entities/course-table.entity';
import { UserTable } from 'src/user-collection/entities/user-collection.entity';
import { Column, CreateDateColumn, Entity, JoinColumn, ManyToOne, PrimaryGeneratedColumn, UpdateDateColumn } from 'typeorm';

@Entity()
export class SubscriptionTable {
  @PrimaryGeneratedColumn()
  subscriptionId: number;


  @ManyToOne(type => CourseTable, pt => pt.SubscriptionTable)
  @JoinColumn({ name: 'courseId' })
  CourseTable: CourseTable;


  @ManyToOne(type => CourseSessionTable, pt => pt.SubscriptionTable)
  @JoinColumn({ name: 'courseSessionId' })
  CourseSessionTable: CourseSessionTable;


  @ManyToOne(type => UserTable, pt => pt.SubscriptionTable)
  @JoinColumn({ name: 'userId' })
  UserTable: UserTable;


  @Column({ length: 100, nullable: true })
  entryDate: string;


  @Column({ length: 100, nullable: true })
  startDate: string;

  @Column({ length: 100, nullable: true })
  endDate: string;

  @Column({ nullable: true, default: 0 })
  status: string;


  @Column({ nullable: true, default: 0 })
  isComplete: number;





  @CreateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)" })
  public createdAt: Date;

  @UpdateDateColumn({ type: "timestamp", default: () => "CURRENT_TIMESTAMP(6)", onUpdate: "CURRENT_TIMESTAMP(6)" })
  public updatedAt: Date;
}
