import { Module, forwardRef } from '@nestjs/common';
import { SubscriptionTableService } from './subscription-table.service';
import { SubscriptionTableResolver } from './subscription-table.resolver';
import { TypeOrmModule } from '@nestjs/typeorm';
import { SubscriptionTable } from './entities/subscription-table.entity';
import { CourseTableModule } from 'src/course-table/course-table.module';
import { UserCollectionModule } from 'src/user-collection/user-collection.module';
import { CourseSessionTableModule } from 'src/course-session-table/course-session-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([SubscriptionTable]), forwardRef(() => CourseTableModule), forwardRef(() => UserCollectionModule), forwardRef(() => CourseSessionTableModule)],
  providers: [SubscriptionTableResolver, SubscriptionTableService],
  exports: [SubscriptionTableService]
})
export class SubscriptionTableModule { }
