import { Field, ObjectType } from '@nestjs/graphql';
import { CourseSessionTableType } from 'src/course-session-table/types/course-session-table.type';
import { CourseTableType } from 'src/course-table/types/course-table.type';
import { UserCollectionType } from 'src/user-collection/type/user-collection.type';

@ObjectType("SubscriptionTableType")
export class SubscriptionTableType {
  @Field(() => Number)
  subscriptionId: number;

  @Field(() => CourseTableType)
  CourseTable: CourseTableType;

  @Field(() => CourseSessionTableType)
  CourseSessionTable: CourseSessionTableType;

  @Field(() => UserCollectionType)
  UserTable: UserCollectionType;

  @Field(() => String, {nullable: true})
  entryDate: string;

  @Field(() => String, {nullable: true})
  startDate: string;

  @Field(() => String, {nullable: true})
  endDate: string;

  @Field(() => String, {nullable: true})
  status: string;

  @Field(() => Number, {nullable: true})
  isComplete: number;

  
}