import { createUnionType, Field, ObjectType } from "@nestjs/graphql";
import { AccessTableType } from "src/access-table/types/access-table.type";


@ObjectType('UserData')
export class UserData {


    @Field()
    username: string;

    @Field()
    id: string;

    @Field(type => String)
    role: string;

    @Field()
    name: string;

    @Field({nullable: true})
    designation?: string;


    @Field(type => AccessTableType, { nullable: true })
    access?: AccessTableType;


}


@ObjectType('LoginSuccess')
export class LoginSuccessType {


    @Field()
    status: boolean;

    @Field()
    token?: string;

    @Field(type => UserData)
    user?: UserData;



}

