import { InputType, Int, Field } from '@nestjs/graphql';

@InputType()
export class CreateUserCollectionInput {

  @Field(() => String, { description: 'Name of the User' })
  name: string;

  @Field(() => String, { description: 'Email of the user' })
  email: string;

  @Field(() => String, { description: 'Phone No' })
  phone: string;

  @Field(() => String, { description: 'Designation', nullable: true })
  designation?: string;

  @Field(() => String, { description: 'Type of the user (ADMIN, CLIENT, USER etc)' })
  role: string;

  @Field(() => String, { description: 'Username to login' })
  username: string;

  @Field(() => String, { description: 'Password for login' })
  password: string;

  @Field(() => Int, {nullable: true})
  departmentId?: number;


  @Field(() => Int, {nullable: true})
  designationId?: number;


  @Field(() => Int, {nullable: true})
  organisationId?: number;

  @Field(() => Boolean, { description: 'Status of the User', defaultValue: true })
  isActive: boolean;

}
