import { InputType, Int, Field, ObjectType } from '@nestjs/graphql';
import { AccessTableType } from 'src/access-table/types/access-table.type';
import { DesignationTableType } from 'src/designation-table/types/designation-table.type';
import { OrganisationTableType } from 'src/organisation-table/types/organisation-table.type';

@ObjectType("UserCollectionType")
export class UserCollectionType {

  @Field(() => Int)
  id: number;

  @Field(() => String)
  name: string;

  @Field(() => String, {nullable: true})
  designation?: string;

  @Field(() => String, { description: 'Email of the user' })
  email?: string;

  @Field(() => String, { description: 'Phone No' })
  phone?: string;

  @Field(() => String, { description: 'Type of the user (ADMIN, CLIENT, USER etc)' })
  role?: string;

  @Field(() => String, { description: 'Username to login' })
  username?: string;

  @Field(() => String, { description: 'Password to login'})
  password: string;
  
  @Field(() => Boolean, {nullable: true})
  isActive?: boolean;

  @Field(() => Date)
  createdAt?: Date;

  @Field(() => Number, {nullable: true})
  integratorId?: number;

  @Field(() => [AccessTableType], {nullable: true})
  AccessTable?: AccessTableType[];

  @Field(() => DesignationTableType, {nullable: true})
  DesignationTable?: DesignationTableType;

  @Field(() => OrganisationTableType, {nullable: true})
  OrganisationTable?: OrganisationTableType;
  
}
