import { forwardRef, Module } from '@nestjs/common';
import { UserCollectionService } from './user-collection.service';
import { UserCollectionResolver } from './user-collection.resolver';
import { UserTable } from './entities/user-collection.entity';

import { TypeOrmModule } from '@nestjs/typeorm';
import { OtpTableModule } from 'src/otp-table/otp-table.module';

import { AccessTableModule } from 'src/access-table/access-table.module';
import { DesignationTableModule } from 'src/designation-table/designation-table.module';
import { OrganisationTableModule } from 'src/organisation-table/organisation-table.module';

@Module({
  imports: [TypeOrmModule.forFeature([UserTable]), forwardRef(() =>OtpTableModule), forwardRef(() => AccessTableModule), forwardRef(() => DesignationTableModule), forwardRef(() => OrganisationTableModule) ],
  providers: [UserCollectionResolver, UserCollectionService],
  exports: [UserCollectionService]
})
export class UserCollectionModule {}
