import { VulnerabilityCategoryTableService } from './vulnerability-category-table.service';
import { VulnerabilityCategoryTable } from './entities/vulnerability-category-table.entity';
import { CreateVulnerabilityCategoryTableInput } from './dto/create-vulnerability-category-table.input';
import { UpdateVulnerabilityCategoryTableInput } from './dto/update-vulnerability-category-table.input';
import { RedisPubSub } from 'graphql-redis-subscriptions';
export declare const NEW_VULCAT_ADD = "NEW_VULCAT_ADD";
export declare class VulnerabilityCategoryTableResolver {
    private readonly vulnerabilityCategoryTableService;
    private pubSub;
    constructor(vulnerabilityCategoryTableService: VulnerabilityCategoryTableService, pubSub: RedisPubSub);
    createVulnerabilityCategoryTable(createVulnerabilityCategoryTableInput: CreateVulnerabilityCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VulnerabilityCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    findAllVulnerabilityCategory(): Promise<VulnerabilityCategoryTable[]>;
    findOneVulnerability(vulcatId: number): Promise<VulnerabilityCategoryTable>;
    updateVulnerabilityCategoryTable(updateVulnerabilityCategoryTableInput: UpdateVulnerabilityCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VulnerabilityCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    removeVulnerabilityCategoryTable(vulcatId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
    vulcatSubscription(): AsyncIterator<unknown, any, undefined>;
}
