"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VulnerabilityCategoryTableResolver = exports.NEW_VULCAT_ADD = void 0;
const graphql_1 = require("@nestjs/graphql");
const vulnerability_category_table_service_1 = require("./vulnerability-category-table.service");
const vulnerability_category_table_entity_1 = require("./entities/vulnerability-category-table.entity");
const create_vulnerability_category_table_input_1 = require("./dto/create-vulnerability-category-table.input");
const update_vulnerability_category_table_input_1 = require("./dto/update-vulnerability-category-table.input");
const common_1 = require("@nestjs/common");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const roles_decorator_1 = require("../user-collection/decorators/roles.decorator");
const role_enum_1 = require("../user-collection/roles/role.enum");
const gql_auth_guard_1 = require("../auth/guards/gql-auth.guard");
const roles_guard_1 = require("../auth/guards/roles.guard");
const vulnerability_category_table_return_type_1 = require("./types/vulnerability-category-table-return.type");
const vulnerability_category_table_type_1 = require("./types/vulnerability-category-table.type");
const count_changed_type_1 = require("../types/count-changed.type");
exports.NEW_VULCAT_ADD = "NEW_VULCAT_ADD";
let VulnerabilityCategoryTableResolver = exports.VulnerabilityCategoryTableResolver = class VulnerabilityCategoryTableResolver {
    constructor(vulnerabilityCategoryTableService, pubSub) {
        this.vulnerabilityCategoryTableService = vulnerabilityCategoryTableService;
        this.pubSub = pubSub;
    }
    createVulnerabilityCategoryTable(createVulnerabilityCategoryTableInput) {
        return this.vulnerabilityCategoryTableService.create(createVulnerabilityCategoryTableInput);
    }
    findAllVulnerabilityCategory() {
        return this.vulnerabilityCategoryTableService.findAll();
    }
    findOneVulnerability(vulcatId) {
        return this.vulnerabilityCategoryTableService.findOne(vulcatId);
    }
    updateVulnerabilityCategoryTable(updateVulnerabilityCategoryTableInput) {
        return this.vulnerabilityCategoryTableService.update(updateVulnerabilityCategoryTableInput.vulcatId, updateVulnerabilityCategoryTableInput);
    }
    removeVulnerabilityCategoryTable(vulcatId) {
        return this.vulnerabilityCategoryTableService.remove(vulcatId);
    }
    vulcatSubscription() {
        return this.pubSub.asyncIterator(exports.NEW_VULCAT_ADD);
    }
};
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vulnerability_category_table_return_type_1.VulnerabilityCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('createVulnerabilityCategoryTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [create_vulnerability_category_table_input_1.CreateVulnerabilityCategoryTableInput]),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "createVulnerabilityCategoryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => [vulnerability_category_table_type_1.VulnerabilityCategoryTableType]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "findAllVulnerabilityCategory", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Query)(() => vulnerability_category_table_type_1.VulnerabilityCategoryTableType),
    __param(0, (0, graphql_1.Args)('vulcatId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "findOneVulnerability", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vulnerability_category_table_return_type_1.VulnerabilityCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('updateVulnerabilityCategoryTableInput')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [update_vulnerability_category_table_input_1.UpdateVulnerabilityCategoryTableInput]),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "updateVulnerabilityCategoryTable", null);
__decorate([
    (0, roles_decorator_1.Roles)(role_enum_1.Role.SUPERADMIN, role_enum_1.Role.ADMIN, role_enum_1.Role.USER),
    (0, common_1.UseGuards)(gql_auth_guard_1.GqlAuthGuard, roles_guard_1.RolesGuard),
    (0, graphql_1.Mutation)(() => vulnerability_category_table_return_type_1.VulnerabilityCategoryTableReturnType),
    __param(0, (0, graphql_1.Args)('vulcatId', { type: () => graphql_1.Int })),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number]),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "removeVulnerabilityCategoryTable", null);
__decorate([
    (0, graphql_1.Subscription)(() => count_changed_type_1.CountChangedType, {
        resolve: (payload) => {
            return { countChanged: payload };
        }
    }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], VulnerabilityCategoryTableResolver.prototype, "vulcatSubscription", null);
exports.VulnerabilityCategoryTableResolver = VulnerabilityCategoryTableResolver = __decorate([
    (0, graphql_1.Resolver)(() => vulnerability_category_table_entity_1.VulnerabilityCategoryTable),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [vulnerability_category_table_service_1.VulnerabilityCategoryTableService,
        graphql_redis_subscriptions_1.RedisPubSub])
], VulnerabilityCategoryTableResolver);
