import { RedisPubSub } from 'graphql-redis-subscriptions';
import { Repository } from 'typeorm';
import { CreateVulnerabilityCategoryTableInput } from './dto/create-vulnerability-category-table.input';
import { UpdateVulnerabilityCategoryTableInput } from './dto/update-vulnerability-category-table.input';
import { VulnerabilityCategoryTable } from './entities/vulnerability-category-table.entity';
export declare const NEW_VULCAT_ADD = "NEW_VULCAT_ADD";
export declare class VulnerabilityCategoryTableService {
    private readonly vulnerabilityCategoryTableRepository;
    private pubSub;
    constructor(vulnerabilityCategoryTableRepository: Repository<VulnerabilityCategoryTable>, pubSub: RedisPubSub);
    create(createVulnerabilityCategoryTableInput: CreateVulnerabilityCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VulnerabilityCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    checkIfAlreadyExists(createVulnerabilityCategoryTableInput: CreateVulnerabilityCategoryTableInput): Promise<number>;
    findAll(): Promise<VulnerabilityCategoryTable[]>;
    findOne(vulcatId: number): Promise<VulnerabilityCategoryTable>;
    findOneByName(vulcatName: string): Promise<VulnerabilityCategoryTable>;
    update(vulcatId: number, updateVulnerabilityCategoryTableInput: UpdateVulnerabilityCategoryTableInput): Promise<{
        status: boolean;
        status_text: string;
        data: VulnerabilityCategoryTable;
    } | {
        status: boolean;
        status_text: string;
        data?: undefined;
    }>;
    remove(vulcatId: number): Promise<{
        status: boolean;
        status_text: string;
    }>;
}
