"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VulnerabilityCategoryTableService = exports.NEW_VULCAT_ADD = void 0;
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const graphql_redis_subscriptions_1 = require("graphql-redis-subscriptions");
const GlobalConstants_1 = require("../helper/GlobalConstants");
const typeorm_2 = require("typeorm");
const vulnerability_category_table_entity_1 = require("./entities/vulnerability-category-table.entity");
exports.NEW_VULCAT_ADD = "NEW_VULCAT_ADD";
let VulnerabilityCategoryTableService = exports.VulnerabilityCategoryTableService = class VulnerabilityCategoryTableService {
    constructor(vulnerabilityCategoryTableRepository, pubSub) {
        this.vulnerabilityCategoryTableRepository = vulnerabilityCategoryTableRepository;
        this.pubSub = pubSub;
    }
    async create(createVulnerabilityCategoryTableInput) {
        let checkIfAlreadyExists = await this.checkIfAlreadyExists(createVulnerabilityCategoryTableInput);
        if (checkIfAlreadyExists == 0) {
            let st = new vulnerability_category_table_entity_1.VulnerabilityCategoryTable();
            st.vulcatName = createVulnerabilityCategoryTableInput.vulcatName;
            let result = await this.vulnerabilityCategoryTableRepository.save(st);
            this.pubSub.publish(exports.NEW_VULCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Added",
                data: result
            };
        }
        else {
            return {
                status: false,
                status_text: "Already Exists"
            };
        }
    }
    async checkIfAlreadyExists(createVulnerabilityCategoryTableInput) {
        let result = await this.vulnerabilityCategoryTableRepository.count({
            where: {
                vulcatName: createVulnerabilityCategoryTableInput.vulcatName
            }
        });
        return result;
    }
    async findAll() {
        return await this.vulnerabilityCategoryTableRepository.find();
    }
    async findOne(vulcatId) {
        return await this.vulnerabilityCategoryTableRepository.findOne({
            where: {
                vulcatId
            }
        });
    }
    async findOneByName(vulcatName) {
        return await this.vulnerabilityCategoryTableRepository.findOne({
            where: {
                vulcatName
            }
        });
    }
    async update(vulcatId, updateVulnerabilityCategoryTableInput) {
        let result = await this.findOne(vulcatId);
        if (result) {
            result.vulcatName = updateVulnerabilityCategoryTableInput.vulcatName;
            let updatedResult = await this.vulnerabilityCategoryTableRepository.save(result);
            this.pubSub.publish(exports.NEW_VULCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Updated",
                data: updatedResult
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
    async remove(vulcatId) {
        let result = await this.findOne(vulcatId);
        if (result) {
            await this.vulnerabilityCategoryTableRepository.remove(result);
            this.pubSub.publish(exports.NEW_VULCAT_ADD, 1);
            return {
                status: true,
                status_text: "Successfully Deleted"
            };
        }
        else {
            return {
                status: false,
                status_text: "Not Found"
            };
        }
    }
};
exports.VulnerabilityCategoryTableService = VulnerabilityCategoryTableService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, typeorm_1.InjectRepository)(vulnerability_category_table_entity_1.VulnerabilityCategoryTable)),
    __param(1, (0, common_1.Inject)(GlobalConstants_1.PUB_SUB)),
    __metadata("design:paramtypes", [typeorm_2.Repository,
        graphql_redis_subscriptions_1.RedisPubSub])
], VulnerabilityCategoryTableService);
